#! /usr/bin/perl 
#  Copyright 2001-2014 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


use DBI;
use CGI;
use Time::JulianDay;

my %lex = ('Display' => 'Display',
	   'Calendar' => 'Calendar',
	   'Main' => 'Main',

    );

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;


# print page header
my $title = "$lex{Display} $lex{Calendar}";
print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print qq{<style type="text/css">\n};
print qq{div.date {float:right;text-align:center;border:1px solid gray; border-width:0 0 1px 1px;background:#EEE;margin:0;padding:0.125em 0.25em 0 0.25em;} \n};

print qq{</style>\n};
print "$chartype\n</head>\n";
print qq{[ <a href="$homepage">$lex{Main}</a> ]\n};
#print qq{| <a href=\"$schpage\">$lex{Timetable}</a> ]\n};


for my $m ( 1..12 ) {
    my $yrmo = '2014-'. $m;
    displayMonthlyCalendar( $yrmo );
    print qq{<p></p>\n};
}


#-------------------------
sub displayMonthlyCalendar {
#-------------------------

    my $yrmo = shift;

    my $endofmonth = endofmonth( $yrmo );

    my ($yr, $mo) = split('-', $yrmo );
    my $startjd = julian_day($yr, $mo, '1');
    my $startdow = day_of_week( $startjd ) + 1; # Sunday is day 1 of week

    my $cellconf = qq{style="font-size:120%;"};


    print qq{<p>Days:$endofmonth</p>\n};

    # Start Table and put in heading.
    print qq{<table cellpadding="3" cellspacing="0" border="1">\n};
    print qq{<tr><th colspan="7">$month[$mo] $yr</th></tr>\n};
    print qq{<tr>};
    for my $dow (1..7) {
	if ( $dow == 1 or $dow == 7 ) { $width = '5%'; } else { $width = '18%'; } 
	print qq{<th style="width:$width;">$s_dow[$dow]</th>}; };
    print qq{</tr>\n};

    # Display first week of calendar.
    my $mday = 1; # first day of month.
    my $start = 0;
    print qq{<tr>};
    for my $dow (1..7) {
	if ( $dow == $startdow ) {
	    print qq{<td $cellconf><div class="date">$mday</div><div>Loreim ipsum</div></td>}; 
	    $mday++;
	    $start = 1;

	} elsif ( $start ) {
	    print qq{<td $cellconf><div class="date">$mday</div><div>More Lorem Ipsum dolor</div></td>};
	    $mday++;

	} else { # print cell without any value
	    print qq{<td></td>};
	}
    };
    print qq{</tr>\n};

    # Now do all following weeks.
    my $stop = 0;
    for $wk (2..6) { #
	if ( $stop ) { next; }
	print qq{<tr>};
	for my $dow (1..7) {
	    if ( not $stop ) {
		print qq{<td>$mday</td>};
	    } else {
		print qq{<td></td>};
	    }
	    $mday++;
	    # Check if past end of month.
	    if ( $mday > $endofmonth ) { $stop = 1; }
	};
	print qq{</tr>\n};
	if ( $stop ) { next; }
    }

    print qq{</table>\n}




} # end of displayMonthlyCalendar



#------------
sub endofmonth {  # return last day in month
#------------

    my @mdays = (0,31,28,31,30,31,30,31,31,30,31,30,31);
    my $maxyear = 2100;

    my $val = shift;
    my ( $year, $month, $day) = split(/-/, $val);

    # reset Feb max days, if leap years
    if ($month == 2) {
	if ($year % 4 != 0) { $mdays[2] = 28; }
	elsif ($year % 400 == 0) { $mdays[2] = 29; }
	elsif ($year % 100 == 0) { $mdays[2] = 28; }
	else { $mdays[2] = 29; }
    }

    return $mdays[$month];

}




#------------
sub checkdate {  # check date for validity
#------------

    my @mdays = (0,31,28,31,30,31,30,31,31,30,31,30,31);
    my $maxyear = 2100;

    my $val = shift;

    if ( not $val =~ m/-/ ) {  # fail if no hyphens
	return undef;
    }

    # Strip Spaces
    $val =~ s/^\s+//g;
    $val =~ s/\s+$//g;

    my ( $year, $month, $day) = split(/-/, $val);


    # Check for non-digits
    if ($year =~ m/\D/) { return undef; }
    if ($month =~ m/\D/) { return undef; }
    if ($day =~ m/\D/) { return undef; }

    # reset Feb max days, if leap years
    if ($month == 2) {
	if ($year % 4 != 0) { $mdays[2] = 28; }
	elsif ($year % 400 == 0) { $mdays[2] = 29; }
	elsif ($year % 100 == 0) { $mdays[2] = 28; }
	else { $mdays[2] = 29; }
    }

    # check ranges
    if ( $day < 0 or $day > $mdays[$month] ) { # days out of range
	return undef;
    } elsif ( $month < 0 or $month > 12 ) { # month error
	return undef;
    } elsif ( $year < 0 or $year > $maxyear ) {
	return undef;
    }

    return $val;

}

