#!/usr/bin/perl
#  Copyright 2001-2019 Leslie Richardson

#  Export vars from meta into a temp_meta file

use DBI;


my ($password, $db, $file) = @ARGV;

if ( not $password ) {
    print "Usage: ./exportmeta.pl password dbase file\n";
    exit;
}


if ( not $db or not $file ) {
    print "Missing database name or filename\n";
    exit;
}

open(my $fh, ">", $file) or
    die("Cannot open $file: $!\n");

$user = 'root';
$dbtype = 'mysql';

my $dsn = "DBI:$dbtype:dbname=$db";
my $dbh = DBI->connect($dsn,$user,$password);

my $sth = $dbh->prepare("select * from meta order by tableid, fieldid");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

while ( my $ref = $sth->fetchrow_hashref ) {
    my %r = %$ref;
    foreach my $key ( keys %r ) {
	$r{$key} = $dbh->quote( $r{$key} );
    }
    print $fh qq{insert into temp_meta (tableid, fieldid, datatype, arrayidx, size, fieldname, 
      defaultvalue, formtype, viewsize, required, description )\n values(};
    print $fh qq{ $r{tableid}, $r{fieldid}, $r{datatype}, $r{arrayidx}, $r{size}, $r{fieldname}, 
      $r{defaultvalue}, $r{formtype}, $r{viewsize}, $r{required}, $r{description} ); \n\n};

}

close $fh;
