-- MySQL dump 10.15  Distrib 10.0.30-MariaDB, for debian-linux-gnu (x86_64)
--
-- Host: localhost    Database: distro
-- ------------------------------------------------------
-- Server version	10.0.30-MariaDB-0+deb8u2

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `announce`
--

DROP TABLE IF EXISTS `announce`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `announce` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `adatetime` datetime DEFAULT NULL,
  `adesc` text,
  `atopic` varchar(255) DEFAULT NULL,
  `adate` date DEFAULT NULL,
  `topstay` char(1) DEFAULT NULL,
  `atype` varchar(16) DEFAULT NULL,
  `author` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `announce`
--

LOCK TABLES `announce` WRITE;
/*!40000 ALTER TABLE `announce` DISABLE KEYS */;
/*!40000 ALTER TABLE `announce` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `attend`
--

DROP TABLE IF EXISTS `attend`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `attend` (
  `attid` int(11) NOT NULL AUTO_INCREMENT,
  `studentid` int(11) DEFAULT NULL,
  `absdate` date DEFAULT NULL,
  `reason` char(60) DEFAULT NULL,
  `period` char(6) DEFAULT NULL,
  `subjsec` char(32) DEFAULT NULL,
  `late` smallint(5) unsigned DEFAULT NULL,
  PRIMARY KEY (`attid`),
  KEY `attend_absdate` (`absdate`),
  KEY `attend_studentid` (`studentid`),
  KEY `attend_subjsec` (`subjsec`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `attend`
--

LOCK TABLES `attend` WRITE;
/*!40000 ALTER TABLE `attend` DISABLE KEYS */;
/*!40000 ALTER TABLE `attend` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `audit`
--

DROP TABLE IF EXISTS `audit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `audit` (
  `audid` int(11) NOT NULL AUTO_INCREMENT,
  `userid` varchar(40) DEFAULT NULL,
  `ipaddr` varchar(20) DEFAULT NULL,
  `scriptname` varchar(64) DEFAULT NULL,
  `tablename` varchar(64) DEFAULT NULL,
  `tableid` int(11) DEFAULT NULL,
  `startval` text,
  `endval` text,
  `tstamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`audid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `audit`
--

LOCK TABLES `audit` WRITE;
/*!40000 ALTER TABLE `audit` DISABLE KEYS */;
/*!40000 ALTER TABLE `audit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `book_copy`
--

DROP TABLE IF EXISTS `book_copy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `book_copy` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `titleid` int(11) DEFAULT NULL,
  `barcode` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `book_copy`
--

LOCK TABLES `book_copy` WRITE;
/*!40000 ALTER TABLE `book_copy` DISABLE KEYS */;
/*!40000 ALTER TABLE `book_copy` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `book_signout`
--

DROP TABLE IF EXISTS `book_signout`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `book_signout` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `copyid` int(11) DEFAULT NULL,
  `studnum` int(11) DEFAULT NULL,
  `signout` date DEFAULT NULL,
  `returndate` date DEFAULT NULL,
  `start_condition` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `book_signout`
--

LOCK TABLES `book_signout` WRITE;
/*!40000 ALTER TABLE `book_signout` DISABLE KEYS */;
/*!40000 ALTER TABLE `book_signout` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `book_title`
--

DROP TABLE IF EXISTS `book_title`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `book_title` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `subject` varchar(64) DEFAULT NULL,
  `title` varchar(64) DEFAULT NULL,
  `author` varchar(64) DEFAULT NULL,
  `pubdate` varchar(12) DEFAULT NULL,
  `cost` decimal(4,2) DEFAULT NULL,
  `barcode` varchar(255) DEFAULT NULL,
  `description` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `book_title`
--

LOCK TABLES `book_title` WRITE;
/*!40000 ALTER TABLE `book_title` DISABLE KEYS */;
/*!40000 ALTER TABLE `book_title` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `conf_system`
--

DROP TABLE IF EXISTS `conf_system`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `conf_system` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `filename` varchar(64) DEFAULT NULL,
  `sectionname` varchar(64) DEFAULT NULL,
  `sequenceval` int(11) DEFAULT NULL,
  `dataname` varchar(64) DEFAULT NULL,
  `datatype` varchar(32) DEFAULT NULL,
  `datavalue` text,
  `hashvar` varchar(64) DEFAULT NULL,
  `version` varchar(16) DEFAULT NULL,
  `description` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=287 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `conf_system`
--

LOCK TABLES `conf_system` WRITE;
/*!40000 ALTER TABLE `conf_system` DISABLE KEYS */;
INSERT INTO `conf_system` VALUES (1,'admin','attendance',100,'g_ppd','hash','%g_ppd = (\'6\' => \'2\',\'11\' => \'5\',\'PK\' => \'2\',\'3\' => \'2\',\'7\' => \'2\',\'K\' => \'2\',\'9\' => \'2\',\'12\' => \'5\',\'2\' => \'2\',\'8\' => \'2\',\'4\' => \'2\',\'1\' => \'2\',\'10\' => \'5\',\'5\' => \'2\');',NULL,'5.25','The number of Periods Per Day (PPD) taken for attendance at each particular grade/form level. A PPD of \'2\' means that only a morning and afternoon attendance is done. Do not change any values here during the school year since this will throw off attendance reports, etc. Change only from one year to the next.'),(2,'admin','attendance',102,'g_AttendanceEntryMethod','hash','%g_AttendanceEntryMethod = (\'6\' => \'homeroom\',\'11\' => \'subject\',\'PK\' => \'homeroom\',\'3\' => \'homeroom\',\'7\' => \'homeroom\',\'K\' => \'homeroom\',\'9\' => \'homeroom\',\'12\' => \'subject\',\'2\' => \'homeroom\',\'8\' => \'homeroom\',\'4\' => \'homeroom\',\'1\' => \'homeroom\',\'10\' => \'subject\',\'5\' => \'homeroom\');',NULL,NULL,'Maps the grade to an attendance entry method, homeroom or subject '),(3,'admin','attendance',105,'attend','array','@attend = (\'Absent Unexcused\',\'Absent Excused\',\'Absent Illness\',\'Absent Moved\',\'Absent Suspension\',\'Late Unexcused\',\'Late Excused\');',NULL,'5.25','The list of all attendance reasons in display order. Do not alter ordering unless you also update the \'points\' for these as well, since the ordering must match between these 2 values.'),(4,'admin','attendance',110,'absentUnexcused','scalar','$absentUnexcused = \'Absent Unexcused\';',NULL,'5.25','The main attendance reason text for \'Absent Unexcused\'.'),(5,'admin','attendance',115,'absentString','scalar','$absentString = \'Absent\';',NULL,'5.25','Text string that matches the \'Absent\' part of the attendance reasons. '),(6,'admin','attendance',120,'lateUnexcused','scalar','$lateUnexcused = \'Late Unexcused\';',NULL,'5.25','The text value for a Late Unexcused reason.'),(7,'admin','attendance',125,'lateString','scalar','$lateString = \'Late\';',NULL,'5.25','The text value for \'Late\' in attendance reasons.'),(8,'admin','attendance',130,'points','array','@points = (\'3\',\'1\',\'1\',\'1\',\'1\',\'1\',\'1\');',NULL,'5.25','The points that match in order each of the attendance reasons stored in the attend variable. '),(9,'admin','attendance',135,'trigger','hash','%trigger = (\'6\' => \'Absence (Two)\',\'18\' => \'Absence (Six)\',\'30\' => \'Absence (Ten)\',\'24\' => \'Absence (Eight)\',\'12\' => \'Absence (Four)\');',NULL,'5.25','These are the number of attendance point triggers and their matching text description. '),(10,'admin','attendance',140,'ignore_reason','array','@ignore_reason = (5,6);',NULL,'5.25','The attendance reasons to ignore when doing a search for perfect attendance. These values are the array index values for the reason and they start at 0.'),(11,'admin','attendance',150,'formletter','hash','%formletter = (\'6\' => \'discipline.tex\',\'18\' => \'discipline.tex\',\'30\' => \'withdraw.tex\',\'24\' => \'discipline.tex\',\'12\' => \'discipline.tex\');',NULL,'5.25','The number of points required to trigger a particular form letter (stored in the templates folder) These values are total from the \'points\' variable that map to each particular attendance reason. (attend variable)'),(12,'admin','dates',400,'month','array','@month = (\'\', \'January\', \'February\', \'March\', \'April\', \'May\', \'June\', \'July\', \'August\', \'September\', \'October\', \'November\', \'December\');',NULL,'5.25','Months of the Year. They are 1 based (not zero based). Do not change, other than for translation.'),(13,'admin','dates',405,'s_month','array','@s_month = (\'\', \'Jan\', \'Feb\', \'Mar\', \'Apr\', \'May\', \'Jun\', \'Jul\', \'Aug\', \'Sep\', \'Oct\', \'Nov\', \'Dec\');',NULL,'5.25','Short Month Values. They are 1 based. (ie. $s_month[1] = \'Jan\' ).'),(14,'admin','dates',410,'dow','array','@dow = (\'\',\'Sunday\', \'Monday\', \'Tuesday\', \'Wednesday\', \'Thursday\', \'Friday\', \'Saturday\');',NULL,'5.25','Day of Week values (longer form) with a 1 value being Sunday.'),(15,'admin','dates',415,'s_dow','array','@s_dow = (\'\',\'Sun\',\'Mon\',\'Tue\',\'Wed\',\'Thu\',\'Fri\',\'Sat\');',NULL,'5.25','Short Day of the Week Values. They are 1 based with first day being Sunday.'),(16,'admin','dates',420,'g_DaysPerCycle','scalar',NULL,NULL,'5.25','The number of days in a school cycle until it repeats.'),(17,'admin','dates',425,'g_ResetCycleDate','hash','%g_ResetCycleDate = ();',NULL,'5.75','These are dates on which the cycle is reset to a new starting value. Following dates then follow this day in normal cycle format. If we reset Monday to a Day 3 in a 5 day cycle (for some reason), then Tuesday would be day 4, Wednesday Day 5, and Thursday would be Day 1 (restarting the cycle). '),(18,'admin','language',500,'doctype','scalar','$doctype = \'<!DOCTYPE html>\';',NULL,'5.25','The version of HTML sent by scripts. Currently HTML 4.01 Transitional.'),(19,'admin','language',505,'langcode','scalar','$langcode = \'en\';',NULL,'5.25','Not used, yet.'),(20,'admin','language',510,'language','scalar','$language = \'English\';',NULL,'5.25','The current language. Not used, yet.'),(21,'admin','language',515,'charset','scalar','$charset = \'UTF-8\';',NULL,'5.25','The character set that is sent when sending pages from scripts. This value is sent using the cgi->header(-charset,$charset) function.'),(22,'admin','language',525,'chartype','scalar','$chartype = \'<meta charset=\"UTF-8\">\';',NULL,'5.25','The value sent by scripts as part of the html page \'head\' section.'),(23,'admin','pagelayout',600,'defaultpapersize','scalar','$defaultpapersize = \'letterpaper\';',NULL,'5.25','The default value for the size of paper. Many scripts (but not all) will use this to speed up paper selection. The values are: letterpaper, a4paper, legalpaper.'),(24,'admin','pagelayout',605,'g_letterpaper_textheight','scalar','$g_letterpaper_textheight = \'246mm\';',NULL,'5.25','Text Height for Letter Paper.'),(25,'admin','pagelayout',610,'g_letterpaper_textwidth','scalar','$g_letterpaper_textwidth = \'190mm\';',NULL,'5.25','Text Width for Letter Paper.'),(26,'admin','pagelayout',615,'g_legalpaper_textheight','scalar','$g_legalpaper_textheight = \'325mm\';',NULL,'5.25','Text Height for Legal Paper.'),(27,'admin','pagelayout',620,'g_legalpaper_textwidth','scalar','$g_legalpaper_textwidth = \'190mm\';',NULL,'5.25','Text Width for Legal Paper'),(28,'admin','pagelayout',625,'g_a4paper_textheight','scalar','$g_a4paper_textheight = \'272mm\';',NULL,'5.25','Text Height for A4 paper.'),(29,'admin','pagelayout',630,'g_a4paper_textwidth','scalar','$g_a4paper_textwidth = \'184mm\';',NULL,'5.25','Text Width for A4 paper.'),(30,'admin','pagelayout',635,'g_color','array','@g_color = (\'#8FA\', \'#FF8\', \'#AAF\', \'#F8F\', \'#FAF\', \'#AFF\', \'#FAA\', \'#AFA\', \'#AAF\', \'#AAA\');',NULL,'5.25','Default color range values used by the gradebook for coloring assessment groups. '),(31,'admin','pagelayout',640,'a_latex_header','scalar','$a_latex_header = \'\\\\inputencoding{latin1}\';',NULL,'5.25','The header used by LaTeX to generate the PDF files. A different value is required for other languages, esp including Thai.'),(32,'admin','pageurl',1000,'homepage','scalar','$homepage = \'/index.shtml\';',NULL,'5.25','The URL for the main index file on the admin site. Do not change.'),(33,'admin','pageurl',1005,'attpage','scalar','$attpage = \'/attendance.html\';',NULL,'5.25','URL for the attendance page'),(34,'admin','pageurl',1010,'discpage','scalar','$discpage = \'/discipline.html\';',NULL,'5.25','URL for the discipline page.'),(35,'admin','pageurl',1015,'feespage','scalar','$feespage = \'/fees.html\';',NULL,'5.25','The URL for the fees page.'),(36,'admin','pageurl',1020,'reppage','scalar','$reppage = \'/repcard.html\';',NULL,'5.25','The URL for the report card page.'),(37,'admin','pageurl',1025,'schpage','scalar','$schpage = \'/timetable.html\';',NULL,'5.25','The Timetable page URL.'),(38,'admin','pageurl',1030,'exppage','scalar','$exppage = \'/export.html\';',NULL,'5.25','The URL for the export page.'),(39,'admin','pageurl',1035,'eoypage','scalar','$eoypage = \'/eoy.html\';',NULL,'5.25','The URL to the Start/End of Year page.'),(40,'admin','pageurl',1050,'tchpage','scalar','$tchpage = \'/tindex.pl\';',NULL,'5.25','The URL location for the main teacher page index file.'),(41,'admin','pageurl',1055,'parpage','scalar','$parpage=\'/pindex.pl\';',NULL,'6.50','The URL location of the main parent site page index file'),(42,'admin','password',900,'g_studentpwd_minlen','scalar','$g_studentpwd_minlen = 4;',NULL,'5.25','The minimum length a student password may be.'),(43,'admin','password',905,'g_studentpwd_maxlen','scalar','$g_studentpwd_maxlen = 6;',NULL,'5.25','The maximum length for a student password.'),(44,'admin','password',910,'g_studentpwd_genlen','scalar','$g_studentpwd_genlen = 6;',NULL,'5.25','This is the length of a generated password when adding students.'),(45,'admin','password',915,'g_studentpwd_caps','scalar','$g_studentpwd_caps = 0;',NULL,'5.25','A value of 1 indicates that one or more capital letters are required in a student password. A value of 0 turns off this requirement.'),(46,'admin','password',920,'g_studentpwd_signs','scalar','$g_studentpwd_signs = 0;',NULL,'5.25','This indicates whether signs or symbols are required in the password. A zero value turns it off and a 1 value turns it on.'),(47,'admin','password',930,'g_staffpwd_minlen','scalar','$g_staffpwd_minlen = 6;',NULL,'5.25','The minimum length that a password may be.'),(48,'admin','password',935,'g_staffpwd_maxlen','scalar','$g_staffpwd_maxlen = 0;',NULL,'5.25','The maximum length that a password may be. A 0 value will disable this requirement.'),(49,'admin','password',940,'g_staffpwd_genlen','scalar','$g_staffpwd_genlen = 6;',NULL,'5.25','This is the length of a generated password when adding staff.'),(50,'admin','password',945,'g_staffpwd_caps','scalar','$g_staffpwd_caps = 1;',NULL,'5.25','A value of 1 indicates that one or more capital letters are required in a password. A value of 0 turns off this requirement.'),(51,'admin','password',950,'g_staffpwd_signs','scalar','$g_staffpwd_signs = 0;',NULL,'5.25','Indicates whether a staff password will require symbols such as @ or #, etc. A value of 0 turns this off, and a value of 1 turns it on.'),(52,'admin','pathways',1200,'cgidir','scalar','$cgidir = \'/opt/openadmin/YOURSCHOOL/cgi\';',NULL,'5.25','Directory root of all the cgi scripts in the server filesystem. (ie absolute location)'),(53,'admin','pathways',1205,'tchcgidir','scalar','$tchcgidir = \'/opt/openadmin/YOURSCHOOL/tcgi\';',NULL,'5.25','The absolute pathway to the root directory for the teacher site scripts. '),(54,'admin','pathways',1210,'parcgidir','scalar','$parcgidir = \'/opt/openadmin/YOURSCHOOL/pcgi\';',NULL,'5.25','The absolute pathway to the parent CGI scripts.'),(55,'admin','pathways',1215,'downloaddir','scalar','$downloaddir = \'/opt/openadmin/YOURSCHOOL/admin/download\';',NULL,'5.25','The absolute pathway to the download directory. This is used by scripts to move files into this location so they can be downloaded. Typically PDF files or export data.'),(56,'admin','pathways',1220,'tchdownloaddir','scalar','$tchdownloaddir = \'/opt/openadmin/YOURSCHOOL/tadmin/download\';',NULL,'5.25','The absolute pathway for the download directory on the teacher site. Files for download (ie. PDF) are copied here by scripts. '),(57,'admin','pathways',1230,'picdir','scalar','$picdir = \'/opt/openadmin/YOURSCHOOL/admin/pic-big\';',NULL,'5.25','The absolute path to the location of the directory storing the full size pictures of students.'),(58,'admin','pathways',1240,'tndir','scalar','$tndir = \'/opt/openadmin/YOURSCHOOL/admin/pic-sm\';',NULL,'5.25','The Thumbnail pictures absolute path location in the filesystem.'),(59,'admin','pathways',1250,'globdir','scalar','$globdir = \'/opt/openadmin/YOURSCHOOL/etc\';',NULL,'5.25','The directory location of the global file (global.conf) that stores the other databases that may be searched on this server for withdrawn students. It also contains the \'read only\' user values to allow it to read from those databases. For single schools the file is normally located in the school etc directory.'),(60,'admin','pathways',1260,'g_EtcPath','scalar','$g_EtcPath = \'../../etc\';',NULL,'5.50','The full path to the location of the configuration files for OA for this school.'),(61,'admin','pathways',1270,'iepdir','scalar','$iepdir = \'/opt/openadmin/iep2020\';',NULL,'5.25','The absolute path to the IEP system, if used.'),(62,'admin','pathways',1280,'pdflatex','scalar','$pdflatex = \'/usr/bin/pdflatex\';',NULL,'5.25','The pathway to the PDF Latex executable file.'),(63,'admin','sasked',1300,'schoolnumber','scalar','$schoolnumber = \'\';',NULL,'5.25','The provincial or state number used to identify the school in that province or state.'),(64,'admin','sasked',1310,'xmlns','scalar','$xmlns = \'http://www.k12.gov.sk.ca/xsd/sl/3.x/SLMessage.xsd\';',NULL,'5.25','Sask Ed value for the XML Name space. Do not change.'),(65,'admin','sasked',1315,'xmlnsxsi','scalar','$xmlnsxsi = \'http://www.w3.org/2001/XMLSchema-instance\';',NULL,'5.25','Sask Ed XML value. Do not change.'),(66,'admin','sasked',1320,'xsischemaLocation','scalar','$xsischemaLocation = \'http://www.k12.gov.sk.ca/xsd/sl/3.x/SLMessage.xsd\n http://www.k12.gov.sk.ca/xsd/sl/3.x/SLMessage.xsd\';',NULL,'5.25','Sask Ed XML setting. Do not change.'),(67,'admin','sasked',1325,'program','scalar','$program = \'10\';',NULL,'5.25','The Sask Ed value for the program a student is following. Typically a \'10\' for an English stream student in Saskatchewan, Canada. Ignore if not a Sask School.'),(68,'admin','sasked',1330,'nativeschool','scalar','$nativeschool = \'0\';',NULL,'5.25','A Sask Ed value to indicate if the school is a First Nations school. Ignore if not in Sask, Canada.  (1=True, 0=False)'),(69,'admin','sasked',1335,'url','scalar','$url = \'https://www.k12.gov.sk.ca/spls/sdsxml/pkgb_xml_interface.sl_message\';',NULL,'5.25','The Sask Ed URL location for SDS record transfer. Do Not Change.'),(70,'admin','schooladdress',300,'schoolname','scalar','$schoolname = \'YOURSCHOOL Name\';',NULL,'5.25','The name of the school as it will appear on reports and report card.'),(71,'admin','schooladdress',305,'schooladdr1','scalar','$schooladdr1 = \'\';',NULL,'5.25','First part of the street address for the school.'),(72,'admin','schooladdress',310,'schooladdr2','scalar','$schooladdr2 = \'\';',NULL,'5.25','Second part of the school street address, if required.'),(73,'admin','schooladdress',315,'schoolcity','scalar','$schoolcity = \'\';',NULL,'5.25','City in which school is located.'),(74,'admin','schooladdress',320,'schoolprov','scalar','$schoolprov = \'\';',NULL,'5.25','The province or state the school is located in.'),(75,'admin','schooladdress',325,'schoolpcode','scalar','$schoolpcode = \'\';',NULL,'5.25','The Postal Code or zip code for the school.'),(76,'admin','schooladdress',330,'schoolphone','scalar','$schoolphone = \'\';',NULL,'5.25','The phone number of the school.'),(77,'admin','schooladdress',335,'schoolfax','scalar','$schoolfax = \'\';',NULL,'5.25','The fax number of the school.'),(78,'admin','schooladdress',340,'schoolemail','scalar','$schoolemail = \'\';',NULL,'5.25','The email address for the school. Typically the \'general mailbox\' for the school, rather than a secretary or admin email account.'),(79,'admin','schooladdress',345,'schoolwebsite','scalar','$schoolwebsite = \'\';',NULL,'5.25','The URL for the school website.'),(80,'admin','schooladdress',350,'returnaddress','scalar','$returnaddress = \'\';',NULL,'5.25','The return address for email sent out via email script.'),(81,'admin','schooladdress',355,'g_Divisionname','scalar','$g_Divisionname = \'\';',NULL,'5.25','Name of your school division, if any. Leave blank if a stand alone school with no affiliation to other schools.'),(82,'admin','schooladdress',360,'g_mailserver','scalar','$g_mailserver = \'\';',NULL,'5.25','The URL for the email server used by the email scripts. It will accept mail from the Open Admin server.'),(83,'admin','schoolrole',800,'g_position','array','@g_position = (\'Classroom Teacher\',\'Educational Assistant\',\'Special Education Teacher\',\'Principal\',\'Vice-Principal\',\'Secretary\',\'Librarian\',\'Community School Room\',\'Custodian\',\'Education Director\',\'Catalyst Teacher\',\'Career Counsellor\',\'Elder\',\'Bus Driver\',\'Maintenance\',\'EA Mentors\',\'EA Trainees\');',NULL,'5.25','The various staff positions in the school.'),(84,'admin','schoolrole',805,'g_posadmin','array','@g_posadmin = (\'Principal\',\'Vice-Principal\');',NULL,'5.25','Text values for the administrators from the positions variable values.'),(85,'admin','schoolrole',810,'g_possped','scalar','$g_possped = \'Special Education Teacher\';',NULL,'5.25','The text value for the special education teacher from the position variable.'),(86,'admin','schoolyear',200,'schoolyear','scalar','$schoolyear = \'2019-2020\';',NULL,'5.25','The school year in YYYY-YYYY format. (ie. 2011-2012)'),(87,'admin','schoolyear',210,'schoolstart','scalar','$schoolstart = \'2019-08-31\';',NULL,'5.25','The starting date for school. Typically the first day that teachers come. This allows a couple of admin days to be set at school start before students arrive. If not desired (to show admin days), then set this to the first day that students come.'),(88,'admin','schoolyear',220,'schoolend','scalar','$schoolend = \'2020-06-30\';',NULL,'5.25','The last day of school. Typically the last day when teachers are at school and report cards are handed out, etc. Administration days are set in the dates to indicate that students do not come. It can be set to last day for students if desired (although not recommended).'),(89,'admin','schoolyear',240,'g_MTrackTerm','hash','%g_MTrackTerm = (\'1\' => {\'1\' => {\'end\' => \'2019-11-14\',\'start\' => \'2019-09-02\'},\'3\' => {\'end\' => \'2020-06-19\',\'start\' => \'2020-03-23\'},\'2\' => {\'end\' => \'2020-03-20\',\'start\' => \'2019-11-17\'}});',NULL,'5.50','Holds the term data (dates) for all tracks and all terms. Structure is: g_MTrackTerm{track}{term}{\'start\' => \'2011-03-15\', \'end\' => \'2011-06-28\'}'),(90,'admin','schoolyear',250,'g_MTrackTermType','hash','%g_MTrackTermType = (\'6\' => 1,\'PK\' => 1,\'3\' => 1,\'7\' => 1,\'K\' => 1,\'2\' => 1,\'8\' => 1,\'1\' => 1,\'4\' => 1,\'5\' => 1);',NULL,'5.25','The grade and a matching index value used to find the term start and end dates when multi-Track school.'),(91,'admin','schoolyear',270,'g_TermDisplay','hash','%g_TermDisplay = (\'1\' => {\'1\' => \'Term 1\',\'3\' => \'Term 3\',\'2\' => \'Term 2\'});',NULL,'5.50','This controls the descriptive text that is shown for each particular term. This gives much more flexibility to the assignment of report periods.'),(92,'admin','schoolyear',275,'g_TermDisplayBlock','hash','%g_TermDisplayBlock = ();',NULL,'','List names for blocks of terms (typically called Semesters, etc). '),(93,'admin','schoolyear',280,'g_TrackDisplay','hash','%g_TrackDisplay = (\'1\' => \'All \');',NULL,'','Lists names associated with each Track.'),(94,'admin','system',700,'dbtype','scalar','$dbtype = \'mysql\';',NULL,'5.25','Type of the database. It is either \'mysql\' or \'pgsql\'. '),(95,'admin','system',705,'sql','hash','%sql = (\'like\' => \'like\',\'default\' => \'NULL\');',NULL,'5.25','SQL values to make use of both MySQL and PostgreSQL possible. We have only been using MySQL for several years. Do Not Change.'),(96,'admin','system',710,'maxfilesize','scalar','$maxfilesize = 30000;',NULL,'5.25','The maximum file size for uploads.'),(97,'admin','system',715,'adminname','scalar','$adminname = \'\';',NULL,'5.25','Name of the system administrator for the Open Admin server. This is displayed when a system error has occurred.'),(98,'admin','system',720,'adminemail','scalar','$adminemail = \'openadmin@gmail.com\';',NULL,'5.25','Email address of the system admin who manages the Open Admin server. This is the contact email address that is shown in the case of system errors.'),(99,'admin','system',730,'g_InacSchool','scalar','$g_InacSchool = \'\';',NULL,'5.75','The INAC (Indigenous and Northern Affairs Canada) number of the school'),(100,'admin','system',740,'g_SessionDuration','scalar','$g_SessionDuration = \'30\';',NULL,'',''),(101,'admin','system',750,'g_OpenadminVersion','scalar','$g_OpenadminVersion = \'11.0\';',NULL,'',''),(284,'admin','staffpay',1750,'pay_LeaveAreas','array','@pay_LeaveAreas = (\'Sick\',\'Bereavement\',\'Personal\',\'Family\');','','','The types of predefined leave categories that hold starting hours.'),(103,'admin','system',765,'remoteuser','scalar','$remoteuser = \'REMOTEUSER\';',NULL,'8.50','User access to remote server for previous year attendance and marks information'),(104,'admin','system',766,'remotepassword','scalar','$remotepassword = \'REMOTEPASSWORD\';',NULL,'8.50','Password for access to remote server for previous year attendance and marks information'),(105,'admin','system',767,'remotehost','scalar','$remotehost = \'192.168.1.237\';',NULL,'8.50','IP Address of remote server for previous year attendance and marks information'),(106,'admin','system',780,'g_FeederSchools','array','@g_FeederSchools = ();',NULL,'',''),(107,'admin','url-other',1100,'cgiurl','scalar','$cgiurl = \'/cgi-bin\';',NULL,'5.25','The URL address for the scripts. This is also set in the Apache configuration for the script alias value. Leave it at \'/cgi-bin\'. '),(108,'admin','url-other',1105,'tcgiurl','scalar','$tcgiurl = \'/cgi-bin\';',NULL,'5.25','The URL for all teacher site scripts. This is also set in the Apache web server configuration value. Do not change.'),(109,'admin','url-other',1110,'webdownloaddir','scalar','$webdownloaddir = \'/download\';',NULL,'5.25','The URL location of the download directory for downloading PDF files, etc. Do Not change.'),(110,'admin','url-other',1115,'tchwebdownloaddir','scalar','$tchwebdownloaddir = \'/download\';',NULL,'5.25','The URL for file download on the teacher site. Again, leave at \'/download\', unless you are using a custom configuration of some sort.'),(111,'admin','url-other',1120,'css','scalar','$css = \'/admin.css\';',NULL,'5.25','The location of the CSS file. This is sent by the scripts as part of the page header.'),(112,'admin','url-other',1125,'tchcss','scalar','$tchcss = \'/tadmin.css\';',NULL,'5.25','The URL for the teacher CSS file.'),(113,'admin','url-other',1130,'parcss','scalar','$parcss = \'/padmin.css\';',NULL,'5.25','The URL of the parent site CSS file.'),(114,'admin','url-other',1135,'picdirurl','scalar','$picdirurl = \'/pic-big\';',NULL,'5.25','The URL for the full sized pictures (ie. more pixels) of students'),(115,'admin','url-other',1140,'tndirurl','scalar','$tndirurl = \'/pic-sm\';',NULL,'5.25','The Thumbnail Directory URL (TN Dir Url). The location of the pictures of students in a smaller pixel format (ie. thumbnail) for fast loading/display.'),(116,'admin','url-other',1150,'g_jquery_url','scalar','$g_jquery_url = \'//ajax.googleapis.com/ajax/libs/jquery/2.0.3/jquery.min.js\';',NULL,'8.00','The URL of the jQuery Library'),(117,'admin','url-other',1155,'g_jquery_ui_url','scalar','$g_jquery_ui_url = \'//ajax.googleapis.com/ajax/libs/jqueryui/1.10.3/jquery-ui.min.js\';',NULL,'8.00','The URL of the jQuery UI Library. Loaded second'),(118,'fees','general',2000,'debitSign','scalar','$debitSign = \'-\';',NULL,'5.25','Sign convention for debit values.'),(119,'fees','general',2005,'padding_digits','scalar','$padding_digits = 4;',NULL,'5.25','Number of digits to left pad record id\'s. '),(120,'fees','general',2010,'profiles','hash','%profiles = (\'Elementary\' => \'Grade: K 1 2 3 4 5 6\',\'High School\' => \'Grade: 10 11 12\',\'Middle Years\' => \'Grade: 7 8 9\');',NULL,'5.25','Grade Profiles'),(121,'fees','tax',2015,'f_tax1','hash','%f_tax1 = (\'rate\' => \'0.05\',\'pass\' => 1,\'account\' => \'\',\'name\' => \'GST\',\'description\' => \'Goods and Services Tax\');',NULL,'','Stores the characteristics of the first tax charged.'),(122,'fees','tax',2016,'f_tax2','hash','%f_tax2 = (\'rate\' => \'0.05\',\'pass\' => 1,\'account\' => \'\',\'name\' => \'PST\',\'description\' => \'Provincial Sales Tax\');',NULL,'','Stores the characteristics of the second tax charged.'),(123,'fees','tax',2017,'f_tax3','hash','%f_tax3 = (\'rate\' => \'0\',\'pass\' => 1,\'account\' => \'\',\'name\' => \'\',\'description\' => \'\');',NULL,'','Stores the characteristics of the third tax charged.'),(124,'fees','tax',2018,'f_tax4','hash','%f_tax4 = (\'rate\' => \'0\',\'pass\' => 1,\'account\' => \'\',\'name\' => \'\',\'description\' => \'\');',NULL,'','Stores the characteristics of the fourth tax charged.'),(125,'first_nation','Certifier',10,'certifier_firstname','scalar','$certifier_firstname = \'\';',NULL,'','First Name of Certifier'),(126,'first_nation','Certifier',15,'certifier_lastname','scalar','$certifier_lastname = \'\';',NULL,'','Last Name of Certifier'),(127,'first_nation','Certifier',20,'certifier_title','scalar','$certifier_title = \'Principal\';',NULL,'','Title of Certifier (ie. Principal, Vice-Principal)'),(128,'first_nation','Contact',10,'contact_firstname','scalar','$contact_firstname = \'\';',NULL,'','First Name of Contact'),(129,'first_nation','Contact',12,'contact_lastname','scalar','$contact_lastname = \'\';',NULL,'','Last Name of Contact'),(130,'first_nation','Contact',15,'contact_title','scalar','$contact_title = \'Principal\';',NULL,'','Title of Contact (ie. Principal, Vice-Principal)'),(131,'first_nation','Contact',20,'contact_phone','scalar','$contact_phone = \'\';',NULL,'','Phone of Contact'),(132,'first_nation','Contact',21,'contact_phone_ext','scalar','$contact_phone_ext = \'\';',NULL,'','Phone Extension of Contact'),(133,'first_nation','Contact',25,'contact_email','scalar','$contact_email = \'\';',NULL,'','Email of Contact'),(134,'first_nation','Contact',30,'contact_address','scalar','$contact_address = \'\';',NULL,'','Address of Contact'),(135,'first_nation','Contact',35,'contact_city','scalar','$contact_city = \'\';',NULL,'','City of Contact'),(136,'first_nation','Contact',40,'contact_province','scalar','$contact_province = \'\';',NULL,'','Province of Contact'),(137,'first_nation','Contact',45,'contact_postalcode','scalar','$contact_postalcode = \'\';',NULL,'','Postal Code of Contact'),(138,'first_nation','General',10,'region','scalar','$region = \'6\';',NULL,'','AANDC Region of the School'),(139,'first_nation','General',20,'provincialcertification','scalar','$provincialcertification = \'true\';',NULL,NULL,'Provincial Certification (true or false (blank=false)'),(140,'first_nation','General',30,'tuitionagreement','scalar','$tuitionagreement = \'\';',NULL,NULL,'Tuition Agreement with students attending Provincial Schools'),(141,'first_nation','Recipient',10,'recipientnumber','scalar','$recipientnumber = \'\';',NULL,'','AANDC Recipient Number'),(142,'first_nation','Recipient',20,'recipient_name','scalar','$recipient_name = \'\';',NULL,NULL,'Recipient Name'),(143,'first_nation','Recipient',30,'recipient_id','scalar','$recipient_id = \'\';',NULL,NULL,'Recipient ID (typically band number)'),(144,'first_nation','Recipient',40,'recipient_type','scalar','$recipient_type = \'01\';',NULL,NULL,'Recipient Type'),(145,'first_nation','Recipient',50,'recipient_phone','scalar','$recipient_phone = \'\';',NULL,'',''),(146,'first_nation','Recipient',60,'recipient_phone_ext','scalar','$recipient_phone_ext = \'\';',NULL,'',''),(147,'first_nation','Recipient',70,'recipient_fax','scalar','$recipient_fax = \'\';',NULL,'',''),(148,'first_nation','Recipient',80,'recipient_street','scalar','$recipient_street = \'\';',NULL,'',''),(149,'first_nation','Recipient',90,'recipient_city','scalar','$recipient_city = \'\';',NULL,'',''),(150,'first_nation','Recipient',100,'recipient_province','scalar','$recipient_province = \'\';',NULL,'',''),(151,'first_nation','Recipient',110,'recipient_postalcode','scalar','$recipient_postalcode = \'\';',NULL,'',''),(152,'first_nation','School',10,'deliveryorg_name','scalar','$deliveryorg_name = \'\';',NULL,NULL,'Delivery Org Name'),(153,'first_nation','School',20,'deliveryorg_id','scalar','$deliveryorg_id = \'\';',NULL,NULL,'Delivery Org ID'),(154,'first_nation','School',30,'deliveryorg_type','scalar','$deliveryorg_type = \'24\';',NULL,NULL,'Delivery Org Type'),(155,'gbook',NULL,NULL,'altcolor','scalar','$altcolor = \'#3B7\';',NULL,'5.25','Alternate color value to the green of teacher site, to stand out. Don\'t forget the # symbol.'),(156,'gbook',NULL,NULL,'defaultItemWeight','scalar','$defaultItemWeight = 500;',NULL,'5.25','Default Item Weight for each assessment item. Do not alter this unless you have a very good idea of what you\'re doing.'),(157,'gbook',NULL,NULL,'specchar','scalar','$specchar = \'*\';',NULL,'5.25','The character used for an assessment so that the value is ignored by the averaging process. This values means the test is ignored or \'excused\'.'),(158,'gbook',NULL,NULL,'useMultipliers','scalaronoff','$useMultipliers = 1;',NULL,'5.25','Turn on the use of weight multipliers when adding items, rather than just raw weight values. Also used by weight adjustment of items.'),(159,'gbook',NULL,NULL,'wtmult','hash','%wtmult = (\'6\' => \'1.5\',\'3\' => \'0.5\',\'7\' => \'2\',\'9\' => \'4\',\'2\' => \'0.33333\',\'8\' => \'3\',\'1\' => \'0.2\',\'4\' => \'0.66666\',\'0\' => \'0\',\'5\' => \'1\');',NULL,'5.25','Mapping function that maps arbitrary values (with 5 being \'normal\') to weight multipliers.'),(160,'image',NULL,NULL,'convertprog','scalar','$convertprog = \'/usr/bin/convert\';',NULL,'5.25','The location of the ImageMagick convert program in the file system. Used to convert image sizes.'),(161,'image',NULL,NULL,'imageheight','scalar','$imageheight = \'300\';',NULL,'5.25','The height uploaded student/staff images are converted to, in pixels (using the ImageMagick convert program)'),(162,'image',NULL,NULL,'maxbufcount','scalar','$maxbufcount = 4096;',NULL,'5.25','The maximum size of uploaded image files (including zip files of images) in KBytes. '),(163,'image',NULL,NULL,'thumbheight','scalar','$thumbheight = \'150\';',NULL,'5.25','The height of converted upload images in pixels. These are stored in the thumbnails folder (pic-sm).'),(164,'ldap',NULL,NULL,'adminpassword','scalar','$adminpassword = \'password\';',NULL,'5.25','Admin password to manage the LDAP server.'),(165,'ldap',NULL,NULL,'adminuser','scalar','$adminuser = \'cn=admin,dc=jp2,dc=loccsd,dc=ca\';',NULL,'5.25','Admin user to manage LDAP directory.'),(166,'ldap',NULL,NULL,'basedn','scalar','$basedn = \'dc=jp2,dc=loccsd,dc=ca\';',NULL,'5.25','Base Distinguished Name.'),(167,'ldap',NULL,NULL,'group_staff','scalar','$group_staff = \'staff\';',NULL,'5.25','The name of the staff group in the LDAP directory.  Matches the Staff GID, of course, on the user management server. (ie. NFS, Samba mounts, etc.)'),(168,'ldap',NULL,NULL,'group_student','scalar','$group_student = \'student\';',NULL,'5.25','The text name for the student group in the LDAP directory.  '),(169,'ldap',NULL,NULL,'ldap_staff_gidnumber','scalar','$ldap_staff_gidnumber = 600;',NULL,'5.25','The gid (Group ID) number for the staff accounts on the server(s). '),(170,'ldap',NULL,NULL,'ldap_startinguidnumber','scalar','$ldap_startinguidnumber = 10000;',NULL,'5.25','Starting values for UID (User Id) numbers for new LDAP accounts. Existing accounts may be lower and there may be new accounts already higher than this value. It might better be called a \'suggested starting point\' for adding new accounts. '),(171,'ldap',NULL,NULL,'ldap_student_gidnumber','scalar','$ldap_student_gidnumber = 500;',NULL,'5.25','The gid (Group ID) number for the student accounts on the server(s). '),(172,'ldap',NULL,NULL,'org','scalar','$org = \'\';',NULL,'5.25','Organization to use in the ldap directory.'),(173,'ldap',NULL,NULL,'servername','scalar','$servername = \'myserver.ca\';',NULL,'5.25','LDAP server to manage.'),(174,'ldap',NULL,NULL,'slappasswd','scalar','$slappasswd = \'/usr/local/sbin/slappasswd\';',NULL,'5.25','Location of the slappasswd binary in the filesystem.'),(175,'repcard','Config',100,'r_CalcGPA','scalaronoff','$r_CalcGPA = \'0\';',NULL,'4.75','On/Off type; Turns on the GPA (Grade Point Average) calculation.'),(176,'repcard','Config',110,'r_ClassAvg','scalaronoff','$r_ClassAvg = \'0\';',NULL,'4.75','On/Off type. When turned on, it will calculate the class average for a subject and place the class average in the comment section.'),(177,'repcard','Config',120,'r_PrintYearEnd','scalaronoff','$r_PrintYearEnd = 1;',NULL,'4.75','On/Off type. Whether to print a year end section for graduation'),(178,'repcard','Config',130,'r_ShowAdmins','scalaronoff','$r_ShowAdmins = \'0\';',NULL,'4.75','On/Off type. Turns on the principal/vice principal names at top of the report card.'),(179,'repcard','Config',140,'r_ShowDemerits','scalaronoff','$r_ShowDemerits = \'0\';',NULL,'4.75','On/Off Type. Turns on demerits display function.'),(180,'repcard','Config',150,'r_ShowGradeCategory','scalaronoff','$r_ShowGradeCategory = \'0\';',NULL,'4.75','On/Off type. Turns this function on or off. The Grade Category is another approach to ranking students. The function assigns a value based on their marks in various subjects.'),(181,'repcard','Config',160,'r_ShowGradeScheme','scalaronoff','$r_ShowGradeScheme = \'1\';',NULL,'5.00','On/Off type. Turns on the evaluation scheme ( set in evalsch variable).'),(182,'repcard','Config',170,'r_ShowHomeroomTeacher','scalaronoff','$r_ShowHomeroomTeacher = \'1\';',NULL,'4.75','On/Off type. Turns on the homeroom teacher printing at top of report card.'),(183,'repcard','Config',180,'r_ShowLogo','scalaronoff','$r_ShowLogo = \'0\';',NULL,'4.75','On/Off type. Shows the logo at top of the report card, rather than just the school name.'),(184,'repcard','Config',190,'r_ShowProvNum','scalaronoff','$r_ShowProvNum = \'1\';',NULL,'5.00','On/Off type. Show provincial/state number at the top of the report card.'),(185,'repcard','Config',200,'r_ShowRanking','scalaronoff','$r_ShowRanking = 0;',NULL,'4.75','On/Off type. Shows the ranking of the student in the class.'),(186,'repcard','Config',210,'r_ShowSubjectAttendance','hash','%r_ShowSubjectAttendance = (\'PK\' => 0, \'K\' => 0, 1 => 0, 2 =>0,3 =>0, 4=>0, 5=>0, 6=>0, 7=>0, 8=>0, 9=>1, 10=>1, 11=>1, 12=>1);',NULL,'5.75','Subject Attendance display control (On/Off 1/0) for each grade.'),(187,'repcard','Config',220,'r_ShowTermAverage','scalaronoff','$r_ShowTermAverage = \'0\';',NULL,'4.75','On/Off type. Shows the term average for the student.'),(188,'repcard','Config',230,'r_SingleTermOnly','scalaronoff','$r_SingleTermOnly = \'0\';',NULL,'','Sets if teacher can post from the gradebook to the current term only (when set to 1) or if teacher can choose term from drop-down (when set to 0)'),(189,'repcard','Config',240,'r_SkipBlankReportCard','scalaronoff','$r_SkipBlankReportCard = \'0\';',NULL,'4.75','On/Off type.  If turned on, it will skip students that have no evaluations (i.e. students have just enrolled, etc)'),(190,'repcard','Config',250,'r_SupressSubject','hash','%r_SupressSubject = (\'123\' => \'1\');',NULL,'5.00','Either subject codes (8412) or subject-section codes (8412-2) are checked against this list and will not show up on the report card. Additional Comments subjects (which are used to store the global, non-subject comments) should not be placed on this list, but are set separately (using r_AdditionalComments). Add values by putting the subject code or subject-section as the new key and a 1 as the new value.'),(191,'repcard','Config',260,'r_TeacherModeOverride','scalaronoff','$r_TeacherModeOverride = 0;',NULL,'4.75','On/Off type. Teacher mode for the report card means it is called from the teacher site. This mode normally only allows the teacher to print his/her own students and subjects. By leaving this override on (ie. =1), the teacher site will print the report card exactly as on the main admin site.'),(192,'repcard','Config',270,'r_TermDisplay','hash','%r_TermDisplay = (\'4\' => \'Term 4\',\'1\' => \'Term 1\',\'3\' => \'Term 3\',\'2\' => \'Term 2\');',NULL,'5.00','To be renamed to g_TermDisplay and moved to admin.conf. Maps the term number to descriptive text.'),(193,'repcard','Config',280,'r_MarkEntryTerm','hash','%r_MarkEntryTerm = (\'1\' => \'1\');',NULL,NULL,'Controls the mark entry term for each of the tracks (blocks of grades).'),(194,'repcard','Eval Key',400,'r_Eval','hashofarray','%r_Eval = (\'c\' => [\'4: Exceeds expectations\',\'3: Fully meets expectations\',\'2: Meets expectations at beginning level\',\'1: Not yet within expectations\'],\'a\' => [\'E::Excellent\',\'G::Good\',\'S::Satisfactory\',\'NI::Needs Improvement\',\'AR::At Risk of Failure\'],\'b\' => [\'VG::Very Good\',\'G::Good\',\'I::Improving\',\'N::Needs More Practice\',\'NA::Not Applicable At This Time\']);',NULL,'5.00','All of the Evaluation/Assessment Keys - general values for all subjects. These are pointed to by the EvalSch variable that maps each grade to a particular assessment group.'),(195,'repcard','Eval Key',405,'r_EvalSch','hash','%r_EvalSch = (\'6\' => \'a\',\'11\' => \'a\',\'PK\' => \'b\',\'3\' => \'a\',\'7\' => \'a\',\'K\' => \'c\',\'9\' => \'a\',\'12\' => \'a\',\'2\' => \'a\',\'8\' => \'a\',\'4\' => \'a\',\'1\' => \'a\',\'10\' => \'a\',\'5\' => \'a\');',NULL,'5.00','A structure that maps the grades to a particular evaluation key found in the Eval variable.'),(196,'repcard','Eval Key',410,'r_EvalAlt1','hashofarray','%r_EvalAlt1 = (\'a\' => [\'4::Eagerly engages in activities. Encourages and supports peers  in learning. Fulfills requirements for task. Produces work of high quality.\',\'3::Willingly participates in activities. Completes tasks with care.  Fulfills most requirements for tasks. Produces work of satisfactory quality.\',\'2::Participates in activities with some encouragement. Completes most  tasks. Partially fulfills requirements. Produces work of marginal quality.\',\'1::Requires continual encouragement to participate in activites. Has  difficulty completing tasks. Seldom fulfills requirements. Work is often late, missing,  or sketchy\']);',NULL,'5.00','Alternate Evaluation Key (#1)'),(197,'repcard','Eval Key',420,'r_EvalAlt1Title','scalar','$r_EvalAlt1Title = \'Effort\';',NULL,'5.00','Title of the alternate evaluation Key #1'),(198,'repcard','Eval Key',440,'r_EvalSchAlt1','hash','%r_EvalSchAlt1 = (\'8\' => \'a\',\'6\' => \'a\',\'4\' => \'a\',\'1\' => \'a\',\'3\' => \'a\',\'7\' => \'a\',\'2\' => \'a\',\'5\' => \'a\');',NULL,'5.00','An Alternate mapping key between grade and evaluation key.'),(199,'repcard','Eval Key',450,'r_PDEval','hashofarray','%r_PDEval = (\'a\' => [\'I - Independent - Student is able to demonstrate appropriate social  and personal behaviours independently and consistently\',\'M - Meeting Success - Student demonstrates appropriate personal and  social behaviours in the school environment.\',\'P - Progressing with Support - Student is progressing towards an  awareness of appropriate personal and social behaviours in the school environment.  He/She often requires guidance.\',\'D - Experiencing Difficulty - Extensive guidance is required for student  to display appropriate personal and social behaviours in a school environment.\'],\'b\' => [\'O - Outstanding\',\'G - Good\',\'A - Acceptable\',\'NI - Needs Improvement\']);',NULL,'5.00','Holds the Personal Development evaluation key. The PDEvalGrp variable holds the \r\nkeys that map to a particular grade.'),(200,'repcard','Eval Key',460,'r_PDEvalGrp','hash','%r_PDEvalGrp = (\'6\' => \'a\',\'PK\' => \'c\',\'3\' => \'a\',\'K\' => \'c\',\'7\' => \'a\',\'2\' => \'a\',\'8\' => \'a\',\'1\' => \'a\',\'4\' => \'a\',\'5\' => \'a\');',NULL,'5.00','Maps the grade to a particular evaluation key for Personal Development subject.'),(201,'repcard','Eval Key',470,'r_Personal_Growth','scalar','$r_Personal_Growth = \'Personal and Social Development\';',NULL,'5.00','Name of the Personal Growth subject'),(202,'repcard','Eval Key',480,'r_AssessKeyCols','scalar','$r_AssessKeyCols = \'3\';',NULL,'5.00','Number of columns used for the evaluation keys.'),(203,'repcard','Eval Key',490,'r_AssessKeyWidth','scalar','$r_AssessKeyWidth = \'140mm\';',NULL,'5.00','Width of the Evaluation Keys.'),(204,'repcard','Layout',680,'r_CenterSubjects','scalaronoff','$r_CenterSubjects = \'1\';',NULL,'5','On/Off type to center subject table on report card. Typically on.'),(205,'repcard','Layout',710,'r_FontSize','scalar','$r_FontSize = \'10pt\';',NULL,'5.00','Font Size, typically 10 or 11 points.'),(206,'repcard','Layout',720,'r_GrayScale','scalar','$r_GrayScale = \'0.90\';',NULL,'5.00','Darkness of the gray section of table headings, etc. Typically 0.90 to 0.92  Change this value depending on the output from your laser printer or digital photocopier, since this is variable.'),(207,'repcard','Layout',730,'r_HOffset','scalar','$r_HOffset = \'-8mm\';',NULL,'5.00','Horizontal offset for items on the page. It shifts things left and right.'),(208,'repcard','Layout',733,'r_VOffset','scalar','$r_VOffset = \'-15mm\';',NULL,'5.00','The vertical offset for page elements on the report card. Shifts everything up or down.'),(209,'repcard','Layout',740,'r_LogoFile','scalar','$r_LogoFile = \'schoollogo.jpg\';',NULL,'5.00','Name of the School Logo file'),(210,'repcard','Layout',750,'r_LogoWidth','scalar','$r_LogoWidth = \'42mm\';',NULL,'5.00','Width of the School Logo'),(211,'repcard','Layout',752,'r_DivLogoFile','scalar','$r_DivLogoFile = \'\';',NULL,'5.00','Name of the division logo file. Having a blank entry turns this off.'),(212,'repcard','Layout',754,'r_DivLogoWidth','scalar','$r_DivLogoWidth = \'18mm\';',NULL,'4.75','Width of the school division logo.'),(213,'repcard','Layout',770,'r_SchoolAddressWidth','scalar','$r_SchoolAddressWidth = \'70mm\';',NULL,'5.00','Width of the school address at the top of the report card.'),(214,'repcard','Layout',775,'r_AddressSpacer','scalar','$r_AddressSpacer = \'5mm\';',NULL,'4.75','Amount of vertical space below logos to help align the address vertically with the logos.'),(215,'repcard','Layout',780,'r_SubjSpace','scalar','$r_SubjSpace = \'80mm\';',NULL,'5.00','Width of the subject name cell in the marks table. Use only measurements in mm.'),(216,'repcard','Layout',783,'r_MarkSpace','scalar','$r_MarkSpace = \'15mm\';',NULL,'5.00','Width of the cell in the table used to show evaluation outcomes. Use only measurements in mm.'),(217,'repcard','Layout',790,'r_TermDisplayLeading','scalaronoff','$r_TermDisplayLeading = 1;',NULL,'4.75','On/Off type. Controls whether later starting subjects display back to start term with blanks.'),(218,'repcard','Layout',800,'r_TermDisplayTrailing','scalaronoff','$r_TermDisplayTrailing = 1;',NULL,'4.75','On/Off type. Allows completed subjects to extend to current term with blanks.'),(219,'repcard','Notes',900,'r_Note1','scalar','$r_Note1 = \'\';',NULL,'4.75','A note that is displayed near top of the report card, just below student name section.'),(220,'repcard','Notes',910,'r_Note2','scalar','$r_Note2 = \'\';',NULL,'4.75','A note that is displayed near top of the report card, just below student name section.'),(221,'repcard','Notes',920,'r_Note3','scalar','$r_Note3 = \'\';',NULL,NULL,'Note 3 is located at bottom of report card, below global comment (additional comment), but above tear off line for parents.'),(222,'repcard','Notes',930,'r_Note4','scalar','$r_Note4 = \'\';',NULL,NULL,'Note 4 is located at bottom of report card below tear off line for parents (or placement text at year end).'),(223,'repcard','Picture',1000,'r_ShowStudentPicture','scalaronoff','$r_ShowStudentPicture = \'1\';',NULL,'5.25','On/Off type. Turn on Student Pictures to show on the report card.'),(224,'repcard','Picture',1010,'r_StudentPictureWidth','scalar','$r_StudentPictureWidth = \'25mm\';',NULL,'5.25','Sets the width of a student picture, when student pictures are turned on with the ShowStudentPicture setting.'),(225,'repcard','Placement',1100,'r_FinalTerm','hash','%r_FinalTerm = (1 => 3, 2 => 3, 3 => 3, 4 => 3, 5 => 3, 6 => 3, 7 => 3, 8 => 3, 9 => undef, 10 => undef, 11 => undef, 12 => undef);',NULL,'5.00','The final term for each grade in the school. Used to trigger the printing of the graduation section feature, if turned on. We map the grade to a particular final term. If undefined for that grade, the feature is not used.'),(226,'repcard','Placement',1110,'r_PlacementIndex','hash','%r_PlacementIndex = (\'PK\' => \'a\',\'K\' => \'a\',\'1\' => \'a\',\'2\' => \'a\',\'3\' => \'a\',\'4\' => \'a\',\'5\' => \'a\',\'6\' => \'a\',\'7\' => \'a\',\'8\' => \'a\',\'9\' => \'a\',\'10\' => \'a\',\'11\' => \'a\',\'12\' => \'a\');',NULL,'5.00','This value controls which Placment text (r_PlacementTeX value) is used based on their grade. '),(227,'repcard','Placement',1120,'r_PlacementTex','hash','%r_PlacementTex = (\'a\' => \'\\\\begin{tabular}{c}{\\\\sf YOURSCHOOL School}\\\\\\\\ {\\\\LARGE\\\\sf Student Placement}\\\\\\\\ {\\\\bf\\\\it\\\\Large %studentname% }\\\\\\\\ will be placed in Grade \\\\underline{\\\\hspace{13mm}} at the beginning  of the next school year.\\\\\\\\ \\\\medskip\\\\\\\\ \\\\underline{\\\\hspace{61mm}} \\\\hfill \\\\underline{\\\\hspace{61mm}}\\\\\\\\ {\\\\small Principal} \\\\hfill {\\\\small Teacher}\\\\\\\\ {\\\\large\\\\sf June 30, %schoolyearend%} \\\\end{tabular};\');',NULL,'5.00','The TeX markup for the placement section of the student in the next school year.\r\nIt is printed at year end and controlled by the FinalTerm value.'),(228,'repcard','Section Control',1200,'r_NewPageBeforeAttendance','scalaronoff','$r_NewPageBeforeAttendance = 1;',NULL,'4.75','On/Off type to turn on a hard page break before the attendance page.'),(229,'repcard','Section Control',1210,'r_ShowAdditionalComments','scalaronoff','$r_ShowAdditionalComments = 1;',NULL,'4.75','On/Off type. Turns on ability to show additional comments section (the generalized comment section of report card below attendance).'),(230,'repcard','Section Control',1220,'r_ShowMonthlyAttendance','scalar','$r_ShowMonthlyAttendance = \'4\';',NULL,'4.75','Show the attendance section (by month). The value here (1-4) controls where it prints on the report card. 1=top, 2=below keys, 3=below subjects, 4=below additional comments. There is also a separate feature to show subject attendance. (showSubjectAttendance). A value of 0 will not display any monthly attendance at all.'),(231,'repcard','Section Control',1230,'r_ShowTearoff','scalaronoff','$r_ShowTearoff = \'1\';',NULL,'5.00','On/Off type. Turns on showing the tearoff section of the report card.'),(232,'repcard','Setting',1500,'r_AdditionalComments','hash','%r_AdditionalComments = (\'99999\'=>1,\'99998\'=> 1);',NULL,'5.00','Subject codes and/or subject-section values for the additional comments subjects used for global comments. The \'marks\' in these subjects are ignored. It is a hash value so several values can be used, if required. The best approach is to use a common subject code for all of these \'subjects\', and just change the section value for different grades.'),(233,'repcard','Setting',1510,'r_AverageWeight','hashofarray','%r_AverageWeight = (\'1-2\' => [\'0.4\',\'0.6\']);',NULL,'4.75','When using the calcAverage function to come up with an average value from all terms, the values here are used to weight the term marks to come up with the weighted average for the student to date.'),(234,'repcard','Setting',1512,'r_AveragePrecision','scalar','$r_AveragePrecision = \'2\';',NULL,NULL,'Controls the number of decimal places displayed in average.'),(235,'repcard','Setting',1530,'r_GCDisplay','hash','%r_GCDisplay = (\'4\' => \'P\',\'1\' => \'I\',\'3\' => \'III\',\'2\' => \'II\',\'5\' => \'U\');',NULL,'4.75','Grade Category Display hash. It maps a particular returned valued from the calcGradeCategory function into a particular display value on the report card. The function would have to be customized to return values described in policy.'),(236,'repcard','Setting',1540,'r_LateAbsentRatio','scalar','$r_LateAbsentRatio = 3;',NULL,'4.75','For subject attendance this value will convert lates into absences. Typically 3 lates = 1 absent.'),(237,'repcard','Setting',1550,'r_MarkField','scalar','$r_MarkField = \'a1\';',NULL,'5.00','Field used to store a numeric value. Typically \'a1\' but could go from a2 to a20.'),(238,'repcard','Setting',1570,'r_Position','scalar','$r_Position = \'Classroom Teacher\';',NULL,'5.00','Name of the Position that marks a staff member as a homeroom teacher. (ie. teaches most of the subjects to that one group of students; typical in the lower grade levels). '),(239,'repcard','Setting',1580,'r_Principal','scalar','$r_Principal = \'Principal\';',NULL,'4.75','Name of the principal. His/Her name at top of report card, if the feature turned on.'),(240,'repcard','Setting',1583,'r_VicePrincipal','scalar','$r_VicePrincipal = \'Vice-principal\';',NULL,'4.75','Description of the Vice Principal at top of the report card'),(241,'repcard','Setting',1590,'r_PrintParentSig','scalaronoff','$r_PrintParentSig = 1;',NULL,'4.75','On/Off type to show parent signature section with tear off.'),(242,'repcard','Setting',1600,'r_TeacherSign','scalar','$r_TeacherSign = \'teacher\';',NULL,'5.00','Selects kind of signing method: teacher, principal, or both, called \'combo\'. Only one of those 3 values can be used: teacher, principal, or combo.'),(243,'schedule',NULL,NULL,'ptime','array','@ptime = (\'\',\'9:05-9:55\',\'10:00-10:50\',\'10:55-11:45\',\'12:35-1:25\',\'1:30-2:20\',\'2:25-3:15\');',NULL,'5.25','The period intervals during the day. Start Time and End Time. It is 1 based (no zeroth period). Leave the first element blank.'),(244,'transcript',NULL,NULL,'creditValues','array','@creditValues = (\'1\',\'0.5\',\'0.3333\',\'0.25\',\'0.125\');',NULL,'5.25','The various values that a course can have for credit. These are fractional values with sufficient precision  ( 1/2, 1/3, 1/4, 1/8 )'),(245,'transcript',NULL,NULL,'failletter','scalar','$failletter = \'F\';',NULL,'5.25','Character indicating a failed class (on a Pass/Fail basis).'),(246,'transcript',NULL,NULL,'gradRequirements','hash','%gradRequirements = (\'English\' => \'4\',\'Bible\' => \'2\',\'Math\' => \'3\',\'Science\' => \'3\',\'Social Studies\' => \'3.5\',\'Worldview\' => \'1\',\'Phys Ed\' => \'0.5\',\'Logic\' => \'1\',\'Languages\' => \'2\',\'Fine Arts\' => \'1\');',NULL,'5.25','Graduation Requirements. These would be the credits required in each of the subject areas. Each course has a subject area setting that would match these key values.'),(247,'transcript',NULL,NULL,'letterToQual','hash','%letterToQual = (\'F\' => \'0\',\'A\' => \'4.00\',\'B-\' => \'2.67\',\'A-\' => \'3.67\',\'D+\' => \'1.33\',\'B\' => \'3\',\'B+\' => \'3.33\',\'C+\' => \'2.33\',\'D\' => \'1\',\'C\' => \'2\',\'D-\' => \'0.67\',\'C-\' => \'1.67\',\'A+\' => \'4.00\');',NULL,'5.25','This is part of the GPA (Grade Point Average) calculation that converts a letter grade back into a numeric value. There should be little need to change this.'),(248,'transcript',NULL,NULL,'markToLetter','hash','%markToLetter = (\'59.9\' => \'D-\',\'79.5\' => \'B-\',\'72.5\' => \'C\',\'62.5\' => \'D\',\'69.5\' => \'C-\',\'82.5\' => \'B\',\'77.5\' => \'C+\',\'97.5\' => \'A+\',\'0\' => \'F\',\'67.5\' => \'D+\',\'92.5\' => \'A\',\'87.5\' => \'B+\',\'89.5\' => \'A-\');',NULL,'5.25','This is used to convert a numeric grade value into a letter grade value in the transcript system.'),(249,'transcript',NULL,NULL,'passletter','scalar','$passletter = \'P\';',NULL,'5.25','Letter indicating a passed class (on a Pass/Fail basis).'),(250,'transcript',NULL,NULL,'section1','scalar','$section1 = \'Honours classes receive extra +0.5 grade point.\n\nAP classes receive +1.0 extra grade point\n\n\';',NULL,'5.25','Section 1 description for use on the transcript(report).'),(251,'transcript',NULL,NULL,'term_desc','hash','%term_desc = (\'c\' => \'Undefined\',\'a\' => \'Fall Semester\',\'b\' => \'Spring Semester\');',NULL,'5.25','Term Text Description - soon to be duplicated in admin.conf'),(252,'transcript',NULL,NULL,'term_key','hash','%term_key = (\'6\' => \'c\',\'3\' => \'b\',\'7\' => \'c\',\'2\' => \'a\',\'8\' => \'c\',\'1\' => \'a\',\'4\' => \'b\',\'5\' => \'c\');',NULL,'5.25','Term Keys that map grade level to a particular group of term descriptions.'),(253,'transcript',NULL,NULL,'t_TruncateSection','scalaronoff','$t_TruncateSection = \'1\';',NULL,'5.25','On/Off type. Whether to truncate section text or not. (1=On, 0=Off). Only used by the transcript report.'),(254,'transcript','',0,'t_ShowMark','scalaronoff','$t_ShowMark = \'1\';',NULL,'4.00','Show mark (number grade) on transcripts, rather than letter grade.'),(255,'usermanage',NULL,NULL,'google_domain','scalar','$google_domain = \'DOMAIN\';',NULL,'5.25','Google Domain to manage.'),(256,'usermanage',NULL,NULL,'google_username','scalar','$google_username = \'admin\';',NULL,'5.25','Google Domain admin user.'),(257,'usermanage',NULL,NULL,'google_password','scalar','$google_password = \'PASSWORD\';',NULL,'5.25','Google Domain Password'),(258,'usermanage','',0,'gradeskip','array','@gradeskip = (\'PK\', \'K\', \'1\', \'2\');',NULL,'5.25','Grades NOT to add accounts for in Google Apps.'),(259,'admin','dates',412,'dowstd','array','@dowstd = (\'Sunday\', \'Monday\', \'Tuesday\', \'Wednesday\', \'Thursday\', \'Friday\', \'Saturday\');',NULL,'10.5','Day of Week values (longer form) with a 0 value being Sunday.'),(260,'first_nation','School',40,'f_DirectorFirstname','scalar','$f_DirectorFirstname = \'\';',NULL,NULL,'First Name of Education Director'),(261,'first_nation','School',50,'f_DirectorLastname','scalar','$f_DirectorLastname = \'\';',NULL,NULL,'Last Name of Education Director'),(262,'fees','report',2030,'f_FeesRolloverDate','scalar','$f_FeesRolloverDate = \'2020-01-01\';','','','This variable sets the starting date for transaction viewing in transactview.pl script.'),(263,'admin','system',770,'g_BritishSchoolMode','scalaronoff','$g_BritishSchoolMode = \'0\';','','','This variable turns on British School mode, affecting grades to forms translation.'),(264,'admin','discipline',1410,'g_DiscAction','array','@g_DiscAction = (\'reviewed student\\\'s file\',\'had conference with student\',\'consulted counsellor\',\'consulted elder\');','','','This variable lists actions taken by the school.'),(265,'admin','discipline',1400,'g_DiscInfraction','hash','%g_DiscInfraction = (\'Skipping classes\' => \'1\',\'Left grounds w/o permission\' => \'1\',\'Uncooperative- Defiant\' => \'1\',\'Destructive to school property\' => \'1\',\'Bullying other students\' => \'1\',\'Disrespectful and uncooperative\' => \'1\',\'Substance Abuse violation\' => \'1\',\'Gang Related\' => \'1\',\'Defacing school property\' => \'1\',\'Smoking in restricted areas\' => \'1\',\'Defiance- Skipping in-school suspension\' => \'1\',\'Brought a weapon to school\' => \'1\',\'Rude / discourteous\' => \'1\',\'Unacceptable language\' => \'1\',\'Excessive talking\' => \'1\',\'Smoking when not permitted to do so\' => \'1\',\'Student Placed on Contract\' => \'1\',\'Excessive tardiness\' => \'1\',\'Fighting\' => \'1\');','','','This variable lists all infractions for the discipline system.'),(266,'admin','Email',1500,'g_EmailAuthId','scalar','$g_EmailAuthId = \'user\';',NULL,NULL,'The email userid with access to the mail server.'),(267,'admin','Email',1510,'g_EmailAuthPwd','scalar','$g_EmailAuthPwd = \'password \';',NULL,NULL,'The password for access to the mail server.'),(268,'admin','Email',1550,'g_EmailPersona','hash','%g_EmailPersona = (\'noreply\' => \'No Reply <noreply@school.org>\');',NULL,NULL,'The various persona used when sending email via scripts.'),(269,'admin','Email',1520,'g_EmailPort','scalar','$g_EmailPort = \'587\';',NULL,NULL,'The port address to use for communication to the mail server. Port 25 is the typical port for unencrypted traffic. Port 587 is used for encrypted TLS traffic.'),(270,'admin','Email',1530,'g_EmailServer','scalar','$g_EmailServer = \'localhost\';',NULL,NULL,'The DNS name or IP address of the mail server. Defaults to localhost.'),(271,'admin','Email',1540,'g_EmailUseTLS','scalar','$g_EmailUseTLS = \'1\';',NULL,NULL,'A zero or one value to turn off or on the use of encrypted TLS communication. Also requires a port change as well'),(272,'admin','system',773,'g_FormMap','hash','%g_FormMap = (\'7\' => \'f1\',\'8\' => \'F2\');','','','This hash maps the grade to a particular form value.'),(273,'admin','homevisit',100,'g_HomeVisitReason','array','@g_HomeVisitReason = (\'Attendance\', \'Suspension/Explusion\', \'Illness\', \'Mental Health Concern\', \'Parent Pickup for Meeting\', \'Student Service Related (Parent/Guardian Signature)\', \'Bus Issue\', \'Other\');',NULL,'10.5','The list of all home visit reasons in display order.'),(274,'admin','url-other',1160,'g_JqueryUiCss','scalar','$g_JqueryUiCss = \'https://ajax.googleapis.com/ajax/libs/jqueryui/1.10.3/themes/smoothness/jquery-ui.css\';','','','URL to the css file used by jquery UI.'),(275,'admin','IEP',100,'g_MasteryLevel','array','@g_MasteryLevel = (\'50%\',\'75%\',\'95%\');','','','The Mastery Level required for objectives in the IEP system.'),(276,'admin','timetable',1810,'g_PeriodMap','hash','%g_PeriodMap = (\'12\' => \'A\',\'11\' => \'A\',\'10\' => \'A\');','','','This variable maps period blocks found in the g_PeriodTime hash to particular grades (that are set as having subject attendance). Grades without subject attendance (ie. homeroom) will allow teachers to set their own periods on a per grade basis.'),(277,'admin','timetable',1800,'g_PeriodTime','hash','%g_PeriodTime = (\'B\' => {\'1\' => {\'s\' => \'9:00\',\'e\' => \'10:00\'},\'3\' => {\'e\' => \'12:30\',\'s\' => \'11:20\'},\'2\' => {\'s\' => \'10:10\',\'e\' => \'11:10\'},\'4\' => {\'s\' => \'12:40 \',\'e\' => \'13:50 \'}},\'A\' => {\'3\' => {\'e\' => \'16:30\',\'s\' => \'15:15\'},\'1\' => {\'e\' => \'14:30\',\'s\' => \'13:30\'},\'2\' => {\'s\' => \'14:40\',\'e\' => \'15:10\'}});','','','Block of Period Start and End Times.'),(278,'admin','schoolrole',815,'g_StaffAbsReason','array','@g_StaffAbsReason = (\'Unexcused\', \'Culture\', \'Sport\', \'Professional Development\', \'Medical Appointment\', \'Illness\', \'Bereavment\', \r\n\'Late\', \'EDO\', \'Mat/Pat Leave\', \'Annual Leave\', \'Sp Leave w Pay\',\'Leave w/o Pay\',\'Other (specify)\');\r\n','','','List of Staff Absence Reasons for missing school.'),(279,'admin','preplan',1700,'pp_DaysPerCycle','scalar','$pp_DaysPerCycle = \'6\';','','','For the pre-plan system, the number of days in a teaching cycle.'),(280,'admin','preplan',1715,'pp_DefaultPeriodsPerCycle','scalar','$pp_DefaultPeriodsPerCycle = \'6\';','','','For the pre-plan system, a default value, where the value is not set, for the number of teaching periods per teaching cycle. For example, if you have a 6 day cycle, and you want to teach every day, then it would be 6. If you have a 5 day cycle..ie weekly, then a value of 5 would possibly make it every day or a double period one day and no periods on another day.'),(281,'admin','preplan',1720,'pp_Grade9PassingAverage','scalar','$pp_Grade9PassingAverage = \'48\';','','','For the pre-plan system, the average value used to find how many grade 9s will be in grade 10 in the following year'),(282,'admin','preplan',1705,'pp_PeriodsPerDay','scalar','$pp_PeriodsPerDay = \'6\';','','','For the pre-plan system, the number of teaching periods per day. Independent from the number of attendance periods per day.'),(283,'admin','preplan',1710,'pp_SemesterCount','scalar','$pp_SemesterCount = \'2\';','','','For the pre-plan system, the number of semesters in a school year. A semester is the smallest time interval that courses run. Typically a semester is 2 terms long (2 report cards), in a 4 term school year.'),(285,'first_nation','General',40,'count_culture','scalar','$count_culture = \'\';',NULL,NULL,'Number of students who are provided with culturally-based curriculum or land-based learning services'),(286,'first_nation','General',50,'count_language','scalar','$count_language = \'\';',NULL,NULL,'Number of students who are taught at least one subject in a First Nations language');
/*!40000 ALTER TABLE `conf_system` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contactlog`
--

DROP TABLE IF EXISTS `contactlog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contactlog` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studnum` int(11) DEFAULT NULL,
  `cdate` date DEFAULT NULL,
  `category` varchar(255) DEFAULT NULL,
  `description` text,
  `author` varchar(40) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contactlog`
--

LOCK TABLES `contactlog` WRITE;
/*!40000 ALTER TABLE `contactlog` DISABLE KEYS */;
/*!40000 ALTER TABLE `contactlog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cree_scores`
--

DROP TABLE IF EXISTS `cree_scores`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cree_scores` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studnum` int(11) DEFAULT NULL,
  `treatynum` varchar(16) DEFAULT NULL,
  `tdate` date DEFAULT NULL,
  `tauthor` varchar(40) DEFAULT NULL,
  `tgrade` varchar(8) DEFAULT NULL,
  `tage` varchar(16) DEFAULT NULL,
  `tstamp` datetime DEFAULT NULL,
  `prepost` varchar(16) DEFAULT NULL,
  `scoremonth` smallint(6) DEFAULT NULL,
  `score` smallint(6) DEFAULT NULL,
  `schoolyear` char(4) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cree_scores`
--

LOCK TABLES `cree_scores` WRITE;
/*!40000 ALTER TABLE `cree_scores` DISABLE KEYS */;
/*!40000 ALTER TABLE `cree_scores` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dates`
--

DROP TABLE IF EXISTS `dates`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dates` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` date DEFAULT NULL,
  `type` varchar(60) DEFAULT NULL,
  `desc1` varchar(60) DEFAULT NULL,
  `desc2` varchar(60) DEFAULT NULL,
  `dayincycle` char(1) DEFAULT NULL,
  `dayfraction` decimal(4,3) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dates`
--

LOCK TABLES `dates` WRITE;
/*!40000 ALTER TABLE `dates` DISABLE KEYS */;
/*!40000 ALTER TABLE `dates` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dates_nonschool`
--

DROP TABLE IF EXISTS `dates_nonschool`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dates_nonschool` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` date DEFAULT NULL,
  `period` tinyint(4) DEFAULT NULL,
  `homeroom` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dates_nonschool`
--

LOCK TABLES `dates_nonschool` WRITE;
/*!40000 ALTER TABLE `dates_nonschool` DISABLE KEYS */;
/*!40000 ALTER TABLE `dates_nonschool` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dates_periods`
--

DROP TABLE IF EXISTS `dates_periods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dates_periods` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` date DEFAULT NULL,
  `grades` char(8) DEFAULT NULL,
  `period` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dates_periods`
--

LOCK TABLES `dates_periods` WRITE;
/*!40000 ALTER TABLE `dates_periods` DISABLE KEYS */;
/*!40000 ALTER TABLE `dates_periods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dbkactivity`
--

DROP TABLE IF EXISTS `dbkactivity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dbkactivity` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` varchar(32) DEFAULT NULL,
  `title` varchar(32) DEFAULT NULL,
  `description` text,
  `startterm` tinyint(3) unsigned DEFAULT NULL,
  `endterm` tinyint(3) unsigned DEFAULT NULL,
  `acttype` varchar(32) DEFAULT NULL,
  `subjsec` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dbkactivity`
--

LOCK TABLES `dbkactivity` WRITE;
/*!40000 ALTER TABLE `dbkactivity` DISABLE KEYS */;
/*!40000 ALTER TABLE `dbkactivity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dbkdata`
--

DROP TABLE IF EXISTS `dbkdata`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dbkdata` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` varchar(40) DEFAULT NULL,
  `date` date DEFAULT NULL,
  `subjsec` varchar(32) DEFAULT NULL,
  `period` smallint(6) DEFAULT NULL,
  `topic` varchar(255) DEFAULT NULL,
  `notes` text,
  `homework` varchar(255) DEFAULT NULL,
  `hwdate` date DEFAULT NULL,
  `category` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dbkdata`
--

LOCK TABLES `dbkdata` WRITE;
/*!40000 ALTER TABLE `dbkdata` DISABLE KEYS */;
/*!40000 ALTER TABLE `dbkdata` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dbktimetable`
--

DROP TABLE IF EXISTS `dbktimetable`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dbktimetable` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` varchar(40) DEFAULT NULL,
  `term` tinyint(3) unsigned DEFAULT NULL,
  `day` tinyint(3) unsigned DEFAULT NULL,
  `period` tinyint(3) unsigned DEFAULT NULL,
  `courseact` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dbktimetable`
--

LOCK TABLES `dbktimetable` WRITE;
/*!40000 ALTER TABLE `dbktimetable` DISABLE KEYS */;
/*!40000 ALTER TABLE `dbktimetable` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `disc_action`
--

DROP TABLE IF EXISTS `disc_action`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `disc_action` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studnum` int(11) DEFAULT NULL,
  `eventid` int(11) DEFAULT NULL,
  `action` text,
  `date` date DEFAULT NULL,
  `comment` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `disc_action`
--

LOCK TABLES `disc_action` WRITE;
/*!40000 ALTER TABLE `disc_action` DISABLE KEYS */;
/*!40000 ALTER TABLE `disc_action` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `disc_event`
--

DROP TABLE IF EXISTS `disc_event`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `disc_event` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `location` varchar(255) DEFAULT NULL,
  `date` date DEFAULT NULL,
  `time` time DEFAULT NULL,
  `author` varchar(40) DEFAULT NULL,
  `infraction` varchar(255) DEFAULT NULL,
  `description` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `disc_event`
--

LOCK TABLES `disc_event` WRITE;
/*!40000 ALTER TABLE `disc_event` DISABLE KEYS */;
/*!40000 ALTER TABLE `disc_event` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `disc_ident`
--

DROP TABLE IF EXISTS `disc_ident`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `disc_ident` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studnum` int(11) DEFAULT NULL,
  `eventid` int(11) DEFAULT NULL,
  `private` char(1) DEFAULT NULL,
  `demerit` tinyint(3) unsigned DEFAULT NULL,
  `comment` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `disc_ident`
--

LOCK TABLES `disc_ident` WRITE;
/*!40000 ALTER TABLE `disc_ident` DISABLE KEYS */;
/*!40000 ALTER TABLE `disc_ident` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eval`
--

DROP TABLE IF EXISTS `eval`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `eval` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `subjcode` varchar(32) DEFAULT NULL,
  `studnum` varchar(32) DEFAULT NULL,
  `teacher` varchar(32) DEFAULT NULL,
  `term` int(11) DEFAULT NULL,
  `program` varchar(255) DEFAULT NULL,
  `comment` text,
  `a1` varchar(12) DEFAULT NULL,
  `a2` varchar(12) DEFAULT NULL,
  `a3` varchar(12) DEFAULT NULL,
  `a4` varchar(12) DEFAULT NULL,
  `a5` varchar(12) DEFAULT NULL,
  `a6` varchar(12) DEFAULT NULL,
  `a7` varchar(12) DEFAULT NULL,
  `a8` varchar(12) DEFAULT NULL,
  `a9` varchar(12) DEFAULT NULL,
  `a10` varchar(12) DEFAULT NULL,
  `a11` varchar(12) DEFAULT NULL,
  `a12` varchar(12) DEFAULT NULL,
  `a13` varchar(12) DEFAULT NULL,
  `a14` varchar(12) DEFAULT NULL,
  `a15` varchar(12) DEFAULT NULL,
  `a16` varchar(12) DEFAULT NULL,
  `a17` varchar(12) DEFAULT NULL,
  `a18` varchar(12) DEFAULT NULL,
  `a19` varchar(12) DEFAULT NULL,
  `a20` varchar(12) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `eval_subjcode` (`subjcode`),
  KEY `eval_studnum` (`studnum`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eval`
--

LOCK TABLES `eval` WRITE;
/*!40000 ALTER TABLE `eval` DISABLE KEYS */;
/*!40000 ALTER TABLE `eval` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ext_moodle`
--

DROP TABLE IF EXISTS `ext_moodle`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ext_moodle` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `subjsec` varchar(32) DEFAULT NULL,
  `subjcode` varchar(32) DEFAULT NULL,
  `studnum` int(11) DEFAULT NULL,
  `role` varchar(64) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ext_moodle`
--

LOCK TABLES `ext_moodle` WRITE;
/*!40000 ALTER TABLE `ext_moodle` DISABLE KEYS */;
/*!40000 ALTER TABLE `ext_moodle` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eyedata`
--

DROP TABLE IF EXISTS `eyedata`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `eyedata` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studnum` int(11) DEFAULT NULL,
  `provnum` varchar(12) DEFAULT NULL,
  `birthdate` date DEFAULT NULL,
  `tdate` date DEFAULT NULL,
  `tgrade` varchar(8) DEFAULT NULL,
  `season` varchar(16) DEFAULT NULL,
  `evaltype` varchar(4) DEFAULT NULL,
  `prepost` varchar(16) DEFAULT NULL,
  `score_ase` varchar(8) DEFAULT NULL,
  `score_soc` varchar(8) DEFAULT NULL,
  `score_cog` varchar(8) DEFAULT NULL,
  `score_lang` varchar(8) DEFAULT NULL,
  `score_pdgross` varchar(8) DEFAULT NULL,
  `score_pdfine` varchar(8) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eyedata`
--

LOCK TABLES `eyedata` WRITE;
/*!40000 ALTER TABLE `eyedata` DISABLE KEYS */;
/*!40000 ALTER TABLE `eyedata` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fees_jrl`
--

DROP TABLE IF EXISTS `fees_jrl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fees_jrl` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studnum` int(11) DEFAULT NULL,
  `trans_date` date DEFAULT NULL,
  `trans_type` varchar(8) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `description` text,
  `subtotal` decimal(10,2) DEFAULT NULL,
  `tax1` decimal(10,2) DEFAULT NULL,
  `tax1_name` varchar(16) DEFAULT NULL,
  `tax2` decimal(10,2) DEFAULT NULL,
  `tax2_name` varchar(16) DEFAULT NULL,
  `tax3` decimal(10,2) DEFAULT NULL,
  `tax3_name` varchar(16) DEFAULT NULL,
  `tax4` decimal(10,2) DEFAULT NULL,
  `tax4_name` varchar(16) DEFAULT NULL,
  `total` decimal(10,2) DEFAULT NULL,
  `paid_id` int(11) DEFAULT NULL,
  `receipt` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fees_jrl`
--

LOCK TABLES `fees_jrl` WRITE;
/*!40000 ALTER TABLE `fees_jrl` DISABLE KEYS */;
/*!40000 ALTER TABLE `fees_jrl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fees_predefined`
--

DROP TABLE IF EXISTS `fees_predefined`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fees_predefined` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(16) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `amount` double DEFAULT NULL,
  `discount` double DEFAULT NULL,
  `tax1_flag` char(1) DEFAULT NULL,
  `tax2_flag` char(1) DEFAULT NULL,
  `tax3_flag` char(1) DEFAULT NULL,
  `tax4_flag` char(1) DEFAULT NULL,
  `group_name` varchar(32) DEFAULT NULL,
  `group_value` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fees_predefined`
--

LOCK TABLES `fees_predefined` WRITE;
/*!40000 ALTER TABLE `fees_predefined` DISABLE KEYS */;
/*!40000 ALTER TABLE `fees_predefined` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gbscore`
--

DROP TABLE IF EXISTS `gbscore`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `gbscore` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `studnum` mediumint(8) unsigned DEFAULT NULL,
  `testid` int(10) unsigned DEFAULT NULL,
  `score` varchar(16) DEFAULT NULL,
  `comment` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `studtestidx` (`studnum`,`testid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `gbscore`
--

LOCK TABLES `gbscore` WRITE;
/*!40000 ALTER TABLE `gbscore` DISABLE KEYS */;
/*!40000 ALTER TABLE `gbscore` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gbtest`
--

DROP TABLE IF EXISTS `gbtest`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `gbtest` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `subjsec` varchar(32) DEFAULT NULL,
  `name` varchar(32) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `tdate` date DEFAULT NULL,
  `score` varchar(8) DEFAULT NULL,
  `scheme` varchar(8) DEFAULT NULL,
  `weight` mediumint(8) unsigned DEFAULT NULL,
  `grp` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `gbtest`
--

LOCK TABLES `gbtest` WRITE;
/*!40000 ALTER TABLE `gbtest` DISABLE KEYS */;
/*!40000 ALTER TABLE `gbtest` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `homevisit`
--

DROP TABLE IF EXISTS `homevisit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `homevisit` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `author` varchar(64) DEFAULT NULL,
  `date` date DEFAULT NULL,
  `studnum` int(11) DEFAULT NULL,
  `reason` varchar(255) DEFAULT NULL,
  `description` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `homevisit`
--

LOCK TABLES `homevisit` WRITE;
/*!40000 ALTER TABLE `homevisit` DISABLE KEYS */;
/*!40000 ALTER TABLE `homevisit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iep_eval`
--

DROP TABLE IF EXISTS `iep_eval`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `iep_eval` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studnum` int(11) DEFAULT NULL,
  `subnum` int(11) DEFAULT NULL,
  `obj1` varchar(255) DEFAULT NULL,
  `obj2` varchar(255) DEFAULT NULL,
  `obj3` varchar(255) DEFAULT NULL,
  `obj4` varchar(255) DEFAULT NULL,
  `obj5` varchar(255) DEFAULT NULL,
  `obj6` varchar(255) DEFAULT NULL,
  `obj7` varchar(255) DEFAULT NULL,
  `obj8` varchar(255) DEFAULT NULL,
  `obj9` varchar(255) DEFAULT NULL,
  `obj10` varchar(255) DEFAULT NULL,
  `obj11` varchar(255) DEFAULT NULL,
  `obj12` varchar(255) DEFAULT NULL,
  `obj13` varchar(255) DEFAULT NULL,
  `obj14` varchar(255) DEFAULT NULL,
  `obj15` varchar(255) DEFAULT NULL,
  `obj16` varchar(255) DEFAULT NULL,
  `obj17` varchar(255) DEFAULT NULL,
  `obj18` varchar(255) DEFAULT NULL,
  `obj19` varchar(255) DEFAULT NULL,
  `obj20` varchar(255) DEFAULT NULL,
  `obj21` varchar(255) DEFAULT NULL,
  `obj22` varchar(255) DEFAULT NULL,
  `obj23` varchar(255) DEFAULT NULL,
  `obj24` varchar(255) DEFAULT NULL,
  `obj25` varchar(255) DEFAULT NULL,
  `obj26` varchar(255) DEFAULT NULL,
  `obj27` varchar(255) DEFAULT NULL,
  `obj28` varchar(255) DEFAULT NULL,
  `obj29` varchar(255) DEFAULT NULL,
  `obj30` varchar(255) DEFAULT NULL,
  `obj31` varchar(255) DEFAULT NULL,
  `obj32` varchar(255) DEFAULT NULL,
  `term` int(11) DEFAULT NULL,
  `comment` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iep_eval`
--

LOCK TABLES `iep_eval` WRITE;
/*!40000 ALTER TABLE `iep_eval` DISABLE KEYS */;
/*!40000 ALTER TABLE `iep_eval` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iep_evalmst`
--

DROP TABLE IF EXISTS `iep_evalmst`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `iep_evalmst` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studnum` int(11) DEFAULT NULL,
  `subnum` int(11) DEFAULT NULL,
  `obj1` text,
  `obj2` text,
  `obj3` text,
  `obj4` text,
  `obj5` text,
  `obj6` text,
  `obj7` text,
  `obj8` text,
  `obj9` text,
  `obj10` text,
  `obj11` text,
  `obj12` text,
  `obj13` text,
  `obj14` text,
  `obj15` text,
  `obj16` text,
  `obj17` text,
  `obj18` text,
  `obj19` text,
  `obj20` text,
  `obj21` text,
  `obj22` text,
  `obj23` text,
  `obj24` text,
  `obj25` text,
  `obj26` text,
  `obj27` text,
  `obj28` text,
  `obj29` text,
  `obj30` text,
  `obj31` text,
  `obj32` text,
  `strategy` text,
  `responsible` text,
  `longtermobjective` text,
  `impactarea` text,
  `targetskill` text,
  `currperform` text,
  `evalmethod` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iep_evalmst`
--

LOCK TABLES `iep_evalmst` WRITE;
/*!40000 ALTER TABLE `iep_evalmst` DISABLE KEYS */;
/*!40000 ALTER TABLE `iep_evalmst` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iep_objectives`
--

DROP TABLE IF EXISTS `iep_objectives`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `iep_objectives` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `catnum` int(11) DEFAULT NULL,
  `category` varchar(255) DEFAULT NULL,
  `idnum` int(11) DEFAULT NULL,
  `description` text,
  `author` varchar(40) DEFAULT NULL,
  `cdate` date DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=3033 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iep_objectives`
--

LOCK TABLES `iep_objectives` WRITE;
/*!40000 ALTER TABLE `iep_objectives` DISABLE KEYS */;
INSERT INTO `iep_objectives` VALUES (1,105,'Language - Receptive',1,'Show awareness of a speaker',NULL,NULL),(2,105,'Language - Receptive',2,'Discriminate between angry and friendly voices',NULL,NULL),(3,105,'Language - Receptive',3,'Look in response to own name',NULL,NULL),(4,105,'Language - Receptive',4,'Comprehend environment',NULL,NULL),(5,105,'Language - Receptive',5,'Look at some objects when names are spoken',NULL,NULL),(6,105,'Language - Receptive',6,'Smile and reach for self in mirror',NULL,NULL),(7,105,'Language - Receptive',7,'Respond to sounds when the source is not visible',NULL,NULL),(8,105,'Language - Receptive',8,'Attend to music or singing',NULL,NULL),(9,105,'Language - Receptive',9,'Anticipate steps within daily routine',NULL,NULL),(10,105,'Language - Receptive',10,'Understand simple questions and instructions; eg., sit down, stand up',NULL,NULL),(11,105,'Language - Receptive',11,'Understand more words than he or she can say',NULL,NULL),(12,105,'Language - Receptive',12,'Understand early concepts; eg. in, on, under',NULL,NULL),(13,105,'Language - Receptive',13,'Understand object function; eg., pour water through a funnel',NULL,NULL),(14,105,'Language - Receptive',14,'Follow two related directions; eg. pick up block and put it in bucket',NULL,NULL),(15,105,'Language - Receptive',15,'Understand questions about a story with pictures',NULL,NULL),(16,105,'Language - Receptive',16,'Follow three related directions',NULL,NULL),(17,110,'Language - Expressive',1,'Cry to get attention',NULL,NULL),(18,110,'Language - Expressive',2,'Vocalize to express pleasure and displeasure',NULL,NULL),(19,110,'Language - Expressive',3,'Stop vocalizing when another person vocalizes',NULL,NULL),(20,110,'Language - Expressive',4,'Call for attention',NULL,NULL),(21,110,'Language - Expressive',5,'Use a wide variety of sound combinations',NULL,NULL),(22,110,'Language - Expressive',6,'Use sentence-like intonation patterns',NULL,NULL),(23,110,'Language - Expressive',7,'Imitate sounds and names for familiar objects',NULL,NULL),(24,110,'Language - Expressive',8,'Nod for affirmation, negative',NULL,NULL),(25,110,'Language - Expressive',9,'Combine vocalization and gesture to obtain desired objects',NULL,NULL),(26,110,'Language - Expressive',10,'Talk more than gesture',NULL,NULL),(27,110,'Language - Expressive',11,'Use names for most familiar objects',NULL,NULL),(28,110,'Language - Expressive',12,'Use two-word phrases',NULL,NULL),(29,110,'Language - Expressive',13,'Relate personal experiences',NULL,NULL),(30,110,'Language - Expressive',14,'Use three-word phrases',NULL,NULL),(31,110,'Language - Expressive',15,'Use some pronouns; eg., he, me, you',NULL,NULL),(32,110,'Language - Expressive',16,'Answer who, what, where questions',NULL,NULL),(33,110,'Language - Expressive',17,'Use two sentence types; ie, statements and simple questions',NULL,NULL),(34,110,'Language - Expressive',18,'Use negation(no, not)',NULL,NULL),(35,110,'Language - Expressive',19,'Use plurals',NULL,NULL),(36,110,'Language - Expressive',20,'Use prepositions(in,on,under)',NULL,NULL),(37,110,'Language - Expressive',21,'Converse in simple, intelligible sentences (although grammatical errors may still be present)',NULL,NULL),(38,110,'Language - Expressive',22,'Use verb forms(present progressive - jumping; past tense regular - jumped; past tense irregular - broke) with some errors',NULL,NULL),(39,110,'Language - Expressive',23,'Describe objects and events',NULL,NULL),(40,110,'Language - Expressive',24,'Use helping verb forms; eg. is jumping, was not',NULL,NULL),(41,110,'Language - Expressive',25,'Use complex sentence and more advanced question forms; eg. what is, whose, who, how many',NULL,NULL),(42,110,'Language - Expressive',26,'Tell a sequenced story',NULL,NULL),(43,1399,'Social Development',25,'Request objects or activities with signs or words',NULL,NULL),(44,1399,'Social Development',4,'Greet familiar people with words or signs',NULL,NULL),(45,1399,'Social Development',18,'Ask a simple question',NULL,NULL),(46,1399,'Social Development',19,'Ask yes/no questions with appropriate inflection',NULL,NULL),(47,110,'Language - Expressive',202,'Comment on appearance or disappearance of objects or people ',NULL,NULL),(48,1399,'Social Development',26,'Request assistance',NULL,NULL),(49,1399,'Social Development',27,'Request permission',NULL,NULL),(50,1399,'Social Development',23,'Sustain conversation for several turns',NULL,NULL),(51,1399,'Social Development',22,'Talk on telephone; wait turn to respond',NULL,NULL),(52,110,'Language - Expressive',210,'Describe what is happening or what he or she is doing',NULL,NULL),(53,110,'Language - Expressive',203,'Complete incomplete sentence begun by an adult in a teaching context',NULL,NULL),(54,110,'Language - Expressive',200,'Describe functions of objects',NULL,NULL),(55,110,'Language - Expressive',201,'Name three or more elements in a picture or describe what is happening in a picture',NULL,NULL),(56,1399,'Social Development',21,'Respond correctly to what do you do and why do we questions.',NULL,NULL),(57,110,'Language - Expressive',204,'Tell a story by looking at pictures',NULL,NULL),(59,110,'Language - Expressive',207,'Communicate cause-and-effect relationships',NULL,NULL),(60,1399,'Social Development',20,'Use contingent questions to maintain a conversation(why did he do that? then what happened?)',NULL,NULL),(61,1399,'Social Development',14,'Create interest in a listener by indirect reference (i have a new toy.)',NULL,NULL),(62,110,'Language - Expressive',208,'Communicate knowledge about the world to peers and adults',NULL,NULL),(63,110,'Language - Expressive',206,'Tell two familiar stories without pictures for help',NULL,NULL),(64,120,'Language - Articulation',1,'student will produce the k, g, h, and ng sounds in isolation',NULL,NULL),(65,120,'Language - Articulation',2,'student will produce the l, w, y, r and r blend, l-blend sounds in isolation',NULL,NULL),(66,120,'Language - Articulation',3,'student will produce the m, n, p, and b sounds in isolation',NULL,NULL),(67,120,'Language - Articulation',4,'student will produce the t, d, and j sounds in isolation',NULL,NULL),(68,120,'Language - Articulation',5,'student will produce the f, v, sh, and ch sounds in isolation',NULL,NULL),(69,120,'Language - Articulation',6,'student will produce the s, z and s-blend sounds in isolation',NULL,NULL),(70,120,'Language - Articulation',7,'student will produce the Th-voiceless and Th-voiced  sounds in isolation',NULL,NULL),(71,120,'Language - Articulation',8,'student will produce the k, g, h, and ng sounds in words',NULL,NULL),(72,120,'Language - Articulation',9,'student will produce the l, w, y, r and r blend, l-blend sounds in words',NULL,NULL),(73,120,'Language - Articulation',10,'student will produce the m, n, p, and b sounds in words',NULL,NULL),(74,120,'Language - Articulation',11,'student will produce the t, d, and j sounds in words',NULL,NULL),(75,120,'Language - Articulation',12,'student will produce the f, v, sh, and ch sounds in words',NULL,NULL),(76,120,'Language - Articulation',13,'student will produce the s, z and s-blend sounds in words',NULL,NULL),(77,120,'Language - Articulation',14,'student will produce the Th-voiceless and Th-voiced  sounds in words',NULL,NULL),(78,120,'Language - Articulation',15,'student will produce the k, g, h, and ng sounds in sentences',NULL,NULL),(79,120,'Language - Articulation',16,'student will produce the l, w, y, r and r blend, l-blend sounds in sentences',NULL,NULL),(80,120,'Language - Articulation',17,'student will produce the m, n, p, and b sounds in sentences',NULL,NULL),(81,120,'Language - Articulation',18,'student will produce the t, d, and j sounds in sentences',NULL,NULL),(82,120,'Language - Articulation',19,'student will produce the f, v, sh, and ch sounds in sentences',NULL,NULL),(83,120,'Language - Articulation',20,'student will produce the s, z and s-blend sounds in sentences',NULL,NULL),(84,120,'Language - Articulation',21,'student will produce the Th-voiceless and Th-voiced  sounds in sentences',NULL,NULL),(85,120,'Language - Articulation',22,'student will produce the k, g, h, and ng sounds in conversation',NULL,NULL),(86,120,'Language - Articulation',23,'student will produce the l, w, y, r and r blend, l-blend sounds in conversation',NULL,NULL),(87,120,'Language - Articulation',24,'student will produce the m, n, p, and b sounds in conversation',NULL,NULL),(88,120,'Language - Articulation',25,'student will produce the t, d, and j sounds in conversation',NULL,NULL),(89,125,'Language - Expressive (Nonverbal)',1,'Discriminate between two pictures',NULL,NULL),(90,125,'Language - Expressive (Nonverbal)',2,'Associate one or two signs, pictures, symbols with their meaning',NULL,NULL),(91,125,'Language - Expressive (Nonverbal)',3,'Discriminate between two signs, pictures, symbols learned',NULL,NULL),(92,125,'Language - Expressive (Nonverbal)',4,'Use signs, pictures, symbols necessary in daily routines',NULL,NULL),(93,125,'Language - Expressive (Nonverbal)',5,'Use two-word communication - signs, pictures, symbols',NULL,NULL),(94,125,'Language - Expressive (Nonverbal)',6,'Use three-word communication - signs, pictures, symbols',NULL,NULL),(95,125,'Language - Expressive (Nonverbal)',7,'Use new signs, pictures, symbols for new routines',NULL,NULL),(96,125,'Language - Expressive (Nonverbal)',8,'Initiate interaction with others',NULL,NULL),(97,130,'Vocabulary - General Knowledge and Use',1,'student will demonstrate knowledge of family members names',NULL,NULL),(98,130,'Vocabulary - General Knowledge and Use',2,'student will demonstrate knowledge of names for familiar objects',NULL,NULL),(99,130,'Vocabulary - General Knowledge and Use',3,'student will identify (50) a variety of words including nouns(foods, body parts, furniture, household objects, important people); action words(sleep, wash, clap); modifiers(hot, clean); location words(up, here); social words(bye, hello) and emotion words(sad, mad)',NULL,NULL),(100,130,'Vocabulary - General Knowledge and Use',4,'student will demonstrate knowledge of (50) a variety of words including nouns(foods, body parts, furniture, household objects, important people); action words(sleep, wash, clap); modifiers(hot, clean); location words(up, here); social words(bye, hello) and emotion words(sad, mad)',NULL,NULL),(101,130,'Vocabulary - General Knowledge and Use',5,'student will identify (100) a variety of words including nouns(foods, body parts, furniture, household objects, important people); action words(sleep, wash, clap); modifiers(hot, clean); location words(up, here); social words(bye, hello) and emotion words(sad, mad)',NULL,NULL),(102,130,'Vocabulary - General Knowledge and Use',6,'student will demonstrate knowledge of (100) a variety of words including nouns(foods, body parts, furniture, household objects, important people); action words(sleep, wash, clap); modifiers(hot, clean); location words(up, here); social words(bye, hello) and emotion words(sad, mad)',NULL,NULL),(103,130,'Vocabulary - General Knowledge and Use',7,'student will say eight to 10 words spontaneously',NULL,NULL),(104,130,'Vocabulary - General Knowledge and Use',8,'Receptive;student will place objects into categories',NULL,NULL),(105,130,'Vocabulary - General Knowledge and Use',9,'Expressive: student will provide categories for given objects',NULL,NULL),(106,130,'Vocabulary - General Knowledge and Use',10,'student will ask the meaning of unfamiliar words',NULL,NULL),(2635,7010,'Emotional Skills',2,'Child will demonstrate appropriate relaxation techniques as taught by the teacher.',NULL,NULL),(2634,7010,'Emotional Skills',1,'Child will be able to identify his or her own feelings such as anger, sadness, frustration or irritability.',NULL,NULL),(112,130,'Vocabulary - General Knowledge and Use',11,'Receptive:student will identify concepts:head,legs,arms,back,stomach,hands,feet,fingers',NULL,NULL),(113,130,'Vocabulary - General Knowledge and Use',12,'Expressive:student will demonstrate knowledge of concepts:head,legs,arms,back,stomach,hands,feet,fingers',NULL,NULL),(114,130,'Vocabulary - General Knowledge and Use',13,'Receptive:student will identify concepts:mouth,eye,nose,ears,tongue,hair,neck',NULL,NULL),(115,130,'Vocabulary - General Knowledge and Use',14,'Expressive:student will demonstrate knowledge of concepts:mouth,eye,nose,ears,tongue,hair,neck',NULL,NULL),(116,130,'Vocabulary - General Knowledge and Use',15,'Receptive:student will identify concepts:thumb,fingernails,toes,heels,knee,chin,elbows,shoulders',NULL,NULL),(117,130,'Vocabulary - General Knowledge and Use',16,'Expressive:student will demonstrate knowledge of concepts:thumb,fingernails,toes,heels,knee,chin,elbows,shoulders',NULL,NULL),(118,130,'Vocabulary - General Knowledge and Use',17,'Receptive:student will identify concepts:chest,ankle,jaw,hips,wrists,waist,thigh,forearm',NULL,NULL),(119,130,'Vocabulary - General Knowledge and Use',18,'Expressive:student will demonstrate knowledge of concepts:chest,ankle,jaw,hips,wrists,waist,thigh,forearm',NULL,NULL),(2672,8025,'Number Facts-Addition',2,'Will correctly compute the sums, when given ten addition facts, for sums up to 6.',NULL,NULL),(2671,8025,'Number Facts-Addition',1,'Will correctly compute the sums, when given ten addition facts, for sums up to 4.',NULL,NULL),(2685,8035,'Number Facts- Multiplication',2,'Will correctly compute the product, when given ten multiplication facts, for the multipliers up to 3.',NULL,NULL),(142,130,'Vocabulary - General Knowledge and Use',19,'Receptive: student will identify colours: red, blue,yellow,green,orange,purple,black,brown,pink',NULL,NULL),(143,130,'Vocabulary - General Knowledge and Use',20,'Expressive: student will demonstrate knowledge of colours:red, blue,yellow,green,orange,purple,black,brown,pink',NULL,NULL),(2694,8040,'Number Facts-Division',1,'Will correctly compute the quotients, when given ten division facts, for the divisors up to 2.',NULL,NULL),(151,130,'Vocabulary - General Knowledge and Use',21,'Receptive: student will identify concepts:Rain,rainy,Hot, sunny,Cloudy,Cold,Windy',NULL,NULL),(152,130,'Vocabulary - General Knowledge and Use',22,'Expressive: student will demonstrate knowledge of concepts:Rain, rainy,Hot, sunny,Cloudy,Cold,Windy',NULL,NULL),(2742,8065,'Fractions',7,'Will demonstrate understanding of fraction 1/2, by shading the appropriate surface area or cutting an object.',NULL,NULL),(156,130,'Vocabulary - General Knowledge and Use',23,'Receptive: student will identify opposites: sick, healthy, boy, girl, man, woman, father, mother, brothers, sisters, wrong, right, old, young ',NULL,NULL),(157,130,'Vocabulary - General Knowledge and Use',24,'Expressive: student will demonstrate knowledge of opposites: sick, healthy, boy, girl, man, woman, father, mother, brothers, sisters, wrong, right, old, young',NULL,NULL),(158,130,'Vocabulary - General Knowledge and Use',25,'Receptive: student will identify emotions: happy, angr, sad, afraid(scared), excited, tired, friendly, relaxed, disappointed, hurt',NULL,NULL),(159,130,'Vocabulary - General Knowledge and Use',26,'Expressive: student will demonstrate knowledge of emotions: happy, angry, sad, afraid(scared), excited, tired, friendly, relaxed, disappointed, hurt',NULL,NULL),(171,130,'Vocabulary - General Knowledge and Use',39,'Receptive:student will identify concepts:Up, down,Right, left,End,Top, bottom,Closed, open,Out, in,Off on,Inside, outside,Under,Next to, beside,High, low,Back, side,front',NULL,NULL),(172,130,'Vocabulary - General Knowledge and Use',40,'Expressivestudent will demonstrate knowledge of concepts:Up/down,Right/left,End,Top/bottom,Closed/open,Out/in,Off/on,Inside/outside,Under,Next to/beside,High/low,Back/side/front',NULL,NULL),(173,130,'Vocabulary - General Knowledge and Use',41,'Receptive:student will identify concepts:Into/out of,Close to,Middle,Through,Beside,Near/far,Moving/standing still,Between,Edge,Over,Toward/away from,Centre,Above/below,Same/different/not the same,Alike(equal, identical),Other than',NULL,NULL),(174,130,'Vocabulary - General Knowledge and Use',42,'Expressive:student will demonstrate knowledge of concepts:Into/out of,Close to,Middle,Through,Beside,Near/far,Moving/standing still,Between,Edge,Over,Toward/away from,Centre,Above/below,Same/different/not the same,Alike(equal, identical),Other than',NULL,NULL),(2684,8035,'Number Facts- Multiplication',1,'Will correctly compute the product, when given ten multiplication facts, for the multipliers up to 2.',NULL,NULL),(2703,8045,'Addition',2,'Will correctly compute the answers, when given ten addition problems, for adding 2 digit numbers with 1 regrouping.',NULL,NULL),(2702,8045,'Addition',1,'Will correctly compute the answers, when given ten addition problems, for adding 2 digit numbers without regrouping.',NULL,NULL),(2710,8050,'Subtraction',2,'Will correctly compute the answers, when given ten subtraction problems, for subracting numbers with 2 digits with 1 regrouping.',NULL,NULL),(199,130,'Vocabulary - General Knowledge and Use',43,'Receptive:student will identify concepts:Medium sized, thick, wide, large, thin/fat, deep/shallow, short/long, heavy/light, tall/short, big/little(small)',NULL,NULL),(200,130,'Vocabulary - General Knowledge and Use',44,'Expressive:student will demonstrate knowledge of concepts:Medium sized, thick, wide, large, thin/fat, deep/shallow, short/long, heavy/light, tall/short, big/little(small)',NULL,NULL),(209,130,'Vocabulary - General Knowledge and Use',45,'Receptive: student will identify concepts:Sharp/dull,Smooth/rough,Loud/quiet,Hard/soft,Shiny,Wood/glass/metal,Dark/light, hot/cold, warm/cool, Slippery, jagged, bumpy',NULL,NULL),(210,130,'Vocabulary - General Knowledge and Use',46,'Expressive: student will demonstrate knowledge of concepts:Sharp/dull,Smooth/rough,Loud/quiet,Hard/soft,Shiny,Wood/glass/metal,Dark/light, hot/cold, warm/cool, Slippery, jagged, bumpy',NULL,NULL),(2749,1399,'Social Development',54,'Student will negotiate with teachers and peers.',NULL,NULL),(2882,8090,'Measurement',7,'When given 5 pairs of metric measurement, will indicate if each pair is of equal value or if one of the measurements is of greater value for linear units.',NULL,NULL),(216,174,'Additional Vocabulary',1,'student will demonstrate knowledge of  concepts: Before/after, now/later ',NULL,NULL),(217,174,'Additional Vocabulary',2,'student will demonstrate knowledge of  concepts:Leaving/arriving (coming),Finished/starting',NULL,NULL),(218,174,'Additional Vocabulary',3,'student will demonstrate knowledge of  concepts:Morning, afternoon/evening, today/tomorrow/yesterday,Daytime/night',NULL,NULL),(219,174,'Additional Vocabulary',4,'student will demonstrate knowledge of  concepts:Seasons',NULL,NULL),(220,174,'Additional Vocabulary',5,'student will demonstrate knowledge of  concepts:Old/new,Fast/slow',NULL,NULL),(221,174,'Additional Vocabulary',6,'student will demonstrate knowledge of  concepts:Finished/starting',NULL,NULL),(222,174,'Additional Vocabulary',7,' student will demonstrate knowledge of  concepts:minute/second/hour',NULL,NULL),(2947,8096,'Rounding Numbers',2,'When given five numbers, will round the numbers accurately to the nearest hundred.',NULL,NULL),(224,200,'Gross Motor Development',1,'Use extremities to alter direction or pivot, when on stomach',NULL,NULL),(225,200,'Gross Motor Development',2,'Creep forward on stomach',NULL,NULL),(226,200,'Gross Motor Development',3,'Maintain a sitting position on floor independently, briefly freeing arms',NULL,NULL),(227,200,'Gross Motor Development',9,'Push up onto hands and knees and rock',NULL,NULL),(228,200,'Gross Motor Development',8,'Achieve a prone position, or a position on hands and knees, from sitting position',NULL,NULL),(229,200,'Gross Motor Development',16,'Hold railing and maintain position, when placed in standing position ',NULL,NULL),(230,200,'Gross Motor Development',11,'Crawl on hands and knees for 5 feet',NULL,NULL),(231,200,'Gross Motor Development',18,'Pull to standing and maintain for 10 seconds',NULL,NULL),(232,200,'Gross Motor Development',6,'Lower self by collapsing',NULL,NULL),(233,200,'Gross Motor Development',4,'Assume sitting position independently from laying on back',NULL,NULL),(234,200,'Gross Motor Development',19,'Stand alone briefly for 5 seconds',NULL,NULL),(235,200,'Gross Motor Development',17,'Lift foot, when standing at railing',NULL,NULL),(236,200,'Gross Motor Development',5,'Scoot around while sitting',NULL,NULL),(237,200,'Gross Motor Development',24,'Walk sideways, holding on, when standing at a rail or by furniture for 5 steps',NULL,NULL),(238,200,'Gross Motor Development',25,'Walk, with one or both hands held',NULL,NULL),(239,200,'Gross Motor Development',7,'Lower to sitting from standing, without collasping',NULL,NULL),(240,200,'Gross Motor Development',26,'Walk independently for 5 steps',NULL,NULL),(241,200,'Gross Motor Development',10,'Assume and maintain kneeling position',NULL,NULL),(242,200,'Gross Motor Development',12,'Crawl up 4 stairs ',NULL,NULL),(243,200,'Gross Motor Development',27,'Walk independently with the ability to change direction',NULL,NULL),(2863,116,'Phonological Awareness',14,'student will demonstrate knowledge of phonemic awareness to spell (invented, creative spelling)',NULL,NULL),(245,200,'Gross Motor Development',46,'Squat to pick up object and re-erect',NULL,NULL),(246,200,'Gross Motor Development',61,'Ride a push toy for 2 meters',NULL,NULL),(247,200,'Gross Motor Development',14,'Climb onto chair, turn and sit',NULL,NULL),(248,200,'Gross Motor Development',38,'Run stiffly(hurried walk) for 2 meters',NULL,NULL),(249,200,'Gross Motor Development',28,'Walk up stairs, one hand held',NULL,NULL),(250,200,'Gross Motor Development',62,'Pull toy behind while walking for 2 meters',NULL,NULL),(251,200,'Gross Motor Development',20,'Stand on one foot, with hands held',NULL,NULL),(252,200,'Gross Motor Development',29,'Walk up stairs holding rail; walk down with hand held',NULL,NULL),(253,200,'Gross Motor Development',71,'Roll ball while sitting on floor',NULL,NULL),(254,200,'Gross Motor Development',72,'Kick playground ball when ball is placed',NULL,NULL),(255,200,'Gross Motor Development',56,'Stand on balance beam, with one hand held',NULL,NULL),(256,200,'Gross Motor Development',82,'Throw ball, arm and body moving as unit ',NULL,NULL),(257,200,'Gross Motor Development',45,'Squat to play',NULL,NULL),(258,200,'Gross Motor Development',51,'Attempt jumping up with both feet',NULL,NULL),(259,200,'Gross Motor Development',48,'Hop with one hand held',NULL,NULL),(260,200,'Gross Motor Development',67,'Pedal tricycle for 3 meters (not around corners)',NULL,NULL),(261,200,'Gross Motor Development',79,'Bounce playground ball and attempt to catch it',NULL,NULL),(262,200,'Gross Motor Development',57,'Walk on balance beam for 5 steps with one foot on and one foot off',NULL,NULL),(263,200,'Gross Motor Development',47,'Bend at waist to pick up objects',NULL,NULL),(264,200,'Gross Motor Development',30,'Walk backwards 5 steps',NULL,NULL),(265,200,'Gross Motor Development',32,'Walk up or down stairs alone, holding rail, without alternating feet',NULL,NULL),(266,200,'Gross Motor Development',52,'Jump from bottom step (feet together)',NULL,NULL),(267,200,'Gross Motor Development',33,'Walk with a heel-toe pattern for 5 steps',NULL,NULL),(268,200,'Gross Motor Development',74,'Kick a large ball with control (leg straight and some body movement)',NULL,NULL),(269,200,'Gross Motor Development',21,'Stand on either foot for 3 seconds',NULL,NULL),(270,200,'Gross Motor Development',15,'Climb jungle gyms and ladders for 3 rungs',NULL,NULL),(271,200,'Gross Motor Development',53,'Jump forward 3 times in a row with both feet',NULL,NULL),(272,200,'Gross Motor Development',68,'Ride tricycle around corners',NULL,NULL),(273,200,'Gross Motor Development',76,'Catch large ball with arms and body',NULL,NULL),(274,200,'Gross Motor Development',49,'Hop on preferred foot for 4 times',NULL,NULL),(275,200,'Gross Motor Development',94,'Walk on balance beam with no support and arms out to side for 1 meter',NULL,NULL),(276,200,'Gross Motor Development',36,'Walk on tiptoes for 10 steps',NULL,NULL),(277,200,'Gross Motor Development',58,'Walk straight line on balance beam for 2 meters',NULL,NULL),(278,200,'Gross Motor Development',39,'Run around obstacles smoothly',NULL,NULL),(279,200,'Gross Motor Development',34,'Walk up and down stairs, holding rail, with alternating feet',NULL,NULL),(280,200,'Gross Motor Development',22,'Balance on one foot, four to eight seconds',NULL,NULL),(281,200,'Gross Motor Development',77,'Catch large; medium; small ball with arms bent at elbows',NULL,NULL),(282,200,'Gross Motor Development',35,'Go up or down stairs, no rail, alternating feet',NULL,NULL),(283,200,'Gross Motor Development',55,'Perform a standing broad jump (40 to 50cm)',NULL,NULL),(284,200,'Gross Motor Development',59,'Walk on balance beam with hands at sides, using a heel-toe pattern',NULL,NULL),(285,200,'Gross Motor Development',91,'Somersault forward',NULL,NULL),(286,200,'Gross Motor Development',85,'Throw tennis ball stepping forward with leg on same side as throwing arm',NULL,NULL),(287,200,'Gross Motor Development',44,'Skip with alternating pattern; hippity-hop',NULL,NULL),(288,200,'Gross Motor Development',23,'Balance on one foot, eyes closed, seven to eight seconds',NULL,NULL),(289,200,'Gross Motor Development',41,'Run well; turn, stop and start and change speed',NULL,NULL),(290,200,'Gross Motor Development',50,'Hop on same foot eight to 10 times',NULL,NULL),(291,200,'Gross Motor Development',78,'Catch bounced ball with both hands',NULL,NULL),(292,200,'Gross Motor Development',69,'Ride small two-wheeled bike with training wheels for 3 meters',NULL,NULL),(293,200,'Gross Motor Development',92,'March in time to music for 15 steps',NULL,NULL),(294,200,'Gross Motor Development',93,'Use skates, skis or roller skates in forward direction for 4 meters',NULL,NULL),(295,200,'Gross Motor Development',60,'Walk backwards on beam, toe to heel for 2 meters',NULL,NULL),(296,200,'Gross Motor Development',81,'Catch bean bag with one hand',NULL,NULL),(297,200,'Gross Motor Development',70,'Ride bicycle for 5 meters',NULL,NULL),(298,200,'Gross Motor Development',88,'Dribble ball 5 times with direction ',NULL,NULL),(299,200,'Gross Motor Development',75,'Kick rolling ball with mature pattern',NULL,NULL),(300,200,'Gross Motor Development',42,'Run with increasing speed (32 metres in 10 seconds)',NULL,NULL),(301,200,'Gross Motor Development',84,'Throw with mature pattern',NULL,NULL),(302,200,'Gross Motor Development',89,'Skip rope independently for 5 skips',NULL,NULL),(2768,8070,'Time',1,'Will be able to identify clocks and watches as instruments that tell time.',NULL,NULL),(303,300,'Fine Motor Control',1,'Grasp objects with either hand',NULL,NULL),(304,300,'Fine Motor Control',2,'Shake, bang, pat-a-cake objects',NULL,NULL),(305,300,'Fine Motor Control',3,'Transfer an object from hand to hand',NULL,NULL),(306,300,'Fine Motor Control',4,'Voluntarily drop, throw, push, pull objects',NULL,NULL),(307,300,'Fine Motor Control',5,'Pick up small objects with thumb and fingers (crude pincer*) ',NULL,NULL),(308,300,'Fine Motor Control',6,'Use refined pincer grasp to pick up small objects',NULL,NULL),(309,300,'Fine Motor Control',7,'Place small object(s) in cup',NULL,NULL),(310,300,'Fine Motor Control',8,'Place one shape in a form board',NULL,NULL),(311,300,'Fine Motor Control',9,'Place rings on a stacking post(random order)',NULL,NULL),(312,300,'Fine Motor Control',16,'Stack three blocks (2.5-4cm)',NULL,NULL),(313,300,'Fine Motor Control',11,'Place four graduating nesting cups inside each other',NULL,NULL),(314,300,'Fine Motor Control',19,'Accurately drop pennies through a horizontal slot',NULL,NULL),(315,300,'Fine Motor Control',18,'String large (2.5cm) beads onto a lace',NULL,NULL),(316,300,'Fine Motor Control',12,'Roll, squeeze, pound or pinch play dough',NULL,NULL),(317,300,'Fine Motor Control',14,'Turn paper pages in a book, one page at a time',NULL,NULL),(318,300,'Fine Motor Control',20,'Accurately release small objects (pellets) from pincer grasp into a bottle',NULL,NULL),(319,300,'Fine Motor Control',21,'Screw and unscrew items',NULL,NULL),(320,300,'Fine Motor Control',15,'Turn doorknobs, handles',NULL,NULL),(321,300,'Fine Motor Control',17,'Stack 10 small blocks (2.5 cm)',NULL,NULL),(324,300,'Fine Motor Control',10,'Randomly place small; medium; large diameter pegs into pegboard ',NULL,NULL),(326,300,'Fine Motor Control',13,'Make clay shapes put together with two to three parts',NULL,NULL),(330,300,'Fine Motor Control',22,'Use pencil sharpener (hand held or manual type mounted on wall or shelf)',NULL,NULL),(331,300,'Fine Motor Control',23,'Scribble randomly on paper',NULL,NULL),(332,300,'Fine Motor Control',26,'Explore a variety of media (crayons, markers, chalk, paint)',NULL,NULL),(333,300,'Fine Motor Control',29,'Color over a picture using random strokes, strokes may extend beyond the boundaries of the picture',NULL,NULL),(334,300,'Fine Motor Control',30,'Attend to specific areas and boundaries of a picture when coloring',NULL,NULL),(335,300,'Fine Motor Control',28,'Use different colors when coloring different areas of a picture generally remain within lines(within 1 cm) in a simple picture)',NULL,NULL),(336,300,'Fine Motor Control',25,'Keep paper still with one hand while controlling maker/crayon with the other hand',NULL,NULL),(337,300,'Fine Motor Control',31,'Generally remain within lines (within 5mm) in a picture that has smaller areas and more detail',NULL,NULL),(338,300,'Fine Motor Control',27,'Choose ',NULL,NULL),(339,300,'Fine Motor Control',32,'Adjust stroke to fit within areas using single directional strokes',NULL,NULL),(340,300,'Fine Motor Control',33,'Precisely adjust the stroke length and direction for specialized effects such as shading and contour(illusion of three dimensions)',NULL,NULL),(342,300,'Fine Motor Control',24,'Scribble with identifiable repetitious strokes demonstrating a predominant stroke direction',NULL,NULL),(343,300,'Fine Motor Control',34,'Hold pencil in extended fingers with straight wrist, movements controlled from the forearm',NULL,NULL),(2862,116,'Phonological Awareness',13,'student will demonstrate knowledge of which of 3 words shares a common sound (e.g., dog,doll,pen)',NULL,NULL),(345,300,'Fine Motor Control',38,'Copy vertical stroke from top to bottom',NULL,NULL),(346,300,'Fine Motor Control',39,'Copy horizontal stroke from left to right',NULL,NULL),(347,300,'Fine Motor Control',40,'Copy circular stroke',NULL,NULL),(348,300,'Fine Motor Control',41,'Copy cross formed of horizontal and vertical lines. +',NULL,NULL),(349,300,'Fine Motor Control',42,'Copy circle in a counter clockwise direction',NULL,NULL),(350,300,'Fine Motor Control',35,'Hold pencil with the ends of the thumb, index and middle fingers, lines made by movements of the wrist and whole hand ',NULL,NULL),(351,300,'Fine Motor Control',37,'Trace shape - circle, square, triangle, oval, diamond',NULL,NULL),(352,300,'Fine Motor Control',43,'Copy 2 horizontal lines:  =',NULL,NULL),(353,300,'Fine Motor Control',44,'Copy 2 vertical lines:  II',NULL,NULL),(354,300,'Fine Motor Control',45,'Copy square',NULL,NULL),(355,300,'Fine Motor Control',36,'Hold pencil with mature three-point grasp supported by the tips of the thumb, index, and middle fingers; with pencil manipulated by fine localized movements of these fingers',NULL,NULL),(356,300,'Fine Motor Control',46,'Copy oblique cross: x (right and left diagonal lines)',NULL,NULL),(357,300,'Fine Motor Control',47,'Copy triangle',NULL,NULL),(358,300,'Fine Motor Control',48,'Copy diamond',NULL,NULL),(359,300,'Fine Motor Control',49,'Copy first name (often all upper case) without understanding sound-symbol association or knowledge of whole alphabet',NULL,NULL),(360,300,'Fine Motor Control',50,'Independently execute vertical strokes using top to bottom direction: horizontal left to right direction',NULL,NULL),(361,300,'Fine Motor Control',52,'Execute diagonals resulting in accurate angles using top to bottom stroke',NULL,NULL),(362,300,'Fine Motor Control',55,'Trace letters made of straight lines: f, h, i, l, ',NULL,NULL),(363,300,'Fine Motor Control',56,'Trace letters formed with curve lines, circles and half circles: c, g, o, a',NULL,NULL),(364,300,'Fine Motor Control',57,'Trace letters with straight lines and curves: b, d, j, p, r, s, u, g, h, m, n',NULL,NULL),(365,300,'Fine Motor Control',58,'Trace letters made of straight lines and diagonals:  k, w, x, y, z',NULL,NULL),(366,300,'Fine Motor Control',59,'Imitate letters made of straight lines',NULL,NULL),(367,300,'Fine Motor Control',60,'Imitate letters formed with curved lines, circles and half circles',NULL,NULL),(368,300,'Fine Motor Control',62,'Imitate letters made of straight lines and diagonals',NULL,NULL),(369,300,'Fine Motor Control',61,'Imitate letters made of straight lines and curves',NULL,NULL),(370,300,'Fine Motor Control',63,'Copy letters from a sample',NULL,NULL),(371,300,'Fine Motor Control',64,'Form upper case letters legibly from memory',NULL,NULL),(372,300,'Fine Motor Control',66,'Demonstrate ability to print upper-case letter with corresponding lower partner from memory',NULL,NULL),(373,300,'Fine Motor Control',67,'Print letters with correct spatial relationship (tall, short, fall below line)',NULL,NULL),(374,300,'Fine Motor Control',68,'Uniformly space letters within single words ',NULL,NULL),(375,300,'Fine Motor Control',70,'Using print, transcribe (copy) words - letter by letter from sample',NULL,NULL),(376,300,'Fine Motor Control',71,'Using print, transcribe simple sentences with attention to details of letter order, spacing between words and placement on the line',NULL,NULL),(377,300,'Fine Motor Control',72,'Using print, transcribe 3 sentences accurately with attention to capitalization and punctuation',NULL,NULL),(379,300,'Fine Motor Control',73,'Hold scissors appropriately* and control blade opening and closing',NULL,NULL),(380,300,'Fine Motor Control',74,'Snip narrow strips of paper randomly',NULL,NULL),(381,300,'Fine Motor Control',75,'Cut forward across a 5 cm wide strip of stiff paper using consecutive open/close movements',NULL,NULL),(383,300,'Fine Motor Control',76,'Cut 5 cm forward on a wide (6mm) line',NULL,NULL),(384,300,'Fine Motor Control',78,'Cut 15 cm forward on a wide (6mm) line',NULL,NULL),(385,300,'Fine Motor Control',80,'Cut out simple straight-sides geometric shapes: squares, rectangles, triangles and diamonds within a 6mm tolerance of the line',NULL,NULL),(386,300,'Fine Motor Control',77,'Cut 5 cm forward on a narrow (3mm) line',NULL,NULL),(387,300,'Fine Motor Control',79,'Cut 15cm forward on a narrow (3mm) line',NULL,NULL),(388,300,'Fine Motor Control',81,'Cut out simple straight-sides geometric shapes within 3mm tolerance of the line and without cutting off corners',NULL,NULL),(389,300,'Fine Motor Control',82,'Cut out gentle art using short separate snips (wide 6mm line)',NULL,NULL),(390,300,'Fine Motor Control',83,'Cut out semicircle adjusting paper position simultaneously during controlled scissor blade closure(narrow 3mm line)',NULL,NULL),(391,300,'Fine Motor Control',84,'Cut out full circle with dynamic interaction between two hands (narrow 3mm line)',NULL,NULL),(392,300,'Fine Motor Control',85,'Cut out irregular shape consisting primarily of sections of straight lines.',NULL,NULL),(393,300,'Fine Motor Control',86,'Cut out complex figures consisting of combinations of curves, straight lines, angles and sharp changes in direction',NULL,NULL),(2997,1104,'Extending Spelling Skills',28,'Spell words with silent s (island)',NULL,NULL),(2996,1104,'Extending Spelling Skills',27,'Spell words with silent w ( wrinkle)',NULL,NULL),(2995,1104,'Extending Spelling Skills',26,'Spell words with the /G/ spelling of g or j sound (frog, bridge)',NULL,NULL),(2994,1104,'Extending Spelling Skills',25,'Spell words with the /CH/ spelling of k',NULL,NULL),(2978,1104,'Extending Spelling Skills',9,'Spell long vowels represented by, single vowels, two vowels together, final e',NULL,NULL),(2979,1104,'Extending Spelling Skills',10,'Spell words with diphthongs, ow, ou, oy, oi',NULL,NULL),(402,400,'Cognitive Development',1,'Sort objects into two categories',NULL,NULL),(2999,1104,'Extending Spelling Skills',30,'Spell words with /GH/ as f (rough)',NULL,NULL),(404,400,'Cognitive Development',2,'Complete a simple pattern',NULL,NULL),(405,400,'Cognitive Development',3,'Complete a two-piece puzzle - straight cut diagonally',NULL,NULL),(407,400,'Cognitive Development',4,'Match simple drawings of shapes/letters/numerals',NULL,NULL),(2998,1104,'Extending Spelling Skills',29,'Spell words with silent t (pitch, often)',NULL,NULL),(409,400,'Cognitive Development',5,'Display a visual memory of four items',NULL,NULL),(410,400,'Cognitive Development',6,'Demonstrate a verbal memory of four items',NULL,NULL),(411,400,'Cognitive Development',7,'Draw a person with at least seen distinct body parts',NULL,NULL),(412,400,'Cognitive Development',8,'Complete a 12-piece puzzle',NULL,NULL),(2977,1104,'Extending Spelling Skills',8,'Spell words with short vowels, a , e, i , o, u (initial or medial position)',NULL,NULL),(414,400,'Cognitive Development',9,'Put graduated sizes in order',NULL,NULL),(2976,1104,'Extending Spelling Skills',7,'Spell words with silent /L/',NULL,NULL),(417,400,'Cognitive Development',10,'Identify first, middle, last name',NULL,NULL),(2968,300,'Fine Motor Control',54,'Print own name',NULL,NULL),(2967,300,'Fine Motor Control',53,'Trace own name',NULL,NULL),(2875,116,'Phonological Awareness',26,'student will demonstrate ability to look for word parts and affixes',NULL,NULL),(2874,116,'Phonological Awareness',25,'student will demonstrate ability to use conventional spelling for simple regularly spelled words',NULL,NULL),(2873,116,'Phonological Awareness',24,'student will demonstrate ability to use knowledge of consonants, short vowels, and silent -e in spelling',NULL,NULL),(2872,116,'Phonological Awareness',23,'student will demonstrate ability to manipulate sounds, letters in words (substitute, delete, reverse)',NULL,NULL),(2870,116,'Phonological Awareness',21,'student will demonstrate ability to count words in sentences',NULL,NULL),(2871,116,'Phonological Awareness',22,'student will demonstrate ability to blend and segment sounds, syllables in single syllable words',NULL,NULL),(2888,8090,'Measurement',13,'When given 5 incomplete statements for the conversion of linear metreic measurements to equivalent metric measurements, will complete the statements accurately for millimeters to meters.',NULL,NULL),(2887,8090,'Measurement',12,'When given 5 incomplete statements for the conversion of linear metreic measurements to equivalent metric measurements, will complete the statements accurately for millimeters to centimeters.',NULL,NULL),(2886,8090,'Measurement',11,'When given 5 incomplete statements for the conversion of linear metreic measurements to equivalent metric measurements, will complete the statements accurately for meters to kilometers. ',NULL,NULL),(2885,8090,'Measurement',10,'When given 5 incomplete statements for the conversion of linear metreic measurements to equivalent metric measurements, will complete the statements accurately for centimeters to meters.',NULL,NULL),(2921,8065,'Fractions',22,'When given five problems requiring subtraction of fractions and/or mixed numbers, will correctly compute the answers by subtracting like fractions.',NULL,NULL),(2920,8065,'Fractions',21,'When given five problems requiring addition of fractions and mixed numbers, will correctly compute the answers by adding mixed mubers with unlike denominators.',NULL,NULL),(2911,120,'Language - Articulation',28,'student will produce the Th-voiceless and Th-voiced  sounds in conversation',NULL,NULL),(2910,120,'Language - Articulation',27,'student will produce the s, z and s-blend sounds in conversation',NULL,NULL),(2909,120,'Language - Articulation',26,'student will produce the f, v, sh, and ch sounds in conversation',NULL,NULL),(2918,8065,'Fractions',19,'When given five problems requiring addition of fractions and mixed numbers, will correctly compute the answers by unlike fractions.',NULL,NULL),(2917,8065,'Fractions',18,'When given five problems requiring addition of fractions and mixed numbers, will correctly compute the answers by adding like fractions.',NULL,NULL),(2916,8065,'Fractions',17,'When given five fractions and/or mixed numbers that require conversion, will correctly make the conversions for mixed numbers to improper fractions.',NULL,NULL),(2913,8065,'Fractions',14,'When given five fractions and/or mixed numbers that require conversion, will correctly make the conversions for fractions to lowest terms. ',NULL,NULL),(2912,8065,'Fractions',13,'When given five fractions and/or mixed numbers that require conversion, will correctly make the conversions for fractions to higher terms.',NULL,NULL),(3008,1200,'Classroom Behaviors',24,'The student will demonstrate non-disruptive behaviors during class time.',NULL,NULL),(3009,1399,'Social Development',75,'The student will admit mistakes and correct them.',NULL,NULL),(3010,1399,'Social Development',76,'The student will demonstrate honesty with peers and adults',NULL,NULL),(3011,1399,'Social Development',77,'The student will demonstrate self-confidence',NULL,NULL),(3012,8099,'Word Problems',1,'The student will be able to identify addition situations in word problems.',NULL,NULL),(3013,8099,'Word Problems',2,'The student will be able to identify subtraction situations in word problems.',NULL,NULL),(2931,8065,'Fractions',32,'When given five problems requiring division of fractions and/or mixed numbers, will correctly compute the answers for dividing whole numbers by mixed numbers.',NULL,NULL),(2930,8065,'Fractions',31,'When given five problems requiring division of fractions and/or mixed numbers, will correctly compute the answers for dividing proper fractions by proper fractions.',NULL,NULL),(2929,8065,'Fractions',30,'When given five problems requiring division of fractions and/or mixed numbers, will correctly compute the answers for dividing whole numbers by proper fractions.',NULL,NULL),(2928,8065,'Fractions',29,'When given five problems requiring multiplication of fractions and/or mixed numbers, will correctly compute the answers by multiplying mixed numbers by mixed numbers.',NULL,NULL),(2927,8065,'Fractions',28,'When given five problems requiring multiplication of fractions and/or mixed numbers, will correctly compute the answers by multiplying whole numbers by mixed numbers.',NULL,NULL),(2926,8065,'Fractions',27,'When given five problems requiring multiplication of fractions and/or mixed numbers, will correctly compute the answers by multiplying proper fractions by proper fractions.',NULL,NULL),(2925,8065,'Fractions',26,'When given five problems requiring multiplication of fractions and/or mixed numbers, will correctly compute the answers by muyltiplying proper fractions by whole numbers.',NULL,NULL),(2924,8065,'Fractions',25,'When given five problems requiring subtraction of fractions and/or mixed numbers, will correctly compute the answers by subtracting mixed numbers with unlike denominators.',NULL,NULL),(2923,8065,'Fractions',24,'When given five problems requiring subtraction of fractions and/or mixed numbers, will correctly compute the answers by subtracting mixed numbers with like denominators.',NULL,NULL),(2932,8080,'Decimals',20,'When given five problems requiring division of fractions and/or mixed numbers, will correctly compute the answers for dividing mixed numbers by mixed numbers.',NULL,NULL),(2937,8095,'Geometry',5,'When given the words freqently used to name geometric shapes or concepts along with picutres illustrating each  of the words, will be able to correctly match the words and pictures for parallel, clockwise, counterclockwise, semicircle, sphere, perimeter, perpendicular, circumference, diameter, radius, right angle, acute angle, obtuse angle, horizontal, and/or vertical.',NULL,NULL),(2936,8095,'Geometry',4,'When shown objects or pictures of objects will correctly identify the shapes (cone, cylinder, cube, hexagon, octagon)..',NULL,NULL),(2935,8095,'Geometry',3,'When shown objects or pictures of objects will correctly identify the shapes (star, oval, heart, diamond).',NULL,NULL),(2934,8095,'Geometry',2,'When shown an object or a picuture of an object, will correctly be able to identify it as one of the four basic shapes (circle, square, rectangle, triangle).',NULL,NULL),(2933,8095,'Geometry',1,'When shown a shape object or picture of a shape, will be able to correctly match it to a like shape.',NULL,NULL),(2954,1399,'Social Development',43,'Recognize roles of other people in the school.',NULL,NULL),(2956,200,'Gross Motor Development',31,'Walk on tiptoes for 3 steps',NULL,NULL),(2938,300,'Fine Motor Control',51,'Independently draw circle in counterclockwise direction',NULL,NULL),(2939,300,'Fine Motor Control',65,'Form lower case letters legibly from memory',NULL,NULL),(2940,300,'Fine Motor Control',69,'Uniformly space letters within sentences',NULL,NULL),(2941,300,'Fine Motor Control',87,'Handwrite letters neatly from sample',NULL,NULL),(2942,300,'Fine Motor Control',88,'Handwrite neatly from memory',NULL,NULL),(2943,300,'Fine Motor Control',90,'Using handwriting, transcribe 3 simple sentences with attention to details of letter order, spacing between words and placement on the line',NULL,NULL),(2944,300,'Fine Motor Control',91,'Using handwriting, transcribe 3 sentences accurately with attention to capitolization and punctuation',NULL,NULL),(2945,300,'Fine Motor Control',99,'Keyboard using adapted techniques',NULL,NULL),(623,606,'Reading',1,'Recognize logos and signs',NULL,NULL),(624,606,'Reading',2,'Have favourite books and stories, recognize familiar pictures in stories',NULL,NULL),(2820,8080,'Decimals',2,'When given 2 lists of 5 decimals with tenths and hundredths, will write the decimals in order of value.',NULL,NULL),(626,606,'Reading',4,'Develop interest in different kinds of stories and books',NULL,NULL),(627,606,'Reading',5,'Create stories to match illustrations in books and stories',NULL,NULL),(628,606,'Reading',6,'Describe story action which matches illustrations',NULL,NULL),(629,606,'Reading',7,'Place book in proper position for reading',NULL,NULL),(630,606,'Reading',8,'Flip through book ,turn pages one at a time',NULL,NULL),(2861,116,'Phonological Awareness',12,'student will demonstrate knowledge of which of 3 words is different (e.g., sit,sit,suit)',NULL,NULL),(632,606,'Reading',18,'Recognize left to right and top to bottom progression',NULL,NULL),(633,606,'Reading',19,'Vocalize as stories are read',NULL,NULL),(634,606,'Reading',20,'Insert words and phrases while stories are read',NULL,NULL),(635,606,'Reading',21,'Repeat stories from memory',NULL,NULL),(636,606,'Reading',22,'Ask for favourite stories to be repeated',NULL,NULL),(637,606,'Reading',23,'Demonstrate learning from books and stories',NULL,NULL),(638,606,'Reading',24,'Distinguish between print and other marks on the page',NULL,NULL),(639,606,'Reading',25,'Recognize some letters and begin to demonstrate understanding of sound-letter correspondence',NULL,NULL),(640,606,'Reading',26,'Use his or her experiences with sounds, letters or words to assist in reading',NULL,NULL),(641,606,'Reading',27,'Begin to apply semantics or meaning clues as a strategy for predicting and identifying words and phrases',NULL,NULL),(642,606,'Reading',28,'Begin to apply his or her knowledge and experiences of structure and patterns(syntactic cues) to identify words or phrases',NULL,NULL),(643,606,'Reading',9,'Demonstrate book knowledge(left-to-right, book order)',NULL,NULL),(644,606,'Reading',10,'Retell the content in random order',NULL,NULL),(645,606,'Reading',11,'Read printed words and understand their meanings',NULL,NULL),(646,606,'Reading',12,'Recognize the pattern in a story and may describe and/or explain it',NULL,NULL),(647,606,'Reading',13,'Respond personally to a book (likes, dislikes, interpretations)',NULL,NULL),(648,606,'Reading',14,'Share books confidently by reading, retelling or responding',NULL,NULL),(649,606,'Reading',15,'Locate illustrations in a book to support what it is saying',NULL,NULL),(650,606,'Reading',16,'Recognize that illustrations tell or enhance the story',NULL,NULL),(651,606,'Reading',17,'Note titles, authors, illustrators',NULL,NULL),(652,606,'Reading',29,'Provide a summary sentence to describe what the selection was about',NULL,NULL),(653,606,'Reading',30,'Answer direct questions about the selection',NULL,NULL),(654,606,'Reading',31,'Retell main events from selection in sequence',NULL,NULL),(655,606,'Reading',32,'Locate or describe specific information in the text or illustrations to support personal thoughts and feelings',NULL,NULL),(656,606,'Reading',33,'Identify the type of pattern in the book; eg. the words rhymed, problem and solution',NULL,NULL),(657,606,'Reading',34,'Search through a book to locate information for sharing',NULL,NULL),(658,606,'Reading',35,'Select a book and give a simple reason for choice; eg. read before, nice pictures, fun',NULL,NULL),(659,606,'Reading',36,'Compare self and personal experiences to characters or events in the selection',NULL,NULL),(660,606,'Reading',37,'Demonstrate storytelling behaviors; eg. stance, awareness of audience, use of props',NULL,NULL),(661,606,'Reading',39,'Provide a summary statement about the main idea of a selection',NULL,NULL),(662,606,'Reading',40,'Provide descriptive details about information read',NULL,NULL),(663,606,'Reading',41,'Provide descriptive details about the settings of main events',NULL,NULL),(664,606,'Reading',42,'Provide descriptive details about the characters in a story',NULL,NULL),(665,606,'Reading',43,'Use words that are associated with particular genres',NULL,NULL),(666,606,'Reading',44,'Sequence the events in a similar order as in a selection',NULL,NULL),(667,606,'Reading',45,'Express personal feelings, orally and in writing, about what was read ',NULL,NULL),(668,606,'Reading',46,'Identify and read about the author',NULL,NULL),(669,606,'Reading',47,'Read silently for long periods of time',NULL,NULL),(670,606,'Reading',48,'Self-correct when miscues interfere with meaning',NULL,NULL),(671,606,'Reading',49,'Gather information from visual sources',NULL,NULL),(672,606,'Reading',50,'Identify the point of view in a story or selection',NULL,NULL),(673,606,'Reading',51,'Make generalizations about main characters',NULL,NULL),(674,606,'Reading',52,'Discriminate fact from an author\"s opinion',NULL,NULL),(675,606,'Reading',53,'Describe the feelings or emotions of characters',NULL,NULL),(676,606,'Reading',54,'Determine feelings and attitudes of characters in a selection',NULL,NULL),(677,606,'Reading',55,'Classify ideas from a selection into categories',NULL,NULL),(678,606,'Reading',56,'Identify a variety of types and forms of literature and visual arts',NULL,NULL),(679,606,'Reading',57,'Make predictions based on what has been read',NULL,NULL),(680,606,'Reading',58,'Show understanding of a story by creating alternate story endings or tableaus',NULL,NULL),(681,606,'Reading',59,'Determine characters',NULL,NULL),(682,606,'Reading',60,'Determine an author',NULL,NULL),(683,606,'Reading',61,'Identify and analyse point of view expressed by an author',NULL,NULL),(684,606,'Reading',62,'Use conventions of print to enhance expression when reading aloud or role playing',NULL,NULL),(685,606,'Reading',63,'Determine whether the story is fiction or non-fiction',NULL,NULL),(686,606,'Reading',64,'Paraphrase the main ideas in a story or selection',NULL,NULL),(687,606,'Reading',65,'Draw conclusions about characters',NULL,NULL),(688,606,'Reading',66,'Identify and respond to mood and theme in a selection',NULL,NULL),(689,606,'Reading',67,'Analyse and appreciate point of view expressed by an author',NULL,NULL),(690,606,'Reading',68,'Understand that each paragraph contains information that is linked to the previous paragraph',NULL,NULL),(691,606,'Reading',69,'Make connections between two selections, situations or themes',NULL,NULL),(692,606,'Reading',70,'Identify cause of events and effect on characters',NULL,NULL),(3019,2600,'Other subjects',10,'Math',NULL,NULL),(3020,2600,'Other subjects',11,'Life Skills',NULL,NULL),(3015,8099,'Word Problems',4,'The student will be able to identify division situations in word problems.',NULL,NULL),(3014,8099,'Word Problems',3,'The student will be able to identify multiplication situations in word problems.',NULL,NULL),(3006,1104,'Extending Spelling Skills',37,'Spell words with unconventional spellings (does, canoe)',NULL,NULL),(3007,1104,'Extending Spelling Skills',38,'Spell words with unconventional spellings (route, onion)',NULL,NULL),(3005,1104,'Extending Spelling Skills',36,'Spell words with /AL/ sound (central)',NULL,NULL),(3004,1104,'Extending Spelling Skills',35,'Spell words with /EL/ sound (model)',NULL,NULL),(3003,1104,'Extending Spelling Skills',34,'Spell words with /EI/ IE/ sounds (weigh, field)',NULL,NULL),(704,704,'Writing Skills',1,'Experiment with pictures, diagrams, symbols, letters, words or phrases to represent ideas or experiences',NULL,NULL),(705,704,'Writing Skills',2,'Use a personal point of view to communicate a message (tone, voice',NULL,NULL),(706,704,'Writing Skills',3,'Express personal feelings and experiences through words',NULL,NULL),(707,704,'Writing Skills',4,'Tell information in a straightforward list-like manner',NULL,NULL),(708,704,'Writing Skills',5,'Recall and retell events',NULL,NULL),(709,704,'Writing Skills',6,'Formulate and record events',NULL,NULL),(710,704,'Writing Skills',7,'Copy work from a model provided',NULL,NULL),(711,704,'Writing Skills',8,'Use drawing to complement written work',NULL,NULL),(712,704,'Writing Skills',9,'Rely on adult scribes',NULL,NULL),(713,704,'Writing Skills',10,'Connect ideas together by using a sequence such as: beginning and ending, a pattern, a writing form',NULL,NULL),(714,704,'Writing Skills',11,'Print along a line (left to right) with spacing between words',NULL,NULL),(715,704,'Writing Skills',12,'Make approximate spellings for some words by using consonant sounds and letter names as clues; eg., strar for straw; horese for horse',NULL,NULL),(716,704,'Writing Skills',13,'Use standard spelling for known words',NULL,NULL),(717,704,'Writing Skills',14,'Use punctuation (periods)',NULL,NULL),(718,704,'Writing Skills',15,'Draw from personal background knowledge for story events',NULL,NULL),(719,704,'Writing Skills',16,'Vary print for emphasis; e.g., using all capital letters',NULL,NULL),(720,704,'Writing Skills',17,'Demonstrate awareness of time in a story sequence; e.g., one evening, the next day, in the morning',NULL,NULL),(721,704,'Writing Skills',18,'Present a problem and solve with a simplistic solution',NULL,NULL),(722,704,'Writing Skills',19,'Provide supportive details about some of the information',NULL,NULL),(723,704,'Writing Skills',20,'Use and sustain a pattern from literature or daily life',NULL,NULL),(724,704,'Writing Skills',21,'Organize ideas sequentially (beginning, middle, ending)',NULL,NULL),(725,704,'Writing Skills',22,'Use opening and closing sentences or signals; e.g., once upon a time, ever since, happily ever after, the end',NULL,NULL),(726,704,'Writing Skills',23,'Use connecting words in sentences; e.g. and, and then, but, so',NULL,NULL),(727,704,'Writing Skills',24,'Choose words to meet their own purposes',NULL,NULL),(728,704,'Writing Skills',25,'Use descriptive words',NULL,NULL),(729,704,'Writing Skills',26,'Use standard spelling for commonly used words',NULL,NULL),(730,704,'Writing Skills',27,'Spell words according to how they hear the consonant and vowel sounds; e.g., all was for always, forist for forest',NULL,NULL),(731,704,'Writing Skills',28,'Use punctuation to indicate the end of a sentence',NULL,NULL),(732,704,'Writing Skills',29,'Include dialogue, usually unpunctuated',NULL,NULL),(733,704,'Writing Skills',30,'Use capitalization (in titles, to begin sentences)',NULL,NULL),(734,704,'Writing Skills',31,'Use form, size and spacing of letters consistently',NULL,NULL),(735,704,'Writing Skills',32,'Include a title when required',NULL,NULL),(736,704,'Writing Skills',33,'Communicate a message so that the reader understands the writer',NULL,NULL),(737,704,'Writing Skills',34,'Foreshadow tone of story in title',NULL,NULL),(738,704,'Writing Skills',35,'Personalize thoughts and ideas',NULL,NULL),(739,704,'Writing Skills',36,'Generate work that appeals to the reader ',NULL,NULL),(740,704,'Writing Skills',37,'Support the intent of the writing with descriptive details',NULL,NULL),(741,704,'Writing Skills',38,'Develop story elements of character, plot, setting',NULL,NULL),(742,704,'Writing Skills',39,'Order information in a coherent sequence (maintain topic)',NULL,NULL),(743,704,'Writing Skills',40,'Make a page layout visually appealing',NULL,NULL),(744,704,'Writing Skills',41,'Provide closure for the message',NULL,NULL),(745,704,'Writing Skills',42,'Attempt a variety of sentence types and lengths for effect',NULL,NULL),(746,704,'Writing Skills',43,'Vary sentence beginnings',NULL,NULL),(747,704,'Writing Skills',44,'Show general control of subject and verb agreement',NULL,NULL),(748,704,'Writing Skills',45,'Use specific words and phrases to add clarity and interest to the writing(strong nouns and verbs)',NULL,NULL),(749,704,'Writing Skills',46,'Show general control of spelling, punctuation and capitalization(errors present usually do not affect the clarity of communication)',NULL,NULL),(750,704,'Writing Skills',47,'Mark dialogue with quotation marks',NULL,NULL),(751,704,'Writing Skills',48,'Use the point of view of another participant as well as personal point of view',NULL,NULL),(752,704,'Writing Skills',49,'Communicate a clear message to the reader (focus on a topic, theme or concept)',NULL,NULL),(753,704,'Writing Skills',50,'Develop and connect beginnings and endings',NULL,NULL),(754,704,'Writing Skills',51,'Use simple, compound and complex sentence structures',NULL,NULL),(755,704,'Writing Skills',52,'Use correct verb tenses consistently',NULL,NULL),(756,704,'Writing Skills',53,'Vary sentence beginnings by using phrases',NULL,NULL),(757,704,'Writing Skills',54,'Organize information using a variety of techniques; e.g., point form, numbered paragraphs, webs',NULL,NULL),(758,704,'Writing Skills',55,'Choose nouns, verbs, conjunctions and phrases to achieve particular effects',NULL,NULL),(759,704,'Writing Skills',56,'Use generally correct spelling, capitalization and punctuation when formulating sentences',NULL,NULL),(760,704,'Writing Skills',57,'Plan ideas prior to writing',NULL,NULL),(761,704,'Writing Skills',58,'Recognize some errors when reading own writing aloud and make necessary changes',NULL,NULL),(762,704,'Writing Skills',59,'Show clear style and voice',NULL,NULL),(763,704,'Writing Skills',60,'Use adjectives to create mood',NULL,NULL),(764,704,'Writing Skills',61,'Use dialogue to develop characters and enhance plot',NULL,NULL),(765,704,'Writing Skills',62,'Organize writing for conventional formats; e.g., letters, reports, books',NULL,NULL),(766,704,'Writing Skills',63,'Sequence ideas in a smooth flowing fashion',NULL,NULL),(767,704,'Writing Skills',64,'Control humor',NULL,NULL),(768,704,'Writing Skills',65,'Combine sentences effectively',NULL,NULL),(769,704,'Writing Skills',66,'Use precise and descriptive vocabulary appropriate to topic and style',NULL,NULL),(771,704,'Writing Skills',67,'Use essentially correct capitalization, punctuation and spelling',NULL,NULL),(772,704,'Writing Skills',68,'Recognize appropriate syntax, grammar and sentence structure when proofreading own writing and make necessary changes',NULL,NULL),(773,704,'Writing Skills',69,'Continue a writing project over several days',NULL,NULL),(774,704,'Writing Skills',70,'Develop a clear introduction',NULL,NULL),(775,704,'Writing Skills',71,'Select details to illustrate an idea',NULL,NULL),(776,704,'Writing Skills',72,'Use a tone which is appropriate for the form',NULL,NULL),(777,704,'Writing Skills',73,'Relate what the student knows to new information and ideas',NULL,NULL),(778,704,'Writing Skills',74,'Link ideas using strategies such as compare and contrast, cause and effect, problem and solution',NULL,NULL),(779,704,'Writing Skills',75,'Explain a point of view',NULL,NULL),(780,704,'Writing Skills',76,'Organize writing using paragraphs',NULL,NULL),(781,704,'Writing Skills',77,'Use variety in sentence type and length',NULL,NULL),(782,704,'Writing Skills',78,'Control language and format to appeal to reader; e.g., lively, interesting, dynamic',NULL,NULL),(783,704,'Writing Skills',79,'Use vocabulary appropriate to a specific form and purpose; e.g., entertain(humour), persuade(argue), inform, explain, reflect',NULL,NULL),(784,704,'Writing Skills',80,'Use dialogue selectively and correctly punctuated',NULL,NULL),(785,704,'Writing Skills',81,'Use essentially correct capitalization, punctuation, spelling and grammar',NULL,NULL),(786,704,'Writing Skills',82,'Use strategies for editing independently',NULL,NULL),(2695,8040,'Number Facts-Division',2,'Will correctly compute the quotients, when given ten division facts, for the divisors up to 3.',NULL,NULL),(789,804,'Consonant and Vowel Sounds',5,'Recognize and sound out regular consonant sounds (initial, medial, final): b,d,f,g,h,j,k,l,m,n,p,r,s,t,v,w,y,z',NULL,NULL),(790,804,'Consonant and Vowel Sounds',6,'Recognize and sound out blends: bl,pl,sl,fl,gl,cl,br,tr,gr,dr,fr,cr,spr,str,thr,st,sn,sp,spl',NULL,NULL),(791,804,'Consonant and Vowel Sounds',7,'Recognize and sound out digraphs: sh,ch,ng,nk,wh,th(voiced or unvoiced)',NULL,NULL),(792,804,'Consonant and Vowel Sounds',8,'Recognize and sound out variants: x,c,k,s,ck',NULL,NULL),(793,804,'Consonant and Vowel Sounds',9,'Recognize and sound out silent l',NULL,NULL),(794,804,'Consonant and Vowel Sounds',10,'Recognize and sound out short vowels: a,e,i,o,u (initial or medial position)',NULL,NULL),(795,804,'Consonant and Vowel Sounds',11,'Recognize and sound out long vowels represented by: a. single vowels  b. two vowels together c. final e',NULL,NULL),(796,804,'Consonant and Vowel Sounds',12,'Recognize and sound out diphthongs: ow,ou,oy,oi',NULL,NULL),(797,804,'Consonant and Vowel Sounds',13,'Recognize and sound out digraphs: ay,oo,ee,ea,ow',NULL,NULL),(798,804,'Consonant and Vowel Sounds',14,'Recognize and sound out vowel sounds controlled by r: er,or,r,ur,ar',NULL,NULL),(799,804,'Consonant and Vowel Sounds',15,'Recognize and sound out final y ',NULL,NULL),(800,804,'Consonant and Vowel Sounds',16,'Recognize and read unconventional spellings: single vowels (from, off, cold)  silent e (give, done) two vowels (been, said) other (they, eye)',NULL,NULL),(801,804,'Consonant and Vowel Sounds',17,'Recognize and sound out initial blends:pr,sc,sk,squ,sm,tw,gw',NULL,NULL),(802,804,'Consonant and Vowel Sounds',18,'Recognize and sound out final blends: ft,ld,lk,mp,nd,nt,rd,sk,st',NULL,NULL),(803,804,'Consonant and Vowel Sounds',19,'Recognize and sound out silent: gh,t,w,b,k',NULL,NULL),(804,804,'Consonant and Vowel Sounds',20,'Recognize and sound out digraphs: gh(f-sound; eg., laugh)',NULL,NULL),(805,804,'Consonant and Vowel Sounds',21,'Recognize and sound out variants: hard, soft c, g',NULL,NULL),(806,804,'Consonant and Vowel Sounds',22,'Recognize and sound out vowel digraphs: ui,ai,ou,oa',NULL,NULL),(807,804,'Consonant and Vowel Sounds',23,'Recognize and sound out vowel variants: ie',NULL,NULL),(808,804,'Consonant and Vowel Sounds',24,'Recognize and read unconventional spellings:  single vowels (kind, full) silent e (whose, sure)  two vowels (bread, ',NULL,NULL),(809,804,'Consonant and Vowel Sounds',39,'Recognize and sound out qu sound',NULL,NULL),(810,804,'Consonant and Vowel Sounds',25,'Recognize and sound out ph spelling of f',NULL,NULL),(811,804,'Consonant and Vowel Sounds',26,'Recognize and sound out ch spelling of k',NULL,NULL),(812,804,'Consonant and Vowel Sounds',27,'Recognize and sound out g spelling of g or j sound (frog, bridge)',NULL,NULL),(813,804,'Consonant and Vowel Sounds',28,'Recognize and sound out silent w (wrinkle)',NULL,NULL),(814,804,'Consonant and Vowel Sounds',29,'Recognize and sound out silent s (island)',NULL,NULL),(815,804,'Consonant and Vowel Sounds',30,'Recognize and sound out silent t (pitch, often)',NULL,NULL),(816,804,'Consonant and Vowel Sounds',31,'Recognize and sound out gh as f (rough)',NULL,NULL),(817,804,'Consonant and Vowel Sounds',32,'Recognize and sound out al sound (chalk)',NULL,NULL),(818,804,'Consonant and Vowel Sounds',33,'Recognize and sound out e sound (castle)',NULL,NULL),(819,804,'Consonant and Vowel Sounds',34,'Recognize and read unconventional spellings (bush, lose, busy)',NULL,NULL),(820,804,'Consonant and Vowel Sounds',35,'Recognize and sound out ei, ie sounds (weigh, field)',NULL,NULL),(3017,2600,'Other subjects',8,'Comprehension',NULL,NULL),(822,804,'Consonant and Vowel Sounds',37,'Recognize and sound out al sound (central)',NULL,NULL),(823,804,'Consonant and Vowel Sounds',38,'Recognize and read unconventional spellings (does, canoe)',NULL,NULL),(824,804,'Consonant and Vowel Sounds',36,'Recognize and read unconventional spellings (route, onion) ',NULL,NULL),(825,904,'Word Analysis',1,'Recognize and correctly use suffixes - er, est, ing',NULL,NULL),(826,904,'Word Analysis',2,'Recognize and correctly use verb forms - s or es for third person',NULL,NULL),(827,904,'Word Analysis',3,'Recognize and correctly use verb forms - d or ed ending for past tense',NULL,NULL),(828,904,'Word Analysis',4,'Recognize and correctly use plurals & possessives add s or es',NULL,NULL),(829,904,'Word Analysis',5,'Recognize and correctly use possessives: add s (yours)',NULL,NULL),(830,904,'Word Analysis',6,'Recognize and correctly use compound words',NULL,NULL),(2859,8085,'Percents',12,'When given ten decimals, will convert the decimals to percents for the decimals with thousandths.',NULL,NULL),(833,904,'Word Analysis',7,'Recognize and correctly use rules when adding a suffix: when doubling or final consonant is required eg. hopped, hopping',NULL,NULL),(834,904,'Word Analysis',8,'Recognize and correctly use rules when adding a suffix: when silent e is dropped (coming)',NULL,NULL),(835,904,'Word Analysis',9,'Recognize and correctly use verb forms - change y to i before es and ed',NULL,NULL),(836,904,'Word Analysis',10,'Recognize and correctly use past, present, future tenses (was, am, will be)',NULL,NULL),(838,904,'Word Analysis',11,'Recognize and correctly use rules of plurals - change y to i before es',NULL,NULL),(839,904,'Word Analysis',12,'Recognize and correctly use rules of plurals - add es to words ending in s, s, ch',NULL,NULL),(840,904,'Word Analysis',13,'Recognize and correctly use rules of possessives: add appostrophe s',NULL,NULL),(841,904,'Word Analysis',14,'Recognize and correctly use contractions/abbreviations',NULL,NULL),(2858,8085,'Percents',11,'When given ten decimals, will convert the decimals to percents for the decimals with whole numbers, hundredths, or tenths.',NULL,NULL),(844,904,'Word Analysis',15,'Recognize and correctly use compound words - examples: airplane, something',NULL,NULL),(845,904,'Word Analysis',16,'Recognize and correctly use prefixes un, re, dis, in, de',NULL,NULL),(846,904,'Word Analysis',17,'Recognize and correctly use suffixes ly, ful, en, y',NULL,NULL),(847,904,'Word Analysis',18,'Recognize and correctly use number suffixes (fifteen, fifty)',NULL,NULL),(848,904,'Word Analysis',19,'Recognize and correctly use other suffixes ness, less, tion',NULL,NULL),(2857,8085,'Percents',10,'When given ten decimals, will convert the decimals to percents for the decimals with tenths.',NULL,NULL),(850,904,'Word Analysis',20,'Recognize and correctly use rulesof plurals: change f to v before es',NULL,NULL),(851,904,'Word Analysis',21,'Recognize and correctly use rules of contractions/abbreviations',NULL,NULL),(852,904,'Word Analysis',22,'Recognize and correctly use abbreviations for days, holidays, months and proper names',NULL,NULL),(853,904,'Word Analysis',23,'Recognize and correctly use prefixes  Examples- ex, pro, can, cam, pre, im',NULL,NULL),(854,904,'Word Analysis',24,'Recognize and correctly use suffixes Examples- ment, ty, let (booklet) ite (favourite) ship (friendship) sion (occasion) ian (musician)',NULL,NULL),(855,904,'Word Analysis',25,'Recognize and correctly use plurals & possessives',NULL,NULL),(856,904,'Word Analysis',26,'Recognize and correctly use possessives: form singular and plural possessives (nouns and pronouns)',NULL,NULL),(857,904,'Word Analysis',27,'Recognize and correctly use contractions and abbreviations',NULL,NULL),(858,904,'Word Analysis',28,'Recognize and correctly use abbreviations of measures, titles and directions (ave, st)',NULL,NULL),(859,904,'Word Analysis',28,'',NULL,NULL),(860,904,'Word Analysis',29,'Recognize and correctly use hyphenated compound words',NULL,NULL),(861,904,'Word Analysis',30,'Recognize and correctly use prefixes bi, tri, ec',NULL,NULL),(863,904,'Word Analysis',31,'Recognize and correctly use other suffixes: ive ar (regular) ure (future) ain (captain) age (voyage) ent (innocent) ant (servant) ate (senate) ence (difference) able, hood ery (dictionary) ern (southern) ic (historic) ize (civilize) or (conductor) ous (dangerous)',NULL,NULL),(864,904,'Word Analysis',32,'Recognize and correctly use compound words (single word)',NULL,NULL),(865,904,'Word Analysis',33,'Recognize and correctly use two word compounds (per cent)',NULL,NULL),(866,904,'Word Analysis',34,'Recognize and correctly use proper names ',NULL,NULL),(867,1004,'Syllabication, Dictionary and Glossary Use',1,'Hear and identify the syllables in two syllable words (yellow, going)',NULL,NULL),(868,1004,'Syllabication, Dictionary and Glossary Use',2,'Locate list words in the dictionary',NULL,NULL),(869,1004,'Syllabication, Dictionary and Glossary Use',3,'Use picture dictionaries for locating correct spelling of words',NULL,NULL),(870,1004,'Syllabication, Dictionary and Glossary Use',4,'Alphabetize words to two letters',NULL,NULL),(871,1004,'Syllabication, Dictionary and Glossary Use',5,'Identify syllable division in list words: open and closed pattern, primary accent',NULL,NULL),(872,1004,'Syllabication, Dictionary and Glossary Use',6,'Locate list words in the dictionary ',NULL,NULL),(873,1004,'Syllabication, Dictionary and Glossary Use',7,'Alphabetize list words to three letters',NULL,NULL),(874,1004,'Syllabication, Dictionary and Glossary Use',8,'Pronunce words using the dictionary',NULL,NULL),(875,1004,'Syllabication, Dictionary and Glossary Use',9,'Understand and use diacritical marks indicating long and short vowels',NULL,NULL),(876,1004,'Syllabication, Dictionary and Glossary Use',10,'Identify syllables in  three and four syllable words',NULL,NULL),(877,1004,'Syllabication, Dictionary and Glossary Use',11,'Recognize and understand primary and secondary accents',NULL,NULL),(878,1004,'Syllabication, Dictionary and Glossary Use',12,'Identify common syllables e, for, be, en, mis, al, ish, in list words',NULL,NULL),(879,1004,'Syllabication, Dictionary and Glossary Use',13,'Locate list words in dictionary',NULL,NULL),(880,1004,'Syllabication, Dictionary and Glossary Use',14,'Identify entry words: special type',NULL,NULL),(881,1004,'Syllabication, Dictionary and Glossary Use',15,'Identify entry words: divided into syllables',NULL,NULL),(882,1004,'Syllabication, Dictionary and Glossary Use',16,'Identify entry words: root words listed',NULL,NULL),(883,1004,'Syllabication, Dictionary and Glossary Use',17,'Identify entry words: abbreviations',NULL,NULL),(884,1004,'Syllabication, Dictionary and Glossary Use',18,'Identify entry words: separate entry for heteronyms',NULL,NULL),(885,1004,'Syllabication, Dictionary and Glossary Use',19,'Use guide words',NULL,NULL),(886,1004,'Syllabication, Dictionary and Glossary Use',20,'Alphabetize words to four letters',NULL,NULL),(887,1004,'Syllabication, Dictionary and Glossary Use',21,'Use apostrophes to contract words and for possessives',NULL,NULL),(888,1004,'Syllabication, Dictionary and Glossary Use',22,'Utilize dictionary pronunciation guide: silent letters omitted',NULL,NULL),(889,1004,'Syllabication, Dictionary and Glossary Use',23,'Utilize dictionary pronunciation guide: consonant sounds represented by single consonant b,d,f,g,h,j,k,l,m,n,p,r,s,t,v,w,x,y,z',NULL,NULL),(890,1004,'Syllabication, Dictionary and Glossary Use',24,'Utlize dictionary pronunciation guide: two letter sounds: ch,sh,th,wh,ng,x as ks, qu as kw, nk as ngk, ch as k(choir), zh(measure), hw(what)',NULL,NULL),(891,1004,'Syllabication, Dictionary and Glossary Use',25,'Utilize dictionary pronunciation guide: vowel sounds: (foot); (moon); e (her, turn, bird), o (haul, saw, all) ,ÃƒÂ´(order), oi (boy, oil), ÃƒÂ¥(arm), ou (cow, mouse), ÃƒÂµ (shore)',NULL,NULL),(892,1004,'Syllabication, Dictionary and Glossary Use',26,'Utilize dictionary pronunciation guide: sch ... (rather, about)',NULL,NULL),(893,1004,'Syllabication, Dictionary and Glossary Use',27,'Utilize dictionary pronunciation guide: endings: ture as cher (picture); tion as shun (election)',NULL,NULL),(894,1004,'Syllabication, Dictionary and Glossary Use',28,'Utilize dictionary pronunciation guide: primary and secondary accents',NULL,NULL),(895,1004,'Syllabication, Dictionary and Glossary Use',29,'Define words and word forms',NULL,NULL),(896,1004,'Syllabication, Dictionary and Glossary Use',30,'Identify separately numbered definitions for words with more than one meaning',NULL,NULL),(898,1004,'Syllabication, Dictionary and Glossary Use',31,'Recognize capitalization of words',NULL,NULL),(899,1004,'Syllabication, Dictionary and Glossary Use',32,'Identify syllabication of words',NULL,NULL),(900,1004,'Syllabication, Dictionary and Glossary Use',33,'Identify digraphs. Examples- ck, th, ch, sh (crock/er, oth/er)',NULL,NULL),(901,1004,'Syllabication, Dictionary and Glossary Use',34,'Identify multi-syllable words',NULL,NULL),(903,1004,'Syllabication, Dictionary and Glossary Use',35,'Locate correct spelling of words by making choices on the options: (coming, comeing, cuming, kumming or koming)',NULL,NULL),(904,1004,'Syllabication, Dictionary and Glossary Use',36,'Alphabetize words to five letters',NULL,NULL),(2919,8065,'Fractions',20,'When given five problems requiring addition of fractions and mixed numbers, will correctly compute the answers by adding mixed numbers with like denominators.',NULL,NULL),(906,1004,'Syllabication, Dictionary and Glossary Use',37,'Identify word endings. Example- age as ij (cottage)',NULL,NULL),(907,1004,'Syllabication, Dictionary and Glossary Use',38,'Define and locate  word forms',NULL,NULL),(908,1004,'Syllabication, Dictionary and Glossary Use',39,'Identify parts of speech',NULL,NULL),(909,1004,'Syllabication, Dictionary and Glossary Use',40,'Locate synonyms',NULL,NULL),(910,1004,'Syllabication, Dictionary and Glossary Use',41,'Identify alternate spellings (theatre, theater)',NULL,NULL),(911,1004,'Syllabication, Dictionary and Glossary Use',42,'Identify irregular verb forms (trimmed, wrote)',NULL,NULL),(912,1004,'Syllabication, Dictionary and Glossary Use',43,'Identify irregular comparative and superlative adjective forms (trimmer, trimmest)',NULL,NULL),(914,1004,'Syllabication, Dictionary and Glossary Use',44,'Identify consonants before ie',NULL,NULL),(916,1004,'Syllabication, Dictionary and Glossary Use',45,'Identify suffixes listed as entry words (less)',NULL,NULL),(917,1004,'Syllabication, Dictionary and Glossary Use',46,'Identify prefixes listed as entry word (un)',NULL,NULL),(919,1004,'Syllabication, Dictionary and Glossary Use',47,'Identify ending sounds Example: r (offer, grammar, sailor) sure as zher (measure) ent as nt (student) ant as nt (servant) ive as iv (active) ate as it (separate)',NULL,NULL),(2856,8085,'Percents',9,'When given ten decimals, will convert the decimals to percents for the decimals with hundredths. ',NULL,NULL),(921,1104,'Extending Spelling Skills',39,'Use correct spelling of homonyms (to, two, too)',NULL,NULL),(922,1104,'Extending Spelling Skills',40,'Use correct spelling of antonyms  (last, first)',NULL,NULL),(924,1104,'Extending Spelling Skills',41,'Use correct spelling of homonyms (its, it',NULL,NULL),(925,1104,'Extending Spelling Skills',42,'Use correct spelling of antonyms (cry, laugh)',NULL,NULL),(926,1104,'Extending Spelling Skills',43,'Use correct spelling of synonyms',NULL,NULL),(2889,8090,'Measurement',14,'When given 5 incomplete statements for the conversion of linear metreic measurements to equivalent metric measurements, will complete the statements accurately for meters to centimeters.',NULL,NULL),(2855,8085,'Percents',8,'When given ten fractions, will convert the fractions to percents with repeating decimal places.',NULL,NULL),(929,1104,'Extending Spelling Skills',44,'Use correct spelling of homonyms (whole, hole)',NULL,NULL),(930,1104,'Extending Spelling Skills',45,'Use correct spelling of unconventional spellings (minute)',NULL,NULL),(931,1104,'Extending Spelling Skills',46,'Spell correctly days, months, holidays, proper names',NULL,NULL),(933,1104,'Extending Spelling Skills',47,'Participate in enrichment activities',NULL,NULL),(2854,8085,'Percents',7,'When given ten fractions, will convert the fractions to percents with nonrepeating decimal places.',NULL,NULL),(935,1104,'Extending Spelling Skills',48,'Utilize proof reading skills',NULL,NULL),(937,1104,'Extending Spelling Skills',50,'Use correct spelling of homonyms (principal, principle)',NULL,NULL),(938,1104,'Extending Spelling Skills',53,'Use correct spelling of unconventional words (thread)',NULL,NULL),(939,1104,'Extending Spelling Skills',54,'Understand heteronyms (sep',NULL,NULL),(941,1104,'Extending Spelling Skills',55,'Understand etymology of words (origin)',NULL,NULL),(942,1200,'Classroom Behaviors',1,'Student will be punctual for each class.',NULL,NULL),(943,1200,'Classroom Behaviors',2,'Student will bring necessary materials to the class.',NULL,NULL),(944,1200,'Classroom Behaviors',3,'Student will be willing to learn when the teacher begins instruction.',NULL,NULL),(945,1200,'Classroom Behaviors',4,'Student will respond to behaviour plan for truancy.',NULL,NULL),(946,1200,'Classroom Behaviors',5,'Student will raise hand when wanting a turn to speak or ask for assistance.',NULL,NULL),(947,1200,'Classroom Behaviors',6,'Student will share information with others when prompted.',NULL,NULL),(948,1200,'Classroom Behaviors',7,'Student will maintain socially appropriate appearance and attire.',NULL,NULL),(949,1200,'Classroom Behaviors',8,'Student will follow the rules in the classroom as posted.',NULL,NULL),(2853,8085,'Percents',6,'When given ten fractions, will convert the fractions to percents with no decimal places.',NULL,NULL),(952,1200,'Classroom Behaviors',9,'Student will respond to requests from adults without delays.',NULL,NULL),(2852,8085,'Percents',5,'When given a list of fractions, will convert the fractions to percents for tenths.',NULL,NULL),(2851,8085,'Percents',4,'When given a list of fractions, will convert the fractions to percents for fifths.',NULL,NULL),(957,1200,'Classroom Behaviors',10,'Student will share necessary educational materials with other students or adults.',NULL,NULL),(958,1200,'Classroom Behaviors',11,'Student will follow classroom procedures as outlined by the teacher.',NULL,NULL),(959,1200,'Classroom Behaviors',12,'Student will complete assignments during class time when requested.',NULL,NULL),(2850,8085,'Percents',3,'When given a list of fractions, will convert the fractions to percents for thirds.',NULL,NULL),(2849,8085,'Percents',2,'When given a list of fractions, will convert the fractions to percents for fourths.',NULL,NULL),(964,1200,'Classroom Behaviors',13,'Student will demonstrate appropriate clean-up responsibilities.',NULL,NULL),(965,1200,'Classroom Behaviors',14,'Student will share necessary educational materials within a small or large group setting.',NULL,NULL),(966,1200,'Classroom Behaviors',15,'Student will demonstrate respect for another within a small or large group setting.',NULL,NULL),(967,1200,'Classroom Behaviors',16,'Student will demonstrate respect for personal space within a small or large group setting.',NULL,NULL),(968,1200,'Classroom Behaviors',17,'Student will check for agreement within a small or large group setting.',NULL,NULL),(969,1200,'Classroom Behaviors',18,'Student will be able to work independently in a small or large group setting when ___________________________________',NULL,NULL),(970,1200,'Classroom Behaviors',19,'Student will be aware of the need to ask for clarification and will do so.',NULL,NULL),(2848,8085,'Percents',1,'When given ten word problems about percentage, will demonstrate comprehension of the concept of percentage by answering the problems accurately.',NULL,NULL),(2847,116,'Phonological Awareness',10,'student will identify phonemes in a word (initial, medial, final)',NULL,NULL),(976,1200,'Classroom Behaviors',20,'Student will demonstrate responsible action in situations outside the classroom.',NULL,NULL),(977,1200,'Classroom Behaviors',21,'Student will adjust appropriately to new situations.',NULL,NULL),(978,1200,'Classroom Behaviors',22,'Student will demonstrate appropriate listening skills as outlined by the teacher.',NULL,NULL),(979,1200,'Classroom Behaviors',23,'Student will listen carefully to the teacher',NULL,NULL),(2846,116,'Phonological Awareness',9,'student will demonstrate ability to manipulate letters to make new words',NULL,NULL),(2845,116,'Phonological Awareness',8,'student will demonstrate ability to count phonemes in a word',NULL,NULL),(2844,116,'Phonological Awareness',7,'student will demonstrate ability to blend phonemes into words',NULL,NULL),(2843,116,'Phonological Awareness',6,'student will demonstrate ability to substitute (initial,medial,final) sounds in words',NULL,NULL),(2842,116,'Phonological Awareness',5,'student will count, clap syllables in words',NULL,NULL),(990,1300,'Domestic and Family Life',1,'Differentiate between immediate family members and others',NULL,NULL),(991,1300,'Domestic and Family Life',2,'Greet family members',NULL,NULL),(992,1300,'Domestic and Family Life',3,'Follow family rules that apply to self',NULL,NULL),(993,1300,'Domestic and Family Life',4,'Demonstrate increasing awareness of home environment by identifying areas of the home and personal belongings',NULL,NULL),(994,1300,'Domestic and Family Life',5,'Indicate understanding of concept of family; recognize siblings, parents and self as a unit',NULL,NULL),(995,1300,'Domestic and Family Life',6,'Identify belongings of other family members',NULL,NULL),(996,1300,'Domestic and Family Life',7,'Identify family members by role',NULL,NULL),(997,1300,'Domestic and Family Life',8,'Assume responsibility for self and belongings',NULL,NULL),(998,1300,'Domestic and Family Life',9,'Identify extended family members by name and role',NULL,NULL),(999,1300,'Domestic and Family Life',10,'Participate in family decision making',NULL,NULL),(1000,1300,'Domestic and Family Life',11,'Identify how family roles and responsibilities change with age',NULL,NULL),(1001,1300,'Domestic and Family Life',12,'Identify how own family is unique',NULL,NULL),(1002,1300,'Domestic and Family Life',13,'Recognize need for family courtesy and family rules',NULL,NULL),(1003,1300,'Domestic and Family Life',14,'Assume responsibility for own behavior',NULL,NULL),(1004,1300,'Domestic and Family Life',15,'Recognize where toys and belongings are kept',NULL,NULL),(1005,1300,'Domestic and Family Life',16,'Recognize that familiar household items have regular place',NULL,NULL),(1006,1300,'Domestic and Family Life',17,'Recognize and cooperate with familiar household routines',NULL,NULL),(1007,1300,'Domestic and Family Life',18,'Put toys away',NULL,NULL),(1008,1300,'Domestic and Family Life',19,'Recognize household chores that need to be carried out',NULL,NULL),(1009,1300,'Domestic and Family Life',20,'Assist with cleaning for a short period of time',NULL,NULL),(1010,1300,'Domestic and Family Life',21,'Identify cleaning tasks that need to be done',NULL,NULL),(1011,1300,'Domestic and Family Life',22,'Clean his or her own living space',NULL,NULL),(1012,1300,'Domestic and Family Life',23,'Initiate cleaning tasks in the classroom',NULL,NULL),(1013,1300,'Domestic and Family Life',24,'Use basic cleaning equipment with assistance',NULL,NULL),(1014,1300,'Domestic and Family Life',25,'Assist with cleaning areas of dwelling',NULL,NULL),(1015,1300,'Domestic and Family Life',26,'Independently undertake classroom cleaning chores',NULL,NULL),(1016,1300,'Domestic and Family Life',27,'Use cleaning equipment and supplies with assistance',NULL,NULL),(1017,1300,'Domestic and Family Life',28,'Care for own living and work space independently',NULL,NULL),(1018,1300,'Domestic and Family Life',29,'Initiate household cleaning',NULL,NULL),(1019,1300,'Domestic and Family Life',30,'Clean others\" belongings and living space. ',NULL,NULL),(1020,1300,'Domestic and Family Life',31,'Distinguish between edible and non-edible substances',NULL,NULL),(1021,1300,'Domestic and Family Life',32,'Assist in selection of food items while shopping',NULL,NULL),(1022,1300,'Domestic and Family Life',33,'Use fork and spoon appropriately; use knife for some cutting of semi-solids',NULL,NULL),(1023,1300,'Domestic and Family Life',34,'Use condiments independently',NULL,NULL),(1024,1300,'Domestic and Family Life',35,'Prepare simple snacks',NULL,NULL),(1025,1300,'Domestic and Family Life',36,'Assist with chores related to food production',NULL,NULL),(1026,1300,'Domestic and Family Life',37,'Assist in setting the table',NULL,NULL),(1027,1300,'Domestic and Family Life',38,'Prepare uncooked breakfast',NULL,NULL),(1028,1300,'Domestic and Family Life',39,'Clean up after snacks',NULL,NULL),(1029,1300,'Domestic and Family Life',40,'Use kitchen utensils with safety',NULL,NULL),(1030,1300,'Domestic and Family Life',41,'Participate in family food shopping',NULL,NULL),(1031,1300,'Domestic and Family Life',42,'Know where food may be purchased',NULL,NULL),(1032,1300,'Domestic and Family Life',43,'Use kitchen appliances with safety',NULL,NULL),(1033,1300,'Domestic and Family Life',44,'Purchase food items',NULL,NULL),(1034,1300,'Domestic and Family Life',45,'Prepare school lunch',NULL,NULL),(1035,1300,'Domestic and Family Life',46,'Identify basic food order',NULL,NULL),(1036,1300,'Domestic and Family Life',47,'Independently prepare table for meal',NULL,NULL),(1037,1300,'Domestic and Family Life',48,'Independently clear table after meal',NULL,NULL),(1038,1300,'Domestic and Family Life',49,'Plan meals for one day',NULL,NULL),(1039,1300,'Domestic and Family Life',50,'Prepare a variety of simple meals',NULL,NULL),(1040,1300,'Domestic and Family Life',51,'The student will plan and prepare meals.',NULL,NULL),(1041,1300,'Domestic and Family Life',52,'Demonstrate independence in grocery shopping',NULL,NULL),(1042,1300,'Domestic and Family Life',53,'Make a simple shopping list',NULL,NULL),(1043,1300,'Domestic and Family Life',54,'Plan meals for week',NULL,NULL),(1044,1300,'Domestic and Family Life',55,'Interpret recipes',NULL,NULL),(1045,1300,'Domestic and Family Life',56,'Prepare simple recipes',NULL,NULL),(1046,1300,'Domestic and Family Life',57,'Get own food items and utensils for snacks',NULL,NULL),(1047,1300,'Domestic and Family Life',58,'Pour drink from a pitcher with assistance',NULL,NULL),(1048,1300,'Domestic and Family Life',59,'Offer food to others',NULL,NULL),(1049,1300,'Domestic and Family Life',60,'Get own lunch box, open containers, serve self',NULL,NULL),(1050,1300,'Domestic and Family Life',61,'Carry tray/plate of food',NULL,NULL),(1051,1300,'Domestic and Family Life',62,'Pour drinks for family members',NULL,NULL),(1052,1300,'Domestic and Family Life',63,'Pass food to family members and guests',NULL,NULL),(1053,1300,'Domestic and Family Life',64,'Take responsibility for serving food for entire meal',NULL,NULL),(1054,1300,'Domestic and Family Life',65,'Recognize storage places for clothing',NULL,NULL),(1055,1300,'Domestic and Family Life',66,'Place clothing in proper storage area',NULL,NULL),(1056,1300,'Domestic and Family Life',67,'Place soiled clothing in laundry area',NULL,NULL),(1057,1300,'Domestic and Family Life',68,'Hang clothing in closet',NULL,NULL),(1058,1300,'Domestic and Family Life',69,'Assist with sorting laundry',NULL,NULL),(1059,1300,'Domestic and Family Life',70,'Assist with folding completed laundry',NULL,NULL),(1060,1300,'Domestic and Family Life',71,'Launder personal items of clothing',NULL,NULL),(1061,1300,'Domestic and Family Life',72,'Read clothing labels',NULL,NULL),(1062,1300,'Domestic and Family Life',73,'Sort and fold laundry',NULL,NULL),(1063,1300,'Domestic and Family Life',74,'Identify clothing in need of repair',NULL,NULL),(1064,1300,'Domestic and Family Life',75,'Learn simple sewing techniques',NULL,NULL),(1065,1300,'Domestic and Family Life',76,'Sew buttons and hems',NULL,NULL),(1066,1300,'Domestic and Family Life',77,'Select and purchase clothing',NULL,NULL),(1067,1300,'Domestic and Family Life',78,'Iron flat items',NULL,NULL),(1068,1300,'Domestic and Family Life',79,'Pack for a trip',NULL,NULL),(1069,1300,'Domestic and Family Life',80,'Launder and iron clothing independently',NULL,NULL),(1070,1300,'Domestic and Family Life',81,'Identify and take appropriate clothing to dry cleaner',NULL,NULL),(1071,1300,'Domestic and Family Life',82,'Understand that different activities occur at different times of the day',NULL,NULL),(1072,1300,'Domestic and Family Life',83,'Follow a picture schedule',NULL,NULL),(1073,1300,'Domestic and Family Life',84,'Understand and use: today, this morning, tonight',NULL,NULL),(1074,1300,'Domestic and Family Life',85,'Understand and use: yesterday, tomorrow, last week, next week, last year, next year',NULL,NULL),(1075,1300,'Domestic and Family Life',86,'Respond to time signals at school',NULL,NULL),(1076,1300,'Domestic and Family Life',87,'Respond to time cues(table setting and meal time, bathing and bedtime)',NULL,NULL),(1077,1300,'Domestic and Family Life',88,'Begin to organize work and play time',NULL,NULL),(1078,1300,'Domestic and Family Life',89,'Tell time on digital clock',NULL,NULL),(1079,1300,'Domestic and Family Life',90,'Use analogue clock/watch with assistance',NULL,NULL),(1080,1300,'Domestic and Family Life',91,'Tell time',NULL,NULL),(1081,1300,'Domestic and Family Life',92,'Organize personal time',NULL,NULL),(1082,1300,'Domestic and Family Life',93,'Schedule activities',NULL,NULL),(1083,1300,'Domestic and Family Life',94,'Tell time from analogue clock/watch',NULL,NULL),(1084,1300,'Domestic and Family Life',95,'Develop a personal schedule for school activities over longer periods of time',NULL,NULL),(1085,1300,'Domestic and Family Life',96,'Recognize basic personnel associated with community services',NULL,NULL),(1086,1300,'Domestic and Family Life',97,'Visit and use community services with adults',NULL,NULL),(1087,1300,'Domestic and Family Life',98,'Identify areas adjacent to home neighborhood',NULL,NULL),(1088,1300,'Domestic and Family Life',99,'Identify community services',NULL,NULL),(1089,1300,'Domestic and Family Life',100,'Identify personnel associated with community services',NULL,NULL),(1090,1300,'Domestic and Family Life',101,'Identify and locate key locations in school community',NULL,NULL),(1091,1300,'Domestic and Family Life',102,'Follow the rules of the neighborhood',NULL,NULL),(1092,1300,'Domestic and Family Life',103,'Identify community facilities',NULL,NULL),(1093,1300,'Domestic and Family Life',104,'Distinguish between civic, provincial and federal government',NULL,NULL),(1094,1300,'Domestic and Family Life',105,'Identify cultural differences in the community',NULL,NULL),(1095,1300,'Domestic and Family Life',106,'Use community services with independence',NULL,NULL),(1096,1300,'Domestic and Family Life',107,'Use community facilities with independence',NULL,NULL),(1097,1300,'Domestic and Family Life',108,'Describe responsibilities of civic, provincial and federal government',NULL,NULL),(1098,1300,'Domestic and Family Life',109,'Understand the importance of community rules',NULL,NULL),(1099,1300,'Domestic and Family Life',110,'Understand rights as an individual',NULL,NULL),(1100,1300,'Domestic and Family Life',111,'Be aware of international government',NULL,NULL),(1101,1300,'Domestic and Family Life',112,'Be aware of the role of international government agencies',NULL,NULL),(1102,1300,'Domestic and Family Life',113,'Apply the term ',NULL,NULL),(1103,1300,'Domestic and Family Life',114,'Sort and match coins',NULL,NULL),(2974,1104,'Extending Spelling Skills',5,'Identify digraphs, sh,ch,ng,nk,wh,th(voiced or unvoiced)',NULL,NULL),(2973,1104,'Extending Spelling Skills',4,'Spell words with blends, bl,pl,sl,fl,gl,cl,br,tr,gr,dr,fr,cr,spr,str,thr,st,sn,sp,spl',NULL,NULL),(2972,1104,'Extending Spelling Skills',3,'Spell words with regular consonant sounds(initial, medial, final) b,d,f,g,h,j,k,l,m,n,p,r,s,t,v,w,y,z',NULL,NULL),(2971,1104,'Extending Spelling Skills',2,'Spell words with key consonants, b,c,d,f,g,h,j,k,l,m,n,p,r,s,t,v,w,y,z',NULL,NULL),(1113,1300,'Domestic and Family Life',115,'Identify dollars and cents when written',NULL,NULL),(1114,1300,'Domestic and Family Life',116,'Perform tasks for small monetary rewards',NULL,NULL),(1115,1300,'Domestic and Family Life',117,'Understand people earn money by doing something for someone else',NULL,NULL),(1116,1300,'Domestic and Family Life',118,'Manage bank account with assistance',NULL,NULL),(1117,1300,'Domestic and Family Life',119,'Keep money in a safe place',NULL,NULL),(1118,1300,'Domestic and Family Life',120,'Save money',NULL,NULL),(1119,1300,'Domestic and Family Life',121,'Perform small jobs for money',NULL,NULL),(1120,1300,'Domestic and Family Life',122,'Purchase items independently',NULL,NULL),(1121,1300,'Domestic and Family Life',123,'Manage bank account with assistance',NULL,NULL),(1122,1300,'Domestic and Family Life',124,'Understand value of money',NULL,NULL),(1123,1300,'Domestic and Family Life',125,'Earn money regularly',NULL,NULL),(1124,1300,'Domestic and Family Life',126,'Compare prices of similar materials',NULL,NULL),(1125,1300,'Domestic and Family Life',127,'Understand borrowing, repayment',NULL,NULL),(1126,1300,'Domestic and Family Life',128,'Budget and plan for expenditures',NULL,NULL),(1127,1300,'Domestic and Family Life',129,'Manage a bank account',NULL,NULL),(1128,1401,'Personal Development',1,'Understand his or her own name',NULL,NULL),(1129,1401,'Personal Development',2,'Know names of family members',NULL,NULL),(1130,1401,'Personal Development',3,'Know gender',NULL,NULL),(1131,1401,'Personal Development',4,'State siblings',NULL,NULL),(1132,1401,'Personal Development',5,'State town or city',NULL,NULL),(1133,1401,'Personal Development',6,'State birthday',NULL,NULL),(1134,1399,'Social Development',1,'Maintain eye contact with care giver or school personnel for 3 seconds',NULL,NULL),(1135,1399,'Social Development',40,'Refrain from unattractive or rude gestures and noises in public',NULL,NULL),(2903,8090,'Measurement',26,'When given pictures of  five objects along with a metric ruler that shows millimeter intervals, will correctly measure the objects for graduations to the nearest centimeter. ',NULL,NULL),(1138,1399,'Social Development',2,'Maintain appropriate distance when speaking to others',NULL,NULL),(1139,1401,'Personal Development',92,'Refrain from touching genital area of self in public',NULL,NULL),(1140,1399,'Social Development',3,'Respond to a social greeting',NULL,NULL),(1141,1399,'Social Development',39,'Respect personal space of self and others',NULL,NULL),(1142,1399,'Social Development',38,'Say excuse me before interrupting.',NULL,NULL),(1143,1399,'Social Development',37,'Apologize for wrong doing',NULL,NULL),(1145,1399,'Social Development',41,'Laugh at appropriate points in a story or situation',NULL,NULL),(1146,1401,'Personal Development',48,'Seek privacy for clothing adjustment',NULL,NULL),(1147,1399,'Social Development',17,'Look to others for social cues',NULL,NULL),(2841,116,'Phonological Awareness',4,'student will provide a word that rhymes with a given word',NULL,NULL),(1149,1399,'Social Development',6,'Use appropriate titles to address adults',NULL,NULL),(2840,116,'Phonological Awareness',3,'student will identify rhyming words presented in pairs',NULL,NULL),(1151,1401,'Personal Development',91,'Respect privacy of others',NULL,NULL),(1152,1399,'Social Development',16,'Initiate and pursue conversation, pausing-allowing others to speak',NULL,NULL),(1153,1399,'Social Development',24,'Conclude conversation politely',NULL,NULL),(1154,1399,'Social Development',15,'Approach peers without fear',NULL,NULL),(2839,116,'Phonological Awareness',2,'student will identify alphabet letters by name',NULL,NULL),(1156,1401,'Personal Development',93,'Become aware of inappropriate touching',NULL,NULL),(2877,8090,'Measurement',2,'Will be able to use a ruler or meter stick to measure accurately a two-dimensional object.',NULL,NULL),(1160,1399,'Social Development',11,'Categorize familiar and unfamiliar people',NULL,NULL),(1161,1399,'Social Development',29,'Verbalize desire to be friends',NULL,NULL),(1162,1399,'Social Development',31,'Initiate friendly activity',NULL,NULL),(2961,200,'Gross Motor Development',63,'Climb up on steps to slide',NULL,NULL),(1164,1399,'Social Development',9,'Identify person to whom need can be expressed',NULL,NULL),(1165,1399,'Social Development',12,'Recognize roles of familiar people',NULL,NULL),(1166,1399,'Social Development',7,'Distinguish between needs and wants',NULL,NULL),(2957,200,'Gross Motor Development',37,'Walk backwards easily',NULL,NULL),(1168,1399,'Social Development',28,'Make choices between activities',NULL,NULL),(1169,1399,'Social Development',5,'Respond appropriately to familiar and unfamiliar people with respect to age and role',NULL,NULL),(1170,1399,'Social Development',42,'Contribute to classroom decision making',NULL,NULL),(1171,1399,'Social Development',36,'Resolve conflict with peers without assistance',NULL,NULL),(1172,1401,'Personal Development',34,'Cooperate while being dressed/undressed',NULL,NULL),(1174,1401,'Personal Development',35,'Put on/remove sleeved garment ',NULL,NULL),(1175,1401,'Personal Development',36,'Put on/remove legged garment ',NULL,NULL),(1176,1401,'Personal Development',37,'Put on/remove socks ',NULL,NULL),(1177,1401,'Personal Development',38,'Remove shoes ',NULL,NULL),(1178,1401,'Personal Development',39,'Put shoes on correct foot',NULL,NULL),(1180,1401,'Personal Development',55,'Manage snaps and velcro fasteners',NULL,NULL),(2837,8080,'Decimals',19,'When given ten problems requiring the division of decimals, will correctly compute the answers for dividing decimals with tenths in divisor.',NULL,NULL),(1182,1401,'Personal Development',43,'Dress appropriately for activity',NULL,NULL),(1183,1401,'Personal Development',42,'Select appropriate clothing for weather',NULL,NULL),(1186,1401,'Personal Development',44,'Differentiate soiled clothing from clean, pressed from wrinkled',NULL,NULL),(1187,1401,'Personal Development',45,'Change clothing when soiled',NULL,NULL),(1188,1401,'Personal Development',41,'Select clothing appropriate to occasion',NULL,NULL),(1189,1401,'Personal Development',46,'Be aware of proper clothing fit',NULL,NULL),(1190,1401,'Personal Development',49,'Clean shoes',NULL,NULL),(2836,8080,'Decimals',18,'When given ten problems requiring the division of decimals, will correctly compute the answers for dividing decimals with hundredths in dividends.',NULL,NULL),(1193,1401,'Personal Development',47,'Be aware of basic color and fashion coordination',NULL,NULL),(1194,1401,'Personal Development',40,'Select some of own wardrobe',NULL,NULL),(1195,1401,'Personal Development',50,'Unbutton 3 large; medium; small buttons on front of clothing',NULL,NULL),(1196,1401,'Personal Development',52,'Zip/unzip zipper without separating or inserting shank',NULL,NULL),(1197,1401,'Personal Development',56,'Snap or unhook clothing in front',NULL,NULL),(1198,1401,'Personal Development',53,'Unzip front zipper on jacket, separating shank',NULL,NULL),(1199,1401,'Personal Development',51,'Button 3 large; medium; small buttons on front of clothing',NULL,NULL),(1200,1401,'Personal Development',64,'Unbuckle shoe or belt',NULL,NULL),(1201,1401,'Personal Development',65,'Buckle up shoe strap or belt',NULL,NULL),(1202,1401,'Personal Development',54,'Zip up jacket zipper inserting shank',NULL,NULL),(1203,1401,'Personal Development',58,'Thread lace through shoe eyelet',NULL,NULL),(1204,1401,'Personal Development',59,'Untie knot on apron or shoe lace',NULL,NULL),(1205,1401,'Personal Development',60,'Tie an overhand knot(first knot of shoe tying)',NULL,NULL),(1206,1401,'Personal Development',61,'Tie bow knot on shoe lace',NULL,NULL),(1207,1401,'Personal Development',62,'Tie hood strings on coat',NULL,NULL),(2835,8080,'Decimals',17,'When given ten problems requiring the division of decimals, will correctly compute the answers for dividing decimals with tenths in dividends.',NULL,NULL),(1209,1401,'Personal Development',57,'Hook/unhook bra fastener',NULL,NULL),(1210,1401,'Personal Development',63,'Tie bow knot on apron behind back',NULL,NULL),(1211,1401,'Personal Development',16,'Indicate he or she is soiled',NULL,NULL),(1214,1401,'Personal Development',17,'Control bowel; control bladder',NULL,NULL),(1215,1401,'Personal Development',18,'Communicate need to urinate; communicate need for bowel movement',NULL,NULL),(2834,8080,'Decimals',16,'When given ten problems requiring the multiplication of decimals, will correctly compute the answers for multiplying decimals with mixed numbers times tenths or hundredths.',NULL,NULL),(2833,8080,'Decimals',15,'When given ten problems requiring the multiplication of decimals, will correctly compute the answers for multiplying decimals with tenths times tenths.',NULL,NULL),(1221,1401,'Personal Development',20,'Use toileting facilities in appropriate manner for urination and bowel movement',NULL,NULL),(1222,1401,'Personal Development',21,'Wipe self independently after bowel movement',NULL,NULL),(1223,1401,'Personal Development',22,'Flush toilet consistently following use',NULL,NULL),(1224,1401,'Personal Development',19,'Recognize and use appropriate restroom in school; community setting',NULL,NULL),(1225,1401,'Personal Development',23,'Be socially acceptable in washroom use ',NULL,NULL),(1226,1401,'Personal Development',24,'Be aware of health and personal hygiene safety issues in relation to use of public facilities',NULL,NULL),(1227,1401,'Personal Development',7,'Cooperate with care giver when washing and drying hands',NULL,NULL),(2879,8090,'Measurement',4,'Read and comprehend linear measurement vocabulary( millimeter, centimeter, meter, kilometer, height, length, width, kilometer, kilometer per hour, volume, area, linear)',NULL,NULL),(1229,1401,'Personal Development',10,'Wash and dry hands ',NULL,NULL),(1231,1401,'Personal Development',8,'Turn water taps on and off at sink',NULL,NULL),(1232,1401,'Personal Development',9,'Adjust tap to achieve desired water temperature and pressure',NULL,NULL),(1233,1401,'Personal Development',11,'Wash and dry face ',NULL,NULL),(1234,1401,'Personal Development',12,'Bathe demonstrating awareness of safety issues of water temperature and depth',NULL,NULL),(2970,1104,'Extending Spelling Skills',1,'Spell cvc words, a, e,i ,o ,u (medial position)',NULL,NULL),(1236,1401,'Personal Development',14,'Draw water independently for bath',NULL,NULL),(1237,1401,'Personal Development',15,'Shampoo hair',NULL,NULL),(1238,1399,'Social Development',30,'Interact positively with peers',NULL,NULL),(1240,1399,'Social Development',32,'Want to be friends with many peers',NULL,NULL),(3018,2600,'Other subjects',9,'Spelling',NULL,NULL),(1244,1401,'Personal Development',94,'Learn about human sexuality',NULL,NULL),(2878,8090,'Measurement',3,'Will be able to use a ruler or meter stick to measure accurately a three-dimensional object.',NULL,NULL),(1247,1399,'Social Development',33,'Recognize the responsibility of friendship',NULL,NULL),(1248,1399,'Social Development',35,'Develop longer lasting relationships with members of both sexes',NULL,NULL),(1249,1401,'Personal Development',95,'Understand human sexuality',NULL,NULL),(1250,1399,'Social Development',34,'Develop long-term friendships at school and in the neighborhood',NULL,NULL),(1251,1401,'Personal Development',96,'Understand dating behavior',NULL,NULL),(1252,1401,'Personal Development',97,'Demonstrate appropriate sexual behavior',NULL,NULL),(1253,1401,'Personal Development',98,'Use correct language when describing sexual behavior',NULL,NULL),(1254,1401,'Personal Development',26,'Blow nose upon request',NULL,NULL),(1255,1401,'Personal Development',25,'Wipe nose when asked',NULL,NULL),(1256,1401,'Personal Development',29,'Brush teeth ',NULL,NULL),(1257,1401,'Personal Development',31,'Comb hair ',NULL,NULL),(1259,1401,'Personal Development',30,'Brush hair ',NULL,NULL),(1260,1401,'Personal Development',27,'Wipe nose voluntarily',NULL,NULL),(1262,1401,'Personal Development',28,'Practice hygiene associated with coughing and sneezing',NULL,NULL),(1263,1401,'Personal Development',32,'Clean finger nails',NULL,NULL),(1264,1401,'Personal Development',83,'Use deodorant',NULL,NULL),(1265,1401,'Personal Development',84,'Clean glasses',NULL,NULL),(1266,1401,'Personal Development',85,'Manage hygiene associated with menstruation',NULL,NULL),(1267,1401,'Personal Development',86,'Purchase personal care items',NULL,NULL),(1268,1401,'Personal Development',87,'Use cosmetics and grooming aids',NULL,NULL),(1269,1401,'Personal Development',88,'Maintain cleanliness of comb and brush',NULL,NULL),(1270,1401,'Personal Development',89,'Manage hair care; washing and styling',NULL,NULL),(1272,1401,'Personal Development',90,'Shave',NULL,NULL),(2876,8090,'Measurement',1,'Will be able to identify the use of a ruler, meter stick, scale, and thermometer.',NULL,NULL),(1274,1401,'Personal Development',66,'Drink from cup independently',NULL,NULL),(1275,1401,'Personal Development',67,'Use spoon to feed self',NULL,NULL),(1276,1401,'Personal Development',68,'Suck from straw',NULL,NULL),(1277,1401,'Personal Development',69,'Manage cups and glasses with one hand independently',NULL,NULL),(1278,1401,'Personal Development',70,'Chew food properly',NULL,NULL),(1279,1401,'Personal Development',71,'Use fork and spoon appropriately',NULL,NULL),(1280,1401,'Personal Development',73,'Communicate need to eat',NULL,NULL),(1281,1401,'Personal Development',74,'Broaden variety of preferred foods',NULL,NULL),(1282,1401,'Personal Development',75,'Associate food items with an order for eating',NULL,NULL),(1283,1401,'Personal Development',76,'Associate foods and sources',NULL,NULL),(1284,1401,'Personal Development',77,'Control food consumption',NULL,NULL),(1285,1401,'Personal Development',78,'Identify foods by label',NULL,NULL),(1286,1401,'Personal Development',79,'Select appropriate food for meal',NULL,NULL),(1287,1401,'Personal Development',80,'Classify all foods',NULL,NULL),(1288,1401,'Personal Development',81,'Choose a balanced diet',NULL,NULL),(1289,1401,'Personal Development',82,'Recognize reasons for controlling consumption',NULL,NULL),(1290,1402,'Safety and Health Development',1,'Demonstrate safe use of play equipment',NULL,NULL),(1291,1402,'Safety and Health Development',2,'Put playthings away',NULL,NULL),(1292,1402,'Safety and Health Development',3,'Cooperate during activities promoting increased safety; eg., accept use of seat belts, hold hands while crossing street',NULL,NULL),(1293,1402,'Safety and Health Development',4,'Respond to commands such as ',NULL,NULL),(1294,1402,'Safety and Health Development',5,'Use small objects with care and safety',NULL,NULL),(1295,1402,'Safety and Health Development',6,'Demonstrate knowledge of safety rules',NULL,NULL),(1296,1402,'Safety and Health Development',7,'Respond to supervision in play areas',NULL,NULL),(1297,1402,'Safety and Health Development',8,'Warn others of danger',NULL,NULL),(1298,1402,'Safety and Health Development',9,'Practice bicycle safety',NULL,NULL),(1299,1402,'Safety and Health Development',10,'Know the dangers of not following safety rules',NULL,NULL),(1300,1402,'Safety and Health Development',11,'Demonstrate safe use of recreational equipment',NULL,NULL),(1301,1402,'Safety and Health Development',12,'Practice fire safety; follow routines of fire drills',NULL,NULL),(1302,1402,'Safety and Health Development',13,'Use community recreational facilities safely',NULL,NULL),(1303,1402,'Safety and Health Development',14,'Recognize where to seek help when hurt',NULL,NULL),(1304,1402,'Safety and Health Development',15,'Organize work and play space to maximize safety',NULL,NULL),(1305,1402,'Safety and Health Development',16,'Demonstrate safe use of equipment for work and play',NULL,NULL),(1306,1402,'Safety and Health Development',17,'Demonstrate unsafe features of work and play equipment',NULL,NULL),(1307,1402,'Safety and Health Development',18,'Follow directions given in emergencies',NULL,NULL),(1308,1402,'Safety and Health Development',19,'Independently use equipment',NULL,NULL),(1309,1402,'Safety and Health Development',20,'Demonstrate knowledge of first aid procedures',NULL,NULL),(1310,1402,'Safety and Health Development',21,'Know how to access emergency services',NULL,NULL),(1311,1402,'Safety and Health Development',22,'Play with the phone',NULL,NULL),(1312,1402,'Safety and Health Development',23,'Imitate phone conversation',NULL,NULL),(1313,1402,'Safety and Health Development',24,'Answer the phone with a clear voice',NULL,NULL),(1314,1402,'Safety and Health Development',25,'Use touch tone and dial phones',NULL,NULL),(1315,1402,'Safety and Health Development',26,'Respond appropriately if call is for someone else',NULL,NULL),(1316,1402,'Safety and Health Development',27,'Notify person wanted',NULL,NULL),(1317,1402,'Safety and Health Development',28,'Carry on meaningful conversation if call is personal',NULL,NULL),(1318,1402,'Safety and Health Development',29,'Use different responses for different types of calls',NULL,NULL),(1319,1402,'Safety and Health Development',30,'Make local calls',NULL,NULL),(1320,1402,'Safety and Health Development',31,'Use pay phones',NULL,NULL),(1321,1402,'Safety and Health Development',32,'Write messages to be conveyed if call for others',NULL,NULL),(1322,1402,'Safety and Health Development',33,'Know how to use an answering machine',NULL,NULL),(1323,1402,'Safety and Health Development',34,'Take and convey messages verbally',NULL,NULL),(1324,1402,'Safety and Health Development',35,'Use yellow pages',NULL,NULL),(1325,1402,'Safety and Health Development',36,'Use talking yellow pages',NULL,NULL),(1326,1402,'Safety and Health Development',37,'Make long distance calls',NULL,NULL),(1327,1402,'Safety and Health Development',38,'Ask for wanted party properly',NULL,NULL),(1328,1402,'Safety and Health Development',39,'End calls politely',NULL,NULL),(1329,1402,'Safety and Health Development',40,'Hang up if caller refuses to identify self or uses obscene language',NULL,NULL),(1330,1402,'Safety and Health Development',41,'Use directory assistance',NULL,NULL),(1331,1402,'Safety and Health Development',42,'Locate number in phone book',NULL,NULL),(1332,1402,'Safety and Health Development',43,'Access fax machine technology',NULL,NULL),(1333,1402,'Safety and Health Development',44,'Understand that some substances can be harmful',NULL,NULL),(1334,1402,'Safety and Health Development',45,'Identify the symbols for hazardous household products',NULL,NULL),(1335,1402,'Safety and Health Development',46,'Learn the definition of a drug and understand that many commonly used substances can be considered drugs',NULL,NULL),(1336,1402,'Safety and Health Development',47,'Understand that drugs can be helpful and harmful',NULL,NULL),(1337,1402,'Safety and Health Development',48,'Distinguish between prescription and non-prescription drugs',NULL,NULL),(1338,1402,'Safety and Health Development',49,'Demonstrate knowledge about the effects of caffeine, tobacco and alcohol',NULL,NULL),(1339,1402,'Safety and Health Development',50,'Differentiate between the use and abuse of drugs',NULL,NULL),(1340,1402,'Safety and Health Development',51,'Identify types of drugs related to drug use and abuse',NULL,NULL),(1341,1402,'Safety and Health Development',52,'Understand the effects of use and abuse of tobacco, alcohol and other drugs',NULL,NULL),(1342,1402,'Safety and Health Development',53,'Know about the consequences of tobacco, alcohol and other drug abuse',NULL,NULL),(1343,1402,'Safety and Health Development',54,'Understand the factors that may influence drug use/abuse',NULL,NULL),(1344,1402,'Safety and Health Development',55,'Be able to assess the risks to oneself',NULL,NULL),(1345,1402,'Safety and Health Development',56,'Understand key issues related to impairment and driving',NULL,NULL),(1346,1402,'Safety and Health Development',57,'Be aware of services available for the treatment of substance abuse',NULL,NULL),(1347,300,'Fine Motor Control',92,'Turn the computer on and off',NULL,NULL),(1348,300,'Fine Motor Control',93,'Handle disks or other storage media that the computer uses',NULL,NULL),(1349,300,'Fine Motor Control',94,'Use a printer, turn it on and off and load it with paper',NULL,NULL),(1350,300,'Fine Motor Control',95,'Locate keys on keyboard using space bar, return, shift keys, cursor movement keys and escape key',NULL,NULL),(1352,300,'Fine Motor Control',97,'Perform simple trouble-shooting routines',NULL,NULL),(1353,300,'Fine Motor Control',98,'Keyboard using home row techniques',NULL,NULL),(1354,300,'Fine Motor Control',100,'Use other hardware peripherals such as mouse, modem, laboratory probes, midi keyboards, cd-rom',NULL,NULL),(1355,1505,'Leisure/Recreation Arts - General',1,'Participate in games led by others',NULL,NULL),(1356,1505,'Leisure/Recreation Arts - General',2,'Understand taking turns',NULL,NULL),(1357,1505,'Leisure/Recreation Arts - General',3,'Understand sharing equipment',NULL,NULL),(1358,1505,'Leisure/Recreation Arts - General',4,'Imitate play activity of others',NULL,NULL),(1359,1505,'Leisure/Recreation Arts - General',5,'Engage in symbolic play',NULL,NULL),(1360,1505,'Leisure/Recreation Arts - General',6,'Attend to task',NULL,NULL),(1361,1505,'Leisure/Recreation Arts - General',7,'Respond to direction from instructor',NULL,NULL),(1362,1505,'Leisure/Recreation Arts - General',8,'Use courtesies associated with games',NULL,NULL),(1363,1505,'Leisure/Recreation Arts - General',9,'Verbalize rules of games',NULL,NULL),(1364,1505,'Leisure/Recreation Arts - General',10,'Participate in games with low level of organization(indoor/outdoor with decreasing amount of adult direction)',NULL,NULL),(1365,1505,'Leisure/Recreation Arts - General',11,'Increase repertoire of games',NULL,NULL),(1366,1505,'Leisure/Recreation Arts - General',12,'Initiate game activity',NULL,NULL),(1367,1505,'Leisure/Recreation Arts - General',13,'Participate in intramural activity',NULL,NULL),(1368,1505,'Leisure/Recreation Arts - General',14,'Participate in organized races',NULL,NULL),(1369,1505,'Leisure/Recreation Arts - General',15,'Play simple games with others',NULL,NULL),(1370,1505,'Leisure/Recreation Arts - General',16,'Participate in community led game activity',NULL,NULL),(1371,1505,'Leisure/Recreation Arts - General',17,'Generalize skills to other games',NULL,NULL),(1372,1505,'Leisure/Recreation Arts - General',18,'Show others how to play game',NULL,NULL),(1373,1505,'Leisure/Recreation Arts - General',19,'Practice skills required for game',NULL,NULL),(1374,1505,'Leisure/Recreation Arts - General',20,'Demonstrate sportsmanship in game activity',NULL,NULL),(1375,1505,'Leisure/Recreation Arts - General',21,'Understand game safety',NULL,NULL),(1376,1505,'Leisure/Recreation Arts - General',22,'Generalize game safety to other games',NULL,NULL),(1377,1505,'Leisure/Recreation Arts - General',23,'Assemble interlocking puzzles',NULL,NULL),(1378,1505,'Leisure/Recreation Arts - General',24,'Put away games when finished',NULL,NULL),(1379,1505,'Leisure/Recreation Arts - General',25,'Play card games requiring matching and sorting (simple classification)',NULL,NULL),(1380,1505,'Leisure/Recreation Arts - General',26,'Share items',NULL,NULL),(1381,1505,'Leisure/Recreation Arts - General',27,'Play simple board games',NULL,NULL),(1382,1505,'Leisure/Recreation Arts - General',28,'Play with electronic games',NULL,NULL),(1383,1505,'Leisure/Recreation Arts - General',29,'Take turns in games',NULL,NULL),(1384,1505,'Leisure/Recreation Arts - General',30,'Behave appropriately while waiting for turn',NULL,NULL),(1385,1505,'Leisure/Recreation Arts - General',31,'Complete simple puzzles',NULL,NULL),(1386,1505,'Leisure/Recreation Arts - General',32,'Play simple card games',NULL,NULL),(1387,1505,'Leisure/Recreation Arts - General',33,'Understand purpose of rules for games',NULL,NULL),(1388,1505,'Leisure/Recreation Arts - General',34,'Play board games requiring participant to take turns and follow complex rules',NULL,NULL),(1389,1505,'Leisure/Recreation Arts - General',35,'Play card games with more complex playing procedures and more complex rules',NULL,NULL),(1390,1505,'Leisure/Recreation Arts - General',36,'Play educational games',NULL,NULL),(1391,1505,'Leisure/Recreation Arts - General',37,'Cooperate as a team player',NULL,NULL),(1392,1505,'Leisure/Recreation Arts - General',38,'Play card games requiring memory skills and strategic play',NULL,NULL),(1393,1505,'Leisure/Recreation Arts - General',39,'Understand leader/follower positions in games',NULL,NULL),(1394,1505,'Leisure/Recreation Arts - General',40,'Play board games required playing strategies',NULL,NULL),(1395,1505,'Leisure/Recreation Arts - General',41,'Complete word puzzles',NULL,NULL),(1396,1505,'Leisure/Recreation Arts - General',42,'Know how to activate and deactivate game',NULL,NULL),(1397,1505,'Leisure/Recreation Arts - General',43,'Play computer games with large display and manipulated by large muscle movement',NULL,NULL),(1398,1505,'Leisure/Recreation Arts - General',44,'Use hand held electronic games',NULL,NULL),(1399,1505,'Leisure/Recreation Arts - General',45,'Have favourite games',NULL,NULL),(1400,1505,'Leisure/Recreation Arts - General',46,'Play games with lower levels of complexity',NULL,NULL),(1401,1505,'Leisure/Recreation Arts - General',47,'Share games',NULL,NULL),(1402,1505,'Leisure/Recreation Arts - General',48,'Know the vocabulary associated with computer games',NULL,NULL),(1403,1505,'Leisure/Recreation Arts - General',49,'Attempt variety of games',NULL,NULL),(1404,1505,'Leisure/Recreation Arts - General',50,'Attempt more complex games',NULL,NULL),(1405,1505,'Leisure/Recreation Arts - General',51,'Engage in competition with others playing same game',NULL,NULL),(1406,1505,'Leisure/Recreation Arts - General',52,'Play with toys',NULL,NULL),(1407,1505,'Leisure/Recreation Arts - General',53,'Imitate play activity of others',NULL,NULL),(1408,1505,'Leisure/Recreation Arts - General',54,'Attend to single activity for short periods of time',NULL,NULL),(1409,1505,'Leisure/Recreation Arts - General',55,'Listen to radio and tapes',NULL,NULL),(1410,1505,'Leisure/Recreation Arts - General',56,'Watch television',NULL,NULL),(1411,1505,'Leisure/Recreation Arts - General',57,'Attend movies with others',NULL,NULL),(1412,1505,'Leisure/Recreation Arts - General',58,'Attend to play activity for longer periods of time',NULL,NULL),(1413,1505,'Leisure/Recreation Arts - General',59,'Participate in community recreational activity with assistance',NULL,NULL),(1414,1505,'Leisure/Recreation Arts - General',60,'Indicate preference for recreational activity',NULL,NULL),(1415,1505,'Leisure/Recreation Arts - General',61,'Have preferences for specific media forms; eg. , television, comics, radio, pictures',NULL,NULL),(1416,1505,'Leisure/Recreation Arts - General',62,'Make choices among available movies, videos',NULL,NULL),(1417,1505,'Leisure/Recreation Arts - General',63,'Participate in community team sports activity (hockey, ball, soccer)',NULL,NULL),(1418,1505,'Leisure/Recreation Arts - General',64,'Participate in track meet activities',NULL,NULL),(1419,1505,'Leisure/Recreation Arts - General',65,'Participate in individual sports (golf, bowling, biking, roller blading)',NULL,NULL),(1420,1505,'Leisure/Recreation Arts - General',66,'Demonstrate appropriate spectator skills',NULL,NULL),(1421,1505,'Leisure/Recreation Arts - General',67,'Develop preferences for media themes (adventure, romance, western, science fiction)',NULL,NULL),(1422,1505,'Leisure/Recreation Arts - General',68,'Go to movies with peers',NULL,NULL),(1423,1505,'Leisure/Recreation Arts - General',69,'Specify preference about recreational activity',NULL,NULL),(1424,1505,'Leisure/Recreation Arts - General',70,'Broaden the range of recreational activity in which he or she participates',NULL,NULL),(1425,1505,'Leisure/Recreation Arts - General',71,'Develop preferences for particular actors',NULL,NULL),(1426,1505,'Leisure/Recreation Arts - General',72,'Initiate participation in recreational activity',NULL,NULL),(1427,1505,'Leisure/Recreation Arts - General',73,'Increase independence in participation',NULL,NULL),(1428,1505,'Leisure/Recreation Arts - General',74,'Broaden recreational activity',NULL,NULL),(1429,1505,'Leisure/Recreation Arts - General',75,'Develop preferences for a wider range of visual arts',NULL,NULL),(1430,1505,'Leisure/Recreation Arts - General',76,'Require less support in movement activities',NULL,NULL),(1431,1505,'Leisure/Recreation Arts - General',77,'Climb play apparatus',NULL,NULL),(1432,1505,'Leisure/Recreation Arts - General',78,'Ride a tricycle',NULL,NULL),(1433,1505,'Leisure/Recreation Arts - General',79,'Participate in group physical activity',NULL,NULL),(1434,1505,'Leisure/Recreation Arts - General',80,'Participate in individual physical activity',NULL,NULL),(1435,1505,'Leisure/Recreation Arts - General',81,'Play ball games requiring large muscle activity',NULL,NULL),(1436,1505,'Leisure/Recreation Arts - General',82,'Become involved in intramural activity',NULL,NULL),(1437,1505,'Leisure/Recreation Arts - General',83,'Complete simple gymnastic movements',NULL,NULL),(1438,1505,'Leisure/Recreation Arts - General',84,'Participate in games requiring small muscle control (ball throwing and catching, marbles)',NULL,NULL),(1439,1505,'Leisure/Recreation Arts - General',85,'Understand importance of fitness; become interested in fitness activity',NULL,NULL),(1440,1505,'Leisure/Recreation Arts - General',86,'Help develop group fitness plan',NULL,NULL),(1441,1505,'Leisure/Recreation Arts - General',87,'Broaden range of activities; summer sports, winter sports and individual pursuits',NULL,NULL),(1442,1505,'Leisure/Recreation Arts - General',88,'Demonstrate awareness of impact of diet on physical fitness',NULL,NULL),(1443,1505,'Leisure/Recreation Arts - General',89,'Develop individual fitness plan',NULL,NULL),(1444,1505,'Leisure/Recreation Arts - General',90,'Maintain physical fitness routine',NULL,NULL),(1445,1510,'Leisure/Recreation Arts - Expression through Drama.',1,'Imitate simple actions',NULL,NULL),(1446,1510,'Leisure/Recreation Arts - Expression through Drama.',2,'Imitate simple sounds',NULL,NULL),(1447,1510,'Leisure/Recreation Arts - Expression through Drama.',3,'Participate in dress-up activities',NULL,NULL),(1448,1510,'Leisure/Recreation Arts - Expression through Drama.',4,'Participate in symbolic play',NULL,NULL),(1449,1510,'Leisure/Recreation Arts - Expression through Drama.',5,'Imitate the actions of familiar animals',NULL,NULL),(1450,1510,'Leisure/Recreation Arts - Expression through Drama.',6,'Imitate the actions of familiar people',NULL,NULL),(1451,1510,'Leisure/Recreation Arts - Expression through Drama.',7,'Demonstrate feelings',NULL,NULL),(1452,1510,'Leisure/Recreation Arts - Expression through Drama.',8,'Role play familiar routines',NULL,NULL),(1453,1510,'Leisure/Recreation Arts - Expression through Drama.',9,'Participate in group activities',NULL,NULL),(1454,1510,'Leisure/Recreation Arts - Expression through Drama.',10,'Demonstrate actions associated with an activity',NULL,NULL),(1455,1510,'Leisure/Recreation Arts - Expression through Drama.',11,'Repeat parts of stories and verses',NULL,NULL),(1456,1510,'Leisure/Recreation Arts - Expression through Drama.',12,'Portray characters from a story or play',NULL,NULL),(1457,1510,'Leisure/Recreation Arts - Expression through Drama.',13,'Demonstrate a particular role from a story or play',NULL,NULL),(1458,1510,'Leisure/Recreation Arts - Expression through Drama.',14,'Demonstrate emotions of characters',NULL,NULL),(1459,1510,'Leisure/Recreation Arts - Expression through Drama.',15,'Participate in impromptu drama',NULL,NULL),(1460,1510,'Leisure/Recreation Arts - Expression through Drama.',16,'Take part in dramatic productions',NULL,NULL),(1461,1510,'Leisure/Recreation Arts - Expression through Drama.',17,'Demonstrate feelings and emotions',NULL,NULL),(1462,1515,'Leisure/Recreation Arts - Appreciation of Music.',1,'Respond to music by facial expression, clapping, playing simple instruments',NULL,NULL),(1463,1515,'Leisure/Recreation Arts - Appreciation of Music.',2,'Listen to music for enjoyment',NULL,NULL),(1464,1515,'Leisure/Recreation Arts - Appreciation of Music.',3,'Participate in musical games',NULL,NULL),(1465,1515,'Leisure/Recreation Arts - Appreciation of Music.',4,'Imitate rhythmic movements',NULL,NULL),(1466,1515,'Leisure/Recreation Arts - Appreciation of Music.',5,'Operate cassette recorders',NULL,NULL),(1467,1515,'Leisure/Recreation Arts - Appreciation of Music.',6,'Play more complex musical instruments',NULL,NULL),(1468,1515,'Leisure/Recreation Arts - Appreciation of Music.',7,'Participate in action songs',NULL,NULL),(1469,1515,'Leisure/Recreation Arts - Appreciation of Music.',8,'Dance',NULL,NULL),(1470,1515,'Leisure/Recreation Arts - Appreciation of Music.',9,'Move to music',NULL,NULL),(1471,1515,'Leisure/Recreation Arts - Appreciation of Music.',10,'Understand more complex rhythm patterns',NULL,NULL),(1472,1515,'Leisure/Recreation Arts - Appreciation of Music.',11,'Request partner to dance',NULL,NULL),(1473,1515,'Leisure/Recreation Arts - Appreciation of Music.',12,'Perform contemporary dance forms',NULL,NULL),(1474,1515,'Leisure/Recreation Arts - Appreciation of Music.',13,'Listen to music as a source of enjoyment',NULL,NULL),(1475,1520,'Leisure/Recreation Arts - Use the Public Library.',1,'Accompany others to library',NULL,NULL),(1476,1520,'Leisure/Recreation Arts - Use the Public Library.',2,'Select books with assistance',NULL,NULL),(1477,1520,'Leisure/Recreation Arts - Use the Public Library.',3,'Attend story time for short period',NULL,NULL),(1478,1520,'Leisure/Recreation Arts - Use the Public Library.',4,'Choose stories',NULL,NULL),(1479,1520,'Leisure/Recreation Arts - Use the Public Library.',5,'Listen attentively to story',NULL,NULL),(1480,1520,'Leisure/Recreation Arts - Use the Public Library.',6,'Select familiar books for reading',NULL,NULL),(1481,1520,'Leisure/Recreation Arts - Use the Public Library.',7,'Develop favourite categories of books',NULL,NULL),(1482,1520,'Leisure/Recreation Arts - Use the Public Library.',8,'Select books from a range of topics',NULL,NULL),(1483,1520,'Leisure/Recreation Arts - Use the Public Library.',9,'Select chapter books',NULL,NULL),(1484,1520,'Leisure/Recreation Arts - Use the Public Library.',10,'Know who the library staff are',NULL,NULL),(1485,1520,'Leisure/Recreation Arts - Use the Public Library.',11,'Select tapes, cds and videos in library',NULL,NULL),(1486,1520,'Leisure/Recreation Arts - Use the Public Library.',12,'Use public library independently',NULL,NULL),(1487,1520,'Leisure/Recreation Arts - Use the Public Library.',13,'Begin to select books about areas of personal interest',NULL,NULL),(1488,1520,'Leisure/Recreation Arts - Use the Public Library.',14,'Select library material other than books; eg. magazine or newspaper articles',NULL,NULL),(1489,1520,'Leisure/Recreation Arts - Use the Public Library.',15,'Understand responsibility for library materials',NULL,NULL),(1490,1520,'Leisure/Recreation Arts - Use the Public Library.',16,'Understand fines for overdue/lost material',NULL,NULL),(1491,1520,'Leisure/Recreation Arts - Use the Public Library.',17,'Know about and use other libraries',NULL,NULL),(1492,1525,'Leisure/Recreation Arts - Participate in Arts and Crafts.',1,'Explore a variety of media such as paints, markers, chalk or fingerpaint',NULL,NULL),(1493,1525,'Leisure/Recreation Arts - Participate in Arts and Crafts.',2,'Explore glueing with a variety of collage materials',NULL,NULL),(1494,1525,'Leisure/Recreation Arts - Participate in Arts and Crafts.',3,'Draw simple pictures with representation; e. g. , face, house, car, tree',NULL,NULL),(1495,1525,'Leisure/Recreation Arts - Participate in Arts and Crafts.',4,'Imitate simple crafts using cutting and gluing',NULL,NULL),(1496,1525,'Leisure/Recreation Arts - Participate in Arts and Crafts.',5,'Use craft materials creatively or to copy a model',NULL,NULL),(1497,1525,'Leisure/Recreation Arts - Participate in Arts and Crafts.',6,'Choose from several projects to make a craft',NULL,NULL),(1498,1525,'Leisure/Recreation Arts - Participate in Arts and Crafts.',7,'Follow several simple illustrated steps to complete a craft',NULL,NULL),(1499,1525,'Leisure/Recreation Arts - Participate in Arts and Crafts.',8,'Complete a project over time',NULL,NULL),(1500,1525,'Leisure/Recreation Arts - Participate in Arts and Crafts.',9,'Develop interest in one or more arts or crafts activities which can be done independently as an enjoyable leisure activity',NULL,NULL),(1501,1525,'Leisure/Recreation Arts - Participate in Arts and Crafts.',10,'Participate in arts and crafts activities sponsored by community organizations',NULL,NULL),(1503,1399,'Social Development',13,'Begin to recognize roles of others in community',NULL,NULL),(2959,200,'Gross Motor Development',43,'Gallop for 4 meters',NULL,NULL),(2960,200,'Gross Motor Development',54,'Jump down from height of 30cm',NULL,NULL),(1505,1399,'Social Development',8,'Communicate needs more clearly',NULL,NULL),(2958,200,'Gross Motor Development',40,'Run on tiptoes 4 meters',NULL,NULL),(2955,200,'Gross Motor Development',13,'Climb on low furniture',NULL,NULL),(1508,1399,'Social Development',10,'Use appropriate language to ask for services (from clerks, food servers)',NULL,NULL),(2992,1104,'Extending Spelling Skills',23,'Spell words with /QU/',NULL,NULL),(2966,200,'Gross Motor Development',80,'Bounce and catch playground ball 3 times with both hands',NULL,NULL),(2965,200,'Gross Motor Development',73,'Kick playground ball when ball is rolled',NULL,NULL),(1512,1399,'Social Development',45,'Settle disputes and disagreements in an acceptable manner',NULL,NULL),(1513,1399,'Social Development',44,'Offer to help others',NULL,NULL),(2964,200,'Gross Motor Development',66,'Swing using independent pumping motion',NULL,NULL),(2962,200,'Gross Motor Development',64,'Slide down on slide',NULL,NULL),(2963,200,'Gross Motor Development',65,'Position self on swing',NULL,NULL),(1516,1402,'Safety and Health Development',61,'Obey walk, wait, do not walk',NULL,NULL),(1517,1402,'Safety and Health Development',62,'Obey stop signal',NULL,NULL),(1518,1402,'Safety and Health Development',63,'Know meaning of  block parent',NULL,NULL),(1519,1402,'Safety and Health Development',64,'Recognize warning sign at railway crossing',NULL,NULL),(1520,1402,'Safety and Health Development',65,'Respond to supervision',NULL,NULL),(1521,1402,'Safety and Health Development',66,'Identify safe places to play',NULL,NULL),(1522,1402,'Safety and Health Development',67,'Seek help when needed',NULL,NULL),(1523,1402,'Safety and Health Development',68,'Obey buckle up sign or command',NULL,NULL),(1524,1402,'Safety and Health Development',69,'Demonstrate safe use of play equipment, objects and materials',NULL,NULL),(1525,1402,'Safety and Health Development',70,'Recognize and understand warning and safety signs; eg. poison, explosives, flammable, fire exit, keep out, exit only',NULL,NULL),(1526,1402,'Safety and Health Development',71,'Recognize and respond appropriately to warning signals: eg.  fire alarm, sirens, smoke alarms',NULL,NULL),(1527,1402,'Safety and Health Development',72,'Recognize emergency exits',NULL,NULL),(1528,1402,'Safety and Health Development',73,'Expand knowledge of safety associated with facilities (swimming pool, skating rink)',NULL,NULL),(1529,1402,'Safety and Health Development',74,'Know how to use 911',NULL,NULL),(1530,1402,'Safety and Health Development',75,'Care for minor injuries',NULL,NULL),(1531,1402,'Safety and Health Development',76,'Manage personal medication',NULL,NULL),(1532,1402,'Safety and Health Development',77,'Know how to set off fire alarm',NULL,NULL),(1533,1402,'Safety and Health Development',78,'Demonstrate safe riding practices',NULL,NULL),(1534,1402,'Safety and Health Development',79,'Know how to set off fire alarm',NULL,NULL),(1535,1402,'Safety and Health Development',80,'Demonstrate safe riding practices',NULL,NULL),(1536,1402,'Safety and Health Development',81,'Know sources of help in emergency situations (block parent, police, bus driver, neighbours)',NULL,NULL),(1537,1402,'Safety and Health Development',82,'Develop a home plan for fire safety',NULL,NULL),(1538,1402,'Safety and Health Development',83,'Recognize consequences of not obeying safety rules',NULL,NULL),(1539,1402,'Safety and Health Development',84,'Recognize dangers to personal safety',NULL,NULL),(1540,1402,'Safety and Health Development',85,'Know first aid procedures',NULL,NULL),(1541,1402,'Safety and Health Development',86,'Understand antidotes for hazardous products',NULL,NULL),(1542,1402,'Safety and Health Development',87,'Alert others of danger',NULL,NULL),(1543,1402,'Safety and Health Development',88,'Recognize importance of keeping equipment in good operating order',NULL,NULL),(1544,1402,'Safety and Health Development',89,'Know how to travel safely on public transportation',NULL,NULL),(1545,1402,'Safety and Health Development',90,'Teach first aid procedures to others',NULL,NULL),(1546,1402,'Safety and Health Development',91,'Understand first aid associated with hazardous products',NULL,NULL),(1547,1402,'Safety and Health Development',92,'Recognize dangerous goods routes',NULL,NULL),(1548,1615,'Use Services available in the Community.',1,'Accompany responsible adults to service outlets in the community',NULL,NULL),(1549,1615,'Use Services available in the Community.',2,'Visit health clinic with responsible adult',NULL,NULL),(1550,1615,'Use Services available in the Community.',3,'Attend story time at public library',NULL,NULL),(1551,1615,'Use Services available in the Community.',4,'Accompany others on public transportation',NULL,NULL),(1552,1615,'Use Services available in the Community.',5,'Deposit letter to be mailed in mail box',NULL,NULL),(1553,1615,'Use Services available in the Community.',6,'Purchase stamps at post office outlet',NULL,NULL),(1554,1615,'Use Services available in the Community.',7,'Mail letter at post office',NULL,NULL),(1555,1615,'Use Services available in the Community.',8,'Meet with school nurse and other medical professionals at school',NULL,NULL),(1556,1615,'Use Services available in the Community.',9,'Associate services available with location',NULL,NULL),(1557,1615,'Use Services available in the Community.',10,'Wait in line for service',NULL,NULL),(1558,1615,'Use Services available in the Community.',11,'Sign out selections at public library',NULL,NULL),(1559,1615,'Use Services available in the Community.',12,'Associate staff role with community service',NULL,NULL),(1560,1615,'Use Services available in the Community.',13,'Ask for help from community service personnel',NULL,NULL),(1561,1615,'Use Services available in the Community.',14,'Use designated change rooms in public athletic facilities',NULL,NULL),(1562,1615,'Use Services available in the Community.',15,'Follow current events in community paper',NULL,NULL),(1563,1615,'Use Services available in the Community.',16,'Use public library independently',NULL,NULL),(1564,1615,'Use Services available in the Community.',17,'Use change rooms independently',NULL,NULL),(1565,1615,'Use Services available in the Community.',18,'Distinguish between recreational activity and services related to personal health and welfare',NULL,NULL),(1566,1615,'Use Services available in the Community.',19,'Locate and use banking services',NULL,NULL),(1567,1615,'Use Services available in the Community.',20,'Mail parcels at post office outlet',NULL,NULL),(1568,1615,'Use Services available in the Community.',21,'Know from whom to seek information about the community',NULL,NULL),(1569,1615,'Use Services available in the Community.',22,'Use community services independently',NULL,NULL),(1570,1615,'Use Services available in the Community.',23,'Evaluate services provided',NULL,NULL),(1571,1615,'Use Services available in the Community.',24,'Use delivery service of post office',NULL,NULL),(1572,1615,'Use Services available in the Community.',25,'Consult doctor when necessary',NULL,NULL),(1573,1615,'Use Services available in the Community.',26,'Establish medical check-up routine',NULL,NULL),(1574,1620,'Knowing how to travel in the community.',1,'Differentiate between vehicles',NULL,NULL),(1575,1620,'Knowing how to travel in the community.',2,'Move about house, yard and school yard',NULL,NULL),(1576,1620,'Knowing how to travel in the community.',3,'Practice safety rules',NULL,NULL),(1577,1620,'Knowing how to travel in the community.',4,'Demonstrate understanding of directional terms - right, left, forward, back',NULL,NULL),(1578,1620,'Knowing how to travel in the community.',5,'Know name, address, phone number; how to use emergency services',NULL,NULL),(1579,1620,'Knowing how to travel in the community.',6,'Respond to travel commands: eg. , no standing',NULL,NULL),(1580,1620,'Knowing how to travel in the community.',7,'Recognize familiar destinations',NULL,NULL),(1581,1620,'Knowing how to travel in the community.',8,'Know safety rules associated with travel',NULL,NULL),(1582,1620,'Knowing how to travel in the community.',9,'Travel throughout the community with increasing independence',NULL,NULL),(1583,1620,'Knowing how to travel in the community.',10,'Relate mode of transpiration to planned journey',NULL,NULL),(1584,1620,'Knowing how to travel in the community.',11,'Recognize payment required for some forms of transportation',NULL,NULL),(1585,1620,'Knowing how to travel in the community.',12,'Operate traffic safety equipment',NULL,NULL),(1586,1620,'Knowing how to travel in the community.',13,'Identify own school bus',NULL,NULL),(1587,1620,'Knowing how to travel in the community.',14,'Cross street independently',NULL,NULL),(1588,1620,'Knowing how to travel in the community.',15,'Know when to refuse rides',NULL,NULL),(1589,1620,'Knowing how to travel in the community.',16,'Understand safety habits associated with riding a bike',NULL,NULL),(1590,1620,'Knowing how to travel in the community.',17,'Follow travel schedule; be at pick-up points on time',NULL,NULL),(1591,1620,'Knowing how to travel in the community.',18,'Respond correctly to traffic signals',NULL,NULL),(1592,1620,'Knowing how to travel in the community.',19,'Know how to seek assistance while travelling',NULL,NULL),(1593,1620,'Knowing how to travel in the community.',20,'Know route between home, school, familiar places',NULL,NULL),(1594,1620,'Knowing how to travel in the community.',21,'Travel independently throughout the community',NULL,NULL),(1595,1620,'Knowing how to travel in the community.',22,'Participate in driver training program',NULL,NULL),(1596,1620,'Knowing how to travel in the community.',23,'Use public transportation system',NULL,NULL),(1597,1620,'Knowing how to travel in the community.',24,'Understand the safety habits associated with driving a vehicle',NULL,NULL),(1598,1625,'Knowing how to order food in a restaurant.',1,'Indicate food choices',NULL,NULL),(1599,1625,'Knowing how to order food in a restaurant.',2,'Stand in line with others',NULL,NULL),(1600,1625,'Knowing how to order food in a restaurant.',3,'Deposit used food containers in supplied garbage bins',NULL,NULL),(1601,1625,'Knowing how to order food in a restaurant.',4,'Know different types of restaurants',NULL,NULL),(1602,1625,'Knowing how to order food in a restaurant.',5,'Verbalize food choices',NULL,NULL),(1603,1625,'Knowing how to order food in a restaurant.',6,'Select and order food choices independently',NULL,NULL),(1604,1625,'Knowing how to order food in a restaurant.',7,'Understand payment required',NULL,NULL),(1605,1625,'Knowing how to order food in a restaurant.',8,'Select and obtain food items from vending machine',NULL,NULL),(1606,1625,'Knowing how to order food in a restaurant.',9,'Make alternate choices if preference not available',NULL,NULL),(1607,1625,'Knowing how to order food in a restaurant.',10,'Wait in line and follow line independently',NULL,NULL),(1608,1625,'Knowing how to order food in a restaurant.',11,'Accompany peers to fast food outlet',NULL,NULL),(1609,1625,'Knowing how to order food in a restaurant.',12,'Select, order, pay for fast food',NULL,NULL),(1610,1625,'Knowing how to order food in a restaurant.',13,'Select broader range of good outlets to visit',NULL,NULL),(1611,1625,'Knowing how to order food in a restaurant.',14,'Evaluate outlets',NULL,NULL),(1612,1625,'Knowing how to order food in a restaurant.',15,'Have food preferences',NULL,NULL),(1613,1625,'Knowing how to order food in a restaurant.',16,'Order a complete meal in restaurant',NULL,NULL),(1614,1630,'Demonstrate environmental awareness.',1,'Recognize plants and animals in the community',NULL,NULL),(1615,1630,'Demonstrate environmental awareness.',2,'Dispose of litter in proper container',NULL,NULL),(1616,1630,'Demonstrate environmental awareness.',3,'Develop understanding of weather and climate',NULL,NULL),(1617,1630,'Demonstrate environmental awareness.',4,'Develop understanding of effect of weather and climate on safety and planned activities',NULL,NULL),(1618,1630,'Demonstrate environmental awareness.',5,'Recognize natural land forms',NULL,NULL),(1619,1630,'Demonstrate environmental awareness.',6,'Identify and dispose of litter',NULL,NULL),(1620,1630,'Demonstrate environmental awareness.',7,'Participate in school recycling projects',NULL,NULL),(1621,1630,'Demonstrate environmental awareness.',8,'Specify use for leftovers',NULL,NULL),(1622,1630,'Demonstrate environmental awareness.',9,'Recognize a variety of litter containers',NULL,NULL),(1623,1630,'Demonstrate environmental awareness.',10,'Identify excessive use of energy (lights left on, equipment left running)',NULL,NULL),(1624,1630,'Demonstrate environmental awareness.',11,'Understand overuse threatens plants, animals and energy sources',NULL,NULL),(1625,1630,'Demonstrate environmental awareness.',12,'Understand people have control over the use of energy sources',NULL,NULL),(1626,1630,'Demonstrate environmental awareness.',13,'Generalize understanding of conservation',NULL,NULL),(1627,1630,'Demonstrate environmental awareness.',14,'Practice conservation in personal life',NULL,NULL),(1628,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',1,'Complete simple tasks',NULL,NULL),(1629,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',2,'Carry out assigned classroom or in-school tasks',NULL,NULL),(1630,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',3,'Complete task within a given time frame',NULL,NULL),(1631,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',4,'Adapt to requirements of new tasks',NULL,NULL),(1632,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',5,'Demonstrate a positive attitude about tasks',NULL,NULL),(1633,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',6,'Be consistent in the performance of routine tasks',NULL,NULL),(1634,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',7,'Accept direction',NULL,NULL),(1635,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',8,'Develop the habit of punctuality',NULL,NULL),(1636,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',9,'Carry out assigned in-school tasks',NULL,NULL),(1637,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',10,'Recognize the relationship between work and earnings',NULL,NULL),(1638,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',11,'Approach new tasks willingly',NULL,NULL),(1639,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',12,'Consider tools and equipment needed for tasks',NULL,NULL),(1640,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',13,'Self-evaluate selected task performances',NULL,NULL),(1641,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',14,'Maintain specified levels of quality in assigned tasks',NULL,NULL),(1642,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',15,'Observe safety rules',NULL,NULL),(1643,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',16,'Maintain satisfactory personal appearance',NULL,NULL),(1644,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',17,'Visit potential work sites',NULL,NULL),(1645,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',18,'Identify appropriate work-site behaviors',NULL,NULL),(1646,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',19,'Learn vocabulary of a variety of occupations',NULL,NULL),(1647,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',20,'Role play occupation interviews',NULL,NULL),(1648,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',21,'Complete an off-campus experience placement',NULL,NULL),(1649,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',22,'Demonstrate appropriate interpersonal skills in work environments',NULL,NULL),(1650,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',23,'Develop a personal resume',NULL,NULL),(1651,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',24,'Complete applications for selected occupations',NULL,NULL),(1652,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',25,'Complete a real or simulated occupation interview',NULL,NULL),(1653,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',26,'Use the telephone in occupation search',NULL,NULL),(1654,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',27,'Read and interpret help wanted advertisements',NULL,NULL),(1655,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',28,'Evaluate and apply for occupational benefits',NULL,NULL),(1656,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',29,'Become aware of legal rights of employees',NULL,NULL),(1657,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',30,'Understand meaning of income tax',NULL,NULL),(1658,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',31,'Complete income tax return with assistance',NULL,NULL),(1659,1705,'Identify and Demonstrate selected Competencies needed by the World of Work.',32,'Read and comprehend payroll deduction statements',NULL,NULL),(1660,1710,'Identify Alternative Career Paths and Plan for a Career.',1,'Approach simple tasks with direction',NULL,NULL),(1661,1710,'Identify Alternative Career Paths and Plan for a Career.',2,'Comply with simple direction',NULL,NULL),(1662,1710,'Identify Alternative Career Paths and Plan for a Career.',3,'Be aware of family members work',NULL,NULL),(1663,1710,'Identify Alternative Career Paths and Plan for a Career.',4,'Recognize that different occupations require different skills',NULL,NULL),(1664,1710,'Identify Alternative Career Paths and Plan for a Career.',5,'Describe occupations of family members',NULL,NULL),(1665,1710,'Identify Alternative Career Paths and Plan for a Career.',6,'Describe competencies required in particular occupations',NULL,NULL),(1666,1710,'Identify Alternative Career Paths and Plan for a Career.',7,'Identify jobs of interest',NULL,NULL),(1667,1710,'Identify Alternative Career Paths and Plan for a Career.',8,'Obtain information about jobs of interest; eg.  entry-level requirements, wage rates',NULL,NULL),(1668,1710,'Identify Alternative Career Paths and Plan for a Career.',9,'Identify own interests and aptitudes',NULL,NULL),(1669,1710,'Identify Alternative Career Paths and Plan for a Career.',10,'Recognize own strengths and limitations in relation to occupation requirements',NULL,NULL),(1670,1710,'Identify Alternative Career Paths and Plan for a Career.',11,'Identify a job of interest that is commensurate with interest and abilities',NULL,NULL),(1671,1710,'Identify Alternative Career Paths and Plan for a Career.',12,'Seek work experience to support occupation interest',NULL,NULL),(1672,1710,'Identify Alternative Career Paths and Plan for a Career.',13,'Perform volunteer tasks',NULL,NULL),(1673,1710,'Identify Alternative Career Paths and Plan for a Career.',14,'Develop a career portfolio containing interests, aptitudes and evidence of career exploration',NULL,NULL),(1676,1801,'Study and Work Skills',1,'Use words associated with time of day (morning, night, afternoon)',NULL,NULL),(1677,1801,'Study and Work Skills',2,'Respond to time signals at school',NULL,NULL),(1678,1801,'Study and Work Skills',7,'Plan free time activity',NULL,NULL),(1679,1801,'Study and Work Skills',12,'Sequence steps in simple routines',NULL,NULL),(1680,1801,'Study and Work Skills',3,'Know importance of being on time',NULL,NULL),(1681,1801,'Study and Work Skills',4,'Tell time using digital clock',NULL,NULL),(1683,1801,'Study and Work Skills',11,'Complete tasks in assigned time',NULL,NULL),(1684,1801,'Study and Work Skills',21,'Help develop classroom schedule',NULL,NULL),(1685,1801,'Study and Work Skills',16,'Attend to tasks',NULL,NULL),(1686,1801,'Study and Work Skills',20,'Manage requests that results in time conflicts',NULL,NULL),(1687,1801,'Study and Work Skills',5,'Tell time from analogue watch',NULL,NULL),(1688,1801,'Study and Work Skills',8,'Prepare personal time schedule',NULL,NULL),(1689,1801,'Study and Work Skills',6,'Budget time for activities',NULL,NULL),(1690,1801,'Study and Work Skills',9,'Complete time sheet',NULL,NULL),(1691,1801,'Study and Work Skills',22,'Bring necessary materials for class.',NULL,NULL),(1693,1801,'Study and Work Skills',23,'Keep a tidy desk or locker',NULL,NULL),(1696,1801,'Study and Work Skills',25,'Remember test dates and due dates for assignments',NULL,NULL),(1698,1801,'Study and Work Skills',13,'Follow oral instructions',NULL,NULL),(1699,1801,'Study and Work Skills',14,'Follow written directions',NULL,NULL),(1700,1801,'Study and Work Skills',15,'Stay on task',NULL,NULL),(1701,1801,'Study and Work Skills',27,'Use some of the test taking strategies',NULL,NULL),(1702,1801,'Study and Work Skills',26,'Set aside time to complete homework',NULL,NULL),(1707,1401,'Personal Development',101,'Will decrease explosive outbursts',NULL,NULL),(1708,1401,'Personal Development',102,'Will find a safe place when feeling explosive.',NULL,NULL),(1709,1505,'Leisure/Recreation Arts - General',91,'Engage in competitive games and remain calm.',NULL,NULL),(1710,110,'Language - Expressive',27,'answer appropriately using yes or no',NULL,NULL),(1711,110,'Language - Expressive',28,'talk using appropriate volume',NULL,NULL),(2686,8035,'Number Facts- Multiplication',3,'Will correctly compute the product, when given ten multiplication facts, for the multipliers up to 4.',NULL,NULL),(2832,8080,'Decimals',14,'When given ten problems requiring the multiplication of decimals, will correctly compute the answers for multiplying decimals with whole numbers times tenths.',NULL,NULL),(1719,300,'Fine Motor Control',89,'Handwrite first and last name legibly',NULL,NULL),(1720,400,'Cognitive Development',11,' Complete a 5-8 piece puzzle.',NULL,NULL),(2884,8090,'Measurement',9,'When given 5 pairs of metric measurement, will indicate if each pair is of equal value or if one of the measurements is of greater value for mass units.',NULL,NULL),(2922,8065,'Fractions',23,'When given five problems requiring subtraction of fractions and/or mixed numbers, will correctly compute the answers by subtracting unlike fractions.',NULL,NULL),(1729,300,'Fine Motor Control',96,'Correctly locate keys on the keyboard and copy a message.',NULL,NULL),(1730,1402,'Safety and Health Development',59,' Recognize exits',NULL,NULL),(1731,1402,'Safety and Health Development',60,' Recognize bathrooms',NULL,NULL),(2748,1399,'Social Development',53,'Student will cooperate willingly with appropriate peer requests.',NULL,NULL),(1735,174,'Additional Vocabulary',8,' Receptive: student will identify contours:flat,straight, incline/decline, curved, crooked',NULL,NULL),(1736,174,'Additional Vocabulary',9,' Expressive: student will demonstrate knowledge of contours:flat,straight, incline/decline, curved, crooked',NULL,NULL),(2770,8070,'Time',3,'Will be able to count by fives to sixty.',NULL,NULL),(1744,174,'Additional Vocabulary',10,' Receptive: student will identify(point) amount concepts (all/ none, more,  empty/full,  half/whole)',NULL,NULL),(1745,174,'Additional Vocabulary',11,'Expressive: student will demonstrate knowledge of amount concepts (all/ none, more,  empty/full,  half/whole)',NULL,NULL),(2769,8070,'Time',2,'Will be able to identify numbers 1-12.',NULL,NULL),(1748,174,'Additional Vocabulary',12,' Receptive: student will identify concepts:close/farther,to the driveway, one city block, across the room/down the hall, across the yard/street, millimeters, centimeters, meters',NULL,NULL),(1749,174,'Additional Vocabulary',13,' Expressive: student will demonstrate knowledge of concepts:close/farther,to the driveway, one city block, across the room/down the hall, across the yard/street, millimeters, centimeters, meters',NULL,NULL),(2989,1104,'Extending Spelling Skills',20,'Spell words with vowel digraphs, ui, ai, ou, oa',NULL,NULL),(2980,1104,'Extending Spelling Skills',11,'Spell words with digraphs, ay, oo, ee, ea, ow',NULL,NULL),(2981,1104,'Extending Spelling Skills',12,'Spell words with vowel sounds controlled by r, er, or, r, ur, ar',NULL,NULL),(1754,174,'Additional Vocabulary',14,' Receptive: student will identify inside concepts:walls, ceilings, floors,carpet, linoleum, rugs,curtains, stairs, escalators, elevators',NULL,NULL),(1755,174,'Additional Vocabulary',15,'Receptive: student will identify inside concepts: walls, ceilings, floors,carpet, linoleum, rugs,curtains, stairs, escalators, elevators',NULL,NULL),(1756,174,'Additional Vocabulary',16,' Receptive: student will identify outside concepts:sidewalks, streets, driveways, corners, curbs, railings, bridges, ramps, asphalt, dirt, grass, signs, symbols, street names',NULL,NULL),(1757,174,'Additional Vocabulary',17,' Receptive: student will identify outside concepts:sidewalks, streets, driveways, corners, curbs, railings, bridges, ramps, asphalt, dirt, grass, signs, symbols, street names',NULL,NULL),(2831,8080,'Decimals',13,'When given ten problems requiring the subraction of decimals, will correctly compute the answers for subtracting decimals with hundredths and thousands.',NULL,NULL),(2830,8080,'Decimals',12,'When given ten problems requiring the subraction of decimals, will correctly compute the answers for subtracting decimals with thousandths.',NULL,NULL),(2709,8050,'Subtraction',1,'Will correctly compute the answers, when given ten subtraction problems, for subracting numbers with 2 digits without regrouping.',NULL,NULL),(2829,8080,'Decimals',11,'When given ten problems requiring the subraction of decimals, will correctly compute the answers for subtracting decimals with tenths and hundredths.',NULL,NULL),(1768,2000,'Olfactory Identification',1,' Identify smells',NULL,NULL),(1769,2000,'Olfactory Identification',2,' Interpret smells',NULL,NULL),(1770,2000,'Olfactory Identification',3,' Localize smells',NULL,NULL),(1771,2000,'Olfactory Identification',4,' Categorize smells',NULL,NULL),(1772,2000,'Olfactory Identification',5,' Discriminate smells',NULL,NULL),(1773,1401,'Personal Development',99,' advocate for self when they can not hear properly.',NULL,NULL),(1774,1401,'Personal Development',100,' advocate for self when they can not see properly.',NULL,NULL),(2085,3000,'AEP English',7,' Practice the behaviours of effective speakers',NULL,NULL),(2086,3000,'AEP English',8,' Speak fluently and confidently in a variety of situations for a variety of audiences.',NULL,NULL),(2087,3000,'AEP English',9,' Use the writing process and develop ideas previously explored into draft form.',NULL,NULL),(2088,3000,'AEP English',10,' Use appropriate prewriting and planning strategies.',NULL,NULL),(2089,3000,'AEP English',11,' Revise and share compositions.',NULL,NULL),(2090,3000,'AEP English',12,' Identify subject and verb in a simple sentence pattern to determine whether sentence makes a complete thought.',NULL,NULL),(2091,3000,'AEP English',13,' Use the period and question mark correctly.',NULL,NULL),(2092,3000,'AEP English',14,' Capitalize proper nouns and the intitial word of each sentence.',NULL,NULL),(2093,3000,'AEP English',15,' Utilize reference materials such as  a dictionary, encyclopedia, CD ROM, and internet.',NULL,NULL),(1838,3100,'AEP Mathematics',8,' Time18 Locate a date on the calendar. ',NULL,NULL),(1837,3100,'AEP Mathematics',7,' Time18 Identify present day, month and year.',NULL,NULL),(1835,3100,'AEP Mathematics',5,' Time18 Tell time to the hour and half hour using the analog clock.',NULL,NULL),(1834,3100,'AEP Mathematics',4,' Time18 Recognize the difference between am and pm.',NULL,NULL),(1832,3100,'AEP Mathematics',2,' Graphing18 Will read and interpret a variety of tables and graphs.',NULL,NULL),(1836,3100,'AEP Mathematics',6,' Time18 Tell time to the hour and half hour using the digital clock.',NULL,NULL),(1833,3100,'AEP Mathematics',3,' Graphing18 Use ordered pairs in the Cartesian Coordinate.',NULL,NULL),(2096,3000,'AEP English',18,' Understand the factors that interfere with good listening for example distractions.',NULL,NULL),(2097,3000,'AEP English',19,' Recognize and recall main and supporting ideas in presentations.',NULL,NULL),(2084,3000,'AEP English',6,' Recognize that talk is an important tool for communicating, thinking, and learning.',NULL,NULL),(2082,3000,'AEP English',4,' Read a variety of texts for a variety of purposes.',NULL,NULL),(2083,3000,'AEP English',5,' Relate literary experience to real life experiences.',NULL,NULL),(2079,3000,'AEP English',1,' English  A18 and B18- Increase their level of reading enjoyment by reading materials appropriate to their independent or instructional level.',NULL,NULL),(2080,3000,'AEP English',2,' Identify the main idea of material read.',NULL,NULL),(2081,3000,'AEP English',3,' Recall detail from material read.',NULL,NULL),(1839,3100,'AEP Mathematics',9,' Time18 Identify the four seasons.',NULL,NULL),(1840,3100,'AEP Mathematics',10,' Time18 Identify holidays with a season and a date. ',NULL,NULL),(1841,3100,'AEP Mathematics',11,' Time18 Write dates in a variety of ways.',NULL,NULL),(1842,3100,'AEP Mathematics',12,' Time28 Read timetables and plan a schedule.',NULL,NULL),(1843,3100,'AEP Mathematics',13,' Time28 Read a TV schedule, sports schedule.',NULL,NULL),(1844,3100,'AEP Mathematics',14,' Time28 Read conference or training schedules to learn locations, times and topics.',NULL,NULL),(1845,3100,'AEP Mathematics',15,' Time28 Read a transportation schedule for a bus, plane,etc.',NULL,NULL),(1846,3100,'AEP Mathematics',16,' Time28 Tell time to the nearest 5 minutes.',NULL,NULL),(1847,3100,'AEP Mathematics',17,' Time28 Understand the concept of half past, quarter after and quarter to.',NULL,NULL),(1848,3100,'AEP Mathematics',18,' Time28 Calculate the passage of time.',NULL,NULL),(1849,3100,'AEP Mathematics',19,' Time28 Use an agenda book to record important dates, appointments,etc.',NULL,NULL),(1850,3100,'AEP Mathematics',20,' Time28 Identify the current century.',NULL,NULL),(1851,3100,'AEP Mathematics',21,' Time38 Identify equivalents of time.',NULL,NULL),(1852,3100,'AEP Mathematics',22,' Time38 Define the terms, annually,semiannually,quarterly.',NULL,NULL),(1853,3100,'AEP Mathematics',23,' Money18 Identify names and values of coins and bills up to twenty dollars.',NULL,NULL),(1854,3100,'AEP Mathematics',24,' Money18 Use the next dollar strategy to pay for an item. ',NULL,NULL),(1855,3100,'AEP Mathematics',25,' Money18 Count coins up to one dollar.',NULL,NULL),(1856,3100,'AEP Mathematics',26,' Money18 Determine on which items GST is charged. ',NULL,NULL),(1857,3100,'AEP Mathematics',27,' Money18 Determine cost of purchasing several items. ',NULL,NULL),(1858,3100,'AEP Mathematics',28,' Money18 Determine lower priced item.',NULL,NULL),(1859,3100,'AEP Mathematics',29,' Money28 Name the value of all Canadian coins and bills.',NULL,NULL),(1860,3100,'AEP Mathematics',30,' Money28 Count coins up to $10.00.',NULL,NULL),(1861,3100,'AEP Mathematics',31,' Money28 Count bills and coins up to $100.00.',NULL,NULL),(1862,3100,'AEP Mathematics',32,' Money28 Give equivalent amounts of money in a variety of coins and bills.',NULL,NULL),(1863,3100,'AEP Mathematics',33,' Money28 Make change for $1.00, $2.00 and $10.00.',NULL,NULL),(1864,3100,'AEP Mathematics',34,' Money38 Count bills and coins up to $1000.00.',NULL,NULL),(1865,3100,'AEP Mathematics',35,' Money38 Estimate the cost of a multi-item purchase.',NULL,NULL),(1866,3100,'AEP Mathematics',36,' Money38 Calculate the cost of multiple purchases.',NULL,NULL),(1867,3100,'AEP Mathematics',37,' Money38 Determine best price by accounting for the size of item.',NULL,NULL),(1868,3100,'AEP Mathematics',38,' Income18 Calculate daily and weekly wages involving regular pay. ',NULL,NULL),(1869,3100,'AEP Mathematics',39,' Income18 To determine the difference between gross pay and net pay by calculating deductions using CPP, EI and tax tables.',NULL,NULL),(1870,3100,'AEP Mathematics',40,' Income38 Identify types of taxes and their purpose.',NULL,NULL),(1871,3100,'AEP Mathematics',41,' Income38 Become familiar with filing income tax.',NULL,NULL),(1872,3100,'AEP Mathematics',42,' Budget18 Define and explain the purpose of a budget.',NULL,NULL),(1873,3100,'AEP Mathematics',43,' Budget18 Determine fixed and variable expenses for the month.',NULL,NULL),(1874,3100,'AEP Mathematics',44,' Budget18 To plan a budget based on percentages allotted to various categories as suggested by financial institutions. ',NULL,NULL),(1875,3100,'AEP Mathematics',45,' Budget18 To stay within a budget or adjust a budget as necessary.',NULL,NULL),(1876,3100,'AEP Mathematics',46,' Banking18 Write numbers in written words. ',NULL,NULL),(1877,3100,'AEP Mathematics',47,' Banking18 Complete bank forms,withdrawal slips and deposit slips.',NULL,NULL),(1878,3100,'AEP Mathematics',48,' Banking28 Know definitions for banking terms, interest,deposit,overdraft,withdrawal,service charge,traveller\'s check,balance,NSF,debit,credit.',NULL,NULL),(1879,3100,'AEP Mathematics',49,' Banking28 Know the different types of accounts.',NULL,NULL),(1880,3100,'AEP Mathematics',50,' Banking28 Write a cheque and know how to cash it.',NULL,NULL),(1881,3100,'AEP Mathematics',51,' Banking28 Know how to use an ATM and a debit card.',NULL,NULL),(1882,3100,'AEP Mathematics',52,' Banking28 Balance a checkbook with opening balance, cheques and deposits.',NULL,NULL),(1883,3100,'AEP Mathematics',53,' Banking28 Calculate simple interest using a calculator.',NULL,NULL),(1884,3100,'AEP Mathematics',54,' Banking28 Define credit and understand the concept of a good credit rating.',NULL,NULL),(1885,3100,'AEP Mathematics',55,' Banking28 Find the monthly interest charges and service charges on an unpaid credit balance.',NULL,NULL),(1886,3100,'AEP Mathematics',56,' Banking28 Identify and compare an installment charge account and a 30 day account.',NULL,NULL),(1887,3100,'AEP Mathematics',57,' Banking38 Reconcile a bank statement.',NULL,NULL),(1888,3100,'AEP Mathematics',58,' Banking38 Identify and compare various methods of bill payment.',NULL,NULL),(1889,3100,'AEP Mathematics',59,' Banking38 Compare simple and compound interest.',NULL,NULL),(1890,3100,'AEP Mathematics',60,' Banking38 Complete a loan application form and learn procedure for applying for a loan.',NULL,NULL),(1891,3100,'AEP Mathematics',61,' Banking38 Become aware of investment possibilities - RRSPs, Mutuals.',NULL,NULL),(1892,3100,'AEP Mathematics',62,' Geometry18 Identify geometric shapes',NULL,NULL),(1893,3100,'AEP Mathematics',63,' Measurement18 Tell/show size of these basic measurements, 1mm, 1cm and 1m.',NULL,NULL),(1894,3100,'AEP Mathematics',64,' Measurement18 Measure using a ruler, tape lengths in metres and centimeters or both. ',NULL,NULL),(1895,3100,'AEP Mathematics',65,' Measurement18 Understand the difference between inches and cm and know places where inches are used.',NULL,NULL),(1896,3100,'AEP Mathematics',66,' Measurement18 Measure using inches and fractions of inches.',NULL,NULL),(1897,3100,'AEP Mathematics',67,' Measurement28 Read a thermometer.',NULL,NULL),(1898,3100,'AEP Mathematics',68,' Measurement28 Know temperatures relating to common activities. ',NULL,NULL),(1899,3100,'AEP Mathematics',69,' Measurement28 Use a chart to find and understand the signifigance of windchill.',NULL,NULL),(1900,3100,'AEP Mathematics',70,' Measurement38 Estimate linear measurements with an adequate degree of accuracy.',NULL,NULL),(1901,3100,'AEP Mathematics',71,' Measurement38 Estimate distances within an urban/rural setting.',NULL,NULL),(1902,3100,'AEP Mathematics',72,' Measurement38 Estimate mass measurement with an adequate degree of accuracy.',NULL,NULL),(1903,3100,'AEP Mathematics',73,' Numeration18 Read numerals 1 to 100,000.',NULL,NULL),(1904,3100,'AEP Mathematics',74,' Numeration18 Hear a number and write the numeral.',NULL,NULL),(1905,3100,'AEP Mathematics',75,' Numeration18 Recognize a decimal number and be able to give its value to the nearest whole number. ',NULL,NULL),(1906,3100,'AEP Mathematics',76,' Numeration18 Compare numbers and decide which is largest and smallest. ',NULL,NULL),(1907,3100,'AEP Mathematics',77,' Numeration28 Recognize and write numerals from 1 to 1,000,000.',NULL,NULL),(1908,3100,'AEP Mathematics',78,' Numeration28 Recognize and write a decimal number to the thousandths place. ',NULL,NULL),(1909,3100,'AEP Mathematics',79,' Numeration28 Compare and order numbers from the smallest to the largest. ',NULL,NULL),(1910,3100,'AEP Mathematics',80,' Fractions18 Recognize the meaning of a fraction.',NULL,NULL),(1911,3100,'AEP Mathematics',81,' Fractions18 Identify fractions equivalent to 1.',NULL,NULL),(1912,3100,'AEP Mathematics',82,' Fractions18 Identify simple fractions that are equivalent.',NULL,NULL),(1913,3100,'AEP Mathematics',83,' Fractions28 Identify equivalent fractions.',NULL,NULL),(1914,3100,'AEP Mathematics',84,' Fractions28 Change a fraction to a mixed numeral. ',NULL,NULL),(1915,3100,'AEP Mathematics',85,' Fractions28 Add and subtract fractions.',NULL,NULL),(1916,3100,'AEP Mathematics',86,' Fractions28 Express fractions as a decimal.',NULL,NULL),(1917,3100,'AEP Mathematics',87,' Fractions38 Write fractions and mixed numerals, convert from one to another.',NULL,NULL),(1918,3100,'AEP Mathematics',88,' Fractions38 Add and subtract like and unlike fractions.',NULL,NULL),(1919,3100,'AEP Mathematics',89,' Fractions38 Multiply fractions.',NULL,NULL),(1920,3100,'AEP Mathematics',90,' Computation18 Add,subtract,multiply and divide up to 10 by memory.',NULL,NULL),(1921,3100,'AEP Mathematics',91,' Computation18 Use a calculator to add,subtract,multiply and divide whole and decimal numbers.',NULL,NULL),(1922,3100,'AEP Mathematics',92,' ProblemSolving18 Figure out 1 step problems by adding,subtracting,multiplying and dividing.',NULL,NULL),(1923,3100,'AEP Mathematics',93,' ProblemSoving38 Figure out 2 step problems by adding,subtracting,multiplying and dividing.',NULL,NULL),(1924,3100,'AEP Mathematics',94,' Averages28 Identify places that use statistical data. ',NULL,NULL),(1925,3100,'AEP Mathematics',95,' Averages28 Calculate the mode.',NULL,NULL),(1926,3100,'AEP Mathematics',96,' Averages28 Calculate the mean average using the calculator.',NULL,NULL),(1927,3100,'AEP Mathematics',97,' Percent28 Define percent.',NULL,NULL),(1928,3100,'AEP Mathematics',98,' Percent28 Change percent to decimal and decimal to percent.',NULL,NULL),(1929,3100,'AEP Mathematics',99,' Percent28 Find the percent of a number using a calculator.',NULL,NULL),(1930,3100,'AEP Mathematics',100,' Percent28 Calculate sales tax. ',NULL,NULL),(1931,3100,'AEP Mathematics',101,' Percent28 Calculate discounts.',NULL,NULL),(1932,3100,'AEP Mathematics',102,' Probability28 List the sample space and events for a random experiment.',NULL,NULL),(1933,3100,'AEP Mathematics',103,' Probability28 Calculate experimental probability of simple events by performing repeated experiments.',NULL,NULL),(1934,3300,'AEP Social Sciences',1,' Politics18 Understand that humans establish various kinds of organizations as a means of meeting their needs and wants.',NULL,NULL),(1935,3300,'AEP Social Sciences',2,' Politics18 Know that any group must decide on some means of decision-making that will allow it to function efficiently.',NULL,NULL),(1936,3300,'AEP Social Sciences',3,' Politics18 Know that individuals within organizations must have some way of resolving differences and making and enforcing conclusions.',NULL,NULL),(1937,3300,'AEP Social Sciences',4,' Politics18 Decide whether the rights of the individual or the group have higher priority.',NULL,NULL),(1938,3300,'AEP Social Sciences',5,' Politics18 Know what areas of life are appropriate for society to control through norms and sanctions.',NULL,NULL),(1939,3300,'AEP Social Sciences',6,' Politics18 Understand that the greatest good for the greatest number is the fundamental value in a democracy.',NULL,NULL),(1940,3300,'AEP Social Sciences',7,' Economics18 Understand that an individual fulfills many roles within the family and the community.',NULL,NULL),(1941,3300,'AEP Social Sciences',8,' Economics18 Understand that individuals have needs and wants that must be met in order to survive. ',NULL,NULL),(1942,3300,'AEP Social Sciences',9,' Economics18 Understand that members of social organizations are interdependent in meeting the needs and wants of the group members.',NULL,NULL),(1943,3300,'AEP Social Sciences',10,' Economics18 Understand that an individual\'s ability to live self-sufficiently is dependent upon his ability to fulfill a role in society and manage his resources. ',NULL,NULL),(1944,3300,'AEP Social Sciences',11,' Nation18 Learn that culture may be identified as the ideas, beliefs, values and behavior patterns transmitted through the generations in a society.',NULL,NULL),(1945,3300,'AEP Social Sciences',12,' Nation18 Recognize that every person develops a personal identity shaped in part by their culture.',NULL,NULL),(1946,3300,'AEP Social Sciences',13,' Nation18 Appreciate that belief systems vary from culture to culture. ',NULL,NULL),(1947,3300,'AEP Social Sciences',14,' Nation18 Appreciate the unique cultural heritage of the Aboriginal people.',NULL,NULL),(1948,3300,'AEP Social Sciences',15,' International Relations 18 Compare a foreign country to Canada in relation to size,language,climate,geography,industry,population,religion,history,etc.',NULL,NULL),(1949,3300,'AEP Social Sciences',16,' Current Events18 Describe the modes of communication in which news travels.',NULL,NULL),(1950,3300,'AEP Social Sciences',17,' Current Events18 Keep up-to-date with current events. ',NULL,NULL),(1951,3300,'AEP Social Sciences',18,' Current Events18 Introduction to the five W\'s.',NULL,NULL),(1952,3300,'AEP Social Sciences',19,' Current Events18 Explain what a local news article is.',NULL,NULL),(1953,3300,'AEP Social Sciences',20,' Current Events18 Gain a knowledge of the different parts of the newspaper. ',NULL,NULL),(1954,3300,'AEP Social Sciences',21,' Human Rights28 Tell why and when the Charter of Rights and Freedoms was developed. ',NULL,NULL),(1955,3300,'AEP Social Sciences',22,' Human Rights28 Explain what the Young Offenders Act is. ',NULL,NULL),(1956,3300,'AEP Social Sciences',23,' Human Rights28 Explain the purpose of the Young Offenders Act. ',NULL,NULL),(1957,3300,'AEP Social Sciences',24,' Human Rights28 Name some of the options youth have under the Young Offenders Act. ',NULL,NULL),(1958,3300,'AEP Social Sciences',25,' Environment28 Understand that learned behavior is the result of the interactins with social and physical environment.',NULL,NULL),(1959,3300,'AEP Social Sciences',26,' Environment28 List the elements of their physical environment. ',NULL,NULL),(1960,3300,'AEP Social Sciences',27,' Environment28 Will develop lists for their social environment.',NULL,NULL),(1961,3300,'AEP Social Sciences',28,' Environment28 Compare their physical and social environment with those in a Third World Country.',NULL,NULL),(1962,3300,'AEP Social Sciences',29,' Environment28 Underrstand that an individual has a unique combination of traits, abilities and needs.(heredity)',NULL,NULL),(1963,3300,'AEP Social Sciences',30,' Wealth28 Understand the definitions of standard of living, needs and wants, income, budget and scarcity.',NULL,NULL),(1964,3300,'AEP Social Sciences',31,' Wealth28 Understand that standards of living involve a level of wealth.  ',NULL,NULL),(1966,3300,'AEP Social Sciences',33,' Wealth28 Know that living within one\'s means requires budgeting. Know how to set one up. ',NULL,NULL),(1967,3300,'AEP Social Sciences',34,' Conflict28 Understand that conflict between individuals and countries is unavoidable because of our differences. ',NULL,NULL),(1968,3300,'AEP Social Sciences',35,' Conflict28 Understand that differences result in resolution(peace) or failure to resolve (war).',NULL,NULL),(1969,3300,'AEP Social Sciences',36,' Conflict28 Know that there have been a number of wars this century, with two major wars involving the whole world. ',NULL,NULL),(1970,3300,'AEP Social Sciences',37,' Conflict28 Know the key locations of WW I and WW II. ',NULL,NULL),(1971,3300,'AEP Social Sciences',38,' Conflict28 Know the key individuals in the Second World War. ',NULL,NULL),(1972,3300,'AEP Social Sciences',39,' Conflict28 Know that Canada was involved in both wars and we observe Remembrance Day to commemorate the war dead and revere peace. ',NULL,NULL),(1973,3300,'AEP Social Sciences',40,' Current Events28 Define what is considered national news. ',NULL,NULL),(1974,3300,'AEP Social Sciences',41,' Current Events28 Understand the structure of government and the accompanying terminology.',NULL,NULL),(1975,3300,'AEP Social Sciences',42,' Current Events28 Become familiar with economic terminology - inflation, recession, unemployment, debt.',NULL,NULL),(1976,3300,'AEP Social Sciences',43,' Current Events38 Recognize and name the major leaders in local, provincial, national and international events. ',NULL,NULL),(1977,3300,'AEP Social Sciences',44,' Current Events38 Explain what makes an international news article.',NULL,NULL),(1978,3300,'AEP Social Sciences',45,' Government38 Identify and understand the purpose of government agencies such as Unemployment, Social Services, Health Care.',NULL,NULL),(1979,3300,'AEP Social Sciences',46,' Government38 Know which agency to call for a particular problem.',NULL,NULL),(1980,3300,'AEP Social Sciences',47,' Government38 Know the purpose of unions. Understand why they were developed. ',NULL,NULL),(1981,3300,'AEP Social Sciences',48,' Geography38 Understand that a map has symbols that represent real places. ',NULL,NULL),(1982,3300,'AEP Social Sciences',49,' Geography38 Understand a Saskatchewan grid map and road map.',NULL,NULL),(1983,3300,'AEP Social Sciences',50,' Geography38 Understand how to locate familiar places on a map of their town, municipality, province, using an index and legend.',NULL,NULL),(1984,3300,'AEP Social Sciences',51,' Geography38 Understand that Canada has different regions of vegetation, population, climate and landforms. ',NULL,NULL),(1985,3300,'AEP Social Sciences',52,' Geography38 Understand that Canada is divided politically into provinces and territories.',NULL,NULL),(1986,3300,'AEP Social Sciences',53,' Geography38 Understand how to read direction and distance on a map.',NULL,NULL),(1987,3300,'AEP Social Sciences',54,' Geography38 Understand how to read and construct graphs of distance, climate and population.',NULL,NULL),(1988,3400,'AEP Life Skills',1,' Self Management18 Self evaluate feelings about themselves.',NULL,NULL),(1989,3400,'AEP Life Skills',2,' Self Management18 Describe themselves socially and physically.',NULL,NULL),(1990,3400,'AEP Life Skills',3,' Self Management18 Define strengths and limitations. ',NULL,NULL),(1991,3400,'AEP Life Skills',4,' Self Management18 List personal strengths and limitations. ',NULL,NULL),(1992,3400,'AEP Life Skills',5,' Self Management18 Use strengths and limits to develop personal goals. ',NULL,NULL),(1993,3400,'AEP Life Skills',6,' Self Management18 Improve study and time management skills. ',NULL,NULL),(1994,3400,'AEP Life Skills',7,' Self Management18 Identify verbal and nonverbal communication style. ',NULL,NULL),(1995,3400,'AEP Life Skills',8,' Self Management18 Build the following communication skills, listening, questioning, being assertive. ',NULL,NULL),(1996,3400,'AEP Life Skills',9,' Self Management18 Develop an understanding of personal fellings and build skills in communicating them. ',NULL,NULL),(1997,3400,'AEP Life Skills',10,' Self Management28 Recognize how to maintain and enhance self worth.',NULL,NULL),(1998,3400,'AEP Life Skills',11,' Well Being18 Understand the principles of positive hygiene.',NULL,NULL),(1999,3400,'AEP Life Skills',12,' Well Being18 Explain the importance of personal hygiene and grooming. ',NULL,NULL),(2000,3400,'AEP Life Skills',13,' Well Being18 Understand the correlation between hygiene and healthiness. ',NULL,NULL),(2001,3400,'AEP Life Skills',14,' Well Being18 List rules for eye, ear, and dental care. ',NULL,NULL),(2002,3400,'AEP Life Skills',15,' Well Being18 Understand the importance of good nutrition. ',NULL,NULL),(2003,3400,'AEP Life Skills',16,' Well Being18 Identify a balanced diet.',NULL,NULL),(2004,3400,'AEP Life Skills',17,' Well Being18 Recognize the role of the community services in assessing and maintaining the individual\'s well-being and be able to access those resources. ',NULL,NULL),(2005,3400,'AEP Life Skills',18,' Well Being28 Recognizes the need to accept personal responsibility for attaining and maintaining optimal levels of well being. ',NULL,NULL),(2006,3400,'AEP Life Skills',19,' Well Being28 Develops an action plan for well-being. ',NULL,NULL),(2007,3400,'AEP Life Skills',20,' Relationships18 Identify strategies to enhance relationships. ',NULL,NULL),(2008,3400,'AEP Life Skills',21,' Relationships18 Recognize that some problems within relationships may not be resolved at a particular time. ',NULL,NULL),(2009,3400,'AEP Life Skills',22,' Relationships18 Define conflict. ',NULL,NULL),(2010,3400,'AEP Life Skills',23,' Relationships18 Develop conflict resolution strategies. ',NULL,NULL),(2011,3400,'AEP Life Skills',24,' Relationships18 Recognize how individuals deal with grief or loss. ',NULL,NULL),(2012,3400,'AEP Life Skills',25,' Relationships28 Identify and develop skills, attitudes and behaviors that promote effective relationships. ',NULL,NULL),(2013,3400,'AEP Life Skills',26,' Relationships28 Identify verbal and nonverbal communication styles. ',NULL,NULL),(2014,3400,'AEP Life Skills',27,' Relationships28 Build communication skills, listening, paraphrasing, questioning, giving and receiving feedback, and recognize communication barriers. ',NULL,NULL),(2015,3400,'AEP Life Skills',28,' Relationships28 Being assertive versus being aggressive. ',NULL,NULL),(2016,3400,'AEP Life Skills',29,' Relationships28 Use the telephone to contact local community services. ',NULL,NULL),(2017,3400,'AEP Life Skills',30,' Relationships38 Define peer pressure and state how to deal with it. ',NULL,NULL),(2018,3400,'AEP Life Skills',31,' Relationships38 Define how communication skills are important in the work place. ',NULL,NULL),(2019,3400,'AEP Life Skills',32,' Relationships38 Demonstrate understanding of how to work and communicate with adults. ',NULL,NULL),(2020,3400,'AEP Life Skills',33,' Relationships38 Identify qualities they would look for in a mate. ',NULL,NULL),(2022,3400,'AEP Life Skills',34,' Careers18 Develop a personal profile.',NULL,NULL),(2023,3400,'AEP Life Skills',35,' Careers18 Review concepts of work, job, career, occupation, career planning. ',NULL,NULL),(2024,3400,'AEP Life Skills',36,' Careers18 Prepare application forms, letters and resumes. ',NULL,NULL),(2025,3400,'AEP Life Skills',37,' Careers28 Explore the meaning of work and recognize how work relates to life. ',NULL,NULL),(2026,3400,'AEP Life Skills',38,' Careers28 Formulate a personal career plan. ',NULL,NULL),(2027,3400,'AEP Life Skills',39,' Independent Living18 Recognize expenses that occur when living on your own.',NULL,NULL),(2028,3400,'AEP Life Skills',40,' Independent Living18 Recognize available banking options. ',NULL,NULL),(2029,3400,'AEP Life Skills',41,' Independent Living18 Demonstrate efficient banking skills. ',NULL,NULL),(2030,3400,'AEP Life Skills',42,' Independent Living18 Identify strategies for dealing with consumer concerns.',NULL,NULL),(2031,3400,'AEP Life Skills',43,' Independent Living18 Identify personal needs. ',NULL,NULL),(2032,3400,'AEP Life Skills',44,' Independent Living28 Identify resources available. ',NULL,NULL),(2033,3400,'AEP Life Skills',45,' Independent Living28 Identify how needs, wants,and expectations may change throughout their life. ',NULL,NULL),(2034,3400,'AEP Life Skills',46,' Independent Living28 Accept responsibility for the consequences of personal decisions. ',NULL,NULL),(2035,3400,'AEP Life Skills',47,' Independent Living38 Demonstrate how to make an appointment. ',NULL,NULL),(2036,3400,'AEP Life Skills',48,' Independent Living38 State questions that should be asked at doctor, dentist and optometrist appointments. ',NULL,NULL),(2037,3400,'AEP Life Skills',49,' Independent Living38 Make a shopping list.',NULL,NULL),(2038,3400,'AEP Life Skills',50,' Independent Living38 Understand basic information required for a learner\'s license. ',NULL,NULL),(2039,3400,'AEP Life Skills',51,' Independent Living38 Know how and where to purchase bus tickets and how to read a schedule.',NULL,NULL),(2040,3400,'AEP Life Skills',52,' Independent Living38 Demonstrate how to use a washer and dryer and what products should be used with each. ',NULL,NULL),(2041,3400,'AEP Life Skills',53,' Independent Living38 Create a simple budget. ',NULL,NULL),(2042,3400,'AEP Life Skills',54,' Self Awareness38 Identify positive qualities in themselves and others. ',NULL,NULL),(2043,3400,'AEP Life Skills',55,' Self Awareness38 Talk about their successes and achievements. ',NULL,NULL),(2044,3400,'AEP Life Skills',56,' Self Awareness38 Create a profile of their own positive qualities. ',NULL,NULL),(2045,3400,'AEP Life Skills',57,' Self Awareness38 Identify causes of stress and ways to deal with it. ',NULL,NULL),(2046,3400,'AEP Life Skills',58,' Self Awareness38 Identify steps to problem solving. ',NULL,NULL),(2047,3400,'AEP Life Skills',59,' Self Awareness38 State how they deal with anger and determine whether it is a healthy or unhealthy way.',NULL,NULL),(2048,3400,'AEP Life Skills',60,' Self Awareness38 Describe warning signs of suicide. ',NULL,NULL),(2049,3400,'AEP Life Skills',61,' Self Awareness38 List signs of depression.',NULL,NULL),(2050,3400,'AEP Life Skills',62,' Self Awareness38 State what they can do if they or someone they know are depressed or thinking about suicide.',NULL,NULL),(2051,3400,'AEP Life Skills',63,' Parenting38 List the rights and responsibilities of the employer,the child and the babysitter. ',NULL,NULL),(2052,3400,'AEP Life Skills',64,' Parenting38 Demonstrate basic care of children.',NULL,NULL),(2053,3400,'AEP Life Skills',65,' Parenting38 Explain the importance of nutrition as it relates to children. ',NULL,NULL),(2054,3400,'AEP Life Skills',66,' Parenting38 Identify common causes of accidental injury to children and means of prevention.',NULL,NULL),(2055,3400,'AEP Life Skills',67,' Parenting38 Demonstrate basic first aid procedures.',NULL,NULL),(2056,3400,'AEP Life Skills',68,' Parenting38 Describe the procedures on how to react to an emergency which may arrise while babysitting. ',NULL,NULL),(2057,3400,'AEP Life Skills',69,' Parenting38 List types of games, songs and toys which are appropriate for different age levels. ',NULL,NULL),(2828,8080,'Decimals',10,'When given ten problems requiring the subraction of decimals, will correctly compute the answers for subtracting decimals with hundredths.',NULL,NULL),(2059,3200,'AEP Science',1,' Solve problems using the scientific method.',NULL,NULL),(2060,3200,'AEP Science',2,' Identify the needs of plants and animals.',NULL,NULL),(2061,3200,'AEP Science',3,' Understand some of the various major functions of the body. For example digestive system, circulatory system, respiratory system, skeletal system, nervous system, and reproductive system.',NULL,NULL),(2062,3200,'AEP Science',4,' Understand some of the various major functions of the body.',NULL,NULL),(2063,3200,'AEP Science',5,' Recognize that wellness is comprised of physical health and mental health.',NULL,NULL),(2064,3200,'AEP Science',6,' Understand that wellness is promoted through nutrition and exercise.',NULL,NULL),(2065,3200,'AEP Science',7,' Understand the difference between a communicable and a non-communicable disease and identify ways in which communicable diseases are spread.',NULL,NULL),(2066,3200,'AEP Science',8,' Identify ways in which they can reduce the threat of disease.',NULL,NULL),(2067,3200,'AEP Science',9,'Identify the effects of drugs on the individual.',NULL,NULL),(2068,3200,'AEP Science',10,' Assess the effect that people have on the environment and the effect that environmental change has on people.',NULL,NULL),(2069,3200,'AEP Science',11,' Identify ways in which people protect the environment.',NULL,NULL),(2100,3000,'AEP English',22,' Listen effectively in a variety of situations for a variety of purposes.',NULL,NULL),(2099,3000,'AEP English',21,' Identify fact, opinion, fallacy, bias, or prejudice.',NULL,NULL),(2098,3000,'AEP English',20,' Identify the effects of various devices a speaker may use to influence a listener.',NULL,NULL),(2095,3000,'AEP English',17,' Practice the behaviour of an effective listener.',NULL,NULL),(2094,3000,'AEP English',16,' Recognize listening as an active, constructive process. For example attending to a message, being able to interpret, summarize and evaluate.',NULL,NULL),(2101,3000,'AEP English',23,' Listen and be able to follow directions.',NULL,NULL),(2102,3000,'AEP English',24,' Listen for personal pleasure',NULL,NULL),(2103,3000,'AEP English',25,' Listen to understand and learn.',NULL,NULL),(2104,3000,'AEP English',26,' Listen and be able to make notes from a presentation.',NULL,NULL),(2108,3000,'AEP English',30,' A28 and B28 - Students will recognize listening as an important life skill.',NULL,NULL),(2109,3000,'AEP English',31,'Students will be able to define purposes of listening. For example enjoyment, information, enhance relationships, and analysis of self.',NULL,NULL),(2110,3000,'AEP English',32,' Students will develop listening skills for a specific situations.',NULL,NULL),(2111,3000,'AEP English',33,' Students will recognize listening as an active constructive process by being able to summarize and interpret information.',NULL,NULL),(2112,3000,'AEP English',34,' Students will recognize and respond appropriately to sounds in their environment.',NULL,NULL),(2113,3000,'AEP English',35,' Recognize that speech is an important tool for communicating thinking and learning.',NULL,NULL),(2114,3000,'AEP English',36,' Practice the behaviours of effective speakers, appropriate to individual ability and/or based on individual need.',NULL,NULL),(2115,3000,'AEP English',37,' Speak to share thoughts, opinions and feelings.',NULL,NULL),(2116,3000,'AEP English',38,' Speak appropriately and with clarity for a variety of audiences to inform and persuade, or question.',NULL,NULL),(2117,3000,'AEP English',39,' Increase their level of reading enjoyment by reading materials appropriate to their independent or instructional level.',NULL,NULL),(2118,3000,'AEP English',40,' Identify the main idea of material read.',NULL,NULL),(2119,3000,'AEP English',41,' Recall detail from material read.',NULL,NULL),(2120,3000,'AEP English',42,' Recall sequence of a story.',NULL,NULL),(2121,3000,'AEP English',43,' Read a variety of reading material for a variety of purposes.',NULL,NULL),(2122,3000,'AEP English',44,' Relate literacy experiences to real life experiences.',NULL,NULL),(2123,3000,'AEP English',45,' Students will gain library skills needed to locate reading materials and resources.',NULL,NULL),(2124,3000,'AEP English',46,' Students will be able to use the writing process and experiment with various forms of writing.',NULL,NULL),(2125,3000,'AEP English',47,' Students will be able to determine whether a sentence makes a complete thought.',NULL,NULL),(2126,3000,'AEP English',48,' Identify and practice using appropriate descriptive words for nouns and verbs.',NULL,NULL),(2127,3000,'AEP English',49,' Use correct capitalization and punctuation skills.',NULL,NULL),(2129,3000,'AEP English',51,' Utilize reference materials within the research and writing process.',NULL,NULL),(2130,3000,'AEP English',52,' Computer literacy skills.',NULL,NULL),(2163,3000,'AEP English',53,' A38 and B38 Recognize viewing as an active process that requires viewers to analyze and evaluate.',NULL,NULL),(2132,6300,'FI Wellness',1,' Gain the skills necessary to participate in bowling, minigolf, golf, swimming, riding bike, crosscountry skiing.',NULL,NULL),(2133,6300,'FI Wellness',2,' Be able to follow a exercise routine at a fitness center. ',NULL,NULL),(2134,6300,'FI Wellness',3,' Achieve enjoyment and exercise from non-skill related activities, such as hiking, walking.',NULL,NULL),(2135,6300,'FI Wellness',4,' Experience the relaxation techniques offered by the Snoezelen Room.',NULL,NULL),(2136,6300,'FI Wellness',5,' Participate in a variety of indoor games and activities. ',NULL,NULL),(2137,6300,'FI Wellness',6,' Express encouragement to others involved in a shared activity. ',NULL,NULL),(2138,6300,'FI Wellness',7,' Accept a difference of skill level in a sportsmanlike manner.',NULL,NULL),(2139,6300,'FI Wellness',8,' Persevere with an activity beyond the level of minimal exertion. ',NULL,NULL),(2140,6300,'FI Wellness',9,' Be aware of the sense of well-being that follows a period of physical activity. ',NULL,NULL),(2141,6500,'FI Communication',1,' Request an object or an activity using the PC Chat.',NULL,NULL),(2142,6500,'FI Communication',2,' Request an object or an activity using polite appropriate language. ',NULL,NULL),(2143,6500,'FI Communication',3,' Greet familiar people using the PC Chat. ',NULL,NULL),(2144,6500,'FI Communication',4,' Greet familiar people using eye contact and appropriate phrases. ',NULL,NULL),(2145,6500,'FI Communication',5,' Request assistance using the PC Chat. ',NULL,NULL),(2146,6500,'FI Communication',6,' Request assistance at an appropriate time using polite appropriate language. ',NULL,NULL),(2147,6500,'FI Communication',7,' Answer a yes/no question independently using the PC Chat.',NULL,NULL),(2148,6500,'FI Communication',8,' Respond to a question that requires a phrase or sentence answer in a one-on-one setting.',NULL,NULL),(2149,6500,'FI Communication',9,' Volunteer appropriately and respond to a question in a group setting.',NULL,NULL),(2150,6500,'FI Communication',10,' Identify appropriate voice volume for different settings and display control of the volume of speech. ',NULL,NULL),(2151,6500,'FI Communication',11,' Respond independently to questions that reflect information on the PC Chat, such as What\'s new?',NULL,NULL),(2152,6500,'FI Communication',12,' Participate in an unscripted conversation (more than 1 set of question/response) with a cued adult or peer.',NULL,NULL),(2153,6500,'FI Communication',13,' Participate in a conversation (more than 1 set of question/response) with any peer or adult.',NULL,NULL),(2154,6500,'FI Communication',14,' Accept rejection gracefully when an attempt at conversation is met with no response. ',NULL,NULL),(2155,6500,'FI Communication',15,' Express emotions or physical feelings using the PC Chat.',NULL,NULL),(2156,6500,'FI Communication',16,' Express emotions or physical feelings appropriately and accurately.',NULL,NULL),(2157,6500,'FI Communication',17,' Identify circumstances under which formal or informal speech is required.  Use the correct form of speech.',NULL,NULL),(2167,3000,'AEP English',57,' Recognize non-verbal aids and visual images as tools for communication.',NULL,NULL),(2166,3000,'AEP English',56,' Recognize that reading is an active process that requires readers to reflect, evaluate and make connections.',NULL,NULL),(2165,3000,'AEP English',55,' Respond personally and creatively to visuals and videos.',NULL,NULL),(2164,3000,'AEP English',54,' Communicate thoughts, feelings and ideas using an illustration/collage.',NULL,NULL),(2168,3000,'AEP English',58,' Experiment with a variety of different writing.',NULL,NULL),(2169,3000,'AEP English',59,' Read a broaden knowledge of Canadian culture and literature.',NULL,NULL),(2170,3000,'AEP English',60,' Recognize listening as an active process which requires listeners to check understanding by making connections interpreting and summarizing.',NULL,NULL),(2171,3000,'AEP English',61,' Experiment with a variety of forms of writing.',NULL,NULL),(2172,3000,'AEP English',62,' Recognize the value of the writing process.',NULL,NULL),(2173,3000,'AEP English',63,' Listen to paraphrase and summarize.',NULL,NULL),(2174,3000,'AEP English',64,' Record responses in a reader\'s journal, log or notebook.',NULL,NULL),(2175,3000,'AEP English',65,' Writing for different purposes and audiences ( news article).',NULL,NULL),(2176,3000,'AEP English',66,' Write an editorial and/or letter to the editor.',NULL,NULL),(2177,3000,'AEP English',67,' Listen for aesthetic satifaction.',NULL,NULL),(2178,3000,'AEP English',68,' Create visual representation to enhance communication.',NULL,NULL),(2179,3000,'AEP English',69,' Practice behaviors of effective and strategic readers.',NULL,NULL),(2180,3000,'AEP English',70,' Experiment with a variety of forms of writing.',NULL,NULL),(2181,3000,'AEP English',71,' Read to stimulate imagination.',NULL,NULL),(2182,3000,'AEP English',72,' Respond critically, personally and creatively.',NULL,NULL),(2183,3000,'AEP English',73,' Recognize that word usage is not right or wrong but suitable to context.',NULL,NULL),(2184,3000,'AEP English',74,' Recognize that Canadian English uses certain word choices and pronunciations by watching a video and responding personally and creatively.',NULL,NULL),(2185,3000,'AEP English',75,' Recognize that pronunciation and meaning of words differ from region to region within Canada.',NULL,NULL),(2186,3000,'AEP English',76,' Recognize that certain words in Canadian English have been created/developed by Canadians.',NULL,NULL),(2187,3000,'AEP English',77,' Recognize that there are different dialects of English by reading various Canadian poems and responding to them.',NULL,NULL),(2188,3000,'AEP English',78,' Respond personally and creatively, as well as relate language to personal experience.',NULL,NULL),(2189,3000,'AEP English',79,' Explore human experiences and values reflected in tests and assess an author\'s   ideas.',NULL,NULL),(2190,3000,'AEP English',80,' Use the writing process to write a formal essay.',NULL,NULL),(2191,6400,'FI Personal/Social Growth',1,' Be an active participant in Catholic practices.',NULL,NULL),(2192,6400,'FI Personal/Social Growth',2,' Develop empathy for fellow students.',NULL,NULL),(2193,6400,'FI Personal/Social Growth',3,' Display manners when dealing with peers and adults. ',NULL,NULL),(2194,6400,'FI Personal/Social Growth',4,' Accept and contribute to praising others.',NULL,NULL),(2195,6400,'FI Personal/Social Growth',5,' Develop appropriate methods of self-control.',NULL,NULL),(2196,6400,'FI Personal/Social Growth',6,' Encourage more appropriate hand and arm movements. ',NULL,NULL),(2197,6400,'FI Personal/Social Growth',7,' Become more independent in the area of personal hygiene. ',NULL,NULL),(2198,6400,'FI Personal/Social Growth',8,' Become more aware of physical appearance and age-appropriate mannerisms. ',NULL,NULL),(2199,6400,'FI Personal/Social Growth',9,' Be responsible for personal belongings. ',NULL,NULL),(2200,6400,'FI Personal/Social Growth',10,' Be responsible for choosing supplies that are necessary when changing classes.',NULL,NULL),(2201,6400,'FI Personal/Social Growth',11,' Become more independent with outer clothing. ',NULL,NULL),(2202,6400,'FI Personal/Social Growth',12,' Develop an enjoyment for age-appropriate leisure activities (noon hours, spares).',NULL,NULL),(2203,6400,'FI Personal/Social Growth',13,' Learn to stop, and think, before speaking or acting.',NULL,NULL),(2204,6400,'FI Personal/Social Growth',14,' Understand the concept of personal space and respect the personal space of others. ',NULL,NULL),(2205,6400,'FI Personal/Social Growth',15,' Practice the procedures for dental and medical appointments.',NULL,NULL),(2259,3000,'AEP English',89,' Gain a better understanding of our history through literacy and comprehension questins.',NULL,NULL),(2258,3000,'AEP English',88,' Locate information and summarize understanding.',NULL,NULL),(2209,6500,'FI Communication',18,' State the real concern or anxiety when a \'rehearsed\' phrase is used. ',NULL,NULL),(2210,6000,'FI Functional English',1,' Be able to get factual information from a passage.',NULL,NULL),(2211,6000,'FI Functional English',2,' Make predictions on what is being read. ',NULL,NULL),(2212,6000,'FI Functional English',3,' Identify the main idea of a selection.',NULL,NULL),(2213,6000,'FI Functional English',4,' Identify the main characters and their corresponding characteristics. ',NULL,NULL),(2214,6000,'FI Functional English',5,' Be able to identify and know the meaining of 75% of the vocabulary presented. ',NULL,NULL),(2215,6000,'FI Functional English',6,' Be able to write a simple sentence.',NULL,NULL),(2216,6000,'FI Functional English',7,' Be able to write a paragraph.',NULL,NULL),(2217,6000,'FI Functional English',8,' Be able to write a multi-paragraph article. ',NULL,NULL),(2218,6000,'FI Functional English',9,' Be able to sequence four story events. ',NULL,NULL),(2219,6000,'FI Functional English',10,' Be able to use the following punctuation correctly - . ? ! ,',NULL,NULL),(2220,6000,'FI Functional English',11,' Be able to use the following punctuation correctly - . ? ! ,  \" \"',NULL,NULL),(2221,6000,'FI Functional English',12,' Use capitalization correctly at the beginning of sentences and proper nouns. ',NULL,NULL),(2222,6000,'FI Functional English',13,' Use capitalization correctly at the beginning of sentences,proper nouns and inside quotation marks.  ',NULL,NULL),(2223,6000,'FI Functional English',14,' Be able to achieve 75% on a weekly spelling list/sentences. ',NULL,NULL),(2224,6000,'FI Functional English',15,' Use a dictionary to find a given word. ',NULL,NULL),(2225,6000,'FI Functional English',16,' Read orally with proper articulation and expression.',NULL,NULL),(2226,6100,'FI Functional Mathematics',1,' Recognize numbers to 100. Be able to read and write these numbers using numerals correctly.',NULL,NULL),(2227,6100,'FI Functional Mathematics',2,' Recognize numbers to 1000. Be able to read and write these numbers using numerals correctly.',NULL,NULL),(2228,6100,'FI Functional Mathematics',3,' Add with regrouping 2 digit numbers with 75% accuracy.',NULL,NULL),(2229,6100,'FI Functional Mathematics',4,' Add with regrouping 3 digit numbers with 75% accuracy. ',NULL,NULL),(2230,6100,'FI Functional Mathematics',5,' Subtract with borrowing 2 digit numbers with 75% accuracy. ',NULL,NULL),(2231,6100,'FI Functional Mathematics',6,' Multiply with a 1 digit bottom factor with regrouping. ',NULL,NULL),(2232,6100,'FI Functional Mathematics',7,' Know the multiplying facts 2X, 5X, 10X and 11X by memory.',NULL,NULL),(2233,6100,'FI Functional Mathematics',8,' Know the multiplying facts to 5X, as well as 10X and 11X by memory.',NULL,NULL),(2234,6100,'FI Functional Mathematics',9,' Be able to do long division with a 1 digit divisor. ',NULL,NULL),(2235,6100,'FI Functional Mathematics',10,' Be able to add and subtract simple fractions with common denominators.',NULL,NULL),(2236,6100,'FI Functional Mathematics',11,' Be able to addition and subtraction with 2 digit decimals.',NULL,NULL),(2237,6100,'FI Functional Mathematics',12,' Be able to count like coins - nickels, dimes, quarters to $1.00. ',NULL,NULL),(2238,6100,'FI Functional Mathematics',13,' Be able to count mixed coins totalling less than $1.00.',NULL,NULL),(2239,6100,'FI Functional Mathematics',14,' Be able to give change for a purchase less than $1.00.',NULL,NULL),(2240,6100,'FI Functional Mathematics',15,' Recognize and perform the operations of addition and subtraction in a word problem.',NULL,NULL),(2241,6100,'FI Functional Mathematics',16,' Add and subtract money using correct notation and correct regrouping. ',NULL,NULL),(2242,3000,'AEP English',81,' Explore human experiences and values by responding personally, critically and creatively.',NULL,NULL),(2243,3000,'AEP English',82,' Relate literary experience to personal experience and extend personal response.',NULL,NULL),(2244,3000,'AEP English',83,' Read to broaden their knowledge of Canadian literary and cultural heritage.',NULL,NULL),(2245,3000,'AEP English',84,' Read a wide range of material to extend experience and empathize and make connections with others.',NULL,NULL),(2246,3000,'AEP English',85,' Recognize that Canada is considered to be multicultural.',NULL,NULL),(2247,3000,'AEP English',86,' Read to stimulate the imagination.',NULL,NULL),(2248,3000,'AEP English',87,' Recognize reading as an active process and that requires readers to make connections, find meaning, reflect and evaluate.',NULL,NULL),(2249,6200,'FI Functional Academics',1,'Be able to write her name independently in the cursive style.',NULL,NULL),(2250,6200,'FI Functional Academics',2,' Be able to develop a functional vocabulary of 20 words - receptive as well as written.',NULL,NULL),(2251,6200,'FI Functional Academics',3,' Understand the value of the numbers to 5. ',NULL,NULL),(2252,6200,'FI Functional Academics',4,'Identify the coins by name.',NULL,NULL),(2253,6200,'FI Functional Academics',5,'Realize the amount of money needed for favorite items - soup, water, sucker, etc.',NULL,NULL),(2254,6200,'FI Functional Academics',6,'Listen to a taped story with appropriate page turning. ',NULL,NULL),(2255,6200,'FI Functional Academics',7,'Type her name onto the computer as a user name/password.',NULL,NULL),(2256,6200,'FI Functional Academics',8,' Be able to manipulate a variety of game sites on the computer. ',NULL,NULL),(2257,6200,'FI Functional Academics',9,'Be able to use art as a means of self-expression.',NULL,NULL),(2260,3000,'AEP English',90,' Gain an understanding of rights and how the rights of the Metis were not respected.',NULL,NULL),(2261,3000,'AEP English',91,' Practice questioning techniques to gain information from an adult.',NULL,NULL),(2262,3000,'AEP English',92,' Identify the difference between fiction and non-fiction selections of literature.',NULL,NULL),(2263,3000,'AEP English',93,' Answer comprehension questions from short fiction and non-fiction selections.',NULL,NULL),(2264,3000,'AEP English',94,' Use the library to find information.',NULL,NULL),(2265,3000,'AEP English',95,' Retell a story to younger students, keeping the listener\'s needs in mind',NULL,NULL),(2267,3000,'AEP English',97,' Retell a story to others.',NULL,NULL),(2268,3000,'AEP English',98,' Compare life now to that in soddy on the Great Plains.',NULL,NULL),(2269,3000,'AEP English',99,' Brainstorm lists of household items the pioneers would not have and categorize each into specific rooms.',NULL,NULL),(2270,3000,'AEP English',100,' Write three sentences describing the differences using proper punctuation and sentence structure.',NULL,NULL),(2271,3000,'AEP English',101,' Understand relationship between words and pictures.',NULL,NULL),(2272,3000,'AEP English',102,' Accurately describe pictures in oral or written words.',NULL,NULL),(2273,3000,'AEP English',103,' Read to understand and increase vocabulary.',NULL,NULL),(2274,3000,'AEP English',104,' Experience a novel.',NULL,NULL),(2275,3000,'AEP English',105,' Listen to and participate in a class discussion.',NULL,NULL),(2276,3000,'AEP English',106,' Identify with assistance certain locations on a world map or globe.',NULL,NULL),(2277,3000,'AEP English',107,' Complete an interview with a relative to determine cultural background.',NULL,NULL),(2278,3000,'AEP English',108,' Develop an interest in Eskimo life today and in the past through the reading of traditional Eskimo chants and legends.',NULL,NULL),(2279,3000,'AEP English',109,' Find the main idea of an article read to them orally.',NULL,NULL),(2280,3000,'AEP English',110,' Define the word genealogy in terms of their personal contexts.',NULL,NULL),(2281,3000,'AEP English',111,' Create a family tree.',NULL,NULL),(2282,3000,'AEP English',112,' Combine life skills and their knowledge of different cultures to make foods from different cultures.',NULL,NULL),(2283,3000,'AEP English',113,' Read  poems orally.',NULL,NULL),(2284,3000,'AEP English',114,' Brainstorm way of dealing with frustration, not only with language differences, but other conflicts the students may encounter.',NULL,NULL),(2285,3000,'AEP English',115,' Learn two words in different languages and practice using them in context.',NULL,NULL),(2286,3000,'AEP English',116,' Listen to information provided by a guest speaker on the culture and traditions of Japan.',NULL,NULL),(2287,3000,'AEP English',117,' Investigate male/female roles in their community.',NULL,NULL),(2288,3000,'AEP English',118,' Constructing a paragraph. Composing topic sentences, closing sentences, supporting details.',NULL,NULL),(2289,3000,'AEP English',119,' Put themselves in the place of a major character.',NULL,NULL),(2290,3000,'AEP English',120,' Independently navigate to a web site of personal interest.',NULL,NULL),(2291,3000,'AEP English',121,' Create headlines and captions to go along with pictures.',NULL,NULL),(2292,3000,'AEP English',122,' Relate their opinions to others orally and in writing.',NULL,NULL),(2293,3000,'AEP English',123,' Provide persuasive arguments for their point of view.',NULL,NULL),(2294,3000,'AEP English',124,' Write a resume, appropriately make complaints.',NULL,NULL),(2295,3000,'AEP English',125,' Demonstrate appropriate friendship-making skills.',NULL,NULL),(2296,3000,'AEP English',126,' Devise and carry out a survey.',NULL,NULL),(2297,3000,'AEP English',127,' Report the results of a survey to others.',NULL,NULL),(2298,3000,'AEP English',128,' Write an effective business letter.',NULL,NULL),(2299,3000,'AEP English',129,' Understand what individual rights are and the rights in the home, school, and community.',NULL,NULL),(2300,3000,'AEP English',130,' Understand the advantage in treating others as we with they would treat us.',NULL,NULL),(2301,3000,'AEP English',131,' Discover that all people tackle issues in their lives differently.',NULL,NULL),(2302,3000,'AEP English',132,' Make predictions on what is being read.',NULL,NULL),(2303,3000,'AEP English',133,' Be able to write a simple sentence.',NULL,NULL),(2304,3000,'AEP English',134,' Be able to write a sentence with a compound subject or compound predicate.',NULL,NULL),(2305,3000,'AEP English',135,' Be able to read orally with proper articulation and expression.',NULL,NULL),(2306,3000,'AEP English',136,' Be able to achieve 75% on a weekly spelling list/sentences.',NULL,NULL),(2307,3000,'AEP English',137,' Identify main characters and corresponding characteristics.',NULL,NULL),(2308,3900,'AEP Business Education',1,' Employee Skills18 Write a business letter.',NULL,NULL),(2309,3900,'AEP Business Education',2,' Employee Skills18 Accurately record memos and phone messages with varying degrees of formality.',NULL,NULL),(2310,3900,'AEP Business Education',3,' Employee Skills18 Be able to file documents both alphabetically and by year.',NULL,NULL),(2311,3900,'AEP Business Education',4,' Employee Skills18 Transfer addresses and invoice numbers accurately from one document to another. ',NULL,NULL),(2312,3900,'AEP Business Education',5,' Employee Skills18 Understand the need for and establish a formal signature.',NULL,NULL),(2313,3900,'AEP Business Education',6,' Employee Skills28 Accurately fill out an expense form based on a collection of receipts.',NULL,NULL),(2314,3900,'AEP Business Education',7,' Employee Skills28 Fill out a variety of new employee forms correctly and legibly.',NULL,NULL),(2315,3900,'AEP Business Education',8,' Employee Skills28 Recognize documents that must be read carefully before signing. ',NULL,NULL),(2316,3900,'AEP Business Education',9,' Employee Skills38 Calculate gross pay.',NULL,NULL),(2317,3900,'AEP Business Education',10,' Employee Skills38 Identify parts of the paycheck and pay stub. ',NULL,NULL),(2318,3900,'AEP Business Education',11,' Banking Skills18 Write money amounts in words/number combinations.',NULL,NULL),(2319,3900,'AEP Business Education',12,' Banking Skills18 Understand the procedure of opening a bank account. ',NULL,NULL),(2320,3900,'AEP Business Education',13,' Banking Skills18 Be able to fill out a deposit slip and make a deposit. ',NULL,NULL),(2321,3900,'AEP Business Education',14,' Banking Skills18 Write out a check correctly.',NULL,NULL),(2322,3900,'AEP Business Education',15,' Banking Skills18 Understand how to use an ATM card. ',NULL,NULL),(2323,3900,'AEP Business Education',16,' Banking Skills18 Know how to correctly endorse a check. ',NULL,NULL),(2324,3900,'AEP Business Education',17,' Banking Skills28 Identify features of a bank that affects a choice of a banking institution.',NULL,NULL),(2325,3900,'AEP Business Education',18,' Banking Skills28 Compare types of bank accounts. ',NULL,NULL),(2326,3900,'AEP Business Education',19,' Banking Skills28 Correctly record checks and deposits in a check register. ',NULL,NULL),(2327,3900,'AEP Business Education',20,' Banking Skills28 Use a check register and bank statement to balance an account. ',NULL,NULL),(2328,3900,'AEP Business Education',21,' Banking Skills38 Become familiar with how to use traveler\'s checks. ',NULL,NULL),(2329,3900,'AEP Business Education',22,' Banking Skills38 Learn why and how to stop payment on a check.',NULL,NULL),(2330,3900,'AEP Business Education',23,' Banking Skills38 Be able to fill out a loan application.',NULL,NULL),(2331,3900,'AEP Business Education',24,' Banking Skills38 Understand the qualifications necessary for loans. ',NULL,NULL),(2332,3900,'AEP Business Education',25,' Social Skills18 Be able to deal with wrong numbers - both receiving and sending.',NULL,NULL),(2333,3900,'AEP Business Education',26,' Social Skills18 Understand how and when to send thank you notes. ',NULL,NULL),(2334,3900,'AEP Business Education',27,' Social Skills18 Be able to offer a compliment.',NULL,NULL),(2335,3900,'AEP Business Education',28,' Social Skills28 Be able to assertively deal with sales calls. ',NULL,NULL),(2336,3900,'AEP Business Education',29,' Organizational Skills18 Be able to locate phone numbers in the phone book.',NULL,NULL),(2337,3900,'AEP Business Education',30,' Organizational Skills18 Understand how to use the yellow pages of the phone book.',NULL,NULL),(2338,3900,'AEP Business Education',31,' Organizational Skills18 Use the internet to find phone numbers. ',NULL,NULL),(2339,3900,'AEP Business Education',32,' Organizational Skills18 Be able to use a table of contents. ',NULL,NULL),(2340,3900,'AEP Business Education',33,' Organizational Skills18 Be able to use an index. ',NULL,NULL),(2341,3900,'AEP Business Education',34,' Organizational Skills28 Understand how to use coded phone numbers. ',NULL,NULL),(2342,3900,'AEP Business Education',35,' Organizational Skills28 Be able to use automated phones.',NULL,NULL),(2343,3900,'AEP Business Education',36,' Organizational Skills28 Understand how to record a greeting on a phone. ',NULL,NULL),(2344,3900,'AEP Business Education',37,' Organizational Skills28 Be able to leave a message on an answering machine. ',NULL,NULL),(2345,3900,'AEP Business Education',38,' Organizational Skills38 Be aware of what papers and documents need to be kept.',NULL,NULL),(2346,3900,'AEP Business Education',39,' Organizational Skills28 Be able to organize and label files for personal documents. ',NULL,NULL),(2347,3900,'AEP Business Education',40,' Understanding Forms18 Correctly fill out forms. ',NULL,NULL),(2348,3900,'AEP Business Education',41,' Understanding Forms18 Be able to use a dictionary efficiently.',NULL,NULL),(2349,3900,'AEP Business Education',42,' Understanding Forms18 Correctly address a letter or parcel. ',NULL,NULL),(2350,3900,'AEP Business Education',43,' Understanding Forms28 Correctly fill out a mail-order form.',NULL,NULL),(2351,3900,'AEP Business Education',44,' Understanding Forms28 Understand how to apply for a credit card. ',NULL,NULL),(2352,3900,'AEP Business Education',45,' Understanding Forms28 Be aware of how to use a credit card appropriately. ',NULL,NULL),(2353,3900,'AEP Business Education',46,' Understanding Forms38 Be aware of what forms are needed for preparation of taxes. ',NULL,NULL),(2354,3900,'AEP Business Education',47,' Understanding Forms38 Complete a tax form.',NULL,NULL),(2355,4200,'AEP Subject Areas',1,' Interact with students in the regular program.',NULL,NULL),(2356,4200,'AEP Subject Areas',2,' Be receptive to instruction from a variety of instructors.',NULL,NULL),(2357,4200,'AEP Subject Areas',3,' Independently move from class to class with the time restriction of class change. ',NULL,NULL),(2358,4200,'AEP Subject Areas',4,' Be responsible for bringing appropriate materials needed for class. ',NULL,NULL),(2359,4200,'AEP Subject Areas',5,' Accept modification or assistance with regular programming.',NULL,NULL),(2360,4200,'AEP Subject Areas',6,' Complete all modified assignments and projects as determined by the teacher and teacher associate.  ',NULL,NULL),(2361,4200,'AEP Subject Areas',7,' Request assistance appropriately from the teacher, teacher associate or a peer.',NULL,NULL),(2362,6600,'FI Career Education',1,' Determine independently which school-based job assigned using a chart or the ChatPC. ',NULL,NULL),(2363,6600,'FI Career Education',2,' Gather the equipment necessary to carry out responsibilities in the school.',NULL,NULL),(2364,6600,'FI Career Education',3,' Return equipment to the proper location after completion of a school-based job. ',NULL,NULL),(2365,6600,'FI Career Education',4,' Independently go to the start up location of a school-based job. ',NULL,NULL),(2366,6600,'FI Career Education',5,' Work through the steps of a school-based job with increasing independence.',NULL,NULL),(2367,6600,'FI Career Education',6,' Complete the steps of the job with neatness and accuracy. ',NULL,NULL),(2368,6600,'FI Career Education',7,' Avoid distractions that would interrupt the work schedule.',NULL,NULL),(2369,6600,'FI Career Education',8,' Deal appropriately with complications that may arise - locked door, moved recycling basket.',NULL,NULL),(2370,6600,'FI Career Education',9,' Interact appropriately using eye contact, gestures or ChatPC with students and staff who initate a greeting or comment. ',NULL,NULL),(2371,6600,'FI Career Education',10,' Control voice and arm movement when moving in and out of classrooms. ',NULL,NULL),(2373,6900,'FI Technology',1,' Type user name/password independently to access Sun computers.',NULL,NULL),(2374,6900,'FI Technology',2,' Manipulate a variety of game sites on the computer.',NULL,NULL),(2375,6900,'FI Technology',3,' Recognize bookmarks for favorite activities. ',NULL,NULL),(2376,6900,'FI Technology',4,' Access free standing computer using desktop icons and CD\'s.',NULL,NULL),(2377,6900,'FI Technology',5,' Use a variety of activity programs on the free standing computer. ',NULL,NULL),(2378,6500,'FI Communication',19,' Increase receptive and expressive knowledge of signed English in conversations.',NULL,NULL),(2379,6500,'FI Communication',20,' Sign and read signs of groups of words such as foods, movements, leisure activities. ',NULL,NULL),(2380,6500,'FI Communication',21,' Be fluent in the signs relating to law enforcement and the courts. ',NULL,NULL),(2381,4100,'AEP Work Experience',1,' Develop an awareness of interests, abilities and attitudes in the workplace. ',NULL,NULL),(2382,4100,'AEP Work Experience',2,' Experience a variety of work placements.',NULL,NULL),(2383,4100,'AEP Work Experience',3,' Dress appropriately for the work place.',NULL,NULL),(2384,4100,'AEP Work Experience',4,' Practice proper hygiene to enhance acceptance at the work place.',NULL,NULL),(2385,4100,'AEP Work Experience',5,' Perform work placement assignments accurately and efficiently.',NULL,NULL),(2386,4100,'AEP Work Experience',6,' Display a pleasant, cooperative manner at the work placement. ',NULL,NULL),(2387,4100,'AEP Work Experience',7,' Develop a well-organized resume and update it yearly.',NULL,NULL),(2388,4100,'AEP Work Experience',8,' Fill out a variety of job application forms.',NULL,NULL),(2389,4100,'AEP Work Experience',9,' Know and experience the avenues of job searches - newspaper, employment centre, internet.',NULL,NULL),(2390,4100,'AEP Work Experience',10,' Develop confidence in taking part in an interview. ',NULL,NULL),(2391,4100,'AEP Work Experience',11,' Understand the rights and responsibilities of employers and employees. ',NULL,NULL),(2969,704,'Writing Skills',83,'Recognize and name five capital letters',NULL,NULL),(2410,1399,'Social Development',46,' Introduces oneself',NULL,NULL),(2991,1104,'Extending Spelling Skills',22,'Spell words with unconventional spellings, single vowels (kind, full) silent e (whose, sure) two vowels (bread)',NULL,NULL),(2412,1399,'Social Development',47,' Gives compliments',NULL,NULL),(2413,1399,'Social Development',48,' Receives compliments politely',NULL,NULL),(2415,1399,'Social Development',49,' Shares',NULL,NULL),(2416,1399,'Social Development',50,' Displays sportsmanship',NULL,NULL),(2993,1104,'Extending Spelling Skills',24,'Spell words with the  /PH/ spelling of f',NULL,NULL),(2418,1399,'Social Development',51,' Helps others',NULL,NULL),(2419,1399,'Social Development',52,' Uses appropriate language',NULL,NULL),(2827,8080,'Decimals',9,'When given ten problems requiring the subraction of decimals, will correctly compute the answers for subtracting decimals with tenths.',NULL,NULL),(2826,8080,'Decimals',8,'When given ten problems requiring the addition of decimals, will correctly compute the answers for adding decimals with hundredths and thousandths.',NULL,NULL),(2952,8096,'Rounding Numbers',7,'When given five numbers, will round the numbers accurately to the nearest thousandth.',NULL,NULL),(2951,8096,'Rounding Numbers',6,'When given five numbers, will round the numbers accurately to the nearest hundredth.',NULL,NULL),(2899,8090,'Measurement',24,'When given 5 imcomplete statements for the conversion of metric measurements for volume and mass to equivalent metric measurements, will complete the statements accurately for converting kilograms to grams.',NULL,NULL),(2825,8080,'Decimals',7,'When given ten problems requiring the addition of decimals, will correctly compute the answers for adding decimals with thousandths.',NULL,NULL),(2824,8080,'Decimals',6,'When given ten problems requiring the addition of decimals, will correctly compute the answers for adding decimals with tenths and hundredths.',NULL,NULL),(2440,4500,'AEP GED Preparation',1,' Receive instruction and practice in the required skill areas.',NULL,NULL),(2441,4500,'AEP GED Preparation',2,' Practise with test items like those found on a GED test.',NULL,NULL),(2442,4500,'AEP GED Preparation',3,' Receive some test taking tips.',NULL,NULL),(2443,4500,'AEP GED Preparation',4,' Do several timed test practices.',NULL,NULL),(2444,4500,'AEP GED Preparation',5,' Chart progress during the preparation for the test. ',NULL,NULL),(2445,4500,'AEP GED Preparation',6,' Complete one or two practice GED tests.',NULL,NULL),(2446,4500,'AEP GED Preparation',7,' Visit the setting where the GED test will be written. ',NULL,NULL),(2447,3200,'AEP Science',12,' Distinguish between living and non-living things.',NULL,NULL),(2448,3200,'AEP Science',13,' Idnetify common needs of all living things to',NULL,NULL),(2449,3200,'AEP Science',14,' Perform activities to demonstrate an understanding of the basic needs of living things.',NULL,NULL),(2450,3200,'AEP Science',15,' Identify a Food chain.',NULL,NULL),(2451,3200,'AEP Science',16,' Discuss the interrelationship between humans and other living and non-living things.',NULL,NULL),(2452,3200,'AEP Science',17,' Identify the major organs of each of  the systems.',NULL,NULL),(2453,3200,'AEP Science',18,' Explain the basic operation of  each of the systems.',NULL,NULL),(2454,3200,'AEP Science',19,' Identify illnesses/problems common to the system.',NULL,NULL),(2455,3200,'AEP Science',20,' Identify ways to maintain and improve body functions.',NULL,NULL),(2456,3200,'AEP Science',21,' Explain the difference between physical and mental health.',NULL,NULL),(2457,3200,'AEP Science',22,' Recognize that physical and mental health are interrelated.',NULL,NULL),(2458,3200,'AEP Science',23,' Identify factors that affect mental state.',NULL,NULL),(2459,3200,'AEP Science',24,' Discuss ways of dealing with stress.',NULL,NULL),(2460,3200,'AEP Science',25,' Identify the elements of good nutrition.',NULL,NULL),(2461,3200,'AEP Science',26,' Recognize the importance of physical excercise in promoting wellness.',NULL,NULL),(2462,3200,'AEP Science',27,' Explain the difference between communicable and non-communicable diseases.',NULL,NULL),(2463,3200,'AEP Science',28,' Identify common communicable diseases.',NULL,NULL),(2464,3200,'AEP Science',29,' Explain how communicable diseases are spread.',NULL,NULL),(2465,3200,'AEP Science',30,' Recognize that sexually transmitted diseases are communicable.',NULL,NULL),(2466,3200,'AEP Science',31,' Determine ways to reduce the threat of disease.',NULL,NULL),(2467,3200,'AEP Science',32,' Identify common S.T.D. s the symptoms and cures.',NULL,NULL),(2468,3200,'AEP Science',33,' Discuss ways of preventing S.T.D.s.',NULL,NULL),(2469,3200,'AEP Science',34,' Assess whether a drug is beneficial or harmful.',NULL,NULL),(2470,3200,'AEP Science',35,' Understand how to properly take prescription or over the counter drugs.',NULL,NULL),(2471,3200,'AEP Science',36,' Examine possible side effects of prescribed drugs.',NULL,NULL),(2472,3200,'AEP Science',37,' Explain what they should do if they experience side effects of a drug.',NULL,NULL),(2473,3200,'AEP Science',38,' Identify alcohol, nicotine, marijuana and other mood altering drugs.',NULL,NULL),(2474,3200,'AEP Science',39,' Recognize the effects of these drugs on the individual.',NULL,NULL),(2475,3200,'AEP Science',40,' Identify elements of the environment.',NULL,NULL),(2476,3200,'AEP Science',41,' Investigate ways that people affect the environment.',NULL,NULL),(2477,3200,'AEP Science',42,' Define pollution.',NULL,NULL),(2478,3200,'AEP Science',43,' Assess the effect of environmental change on people.',NULL,NULL),(2479,3200,'AEP Science',44,' Identify the main principles of pollution reduction.',NULL,NULL),(2480,3200,'AEP Science',45,' Identify ways in which they can personally reduce pollution.',NULL,NULL),(2481,3200,'AEP Science',46,' Employ the pollution reduction procedures of reducing, reusing, and recycling.',NULL,NULL),(2483,4200,'AEP Subject Areas',8,' Use Laptop PC for written assignments.',NULL,NULL),(2484,4200,'AEP Subject Areas',9,' Be responsible to keeping track of assignments and due dates. ',NULL,NULL),(2485,2600,'Other subjects',1,' Science',NULL,NULL),(2486,2600,'Other subjects',2,' Social Studies',NULL,NULL),(2487,2600,'Other subjects',3,' Religion',NULL,NULL),(2488,2600,'Other subjects',4,' Fine Arts',NULL,NULL),(2489,2600,'Other subjects',5,' Physical Education',NULL,NULL),(2490,2600,'Other subjects',6,' Health',NULL,NULL),(2491,606,'Reading',38,' Recognizes grade two Dolch Sight Words',NULL,NULL),(2517,6700,'FI Community Involvement',2,'Follow a schedule and using the Chat PC identify the activity of the day. ',NULL,NULL),(2518,6700,'FI Community Involvement',3,'Become independent in preparing for the activity.(outer clothes,equipment)',NULL,NULL),(2519,6700,'FI Community Involvement',4,'Handle the transition of leaving and returning to the school.',NULL,NULL),(2516,6700,'FI Community Involvement',1,'Follow a schedule and be able to identify the activity for the day. ',NULL,NULL),(2520,6700,'FI Community Involvement',5,'Show cooperation and appropriate behavior during the transport to and from the activity placement.',NULL,NULL),(2521,6700,'FI Community Involvement',6,'Display behavior appropriate to the activity placement. ',NULL,NULL),(2522,6700,'FI Community Involvement',7,'Communicate with the school personnel and the personnel at the activity placement. ',NULL,NULL),(2523,6700,'FI Community Involvement',8,'Communicate using the Chat PC with the school personnel and the personnel at the activity placement.',NULL,NULL),(2524,6700,'FI Community Involvement',9,'Participate in all the planned activities. ',NULL,NULL),(2525,6700,'FI Community Involvement',10,'Be able to respond correctly to the query, \"What did you do at __ today?\"',NULL,NULL),(2526,6700,'FI Community Involvement',11,'Be able to respond correctly using the Chat PC to the query, \"What did you do at __ today?\"',NULL,NULL),(2527,7000,'FI Health Club',1,'Distinguish between a fruit and a vegetable.',NULL,NULL),(2528,7000,'FI Health Club',2,'Use the Chat PC to distinguish a fruit and a vegetable.',NULL,NULL),(2529,7000,'FI Health Club',3,'Identify at least fifteen common fruits and vegetables. ',NULL,NULL),(2530,7000,'FI Health Club',4,'Use the Chat PC to label at least fifteen common fruits and vegetables.',NULL,NULL),(2531,7000,'FI Health Club',5,'Experiment with the taste of a wide variety of fruits and vegetables.',NULL,NULL),(2532,7000,'FI Health Club',6,'Show an understanding of the importance of cleanliness when dealing with foods by washing independently.',NULL,NULL),(2533,7000,'FI Health Club',7,'Use kitchen utensils correctly and safely.',NULL,NULL),(2534,7000,'FI Health Club',8,'Wash fruit and place gently in storage containers. ',NULL,NULL),(2535,7000,'FI Health Club',9,'Wash vegetables and prepare for final cutting or dicing. ',NULL,NULL),(2536,7000,'FI Health Club',10,'Peel carrots.',NULL,NULL),(2537,7000,'FI Health Club',11,'Cut cucumbers, carrots, celery, peppers correctly.',NULL,NULL),(2538,7000,'FI Health Club',12,'Prepare containers with one serving of each fruit or vegetable.',NULL,NULL),(2539,7000,'FI Health Club',13,'Wash and rinse food containers and utensils. ',NULL,NULL),(2540,7000,'FI Health Club',14,'Assist in the general cleanup of the kitchen.',NULL,NULL),(2541,7000,'FI Health Club',15,'Choose fruits and vegetables that are free of bruises and spoilage. ',NULL,NULL),(2542,7000,'FI Health Club',16,'Cooperatively assist in transporting the bags of produce to the vehicle and later into the school.',NULL,NULL),(2543,7000,'FI Health Club',17,'Use eye contact and greet less familiar teachers during the delivery process.',NULL,NULL),(2544,7000,'FI Health Club',18,'Use manners and proper speech in deliveries. ',NULL,NULL),(2545,7000,'FI Health Club',19,'Use the Chat PC to greet teachers and also to respond to thank yous. ',NULL,NULL),(2546,3100,'AEP Mathematics',104,'Be able to achieve adequate success in AEP Grade 8 Math Program.',NULL,NULL),(2547,3100,'AEP Mathematics',105,'Be able to achieve adequate success in AEP Grade 9 Math Program.',NULL,NULL),(2548,3100,'AEP Mathematics',106,'Be able to achieve adequate success in Math 18 Program.',NULL,NULL),(2549,3100,'AEP Mathematics',107,'Be able to achieve adequate success in Math 28 Program.',NULL,NULL),(2550,3100,'AEP Mathematics',108,'Be able to achieve adequate success in Math 38 Program.',NULL,NULL),(2551,3100,'AEP Mathematics',109,'Completes class time assignments in the AEP Math program.',NULL,NULL),(2552,3100,'AEP Mathematics',110,'Completes homework assignments in the AEP Math program.',NULL,NULL),(2553,3100,'AEP Mathematics',111,'Knows addition facts.',NULL,NULL),(2554,3100,'AEP Mathematics',112,'Knows subtraction facts. ',NULL,NULL),(2555,3100,'AEP Mathematics',113,'Knows multiplication facts. ',NULL,NULL),(2950,8096,'Rounding Numbers',5,'When given five numbers, will round the numbers accurately to the nearest tenth.',NULL,NULL),(2949,8096,'Rounding Numbers',4,'When given five numbers, will round the numbers accurately to the nearest ten thousand.',NULL,NULL),(2948,8096,'Rounding Numbers',3,'When given five numbers, will round the numbers accurately to the nearest thousand.',NULL,NULL),(2975,1104,'Extending Spelling Skills',6,'Spell words with variants, x, c, k, s, ck',NULL,NULL),(2915,8065,'Fractions',16,'When given five fractions and/or mixed numbers that require conversion, will correctly make the conversions for mixed numbers to improper fractions to mixed numbers.',NULL,NULL),(2584,1104,'Extending Spelling Skills',49,'Understand heteronyms (lead-led);(lead-leed)',NULL,NULL),(2914,8065,'Fractions',15,'When given five fractions and/or mixed numbers that require conversion, will correctly make the conversions for improper fractions to mixed numbers.',NULL,NULL),(2587,1104,'Extending Spelling Skills',51,'Corectly spell EL sound (model)',NULL,NULL),(2588,1104,'Extending Spelling Skills',52,'Correctly spell AL sound (central)',NULL,NULL),(2953,8096,'Rounding Numbers',8,'When given five numbers, will round the numbers accurately to the nearest million.',NULL,NULL),(2590,8000,'Number Recognition',1,'When shown the numbers 0-5, will read the numbers aloud ',NULL,NULL),(2591,8000,'Number Recognition',2,'When shown the numbers 0-10, will read the numbers aloud ',NULL,NULL),(2592,8000,'Number Recognition',3,'When shown ten numbers, will read the numbers aloud for numbers up to 20.',NULL,NULL),(2593,8000,'Number Recognition',4,'When shown ten numbers, will read the numbers aloud for numbers up to 25.',NULL,NULL),(2594,8000,'Number Recognition',5,'When shown ten numbers, will read the numbers aloud for numbers up to 50.',NULL,NULL),(2595,8000,'Number Recognition',6,'When shown ten numbers, will read the numbers aloud for numbers up to 100.',NULL,NULL),(2596,8000,'Number Recognition',7,'When shown ten numbers, will read the numbers aloud for numbers up to 1,000.',NULL,NULL),(2597,8000,'Number Recognition',8,'When shown ten numbers, will read the numbers aloud for numbers up to 10, 000.',NULL,NULL),(2598,8000,'Number Recognition',9,'When shown ten numbers, will read the numbers aloud for numbers up to 100,000.',NULL,NULL),(2599,8000,'Number Recognition',10,'When shown ten numbers, will read the numbers aloud for numbers up to 1,000,000.',NULL,NULL),(2600,8010,'Sequencing Numbers',1,'Will sequence the numbers 1-5.',NULL,NULL),(2601,8010,'Sequencing Numbers',2,'Will sequence the numbers 1-10.',NULL,NULL),(2602,8010,'Sequencing Numbers',3,'When given five numbers, from the numbers 1-20, will put them in numerical order.',NULL,NULL),(2603,8010,'Sequencing Numbers',4,'When given five numbers, from the numbers 1-25, will put them in numerical order.',NULL,NULL),(2604,8010,'Sequencing Numbers',5,'When given five numbers, from the numbers 1-50, will put them in numerical order.',NULL,NULL),(2605,8010,'Sequencing Numbers',6,'When given five numbers, from the numbers 1-100, will put them in numerical order.',NULL,NULL),(2606,8010,'Sequencing Numbers',7,'When given five numbers, from the numbers 1-1,000, will put them in numerical order.',NULL,NULL),(2607,8010,'Sequencing Numbers',8,'When given five numbers, from the numbers 1-10,000, will put them in numerical order.',NULL,NULL),(2608,8010,'Sequencing Numbers',9,'When given five numbers, from the numbers 1-100,000, will put them in numerical order.',NULL,NULL),(2609,8010,'Sequencing Numbers',10,'When given five numbers, from the numbers 1-1,000,000,000, will put them in numerical order.',NULL,NULL),(2729,8065,'Fractions',1,'When given a fraction shown by a shaded picture or with the fraction shown in a concrete object, will correctly identify the fraction as 1/2.',NULL,NULL),(2740,1801,'Study and Work Skills',28,'Student will set realistic personal goals.',NULL,NULL),(2946,8096,'Rounding Numbers',1,'When given five numbers, will round the numbers accurately to the nearest ten.',NULL,NULL),(2739,1801,'Study and Work Skills',10,'Student will follow directions and timelines.',NULL,NULL),(2738,1801,'Study and Work Skills',18,'Student will complete assignments on time.',NULL,NULL),(2737,1801,'Study and Work Skills',17,'Student will manage class time effectively.',NULL,NULL),(2736,1801,'Study and Work Skills',24,'Student will keep notebooks organized according to teacher expectations.',NULL,NULL),(2620,8015,'Ordinal Numbers',1,'When shown ten objects in a line, will point to the correct object as each ordinal position first and last is given.',NULL,NULL),(2621,8015,'Ordinal Numbers',2,'When shown ten objects in a line, will point to the correct object as each ordinal position first, second, third is given. ',NULL,NULL),(2622,8015,'Ordinal Numbers',3,'When shown ten objects in a line, will point to the correct object as each ordinal position,  first through fifth is given.',NULL,NULL),(2623,8015,'Ordinal Numbers',4,'When shown ten objects in a line, will point to the correct object as each ordinal position,  first through tenth is given.',NULL,NULL),(2881,8090,'Measurement',6,'Will be able to read and comprehend weight measurement vocabulary ( milligrams, grams, kilograms).',NULL,NULL),(2880,8090,'Measurement',5,'Will be able to read and comprehend liquid measurement vocabulary (measure, milliliters, liters, kiloliters, volume, and graduations).',NULL,NULL),(2624,8020,'Writing Numbers',1,'Will write the numbers 0-5, when dictated.',NULL,NULL),(2625,8020,'Writing Numbers',2,'Will write the numbers 0-10, when dictated.',NULL,NULL),(2626,8020,'Writing Numbers',3,'Will write the numbers 0-20, when dictated.',NULL,NULL),(2627,8020,'Writing Numbers',4,'Will write the numbers 0-25, when dictated.',NULL,NULL),(2628,8020,'Writing Numbers',5,'Will write the numbers, when given ten dictated numbers, from the range 0-50.',NULL,NULL),(2629,8020,'Writing Numbers',6,'Will write the numbers, when given ten dictated numbers, from the range 0-100.',NULL,NULL),(2630,8020,'Writing Numbers',7,'Will write the numbers, when given ten dictated numbers, from the range 0-1,000.',NULL,NULL),(2631,8020,'Writing Numbers',8,'Will write the numbers, when given ten dictated numbers, from the range 0-10,000.',NULL,NULL),(2632,8020,'Writing Numbers',9,'Will write the numbers, when given ten dictated numbers, from the range 0-100,000.',NULL,NULL),(2633,8020,'Writing Numbers',10,'Will write the numbers, when given ten dictated numbers, from the range 0-1,000,000.',NULL,NULL),(2636,7010,'Emotional Skills',3,'child will demonstrate appropriate behaviours to deal with aggression or anger as taught by the teacher.',NULL,NULL),(2637,7010,'Emotional Skills',4,'Child will be able to consider alternatives to the problem setting.',NULL,NULL),(2638,7010,'Emotional Skills',5,'Child will be able to consider the consequences of the alternative behaviours of the situation.',NULL,NULL),(2639,7010,'Emotional Skills',6,'Child will choose the most appropriate response for the situation.',NULL,NULL),(2640,7010,'Emotional Skills',8,'Child will recognize frustration in self and employ a technique to deal with it as taught by the teacher.',NULL,NULL),(2641,7010,'Emotional Skills',9,'Child will respond appropriately to redirection from the teacher.',NULL,NULL),(2642,7010,'Emotional Skills',10,'Child will learn to ask for clarification when he needs help.',NULL,NULL),(2643,7010,'Emotional Skills',11,'Child will learn to try when it is hard.',NULL,NULL),(2644,7010,'Emotional Skills',12,'Child will learn to take a time out when necessary.',NULL,NULL),(2645,7010,'Emotional Skills',13,'Child will respond to behavioural plan to keep him in school as outlined by the school.',NULL,NULL),(2823,8080,'Decimals',5,'When given ten problems requiring the addition of decimals, will correctly compute the answers for adding decimals with hundredths.',NULL,NULL),(2822,8080,'Decimals',4,'When given ten problems requiring the addition of decimals, will correctly compute the answers for adding decimals with tenths.',NULL,NULL),(2821,8080,'Decimals',3,'When given 2 lists of 5 decimals with tenths, hundredths, and thousands,  will write the decimals in order of value.',NULL,NULL),(2661,7010,'Emotional Skills',14,'Child will demonstrate anger management techniques as taught by the teacher.',NULL,NULL),(2662,8030,'Number Facts-Subtraction',1,'Will correctly compute the differences, when given ten subtraction facts, for minuends up to 4.',NULL,NULL),(2663,8030,'Number Facts-Subtraction',2,'Will correctly compute the differences, when given ten subtraction facts, for minuends up to 6.',NULL,NULL),(2664,8030,'Number Facts-Subtraction',3,'Will correctly compute the differences, when given ten subtraction facts, for minuends up to 8.',NULL,NULL),(2665,8030,'Number Facts-Subtraction',4,'Will correctly compute the differences, when given ten subtraction facts, for minuends up to 10.',NULL,NULL),(2666,8030,'Number Facts-Subtraction',5,'Will correctly compute the differences, when given ten subtraction facts, for minuends up to 12.',NULL,NULL),(2667,8030,'Number Facts-Subtraction',6,'Will correctly compute the differences, when given ten subtraction facts, for minuends up to 14.',NULL,NULL),(2668,8030,'Number Facts-Subtraction',7,'Will correctly compute the differences, when given ten subtraction facts, for minuends up to 16.',NULL,NULL),(2669,8030,'Number Facts-Subtraction',8,'Will correctly compute the differences, when given ten subtraction facts, for minuends up to 18.',NULL,NULL),(2670,8030,'Number Facts-Subtraction',9,'Will correctly compute the differences, when given ten subtraction facts, for minuends up to 20.',NULL,NULL),(2673,8025,'Number Facts-Addition',3,'Will correctly compute the sums, when given ten addition facts, for sums up to 8.',NULL,NULL),(2674,8025,'Number Facts-Addition',4,'Will correctly compute the sums, when given ten addition facts, for sums up to 10.',NULL,NULL),(2675,8025,'Number Facts-Addition',5,'Will correctly compute the sums, when given ten addition facts, for sums up to 12.',NULL,NULL),(2676,8025,'Number Facts-Addition',6,'Will correctly compute the sums, when given ten addition facts, for sums up to 14.',NULL,NULL),(2677,8025,'Number Facts-Addition',7,'Will correctly compute the sums, when given ten addition facts, for sums up to 16.',NULL,NULL),(2678,8025,'Number Facts-Addition',8,'Will correctly compute the sums, when given ten addition facts, for sums up to 18.',NULL,NULL),(2679,8025,'Number Facts-Addition',9,'Will correctly compute the sums, when given ten addition facts, for sums up to 20.',NULL,NULL),(2990,1104,'Extending Spelling Skills',21,'Spell words with vowel variants, ie',NULL,NULL),(2680,804,'Consonant and Vowel Sounds',1,'Recognize short vowels, a e i o u (medial position)',NULL,NULL),(2681,804,'Consonant and Vowel Sounds',2,'Sound out vowel sounds, a e i o u (medial positions)',NULL,NULL),(2682,804,'Consonant and Vowel Sounds',3,'Recognize key consonants , b c d f g h j k l m n p r s t v w y z ',NULL,NULL),(2683,804,'Consonant and Vowel Sounds',4,'Sound out key consonants, b c d f g h j k l m n p r s t v w y z',NULL,NULL),(2687,8035,'Number Facts- Multiplication',4,'Will correctly compute the product, when given ten multiplication facts, for the multipliers up to 5.',NULL,NULL),(2688,8035,'Number Facts- Multiplication',5,'Will correctly compute the product, when given ten multiplication facts, for the multipliers up to 6.',NULL,NULL),(2689,8035,'Number Facts- Multiplication',6,'Will correctly compute the product, when given ten multiplication facts, for the multipliers up to 7.',NULL,NULL),(2690,8035,'Number Facts- Multiplication',7,'Will correctly compute the product, when given ten multiplication facts, for the multipliers up to 8.',NULL,NULL),(2691,8035,'Number Facts- Multiplication',8,'Will correctly compute the product, when given ten multiplication facts, for the multipliers up to 9.',NULL,NULL),(2692,8035,'Number Facts- Multiplication',9,'Will correctly compute the product, when given ten multiplication facts, for the multipliers up to 10.',NULL,NULL),(2693,8035,'Number Facts- Multiplication',10,'Will correctly compute the product, when given ten multiplication facts, for the multipliers up to 12.',NULL,NULL),(2696,8040,'Number Facts-Division',3,'Will correctly compute the quotients, when given ten division facts, for the divisors up to 4.',NULL,NULL),(2697,8040,'Number Facts-Division',4,'Will correctly compute the quotients, when given ten division facts, for the divisors up to 5.',NULL,NULL),(2698,8040,'Number Facts-Division',5,'Will correctly compute the quotients, when given ten division facts, for the divisors up to 6.',NULL,NULL),(2699,8040,'Number Facts-Division',6,'Will correctly compute the quotients, when given ten division facts, for the divisors up to 7.',NULL,NULL),(2700,8040,'Number Facts-Division',7,'Will correctly compute the quotients, when given ten division facts, for the divisors up to 8.',NULL,NULL),(2701,8040,'Number Facts-Division',8,'Will correctly compute the quotients, when given ten division facts, for the divisors up to 9.',NULL,NULL),(2704,8045,'Addition',3,'Will correctly compute the answers, when given ten addition problems ,for adding 3 digit numbers without regrouping.',NULL,NULL),(2705,8045,'Addition',4,'Will correctly compute the answers, when given ten addition problems, for adding 3 digit numbers with 1 regrouping.',NULL,NULL),(2706,8045,'Addition',5,'Will correctly compute the answers, when given ten addition problems, for adding 3 digit numbers with 2 regroupings.',NULL,NULL),(2707,8045,'Addition',6,'Will correctly compute the answers, when given ten addition problems, for adding 4 digit numbers with 2 regroupings.',NULL,NULL),(2708,8045,'Addition',7,'Will correctly compute the answers, when given ten addition problems, for adding  4 digit numbers with 3 regroupings. ',NULL,NULL),(3016,2600,'Other subjects',7,'Reading',NULL,NULL),(2711,8050,'Subtraction',3,'Will correctly compute the answers, when given ten subtraction problems, for subracting numbers with 3 digits without regrouping.',NULL,NULL),(2712,8050,'Subtraction',4,'Will correctly compute the answers, when given ten subtraction problems, for subracting numbers with 3 digits with 1 regrouping.',NULL,NULL),(2713,8050,'Subtraction',5,'Will correctly compute the answers, when given ten subtraction problems, for subracting numbers with 3 digits with 2 regroupings.',NULL,NULL),(2714,8050,'Subtraction',6,'Will correctly compute the answers, when given ten subtraction problems, for subracting numbers with 4 digits with 3 regroupings.',NULL,NULL),(2838,116,'Phonological Awareness',1,'student will count syllables of words',NULL,NULL),(2715,8055,'Multiplication',1,'Will correctly compute the answers, when given ten multiplication problems, for multiplying numbers with 2 digits X 1 digit without regrouping.',NULL,NULL),(2716,8055,'Multiplication',2,'Will correctly compute the answers, when given ten multiplication problems, for multiplying numbers with 2 digits X 1 digit with regrouping.',NULL,NULL),(2717,8055,'Multiplication',3,'Will correctly compute the answers, when given ten multiplication problems, for multiplying numbers with 3 digits X 2 digits with regrouping and no zero in multiplier.',NULL,NULL),(2718,8055,'Multiplication',4,'Will correctly compute the answers, when given ten multiplication problems, for multiplying numbers with 3 digits X 2 digit with regrouping and zero in multiplier.',NULL,NULL),(2719,8055,'Multiplication',5,'Will correctly compute the answers, when given ten multiplication problems, for multiplying numbers with 3 digits X 3 digit with regrouping and no zero in multiplier.',NULL,NULL),(2720,8055,'Multiplication',6,'Will correctly compute the answers, when given ten multiplication problems, for multiplying numbers with 3 digits X 3 digit with regrouping and  zero in multiplier.',NULL,NULL),(2721,8060,'Division',1,'Will correctly compute the answers, when given ten division problems, for dividing numbers with 2 digits by 1 digit.',NULL,NULL),(2722,8060,'Division',2,'Will correctly compute the answers, when given ten division problems, for dividing numbers with 2 digits by 2 digits.',NULL,NULL),(2723,8060,'Division',3,'Will correctly compute the answers, when given ten division problems, for dividing numbers with 3 digits by 2 digits with 1 digit in quotient.',NULL,NULL),(2724,8060,'Division',4,'Will correctly compute the answers, when given ten division problems, for dividing numbers with 3 digits by 2 digits with 2 digits in quotient.',NULL,NULL),(2725,8060,'Division',5,'Will correctly compute the answers, when given ten division problems, for dividing numbers with 4 digits by 3 digits with no zero in quotient.',NULL,NULL),(2726,8060,'Division',6,'Will correctly compute the answers, when given ten division problems, for dividing numbers with 4 digits by 3 digits with zero in quotient.',NULL,NULL),(2860,116,'Phonological Awareness',11,'student will identify letter-sound associations (consonants, long/short vowels, consonant blends, consonant diagraphs, r-controlled vowels, vowel diagraphs, diphthongs)',NULL,NULL),(2727,7010,'Emotional Skills',7,'Child will accept the consequences of personal decisions.',NULL,NULL),(2728,7010,'Emotional Skills',15,'Child will demonstrate self-control by employing techniques as taught by the teacher.',NULL,NULL),(2730,8065,'Fractions',2,'When given a fraction shown by a shaded picture or with the fraction shown in a concrete object, will correctly identify the fraction as 1/3.',NULL,NULL),(2731,8065,'Fractions',3,'When given a fraction shown by a shaded picture or with the fraction shown in a concrete object, will correctly identify the fraction as 1/4.',NULL,NULL),(2732,8065,'Fractions',4,'When given a fraction shown by a shaded picture or with the fraction shown in a concrete object, will correctly identify the fraction as 1/5.',NULL,NULL),(2733,8065,'Fractions',5,'When given a fraction shown by a shaded picture or with the fraction shown in a concrete object, will correctly identify the fraction as 1/6.',NULL,NULL),(2734,8065,'Fractions',6,'When given a fraction shown by a shaded picture or with the fraction shown in a concrete object, will correctly identify the fraction as 1/8.',NULL,NULL),(2741,1801,'Study and Work Skills',19,'Student will budget time for activities.',NULL,NULL),(2743,8065,'Fractions',8,'When given a fraction shown by a shaded picture or with the fraction shown in a concrete object, will correctly identify the fraction as 1/3.',NULL,NULL),(2744,8065,'Fractions',9,'When given a fraction shown by a shaded picture or with the fraction shown in a concrete object, will correctly identify the fraction as 1/4.',NULL,NULL),(2745,8065,'Fractions',10,'When given a fraction shown by a shaded picture or with the fraction shown in a concrete object, will correctly identify the fraction as 1/5.',NULL,NULL),(2746,8065,'Fractions',11,'When given a fraction shown by a shaded picture or with the fraction shown in a concrete object, will correctly identify the fraction as 1/6.',NULL,NULL),(2747,8065,'Fractions',12,'When given a fraction shown by a shaded picture or with the fraction shown in a concrete object, will correctly identify the fraction as 1/8.',NULL,NULL),(2883,8090,'Measurement',8,'When given 5 pairs of metric measurement, will indicate if each pair is of equal value or if one of the measurements is of greater value for volume units.',NULL,NULL),(2750,1399,'Social Development',55,'Student will disagree using appropriate language/say no politely.',NULL,NULL),(2753,1399,'Social Development',56,'Student will accept criticism well.',NULL,NULL),(2754,1399,'Social Development',57,'Student will check for agreement.',NULL,NULL),(2755,1399,'Social Development',58,'Student will encourage others.',NULL,NULL),(2756,1399,'Social Development',59,'Student will share feelings.',NULL,NULL),(2757,1399,'Social Development',60,'Student will respond to others ideas.',NULL,NULL),(2758,1399,'Social Development',61,'Student will stay on topic of discussion.',NULL,NULL),(2759,1399,'Social Development',62,'Student will make a complaint in an appropriate manner.',NULL,NULL),(2760,1399,'Social Development',63,'Student will respond to a complaint in an appropriate manner.',NULL,NULL),(2761,1399,'Social Development',64,'Student will deal with another',NULL,NULL),(2762,1399,'Social Development',65,'Student will deal with feeling of being left out.',NULL,NULL),(2763,1399,'Social Development',66,'Student will avoid trouble.',NULL,NULL),(2764,1399,'Social Development',67,'Student will deal and respond appropriately to teasing.',NULL,NULL),(2765,1399,'Social Development',68,'Wants to be first',NULL,NULL),(2766,1399,'Social Development',69,'Avoids using profanity',NULL,NULL),(2767,1399,'Social Development',70,'Stays out of fights',NULL,NULL),(2771,8070,'Time',4,'Will be able to count by tens to sixty.',NULL,NULL),(2772,8070,'Time',5,'Will be able to count by fifteens to sixty.',NULL,NULL),(2773,8070,'Time',6,'Will be able to identify the hour and minute hands on an analog clock.',NULL,NULL),(2774,8070,'Time',7,'When shown an analog clock face showing time, will correctly indicate the time shown, for time intervals of one hour.',NULL,NULL),(2775,8070,'Time',8,'When shown an analog clock face showing time, will correctly indicate the time shown, for time intervals of half hour.',NULL,NULL),(2776,8070,'Time',9,'When shown an analog clock face showing time, will correctly indicate the time shown, for time intervals of quarter hour.',NULL,NULL),(2777,8070,'Time',10,'When shown an analog clock face showing time, will correctly indicate the time shown, for time intervals of five minutes.',NULL,NULL),(2778,8070,'Time',11,'When shown analog clock faces showing time, will indicate the time shown for time intervals of minutes.',NULL,NULL),(2988,1104,'Extending Spelling Skills',19,'Spell words with variants (hard and soft) c,g',NULL,NULL),(2782,1399,'Social Development',71,'Display affection to age peers and adults',NULL,NULL),(2987,1104,'Extending Spelling Skills',18,'Spell words with digraphs, gh(f- sound, eg. laugh)',NULL,NULL),(2986,1104,'Extending Spelling Skills',17,'Spell words with silent letters, gh,t,w,b,k',NULL,NULL),(2985,1104,'Extending Spelling Skills',16,'Spell words with final blends, ft,ld,lk,mp,nd,nt,rd,sk,st',NULL,NULL),(2984,1104,'Extending Spelling Skills',15,'Spell words with initial blends, pr,sc,sk,squ,sm,tw,gw',NULL,NULL),(2791,1399,'Social Development',72,'Respect privacy of others',NULL,NULL),(2983,1104,'Extending Spelling Skills',14,'Spell words with unconventional spellings, single vowels(from, off, cold) silent e(give,done) two vowels(been, said) other (they,eye)',NULL,NULL),(2982,1104,'Extending Spelling Skills',13,'Spell words with final y',NULL,NULL),(2796,1399,'Social Development',73,'Accept choices made by others',NULL,NULL),(2797,1399,'Social Development',74,'Respond to verbal and non-verbal communication',NULL,NULL),(2901,1401,'Personal Development',33,'Cut finger nails',NULL,NULL),(2819,8080,'Decimals',1,'When given 2 lists of 5 decimals with tenths, will write the decimals in order of value.',NULL,NULL),(2799,200,'Gross Motor Development',86,'Throw a bean bag with accuracy',NULL,NULL),(2800,200,'Gross Motor Development',87,'Hit ball with bat or stick',NULL,NULL),(2801,200,'Gross Motor Development',90,'Run while dribbling ball for 4 meters',NULL,NULL),(2802,8075,'Money',1,'When shown 6 coins will give the name of each coin(penny, nickel, dime, quarter, loonie, toonie)',NULL,NULL),(2803,8075,'Money',2,'When shown 6 coins will give the value of each coin(penny, nickel, dime, quarter, loonie, toonie)',NULL,NULL),(2804,8075,'Money',3,'When given an  incomplete statement about the equivalent values of a coin, will complete the statement to indicate knowlege of 1 nickel=5 cents',NULL,NULL),(2805,8075,'Money',4,'When given an  incomplete statement about the equivalent values of a coin, will complete the statement to indicate knowlege of 1 dime=2 nickels.',NULL,NULL),(2806,8075,'Money',5,'When given an  incomplete statement about the equivalent values of a coin, will complete the statement to indicate knowlege of 1 dime=10 cents.',NULL,NULL),(2807,8075,'Money',6,'When given an  incomplete statement about the equivalent values of a coin, will complete the statement to indicate knowlege of 1 quarter=25 cents.',NULL,NULL),(2808,8075,'Money',7,'When given an  incomplete statement about the equivalent values of a coin, will complete the statement to indicate knowlege of 1 quarter=5 nickels.',NULL,NULL),(2809,8075,'Money',8,'When given an  incomplete statement about the equivalent values of a coin, will complete the statement to indicate knowlege of 1 dollar(loonie)=4 quarters.',NULL,NULL),(2810,8075,'Money',9,'When given an  incomplete statement about the equivalent values of a coin, will complete the statement to indicate knowlege of 1 dollar(loonie)=10 dimes',NULL,NULL),(2811,8075,'Money',10,'When given an  incomplete statement about the equivalent values of a coin, will complete the statement to indicate knowlege of 1 dollar(loonie)=20 nickels.',NULL,NULL),(2812,8075,'Money',11,'Will be able to convert a group of coins to another group of coins that equals the same amount, when given a group of coins converting nickels to dimes and cents.',NULL,NULL),(2813,8075,'Money',12,'Will be able to convert a group of coins to another group of coins that equals the same amount, when given a group of coins converting dimes to quarters, dimes, nickels, and cents.',NULL,NULL),(2814,8075,'Money',13,'Will be able to convert a group of coins to another group of coins that equals the same amount, when given a group of coins converting quarters to dimes and nickels.',NULL,NULL),(2815,8075,'Money',14,'When given problems on making change for purchase made with a coin, will determine the fewest number of coins needed to make the correct change for dime, quarter, loonie, toonie, five and ten dollar bills.',NULL,NULL),(3002,1104,'Extending Spelling Skills',33,'Spell words with unconventional spellings ( bush, lose, busy)',NULL,NULL),(3001,1104,'Extending Spelling Skills',32,'Spell words with /E/ sound (castle)',NULL,NULL),(3000,1104,'Extending Spelling Skills',31,'Spell words with /AL/ sound (chalk)',NULL,NULL),(2864,116,'Phonological Awareness',15,'student will demonstrate knowledge of basic word families and patterns',NULL,NULL),(2865,116,'Phonological Awareness',16,'student will demonstrate ability to decode single syllable words and nonsense words containing various combinations of consonants, long/short vowels, consonant blends, consonant diagraphs, r-controlled vowels, vowel diagraphs, diphthongs',NULL,NULL),(2866,116,'Phonological Awareness',17,'student will demonstrate ability to use knowledge of letter-sound correspondence to sound out unknown words',NULL,NULL),(2867,116,'Phonological Awareness',18,'student will demonstrate ability to recognize common irregularily spelled words by sight (e.g., said, two)',NULL,NULL),(2868,116,'Phonological Awareness',19,'student will demonstrate ability to recognize 50 high frequency words automatically',NULL,NULL),(2869,116,'Phonological Awareness',20,'student will demonstrate ability to count the number of syllables in a word',NULL,NULL),(2890,8090,'Measurement',15,'When given 5 incomplete statements for the conversion of linear metreic measurements to equivalent metric measurements, will complete the statements accurately for kilometers to meters.',NULL,NULL),(2891,8090,'Measurement',16,'When given 5 incomplete statements for the conversion of linear metreic measurements to equivalent metric measurements, will complete the statements accurately for centimeters to millimeters.',NULL,NULL),(2892,8090,'Measurement',17,'When given 5 incomplete statements for the conversion of linear metreic measurements to equivalent metric measurements, will complete the statements accurately for meters to millimeters.',NULL,NULL),(2893,8090,'Measurement',18,'When given 5 imcomplete statements for the conversion of metric measurements for volume and mass to equivalent metric measurements, will complete the statements accurately for converting milliliters to liters.',NULL,NULL),(2894,8090,'Measurement',19,'When given 5 imcomplete statements for the conversion of metric measurements for volume and mass to equivalent metric measurements, will complete the statements accurately for converting liters to kiloliters.',NULL,NULL),(2895,8090,'Measurement',20,'When given 5 imcomplete statements for the conversion of metric measurements for volume and mass to equivalent metric measurements, will complete the statements accurately for converting liters to milliliters.',NULL,NULL),(2896,8090,'Measurement',21,'When given 5 imcomplete statements for the conversion of metric measurements for volume and mass to equivalent metric measurements, will complete the statements accurately for converting kiloliters to liters.',NULL,NULL),(2897,8090,'Measurement',22,'When given 5 imcomplete statements for the conversion of metric measurements for volume and mass to equivalent metric measurements, will complete the statements accurately for converting grams to kilograms.',NULL,NULL),(2898,8090,'Measurement',23,'When given 5 imcomplete statements for the conversion of metric measurements for volume and mass to equivalent metric measurements, will complete the statements accurately for converting milligrams to grams.',NULL,NULL),(2900,8090,'Measurement',25,'When given 5 imcomplete statements for the conversion of metric measurements for volume and mass to equivalent metric measurements, will complete the statements accurately for converting grams to milligrams.',NULL,NULL),(2902,1401,'Personal Development',72,'Use knife and fork combination for cutting of appropriate foods',NULL,NULL),(2904,8090,'Measurement',27,'When given pictures of  five objects along with a metric ruler that shows millimeter intervals, will correctly measure the objects for graduations to the nearest millimeter. ',NULL,NULL),(2905,8090,'Measurement',28,'When given pictures of Celsius thermometers depiciting 100 degrees, 30 to 40 degrees, and 0 degrees or lower, will be able to identify the temperatures for boiling, a  hot  day, and freezing weather.',NULL,NULL),(2906,8090,'Measurement',29,'When give 5 pictures of  Celsius thermometers with varying temperatures, will be able to read the temperatures accurately for temperatures above 0 degrees.',NULL,NULL),(2907,8090,'Measurement',30,'When give 5 pictures of  Celsius thermometers with varying temperatures, will be able to read the temperatures accurately for temperatures below 0 degrees.',NULL,NULL),(2908,8090,'Measurement',31,'When given 5 readings on a meter or a gauge, will indicate the readings on the meter or gauge accurately.',NULL,NULL),(3021,2601,'Health/Life skills',1,'Hygiene',NULL,NULL),(3022,2601,'Health/Life skills',2,'Plan an nutritious meal following the Canada Food Guide',NULL,NULL),(3023,2601,'Health/Life skills',3,'Follow  a simple recipe',NULL,NULL),(3024,2601,'Health/Life skills',4,'safety',NULL,NULL),(3025,2601,'Health/Life skills',5,'social skills',NULL,NULL),(3031,116,'Phonological Awareness ',28,'student will demonstrate ability to segment words into syllables',NULL,NULL),(3030,116,'Phonological Awareness ',27,' student will demonstrate ablilty to segment compound words',NULL,NULL),(3032,116,'Phonological Awareness ',29,'student will be able to demonstrate ability to delete phonemes in a word',NULL,NULL);
/*!40000 ALTER TABLE `iep_objectives` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iep_student`
--

DROP TABLE IF EXISTS `iep_student`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `iep_student` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `lastname` varchar(40) DEFAULT NULL,
  `firstname` varchar(40) DEFAULT NULL,
  `birthdate` date DEFAULT NULL,
  `studnum` int(11) DEFAULT NULL,
  `provnum` varchar(12) DEFAULT NULL,
  `desdate` date DEFAULT NULL,
  `ddpflvl` varchar(12) DEFAULT NULL,
  `designation` varchar(60) DEFAULT NULL,
  `grade` varchar(6) DEFAULT NULL,
  `school` varchar(60) DEFAULT NULL,
  `sex` char(1) DEFAULT NULL,
  `medical` text,
  `medication` text,
  `equip` text,
  `adapt` text,
  `history` text,
  `strengths` text,
  `challenges` text,
  `assessments` text,
  `additional` text,
  `schoolyear` smallint(6) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iep_student`
--

LOCK TABLES `iep_student` WRITE;
/*!40000 ALTER TABLE `iep_student` DISABLE KEYS */;
/*!40000 ALTER TABLE `iep_student` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iep_team`
--

DROP TABLE IF EXISTS `iep_team`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `iep_team` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studnum` int(11) DEFAULT NULL,
  `userid` char(128) DEFAULT NULL,
  `jobtitle` char(40) DEFAULT NULL,
  `phone` char(20) DEFAULT NULL,
  `email` char(40) DEFAULT NULL,
  `sign` char(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iep_team`
--

LOCK TABLES `iep_team` WRITE;
/*!40000 ALTER TABLE `iep_team` DISABLE KEYS */;
/*!40000 ALTER TABLE `iep_team` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `infraction`
--

DROP TABLE IF EXISTS `infraction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `infraction` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` char(60) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `infraction`
--

LOCK TABLES `infraction` WRITE;
/*!40000 ALTER TABLE `infraction` DISABLE KEYS */;
/*!40000 ALTER TABLE `infraction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `lint_program`
--

DROP TABLE IF EXISTS `lint_program`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `lint_program` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` varchar(40) DEFAULT NULL,
  `groupdesc` varchar(40) DEFAULT NULL,
  `startdate` date DEFAULT NULL,
  `enddate` date DEFAULT NULL,
  `programhours` varchar(16) DEFAULT NULL,
  `periodlength` varchar(4) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `lint_program`
--

LOCK TABLES `lint_program` WRITE;
/*!40000 ALTER TABLE `lint_program` DISABLE KEYS */;
/*!40000 ALTER TABLE `lint_program` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `lint_student`
--

DROP TABLE IF EXISTS `lint_student`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `lint_student` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studnum` int(11) DEFAULT NULL,
  `progid` int(11) DEFAULT NULL,
  `startdate` date DEFAULT NULL,
  `enddate` date DEFAULT NULL,
  `programhours` varchar(16) DEFAULT NULL,
  `comment` text,
  `author` varchar(40) DEFAULT NULL,
  `attendance` varchar(4) DEFAULT NULL,
  `initialkit` varchar(32) DEFAULT NULL,
  `initiallesson` varchar(8) DEFAULT NULL,
  `withdrawtype` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `lint_student`
--

LOCK TABLES `lint_student` WRITE;
/*!40000 ALTER TABLE `lint_student` DISABLE KEYS */;
/*!40000 ALTER TABLE `lint_student` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `lok_link`
--

DROP TABLE IF EXISTS `lok_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `lok_link` (
  `locker_num` varchar(8) NOT NULL DEFAULT '',
  `lock_num` varchar(12) NOT NULL DEFAULT '',
  PRIMARY KEY (`locker_num`,`lock_num`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `lok_link`
--

LOCK TABLES `lok_link` WRITE;
/*!40000 ALTER TABLE `lok_link` DISABLE KEYS */;
/*!40000 ALTER TABLE `lok_link` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `lok_lock`
--

DROP TABLE IF EXISTS `lok_lock`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `lok_lock` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `lock_num` varchar(12) NOT NULL DEFAULT '',
  `combination` varchar(12) NOT NULL DEFAULT '',
  `pool` varchar(12) NOT NULL DEFAULT '',
  `comment` varchar(64) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `lock_num` (`lock_num`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `lok_lock`
--

LOCK TABLES `lok_lock` WRITE;
/*!40000 ALTER TABLE `lok_lock` DISABLE KEYS */;
/*!40000 ALTER TABLE `lok_lock` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `lok_locker`
--

DROP TABLE IF EXISTS `lok_locker`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `lok_locker` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `locker_num` varchar(8) NOT NULL DEFAULT '',
  `cleaned` tinyint(1) DEFAULT NULL,
  `location` varchar(64) DEFAULT NULL,
  `comment` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `locker_num` (`locker_num`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `lok_locker`
--

LOCK TABLES `lok_locker` WRITE;
/*!40000 ALTER TABLE `lok_locker` DISABLE KEYS */;
/*!40000 ALTER TABLE `lok_locker` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `lok_rlink`
--

DROP TABLE IF EXISTS `lok_rlink`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `lok_rlink` (
  `locker_num` varchar(8) NOT NULL DEFAULT '',
  `studnum` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`locker_num`,`studnum`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `lok_rlink`
--

LOCK TABLES `lok_rlink` WRITE;
/*!40000 ALTER TABLE `lok_rlink` DISABLE KEYS */;
/*!40000 ALTER TABLE `lok_rlink` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `math_fstep`
--

DROP TABLE IF EXISTS `math_fstep`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `math_fstep` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studnum` int(11) DEFAULT NULL,
  `treatynum` varchar(16) DEFAULT NULL,
  `tphase` varchar(32) DEFAULT NULL,
  `tseason` varchar(32) DEFAULT NULL,
  `tdate` date DEFAULT NULL,
  `tage` varchar(16) DEFAULT NULL,
  `tauthor` varchar(40) DEFAULT NULL,
  `tgrade` varchar(8) DEFAULT NULL,
  `tstamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `math_fstep`
--

LOCK TABLES `math_fstep` WRITE;
/*!40000 ALTER TABLE `math_fstep` DISABLE KEYS */;
/*!40000 ALTER TABLE `math_fstep` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mathca_outcomes`
--

DROP TABLE IF EXISTS `mathca_outcomes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mathca_outcomes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `oid` varchar(8) DEFAULT NULL,
  `odesc` varchar(255) DEFAULT NULL,
  `grade` varchar(8) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=293 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mathca_outcomes`
--

LOCK TABLES `mathca_outcomes` WRITE;
/*!40000 ALTER TABLE `mathca_outcomes` DISABLE KEYS */;
INSERT INTO `mathca_outcomes` VALUES (147,'NK.1','Counting 0 - 10 (forward and backward)','K'),(148,'NK.2','Subitize 1-5 objects, dots, pictures','K'),(149,'NK.3','Relate 0 - 10 to quantity','K'),(150,'NK.4','Partition 1 - 10 concretely and pictorially','K'),(151,'NK.5','Compare quantities, 0 - 10, using one-to-one correspondence','K'),(152,'PK.1','Repeating patterns of 2 or 3 elements','K'),(153,'SSK.1','Compare two objects using one attribute','K'),(154,'SSK.2','Sort 3-D objects using single attribute','K'),(155,'SSK.3','Build and describe 3-D objects','K'),(156,'N1.1','Counting 0 - 100','1'),(157,'N1.2','Subitize 1-10 objects, dots, pictures','1'),(158,'N1.3','Counting strategies','1'),(159,'N1.4','Represent numbers to 20','1'),(160,'N1.5','Comparing sets to 20','1'),(161,'N1.6','Estimate quantities to 20','1'),(162,'N1.7','Represent whole numbers in groupings','1'),(163,'N1.8','Identify number (up to 20) that is more or less than given number','1'),(164,'N1.9','Addition of numbers to 20','1'),(165,'N1.10','Mental math strategies','1'),(166,'P1.1','Repeating patterns of 2 - 4 elements','1'),(167,'P1.2','Translate repeating patterns','1'),(168,'P1.3','Equality as balance; inequality as imbalance','1'),(169,'P1.4','Use the equal symbol','1'),(170,'SS1.1','Measurement by comparing','1'),(171,'SS1.2','Sort 3-D objects and 2-D shapes using single attribute','1'),(172,'SS1.3','Replicate 2-D shapes and 3-D objects','1'),(173,'SS1.4','Compare 2-D shpaes to 3-D objects','1'),(174,'N2.1','Whole numbers to 100','2'),(175,'N2.2','Addition and subtraction (sums to 100)','2'),(176,'P2.1','Repeating patterns 3-5 elements','2'),(177,'P2.2','Increasing patterns','2'),(178,'P2.3','Equality and inequality (0 - 100)','2'),(179,'SS2.1','Measuring length with non-standard units','2'),(180,'SS2.2','Measuring mass with non-standard units','2'),(181,'SS2.3','3-D objects','2'),(182,'SS2.4','2-D shapes','2'),(183,'SS2.5','Relationship between 2-D shapes and 3-D objects','2'),(184,'SP2.1','Concrete graphs and pictographs','2'),(185,'N3.1','Whole numbers to 1 000','3'),(186,'N3.2','Addition and subtraction up to 1 000','3'),(187,'N3.3','Multiplication and division up to 5x5','3'),(188,'N3.4','Fractions are equal parts of the whole','3'),(189,'P3.1','Increasing and decreasing patterns','3'),(190,'P3.2','One step addition and subtraction problems','3'),(191,'SS3.1','Passage of time','3'),(192,'SS3.2','Measuring mass in g and kg','3'),(193,'SS3.3','Measuring length in cm and m','3'),(194,'SS3.4','3-D objects: faces, edges, vertices','3'),(195,'SS3.5','2-D shapes: triangles, quadrilaterals, pentagons, hexagons, octagons','3'),(196,'SP3.1','First-hand data: bar graphs, line plots','3'),(197,'N4.1','Whole numbers to 10 000','4'),(198,'N4.2','Addition and subtraction up to 10 000','4'),(199,'N4.3','Multiplication and division up to 10x10','4'),(200,'N4.4','Multiplication (2- or 3-digit by 1-digit)','4'),(201,'N4.5','Division (1-digit divisor and up to 2-digit dividend)','4'),(202,'N4.6','Fractions less than or equal to one','4'),(203,'N4.7','Decimal numbers: tenths and hundredths','4'),(204,'N4.8','Addition and subtraction of decimals to hundredths','4'),(205,'P4.1','Patterns and relations','4'),(206,'P4.2','Equations involving symbols','4'),(207,'SS4.1','Time: including 24 hour clock','4'),(208,'SS4.2','Area of 2-D shapes','4'),(209,'SS4.3','Rectangular and triangular prisms','4'),(210,'SS4.4','Line symmetry','4'),(211,'SP4.1','Graphing: many-to-one correspondence','4'),(212,'N5.1','Whole numbers to 1 000 000','5'),(213,'N5.2','Multiplication strategies for whole numbers','5'),(214,'N5.3','Divison: 3-digit by 1-digit, remainders','5'),(215,'N5.4','Estimation strategies','5'),(216,'N5.5','Fractions: equivalent; comparing','5'),(217,'N5.6','Decimals to thousandths','5'),(218,'N5.7','Decimals: adding and subtracting','5'),(219,'P5.1','Patterns: using mathematical notation','5'),(220,'P5.2','Equations: Single-variable, one-step','5'),(221,'SS5.1','Rectangles: with perimeter or area given','5'),(222,'SS5.2','Measuring length: mm, cm, m','5'),(223,'SS5.3','Measuring volume: cm?, m?','5'),(224,'SS5.4','Measuring capacity: mL, L','5'),(225,'SS5.5','3-D and 2-D edges, faces, sides: parallel, intersecting, perpendicular, vertical, horizontal','5'),(226,'SS5.6','Quadrilaterals','5'),(227,'SS5.7','Single transformations of 2-D shapes','5'),(228,'SP5.1','First-hand and second-hand data','5'),(229,'SP5.2','Graphing: double bar graphs','5'),(230,'SP5.3','Probability: likelihood of outcomes','5'),(231,'N6.1','Place value: greater than I million, less than 1 thousandth','6'),(232,'N6.2','Factors and multiples','6'),(233,'N6.3','Order of operations','6'),(234,'N6.4','Decimals:multiplication and division','6'),(235,'N6.5','Percent','6'),(236,'N6.6','Integers','6'),(237,'N6.7','Fractions: improper fractions, mixed numbers','6'),(238,'N6.8','Ratios','6'),(239,'P6.1','Patterns and relations: tables, graphs','6'),(240,'P6.2','Preservation of equality','6'),(241,'P6.3','Expressions and equations','6'),(242,'SS6.1','Angles','6'),(243,'SS6.2','Perimeter, area, volume','6'),(244,'SS6.3','Polygons','6'),(245,'SS6.4','Ordered pairs within first quadrant of Cartesian plane','6'),(246,'SS6.5','Transformations','6'),(247,'SP6.1','Data analysis: line graphs, discrete data, collecting data','6'),(248,'SP6.2','Probability: experimental. Theoretical','6'),(249,'N7.1','Divisibility rules','7'),(250,'N7.2','Decimals: adding, subtracting, multiplying, dividing','7'),(251,'N7.3','Relationship among fractions, decimals, whole numbers','7'),(252,'N7.4','Fractional percents between 1% and 100%','7'),(253,'N7.5','Fractions and mixed numbers: adding and subtracting','7'),(254,'N7.6','Integers: adding and subtracting','7'),(255,'P7.1','Relationships among patterns, graphs, and linear relations','7'),(256,'P7.2','Algebraic expressions and equations','7'),(257,'P7.3','Solve algebraic equations involving whole numbers and integers','7'),(258,'P7.4','Solve algebraic equations involving whole numbers and integers','7'),(259,'SS7.1','Circles: circumference, central angles','7'),(260,'SS7.2','Area formulae: triangles, parallelograms, circles','7'),(261,'SS7.3','2-D relationships: lines, angles','7'),(262,'SS7.4','Cartesian plane','7'),(263,'SS7.5','Transformations of 2-D shapes in all quadrants','7'),(264,'SP7.1','Measures of central tendency and range of data','7'),(265,'SP7.2','Circle graphs','7'),(266,'SP7.3','Probability: theoretical and experimental for 2 independent events','7'),(267,'N8.1','Square root of whole numbers','8'),(268,'N8.2','Percents greater than or equal to 0%','8'),(269,'N8.3','Ratio and rate','8'),(270,'N8.4','Fractions and mixed numbers: multiply and divide','8'),(271,'N8.5','Integers: multiply and divide','8'),(272,'P8.1','Equations: using graphs, table of values','8'),(273,'P8.2','Linear equations (including integers)','8'),(274,'SS8.1','Pythagorean Theorem','8'),(275,'SS8.2','3-D objects: nets, alternate views','8'),(276,'SS8.3','Volume: right prisms and right cylinders','8'),(277,'SS8.4','Tessellations','8'),(278,'SP8.1','Graphing','8'),(279,'SP8.2','Probability: independent events','8'),(280,'N9.1','Powers with integral bases','9'),(281,'N9.2','Rational numbers','9'),(282,'N9.3','Square roots (including positive rational numbers)','9'),(283,'P9.1','Linear relations','9'),(284,'P9.2','Situational questions using linear equations','9'),(285,'P9.3','Single variable linear equations','9'),(286,'P9.4','Polynomials','9'),(287,'SS9.1','Circle properties','9'),(288,'SS9.2','Surface area of 3-D objects','9'),(289,'SS9.3','Similarity of 2-D shapes','9'),(290,'SS9.4','Symmetry: line and rotation','9'),(291,'SP9.1','Data collection','9'),(292,'SP9.3','Probability','9');
/*!40000 ALTER TABLE `mathca_outcomes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mathca_scores`
--

DROP TABLE IF EXISTS `mathca_scores`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mathca_scores` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studnum` int(11) DEFAULT NULL,
  `treatynum` varchar(16) DEFAULT NULL,
  `tdate` date DEFAULT NULL,
  `tauthor` varchar(40) DEFAULT NULL,
  `tgrade` varchar(8) DEFAULT NULL,
  `tage` varchar(16) DEFAULT NULL,
  `tstamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `prepost` varchar(16) DEFAULT NULL,
  `outcome` varchar(16) DEFAULT NULL,
  `score` smallint(6) DEFAULT NULL,
  `schoolyear` char(4) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mathca_scores`
--

LOCK TABLES `mathca_scores` WRITE;
/*!40000 ALTER TABLE `mathca_scores` DISABLE KEYS */;
/*!40000 ALTER TABLE `mathca_scores` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `meta`
--

DROP TABLE IF EXISTS `meta`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `meta` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `dbaseid` varchar(64) DEFAULT NULL,
  `tableid` varchar(64) DEFAULT NULL,
  `fieldid` varchar(64) DEFAULT NULL,
  `datatype` varchar(16) DEFAULT NULL,
  `arrayidx` smallint(5) unsigned DEFAULT NULL,
  `size` smallint(5) unsigned DEFAULT NULL,
  `fieldname` varchar(255) DEFAULT NULL,
  `defaultvalue` text,
  `formtype` varchar(255) DEFAULT NULL,
  `viewsize` varchar(255) DEFAULT NULL,
  `required` char(1) DEFAULT NULL,
  `description` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=200 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `meta`
--

LOCK TABLES `meta` WRITE;
/*!40000 ALTER TABLE `meta` DISABLE KEYS */;
INSERT INTO `meta` VALUES (1,NULL,'announce','adate','date',4,0,'Date','','text','20','',NULL),(2,NULL,'announce','adatetime','datetime',1,0,'Date/Time','','text','20','',NULL),(3,NULL,'announce','adesc','text',2,0,'Description','','textarea','6x80','',NULL),(4,NULL,'announce','atopic','varchar(255)',3,255,'Topic','','text','30','',NULL),(5,NULL,'announce','atype','varchar(16)',6,16,'Type','teacher parent both','select','20','',NULL),(6,NULL,'announce','id','int(11)',0,0,'id','','readonly','20','',NULL),(7,NULL,'announce','topstay','char(1)',5,1,'Stay on Top?','1','checkbox','20','',NULL),(8,NULL,'staff','alt_city','varchar(32)',26,32,'alt_city','','text','20','',NULL),(9,NULL,'staff','alt_country','varchar(64)',28,64,'alt_country','','text','20','',NULL),(10,NULL,'staff','alt_email','varchar(64)',31,64,'alt_email','','text','20','',NULL),(11,NULL,'staff','alt_pcode','varchar(32)',29,32,'alt_pcode','','text','20','',NULL),(12,NULL,'staff','alt_phone','varchar(64)',30,64,'alt_phone','','text','20','',NULL),(13,NULL,'staff','alt_prov','varchar(32)',27,32,'alt_prov','','text','20','',NULL),(14,NULL,'staff','alt_street','varchar(64)',25,64,'alt_street','','text','20','',NULL),(15,NULL,'staff','ancestry','varchar(16)',44,16,'Ancestry','0998.01 First_Nation 0998.02 Inuit 0998.03 Metis 9999 Non-Aboriginal','selecthash','20','',NULL),(16,NULL,'staff','cell_phone','varchar(64)',12,64,'Cell Phone','','text','30','',NULL),(17,NULL,'staff','certification1','varchar(255)',10,255,'Certificate Number','','text','20','',NULL),(18,NULL,'staff','certification2','varchar(255)',32,255,'certification2','','text','20','',NULL),(19,NULL,'staff','certification3','varchar(255)',33,255,'certification3','','text','20','',NULL),(20,NULL,'staff','certification4','varchar(255)',34,255,'certification4','','text','20','',NULL),(21,NULL,'staff','certification5','varchar(255)',35,255,'certification5','','text','20','',NULL),(22,NULL,'staff','certification6','varchar(255)',36,255,'certification6','','text','20','',NULL),(23,NULL,'staff','certification7','varchar(255)',37,255,'certification7','','text','20','',NULL),(24,NULL,'staff','certification8','varchar(255)',38,255,'certification8','','text','20','',NULL),(25,NULL,'staff','citizenship','varchar(64)',23,64,'Citizenship','','text','20','',NULL),(26,NULL,'staff','city','varchar(32)',14,32,'City','','text','15','',NULL),(27,NULL,'staff','doatt','char(1)',9,1,'Does Attendance','~ Y','select','20','',NULL),(28,NULL,'staff','driver_class','varchar(64)',20,64,'License Class','','text','20','',NULL),(29,NULL,'staff','driver_license','varchar(64)',19,64,'Driver\'s License','','text','20','',NULL),(30,NULL,'staff','email','varchar(255)',7,255,'Email','','text','30','',NULL),(31,NULL,'staff','emergency_contact_name','varchar(255)',17,255,'Emergency Contact Name','','text','30','',NULL),(32,NULL,'staff','emergency_contact_phone','varchar(255)',18,255,'Emergency Contact Phone','','text','30','',NULL),(33,NULL,'staff','firstname','varchar(40)',3,40,'Firstname','','text','20','',NULL),(34,NULL,'staff','fulltimeequivalent','varchar(16)',48,16,'Full Time Equivalent','0843 Full_Time_(100%) \r\n0844.875 Part_Time_(88%) \r\n0844.750 Part_Time_(75%) \r\n0844.625 Part_Time_(63%) \r\n0844.500 Part_Time_(50%)\r\n0844.375 Part_Time_(38%)\r\n0844.250 Part_Time_(25%)\r\n0844.125 Part_Time_(13%)','selecthash','20','',NULL),(35,NULL,'staff','gender','varchar(16)',46,16,'Gender','~ M F','select','20','',NULL),(36,NULL,'staff','home_phone','varchar(64)',11,64,'Home Phone','','text','20','',NULL),(37,NULL,'staff','id','int(11)',0,0,'id','','readonly','20','',NULL),(38,NULL,'staff','indianstatus','varchar(16)',45,16,'Indian Status','1 Registered 2 Not_Registered 3 Not_Eligible','selecthash','20','',NULL),(39,NULL,'staff','lastname','varchar(60)',2,60,'Lastname','','text','30','',NULL),(40,NULL,'staff','ldap_gidnumber','mediumint(9)',41,0,'ldap_gidnumber','','text','20','',NULL),(41,NULL,'staff','ldap_uid','varchar(64)',39,64,'ldap_uid','','text','20','',NULL),(42,NULL,'staff','ldap_uidnumber','mediumint(9)',40,0,'ldap_uidnumber','','text','20','',NULL),(43,NULL,'staff','middlename','varchar(40)',4,40,'Middlename','','text','20','',NULL),(44,NULL,'staff','nrskip','char(1)',50,1,'Nominal Roll Skip','1','checkbox','20','','Staff Members that are NOT to be included in the First Nation nominal roll should be checked. '),(45,NULL,'staff','occupations','text',49,0,'Occupations Area','0210 Teacher_(Educator) \r\n0213 Resource/Special_Education_teacher_(Educator)\r\n0213.01 Language_and_Culture_teacher_(Educator)\r\n8201 Physical_Education_teacher_(Educator)\r\n0112 Principal_(Educator) \r\n0105 Vice-principal_(Educator)\r\n0206 Librarian_(Educator)\r\n0203.01 Guidance_Counsellor_(Educator)\r\n0203 Counsellor_(Educator)\r\n0108 Director_(Educator)\r\n0413 Teacher_Aide/Classroom_Assistant_(Non-Educator)\r\n0413.01 Special_Education_Teacher_Aide/_Classroom_Assistant_(Non-Educator) \r\n0107 School_Secretary_(Non-Educator)\r\n9999 Other_Specify_(Non-Educator)','text','20','',NULL),(46,NULL,'staff','passport','varchar(64)',24,64,'Passport','','text','20','',NULL),(47,NULL,'staff','password','varchar(255)',6,255,'password','','text','20','',NULL),(48,NULL,'staff','pcode','varchar(32)',16,32,'Postal Code','','text','10','',NULL),(49,NULL,'staff','prov','varchar(32)',15,32,'Province','SK','text','10','',NULL),(50,NULL,'staff','sal','varchar(6)',1,6,'Salutation','Mr. Ms. Mrs.','select','20','',NULL),(51,NULL,'staff','street','varchar(64)',13,64,'Street','','text','20','',NULL),(52,NULL,'staff','tdate','date',8,0,'tdate','','text','20','',NULL),(53,NULL,'staff','teachingcertificatejurisdiction','varchar(16)',43,16,'Teaching Certificate Jurisdiction','SK','text','4','',NULL),(54,NULL,'staff','teachingcertificatestatus','varchar(16)',42,16,'Teaching Certificate Status','1222 Permanent \r\n1224 Temporary/Provisional/Probationary\r\n1228 In_Progress\r\n9999 Not_Certified','selecthash','20','',NULL),(55,NULL,'staff','userid','varchar(40)',5,40,'User Id','','text','20','Y',NULL),(56,NULL,'staff','vehicle_plate','varchar(64)',22,64,'Vehicle Plate','','text','20','',NULL),(57,NULL,'staff','vehicle_reg','varchar(64)',21,64,'Vehicle Registration','','text','20','',NULL),(58,NULL,'staff_multi','field_additional','varchar(255)',4,255,'field_additional',NULL,'text','20',NULL,NULL),(59,NULL,'staff_multi','field_name','varchar(255)',2,255,'field_name',NULL,'text','20',NULL,NULL),(60,NULL,'staff_multi','field_value','varchar(255)',3,255,'field_value',NULL,'text','20',NULL,NULL),(61,NULL,'staff_multi','id','int(11)',0,0,'id',NULL,'text','20',NULL,NULL),(62,NULL,'staff_multi','userid','varchar(32)',1,32,'userid',NULL,'text','20',NULL,NULL),(63,NULL,'student','address1','varchar(40)',34,40,'Addr 1','','text','20','',NULL),(64,NULL,'student','address1mailing','varchar(128)',114,128,'Mailing Address 1','','text','30','',NULL),(65,NULL,'student','address2','varchar(40)',45,40,'Addr 2','','text','20','',NULL),(66,NULL,'student','address2mailing','varchar(128)',115,128,'Mailing Address 2','','text','30','',NULL),(67,NULL,'student','address_land','varchar(32)',106,32,'Land Address (TR)','','text','20','',NULL),(68,NULL,'student','alias','varchar(16)',63,16,'Alias','','text','20','',NULL),(69,NULL,'student','band','varchar(64)',58,64,'Band Name','','text','20','',NULL),(70,NULL,'student','bandnum','varchar(32)',59,32,'Band# (3digit)','','text','20','',NULL),(71,NULL,'student','baptism','char(1)',60,1,'Baptism','','checkbox','','',NULL),(72,NULL,'student','billet','varchar(255)',92,255,'Billet','','text','20','',NULL),(73,NULL,'student','birthdate','date',8,0,'Birthdate (yymmdd)','','text','12','Y',NULL),(74,NULL,'student','busroute','varchar(30)',56,30,'Bus Route','','text','20','',NULL),(75,NULL,'student','cell1','varchar(64)',32,64,'Cell 1','','text','20','',NULL),(76,NULL,'student','cell2','varchar(64)',43,64,'Cell 2','','text','20','',NULL),(77,NULL,'student','childcare_address','varchar(255)',94,255,'Babysitter - Address','','text','20','',NULL),(78,NULL,'student','childcare_name','varchar(255)',93,255,'Babysitter - Name','','text','20','',NULL),(79,NULL,'student','childcare_phone1','varchar(255)',95,255,'Babysitter - Phone1','','text','20','',NULL),(80,NULL,'student','childcare_phone2','varchar(255)',96,255,'Babysitter - Phone2','','text','20','',NULL),(81,NULL,'student','city1','varchar(40)',35,40,'City 1','','text','20','',NULL),(82,NULL,'student','city2','varchar(40)',46,40,'City 2','','text','20','',NULL),(83,NULL,'student','commun','char(1)',23,1,'Commun','','checkbox','','',NULL),(84,NULL,'student','confirm','char(1)',25,1,'Confirm','','checkbox','','',NULL),(85,NULL,'student','contact','varchar(255)',61,255,'Contact Address','','text','20','',NULL),(86,NULL,'student','contact1','varchar(255)',28,255,'Contact 1','','text','20','',NULL),(87,NULL,'student','contact2','varchar(255)',39,255,'Contact 2','','text','20','',NULL),(88,NULL,'student','cumfolder','tinyint(4)',113,0,'Cum Folder - present','','checkbox','20','',NULL),(89,NULL,'student','dadrel','varchar(25)',21,25,'Dad Religion','','text','20','',NULL),(90,NULL,'student','docphone','varchar(15)',55,15,'Doc Phone','','text','20','',NULL),(91,NULL,'student','doctor','varchar(70)',54,70,'Doctor','','text','20','',NULL),(92,NULL,'student','email','varchar(255)',74,255,'Email','','text','30','',NULL),(93,NULL,'student','emcell','varchar(64)',53,64,'Em Cell','','text','20','',NULL),(94,NULL,'student','emhphone','varchar(64)',51,64,'Emerg H Phone','','text','20','',NULL),(95,NULL,'student','emname','varchar(255)',50,255,'Emerg Name','','text','20','',NULL),(96,NULL,'student','emrelation','varchar(20)',49,20,'Emerg Relation','','text','20','',NULL),(97,NULL,'student','emwphone','varchar(64)',52,64,'Emerg W Phone','','text','20','',NULL),(98,NULL,'student','entry','varchar(255)',11,255,'entry','','text','20','',NULL),(99,NULL,'student','ethnic','varchar(20)',12,20,'Ethnic Category','Non_Native Status_Native Non-status_Native Metis','select','10','',NULL),(100,NULL,'student','family','varchar(32)',62,32,'Family','','text','8','',NULL),(101,NULL,'student','fax1','varchar(64)',33,64,'Fax 1','','text','20','',NULL),(102,NULL,'student','fax2','varchar(64)',44,64,'Fax 2','','text','20','',NULL),(103,NULL,'student','field1','varchar(255)',66,255,'field1','','text','20','',NULL),(104,NULL,'student','field2','varchar(255)',67,255,'field2','','text','20','',NULL),(105,NULL,'student','field3','varchar(255)',68,255,'field3','','text','20','',NULL),(106,NULL,'student','firstname','varchar(40)',2,40,'First Name','','text','30','Y',NULL),(107,NULL,'student','graddate','date',102,0,'Grad Date','','text','20','',NULL),(108,NULL,'student','grade','varchar(8)',5,8,'Grade','~ PK K 1 2 3 4 5 6 7 8 9 10 11 12','select','2','Y',NULL),(109,NULL,'student','group_after_school_prog','char(1)',82,1,'Aft Sch Prog','~ Y','select','','',NULL),(110,NULL,'student','group_alt1','varchar(64)',89,64,'Alt Group 1','','text','20','',NULL),(111,NULL,'student','group_alt2','varchar(64)',90,64,'Alt Group 2','','text','20','',NULL),(112,NULL,'student','group_alt3','varchar(64)',91,64,'Alt Group 3','','text','20','',NULL),(113,NULL,'student','healthid','varchar(12)',10,12,'Health ID','','text','11','',NULL),(114,NULL,'student','homeroom','varchar(8)',6,8,'Homeroom','','text','8','Y',NULL),(115,NULL,'student','house','varchar(20)',9,20,'House League','','text','10','',NULL),(116,NULL,'student','hphone1','varchar(64)',30,64,'H Phone 1','','text','20','',NULL),(117,NULL,'student','hphone2','varchar(64)',41,64,'H Phone 2','','text','20','',NULL),(118,NULL,'student','immersion_type','varchar(32)',112,32,'Immersion Type','~ FR CR UK','select','20','',NULL),(119,NULL,'student','initial','varchar(40)',3,40,'Middle Name','','text','30','',NULL),(120,NULL,'student','internet','char(1)',14,1,'Internet','','checkbox','1','',NULL),(121,NULL,'student','internet_type','varchar(255)',97,255,'Internet Type','','text','20','',NULL),(122,NULL,'student','lastname','varchar(40)',1,40,'(Legal) Last Name','','text','30','Y',NULL),(123,NULL,'student','ldap_gidnumber','mediumint(9)',105,0,'ldap_gidnumber','','text','20','',NULL),(124,NULL,'student','ldap_uid','varchar(64)',103,64,'ldap_uid','','text','20','',NULL),(125,NULL,'student','ldap_uidnumber','mediumint(9)',104,0,'ldap_uidnumber','','text','20','',NULL),(126,NULL,'student','lunchstatus','varchar(255)',83,255,'Lunch Status','~ Free Reduced Full','select','20','',NULL),(127,NULL,'student','maiden','varchar(40)',26,40,'Maiden Name','','text','20','',NULL),(128,NULL,'student','medical','text',18,0,'Medical','','textarea','6x30','',NULL),(129,NULL,'student','momrel','varchar(25)',20,25,'Mom Religion','','text','20','',NULL),(130,NULL,'student','name1','varchar(255)',29,255,'Name 1','','text','20','',NULL),(131,NULL,'student','name2','varchar(255)',40,255,'Name 2','','text','20','',NULL),(132,NULL,'student','name_knownas','varchar(64)',88,64,'Known As','','text','20','',NULL),(133,NULL,'student','name_prefix','varchar(64)',86,64,'Name Prefix','','text','20','',NULL),(134,NULL,'student','name_suffix','varchar(64)',87,64,'Name Suffix','','text','20','',NULL),(135,NULL,'student','owing','decimal(9,2)',16,0,'Owing','','text','8','',NULL),(136,NULL,'student','par1_email','varchar(64)',84,64,'Email - Par 1','','text','20','',NULL),(137,NULL,'student','par1_firstname','varchar(255)',98,255,'Firstname - Par 1','','text','20','',NULL),(138,NULL,'student','par1_lastname','varchar(255)',99,255,'Lastname - Par 1','','text','20','',NULL),(139,NULL,'student','par2_email','varchar(64)',85,64,'Email - Par 2','','text','20','',NULL),(140,NULL,'student','par2_firstname','varchar(255)',100,255,'Firstname - Par 2','','text','20','',NULL),(141,NULL,'student','par2_lastname','varchar(255)',101,255,'Lastname - Par 2','','text','20','',NULL),(142,NULL,'student','parent_lockout','varchar(8)',116,8,'Parent Lockout',NULL,'text','20',NULL,NULL),(143,NULL,'student','parish','varchar(255)',22,255,'Parish','','text','20','',NULL),(144,NULL,'student','password','varchar(32)',65,32,'Password','','text','20','',NULL),(145,NULL,'student','pcode1','varchar(10)',36,10,'PCode 1','','text','20','',NULL),(146,NULL,'student','pcode2','varchar(10)',47,10,'PCode 2','','text','20','',NULL),(147,NULL,'student','pic','varchar(255)',64,255,'pic','','text','20','',NULL),(148,NULL,'student','program','varchar(64)',72,64,'Program','10 Regular_Program \n05 Alternative_Education_Plan 09 Adult_Secondary_Program 18 Alternative_Adult_Secondary\n15 Special_Education_Program(up_to_Grade_9)','selecthash','20','',NULL),(149,NULL,'student','prov1','varchar(32)',69,32,'Prov1','SK AB BC MB ON QC NL NT PE NB NS NU YT','select','3','',NULL),(150,NULL,'student','prov2','varchar(32)',70,32,'Prov2','SK AB BC MB ON QC NL NT PE NB NS NU YT','select','3','',NULL),(151,NULL,'student','provnum','varchar(12)',57,12,'Provincial Stud Num','','text','20','',NULL),(152,NULL,'student','recon','char(1)',24,1,'Recon','','checkbox','','',NULL),(153,NULL,'student','relation1','varchar(20)',27,20,'Relation 1','Mother Father Aunt Uncle Grandfather Grandmother Guardian','select','20','',NULL),(154,NULL,'student','relation2','varchar(20)',38,20,'Relation 2','Mother Father Aunt Uncle Grandfather Grandmother Guardian','select','20','',NULL),(155,NULL,'student','reserveres','varchar(64)',71,64,'Reserve Resident','1 Yes 0 No','selecthash','20','',NULL),(156,NULL,'student','sex','char(1)',7,1,'Sex','M F','select','6','Y',NULL),(157,NULL,'student','single','char(1)',13,1,'Single Parent','','checkbox','1','',NULL),(158,NULL,'student','studid','int(11)',0,0,'studid','','readonly','20','',NULL),(159,NULL,'student','studnum','int(11)',4,0,'Local Student Num','','readonly','20','',NULL),(160,NULL,'student','studrel','varchar(25)',19,25,'Student Religion','','text','20','',NULL),(161,NULL,'student','trans_am_route','varchar(64)',77,64,'AM Route','','text','20','',NULL),(162,NULL,'student','trans_bus_stop_location','varchar(64)',81,64,'Bus Stop Location','','text','20','',NULL),(163,NULL,'student','trans_dropoff_time','varchar(16)',80,16,'Dropoff Time','','text','6','',NULL),(164,NULL,'student','trans_name','varchar(255)',76,255,'Bus Route','','text','20','',NULL),(165,NULL,'student','trans_pickup_time','varchar(16)',78,16,'Pickup Time','','text','6','',NULL),(166,NULL,'student','trans_pm_route','varchar(64)',79,64,'PM Route','','text','20','',NULL),(167,NULL,'student','trans_type','varchar(255)',75,255,'Transport','~ Bus Walk Parent','select','20','',NULL),(168,NULL,'student','treaty','varchar(20)',17,20,'Treaty# (10digit)','','text','12','',NULL),(169,NULL,'student','tuition_collect','tinyint(4)',110,0,'Tuition Collect','','checkbox','20','',NULL),(170,NULL,'student','tuition_country','varchar(8)',111,8,'Country of Origin','','text','8','',NULL),(171,NULL,'student','tuition_duration','varchar(64)',108,64,'Tuition Duration (mo)','','text','10','',NULL),(172,NULL,'student','tuition_program','varchar(128)',109,128,'Tuition Program','~ AS CE CA CC EF ES GE IC IS NA OT RE SE SQ WH FP GP','select','20','',NULL),(173,NULL,'student','tuition_status','varchar(64)',107,64,'Tuition Status','~ FE FT RE ID','select','20','',NULL),(174,NULL,'student','utag','varchar(255)',73,255,'utag','','text','20','',NULL),(175,NULL,'student','workplace1','varchar(60)',37,60,'Wrkplace 1','','text','20','',NULL),(176,NULL,'student','workplace2','varchar(60)',48,60,'Wrkplace 2','','text','20','',NULL),(177,NULL,'student','wphone1','varchar(64)',31,64,'W Phone 1','','text','20','',NULL),(178,NULL,'student','wphone2','varchar(64)',42,64,'W Phone 2','','text','20','',NULL),(179,NULL,'student','youngest','char(1)',15,1,'Youngest','','checkbox','1','',NULL),(180,NULL,'student_inac','accommodation','tinyint(4)',4,0,'Accommodation','3425 Group_home\r\n1673.02 Student_residence\r\n1673.01 Boarding_school\r\n1678.01 Mandatory_room_and_board,_mandatory_private_home_placement\r\n1678.02 Room_and_board_(5_days)','selecthash','20','',''),(181,NULL,'student_inac','financial_edu','tinyint(4)',8,0,'Financial Support From','','text','5','',''),(182,NULL,'student_inac','fte','tinyint(4)',2,0,'Full Time Equivalent','0843 Full_Time_(100%)  0844.875 Part_Time_(88%)  0844.750 Part_Time_(75%)  0844.625 Part_Time_(63%)  0844.500 Part_Time_(50%) 0844.375 Part_Time_(38%) 0844.250 Part_Time_(25%) 0844.125 Part_Time_(13%)','selecthash','4','',''),(199,'school','student_inac','programcompletedprevyear','char(1)',14,1,'Program Completed Previous Year',NULL,'checkbox','20',NULL,NULL),(184,NULL,'student_inac','id','int(11)',0,0,'Id','No Entry','readonly','20','',''),(187,NULL,'student_inac','language_instruction','tinyint(4)',7,0,'Language of Instruction','EN English NAI First_Nation FR French','selecthash','20','',''),(188,NULL,'student_inac','programdelivery','varchar(16)',12,16,'Program Delivery','0605 Classroom\r\n0608.01 Distance_Education_(correspondence_courses,etc.)\r\n0608.02 Virtual_(Internet)\r\n0608.03 Blended:_Classroom_and_Virtual(Internet)\r\n0608.04 Blended:_Classroom_and_Distance_Education 0610 Home_Schooled','selecthash','20','',NULL),(189,NULL,'student_inac','residence','tinyint(4)',3,0,'Residence','1 On_Reserve\r\n2 On_Crown_land_(in_a_community_administered_by_a_band) \r\n3 Off_Reserve_(not_eligible_to_be_funded_by_INAC)','selecthash','20','',''),(190,NULL,'student_inac','residence_band','tinyint(4)',9,0,'Band of Residence','','text','5','',''),(191,NULL,'student_inac','residence_reserve','tinyint(4)',10,0,'Reserve of Residence','','select','5','','The reserve the student normally resides at.'),(192,NULL,'student_inac','schoolprogram','varchar(16)',11,16,'School Program','0100 Regular \r\n9999 Immersion \r\n1000 Bilingual\r\n2600 Alternative/Outreach\r\n1501 Adult/Mature\r\n0308 Technical\r\n0399 Vocational\r\n0309.01 Trade-FTP\r\n0309.02 Trade-FMS\r\n9999.01 Course_upgrade_after_graduation','selecthash','20','',NULL),(193,NULL,'student_inac','serviceprovision','varchar(16)',13,16,'Service Provision','41 Continued_Enrollment_-_Elementary/Secondary_Program\r\n42 Continued_Enrollment_-_Post_Graduation_Course_Upgrade\r\n1921 Graduated\r\n1922 Course_Upgrade_Completed\r\n1908 Transferred_To_Another_School_On_SAME_Nominal_Roll(Feeder_School)\r\n23 Transferred_-_To_another_Recipient\r\n1926 Withdrew\r\n28 Moved_off_reserve\r\n29 Not_enrolled_in_an_accredited/eligible_program\r\n24 Insufficient_attendance\r\n26 Over/Under_Age\r\n1924 Medical\r\n1923 Deceased','selecthash','20','',NULL),(194,NULL,'student_inac','studnum','varchar(32)',1,32,'Student Number','No Entry','readonly','20','',''),(195,NULL,'student_inac','transportation_daily','tinyint(4)',5,0,'Daily Transportation','01 Transportation_by_School_Bus\r\n02 Transportation_by_Public_Transit\r\n03 Transportation_by_other_means\r\n04 Transportation_for_HCSE_Student','selecthash','20','',''),(196,NULL,'student_inac','transportation_other','tinyint(4)',6,0,'Transportation Other','05 Lunch\r\n06 Weekend_Transportation\r\n07 Seasonal_Transportation\r\n08 Weekend/Seasonal_Transportation_for_HCSE_student','selecthash','20','',''),(197,'school','announce','author','varchar(32)',7,32,'author',NULL,'text','20',NULL,NULL),(198,'school','staff','birthdate','date',47,0,'birthdate',NULL,'text','20',NULL,NULL);
/*!40000 ALTER TABLE `meta` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oaupdate`
--

DROP TABLE IF EXISTS `oaupdate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `oaupdate` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(127) DEFAULT NULL,
  `description` text,
  `date` date DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=98 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oaupdate`
--

LOCK TABLES `oaupdate` WRITE;
/*!40000 ALTER TABLE `oaupdate` DISABLE KEYS */;
INSERT INTO `oaupdate` VALUES (12,'New School Year Updates','The previous school year database has been added with a \'1617\' added to indicate the 2016-2017 school year when looking up attendance or marks from the last school year.\r\n\r\nBefore that databases only ended in the second part of the school year (ie. 2015-2016 school year is \'2016\'). \r\n\r\nThe current database has had the yearly information removed (ie. attendance, marks, etc) in preparation for this school year.','2017-08-10'),(13,'Sask Ed Course Codes - updated','All course codes, including title, start and end dates, have been updated in the reference table for all schools, from new Sask Ed data files for this year. This is a separate table from the courses offered in each school and contains all possible courses K-12 that can be offered.','2017-08-15'),(14,'SDS Certificate Update','SDS connectivity is now back. I had to install new certificates for the www.k12.gov.sk.ca server access, since they apparently changed on Sept 1, without warning.','2017-09-08'),(15,'New Discipline System','The discipline system has been updated with the ability to attach multiple students to a single event and also add a variety of actions to each student for that event. You can add/delete both infraction events and actions taken using the configure button. Feedback welcome.','2017-09-12'),(16,'Discipline View - event edit added','I\'ve added event editing. The student and action options will follow as required. Each discipline event is linked to separate student disc records and also separate action records as well. Thus editing and deleting is complex.  -- Les','2017-10-13'),(17,'Discipline System - updates complete','I\'ve added several new abilities to the discpline system in the \'View\' button/script. This includes the ability to add and delete students associated with a discipline event and also to add new actions to a student for an event. -- Les','2017-10-24'),(18,'IEP Development - Eval Masters','New table designs and scripting have been added for testing of updates to the IEP evaluation masters for IEP students. Development is ongoing for this. -- Les','2017-11-07'),(19,'Following Your Voices - attendance export','This attendance script is now updated to allow users to export data from previous years if necessary. It accesses the previous years\' databases on our secondary server. -- Les','2017-12-01'),(20,'Teacher Attendance Entry','The new teacher attendance entry script is now ready for testing in schools. It includes the perfect attendance directly in the script, so teachers can do both at the same time (mark perfect attendance for some days/periods and also enter student absences on other dates and periods. -- Les','2017-12-01'),(21,'K/PK Non School Day system','There is now a new Non-School Day (NSD) system for marking days where PK/K students do not come to school. It allows those days or half days to be marked on a monthly basis for each K or PK students. Other scripts such as Attendance report 4, report cards have yet to be updated to support this. I\'ll notify once this is ready also. -- Les','2017-12-01'),(22,'SDS Sending Marks','The SDS script to send in marks is updated to disallow any marks that contain any alphabetical characters (A-Z). It will also strip any % sign trailing the mark as well as any spaces.','2017-12-12'),(23,'Teacher Attendance  PK/K Non-School Days','Teacher attendance entry is updated to support setting of Non-School Days for the PK/K grades. Attendance Report 4 is also updated to support these non-school days for these grades. Any problems, you know who to call! -- Les','2018-01-05'),(24,'CMA New Outcome Completion Reports','Updated Report 8 (by grade)  and new report 10 (by homeroom) reports added to schools.','2018-01-24'),(25,'OA Library Updates / Staff Absence Report','The attendance and schedule software libraries are now updated to improve behaviours and remove old dependencies. The absence report now has added late minutes and late totals.','2018-01-29'),(26,'SDS script updates','The high school Sask Ed (Student Data System - SDS) scripts for course enrollments, and mark submissions are updated. The checking button for course enrollment is also updated. There is a new button to check the SDS marks against the OA marks to make sure all marks have been correctly added to the SDS system. -- Les','2018-02-06'),(27,'SDS Course Query / Reading Level 40K fixed','I\'ve updated the SDS course enrollment query script to add sorting for both registered and unregistered courses. Reading level 40K is now fixed to allow additions of reading tests for that level. There was an error in the database for that reading level. --Les','2018-02-08'),(28,'Sask Ed Course Codes - New Viewer','I have added a new Sask Ed Course Code viewer so that you can find a course code that you need. Any courses without an end date are active. Any locally developed courses (as indicated), would have to be reported on the Form 2 to Sask Ed, along with your other normal courses. This new button is on the report card page, bottom right in Sask Ed Courses section. --Les','2018-02-14'),(29,'Feeder Schools / LLI','Buttons to view Discipline, Reading, and Math in feeder schools are now found on the SSP page/tab. A new LLI progress report is also found on the SSP page (admin site). --Les','2018-02-15'),(30,'Feeder School Attendance','I\'ve added a new button/script on SSP page to allow schools that have feeder schools to check student attendance for previous years in the feeder schools. --Les','2018-02-26'),(31,'Attendance/Credits Earned Report','There is a new report on the Attendance (and Report Card page) that groups students into attendance groups (>70%,50-70%,<50%) and then calculates their course credit earneds vs attempted ratio.','2018-03-29'),(32,'LLI Progress/Edit Withdraw','The LLI progress report is updated to allow for multiple group selections at one time (and viewing on the second page). Also, I\'ve added options for indicating reasons why students who are no longer in the program.','2018-03-29'),(33,'New! Attendance Scan 2','I\'ve added a new attendance scan script on the bottom left of the attendance page. It will ask for a % attendance cutoff, and will then display all students with average attendance below that figure. They are sorted by average attendance, and it also displays the monthly attendance for all of those students as well. There is a also another table that displays average attendance for each grade and the numbers that are over the attendance cutoff (and thus not displayed). Any problems, or suggestions for additions, please let me know. -- Les','2018-04-12'),(34,'New - Set Period Times','There is a new button on the EOY page to allow you to set the start and end times for periods for the grades with subject based attendance. This will allow us to give you better reports. For the other grades (homeroom based attendance), I will add scripts (buttons) to allow teachers to set their own times and also subjects/activities that will then integrate with the daybook. Any problems or questions, please email me. -- Les','2018-04-24'),(35,'new CMA (Math) Report 11','There is a new CMA Report 11 which gives the strand averages for each student over the last 3 years. Sorted by name. On SSP page for admin site, also on teacher site.','2018-04-26'),(36,'New Admin site Non School Day Viewer (PK/K)','I\'ve added a new NSD (Non School Day) for PK/K viewer to the Date Management section of the EOY page. \r\nLet me know if any problems --Les','2018-05-25'),(37,'REMINDER: Year End... Wait till August!','Make sure you DON\'T start changing things for next year in June. WAIT UNTIL AUGUST. I do the \"Previous Year\" databases in July so that you\'ll have a 2017-2018 database to look back at in future years. If you make changes now you won\'t be able look back to this 2017-2018 year and see the correct data for this school year. You have been warned! (grin) -- Les','2018-06-04'),(38,'Kindergarten Registration','You can easily preregister K/PK students in OA by selecting preregistration as the option during enrollment. This puts the student data into a separate table from which they are moved in August to the normal student table. Thus we won\'t change the student table in June which is used for the 2017-2018 previous year database. (as the previous entry notes). -- Les','2018-06-12'),(39,'New Daybook System','There is a new daybook system in place to allow teachers to set their own period times, their own activities and then timetable for both courses and activities. Once these are set, they are used by the new daybook software to do course planning and presentation. Documentation and Planning Tool to follow. -- Les','2018-06-13'),(40,'Marks to Sask Ed','Please make sure you\'ve sent all of your high school marks to Sask Ed, by July 6th. After that date I will be doing conversion to the next school year and current marks will be erased. They will be in the backups in the 2017-2018 school year of course. -- Les','2018-06-28'),(41,'Previous School Year Cleanup','The current school year databases have been cleaned in preparation for the 2018-2019 school year. I\'m now creating the previous school year databases so you can look back at previous year data. Any problems, please let me know. -- Les Richardson (openadmin@gmail.com)','2018-08-03'),(42,'Previous School Databases Added','The 2017-2018 school year database is now added for all schools, so you can see previous attendance, marks, staff attendance, school year on the SSP tab. -- Les','2018-08-03'),(43,'Reset Course Master ','I\'ve updated the Course Master RESET button to include all staff that are classroom teachers (rather than just teachers who already are found in the course masters). Terms are changed into pulldown (select list) choices. Any problems, let me know. -- Les','2018-08-29'),(44,'Staff Restore/Reinstate Button','I\'ve added a new staff button to allow admin users to move staff from the withdrawn staff into current staff again (rather than having to retype all of the staff info). This is on the EOY page under staff management. Any problems, let me know. -- Les','2018-08-30'),(45,'Previous Year - Attendance Scan 2 (color coded)','The color coded Attendance Scan 2 script has now been modified and placed on the SSP page/tab to allow you to analyze previous year attendance data. Any problems let me know! -- Les','2018-08-31'),(46,'Announcement System - author added','I\'ve added an author field to announcements. Any problems, let me know. --Les','2018-09-05'),(47,'Cree Language Assessment','A Cree Language system is started with Add and View/Edit options. Reporting to follow. On the teacher site. -- Les','2018-09-18'),(48,'Cree Language - score','The add and edit sections are updated to allow numeric scores 1-100. Any blank or text scores are assumed to be ssp exceptions (ie. not tested). --Les','2018-10-03'),(49,'Main Page - Open Sections','I\'ve changed 3 section of OA main page to be open by default: student roster, staff attendance, and nominal roll. -- Les','2018-10-03'),(50,'Nominal Roll ','The nominal roll file generator is updated to include a new field introduced late in June. ','2018-10-15'),(51,'Home Visit Tracking','The home visit system (on Discipline page) is now added to all schools.','2018-10-22'),(52,'Cree Language -  View script update','The Cree View script (on teacher site) is updated to allow for both editing and deleting of cree score records. -- Les','2018-10-23'),(53,'Add Reading Test - Updated','The script will allow selection of students via pulldown choices for grade / homeroom. Minor cleanup done on first couple of pages. -- Les','2018-10-24'),(54,'School Enrol script updated','The school enrollment script (enrol on main page) is now updated and shows that a local student number (of a withdrawn student) may be used in the last name field to quickly add student back into the school. Please let me know if any issues, since I\'ve changed a lot internally. -- Les','2018-10-25'),(55,'New Staff Timetable Report','This is a new report on the Timetable page/tab that outputs in HTML (ie. web page) format. It allows more customization of output and has embedded page breaks by teacher when printed. The script to set Period Times (start/end) is now linked on this page, as also found on EOY page.','2018-10-25'),(56,'Cree Language moves to Indigenous Languages','The Cree Language system is now an Indigenous Language system. Otherwise, system remains the same.','2018-10-25'),(57,'New Timetable Scripts - Web Page (HTML) Output','The previous timetable scripts on the timetable page generated PDF files. I\'ve written 2 new scripts with HTML (ie. web page) output, that also include more options and will also generate page breaks for printing both students and staff -- Les','2018-10-29'),(58,'Period Configuration (System)','I\'ve updated the period setting script for the main OA system (as opposed to the teacher script for setting personal periods for teaching) to support up to 15 periods. It was not working correctly for more than 9 periods.','2018-10-29'),(59,'Attendance - Change Courses ','I\'ve added a new script on the attendance page to allow you to change the attendance records when students are moved from one course to another. It simply resets the coursecode-section value in the records for the moved students. It has no effect on course enrollment.','2018-10-31'),(60,'Add Course Enrollments - Filter','I\'ve added section filtering to the 3 course selection methods (grade, name, terms). Thus once you have all grade 10 courses (Select by Grade, enter 10), you can then further select only those with a section value of 3, etc. In fact, multiple methods can be used at the same time, if you wish.','2018-10-31'),(61,'Family Report Fixed','The family report (which depends on phone numbers for assembling families) is now updated and fixed.','2018-11-15'),(62,'Gradebook Feature Reqests?','I\'ve been dragged into gradebook updates. Are there any feature requests while I\'m doing this? -- Les','2018-11-20'),(63,'Gradebook update','The gradebook is now out for some testing, and I\'ll update schools once we\'ve had an initial test. I just want to avoid report card season for this update. It will not show students withdrawn from school, even though gradebook data exists. Any problems let me know. -- Les','2018-11-21'),(64,'Gradebook, sortorder Updated','All schools are now updated with the new gradebook code, and updated sortorder script (on maintenance menu of gradebook). This is used when new students enrol, and you have to add them to the bottom of your paper forms for recording marks. By altering the sortorder you can make the on-screen ordering match the paper form for easily entering mark raw scores (We never need percentages in gradebook).','2018-11-23'),(65,'Gradebook - name splitting between lines','The splitting of long student names in the gradebook has been supressed using new CSS command, rather than the older non-breaking space method. Most will notice no change. All schools updated. -- Les','2018-11-30'),(66,'Attendance Scan 2','The color printing for attendance scan 2 is now fixed.','2018-12-04'),(67,'Land Based Learning - School Events','A Land Based Learning section has been added to the school events system. ','2019-01-09'),(68,'Math - SSP Page - Added Hover Description','The Math section of the SSP page has \'hoverable\' descriptions for each of the 11 math reports.','2019-01-11'),(69,'Math Report 2 - fixed','An error preventing Math report 2 from working is now fixed.','2019-01-11'),(70,'Indigenous Language Reports','Indigenous Language Report 1 is now added to the SSP page/tab of the admin site. It shows each student pre/post averages for each month. A similar report is available on both central site and consultant site.','2019-01-14'),(71,'Pelican Lake Schools - student import','The two Pelican Lake FN schools have student data imported. The school year and staff must be added next. ','2019-02-06'),(72,'Onion Lake Schools - Enrollment Report','A new report for monthly enrollment changes and attendance, breakdown by grade/homeroom. Located on main page, in enrollment section, on right side. It should be useful to all schools. Any problems, let me know. --Les','2019-02-08'),(73,'Onion Lake Schools - Report 2 for Enrollment','The second monthly enrollment report for each homeroom is now ready for testing. Located on the main page, right side in Enrollment section. Any problems, let me know. -- Les','2019-02-13'),(74,'Teacher Timetable View','The teacher timetable viewer (on teacher page) is now updated to include period times, and other updates.','2019-02-23'),(75,'Homeroom Teacher Attendance Check','The home teacher attendance check script is now updated to support the K/PK closure dates (ie. non school wide days closed). -- Les','2019-02-26'),(76,'Set PK/K Days Closed - Admin site','This script, found on the teacher site for PK/K teachers, has also been added to the admin site on EOY page in the date section. -- Les','2019-02-28'),(77,'Timetable Edit - Updated','This script now sorts courses and doesn\'t show courses not available in a selected term, along with displaying start and end terms for the courses. -- Les','2019-02-28'),(78,'Discipline View - show student demographic ','The Discipline View button now shows parent 1 name and contact information and will also popup screen of core student information. -- Les','2019-03-02'),(79,'Attendance Outside of Enrollment Fix','There is a new script to fix attendance outside of enrollment caused by a teacher entering attendance until student is marked as withdrawn (at earlier date than attendance records). On Attendance page, top left with a \'New\' identifier.','2019-03-13'),(80,'new Dates Closed Management Scripts','There are 3 new scripts for date management (View, Add, Edit/Delete) that now include periods closed as well as the fraction of the day closed. This will allow us do better attendance entry and reporting, especially with the complexity of the PK/K days closed as well. Any problems, let me know. -- Les','2019-03-14'),(81,'Nominal Roll','I\'ve updated the nominal roll to support changes in the INAC data layout. There are now 2 enrollment types... normal Primary/Secondary enrollment, and a new Upgrading Courses enrollment. I\'ve modified all student nominal roll records to be a normal enrollment. Any enrollments in the fall with upgrading, should use the new code. It\'s in the (misnamed) Service Provision field. --Les','2019-03-19'),(82,'Export Report Card Marks to Spreadsheet','There is a new script on bottom left of report card page to allow you to export any report card assessments to a spreadsheet CSV for further analysis/reporting. --Les','2019-03-25'),(83,'Course Master / Course View','I\'ve updated both the Add and Edit functions for Course Master to allow improved visibility for objectives and course view links. I\'ve updated Sask Ed course views to allow selections by grade, active, and type of course (Locally Developed, etc) I\'m also writing a new system to track all consultant work and travel time and distance based on FN support contracts. -- Les','2019-04-06'),(84,'Teacher IEP Detailed Report','I\'ve updated the detailed report to use the new IEP table designs. This was missed when I rewrote other IEP scripts. --Les','2019-04-25'),(85,'Attendance Profiles report - updated','The report is updated to filter band names correctly.','2019-05-14'),(86,'Preplan Next Year Course Offerings','I\'ve created a new tool to simplify the planning of course offerings for grades 10-12. It will create a table with course, semester, teacher, periods which can then be used to update the course master automatically over the summer, for use in the fall. ','2019-05-20'),(87,'Preplan Course Offering','Forgot.... the tool is on the Report Card page, at the bottom of the Course Master section. There will be more tools to come for viewing teacher loads, which will also be necessary in the planning process. Any problems or ideas for updates, please let me know. --Les','2019-05-20'),(88,'Preplan Course Master - update','I\'ve added code to remove students (Grade 12) who are in an Adult Program (Program code 09) rather than regular program (code 10). I\'ve also added Teacher Course Load views on page 3 (Set Teacher, Semester, Grade Offered, Backings) and Page 4 (Set Periods for Courses). Page 5 (View courses) shows the final values set and allows you to reset (Go to page 3) and also restart (go to page 1). Once you have the preplan course master set I will use it reset your grade 10-12 course master at end of July. I\'m also exploring \'auto course enrol\' to simplify the enrolling of students based on their course requirements. Any ideas or problems, let me know. -- Les','2019-06-10'),(89,'New Staff Pay System','I\'m developing a new pay system for Chief Napew school. If your school would like to look at this for fall or have some input on design, please let me know. -- Les','2019-06-25'),(90,'Preplan Course Offerings - Completed','I\'ve completed updates to the pre-planning tool to use values from the configuration system. Please let me know if you are using this and need any tweaks, etc. I\'ll update your course master from the preplanning system over the summer, but you\'ll have to let me know to do so. -- Les (openadmin@gmail.com)','2019-06-25'),(91,'Sending Marks to SDS','I had to override some course end dates to send marks to SDS for Cst Robin Cameron school. I\'m updating the send marks to allow users to do that also. In the interim, let me know if any issues, and I\'ll hack this manually for you. -- Les','2019-06-27'),(92,'School Year Update','I\'ve created the 2018-2019 school year databases for previous mark / attendance checking. I\'ve removed previous year data from the active databases so we are ready for the 2019-2020 school year. Please consult the getting started document to see what you have to do in preparation for this coming school year, such as setting the school year and dates closed. --Les','2019-07-30'),(93,'Staff Add/Edit Updated','The Staff Add scripts are now removed, and replaced with a single script that does both add and edit and has a first nation mode (which we use) and another provincial school mode (without INAC fields). As a result there are several fewer scripts, and improved layout for editing. The configuration value g_InacSchool must be set to a nonzero value to work.','2019-07-31'),(94,'Updates to Staff Pay /OA version','I\'ve updated the version number to 11.0. There are some changes to the main index page to show the Staff Pay section to all schools (developed with Theresa at Chief Napew).','2019-08-13'),(95,'Daybook Scripts Updated','I\'ve rewritten/revised all of the daybook scripts. Any problems, let me know! --Les','2019-09-05'),(96,'Staff Pay - Update to AddTransaction','I\'ve added the ability to delete records as well to the AddTransactions script. Other updates also done to this script.','2019-09-08'),(97,'Nominal Roll - updating','I\'m working on updating nominal roll and new staff/student values for this year. FYI. --Les','2019-09-11');
/*!40000 ALTER TABLE `oaupdate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `period_data`
--

DROP TABLE IF EXISTS `period_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `period_data` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `timeset` smallint(5) unsigned DEFAULT NULL,
  `period` tinyint(3) unsigned DEFAULT NULL,
  `starttime` time DEFAULT NULL,
  `endtime` time DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `period_data`
--

LOCK TABLES `period_data` WRITE;
/*!40000 ALTER TABLE `period_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `period_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `period_map`
--

DROP TABLE IF EXISTS `period_map`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `period_map` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `timeset` smallint(5) unsigned DEFAULT NULL,
  `timetype` varchar(32) DEFAULT NULL,
  `timeval` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `period_map`
--

LOCK TABLES `period_map` WRITE;
/*!40000 ALTER TABLE `period_map` DISABLE KEYS */;
/*!40000 ALTER TABLE `period_map` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `plan_homework`
--

DROP TABLE IF EXISTS `plan_homework`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `plan_homework` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `subjsec` varchar(32) DEFAULT NULL,
  `teacher` varchar(40) DEFAULT NULL,
  `duedatetime` datetime DEFAULT NULL,
  `currentdatetime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `topic` varchar(255) DEFAULT NULL,
  `description` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `plan_homework`
--

LOCK TABLES `plan_homework` WRITE;
/*!40000 ALTER TABLE `plan_homework` DISABLE KEYS */;
/*!40000 ALTER TABLE `plan_homework` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ppvt_test`
--

DROP TABLE IF EXISTS `ppvt_test`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ppvt_test` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studnum` int(11) DEFAULT NULL,
  `tdate` date DEFAULT NULL,
  `tauthor` varchar(40) DEFAULT NULL,
  `tgrade` varchar(8) DEFAULT NULL,
  `tstamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `rawscore` smallint(6) DEFAULT NULL,
  `stdscore` smallint(6) DEFAULT NULL,
  `confsetting` smallint(6) DEFAULT NULL,
  `confstart` smallint(6) DEFAULT NULL,
  `confend` smallint(6) DEFAULT NULL,
  `percentile` smallint(6) DEFAULT NULL,
  `normalce` smallint(6) DEFAULT NULL,
  `stanine` smallint(6) DEFAULT NULL,
  `growthsv` smallint(6) DEFAULT NULL,
  `equivage` varchar(10) DEFAULT NULL,
  `equivgrade` varchar(10) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ppvt_test`
--

LOCK TABLES `ppvt_test` WRITE;
/*!40000 ALTER TABLE `ppvt_test` DISABLE KEYS */;
/*!40000 ALTER TABLE `ppvt_test` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `preplan_coursemaster`
--

DROP TABLE IF EXISTS `preplan_coursemaster`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `preplan_coursemaster` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `subjcode` varchar(32) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `grade` varchar(8) DEFAULT NULL,
  `teacher` varchar(255) DEFAULT NULL,
  `section` varchar(32) DEFAULT NULL,
  `subjsec` varchar(32) DEFAULT NULL,
  `startterm` tinyint(3) unsigned DEFAULT NULL,
  `endterm` tinyint(3) unsigned DEFAULT NULL,
  `offeredto` varchar(8) DEFAULT NULL,
  `backedwith` varchar(32) DEFAULT NULL,
  `semester` varchar(8) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `preplan_coursemaster`
--

LOCK TABLES `preplan_coursemaster` WRITE;
/*!40000 ALTER TABLE `preplan_coursemaster` DISABLE KEYS */;
/*!40000 ALTER TABLE `preplan_coursemaster` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `preplan_courseperiods`
--

DROP TABLE IF EXISTS `preplan_courseperiods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `preplan_courseperiods` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `subjsec` varchar(32) DEFAULT NULL,
  `semester` varchar(8) DEFAULT NULL,
  `periods` tinyint(3) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `preplan_courseperiods`
--

LOCK TABLES `preplan_courseperiods` WRITE;
/*!40000 ALTER TABLE `preplan_courseperiods` DISABLE KEYS */;
/*!40000 ALTER TABLE `preplan_courseperiods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prereg`
--

DROP TABLE IF EXISTS `prereg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prereg` (
  `studid` int(11) NOT NULL AUTO_INCREMENT,
  `lastname` varchar(40) DEFAULT NULL,
  `firstname` varchar(40) DEFAULT NULL,
  `initial` varchar(40) DEFAULT NULL,
  `studnum` int(11) DEFAULT NULL,
  `grade` varchar(8) DEFAULT NULL,
  `homeroom` varchar(8) DEFAULT NULL,
  `sex` char(1) DEFAULT NULL,
  `birthdate` date DEFAULT NULL,
  `house` varchar(20) DEFAULT NULL,
  `healthid` varchar(12) DEFAULT NULL,
  `entry` varchar(255) DEFAULT NULL,
  `ethnic` varchar(20) DEFAULT NULL,
  `single` char(1) DEFAULT NULL,
  `internet` char(1) DEFAULT NULL,
  `youngest` char(1) DEFAULT NULL,
  `owing` decimal(9,2) DEFAULT NULL,
  `treaty` varchar(20) DEFAULT NULL,
  `medical` mediumtext,
  `studrel` varchar(25) DEFAULT NULL,
  `momrel` varchar(25) DEFAULT NULL,
  `dadrel` varchar(25) DEFAULT NULL,
  `parish` varchar(255) DEFAULT NULL,
  `commun` char(1) DEFAULT NULL,
  `recon` char(1) DEFAULT NULL,
  `confirm` char(1) DEFAULT NULL,
  `maiden` varchar(40) DEFAULT NULL,
  `relation1` varchar(20) DEFAULT NULL,
  `contact1` varchar(255) DEFAULT NULL,
  `name1` varchar(255) DEFAULT NULL,
  `hphone1` varchar(64) DEFAULT NULL,
  `wphone1` varchar(64) DEFAULT NULL,
  `cell1` varchar(64) DEFAULT NULL,
  `fax1` varchar(64) DEFAULT NULL,
  `address1` varchar(40) DEFAULT NULL,
  `city1` varchar(40) DEFAULT NULL,
  `pcode1` varchar(10) DEFAULT NULL,
  `workplace1` varchar(60) DEFAULT NULL,
  `relation2` varchar(20) DEFAULT NULL,
  `contact2` varchar(255) DEFAULT NULL,
  `name2` varchar(255) DEFAULT NULL,
  `hphone2` varchar(64) DEFAULT NULL,
  `wphone2` varchar(64) DEFAULT NULL,
  `cell2` varchar(64) DEFAULT NULL,
  `fax2` varchar(64) DEFAULT NULL,
  `address2` varchar(40) DEFAULT NULL,
  `city2` varchar(40) DEFAULT NULL,
  `pcode2` varchar(10) DEFAULT NULL,
  `workplace2` varchar(60) DEFAULT NULL,
  `emrelation` varchar(20) DEFAULT NULL,
  `emname` varchar(255) DEFAULT NULL,
  `emhphone` varchar(64) DEFAULT NULL,
  `emwphone` varchar(64) DEFAULT NULL,
  `emcell` varchar(64) DEFAULT NULL,
  `doctor` varchar(70) DEFAULT NULL,
  `docphone` varchar(15) DEFAULT NULL,
  `busroute` varchar(30) DEFAULT NULL,
  `provnum` varchar(12) DEFAULT NULL,
  `band` varchar(64) DEFAULT NULL,
  `bandnum` varchar(32) DEFAULT NULL,
  `baptism` char(1) DEFAULT NULL,
  `contact` varchar(255) DEFAULT NULL,
  `family` varchar(32) DEFAULT NULL,
  `alias` varchar(16) DEFAULT NULL,
  `pic` varchar(255) DEFAULT NULL,
  `password` varchar(32) DEFAULT NULL,
  `field1` varchar(255) DEFAULT NULL,
  `field2` varchar(255) DEFAULT NULL,
  `field3` varchar(255) DEFAULT NULL,
  `prov1` varchar(32) DEFAULT NULL,
  `prov2` varchar(32) DEFAULT NULL,
  `reserveres` varchar(64) DEFAULT NULL,
  `program` varchar(64) DEFAULT NULL,
  `utag` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `trans_type` varchar(255) DEFAULT NULL,
  `trans_name` varchar(255) DEFAULT NULL,
  `trans_am_route` varchar(64) DEFAULT NULL,
  `trans_pickup_time` varchar(16) DEFAULT NULL,
  `trans_pm_route` varchar(64) DEFAULT NULL,
  `trans_dropoff_time` varchar(16) DEFAULT NULL,
  `trans_bus_stop_location` varchar(64) DEFAULT NULL,
  `group_after_school_prog` char(1) DEFAULT NULL,
  `lunchstatus` varchar(255) DEFAULT NULL,
  `par1_email` varchar(64) DEFAULT NULL,
  `par2_email` varchar(64) DEFAULT NULL,
  `name_prefix` varchar(64) DEFAULT NULL,
  `name_suffix` varchar(64) DEFAULT NULL,
  `name_knownas` varchar(64) DEFAULT NULL,
  `group_alt1` varchar(64) DEFAULT NULL,
  `group_alt2` varchar(64) DEFAULT NULL,
  `group_alt3` varchar(64) DEFAULT NULL,
  `billet` varchar(255) DEFAULT NULL,
  `childcare_name` varchar(255) DEFAULT NULL,
  `childcare_address` varchar(255) DEFAULT NULL,
  `childcare_phone1` varchar(255) DEFAULT NULL,
  `childcare_phone2` varchar(255) DEFAULT NULL,
  `internet_type` varchar(255) DEFAULT NULL,
  `par1_firstname` varchar(255) DEFAULT NULL,
  `par1_lastname` varchar(255) DEFAULT NULL,
  `par2_firstname` varchar(255) DEFAULT NULL,
  `par2_lastname` varchar(255) DEFAULT NULL,
  `graddate` date DEFAULT NULL,
  `ldap_uid` varchar(64) DEFAULT NULL,
  `ldap_uidnumber` mediumint(9) DEFAULT NULL,
  `ldap_gidnumber` mediumint(9) DEFAULT NULL,
  `address_land` varchar(32) DEFAULT NULL,
  `tuition_status` varchar(64) DEFAULT NULL,
  `tuition_duration` varchar(64) DEFAULT NULL,
  `tuition_program` varchar(128) DEFAULT NULL,
  `tuition_collect` tinyint(4) DEFAULT NULL,
  `tuition_country` varchar(8) DEFAULT NULL,
  `immersion_type` varchar(32) DEFAULT NULL,
  `cumfolder` tinyint(4) DEFAULT NULL,
  `address1mailing` varchar(128) DEFAULT NULL,
  `address2mailing` varchar(128) DEFAULT NULL,
  `parent_lockout` varchar(8) DEFAULT NULL,
  PRIMARY KEY (`studid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prereg`
--

LOCK TABLES `prereg` WRITE;
/*!40000 ALTER TABLE `prereg` DISABLE KEYS */;
/*!40000 ALTER TABLE `prereg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prereg_staff`
--

DROP TABLE IF EXISTS `prereg_staff`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prereg_staff` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sal` varchar(6) DEFAULT NULL,
  `lastname` varchar(60) DEFAULT NULL,
  `firstname` varchar(40) DEFAULT NULL,
  `middlename` varchar(40) DEFAULT NULL,
  `userid` varchar(40) DEFAULT NULL,
  `password` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `tdate` date DEFAULT NULL,
  `doatt` char(1) DEFAULT NULL,
  `certification1` varchar(255) DEFAULT NULL,
  `home_phone` varchar(64) DEFAULT NULL,
  `cell_phone` varchar(64) DEFAULT NULL,
  `street` varchar(64) DEFAULT NULL,
  `city` varchar(32) DEFAULT NULL,
  `prov` varchar(32) DEFAULT NULL,
  `pcode` varchar(32) DEFAULT NULL,
  `emergency_contact_name` varchar(255) DEFAULT NULL,
  `emergency_contact_phone` varchar(255) DEFAULT NULL,
  `driver_license` varchar(64) DEFAULT NULL,
  `driver_class` varchar(64) DEFAULT NULL,
  `vehicle_reg` varchar(64) DEFAULT NULL,
  `vehicle_plate` varchar(64) DEFAULT NULL,
  `citizenship` varchar(64) DEFAULT NULL,
  `passport` varchar(64) DEFAULT NULL,
  `alt_street` varchar(64) DEFAULT NULL,
  `alt_city` varchar(32) DEFAULT NULL,
  `alt_prov` varchar(32) DEFAULT NULL,
  `alt_country` varchar(64) DEFAULT NULL,
  `alt_pcode` varchar(32) DEFAULT NULL,
  `alt_phone` varchar(64) DEFAULT NULL,
  `alt_email` varchar(64) DEFAULT NULL,
  `certification2` varchar(255) DEFAULT NULL,
  `certification3` varchar(255) DEFAULT NULL,
  `certification4` varchar(255) DEFAULT NULL,
  `certification5` varchar(255) DEFAULT NULL,
  `certification6` varchar(255) DEFAULT NULL,
  `certification7` varchar(255) DEFAULT NULL,
  `certification8` varchar(255) DEFAULT NULL,
  `ldap_uid` varchar(64) DEFAULT NULL,
  `ldap_uidnumber` mediumint(9) DEFAULT NULL,
  `ldap_gidnumber` mediumint(9) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prereg_staff`
--

LOCK TABLES `prereg_staff` WRITE;
/*!40000 ALTER TABLE `prereg_staff` DISABLE KEYS */;
/*!40000 ALTER TABLE `prereg_staff` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prereg_staff_multi`
--

DROP TABLE IF EXISTS `prereg_staff_multi`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prereg_staff_multi` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` varchar(32) DEFAULT NULL,
  `field_name` varchar(255) DEFAULT NULL,
  `field_value` varchar(255) DEFAULT NULL,
  `field_additional` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prereg_staff_multi`
--

LOCK TABLES `prereg_staff_multi` WRITE;
/*!40000 ALTER TABLE `prereg_staff_multi` DISABLE KEYS */;
/*!40000 ALTER TABLE `prereg_staff_multi` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prereg_waitlist`
--

DROP TABLE IF EXISTS `prereg_waitlist`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prereg_waitlist` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studnum` int(11) DEFAULT NULL,
  `enroldate` date DEFAULT NULL,
  `waitnumber` int(11) DEFAULT NULL,
  `description` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prereg_waitlist`
--

LOCK TABLES `prereg_waitlist` WRITE;
/*!40000 ALTER TABLE `prereg_waitlist` DISABLE KEYS */;
/*!40000 ALTER TABLE `prereg_waitlist` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `preset`
--

DROP TABLE IF EXISTS `preset`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `preset` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `lastname` char(40) DEFAULT NULL,
  `firstname` char(40) DEFAULT NULL,
  `initial` char(2) DEFAULT NULL,
  `studnum` int(11) DEFAULT NULL,
  `grade` char(2) DEFAULT NULL,
  `homeroom` char(4) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `preset`
--

LOCK TABLES `preset` WRITE;
/*!40000 ALTER TABLE `preset` DISABLE KEYS */;
/*!40000 ALTER TABLE `preset` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pwalk_eval`
--

DROP TABLE IF EXISTS `pwalk_eval`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pwalk_eval` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) DEFAULT NULL,
  `description` text,
  `authorid` varchar(40) DEFAULT NULL,
  `tuserid` varchar(40) DEFAULT NULL,
  `tlastname` varchar(60) DEFAULT NULL,
  `tfirstname` varchar(40) DEFAULT NULL,
  `tcertnum` varchar(32) DEFAULT NULL,
  `subject` varchar(60) DEFAULT NULL,
  `adatetime` datetime DEFAULT NULL,
  `comment` text,
  `continueedit` char(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pwalk_eval`
--

LOCK TABLES `pwalk_eval` WRITE;
/*!40000 ALTER TABLE `pwalk_eval` DISABLE KEYS */;
/*!40000 ALTER TABLE `pwalk_eval` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pwalk_mst`
--

DROP TABLE IF EXISTS `pwalk_mst`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pwalk_mst` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) DEFAULT NULL,
  `description` text,
  `category` varchar(64) DEFAULT NULL,
  `identcode` varchar(64) DEFAULT NULL,
  `cdate` date DEFAULT NULL,
  `sequence` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=50 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pwalk_mst`
--

LOCK TABLES `pwalk_mst` WRITE;
/*!40000 ALTER TABLE `pwalk_mst` DISABLE KEYS */;
INSERT INTO `pwalk_mst` VALUES (11,'Math Walkthrough','','Instruction','b2f25b26-4b01-4159-bf7c-75ee9785eb6e','2014-01-24',500),(12,'Math Walkthrough','','Instructional Strategies','3f77fffc-6c3a-4302-b925-bab1b1e87052','2014-01-24',540),(8,'Math Walkthrough ','Common expectations for all instruction','Planning and Preparation','ae65de95-5de8-4006-ba16-d8bd4bb67dc7','2014-01-23',510),(9,'Math Walkthrough','','Classroom/Learning Environment','cb4d204a-ce7b-4b0f-a4cc-47dc54f7f374','2014-01-24',520),(10,'Math Walkthrough','','Physical Setting','5f1e5784-49b6-40e6-a832-87c3d151c57c','2014-01-24',530),(13,'General Walkthrough','','Year Plan','d3552862-6024-421c-952f-26fc2206bc6a','2014-01-24',400),(14,'General Walkthrough','','Unit Plan','9335d8e1-ad65-4a4d-bf6b-7c4885d16e46','2014-01-24',410),(15,'General Walkthrough','','Five Day Plan','7d676648-60e4-490e-b852-5326a3e96f07','2014-01-24',420),(16,'General Walkthrough','','Instruction','c5ed08d7-bd3f-45c0-bb07-6bdd0594322f','2014-01-24',430),(17,'General Walkthrough','','Classroom Management','ff4e822b-7b58-44b1-b63e-214e047ea7c7','2014-01-24',440),(18,'General Walkthrough','','Instructional Strategies','9758490d-b7f3-4806-a8a6-aeed7c662577','2014-01-24',450),(19,'General Walkthrough','','DRA/FSiM/PPVT/EYE/CMA Data Usage','b218c149-bbdd-4b83-9984-98fdc6c7c4fa','2014-01-24',460),(20,'PPP Teambuilding Checklist','','Parent Meeting Checklist','789afd3c-3d72-4ac2-bf27-4dd2b07c39a2','2014-01-28',700),(21,'PPP Teambuilding Checklist','','PPP in the classroom','6aeca995-0f28-41ed-8077-a27cd82bce50','2014-01-28',710),(23,'Catalyst Walkthrough','','Organization Skills','40f92e6a-8e0d-450a-8529-0260944864a8','2014-04-09',200),(24,'Catalyst Walkthrough','','Leadership Consultation','e79e1570-d5f4-479b-b4d2-c9c4b56f5d90','2014-04-09',210),(25,'Catalyst Walkthrough','','Support','f3822bbe-5086-451e-9fa5-e70faa7fe3fd','2014-04-09',220),(26,'Catalyst Walkthrough','','Goalsetting and Accountability','d915404e-79b9-4273-b23a-64c9ccff7613','2014-04-09',230),(27,'Catalyst Walkthrough','','Cooperation and Collaboration','526101b7-6fc6-41d0-8524-c2af61052127','2014-04-09',240),(28,'Balanced Literacy','','Read Aloud','7a478bce-27d7-4fa6-b9bc-eb49fc5906fd','2014-05-30',100),(29,'Balanced Literacy','','Shared Reading','348e2e4b-ed92-4a78-9a3a-c70215fec9aa','2014-05-30',110),(30,'Balanced Literacy','','Guided Reading','0be4a22b-2c67-44a5-850d-dd1b3ae767df','2014-05-30',120),(31,'Balanced Literacy','','Independent Reading','d4c952b2-2468-4ea1-9e60-a2cc55bc3ae8','2014-05-30',130),(32,'Early Learning Walkthrough PK,K,1','','Planning','9db8eedd-d572-4661-8579-9177355ef940','2014-06-25',300),(33,'Early Learning Walkthrough PK,K,1','','Environment','21f4d9d8-6512-4065-a995-686ff2e6647e','2014-06-25',310),(34,'Early Learning Walkthrough PK,K,1','','Instruction','4fb6ab6a-c742-4a87-95d6-935b5cb53073','2014-06-25',320),(35,'Early Learning Walkthrough PK,K,1','','Assessment','e4146c73-3d58-4f85-b598-2d22dd1342b2','2014-06-25',330),(36,'Treaty, Language and Culture ','','Planning','80a61665-abfd-4829-866f-12479dc268eb','2014-06-25',600),(37,'Treaty, Language and Culture ','','Environment','a90e36ea-58e7-4e0a-9f01-a089b0ccaa45','2014-06-25',610),(38,'Treaty, Language and Culture ','','Instruction','2df9ec23-fb82-435b-87e7-a39711b4957a','2014-06-25',620),(39,'Treaty, Language and Culture ','','Cree Classroom','64a903b4-491c-4fa6-a4a7-e7f35428b0a6','2014-06-25',630),(40,'Treaty, Language and Culture ','','Protocols','c8d0a369-a70c-4632-ac2e-ca5c4be2b5a7','2014-06-25',640),(42,'Teacher Associate Walkthrough','','Planning','7dd35d07-45ca-4a62-8c58-9c45aad5a692','2014-10-09',550),(43,'Teacher Associate Walkthrough','','Instructional Skills','65b0505a-fe77-48e1-94bd-65d656fd9206','2014-10-09',560),(44,'Teacher Associate Walkthrough','','Evaluation','4a30cd7f-5b3f-4f05-ae20-23663677a26f','2014-10-09',570),(45,'Teacher Associate Walkthrough','','Personal and Professional','f8ff0066-7952-4195-81f4-1e4d9b80e32c','2014-10-09',580),(49,'Data Walkthrough','For principals to monitor data records and to engage staff in using data for a focus for instruction and the improvement of student outcomes','Basic Data Capture','67FA9EF0-E7E3-11E6-8C18-74AD466BEA78','2017-01-31',800);
/*!40000 ALTER TABLE `pwalk_mst` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pwalk_score`
--

DROP TABLE IF EXISTS `pwalk_score`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pwalk_score` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mstid` int(11) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `category` varchar(64) DEFAULT NULL,
  `sequence` int(11) DEFAULT NULL,
  `score` tinyint(3) unsigned DEFAULT NULL,
  `strengths` text,
  `weaknesses` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pwalk_score`
--

LOCK TABLES `pwalk_score` WRITE;
/*!40000 ALTER TABLE `pwalk_score` DISABLE KEYS */;
/*!40000 ALTER TABLE `pwalk_score` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pwalk_tpl`
--

DROP TABLE IF EXISTS `pwalk_tpl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pwalk_tpl` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mstid` int(11) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `category` varchar(64) DEFAULT NULL,
  `sequence` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=293 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pwalk_tpl`
--

LOCK TABLES `pwalk_tpl` WRITE;
/*!40000 ALTER TABLE `pwalk_tpl` DISABLE KEYS */;
INSERT INTO `pwalk_tpl` VALUES (34,8,'Uses approved resources - MMS, FSiM','Planning and Preparation',2),(54,12,'Teacher demonstration','Instructional Strategies',2),(53,12,'Lecture','Instructional Strategies',1),(52,11,'Students can identify outcomes or learning destination','Instruction',5),(51,11,'Evidence of diagnostic tasks and/or pre-assessment','Instruction',4),(50,11,'Evidence of prior knowledge assessment and activation','Instruction',3),(49,11,'Variety of approaches and strategies to aid learning','Instruction',2),(48,11,'Daily math scheduled for required number of minutes','Instruction',1),(59,12,'Students using manipulatives or technology','Instructional Strategies',7),(58,12,'Cooperative group activity','Instructional Strategies',6),(57,12,'Student/student discussion','Instructional Strategies',5),(56,12,'Teacher/student discussion','Instructional Strategies',4),(55,12,'Teacher using technology','Instructional Strategies',3),(35,8,'Evidence of outcome based planning','Planning and Preparation',3),(33,8,'Uses common year plan','Planning and Preparation',1),(36,8,'Evidence of formative assessment','Planning and Preparation',4),(37,8,'Evidence of variety of summative assessments','Planning and Preparation',5),(38,9,'Procedures and rules evident and in use','Classroom/Learning Environment',1),(39,9,'Consistent expectation and response to behavior','Classroom/Learning Environment',2),(40,9,'Math mentors and EA\'s engaged in lesson','Classroom/Learning Environment',3),(41,9,'Teacher demonstrates knowledge of content','Classroom/Learning Environment',4),(42,9,'Appropriate instruction and use of manipulatives','Classroom/Learning Environment',5),(43,10,'Visual aids - number lines, desk tags, hundred chart, word wall','Physical Setting',1),(44,10,'Manipulatives accessible and stored properly','Physical Setting',2),(45,10,'Furniture allows for grouping','Physical Setting',3),(46,10,'Space adequate for activities','Physical Setting',4),(47,10,'Room clean and neat','Physical Setting',5),(60,12,'Small group activity','Instructional Strategies',8),(61,12,'Appropriate independent seat work','Instructional Strategies',9),(62,13,'Instructional timeline for units outlined for year','Year Plan',1),(63,13,'Instructional minutes for units outlined for outcomes','Year Plan',2),(64,13,'Outcomes listed by unit cross referenced to curriculum guide','Year Plan',3),(65,13,'Resources/Instructional strategy for each outcome indicated','Year Plan',4),(66,13,'Evidence of curriculum guide and year plan in daily reflection','Year Plan',5),(67,14,'Unit plan developed through UbD (understanding by design)','Unit Plan',1),(68,14,'Outcomes identified in terms students understand','Unit Plan',2),(69,14,'Indicators identified  in terms students understand','Unit Plan',3),(70,14,'Indicators triangulated (conversation, observation, product)','Unit Plan',4),(71,14,'Resources identified for each indicator','Unit Plan',5),(72,14,'Identifies DI (differentiated instruction)','Unit Plan',6),(73,15,'Lesson outlines in daybook','Five Day Plan',1),(74,15,'Lesson focus evident - what outcome/indicator students learn','Five Day Plan',2),(75,15,'Instruction reflects prior learning/material taught','Five Day Plan',3),(76,15,'Instruction aligns with day plan','Five Day Plan',4),(77,15,'Identifies BDA procedures (before, during, after)','Five Day Plan',5),(78,15,'Identifies DI (differentiated instruction)','Five Day Plan',6),(79,15,'Identifies resources required for instruction','Five Day Plan',7),(80,15,'Identifies formative/summative assessment','Five Day Plan',8),(81,15,'Identifies student attendance and materials to catch up','Five Day Plan',9),(82,16,'Focus for learning evident at beginning of class ','Instruction',1),(83,16,'Motivational set employed','Instruction',2),(84,16,'Variety of instructional strategies employed','Instruction',3),(85,16,'Formative assessment evident in ongoing instruction','Instruction',4),(86,16,'Instruction differentiated to meet student needs','Instruction',5),(87,16,'Pacing of instruction and student work time meets student needs','Instruction',6),(88,16,'Exit strategies employed to student learning/planning for next day','Instruction',7),(89,17,'Expectations of students clearly displayed','Classroom Management',1),(90,17,'Teacher treats students in consistent and equitable manner','Classroom Management',2),(91,17,'Teacher is aware of classroom dynamics','Classroom Management',3),(92,17,'Respect and rapport is evident','Classroom Management',4),(93,17,'Teacher handles student misbehavior appropriately','Classroom Management',5),(94,17,'Transitions are smooth','Classroom Management',6),(95,17,'Teacher circulates during student work time','Classroom Management',7),(96,11,'Corelation guide for FSiM and MMS on teacher desk','Instruction',6),(97,11,'Common year plan in daybook','Instruction',7),(98,18,'Discussion','Instructional Strategies',1),(99,18,'Hands on Learning','Instructional Strategies',2),(100,18,'Inquiry Learning','Instructional Strategies',3),(101,18,'Smartboard/Technology','Instructional Strategies',4),(102,18,'Independent Seat Work','Instructional Strategies',5),(103,18,'Learning Centres','Instructional Strategies',6),(104,18,'Graphic Organizers','Instructional Strategies',7),(105,18,'Differentiated Instruction','Instructional Strategies',8),(106,18,'Modelling','Instructional Strategies',9),(107,18,'Student Presentation','Instructional Strategies',10),(108,18,'Questioning','Instructional Strategies',11),(109,18,'Cooperative Learning','Instructional Strategies',12),(110,19,'Instructional groupings reflect data','DRA/FSiM/PPVT/EYE/CMA Data Usage',1),(111,19,'Focus for instruction relates to areas of growth','DRA/FSiM/PPVT/EYE/CMA Data Usage',2),(112,19,'Recommended timelines for instruction are evident','DRA/FSiM/PPVT/EYE/CMA Data Usage',3),(113,19,'Use of comprehension strategies evident','DRA/FSiM/PPVT/EYE/CMA Data Usage',4),(114,19,'Times blocked for SSP initiatives','DRA/FSiM/PPVT/EYE/CMA Data Usage',5),(115,19,'Appropriate resources are displayed/used in class','DRA/FSiM/PPVT/EYE/CMA Data Usage',6),(116,20,'Meeting scheduled early September','Parent Meeting Checklist',1),(117,20,'Parents present','Parent Meeting Checklist',2),(118,20,'Teachers of child present','Parent Meeting Checklist',3),(119,20,'Administrator present','Parent Meeting Checklist',4),(120,20,'EA of child present','Parent Meeting Checklist',5),(121,20,'Sp. Ed. teacher present','Parent Meeting Checklist',6),(122,20,'Evidence of EYE/summative assessment presented to parents','Parent Meeting Checklist',7),(123,20,'Discussion of child\'s learning style and goals','Parent Meeting Checklist',8),(124,20,'Evidence of ongoing programming to meet child\'s needs','Parent Meeting Checklist',9),(125,20,'Evidence of parent checklist completion','Parent Meeting Checklist',10),(126,21,'PPP identifies, strengths, weaknesses and mastery learning','PPP in the classroom',1),(127,21,'Evidence PPP is updated by teachers','PPP in the classroom',2),(128,21,'Evidence of PPP planning in daybook','PPP in the classroom',3),(129,21,'Proof of assessment plan documents available','PPP in the classroom',4),(130,21,'Filing and paperwork behavioral students up to date','PPP in the classroom',5),(131,21,'Filing and paperwork high cost students up to date','PPP in the classroom',6),(132,21,'Targeted school wide behavior plan in use','PPP in the classroom',7),(133,21,'Teacher demonstrates use of technology in record keeping','PPP in the classroom',8),(134,21,'Teacher demonstrates use of technology in instruction','PPP in the classroom',9),(135,20,'AANDC Documentation completed','Parent Meeting Checklist',11),(136,20,'Results of referrals and tests available','Parent Meeting Checklist',12),(137,23,'Prepares detailed, accurate and timely reports','Organization Skills',1),(138,23,'Delegates responsibility and routine tasks to others ie resource cataloguing','Organization Skills',2),(139,23,'Plans and organizes duties efficiently and effectively','Organization Skills',3),(140,23,'Follows through to see objectives achieved on an established course of action','Organization Skills',4),(141,23,'Spends at least 50% of time directly coaching teachers','Organization Skills',5),(142,23,'Practices effective time management','Organization Skills',6),(143,25,'Effectively guides teachers towards best practice','Support',1),(144,25,'Provides leadership in support and planning unit and lesson plans','Support',2),(145,25,'Provides leadership and support in assessment','Support',3),(146,25,'Provides leadership and support in implementing curriculum','Support',4),(147,25,'Provides leadership and support in instructional approaches','Support',5),(148,24,'Consults with staff and enables cooperative efforts with enthusiasm','Leadership Consultation',1),(149,24,'Consults with administration about decisions affecting ELA/Math program','Leadership Consultation',2),(150,24,'Consults with staff about decisions affecting ELA/Math program','Leadership Consultation',3),(151,24,'Facilitates effective group meetings with staff','Leadership Consultation',4),(152,24,'Provides feedback in a respectful manner','Leadership Consultation',5),(153,26,'Articulate and clear in expressing thoughts; directions easily followed','Goalsetting and Accountability',1),(154,26,'Researches best practice and provides appropriate resources','Goalsetting and Accountability',2),(155,26,'Helps set and maintain focus on Balanced Literacy/CYP','Goalsetting and Accountability',3),(156,26,'Establishes school action plan and coordinates improvement activities','Goalsetting and Accountability',4),(157,26,'Evaluates school progress in relation to school learning focus','Goalsetting and Accountability',5),(158,27,'Demonstrates empathy, consideration and good judgment when dealing  with people','Cooperation and Collaboration',1),(159,27,'Listens well, participates in, but does not dominate group discussion','Cooperation and Collaboration',2),(160,27,'Willingly accepts constructive feedback','Cooperation and Collaboration',3),(161,27,'Strives to be the type of person other people like to work with','Cooperation and Collaboration',4),(162,27,'Practices positive collaboration with staff','Cooperation and Collaboration',5),(163,27,'Constructive and affirming when providing feedback','Cooperation and Collaboration',6),(164,27,'Supportive not evaluative','Cooperation and Collaboration',7),(165,28,'Teacher plan indicates a teaching focus for the lesson','Read aloud',1),(166,28,'Teacher plan indicates daily read aloud with a book title','Read aloud',2),(167,28,'Whole class session with the teacher reading aloud expressively','Read aloud',3),(168,28,'Students listening purposefully and actively','Read aloud',4),(169,28,'Teacher pausing at planned places to think aloud about strategies','Read aloud',5),(170,29,'Teacher plan indicates a teaching focus for each day','Shared Reading',1),(171,29,'Teacher plan indicates that text is used over several days','Shared Reading',2),(172,29,'Explicit instruction on reading comprehension strategies with skills','Shared Reading',3),(173,29,'Whole class session with teacher and students reading a communal text','Shared Reading',4),(174,29,'Teacher reads the text aloud followed by students reading in unison or small groups','Shared Reading',5),(175,29,'Word study connected to daily reading and writing','Shared Reading',6),(176,29,'Time provided for students to talk about text and their thinking','Shared Reading',7),(177,30,' Teacher plan indicates/skill strategy focus, focus questions and group information','Guided Reading',1),(178,30,'Teacher reinforces comprehension strategies and skills that have been previously modelled','Guided Reading',2),(179,30,'Teacher plans a Before, During and After lesson','Guided Reading',3),(180,30,'Working with 5 to 6 students using short texts (fiction and non-fiction) at their instructional level','Guided Reading',4),(181,30,'Students read the text independently and practice strategies while the teacher provides support','Guided Reading',5),(182,30,'Teachers listen to individuals read and prompt when needed','Guided Reading',6),(183,30,'Students read the text independently and are NOT round robin reading','Guided Reading',7),(184,30,'Sets guiding questions to focus comprehension and lead discussions to promote deeper understanding of text and strategy use','Guided Reading',8),(185,30,'Running records are used to assess student progress','Guided Reading',9),(186,30,'Other students are working independently','Guided Reading',10),(187,31,'Teacher plan indicates a mini-lesson with a purpose for reading','Independent Reading',1),(188,31,'Students have selected text at their independent reading level','Independent Reading',2),(189,31,'Students are reading independently for a sustained period of time and practice strategies taught during explicit strategy instruction','Independent Reading',3),(190,31,'Students keep a reading log','Independent Reading',4),(191,31,'Teacher conducts individual conferences with students and keeps anecdotal notes','Independent Reading',5),(192,31,'Time allowed for sharing','Independent Reading',6),(193,32,'Teacher is flexible in planning, understands curriculum evolves on student interest','Planning',1),(194,32,'All units incorporate evidence of First Nations materials relating to Treaty, Language and Culture','Planning',2),(195,32,'Play is purposeful and planned','Planning',3),(196,32,'Play centres are modified, added to, refreshed and enhanced as children develop competencies','Planning',4),(197,32,'Invitations used to explore child’s prior knowledge and interests and enhance learning','Planning',5),(198,32,'Balance between direct teaching, inquiry and play','Planning',6),(199,32,'Balance between whole group, small group and individual instruction based on student need','Planning',7),(200,32,'Scheduled blocks of time for children to engage in inquiry and exploration ','Planning',8),(201,32,'Incorporation of technology, community resources and traditional knowledge keepers','Planning',9),(202,33,'Reflects children’s’ photos creations, conversations and classroom displays','Environment',1),(203,33,'Work displayed is created by children and is of interest to them','Environment',2),(204,33,'Indoor and outdoor environments support safe and healthy development in learning','Environment',3),(205,33,'Literacy rich environment with variety of literature, including First Nations literature , print and writing materials at every learning centre','Environment',4),(206,33,'Layout and access thoughtful, uncluttered and organized according to student needs','Environment',5),(207,33,'First Nations cultural items and elements of natural environment in classroom environment in meaningful way','Environment',6),(208,34,'Open ended questions to engage student conversation to scaffold/extend learning','Instruction',1),(209,34,'Guides learning through interaction, observation and documentation','Instruction',2),(210,34,'Promotes openness, opportunity for interaction and shows interest in children','Instruction',3),(211,34,'Nurtures and supports children through words, action and body language','Instruction',4),(212,34,'Views children as capable, competent learners, respecting prior knowledge, culture and experiences','Instruction',5),(213,35,'Uses variety of research based methods to collect information','Assessment',1),(214,35,'Evidence of accessibility for parents and children ','Assessment',2),(215,36,'Evidence of Elder plan being used in day book or on wall','Planning',1),(216,36,'Evidence of daily lesson plan','Planning',2),(217,36,'Evidence of Treaty Language and Culture into regular instruction','Planning',3),(218,36,'Evidence of use of Treaty kits in the classroom','Planning',4),(219,36,'Evidence of Cultural Year Plan in day book and on wall','Planning',5),(220,37,'Cree word beside English word on wall','Environment',1),(221,37,'Cree word weekly charts used by Cree and non-Cree speaking staff','Environment',2),(222,37,'Evidence of Treaties posted on walls','Environment',3),(223,37,'All objects in class labeled in Cree','Environment',4),(224,37,'Cree world view displayed on wall','Environment',5),(225,37,'Evidence of morning prayer where applicable','Environment',6),(226,37,'Evidence of smudging where applicable','Environment',7),(227,38,'Evidence of use of the word of the day','Instruction',1),(228,38,'Evidence of tipi teachings/virtues incorporated into lesson ','Instruction',2),(229,38,'Evidence of cultural relationship skills with students','Instruction',3),(230,38,'Evidence of relationship skills with students','Instruction',4),(231,39,'Instruction in Cree only','Cree Classroom',1),(232,39,'Use of other strategies than coloring','Cree Classroom',2),(233,39,'Evidence of Cree learning centres','Cree Classroom',3),(234,39,'Teacher demonstrates cultural protocols as related to age and sex','Cree Classroom',4),(235,39,'Teacher knows how to engage oskapewis as the bridge between school, community and traditional knowledge keepers','Cree Classroom',5),(236,39,'Teachers know how to engage Elders in discussion of sacred sites and other teachings and their meaning','Cree Classroom',6),(237,39,'Teachers use Elders to bridge traditional knowledge with oral tradition of the community','Cree Classroom',7),(238,40,'Teacher is familiar with the uses/abuses of tobacco','Protocols',1),(239,40,'Teacher is familiar with protocol for presenting tobacco to an Elder','Protocols',2),(282,12,'Teacher used Common Math Assessments as a part of instructional strategy','Instructional Strategies',10),(246,36,'Evidence of common Cree Language Year Plan being used in day book or on wall','Planning',6),(281,8,'Uses Common Math Assessment outcomes in planning instruction','Planning and Preparation',6),(280,11,'Evidence of use of CMA assessment to focus instruction ','Instruction',8),(253,42,'Follows IEP objectives','Planning',1),(254,42,'Takes initiative to change plans when necessary','Planning',2),(255,42,'Works as a team with teachers of assigned students','Planning',3),(256,42,'Plans activities around stated IEP objectives','Planning',4),(257,42,'Keeps accurate records in daily log books','Planning',5),(258,42,'Plans to use a variety of methods, activities and management strategies','Planning',6),(259,43,'Gives clear directions','Instructional Skills',1),(260,43,'Uses encouragement and praise to support student effort','Instructional Skills',2),(261,43,'Implements a variety of activities around the stated objective','Instructional Skills',3),(262,43,'Monitors student work','Instructional Skills',4),(263,43,'Uses a variety of classroom management strategies','Instructional Skills',5),(264,43,'Works diligently with assigned students','Instructional Skills',6),(265,44,'Makes suggestions about lesson based on what was effective with children','Evaluation',1),(266,44,'Communicates with teacher regarding evaluation','Evaluation',2),(267,44,'Evaluates and provides feedback about lesson to the teacher','Evaluation',3),(268,44,'Takes initiative to change lessons based on child\'s responses','Evaluation',4),(269,44,'Participates in parent teacher interviews','Evaluation',5),(270,44,'Contacts parents frequently about student progress','Evaluation',6),(271,45,'Demonstrates a cooperative, professional relationship with staff','Personal and Professional',1),(272,45,'Demonstrates a cooperative, professional relationship with supervisors','Personal and Professional',2),(273,45,'Demonstrates a cooperative, professional relationship with parents','Personal and Professional',3),(274,45,'Shows a willingness to be flexible','Personal and Professional',4),(275,45,'Shows a willingness to be creative and attempts new ways to work with students','Personal and Professional',5),(276,45,'Exhibits warmth, patience, tolerance, empathy and respect to students','Personal and Professional',6),(277,45,'Is involved in extra-curricular activities and school communities','Personal and Professional',7),(278,45,'Is punctual for assigned duties','Personal and Professional',8),(279,45,'Willingness to develop as a professional by participating in PD','Personal and Professional',9),(283,49,'Data Observations','Basic Data Capture',1),(284,49,'Three Things I Saw','Basic Data Capture',2),(285,49,'Two Questions I Have','Basic Data Capture',3),(286,49,'One Thing I Liked','Basic Data Capture',4),(292,49,'Next Steps','Basic Data Capture',6),(291,49,'Notes From Conversation With Teacher','Basic Data Capture',5);
/*!40000 ALTER TABLE `pwalk_tpl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `read_level`
--

DROP TABLE IF EXISTS `read_level`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `read_level` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `readlevel` varchar(4) DEFAULT NULL,
  `category` varchar(255) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `seq` int(11) DEFAULT NULL,
  `help1` text,
  `help2` text,
  `help3` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=589 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `read_level`
--

LOCK TABLES `read_level` WRITE;
/*!40000 ALTER TABLE `read_level` DISABLE KEYS */;
INSERT INTO `read_level` VALUES (224,'2','Oral Fluency','Accuracy',60,NULL,NULL,NULL),(225,'2','Printed Language Concepts','Directionality',70,NULL,NULL,NULL),(226,'2','Printed Language Concepts','One-to-One Correspondence',80,NULL,NULL,NULL),(227,'2','Printed Language Concepts','Words/Letters',90,NULL,NULL,NULL),(25,'2','Reading Engagement','Literacy Support',10,NULL,NULL,NULL),(26,'2','Reading Engagement','Favorite Book',20,NULL,NULL,NULL),(27,'2','Reading Engagement','Book Handling Skills',30,NULL,NULL,NULL),(223,'2','Oral Fluency','Use of Cues',50,NULL,NULL,NULL),(222,'2','Oral Fluency','Monitoring/Self-Corrections',40,NULL,NULL,NULL),(480,'28N','Comprehension','Literal Comprehension',110,NULL,NULL,NULL),(481,'28N','Comprehension','Interpretation',120,NULL,NULL,NULL),(482,'28N','Comprehension','Reflection',130,NULL,NULL,NULL),(483,'28F','Reading Engagement','Wide Reading',10,NULL,NULL,NULL),(484,'28F','Reading Engagement','Self Assessment/Goal Setting',20,NULL,NULL,NULL),(485,'28F','Oral Fluency','Expression',30,NULL,NULL,NULL),(486,'28F','Oral Fluency','Phrasing',40,NULL,NULL,NULL),(487,'28F','Oral Fluency','Rate',50,NULL,NULL,NULL),(488,'28F','Oral Fluency','Accuracy',60,NULL,NULL,NULL),(489,'28F','Comprehension','Use of Text features',70,NULL,NULL,NULL),(460,'16N','Oral Fluency','Phrasing',40,NULL,NULL,NULL),(461,'16N','Oral Fluency','Rate',50,NULL,NULL,NULL),(462,'16N','Oral Fluency','Accuracy',60,NULL,NULL,NULL),(463,'16N','Comprehension','Previewing',70,NULL,NULL,NULL),(464,'16N','Comprehension','Retelling: Key Ideas and Facts',80,NULL,NULL,NULL),(465,'16N','Comprehension','Retelling: Details',90,NULL,NULL,NULL),(466,'16N','Comprehension','Retelling: Vocabulary',100,NULL,NULL,NULL),(467,'16N','Comprehension','Retelling: Teacher Support',110,NULL,NULL,NULL),(468,'16N','Comprehension','Using nonfiction text features',120,NULL,NULL,NULL),(469,'16N','Comprehension','Making Connections',130,NULL,NULL,NULL),(470,'28N','Reading Engagement','Wide Reading',10,NULL,NULL,NULL),(471,'28N','Reading Engagement','Self Assessment/Goal Setting',20,NULL,NULL,NULL),(472,'28N','Oral Fluency','Expression',30,NULL,NULL,NULL),(473,'28N','Oral Fluency','Phrasing',40,NULL,NULL,NULL),(474,'28N','Oral Fluency','Rate',50,NULL,NULL,NULL),(475,'28N','Oral Fluency','Accuracy',60,NULL,NULL,NULL),(476,'28N','Comprehension','Prediction',70,NULL,NULL,NULL),(477,'28N','Comprehension','Nonfiction Text Features',80,NULL,NULL,NULL),(478,'28N','Comprehension','Scaffolded Summary',90,NULL,NULL,NULL),(479,'28N','Comprehension','Scaffolded Summary: Vocabulary',100,NULL,NULL,NULL),(459,'16N','Oral Fluency','Expression',30,NULL,NULL,NULL),(458,'16N','Reading Engagement','Sustained Reading',20,NULL,NULL,NULL),(457,'16N','Reading Engagement','Book Selection',10,NULL,NULL,NULL),(431,'4','Reading Engagement','Book Selection',10,NULL,NULL,NULL),(432,'4','Reading Engagement','Sustained Reading',20,NULL,NULL,NULL),(433,'4','Oral Fluency','Phrasing',30,NULL,NULL,NULL),(434,'4','Oral Fluency','Monitoring/Self Correction',40,NULL,NULL,NULL),(435,'4','Oral Fluency','Problem Solving Unknown Words',50,NULL,NULL,NULL),(436,'4','Oral Fluency','Accuracy',60,NULL,NULL,NULL),(437,'4','Comprehension','Previewing',70,NULL,NULL,NULL),(438,'4','Comprehension','Retelling: Sequence of Events',80,NULL,NULL,NULL),(439,'4','Comprehension','Retelling: Characters and Details',90,NULL,NULL,NULL),(440,'4','Comprehension','Retelling: Vocabulary',100,NULL,NULL,NULL),(441,'4','Comprehension','Retelling: Teacher Support',110,NULL,NULL,NULL),(442,'4','Comprehension','Reflection',120,NULL,NULL,NULL),(443,'4','Comprehension','Making Connections',130,NULL,NULL,NULL),(444,'16F','Reading Engagement','Book Selection',10,NULL,NULL,NULL),(445,'16F','Reading Engagement','Sustained Reading',20,NULL,NULL,NULL),(446,'16F','Oral Fluency','Expression',30,NULL,NULL,NULL),(447,'16F','Oral Fluency','Phrasing',40,NULL,NULL,NULL),(448,'16F','Oral Fluency','Rate',50,NULL,NULL,NULL),(449,'16F','Oral Fluency','Accuracy',60,NULL,NULL,NULL),(450,'16F','Comprehension','Previewing',70,NULL,NULL,NULL),(451,'16F','Comprehension','Retelling: Sequence of Events',80,NULL,NULL,NULL),(452,'16F','Comprehension','Retelling: Characters and Details',90,NULL,NULL,NULL),(453,'16F','Comprehension','Retelling: Vocabulary',100,NULL,NULL,NULL),(454,'16F','Comprehension','Retelling: Teacher Support',110,NULL,NULL,NULL),(455,'16F','Comprehension','Reflection',120,NULL,NULL,NULL),(456,'16F','Comprehension','Making Connections',130,NULL,NULL,NULL),(43,'12','Reading Engagement','Book Selection',10,'<li>Model and discuss why readers have favorite books and authors</li>\n<li>Model and support how to select \"just right\" new texts for independent reading</li>\n<li>Provide guided opportunities to select familiar stories for rereading</li>\n','<li>Allie\'s Wish; Robert\'s New Friend</li>\n',NULL),(44,'12','Reading Engagement','Sustained Reading',20,'<li>Create structures and routines to support buddy reading</li>\n<li>Create structures to support reading at home</li>\n<li>Model and support the use of sustained reading time</li>\n','<li>Allie\'s Wish; Robert\'s New Friend</li>\n',NULL),(45,'12','Oral Fluency','Phrasing',30,'<li>Encourage students to read in phrases during shared reading</li>\r\n<li>Show how words are grouped into phrases in big books and poetry charts</li>\r\n<li>Support rereading familiar texts to build fluency</li>\r\n','<li>Allie\'s Wish; Robert\'s New Friend</li>\r\n',''),(46,'12','Oral Fluency','Monitoring/Self-Corrections',40,'<li>Demonstrate and teach how to read for meaning, self-correcting when a word doesn\'t make sense or sound right</li>\n<li>Model and support confirming and discounting word choice using meaning, language, and visual information</li>\n<li>Model and teach how to monitor visual information, self-correcting when a word doesn\'t look right</li>\n<li>Model and teach how to use known words as a means to self-monitor</li>\n<li>Support one-to-one matching as a means to self-monitor</li>\n','<li>Allie\'s Wish; Robert\'s New Friend</li>\n',NULL),(47,'12','Oral Fluency','Problem-Solving Unknown Words',50,'<li>Model and support using beginning letter(s)/sounds(s), sentence and/or story structure, as well as meaning (illustrations and background knowledge) to problem-solve unknown words</li>\n<li>Teach how to take words apart (onset and rime) to problem-solve unknown words</li>\n','<li>Allie\'s Wish; Robert\'s New Friend</li>\n',NULL),(48,'12','Oral Fluency','Accuracy',60,NULL,NULL,NULL),(49,'12','Comprehension','Previewing',70,'<li>Model and support previewing a book before reading, during read-aloud and shared reading experinces</li>\n<li>Support creating a story from the illustrations </li>\n','<li>Allie\'s Wish; Robert\'s New Friend</li>\n',NULL),(50,'12','Comprehension','Retelling:  Sequence of Events',80,'<li>Demonstrate how to create and use story maps to aid retelling. </li>\n<li>Model and support using key language/vocabulary from the text in a retelling. </li>\n<li>Model and teach the elements in a good retelling.</li>\n<li>Model the retelling of familiar stories.</li>\n<li>Support retelling a story in sequence. </li>\n','<li>Allie\'s Wish; Robert\'s New Friend</li>\n',NULL),(51,'12','Comprehension','Retelling:  Characters and Details',90,'<li>Demonstrate how to create and use story maps to aid retelling</li>\n<li>Encourage student to use characters\' names when retelling a story</li>\n<li>Model and teach the elements in a good retelling</li>\n<li>Model the retelling of familiar stories</li>\n<li>Support and reinforce student\'s response to books during read-aloud, and shared and guided reading experiences</li>\n','<li>Allie\'s Wish; Robert\'s New Friend</li>\n',NULL),(52,'12','Comprehension','Retelling:  Vocabulary',100,'<li>Demonstrate how to create and use story maps to aid retelling</li>\n<li>Model and support using key language/vocabulary from the text in a retelling</li>\n<li>Model and teach the elements in a good retelling</li>\n<li>Model the retelling of familiar stories</li>\n','<li>Allie\'s Wish; Robert\'s New Friend</li>\n',NULL),(53,'12','Comprehension','Retelling:  Teacher Support',110,'<li>Demonstrate how to create and use story maps to aid retelling</li>\n<li>Model and support using key language/vocabulary from the text in a retelling</li>\n<li>Model and teach the elements in a good retelling</li>\n<li>Model the retelling of familiar stories</li>\n','<li>Allie\'s Wish; Robert\'s New Friend</li>\n',NULL),(54,'12','Comprehension','Reflection',120,'<li>Demonstrate how to give reason(s) for one\'s opinion</li>\n<li>Help student identify favorite part of books</li>\n<li>Provide opportunities to select a favorite book, toy, TV show, etc and tell why it is a favorite</li>\n','<li>Allie\'s Wish; Robert\'s New Friend</li>\n',NULL),(55,'12','Comprehension','Making Connections',130,'<li>Model and support how to make text-to-text connections</li>\n<li>Model and teach how to make text-to-self conections</li>\n','<li>Allie\'s Wish; Robert\'s New Friend</li>\n',NULL),(56,'14','Reading Engagement','Book Selection',10,'<li>Introduce student to reading materials from a variety of genres</li>\n<li>Model and discuss why readers have favorite books and authors</li>\n<li>Teach student strategies to select \"just right\" texts for independent reading</li>\n','<li>A New School; The Wagon</li>\n',NULL),(57,'14','Reading Engagement','Sustained Reading',20,'<li>Create structures and routines to support reading at home</li>\n<li>Develop clear expectations for amount of independent reading</li>\n<li>Model and support the use of sustained reading time</li>\n<li>Provide opportunities for buddy reading</li>\n','<li>A New School; The Wagon</li>\n',''),(58,'14','Oral Fluency','Expression',30,'<li>Have student participate in choral reading and/or reader\'s theater</li>\n<li>Have student practice appropriate phrasing and expression with familiar texts</li>\n<li>Model and support reading in longer meaningful phrases with appropriate expression</li>\n<li>Model and teach how to heed punctuation</li>\n','<li>A New School; The Wagon</li>\n',NULL),(59,'14','Oral Fluency','Phrasing',40,'<li>Have student participate in choral reading and/or reader\'s theater</li>\n<li>Have student practice appropriate phrasing and expression with familiar texts</li>\n<li>Model and support reading in longer meaningful phrases with appropriate expression</li>\n<li>Model and teach how to heed punctuation</li>\n','<li>A New School; The Wagon</li>\n',NULL),(60,'14','Oral Fluency','Rate',50,'<li>Provide materials and time for repeated reading to increase reading rate</li>\n<li>Teach student to read lower-level and/or familiar texts at an appropriate rate</li>\n','<li>A New School; The Wagon</li>\n',NULL),(61,'14','Oral Fluency','Accuracy',60,'<li>Model and support how to take words apart (onset and rime) to problem-solve unknown words</li>\n<li>Provide spelling activities and word sorts to help student recognize patterns in words</li>\n<li>Support and reinforce self-corrections of miscues</li>\n<li>Teach how to use word chunks and analogies to problem-solve unknown words</li>\n','<li>A New School; The Wagon</li>\n',NULL),(62,'14','Comprehension','Previewing',70,'<li>Model and support previewing a book before reading, during read-aloud and shared reading experinces</li>\n<li>Support creating a story from the illustrations </li>\n','<li>A New School; The Wagon</li>\n',NULL),(63,'14','Comprehension','Retelling:  Sequence of Events',80,'<li>Demonstrate how to create and use story maps to aid retelling. </li>\n<li>Model and support using key language/vocabulary from the text in a retelling. </li>\n<li>Model and teach how to identify important events to include in a retelling.</li>\n<li>Model and teach the elements in a good retelling.</li>\n<li>Support retelling a story in sequence. </li>\n','<li>A New School; The Wagon</li>\n',NULL),(64,'14','Comprehension','Retelling:  Characters and Details',90,'<li>Demonstrate how to create and use story maps to aid retelling</li>\n<li>Encourage student to use characters\' names when retelling a story</li>\n<li>Model and teach how to identify important details to include in a retelling.</li>\n<li>Model and teach the elements in a good retelling</li>\n<li>Model the retelling of familiar stories</li>\n','<li>A New School; The Wagon</li>\n',NULL),(65,'14','Comprehension','Retelling:  Vocabulary',100,'<li>Demonstrate how to create and use story maps to aid retelling</li>\n<li>Model and support using key language/vocabulary from the text in a retelling</li>\n<li>Model and teach how to retell a story.</li>\n<li>Model and teach the elements in a good retelling</li>\n<li>Model the retelling of familiar stories</li>\n','<li>A New School; The Wagon</li>\n',NULL),(66,'14','Comprehension','Retelling: Teacher Support',110,'<li>Demonstrate how to create and use story maps to aid retelling</li>\n<li>Model and support using key language/vocabulary from the text in a retelling</li>\n<li>Model and teach the elements in a good retelling</li>\n<li>Model the retelling of familiar stories</li>\n','<li>A New School; The Wagon</li>\n',''),(67,'14','Comprehension','Reflection',120,'<li>Demonstrate how to support one\'s opinion</li>\n<li>Help student identify favorite part of books</li>\n<li>Provide opportunities to select a favorite book, toy, TV show, etc and tell why it is a favorite</li>\n<li>Support and reinforce student\'s response to books during read-aloud, and shared and guided reading experinces</li>\n','<li>A New School; The Wagon</li>\n',NULL),(68,'14','Comprehension','Making Connections',130,'<li>Model and teach how to make text-to-self conections</li>\n<li>Model and teach how to make text-to-text connections</li>\n','<li>A New School; The Wagon</li>\n',NULL),(82,'18','Reading Engagement','Book Selection',10,'<li>Introduce student to reading materials from a variety of genres</li>\n<li>Model/teach how to read for different purposes</li>\n<li>Teach student how to use a reading log to monitor book selection</li>\n<li>Teach student strategies to select \"just right\" texts for independent reading</li>\n','<li>Game Day; A Giant in the Forest</li>\n',NULL),(83,'18','Reading Engagement','Sustained Reading',20,'<li>Create structures to support reading at home </li>\n<li>Develop clear expectations for amount of independent reading</li>\n<li>Model and support how to read independently</li>\n<li>Teach strategies to build reading stamina</li>\n','<li>Game Day; A Giant in the Forest</li>\n',NULL),(84,'18','Oral Fluency','Expression',30,'<li>Have student practice appropriate expression with familiar texts</li>\n<li>Model and support reading in longer, meaningful phrases with </li>\n<li>Teach student to heed punctuation</li>\n','<li>Game Day; A Giant in the Forest</li>\n',NULL),(85,'18','Oral Fluency','Phrasing',40,'<li>Have student practice appropriate expression with familiar texts</li>\n<li>Model and support reading in longer, meaningful phrases with </li>\n<li>Teach student to heed punctuation</li>\n','<li>Game Day; A Giant in the Forest</li>\n',NULL),(86,'18','Oral Fluency','Rate',50,'<li>Provide material and time for repeated reading to increase reading rate</li>\n<li>Teach student to read lower-level and/or familiar texts at an appropriate rate</li>\n','<li>Game Day; A Giant in the Forest</li>\n',NULL),(87,'18','Oral Fluency','Accuracy',60,'<li>Model and support how to take words apart (onset and rhyme, syllables) to problem-solve unknown words</li>\n<li>Provide spelling activities and word sorts to help student recognize patterns in words</li>\n<li>Support and reinforce self-corrections of miscues</li>\n<li>Teach how to use word chunks and analogies to problem-solve unknown words</li>\n','<li>Game Day; A Giant in the Forest</li>\n',NULL),(88,'18','Comprehension','Prediction',70,'<li>Model and support how to use background knowledge to make meaningful predictions </li>\n<li>Teach student how to make predictions based on title and book cover, as well as opening paragraphs and illustrations of texts read aloud</li>\n','<li>Game Day; A Giant in the Forest</li>\n',NULL),(89,'18','Comprehension','Retelling:  Sequence of Events',80,'<li>Support retelling a story in sequence</li>\n','<li>Game Day; A Giant in the Forest</li>\n',NULL),(90,'18','Comprehension','Retelling:  Characters and Details',90,'<li>Model and teach how to identify important details to include in a retelling </li>\n','<li>Game Day; A Giant in the Forest</li>\n',NULL),(91,'18','Comprehension','Retelling:  Vocabulary',100,'<li>Model and support using key language and vocabulary from the text in a retelling </li>\n','<li>Game Day; A Giant in the Forest</li>\n',NULL),(92,'18','Comprehension','Retelling:  Teacher Support',110,'<li>Model and teach how to create and use story maps to aid retelling </li>\n<li>Model and teach how to identify important events to include in a retelling</li>\n<li>Model and teach how to retell a story</li>\n','<li>Game Day; A Giant in the Forest</li>\n',NULL),(93,'18','Comprehension','Interpretation',120,'<li>Model and teach how to support inferences with information or examples from the text</li>\n<li>Model and teach student how to think about Why?  questions while and after reading a text</li>\n<li>Model how to infer during shared reading and read-alouds</li>\n<li>Teach and share examples of inferences</li>\n','<li>Game Day; A Giant in the Forest</li>\n',NULL),(94,'18','Comprehension','Reflection',130,'<li>Demonstrate and teach student how to support opinion with details from the text </li>\n<li>Help student identify important information and/or message in a story</li>\n<li>Provide opportunities to identify and discuss the important event in a story</li>\n','<li>Game Day; A Giant in the Forest</li>\n',NULL),(107,'30','Reading Engagement','Wide Reading',10,'<li>Create structures and/or routines to support reading at home</li>\n<li>Develop clear expectations for amount of independent reading</li>\n<li>Introduce student to reading materials from a variety of genres</li>\n<li>Model/teach how to read for different purposes</li>\n<li>Teach strategies to build reading stamina</li>\n<li>Teach student how to use a reading log to monitor book selection and set reading goals</li>\n<li>Teach student strategies to select appropriately levelled texts for independent reading</li>\n','<li>Busy Helpers; Tiger\'s Whirlwind Day</li>\n',NULL),(108,'30','Reading Engagement','Self-Assessment/Goal Setting',20,'<li>Help student identify 1-2 reading goals and a plan of action to improve reading</li>\n<li>Model and discuss strategies good readers use</li>\n<li>Support revision of ongoing reading goals</li>\n','<li>Busy Helpers; Tiger\'s Whirlwind Day</li>\n',NULL),(109,'30','Oral Fluency','Expression',30,'<li>Have student practice appropriate expression with familiar texts</li>\n<li>Model and support reading longer, meaningful phrases with appropriate expression </li>\n','<li>Busy Helpers; Tiger\'s Whirlwind Day</li>\n',NULL),(110,'30','Oral Fluency','Phrasing',40,'<li>Teach student to heed punctuation </li>\n','<li>Busy Helpers; Tiger\'s Whirlwind Day</li>\n',NULL),(111,'30','Oral Fluency','Rate',50,'<li>Provide materials and time for repeated reading to increase reading rate</li>\n<li>Teach student to read lower-level and/or familiar texts at an appropriate rate</li>\n','<li>Busy Helpers; Tiger\'s Whirlwind Day</li>\n',NULL),(112,'30','Oral Fluency','Accuracy',60,'<li>Model and support how to take words apart (e.g. onset and rhyme, syllables) to problem-solve unknown words</li>\n<li>Provide spelling activities and word sorts to help student recognize patterns in words</li>\n<li>Support and reinforce self-corrections of miscues </li>\n<li>Teach how to use word chunks and analogies to problem-solve unknown words</li>\n','<li>Busy Helpers; Tiger\'s Whirlwind Day</li>\n',NULL),(113,'30','Comprehension','Use of Text Features',70,'<li>Provide opportunities for student to discuss what he or she knows about the characters based on title and book cover, as well as opening paragraphs and texts read aloud</li>\n<li>Teach student how to describe characters using information from fiction text features (e.g. title, illustrations, and text)</li>\n','<li>Busy Helpers; Tiger\'s Whirlwind Day</li>\n',NULL),(114,'30','Comprehension','Prediction',80,'<li>Model and support using background information to make meaningful predictions</li>\n<li>Teach student how to make predictions based on title and book cover, as well as opening paragraphs of texts read aloud</li>\n','<li>Busy Helpers; Tiger\'s Whirlwind Day</li>\n',NULL),(115,'30','Comprehension','Scaffolded Summary',90,'<li>Model and co-construct written summaries of texts read aloud</li>\n<li>Model and support how to distinguish between more important and less important ideas and details</li>\n<li>Share and identify characteristics of good summaries </li>\n<li>Teach student how to identify story elements (e.g. characters, setting, plot)</li>\n<li>Teach student how to use a graphic organizer as an aid to creating a summary</li>\n','<li>Busy Helpers; Tiger\'s Whirlwind Day</li>\n',NULL),(116,'30','Comprehension','Scaffolded Summary: Vocabulary',100,NULL,NULL,NULL),(117,'30','Comprehension','Literal Comprehension',110,'<li>Help student locate and record specific details</li>\n<li>Provide opportunities for student to answer and construct literal questions </li>\n<li>Show student how to use key words to identify specific information from the text</li>\n<li>Teach student how to use graphic organizers to keep track of story information </li>\n','<li>Busy Helpers; Tiger\'s Whirlwind Day</li>\n',NULL),(118,'30','Comprehension','Interpretation',120,'<li>Give student opportunities to respond to inference questions orally and in writing </li>\n<li>Model and teach how to support inferences with examples from the text</li>\n<li>Model and teach student how to think about Why? questions while and after reading a text</li>\n<li>Teach and share examples of inferences</li>\n','<li>Busy Helpers; Tiger\'s Whirlwind Day</li>\n',NULL),(119,'30','Comprehension','Reflection',130,'<li>Demonstrate and teach student how to support opinion with details from the text</li>\n<li>Help student identify important message in a story </li>\n<li>Provide opportunities to identify and discuss the most important event in a story</li>\n','<li>Busy Helpers; Tiger\'s Whirlwind Day</li>\n',NULL),(548,'38B','Oral Fluency','Phrasing',33,'','',''),(549,'20B','Oral Fluency','Phrasing',35,NULL,NULL,NULL),(550,'24B','Oral Fluency','Phrasing',35,NULL,NULL,NULL),(551,'28B','Oral Fluency','Phrasing',35,NULL,NULL,NULL),(552,'20B','Oral Fluency','Phrasing',35,NULL,NULL,NULL),(553,'90','Reading Engagement','Wide Reading',10,NULL,NULL,NULL),(554,'90','Reading Engagement','Self-Assessment/Goal Setting',20,NULL,NULL,NULL),(555,'90','Oral Fluency','Expression',30,NULL,NULL,NULL),(556,'90','Oral Fluency','Phrasing',40,NULL,NULL,NULL),(557,'90','Oral Fluency','Rate',50,NULL,NULL,NULL),(558,'90','Oral Fluency','Accuracy',60,NULL,NULL,NULL),(559,'90','Comprehension','Questioning Prediction',70,NULL,NULL,NULL),(560,'90','Comprehension','Summary',80,NULL,NULL,NULL),(561,'90','Comprehension','Literal Comprehension',90,NULL,NULL,NULL),(562,'90','Comprehension','Interpretation',100,NULL,NULL,NULL),(563,'90','Comprehension','Reflection',110,NULL,NULL,NULL),(564,'90','Comprehension','Metacognitive Awareness',120,NULL,NULL,NULL),(132,'40','Reading Engagement','Wide Reading',10,'<li>Create structures and/or routines to support reading at home</li>\n<li>Develop and monitor clear expectations for amount of independent reading</li>\n<li>Introduce student to reading materials from a variety of genres</li>\n<li>Teach strategies to build reading stamina</li>\n<li>Teach student how to use a reading log to monitor book selection and set reading goals</li>\n<li>Teach student strategies to select appropriately levelled texts for independent reading</li>\n','<li>All the Way Under; The Amazing Octopus; A Journey to Freedom; A Pack of Wolves</li>\n',NULL),(133,'40','Reading Engagement','Self-Assessment/Goal Setting',20,'<li>Help student identify 1-2 reading goals and a plan of action to improve reading</li>\n<li>Model and discuss strategies good readers use</li>\n<li>Support revision of ongoing reading goals</li>\n','<li>All the Way Under; The Amazing Octopus; A Journey to Freedom; A Pack of Wolves</li>\n',NULL),(134,'40','Oral Fluency','Expression',30,'<li>Have student practice appropriate expression with familiar texts</li>\n<li>Model and teach reading longer, meaningful phrases with appropriate expression </li>\n<li>Teach student to heed punctuation </li>\n','<li>All the Way Under; The Amazing Octopus; A Journey to Freedom; A Pack of Wolves</li>\n',NULL),(135,'40','Oral Fluency','Phrasing',40,'<li>Have student practice appropriate expression with familiar texts</li>\n<li>Model and teach reading longer, meaningful phrases with appropriate expression </li>\n<li>Teach student to heed punctuation </li>\n','<li>All the Way Under; The Amazing Octopus; A Journey to Freedom; A Pack of Wolves</li>\n',NULL),(136,'40','Oral Fluency','Rate',50,'<li>Give opportunities for student  to read lower-level and/or familiar texts at an appropriate rate</li>\n<li>Provide materials and time for repeated reading and timed readings to increase reading rate</li>\n','<li>All the Way Under; The Amazing Octopus; A Journey to Freedom; A Pack of Wolves</li>\n',NULL),(137,'40','Oral Fluency','Accuracy',60,'<li>Model and support how to take words apart (e.g. onset and rhyme, syllables) to problem-solve unknown words</li>\n<li>Provide spelling activities and word sorts to help student recognize patterns in words</li>\n<li>Support and reinforce self-corrections of miscues </li>\n<li>Teach how to use word chunks and analogies to problem-solve unknown words</li>\n','<li>All the Way Under; The Amazing Octopus; A Journey to Freedom; A Pack of Wolves</li>\n',NULL),(138,'40','Comprehension','Questioning/Prediction',70,'<li>Model and support using background information to make meaningful predictions</li>\n<li>Model and support using knowledge of text structures/genre characteristics to make predictions</li>\n<li>Provide opportunities for student to discuss what he or she knows about the characters and setting based on title and book cover, as well as opening paragraphs and illustrations of texts read aloud</li>\n<li>Teach student how to make and confirm predictions prior to and during reading </li>\n','<li>All the Way Under; The Amazing Octopus; A Journey to Freedom; A Pack of Wolves</li>\n',NULL),(139,'40','Comprehension','Summary',80,'<li>Model and co-construct written summaries of texts read aloud </li>\n<li>Model and support how to distinguish between more important and less important ideas and facts</li>\n<li>Provide time for student how to practice oral and written summaries</li>\n<li>Share and identify characteristics of good summaries</li>\n<li>Teach student how to identify story elements (e.g. characters, setting, plot)</li>\n<li>Teach student how to use graphic organizer as an aid to creating a summary</li>\n','<li>All the Way Under; The Amazing Octopus; A Journey to Freedom; A Pack of Wolves</li>\n',NULL),(140,'40','Comprehension','Literal Comprehension',90,'<li>Help student locate and record specific details </li>\n<li>Provide opportunities for student to answer and construct literal questions</li>\n<li>Show student how to use key words to identify specific information from the text</li>\n<li>Teach student how to use graphic organizers to keep track of key ideas and facts</li>\n','<li>All the Way Under; The Amazing Octopus; A Journey to Freedom; A Pack of Wolves</li>\n',NULL),(141,'40','Comprehension','Interpretation',100,'<li>Give student opportunities to respond to and construct inference questions orally and in writing </li>\n<li>Model and support how to identify important text implications</li>\n<li>Provide opportunities for student to support inferences with information or examples from the text</li>\n<li>Teach and share examples of inferences</li>\n','<li>All the Way Under; The Amazing Octopus; A Journey to Freedom; A Pack of Wolves</li>\n',NULL),(142,'40','Comprehension','Reflection',110,'<li>Demonstrate and teach how to support opinion with details from the text</li>\n<li>Help student identify important information and/or  key vocabulary in a variety of texts</li>\n<li>Provide opportunities to discuss theme/most important idea of stories read aloud</li>\n<li>Provide opportunities to identify and discuss a significant message or event in a story </li>\n','<li>All the Way Under; The Amazing Octopus; A Journey to Freedom; A Pack of Wolves</li>\n',NULL),(143,'40','Comprehension','Metacognitive Awareness',120,'<li>Help student identify examples in a text where he  or she used a specific strategy</li>\n<li>Model and teach comprehension strategies for fiction texts</li>\n<li>Provide opportunities for student to practice using a specific comprehension strategy (e.g. making connections, visualizing, responding emotionally)</li>\n','<li>All the Way Under; The Amazing Octopus; A Journey to Freedom; A Pack of Wolves</li>\n',NULL),(144,'34','Reading Engagement','Wide Reading',10,'<li>Model/teach how to read for different purposes</li>\n<li>Teach student how to use a reading log to monitor book selection and set reading goals</li>\n','<li>The Mystery at the Mays\' House; Summer Discovery</li>\n',NULL),(145,'34','Reading Engagement','Self-Assessment/Goal Setting',20,'<li>Help student identity 1-2 reading goals and a plan of action to improve reading</li>\n<li>Model and discuss strategies good readers use</li>\n<li>Support revision of ongoing reading goals</li>\n','<li>The Mystery at the Mays\' House; Summer Discovery</li>\n',NULL),(146,'34','Oral Fluency','Expression',30,'<li>Have student participate in choral reading and/or reader\'s theater</li>\n<li>Have student practice appropriate expression with familiar texts</li>\n<li>Model and support reading in longer, meaningful phrases with appropriate expression</li>\n<li>Teach student to heed punctuation</li>\n','<li>The Mystery at the Mays\' House; Summer Discovery</li>\n',NULL),(147,'34','Oral Fluency','Phrasing',40,'<li>Have student participate in choral reading and/or reader\'s theater</li>\n<li>Model and support reading in longer, meaningful phrases with appropriate expression</li>\n<li>Teach student to heed punctuation</li>\n','<li>The Mystery at the Mays\' House; Summer Discovery</li>\n',NULL),(148,'34','Oral Fluency','Rate',50,'<li>Provide materials and time for repeated reading to increase reading rate</li>\n<li>Teach student to read lower-level and/or familiar texts at an appropriate rate</li>\n','<li>The Mystery at the Mays\' House; Summer Discovery</li>\n',NULL),(149,'34','Oral Fluency','Accuracy',60,'<li>Model and support how to take words apart (e.g. Onset and rime, syllables) to problem-solve unknown words</li>\n<li>Provide spelling activities and word sorts to help student recognize patterns in words</li>\n<li>Support and reinforce self-corrections of miscues</li>\n<li>Teach how to use word chunks and analogies to problem-solve unknown words</li>\n','<li>The Mystery at the Mays\' House; Summer Discovery</li>\n',NULL),(150,'34','Comprehension','Use of Text Features',70,'<li>Provide opportunities for student to discuss what he or she knows about the characters based on title and book cover, as well as opening paragraphs and texts read aloud</li>\n<li>Teach student how to describe characters using information from fiction text features (e.g. title, illustrations, and text)</li>\n','<li>The Mystery at the Mays\' House; Summer Discovery</li>\n',NULL),(151,'34','Comprehension','Prediction',80,'<li>Model and supoort how touse background information to make meaningful predictions</li>\n<li>Teach student how to use make predictions based on title and book cover, as well as opening paragraphs of texts read aloud.</li>\n','<li>The Mystery at the Mays\' House; Summer Discovery</li>\n',NULL),(152,'34','Comprehension','Scaffolded Summary',90,'<li>Model and support how to distinguish between more important and less important ideas and details</li>\n<li>Share and identify characterics of good summaries </li>\n<li>Teach student how to identify story elements (e.g. characters, setting, plot)</li>\n<li>Teach student how to use a graphic organizer as an aid to creating a summary</li>\n','<li>The Mystery at the Mays\' House; Summer Discovery</li>\n',NULL),(153,'34','Comprehension','Scaffolded Summary: Vocabulary',100,NULL,NULL,NULL),(154,'34','Comprehension','Literal Comprehension',110,'<li>Help student locate and record specific details</li>\n<li>Provide opportunties for student to answer and construct literal questions</li>\n<li>Show student how to use key words to identify specific information from the text</li>\n<li>Teach student how to use graphic organizers to keep track of story information </li>\n','<li>The Mystery at the Mays\' House; Summer Discovery</li>\n',NULL),(155,'34','Comprehension','Interpretation',120,'<li>Give student opportunities to respond to inference questions orally and in writing </li>\n<li>Model and teach how to support inferences with examples from the text</li>\n<li>Model and teach student how to think about Why? questions while and after reading a text</li>\n<li>Teach and share examples of inferences</li>\n','<li>The Mystery at the Mays\' House; Summer Discovery</li>\n',NULL),(156,'34','Comprehension','Reflection',130,'<li>Demosntrate and teach student how to support opinion with details from the text</li>\n<li>Help student identify important message in a story </li>\n<li>Provide opportunities to identify and discuss the most important event in a story</li>\n','<li>The Mystery at the Mays\' House; Summer Discovery</li>\n',NULL),(157,'20','Reading Engagement','Book Selection',10,'<li>Introduce student to reading materials from a variety of genres</li>\n<li>Model/teach how to read for different purposes</li>\n<li>Teach student how to use a reading log to monitor book selection</li>\n<li>Teach student strategies to select \"just right\" texts for independent reading</li>\n','<li>Green Freddie; Turtle\'s Big Race</li>\n',NULL),(158,'20','Reading Engagement','Sustained Reading',20,'<li>Have student participate in choral reading and/or reader\'s theater</li>\n<li>Have student practice appropriate expression with familiar texts</li>\n<li>Model and support how to read independently</li>\n<li>Teach strategies to build reading stamina</li>\n<li>Teach student to heed punctuation</li>\n','<li>Green Freddie; Turtle\'s Big Race</li>\n',NULL),(159,'20','Oral Fluency','Expression',30,'<li>Have students participate in choral reading and / or reader\'s theatre.</li>\n<li>Have students practice appropriate expression with familiar texts.</li>\n<li>Model and support reading in longer, meaningful phrases with appropriate expression</li>\n<li>Teach student to heed punctuation.</li>\n','<li>Green Freddie; Turtle\'s Big Race</li>\n',NULL),(160,'20','Oral Fluency','Phrasing',40,'<li>Have students participate in choral reading and / or reader\'s theatre.</li>\n<li>Have students practice appropriate expression with familiar texts.</li>\n<li>Model and support reading in longer, meaningful phrases with appropriate expression</li>\n<li>Teach student to heed punctuation.</li>\n','<li>Green Freddie; Turtle\'s Big Race</li>\n',NULL),(161,'20','Oral Fluency','Rate',50,'<li>Provide materials and time for repeated reading to increase reading rate</li>\n<li>Teach student to read lower-level and/or familiar texts at an appropriate rate</li>\n','<li>Green Freddie; Turtle\'s Big Race</li>\n',NULL),(162,'20','Oral Fluency','Accuracy',60,'<li>Model and support how to take words apart (e.g. Onset and rime, syllables) to problem-solve unknown words</li>\n<li>Provide spelling activities and word sorts to help student recognize patterns in words</li>\n<li>Support and reinforce self-corrections of miscues</li>\n<li>Teach how to use word chunks and analogies to problem-solve unknown words</li>\n','<li>Green Freddie; Turtle\'s Big Race</li>\n',NULL),(163,'20','Comprehension','Prediction',70,'<li>Model and support how to use background knowledge to make meaningful predictions </li>\n<li>Teach student how to make predictions based on title and book cover, as well as opening paragraphs and illustrations of texts read aloud</li>\n','<li>Green Freddie; Turtle\'s Big Race</li>\n',NULL),(164,'20','Comprehension','Retelling:  Sequence of Events',80,'<li>Support retelling a story in sequence</li>\n','<li>Green Freddie; Turtle\'s Big Race</li>\n',NULL),(165,'20','Comprehension','Retelling:  Characters and Details',90,'<li>Encourage student ot use characters\' names when retelling a story</li>\n<li>Model and teach how to identify important details to include in a retelling</li>\n','<li>Green Freddie; Turtle\'s Big Race</li>\n',NULL),(166,'20','Comprehension','Retelling:  Vocabulary',100,'<li>Model and support using key language and vocabulary from the text in a retelling </li>\n','<li>Green Freddie; Turtle\'s Big Race</li>\n',NULL),(167,'20','Comprehension','Retelling:  Teacher Support',110,'<li>Model and teach how to create and use story maps to aid retelling</li>\n<li>Model and teach how to identify important events to include in a retelling</li>\n<li>Model and teach how to retell </li>\n','<li>Green Freddie; Turtle\'s Big Race</li>\n',NULL),(168,'20','Comprehension','Interpretation',120,'<li>Model and teach how to support inferences with information or examples from the text</li>\n<li>Model and teach student how to think about Why?  questions while and after reading a text</li>\n<li>Model how to infer during shared reading and read-alouds</li>\n<li>Teach and share examples of inferences</li>\n','<li>Green Freddie; Turtle\'s Big Race</li>\n',NULL),(169,'20','Comprehension','Reflection',130,'<li>Demonstrate and teach student how to support opinion with details from the text </li>\n<li>Help student identify important information message in a story</li>\n<li>Provide opportunities to identify and discuss the important event in a story</li>\n','<li>Green Freddie; Turtle\'s Big Race</li>\n',NULL),(170,'24','Reading Engagement','Book Selection',10,'<li>Introduce student to reading materials from a variety of genres</li>\n<li>Model/teach how to read for different purposes</li>\n<li>Teach student how to use a reading log to monitor book selection</li>\n<li>Teach student strategies to select \"just right\" texts for independent reading</li>\n','<li>Thin as a Stick; The Wonderful Day</li>\n',NULL),(171,'24','Reading Engagement','Sustained Reading',20,'<li>Create structures to support reading at home</li>\n<li>Develop clear expectations for amount of independent reading</li>\n<li>Model and suport how to read independently</li>\n<li>Teach strategies to build reading stamina</li>\n','<li>Thin as a Stick; The Wonderful Day</li>\n',NULL),(172,'24','Oral Fluency','Expression',30,'<li>Have student participate in choral reading and/or reader\'s theater</li>\n<li>Have student practice appropriate expression with familiar texts</li>\n<li>Model and support reading in longer, meaningful phrases with appropriate expression</li>\n<li>Teach student to heed punctuation</li>\n','<li>Thin as a Stick; The Wonderful Day</li>\n',NULL),(173,'24','Oral Fluency','Phrasing',40,'<li>Have student participate in choral reading and/or reader\'s theater</li>\n<li>Have student practice appropriate expression with familiar texts</li>\n<li>Model and support reading in longer, meaningful phrases with appropriate expression</li>\n<li>Teach student to heed punctuation</li>\n','<li>Thin as a Stick; The Wonderful Day</li>\n',NULL),(174,'24','Oral Fluency','Rate',50,'<li>Provide materials and time for repeated reading to increase reading rate</li>\n<li>Teach stduent to read lower-level and/or familiar texts at an appropriate rate</li>\n','<li>Thin as a Stick; The Wonderful Day</li>\n',NULL),(175,'24','Oral Fluency','Accuracy',60,'<li>Model and support how to take words apart (e.g. Onset and rime, syllables) to problem-solve unknown words</li>\n<li>Provide spelling activities and word sorts to help student recognize patterns in words</li>\n<li>Support and reinforce self-corrections of miscues</li>\n<li>Teach how to use word chunks and analogies to problem-solve unknown words</li>\n','<li>Thin as a Stick; The Wonderful Day</li>\n',NULL),(176,'24','Comprehension','Prediction',70,'<li>Model and supoort how touse background knowledge to make meaningful predictions</li>\n<li>Teach student how to make predictions based on title and book cover, as well as opening paragraphs and illustrations of texts read aloud</li>\n','<li>Thin as a Stick; The Wonderful Day</li>\n',NULL),(177,'24','Comprehension','Retelling:  Sequence of Events',80,'<li>Model and teach how to identify important events to include in a retelling</li>\n<li>Support retelling a story in sequence</li>\n','<li>Thin as a Stick; The Wonderful Day</li>\n',NULL),(178,'24','Comprehension','Retelling:  Characters and Details',90,'<li>Encourage student to use characters\' names when retelling a story</li>\n<li>Model and teach how to identify important details to include in a retelling</li>\n','<li>Thin as a Stick; The Wonderful Day</li>\n',NULL),(179,'24','Comprehension','Retelling:  Vocabulary',100,'<li>Model and support using key language and vocabulary from the text in a retelling </li>\n','<li>Thin as a Stick; The Wonderful Day</li>\n',NULL),(180,'24','Comprehension','Retelling:  Teacher Support',110,'<li>Model and teach how to create and use story maps to aid retelling</li>\n<li>Model and teach how to retell a story</li>\n','<li>Thin as a Stick; The Wonderful Day</li>\n',NULL),(181,'24','Comprehension','Interpretation',120,'<li>Model and teach how to support inferences with information or examples from the text</li>\n<li>Model and teach student how to think about Why?  questions while and after reading a text</li>\n<li>Model how to infer during shared reading and read-alouds</li>\n<li>Teach and share examples of inferences</li>\n','<li>Thin as a Stick; The Wonderful Day</li>\n',NULL),(182,'24','Comprehension','Reflection',130,'<li>Demonstrate and teach student how to support opinion with details from the text </li>\n<li>Help student identify important message in a story </li>\n<li>Provide opportunities to identify and discuss the important event in a story</li>\n','<li>Thin as a Stick; The Wonderful Day</li>\n',NULL),(183,'6','Reading Engagement','Book Selection',10,'<li>Model and discuss why readers have favorite books and authors</li>\n<li>Model and support how to select \"just right\" new texts for independent reading</li>\n<li>Provided guided opportunities to select familiar stories for rereading</li>\n','<li>Time to Play; Why Are We Stopping?</li>\n',NULL),(184,'6','Reading Engagement','Sustained Reading',20,'<li>Create structures and routines to support buddy reading</li>\n<li>Create structures and routines to support reading at home</li>\n<li>Model and support the use of sustained reading time</li>\n','<li>Time to Play; Why Are We Stopping?</li>\n',NULL),(185,'6','Oral Fluency','Phrasing',30,'<li>Encourage student to read in phrases during shared reading</li>\n<li>Show how words are grouped into phrases in big books and poetry charts</li>\n<li>Support rereading familar texts to build fluency</li>\n','<li>Time to Play; Why Are We Stopping?</li>\n',NULL),(186,'6','Oral Fluency','Monitoring/Self-Correction',40,'<li>Demonstrate and teach how to read for meaning, self-correcting when a word doesn\'t make sense or sound right</li>\n<li>Model and support confirming and discounting word choice using meaning, language, and visual information</li>\n<li>Model and teach how to monitor visual information, self-correcting when a word doesn\'t look right</li>\n<li>Model and teach how to use known words as a means to self-monitor</li>\n<li>Support one-to-one matching as a means to self-monitor</li>\n','<li>Time to Play; Why Are We Stopping?</li>\n',NULL),(187,'6','Oral Fluency','Problem-Solving Unknown Words',50,'<li>Model and support using beginning letter(s)/sounds(s), sentence and/or story structure, as well as meaning (illustrations and background knowledge) to problem-solve unknown words</li>\n<li>Teach how to take words apart (onset and rime) to problem-solve unknown words</li>\n','<li>Time to Play; Why Are We Stopping?</li>\n',NULL),(188,'6','Oral Fluency','Accuracy',60,NULL,NULL,NULL),(189,'6','Comprehension','Previewing',70,'<li>Model and support previewing a book before reading, during read-aloud and shared reading experinces</li>\n<li>Support creating a story from the illustrations </li>\n','<li>Time to Play; Why Are We Stopping?</li>\n',NULL),(190,'6','Comprehension','Retelling:  Sequence of Events',80,'<li> Demonstrate how to create and use story maps to aid retelling. </li>\n<li> Model the retelling of familiar stories.</li>\n<li>Support retelling a story in sequence. </li>\n<li>Teach the elements in a good retelling.</li>\n','<li>Time to Play; Why Are We Stopping?</li>\n',NULL),(191,'6','Comprehension','Retelling:  Characters and Details',90,'<li> Demonstrate how to create and use story maps to aid retelling. </li>\n<li> Model the retelling of familiar stories.</li>\n<li>Encourage student to use characters\' names when retelling a story.</li>\n<li>Teach the elements in a good retelling.</li>\n','<li>Time to Play; Why Are We Stopping?</li>\n',NULL),(192,'6','Comprehension','Retelling:  Vocabulary',100,'<li>Model the retelling of familiar stories. </li>\n<li>Support using key language/vocabulary from the text in a retelling. </li>\n<li>Teach the elements in a good retelling. Model the retelling of familiar stories. </li>\n','<li>Time to Play; Why Are We Stopping?</li>\n',NULL),(193,'6','Comprehension','Retelling:  Teacher Support',110,'<li> Demonstrate how to create and use story maps to aid retelling. </li>\n<li> Model the retelling of familiar stories.</li>\n<li>Teach the elements in a good retelling.</li>\n','<li>Time to Play; Why Are We Stopping?</li>\n',NULL),(194,'6','Comprehension','Reflection',120,'<li>Demonstrate how to give reason(s) for one\'s opinion.</li>\n<li>Help students identify favourite parts of books</li>\n<li>Provide opportunities to select a favorite book, toy, TV show, etc and tell why it is a favorite</li>\n<li>Support and reinforce student\'s response to books during read-aloud, and shared and guided reading experinces</li>\n','<li>Time to Play; Why Are We Stopping?</li>\n',NULL),(195,'6','Comprehension','Making Connections',130,'<li>Model and support how to make text-to-text connections</li>\n<li>Model and teach how to make text-to-self conections</li>\n','<li>Time to Play; Why Are We Stopping?</li>\n',NULL),(196,'8','Reading Engagement','Book Selection',10,'<li>Model and discuss why readers have favorite books and authors</li>\n<li>Model and support how to select \"just right\" new texts for independent reading</li>\n<li>Provide guided opportunities to select familiar stories for rereading</li>\n','<li>Duke; The Lost Book</li>\n',NULL),(197,'8','Reading Engagement','Sustained Reading',20,'<li>Create structures and routines to support buddy reading</li>\n<li>Create structures and routines to support reading at home</li>\n<li>Model and support to use of sustained reading time</li>\n','<li>Duke; The Lost Book</li>\n',NULL),(198,'8','Oral Fluency','Phrasing',30,'<li>Encourage student to read in phrases during shared reading</li>\n<li>Show how words are grouped into phrases in big books and poetry charts</li>\n<li>Support rereading familar texts to build fluency</li>\n','<li>Duke; The Lost Book</li>\n',NULL),(199,'8','Oral Fluency','Monitoring/Self-Corrections',40,'<li> Model and support confirming and discounting word choice using meaning, language, and visual information</li>\n<li> Model and teach how to monitor visual information, self-correcting when a word doesn\'t look right.</li>\n<li> Model and teach how to use known words as a means to self-monitor.</li>\n<li>Demonstrate and teach how to read for meaning, self-correcting when a word doesn\'t make sense or sound right.</li>\n<li>Support one-to-one matching as a means to self-monitor.</li>\n','<li>Duke; The Lost Book</li>\n',NULL),(200,'8','Oral Fluency','Problem-Solving Unknown Words',50,'<li>Model and support how to take words apart (onset and rime) to problem-solve unknown words</li>\n<li>Model and support using beginning letter(s)/sounds(s), sentence and/or story structure, as well as meaning (illustrations and background knowledge) to problem-solve unknown words</li>\n','<li>Duke; The Lost Book</li>\n',NULL),(201,'8','Oral Fluency','Accuracy',60,NULL,NULL,NULL),(202,'8','Comprehension','Previewing',70,'<li>Model and support previewing a book before reading, during read-aloud and shared reading experinces</li>\n<li>Support creating a story from the illustrations </li>\n','<li>Duke; The Lost Book</li>\n',NULL),(203,'8','Comprehension','Retelling:  Sequence of Events',80,'<li>Demonstrate how to create and use story maps to aid retelling.</li>\n<li>Model and teach the elements in a good retelling. </li>\n<li>Model the retelling of familar stories. </li>\n<li>Support retelling a story in sequence. </li>\n','<li>Duke; The Lost Book</li>\n',NULL),(204,'8','Comprehension','Retelling:  Characters and Details',90,'<li>Demonstrate how to create and use story maps to aid retelling.</li>\n<li>Encourage student to use characters\' names when retelling a story.</li>\n<li>Model and teach the elements in a good retelling. </li>\n<li>Model the retelling of familar stories. </li>\n','<li>Duke; The Lost Book</li>\n',NULL),(205,'8','Comprehension','Retelling:  Vocabulary',100,'<li>Demonstrate how to create and use story maps to aid retelling.</li>\n<li>Model and support using key language/vocabulary from the text in a retelling.</li>\n<li>Model and teach the elements in a good retelling. </li>\n<li>Model the retelling of familiar stories. </li>\n','<li>Duke; The Lost Book</li>\n',NULL),(206,'8','Comprehension','Retelling:  Teacher Support',110,'<li>Demonstrate how to create and use story maps to aid retelling.</li>\n<li>Model and teach the elements in a good retelling. </li>\n<li>Model the retelling of familar stories. </li>\n','<li>Duke; The Lost Book</li>\n',NULL),(207,'8','Comprehension','Reflection',120,'<li>Demonstrate how to give reason(s) for one\'s opinion</li>\n<li>Help student identify favorite part of books</li>\n<li>Provide opportunities to select a favorite book, toy, TV show, etc and tell why it is a favorite</li>\n<li>Support and reinforce student\'s response to books during read-aloud, and shared and guided reading experinces</li>\n','<li>Duke; The Lost Book</li>\n',NULL),(208,'8','Comprehension','Making Connections',130,'<li>Model and support how to make text-to-text connections</li>\n<li>Model and teach how to make text-to-self conections</li>\n','<li>Duke; The Lost Book</li>\n',NULL),(209,'10','Reading Engagement','Book Selection',10,'<li>Model and discuss why readers have favorite books and authors</li>\n<li>Model and support how to select \"just right\" new texts for independent reading</li>\n<li>Provide guided opportunities to select familiar stories for rereading</li>\n','<li>Grandma\'s Surprise; Shoe Boxes</li>\n',NULL),(210,'10','Reading Engagement','Sustained Reading',20,'<li>Create structures and routines to support buddy reading</li>\n<li>Create structures and routines to support reading at home</li>\n<li>Model and support the use of sustained reading time</li>\n','<li>Grandma\'s Surprise; Shoe Boxes</li>\n',NULL),(211,'10','Oral Fluency','Phrasing',30,'<li>Encourage student to read in phrases during shared reading</li>\n<li>Show how words are grouped into phrases in big books and poetry charts</li>\n<li>Support rereading familar texts to build fluency</li>\n','<li>Grandma\'s Surprise; Shoe Boxes</li>\n',NULL),(212,'10','Oral Fluency','Monitoring/Self-Corrections',40,'<li>Demonstrate and teach how to read for meaning, self-correcting when a word doesn\'t make sense or sound right</li>\n<li>Model and support confirming and discounting word choice using meaning, language, and visual information</li>\n<li>Model and teach how to monitor visual information, self-correcting when a word doesn\'t look right</li>\n<li>Model and teach how to use known words as a means to self-monitor</li>\n<li>Support one-to-one matching as a means to self-monitor</li>\n','<li>Grandma\'s Surprise; Shoe Boxes</li>\n',NULL),(213,'10','Oral Fluency','Problem-Solving Unknown Words',50,'<li>Model and support how to take words apart (onset and rime) to problem-solve unknown words</li>\n<li>Model and support using beginning letter(s)/sounds(s), sentence and/or story structure, as well as meaning (illustrations and background knowledge) to problem-solve unknown words</li>\n','<li>Grandma\'s Surprise; Shoe Boxes</li>\n',NULL),(214,'10','Oral Fluency','Accuracy',60,NULL,NULL,NULL),(215,'10','Comprehension','Previewing',70,'<li>Model and support previewing a book before reading, during read-aloud and shared reading experiences</li>\n<li>Support creating a story from the illustrations </li>\n','<li>Grandma\'s Surprise; Shoe Boxes</li>\n',NULL),(216,'10','Comprehension','Retelling:  Sequence of Events',80,'<li>Demonstrate and teach how to create and use story maps to aid retelling</li>\n<li>Model and teach the elements in a good retelling.</li>\n<li>Model the retelling of familar stories. </li>\n<li>Support retelling a story in sequence </li>\n','<li>Grandma\'s Surprise; Shoe Boxes</li>\n',NULL),(217,'10','Comprehension','Retelling:  Characters and Details',90,'<li>Demonstrate and teach how to create and use story maps to aid retelling</li>\n<li>Encourage student to use characters\' names when retelling a story</li>\n<li>Model and teach the elements in a good retelling</li>\n<li>Model the retelling of familar stories. </li>\n','<li>Grandma\'s Surprise; Shoe Boxes</li>\n',NULL),(218,'10','Comprehension','Retelling: Vocabulary',100,'<li>Demonstrate and teach how to create and use story maps to aid retelling</li>\n<li>Model and support using key language/vocabulary from the text in a retelling.</li>\n<li>Model and teach the elements in a good retelling</li>\n<li>Model the retelling of familar stories. </li>\n','<li>Grandma\'s Surprise; Shoe Boxes</li>\n',NULL),(219,'10','Comprehension','Retelling:  Teacher Support',110,'<li>Demonstrate and teach how to create and use story maps to aid retelling</li>\n<li>Model and teach the elements in a good retelling</li>\n<li>Model the retelling of familar stories. </li>\n','<li>Grandma\'s Surprise; Shoe Boxes</li>\n',NULL),(220,'10','Comprehension','Reflection',120,'<li>Demonstrate how to give reason(s) for one\'s opinion</li>\n<li>Help student identify favorite part of books</li>\n<li>Provide opportunities to select a favorite book, toy, TV show, etc and tell why it is a favorite</li>\n<li>Support and reinforce student\'s response to books during read-aloud, and shared and guided reading experiences</li>\n','<li>Grandma\'s Surprise; Shoe Boxes</li>\n',NULL),(221,'10','Comprehension','Making Connections',130,'<li>Model and support how to make text-to-text connections</li>\n<li>Model and teach how to make text-to-self connections</li>\n','<li>Grandma\'s Surprise; Shoe Boxes</li>\n',NULL),(241,'3','Oral Fluency','Accuracy',60,NULL,NULL,NULL),(240,'3','Oral Fluency','Use of Cues',50,'','',''),(239,'3','Oral Fluency','Monitoring & Self Correction',40,'','',''),(238,'3','Reading Engagement','Book-Handling Skills',30,NULL,NULL,NULL),(237,'3','Reading Engagement','Favourite Book',20,NULL,NULL,NULL),(236,'3','Reading Engagement','Literacy Support',10,'','',''),(242,'3','Printed Language Concepts','Directionality',70,NULL,NULL,NULL),(243,'3','Printed Language Concepts','One-toOne Correspondence',80,NULL,NULL,NULL),(244,'3','Printed Language Concepts','Letter/Word',90,NULL,NULL,NULL),(255,'50','Reading Engagement','Wide Reading',10,NULL,NULL,NULL),(256,'50','Reading Engagement','Self-Assessment/Goal Setting',20,NULL,NULL,NULL),(257,'50','Oral Fluency','Expression',30,NULL,NULL,NULL),(258,'50','Oral Fluency','Phrasing',40,NULL,NULL,NULL),(259,'50','Oral Fluency','Rate',50,NULL,NULL,NULL),(260,'50','Oral Fluency','Accuracy',60,NULL,NULL,NULL),(261,'50','Comprehension','Questioning Prediction',70,NULL,NULL,NULL),(262,'50','Comprehension','Summary',80,NULL,NULL,NULL),(263,'50','Comprehension','Literal Comprehension',90,NULL,NULL,NULL),(264,'50','Comprehension','Interpretation',100,NULL,NULL,NULL),(265,'50','Comprehension','Reflection',110,NULL,NULL,NULL),(266,'50','Comprehension','Metacognitive Awareness',120,NULL,NULL,NULL),(267,'60','Reading Engagement','Wide Reading',10,NULL,NULL,NULL),(268,'60','Reading Engagement','Self-Assessment/Goal Setting',20,NULL,NULL,NULL),(269,'60','Oral Fluency','Expression',30,NULL,NULL,NULL),(270,'60','Oral Fluency','Phrasing',40,NULL,NULL,NULL),(271,'60','Oral Fluency','Rate',50,NULL,NULL,NULL),(272,'60','Oral Fluency','Accuracy',60,NULL,NULL,NULL),(273,'60','Comprehension','Questioning Prediction',70,NULL,NULL,NULL),(274,'60','Comprehension','Summary',80,NULL,NULL,NULL),(275,'60','Comprehension','Literal Comprehension',90,NULL,NULL,NULL),(276,'60','Comprehension','Interpretation',100,NULL,NULL,NULL),(277,'60','Comprehension','Reflection',110,NULL,NULL,NULL),(278,'60','Comprehension','Metacognitive Awareness',120,NULL,NULL,NULL),(279,'70','Reading Engagement','Wide Reading',10,NULL,NULL,NULL),(280,'70','Reading Engagement','Self-Assessment/Goal Setting',20,NULL,NULL,NULL),(281,'70','Oral Fluency','Expression',30,NULL,NULL,NULL),(282,'70','Oral Fluency','Phrasing',40,NULL,NULL,NULL),(283,'70','Oral Fluency','Rate',50,NULL,NULL,NULL),(284,'70','Oral Fluency','Accuracy',60,NULL,NULL,NULL),(285,'70','Comprehension','Questioning Prediction',70,NULL,NULL,NULL),(286,'70','Comprehension','Summary',80,NULL,NULL,NULL),(287,'70','Comprehension','Literal Comprehension',90,NULL,NULL,NULL),(288,'70','Comprehension','Interpretation',100,NULL,NULL,NULL),(289,'70','Comprehension','Reflection',110,NULL,NULL,NULL),(290,'70','Comprehension','Metacognitive Awareness',120,NULL,NULL,NULL),(291,'80','Reading Engagement','Wide Reading',10,NULL,NULL,NULL),(292,'80','Reading Engagement','Self-Assessment/Goal Setting',20,NULL,NULL,NULL),(293,'80','Oral Fluency','Expression',30,NULL,NULL,NULL),(294,'80','Oral Fluency','Phrasing',40,NULL,NULL,NULL),(295,'80','Oral Fluency','Rate',50,NULL,NULL,NULL),(296,'80','Oral Fluency','Accuracy',60,NULL,NULL,NULL),(297,'80','Comprehension','Questioning Prediction',70,NULL,NULL,NULL),(298,'80','Comprehension','Summary',80,NULL,NULL,NULL),(299,'80','Comprehension','Literal Comprehension',90,NULL,NULL,NULL),(300,'80','Comprehension','Interpretation',100,NULL,NULL,NULL),(301,'80','Comprehension','Reflection',110,NULL,NULL,NULL),(302,'80','Comprehension','Metacognitive Awareness',120,NULL,NULL,NULL),(311,'1','Reading Engagement','Literacy Support',10,'','',''),(312,'1','Reading Engagement','Favourite Book',20,NULL,NULL,NULL),(313,'1','Reading Engagement','Book Handling Skills',30,NULL,NULL,NULL),(314,'1','Oral Fluency','Monitoring Self-correction',40,NULL,NULL,NULL),(315,'1','Oral Fluency','Use of Cues',50,NULL,NULL,NULL),(316,'1','Oral Fluency','Accuracy',60,NULL,NULL,NULL),(317,'1','Printed Language Concepts','Directionality',70,NULL,NULL,NULL),(318,'1','Printed Language Concepts','One to One  Correspondence',80,NULL,NULL,NULL),(327,'A','Reading Engagement','Literacy Support',10,NULL,NULL,NULL),(328,'A','Reading Engagement','Favourite Book',20,NULL,NULL,NULL),(329,'A','Reading Engagement','Book Handling Skills',30,NULL,NULL,NULL),(330,'A','Oral Fluency','Monitoring Self-correction',40,NULL,NULL,NULL),(331,'A','Oral Fluency','Use of Cues',50,NULL,NULL,NULL),(332,'A','Oral Fluency','Accuracy',60,NULL,NULL,NULL),(333,'A','Printed Language Concepts','Directionality',70,NULL,NULL,NULL),(334,'A','Printed Language Concepts','One to One  Correspondence',80,NULL,NULL,NULL),(336,'20B','Reading Engagement','Wide Reading',10,NULL,NULL,NULL),(337,'20B','Reading Engagement','Self-Assessment/Goal Setting',20,NULL,NULL,NULL),(338,'20B','Oral Fluency','Expression',30,'','',''),(339,'20B','Oral Fluency','Rate',40,NULL,NULL,NULL),(340,'20B','Oral Fluency','Accuracy: Word Analysis',50,NULL,NULL,NULL),(341,'20B','Comprehension','Questioning; Prediction',60,NULL,NULL,NULL),(342,'20B','Comprehension','Scaffolded Summary',70,NULL,NULL,NULL),(343,'20B','Comprehension','Literal Comprehension',80,NULL,NULL,NULL),(344,'20B','Comprehension','Interpretation',90,NULL,NULL,NULL),(345,'20B','Comprehension','Reflection',100,NULL,NULL,NULL),(346,'20B','Comprehension','Metacognitive Awareness',110,NULL,NULL,NULL),(347,'24B','Reading Engagement','Wide Reading',10,NULL,NULL,NULL),(348,'24B','Reading Engagement','Self-Assessment/Goal Setting',20,NULL,NULL,NULL),(349,'24B','Oral Fluency','Expression',30,'','',''),(350,'24B','Oral Fluency','Rate',40,NULL,NULL,NULL),(351,'24B','Oral Fluency','Accuracy: Word Analysis',50,NULL,NULL,NULL),(352,'24B','Comprehension','Questioning; Prediction',60,NULL,NULL,NULL),(353,'24B','Comprehension','Scaffolded Summary',70,NULL,NULL,NULL),(354,'24B','Comprehension','Literal Comprehension',80,NULL,NULL,NULL),(355,'24B','Comprehension','Interpretation',90,NULL,NULL,NULL),(356,'24B','Comprehension','Reflection',100,NULL,NULL,NULL),(357,'24B','Comprehension','Metacognitive Awareness',110,NULL,NULL,NULL),(388,'28B','Comprehension','Literal Comprehension',80,NULL,NULL,NULL),(387,'28B','Comprehension','Summary',70,NULL,NULL,NULL),(386,'28B','Comprehension','Questioning; Prediction',60,NULL,NULL,NULL),(381,'28B','Reading Engagement','Wide Reading',10,NULL,NULL,NULL),(382,'28B','Reading Engagement','Self-Assessment/Goal Setting',20,NULL,NULL,NULL),(383,'28B','Oral Fluency','Expression',30,'','',''),(384,'28B','Oral Fluency','Rate',40,NULL,NULL,NULL),(385,'28B','Oral Fluency','Accuracy: Word Analysis',50,NULL,NULL,NULL),(370,'30B','Reading Engagement','Wide Reading',10,NULL,NULL,NULL),(371,'30B','Reading Engagement','Self-Assessment/Goal Setting',20,NULL,NULL,NULL),(372,'30B','Oral Fluency','Expression',30,'','',''),(373,'30B','Oral Fluency','Rate',40,NULL,NULL,NULL),(374,'30B','Oral Fluency','Accuracy: Word Analysis',50,NULL,NULL,NULL),(375,'30B','Comprehension','Questioning; Prediction',60,NULL,NULL,NULL),(376,'30B','Comprehension','Scaffolded Summary',70,NULL,NULL,NULL),(377,'30B','Comprehension','Literal Comprehension',80,NULL,NULL,NULL),(378,'30B','Comprehension','Interpretation',90,NULL,NULL,NULL),(379,'30B','Comprehension','Reflection',100,NULL,NULL,NULL),(380,'30B','Comprehension','Metacognitive Awareness',110,NULL,NULL,NULL),(389,'28B','Comprehension','Interpretation',90,NULL,NULL,NULL),(390,'28B','Comprehension','Reflection',100,NULL,NULL,NULL),(391,'28B','Comprehension','Metacognitive Awareness',110,NULL,NULL,NULL),(422,'34B','Comprehension','Literal Comprehension',90,NULL,NULL,NULL),(421,'34B','Comprehension','Scaffolded Summary',80,NULL,NULL,NULL),(420,'34B','Comprehension','Questioning Prediction',70,NULL,NULL,NULL),(419,'34B','Oral Fluency','Accuracy',60,NULL,NULL,NULL),(418,'34B','Oral Fluency','Rate',50,NULL,NULL,NULL),(417,'34B','Oral Fluency','Phrasing',40,NULL,NULL,NULL),(416,'34B','Oral Fluency','Expression',30,NULL,NULL,NULL),(414,'34B','Reading Engagement','Wide Reading',10,NULL,NULL,NULL),(415,'34B','Reading Engagement','Self-Assessment/Goal Setting',20,NULL,NULL,NULL),(403,'38B','Reading Engagement','Wide Reading',10,NULL,NULL,NULL),(404,'38B','Reading Engagement','Self-Assessment/Goal Setting',20,NULL,NULL,NULL),(405,'38B','Oral Fluency','Expression ',30,'','',''),(406,'38B','Oral Fluency','Rate',40,NULL,NULL,NULL),(407,'38B','Oral Fluency','Accuracy: Word Analysis',50,NULL,NULL,NULL),(408,'38B','Comprehension','Questioning; Prediction',60,NULL,NULL,NULL),(409,'38B','Comprehension','Scaffolded Summary',70,NULL,NULL,NULL),(410,'38B','Comprehension','Literal Comprehension',80,NULL,NULL,NULL),(411,'38B','Comprehension','Interpretation',90,NULL,NULL,NULL),(412,'38B','Comprehension','Reflection',100,NULL,NULL,NULL),(413,'38B','Comprehension','Metacognitive Awareness',110,NULL,NULL,NULL),(423,'34B','Comprehension','Interpretation',100,NULL,NULL,NULL),(424,'34B','Comprehension','Reflection',110,NULL,NULL,NULL),(425,'34B','Comprehension','Metacognitive Awareness',120,NULL,NULL,NULL),(490,'28F','Comprehension','Prediction',80,NULL,NULL,NULL),(491,'28F','Comprehension','Scaffolded Summary',90,NULL,NULL,NULL),(492,'28F','Comprehension','Scaffolded Summary: Vocabulary',100,NULL,NULL,NULL),(493,'28F','Comprehension','Literal Comprehension',110,NULL,NULL,NULL),(494,'28F','Comprehension','Interpretation',120,NULL,NULL,NULL),(495,'28F','Comprehension','Reflection',130,NULL,NULL,NULL),(496,'38N','Reading Engagement','Wide Reading',10,NULL,NULL,NULL),(497,'38N','Reading Engagement','Self Assessment/Goal Setting',20,NULL,NULL,NULL),(498,'38N','Oral Fluency','Expression',30,NULL,NULL,NULL),(499,'38N','Oral Fluency','Phrasing',40,NULL,NULL,NULL),(500,'38N','Oral Fluency','Rate',50,NULL,NULL,NULL),(501,'38N','Oral Fluency','Accuracy',60,NULL,NULL,NULL),(502,'38N','Comprehension','Prediction',70,NULL,NULL,NULL),(503,'38N','Comprehension','Nonfiction Text Features',80,NULL,NULL,NULL),(504,'38N','Comprehension','Scaffolded Summary',90,NULL,NULL,NULL),(505,'38N','Comprehension','Scaffolded Summary: Vocabulary',100,NULL,NULL,NULL),(506,'38N','Comprehension','Literal Comprehension',110,NULL,NULL,NULL),(507,'38N','Comprehension','Interpretation',120,NULL,NULL,NULL),(508,'38N','Comprehension','Reflection',130,NULL,NULL,NULL),(509,'38F','Reading Engagement','Wide Reading',10,NULL,NULL,NULL),(510,'38F','Reading Engagement','Self Assessment/Goal Setting',20,NULL,NULL,NULL),(511,'38F','Oral Fluency','Expression',30,NULL,NULL,NULL),(512,'38F','Oral Fluency','Phrasing',40,NULL,NULL,NULL),(513,'38F','Oral Fluency','Rate',50,NULL,NULL,NULL),(514,'38F','Oral Fluency','Accuracy',60,NULL,NULL,NULL),(515,'38F','Comprehension','Use of Text features',70,NULL,NULL,NULL),(516,'38F','Comprehension','Prediction',80,NULL,NULL,NULL),(517,'38F','Comprehension','Scaffolded Summary',90,NULL,NULL,NULL),(518,'38F','Comprehension','Scaffolded Summary: Vocabulary',100,NULL,NULL,NULL),(519,'38F','Comprehension','Literal Comprehension',110,NULL,NULL,NULL),(520,'38F','Comprehension','Interpretation',120,NULL,NULL,NULL),(521,'38F','Comprehension','Reflection',130,NULL,NULL,NULL),(586,'40K','Comprehension','Interpretation',100,NULL,NULL,NULL),(585,'40K','Comprehension','Literal Comprehension',90,NULL,NULL,NULL),(584,'40K','Comprehension','Summary',80,NULL,NULL,NULL),(583,'40K','Comprehension','Questioning/Prediction',70,NULL,NULL,NULL),(582,'40K','Oral Fluency','Accuracy',60,NULL,NULL,NULL),(581,'40K','Oral Fluency','Rate',50,NULL,NULL,NULL),(580,'40K','Oral Fluency','Phrasing',40,NULL,NULL,NULL),(579,'40K','Oral Fluency','Expression',30,NULL,NULL,NULL),(578,'40K','Reading Engagement','Self-Assessment/Goal Setting',20,NULL,NULL,NULL),(577,'40K','Reading Engagement','Wide Reading',10,NULL,NULL,NULL),(587,'40K','Comprehension','Reflection',110,NULL,NULL,NULL),(588,'40K','Comprehension','Metacognitive Awareness',120,NULL,NULL,NULL);
/*!40000 ALTER TABLE `read_level` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `read_test`
--

DROP TABLE IF EXISTS `read_test`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `read_test` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studnum` int(11) DEFAULT NULL,
  `readlevel` varchar(4) DEFAULT NULL,
  `tdate` date DEFAULT NULL,
  `tauthor` varchar(40) DEFAULT NULL,
  `tgrade` varchar(8) DEFAULT NULL,
  `tstamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `season` varchar(16) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `read_test`
--

LOCK TABLES `read_test` WRITE;
/*!40000 ALTER TABLE `read_test` DISABLE KEYS */;
/*!40000 ALTER TABLE `read_test` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `read_test_score`
--

DROP TABLE IF EXISTS `read_test_score`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `read_test_score` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `testid` int(11) DEFAULT NULL,
  `category` text,
  `name` text,
  `seq` int(11) DEFAULT NULL,
  `score` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `read_test_score`
--

LOCK TABLES `read_test_score` WRITE;
/*!40000 ALTER TABLE `read_test_score` DISABLE KEYS */;
/*!40000 ALTER TABLE `read_test_score` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sasked_completedcourses`
--

DROP TABLE IF EXISTS `sasked_completedcourses`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sasked_completedcourses` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `provnum` int(11) DEFAULT NULL,
  `birthdate` date DEFAULT NULL,
  `schoolid` int(11) DEFAULT NULL,
  `schoolname` varchar(255) DEFAULT NULL,
  `courseid` varchar(16) DEFAULT NULL,
  `coursetitle` varchar(255) DEFAULT NULL,
  `coursetype` varchar(32) DEFAULT NULL,
  `schoolyear` varchar(16) DEFAULT NULL,
  `courseenddate` date DEFAULT NULL,
  `finalmark` varchar(4) DEFAULT NULL,
  `creditsearned` varchar(4) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sasked_completedcourses`
--

LOCK TABLES `sasked_completedcourses` WRITE;
/*!40000 ALTER TABLE `sasked_completedcourses` DISABLE KEYS */;
/*!40000 ALTER TABLE `sasked_completedcourses` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sasked_courses`
--

DROP TABLE IF EXISTS `sasked_courses`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sasked_courses` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) DEFAULT NULL,
  `code` varchar(16) DEFAULT NULL,
  `startdate` date DEFAULT NULL,
  `enddate` date DEFAULT NULL,
  `ctype` varchar(32) DEFAULT NULL,
  `grade` varchar(4) DEFAULT NULL,
  `category` varchar(32) DEFAULT NULL,
  `prereg` varchar(255) DEFAULT NULL,
  `cgroup` varchar(64) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=27186 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sasked_courses`
--

LOCK TABLES `sasked_courses` WRITE;
/*!40000 ALTER TABLE `sasked_courses` DISABLE KEYS */;
INSERT INTO `sasked_courses` VALUES (24556,'(Basic) Electricity 30L','8940','1997-08-16','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(24557,'(Basic) Electricity Lab 30L','8941','1997-08-16','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(24558,'(Electrical) Drafting 30L','8939','1996-08-16','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(24559,'(Technical) Communication 20L','6942','1996-08-16','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(24560,'Aboriginal Education & Career Success 10L','5332','2006-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(24561,'Academic Reading and Writing 30L','9510','2015-08-01','0000-00-00','Locally Developed Dual Credit','12',NULL,NULL,NULL),(24562,'Accounting 10','1705','1977-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(24563,'Accounting 10','5205','1992-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(24564,'Accounting 10L','1704','1990-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(24565,'Accounting 20','2705','1977-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24566,'Accounting 20','7205','1992-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(24567,'Accounting 20L','2604','1990-09-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24568,'Accounting 30','3705','1977-09-01','1998-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24569,'Accounting 30','9205','1992-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24570,'Accounting 30L','3704','1990-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(24571,'Active Living and Fitness Leadership 20L','6610','2009-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24572,'Active Living and Fitness Leadership 30L','8610','2009-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24573,'Adaptation au travail 10','5125','2001-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(24574,'Adaptation au travail 20','7125','2001-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(24575,'Adaptation au travail 30','9125','2001-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24576,'Advanced Baking 30L','9026','2013-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24577,'Advanced Clothing A 30','3660','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24578,'Advanced Clothing A 31','3659','1950-09-01','1997-08-15','Locally Modified Down','12',NULL,NULL,NULL),(24579,'Advanced Clothing B 30','3665','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24580,'Advanced Clothing B 31','3664','1950-09-01','1997-08-15','Locally Modified Down','12',NULL,NULL,NULL),(24581,'Advanced Foods A 30','3650','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24582,'Advanced Foods A 31','3649','1950-09-01','1997-08-15','Locally Modified Down','12',NULL,NULL,NULL),(24583,'Advanced Foods A 31','3651','1950-09-01','1997-08-15','Locally Modified Down','12',NULL,NULL,NULL),(24584,'Advanced Foods B 30','3655','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24585,'Advanced Foods B 31','3654','1950-09-01','1997-08-15','Locally Modified Down','12',NULL,NULL,NULL),(24586,'Advanced Ukrainian 10A','1441','1990-01-24','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(24587,'Advanced Ukrainian 20A','2441','1990-09-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(24588,'Advanced Ukrainian 30A','3441','1990-09-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24589,'Ag Tech-Cow/Calf 10','4961','2003-08-15','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(24590,'Ag Tech-Cow/Calf 20','6961','2003-08-15','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(24591,'Ag Tech-Cow/Calf 30','8961','2003-08-15','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24592,'Ag Tech-Dairy 10','4960','2003-08-15','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(24593,'Ag Tech-Dairy 20','6960','2003-08-15','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(24594,'Ag Tech-Dairy 30','8960','2003-08-15','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24595,'Ag Tech-Feedlot 10','5000','2003-08-15','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(24596,'Ag Tech-Feedlot 20','7000','2003-08-15','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(24597,'Ag Tech-Feedlot 30','9000','2003-08-15','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24598,'Ag Tech-Field Crop 10','4959','2003-08-15','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(24599,'Ag Tech-Field Crop 20','6959','2003-08-15','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(24600,'Ag Tech-Field Crop 30','8959','2003-08-15','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24601,'Ag Tech-Pork 10','4998','2003-08-15','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(24602,'Ag Tech-Pork 20','6998','2003-08-15','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(24603,'Ag Tech-Sheep 10','4999','2003-08-15','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(24604,'Ag Tech-Sheep 20','6999','2003-08-15','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(24605,'Ag Tech-Sheep 30','8999','2003-08-15','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24606,'Agricultural 10','1828','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(24607,'Agricultural 10','1830','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(24608,'Agricultural 20','2830','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24609,'Agricultural 20','2831','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24610,'Agricultural 30','3830','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24611,'Agricultural 30','3831','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24612,'Agricultural Equipment Technician 20L','7044','2018-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24613,'Agricultural Equipment Technician 30L','9044','2018-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24614,'Agricultural Experience 20','2829','1975-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24615,'Agricultural Experience 30','3829','1975-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24616,'Agricultural II 10','1829','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(24617,'Agricultural Machinery 20','2960','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24618,'Agricultural Machinery 30','3960','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24619,'Agricultural Mechanics 10','1964','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(24620,'Agricultural Mechanics 10','1965','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(24621,'Agricultural Mechanics 20','2965','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24622,'Agriculture 10L','4950','1996-08-16','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(24623,'Agriculture 20','2630','1946-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24624,'Agriculture 20','2635','1995-06-01','2007-07-31','Departmentally Developed','11',NULL,NULL,NULL),(24625,'Agriculture Bioresources 20L','7021','2012-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24626,'Agriculture Mechanics 30','3965','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24627,'Agriculture Studies 30','8946','1997-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24628,'Agriculture Studies 30','8973','1998-08-16','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24629,'Agriculture Tech - Field Crop 10','4963','1998-08-16','1999-08-15','Departmentally Developed','10',NULL,NULL,NULL),(24630,'Agriculture Tech - Field Crop 20','6963','1998-08-16','1999-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24631,'Agriculture Tech - Field Crop 30','8963','1998-08-16','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24632,'Agriculture Tech-Field Crop Production 10L','4934','1996-08-16','2003-08-15','Locally Developed','10',NULL,NULL,NULL),(24633,'Agriculture Tech-Field Crop Production 20L','6934','1996-08-16','2003-08-15','Locally Developed','11',NULL,NULL,NULL),(24634,'Agriculture Tech-Field Crop Production 30L','8934','1996-08-16','2003-08-15','Locally Developed','12',NULL,NULL,NULL),(24635,'Agriculture Technician - Dairy 10','4964','1998-08-16','1999-08-15','Departmentally Developed','10',NULL,NULL,NULL),(24636,'Agriculture Technician - Dairy 10L','4929','1995-08-16','2003-08-15','Locally Developed','10',NULL,NULL,NULL),(24637,'Agriculture Technician - Dairy 20','6964','1998-08-16','1999-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24638,'Agriculture Technician - Dairy 20L','6929','1995-08-16','2003-08-15','Locally Developed','11',NULL,NULL,NULL),(24639,'Agriculture Technician - Dairy 30','8964','1998-08-16','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24640,'Agriculture Technician - Dairy 30L','8929','1995-08-16','2003-08-15','Locally Developed','12',NULL,NULL,NULL),(24641,'Agriculture Technician - Pork Prod 10L','4952','1997-08-16','2003-08-15','Locally Developed','10',NULL,NULL,NULL),(24642,'Agriculture Technician - Pork Prod 20L','6952','1997-08-16','2003-08-15','Locally Developed','11',NULL,NULL,NULL),(24643,'Agriculture Technician - Sheep 10L','4951','1997-08-16','2003-08-15','Locally Developed','10',NULL,NULL,NULL),(24644,'Agriculture Technician - Sheep 20L','6951','1997-08-16','2003-08-15','Locally Developed','11',NULL,NULL,NULL),(24645,'Agriculture Technician - Sheep 30L','8951','1998-08-16','2003-08-15','Locally Developed','12',NULL,NULL,NULL),(24646,'Agriculture Technician Feedlot 10L','4986','1999-08-16','2003-08-15','Locally Developed','10',NULL,NULL,NULL),(24647,'Agriculture Technician Feedlot 20L','6986','1999-08-15','2003-08-15','Locally Developed','11',NULL,NULL,NULL),(24648,'Agriculture Technician Feedlot 30L','8986','1999-08-16','2003-08-15','Locally Developed','12',NULL,NULL,NULL),(24649,'Agriculture Technician-Cow Calf 10','4965','1998-08-16','1999-08-15','Departmentally Developed','10',NULL,NULL,NULL),(24650,'Agriculture Technician-Cow Calf 20','6965','1998-08-16','1999-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24651,'Agriculture Technician-Cow Calf 30','8965','1998-08-16','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24652,'Agriculture Technician-Cow-Calf 10L','4935','1996-08-16','2003-08-15','Locally Developed','10',NULL,NULL,NULL),(24653,'Agriculture Technician-Cow-Calf 20L','6935','1996-08-16','2003-08-15','Locally Developed','11',NULL,NULL,NULL),(24654,'Agriculture Technician-Cow-Calf 30L','8935','1996-08-16','2003-08-15','Locally Developed','12',NULL,NULL,NULL),(24655,'Agriculture and Sustainable Food Production 10L','5049','2018-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(24656,'Agriculture and Sustainable Food Production 20L','7049','2018-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24657,'Algebra (Modern) 10','1210','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(24658,'Algebra (Modern) 10 A','1211','1950-09-01','1997-08-15','Locally Modified Up','10',NULL,NULL,NULL),(24659,'Algebra (Modern) 11','1209','1950-09-01','1997-08-15','Locally Modified Down','10',NULL,NULL,NULL),(24660,'Algebra (Modern) 20','2210','1950-09-01','1998-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24661,'Algebra (Modern) 20A','2211','1950-09-01','1998-08-15','Locally Modified Up','11',NULL,NULL,NULL),(24662,'Algebra (Modern) 21','2209','1950-09-01','1998-08-15','Locally Modified Down','11',NULL,NULL,NULL),(24663,'Algebra (Modern) 30','3210','1950-09-01','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24664,'Algebra (Modern) 30A','3211','1950-09-01','1999-08-15','Locally Modified Up','12',NULL,NULL,NULL),(24665,'Algebra (Modern) 31','3209','1950-09-01','1999-08-15','Locally Modified Down','12',NULL,NULL,NULL),(24666,'Algebra (Traditional) 10','1215','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(24667,'Algebra (Traditional) 10A','1216','1950-09-01','1997-08-15','Locally Modified Up','10',NULL,NULL,NULL),(24668,'Algebra (Traditional) 11','1214','1950-09-01','1997-08-15','Locally Modified Down','10',NULL,NULL,NULL),(24669,'Algebra (Traditional) 20','2215','1946-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24670,'Algebra (Traditional) 20A','2216','1950-09-01','1997-08-15','Locally Modified Up','11',NULL,NULL,NULL),(24671,'Algebra (Traditional) 21','2214','1950-09-01','1997-08-15','Locally Modified Down','11',NULL,NULL,NULL),(24672,'Algebra (Traditional) 30','3215','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24673,'Algebra (Traditional) 30A','3216','1950-09-01','1997-08-15','Locally Modified Up','12',NULL,NULL,NULL),(24674,'Algebra (Traditional) 31','3214','1950-09-01','1997-08-15','Locally Modified Down','12',NULL,NULL,NULL),(24675,'Algebra 10 (I)','4410','1991-08-16','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(24676,'Algebra 10 (IB)','4400','1988-08-15','1997-08-15','International Baccalaureate','10',NULL,NULL,NULL),(24677,'Algebra 20 (I)','6410','1991-08-16','1998-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24678,'Algebra 20 (IB)','6400','1988-08-15','1999-08-15','International Baccalaureate','11',NULL,NULL,NULL),(24679,'Algebra 30 (I)','8410','1993-08-16','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24680,'Algebra 30 (IB)','8400','1989-08-15','1999-08-15','International Baccalaureate','12',NULL,NULL,NULL),(24681,'Algebre 10','1217','1983-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(24682,'Algebre 20','2217','1983-09-01','1998-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24683,'Algebre 30','3217','1983-09-01','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24684,'Alimentation 10','5103','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(24685,'Alimentation 20','7103','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(24686,'Alimentation 30','9103','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24687,'Allemand 10L','4059','2000-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(24688,'Allemand 20L','6059','2000-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24689,'Allemand 30L','8059','2000-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24690,'American Literature and Style Analysis 30L','8099','2013-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24691,'American Sign Language & Deaf Culture 10L','5027','2013-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(24692,'American Sign Language & Deaf Culture 20L','7027','2013-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24693,'American Sign Language & Deaf Culture 30L','9027','2013-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24694,'American Sign Language 10L','1462','1989-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(24695,'American Sign Language 20L','2462','2011-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24696,'Anatomy 30L','9506','2016-08-01','0000-00-00','Locally Developed Dual Credit','12',NULL,NULL,NULL),(24697,'Animation 10L','5003','2002-08-15','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(24698,'Animation 20L','7003','2003-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24699,'Animation 30L','9003','2015-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24700,'Applications Of Control Theory 30L','8863','2000-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24701,'Applied Global Citizenship 30L','8346','2007-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24702,'Applied Mathematics 18','5434','1992-08-15','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(24703,'Applied Mathematics 28','7434','1992-08-15','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(24704,'Applied Mathematics 38','9434','1992-08-15','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(24705,'Apprenticeship A 20','7011','2009-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(24706,'Apprenticeship A 30','9011','2009-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24707,'Apprenticeship B 20','7012','2009-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(24708,'Apprenticeship B 30','9012','2009-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24709,'Aptitudes a la vie quotidienne 18','5423','1991-09-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(24710,'Aptitudes a la vie quotidienne 28','7423','1991-09-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(24711,'Aptitudes a la vie quotidienne 38','9423','1991-09-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(24712,'Art 10','1510','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(24713,'Art 10 (IB)','4507','1989-08-15','0000-00-00','International Baccalaureate','10',NULL,NULL,NULL),(24714,'Art 10A','1511','1950-09-01','1997-08-15','Locally Modified Up','10',NULL,NULL,NULL),(24715,'Art 11','1509','1950-09-01','1997-08-15','Locally Modified Down','10',NULL,NULL,NULL),(24716,'Art 20','2510','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24717,'Art 20','2880','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(24718,'Art 20','2881','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(24719,'Art 20 (IB)','6507','1989-08-15','0000-00-00','International Baccalaureate','11',NULL,NULL,NULL),(24720,'Art 20A','2511','1950-09-01','1997-08-15','Locally Modified Up','11',NULL,NULL,NULL),(24721,'Art 20L','6508','1991-08-15','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24722,'Art 21','2509','1950-09-01','1997-08-15','Locally Modified Down','11',NULL,NULL,NULL),(24723,'Art 30','3508','1970-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(24724,'Art 30','3510','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24725,'Art 30','3880','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(24726,'Art 30','3881','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(24727,'Art 30 (IB)','8507','1989-08-15','0000-00-00','International Baccalaureate','12',NULL,NULL,NULL),(24728,'Art 30A','3511','1950-09-01','0000-00-00','Locally Modified Up','12',NULL,NULL,NULL),(24729,'Art 30L','8508','1997-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24730,'Art 31','3509','1970-09-01','1997-08-15','Locally Modified Down','12',NULL,NULL,NULL),(24731,'Art I 20','2508','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(24732,'Art dramatique 10','4523','1995-08-15','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(24733,'Art dramatique 20','6523','1995-08-15','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(24734,'Art dramatique 30','8523','1995-08-15','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24735,'Arts Education 10','4511','1994-08-15','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(24736,'Arts Education 18','5469','2009-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(24737,'Arts Education 20','6516','1994-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(24738,'Arts Education 28','7469','2009-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(24739,'Arts Education 30','8516','1993-08-15','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24740,'Arts Education 38','9469','2009-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(24741,'Arts dramatiques 10','4501','1990-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(24742,'Arts dramatiques 20','6501','1991-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24743,'Arts et culture francophones 20L','6521','1993-08-15','2004-07-31','Locally Developed','11',NULL,NULL,NULL),(24744,'Arts pratiques et appliquÃ©s (cours combinÃ©s) 10','5101','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(24745,'Arts pratiques et appliquÃ©s (cours combinÃ©s) 20','7101','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(24746,'Arts pratiques et appliquÃ©s (cours combinÃ©s) 30','9101','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24747,'Arts pratiques et appliquÃ©s (cours combinÃ©s) A 18','5464','2006-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(24748,'Arts pratiques et appliquÃ©s (cours combinÃ©s) A 28','7464','2006-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(24749,'Arts pratiques et appliquÃ©s (cours combinÃ©s) A 38','9464','2006-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(24750,'Arts pratiques et appliquÃ©s (cours combinÃ©s) B 18','5465','2006-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(24751,'Arts pratiques et appliquÃ©s (cours combinÃ©s) B 28','7465','2006-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(24752,'Arts pratiques et appliquÃ©s (cours combinÃ©s) B 38','9465','2006-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(24753,'Arts visuels 10','4534','1999-08-06','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(24754,'Arts visuels 20','6534','1999-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(24755,'Arts visuels 30','8534','1999-08-06','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24756,'Arts/Aesthetic Education A 18','5412','1989-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(24757,'Arts/Aesthetic Education A 28','7412','1989-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(24758,'Arts/Aesthetic Education A 38','9412','1990-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(24759,'Arts/Aesthetic Education B 18','5440','1990-08-16','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(24760,'Arts/Aesthetic Education B 28','7440','1990-08-16','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(24761,'Arts/Aesthetic Education B 38','9440','1990-08-16','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(24762,'Artwoods & Metal 20','2507','1990-01-29','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(24763,'Asian Studies 20L','6300','1991-01-01','2002-08-15','Locally Developed','11',NULL,NULL,NULL),(24764,'Asian Studies 20L','6341','2002-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24765,'Astronomy 20L','6264','2015-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24766,'Astronomy 30L','9512','2016-08-01','0000-00-00','Locally Developed Dual Credit','12',NULL,NULL,NULL),(24767,'Auto Parts & Warehousing 10L','4916','1991-08-21','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(24768,'Auto Parts & Warehousing A 20L','6916','1990-09-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24769,'Auto Parts & Warehousing A 30L','8916','1990-09-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24770,'Auto Parts & Warehousing B 20L','6917','1990-09-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24771,'Auto Parts & Warehousing B 30L','8917','1990-09-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24772,'Autobody 10','1968','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(24773,'Autobody 10','1970','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(24774,'Autobody 10','1971','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(24775,'Autobody 10','1972','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(24776,'Autobody 10','4949','1997-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(24777,'Autobody 10','4970','1998-08-16','1999-08-15','Departmentally Developed','10',NULL,NULL,NULL),(24778,'Autobody 10L','1872','1988-09-01','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(24779,'Autobody 18','5479','2009-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(24780,'Autobody 20','2968','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(24781,'Autobody 20','2970','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(24782,'Autobody 20','2971','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(24783,'Autobody 20','2972','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(24784,'Autobody 20','2983','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(24785,'Autobody 20','2984','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(24786,'Autobody 20','6970','1998-08-16','1999-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24787,'Autobody 20L','2872','1989-06-22','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(24788,'Autobody 28','7479','2009-08-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(24789,'Autobody 30','3968','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(24790,'Autobody 30','3970','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(24791,'Autobody 30','3971','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(24792,'Autobody 30','3972','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(24793,'Autobody 30','3983','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(24794,'Autobody 30','3984','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(24795,'Autobody 30','8970','1998-08-16','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24796,'Autobody 30L','3872','1989-06-22','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(24797,'Autobody 38','9479','2009-08-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(24798,'Autobody A 10L','1873','1989-06-22','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(24799,'Autobody A 20','6949','1997-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(24800,'Autobody A 20L','2873','1989-06-22','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(24801,'Autobody A 28','7488','2017-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(24802,'Autobody A 30','8949','1997-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24803,'Autobody A 30L','3873','1989-06-22','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(24804,'Autobody A 38','9488','2017-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(24805,'Autobody B 10L','1874','1989-06-22','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(24806,'Autobody B 20','6962','1998-08-15','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(24807,'Autobody B 20L','2874','1989-06-22','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(24808,'Autobody B 28','7489','2017-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(24809,'Autobody B 30','8962','1998-08-15','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24810,'Autobody B 30L','3874','1989-06-22','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(24811,'Autobody B 38','9489','2017-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(24812,'Autobody I 10','1969','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(24813,'Automotive 10','1897','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(24814,'Automotive 10','1928','1970-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(24815,'Automotive 10','1929','1970-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(24816,'Automotive 10','1930','1970-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(24817,'Automotive 10','1931','1970-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(24818,'Automotive 10','1932','1970-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(24819,'Automotive 20','2897','1988-02-10','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(24820,'Automotive 20','2928','1975-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(24821,'Automotive 20','2929','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(24822,'Automotive 20','2930','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24823,'Automotive 20','2931','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24824,'Automotive 20','2932','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24825,'Automotive 20','2974','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(24826,'Automotive 20','2975','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(24827,'Automotive 30','3897','1988-02-10','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(24828,'Automotive 30','3928','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(24829,'Automotive 30','3929','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(24830,'Automotive 30','3930','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24831,'Automotive 30','3931','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24832,'Automotive 30','3932','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24833,'Automotive 30','3974','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(24834,'Automotive 30','3975','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(24835,'Aviation Maintenance Orientation Program 30L','9010','2007-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24836,'Aviation Studies 20L','6930','1996-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24837,'Aviation Studies 30L','8930','1997-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24838,'Band 10','1525','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(24839,'Band 10','1527','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(24840,'Band 10','4526','1996-08-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(24841,'Band 10L','4512','1991-08-15','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(24842,'Band 18','5605','2017-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(24843,'Band 20','2525','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24844,'Band 20','2527','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24845,'Band 20','6526','1996-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(24846,'Band 20L','6512','1991-08-15','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(24847,'Band 28','7605','2017-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(24848,'Band 30','3525','1970-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24849,'Band 30','3527','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24850,'Band 30','8526','1996-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24851,'Band 30L','8512','1991-08-15','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(24852,'Band 38','9605','2017-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(24853,'Basic Military Qualification 30L','9340','2014-08-01','2014-08-02','Locally Developed','12',NULL,NULL,NULL),(24854,'Basic Military Qualification 30L','9500','2014-08-01','0000-00-00','Locally Developed Dual Credit','12',NULL,NULL,NULL),(24855,'Biblical Word Studies 10L','4806','1999-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(24856,'Biologie 20','2267','1983-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24857,'Biologie 20','6216','1993-08-15','2015-07-31','Departmentally Developed','11',NULL,NULL,NULL),(24858,'Biologie 21','6240','2004-08-01','2016-08-31','Locally Modified Down','11',NULL,NULL,NULL),(24859,'Biologie 30','3267','1983-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24860,'Biologie 30','8216','1993-01-01','2016-08-31','Departmentally Developed','12',NULL,NULL,NULL),(24861,'Biologie 30 (nouveau)','8258','2015-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24862,'Biologie 31','8240','2004-08-01','2016-08-31','Locally Modified Down','12',NULL,NULL,NULL),(24863,'Biology 20','2265','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24864,'Biology 20','6211','1992-08-16','2015-07-31','Departmentally Developed','11',NULL,NULL,NULL),(24865,'Biology 20 (I)','6218','1991-08-16','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24866,'Biology 20 (IB)','6207','1989-08-15','1999-08-15','International Baccalaureate','11',NULL,NULL,NULL),(24867,'Biology 20 (IB)','6208','1989-08-15','1999-08-15','International Baccalaureate','11',NULL,NULL,NULL),(24868,'Biology 20 (IB)','6235','1997-08-16','2015-07-31','International Baccalaureate','11',NULL,NULL,NULL),(24869,'Biology 20A','6225','1995-08-15','2015-07-31','Locally Modified Up','11',NULL,NULL,NULL),(24870,'Biology 21','2264','1950-09-01','1997-08-15','Locally Modified Down','11',NULL,NULL,NULL),(24871,'Biology 21','6229','1996-08-16','2016-07-31','Locally Modified Down','11',NULL,NULL,NULL),(24872,'Biology 30','3265','1946-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24873,'Biology 30','8211','1992-08-16','2016-08-31','Departmentally Developed','12',NULL,NULL,NULL),(24874,'Biology 30 (AP)','8236','2000-08-15','2016-08-31','Advanced Placement','12',NULL,NULL,NULL),(24875,'Biology 30 (AP)','8275','2016-08-01','0000-00-00','Advanced Placement','12',NULL,NULL,NULL),(24876,'Biology 30 (I)','8218','1991-08-15','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24877,'Biology 30 (IB)','8207','1989-08-15','1999-08-15','International Baccalaureate','12',NULL,NULL,NULL),(24878,'Biology 30 (IB)','8208','1989-08-15','1999-08-15','International Baccalaureate','12',NULL,NULL,NULL),(24879,'Biology 30 (IB)','8235','1997-08-16','2016-08-31','International Baccalaureate','12',NULL,NULL,NULL),(24880,'Biology 30 (IB)','8278','2016-08-01','0000-00-00','International Baccalaureate','12',NULL,NULL,NULL),(24881,'Biology 30 (new)','8255','2015-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24882,'Biology 30A','8225','1995-08-15','2017-07-31','Locally Modified Up','12',NULL,NULL,NULL),(24883,'Biology 30A','8281','2017-08-01','0000-00-00','Locally Modified Up','12',NULL,NULL,NULL),(24884,'Biology 31','8229','1996-08-16','0000-00-00','Locally Modified Down','12',NULL,NULL,NULL),(24885,'Biology Preparation AP 30L','8282','2018-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24886,'Bioresource Management 20L','6243','2007-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24887,'Bioresource Management 30L','8243','2008-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24888,'Bookkeeping 10','1709','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(24889,'Bookkeeping 10','1710','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(24890,'Bookkeeping 20','2710','1946-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24891,'Bookkeeping 30','3710','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24892,'Braille 10L','1464','1992-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(24893,'Braille 20L','2464','1992-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24894,'Braille 30L','3464','1993-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24895,'Bridges 20L','7040','2015-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24896,'Bridging Mathematics 30L','8438','2013-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24897,'Bscs Biology 20','2260','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24898,'Bscs Biology 20A','2261','1950-09-01','1997-08-15','Locally Modified Up','11',NULL,NULL,NULL),(24899,'Bscs Biology 21','2259','1950-09-01','1997-08-15','Locally Modified Down','11',NULL,NULL,NULL),(24900,'Bscs Biology 30','3260','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24901,'Bscs Biology 30A','3261','1950-09-01','1997-08-15','Locally Modified Up','12',NULL,NULL,NULL),(24902,'Bscs Biology 31','3259','1950-09-01','1997-08-15','Locally Modified Down','12',NULL,NULL,NULL),(24903,'Building Construction 10','1933','1970-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(24904,'Building Construction 10','1935','1975-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(24905,'Building Construction 10','1936','1975-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(24906,'Building Construction 10','1937','1975-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(24907,'Building Construction 20','2976','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(24908,'Building Construction 20','2977','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(24909,'Building Maintenance 10L','4918','1990-08-21','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(24910,'Building Maintenance A 20L','6918','1990-09-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24911,'Building Maintenance A 30L','8918','1991-08-21','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24912,'Building Maintenance B 20L','6919','1990-09-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24913,'Building Maintenance B 30L','8919','1991-08-21','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24914,'Business Communications 20L','2729','1990-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(24915,'Business Communications 30L','8700','1991-08-21','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24916,'Business Education A 18','5414','1989-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(24917,'Business Education A 28','7414','1989-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(24918,'Business Education A 38','9414','1990-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(24919,'Business Education B 18','5441','1993-08-16','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(24920,'Business Education B 28','7441','1993-08-16','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(24921,'Business Education B 38','9441','1993-08-16','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(24922,'Business Management 30','3715','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24923,'Business Records 10','1770','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(24924,'Business Records 20','2770','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24925,'Cabinet Making 20L','6921','1992-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24926,'Cabinet Making 30L','8921','1999-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24927,'Cadet Training 11','1360','1950-09-01','1998-08-15','External','10',NULL,NULL,NULL),(24928,'Cadet Training 21','2360','1950-09-01','1998-08-15','External','11',NULL,NULL,NULL),(24929,'Cadet Training 31','3360','1950-09-01','2004-01-29','External','12',NULL,NULL,NULL),(24930,'Calcul 30','8422','2005-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24931,'Calcul 30L','8417','1998-08-16','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(24932,'Calculus 30','3218','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(24933,'Calculus 30','3232','1990-08-23','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(24934,'Calculus 30','3233','1989-01-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(24935,'Calculus 30','8403','1991-09-01','2006-07-31','Departmentally Developed','12',NULL,NULL,NULL),(24936,'Calculus 30','8421','2003-08-15','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24937,'Calculus 30 (AP)','8418','2000-08-15','0000-00-00','Advanced Placement','12',NULL,NULL,NULL),(24938,'Calculus 30 (IB)','8402','1989-08-15','0000-00-00','International Baccalaureate','12',NULL,NULL,NULL),(24939,'Canadian Studies 30','3137','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(24940,'Career And Life Management 10','1323','1990-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(24941,'Career Awareness 10L','5305','1996-08-16','2000-08-15','Locally Developed','10',NULL,NULL,NULL),(24942,'Career Development 20L','7305','1997-08-16','1999-08-31','Locally Developed','11',NULL,NULL,NULL),(24943,'Career Education 10','1328','1983-09-01','1998-08-15','Departmentally Developed','10',NULL,NULL,NULL),(24944,'Career Education 10','1334','1983-09-01','1998-08-15','Departmentally Developed','10',NULL,NULL,NULL),(24945,'Career Education 10L','1327','1990-09-01','1998-08-15','Locally Developed','10',NULL,NULL,NULL),(24946,'Career Education 18','5408','1989-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(24947,'Career Education 20','2328','1983-09-01','1998-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24948,'Career Education 20','2334','1983-09-01','1998-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24949,'Career Education 28','7408','1990-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(24950,'Career Education 30','3328','1983-09-01','1998-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24951,'Career Education 30','3334','1983-09-01','1998-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24952,'Career Education 38','9408','1990-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(24953,'Career Safety Skills 20L','7306','1996-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24954,'Career Safety Skills 20L','7307','1996-08-16','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(24955,'Career and Personal Planning 10L','4612','2009-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(24956,'Career and Work Exploration 10','4994','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(24957,'Career and Work Exploration 18','5451','2006-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(24958,'Career and Work Exploration 20','6994','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(24959,'Career and Work Exploration 28','7451','2006-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(24960,'Career and Work Exploration A 30','8994','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24961,'Career and Work Exploration A 38','9451','2006-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(24962,'Career and Work Exploration B 30','8995','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24963,'Career and Work Exploration B 38','9462','2006-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(24964,'Carpentry 30L','9042','2016-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24965,'Catholic Studies 10','4807','2016-08-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(24966,'Catholic Studies 18','5498','2017-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(24967,'Catholic Studies 20','6807','2016-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(24968,'Catholic Studies 28','7498','2017-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(24969,'Catholic Studies 30','8807','2016-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24970,'Catholic Studies 38','9498','2017-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(24971,'Catholic Youth Leadership 20L','7331','2004-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(24972,'Certificates 30L','9038','2015-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(24973,'Chem Study 20','2250','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24974,'Chem Study 20A','2251','1950-09-01','1997-08-15','Locally Modified Up','11',NULL,NULL,NULL),(24975,'Chem Study 30','3250','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24976,'Chem Study 30A','3251','1950-09-01','1997-08-15','Locally Modified Up','12',NULL,NULL,NULL),(24977,'Chemistry 20','2255','1946-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24978,'Chemistry 20','6212','1992-08-16','2015-07-31','Departmentally Developed','11',NULL,NULL,NULL),(24979,'Chemistry 20 (I)','6219','1991-08-16','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(24980,'Chemistry 20 (IB)','6209','1989-08-15','1999-08-15','International Baccalaureate','11',NULL,NULL,NULL),(24981,'Chemistry 20 (IB)','6233','1997-08-16','2015-07-31','International Baccalaureate','11',NULL,NULL,NULL),(24982,'Chemistry 20A','2256','1988-09-01','1997-08-15','Locally Modified Up','11',NULL,NULL,NULL),(24983,'Chemistry 20A','6227','1996-08-16','2015-07-31','Locally Modified Up','11',NULL,NULL,NULL),(24984,'Chemistry 21','2254','1950-09-01','1997-08-15','Locally Modified Down','11',NULL,NULL,NULL),(24985,'Chemistry 21','6230','1996-08-16','2016-08-31','Locally Modified Down','11',NULL,NULL,NULL),(24986,'Chemistry 30','3255','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24987,'Chemistry 30','8212','1992-08-16','2016-08-31','Departmentally Developed','12',NULL,NULL,NULL),(24988,'Chemistry 30 (AP)','8237','2000-08-15','2016-08-31','Advanced Placement','12',NULL,NULL,NULL),(24989,'Chemistry 30 (AP)','8276','2016-08-01','0000-00-00','Advanced Placement','12',NULL,NULL,NULL),(24990,'Chemistry 30 (I)','8219','1993-08-16','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(24991,'Chemistry 30 (IB)','8209','1989-08-15','1999-08-15','International Baccalaureate','12',NULL,NULL,NULL),(24992,'Chemistry 30 (IB)','8233','1997-08-16','2016-08-31','International Baccalaureate','12',NULL,NULL,NULL),(24993,'Chemistry 30 (IB)','8279','2016-08-01','0000-00-00','International Baccalaureate','12',NULL,NULL,NULL),(24994,'Chemistry 30 (new)','8256','2015-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(24995,'Chemistry 30A','3256','1988-09-01','1997-08-15','Locally Modified Up','12',NULL,NULL,NULL),(24996,'Chemistry 30A','8227','1996-08-16','2016-08-31','Locally Modified Up','12',NULL,NULL,NULL),(24997,'Chemistry 31','3254','1950-09-01','1997-08-15','Locally Modified Down','12',NULL,NULL,NULL),(24998,'Chemistry 31','8230','1996-08-16','2016-08-31','Locally Modified Down','12',NULL,NULL,NULL),(24999,'Chemistry Preparation AP 30L','8283','2018-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25000,'Child Guidance 1 30L','9511','2016-08-01','0000-00-00','Locally Developed Dual Credit','12',NULL,NULL,NULL),(25001,'Chimie 20','2257','1983-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25002,'Chimie 20','6222','1993-08-15','2015-07-31','Departmentally Developed','11',NULL,NULL,NULL),(25003,'Chimie 30','3257','1983-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25004,'Chimie 30','8222','1993-08-15','2016-08-31','Departmentally Developed','12',NULL,NULL,NULL),(25005,'Chimie 30 (nouveau)','8259','2015-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25006,'Chinese 10','1455','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25007,'Chinese 10L','4029','1996-08-16','2001-08-15','Locally Developed','10',NULL,NULL,NULL),(25008,'Chinese 20','2455','1950-09-01','2001-08-15','Locally Developed','11',NULL,NULL,NULL),(25009,'Chinese 20L','6029','1998-08-16','2001-08-15','Locally Developed','11',NULL,NULL,NULL),(25010,'Chinese 30','3455','1970-09-01','2001-08-15','Locally Developed','12',NULL,NULL,NULL),(25011,'Choral 10','1535','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25012,'Choral 10','1537','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25013,'Choral 10','4529','1997-08-15','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25014,'Choral 10 (I)','4519','1991-08-16','1999-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25015,'Choral 10L','4513','1991-08-15','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(25016,'Choral 18','5606','2017-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(25017,'Choral 20','2535','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25018,'Choral 20','2537','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25019,'Choral 20','6529','1997-08-15','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25020,'Choral 20 (I)','6519','1992-08-16','1999-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25021,'Choral 20L','6513','1991-08-15','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(25022,'Choral 28','7606','2017-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(25023,'Choral 30','3535','1970-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25024,'Choral 30','3537','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25025,'Choral 30','8529','1997-08-15','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25026,'Choral 30 (I)','8519','1993-08-16','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25027,'Choral 30L','8513','1991-08-15','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(25028,'Choral 38','9606','2017-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25029,'Chorale 10L','4535','1999-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25030,'Chorale 20L','6535','1999-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25031,'Chorale 30L','8535','1999-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25032,'Christian Ethics 10','1345','1967-09-01','2000-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25033,'Christian Ethics 10','4804','1998-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25034,'Christian Ethics 11','1350','1950-09-01','2016-07-31','Locally Modified Down','10',NULL,NULL,NULL),(25035,'Christian Ethics 18','5417','1990-09-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(25036,'Christian Ethics 20','2345','1967-09-01','2000-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25037,'Christian Ethics 20','6804','1998-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25038,'Christian Ethics 21','2350','1950-09-01','2016-07-31','Locally Modified Down','11',NULL,NULL,NULL),(25039,'Christian Ethics 28','7417','1990-09-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(25040,'Christian Ethics 30','3345','1967-09-01','2000-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25041,'Christian Ethics 30','8804','1998-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25042,'Christian Ethics 31','3350','1950-09-01','2016-07-31','Locally Modified Down','12',NULL,NULL,NULL),(25043,'Christian Ethics 38','9417','1990-09-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25044,'Clothing 18','5470','2009-08-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(25045,'Clothing 28','7470','2009-08-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(25046,'Clothing 38','9470','2009-08-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(25047,'Clothing And Fashion 30','3667','1983-09-01','2002-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25048,'Clothing And The Person 30','3662','1983-09-01','2002-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25049,'Clothing, Textiles And Fashion 18','5490','2017-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(25050,'Clothing, Textiles And Fashion 20','6862','1999-08-16','2005-07-31','Departmentally Developed','11',NULL,NULL,NULL),(25051,'Clothing, Textiles And Fashion 28','7490','2017-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(25052,'Clothing, Textiles And Fashion 38','9490','2017-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25053,'Clothing, Textiles and Fashion 10','4862','1999-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25054,'Clothing, Textiles and Fashion 20L','7025','2013-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25055,'Clothing, Textiles and Fashion 30','8862','1999-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25056,'Commercial Art 20L','6520','1993-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25057,'Commercial Art 30L','8520','1993-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25058,'Commercial Cooking 10','1913','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25059,'Commercial Cooking 10','1915','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25060,'Commercial Cooking 10','1916','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25061,'Commercial Cooking 10','4906','1990-09-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25062,'Commercial Cooking 10L','4907','1990-09-01','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(25063,'Commercial Cooking 18','5608','2017-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(25064,'Commercial Cooking 20','2914','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25065,'Commercial Cooking 20','2915','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25066,'Commercial Cooking 20','2916','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25067,'Commercial Cooking 20','2917','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25068,'Commercial Cooking 20','6906','1990-09-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25069,'Commercial Cooking 20L','2918','1990-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25070,'Commercial Cooking 20L','6907','1990-09-01','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(25071,'Commercial Cooking 28','7608','2017-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(25072,'Commercial Cooking 30','3913','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25073,'Commercial Cooking 30','3914','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25074,'Commercial Cooking 30','3915','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25075,'Commercial Cooking 30','3916','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25076,'Commercial Cooking 30','3917','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25077,'Commercial Cooking 30','8906','1990-09-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25078,'Commercial Cooking 30L','3918','1990-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25079,'Commercial Cooking 30L','8907','1990-09-01','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(25080,'Commercial Cooking 38','9608','2017-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25081,'Commercial Cooking II 10','1914','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25082,'Communication Media 10','5015','2010-08-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25083,'Communication Media 18','5609','2017-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(25084,'Communication Media 20','7015','2010-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25085,'Communication Media 28','7609','2017-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(25086,'Communication Media 30','9015','2010-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25087,'Communication Media 38','9609','2017-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25088,'Communication Production Tech 10','4955','1998-08-16','2013-07-31','Departmentally Developed','10',NULL,NULL,NULL),(25089,'Communication Production Tech 10','4969','1998-08-16','1999-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25090,'Communication Production Tech 20','6955','1998-08-16','2013-07-31','Departmentally Developed','11',NULL,NULL,NULL),(25091,'Communication Production Tech 20','6969','1998-08-16','1999-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25092,'Communication Production Tech 30','8955','1998-08-16','2013-07-31','Departmentally Developed','12',NULL,NULL,NULL),(25093,'Communication Production Tech 30','8969','1998-08-16','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25094,'Communication Production Technology 20L','6990','1999-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25095,'Communication Skills 10L','1092','1990-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25096,'Communication Skills 20L','2093','1990-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25097,'Communication Studies 20','6026','1996-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25098,'Communication radiophonique 20L','6057','2000-01-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25099,'Communications 10','1730','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25100,'Communications 20','2730','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25101,'Communications 30','3730','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25102,'Composition 10','1120','1948-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25103,'Composition 10A','1121','1950-09-01','1997-08-15','Locally Modified Up','10',NULL,NULL,NULL),(25104,'Composition 11','1119','1950-09-01','1997-08-15','Locally Modified Down','10',NULL,NULL,NULL),(25105,'Composition 20','2120','1946-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25106,'Composition 20A','2121','1950-09-01','1997-08-15','Locally Modified Up','11',NULL,NULL,NULL),(25107,'Composition 21','2119','1950-09-01','1997-08-15','Locally Modified Down','11',NULL,NULL,NULL),(25108,'Composition 30','3120','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25109,'Composition 30A','3121','1950-09-01','1997-08-15','Locally Modified Up','12',NULL,NULL,NULL),(25110,'Composition 31','3119','1950-09-01','1997-08-15','Locally Modified Down','12',NULL,NULL,NULL),(25111,'Comprehensive School Community Health 10L','4618','2014-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25112,'Comptabilite 10L','4416','1998-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25113,'Comptabilite 20L','6416','1998-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25114,'Comptabilite 30L','8416','1998-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25115,'Computer Animation 20L','6991','1999-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25116,'Computer Applications 10','1608','1984-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25117,'Computer Applications 10','1612','1989-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25118,'Computer Applications 20','2608','1984-10-02','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25119,'Computer Applications 20','2612','1989-06-23','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25120,'Computer Applications 30L','3612','1991-08-21','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25121,'Computer Literacy 10','1609','1981-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25122,'Computer Networking 10L','4997','2000-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25123,'Computer Networking 20L','6997','2000-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25124,'Computer Networking 30L','8997','2000-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25125,'Computer Programming 30L','8703','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25126,'Computer Science 10','1610','1950-09-01','2002-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25127,'Computer Science 10','1611','1979-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25128,'Computer Science 20','2610','1950-09-01','2002-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25129,'Computer Science 20','2611','1972-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25130,'Computer Science 20','6702','1997-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25131,'Computer Science 28','7611','2017-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(25132,'Computer Science 30','3610','1950-09-01','2002-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25133,'Computer Science 30','8702','1997-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25134,'Computer Science 30 (AP)','8704','2000-08-15','0000-00-00','Advanced Placement','12',NULL,NULL,NULL),(25135,'Computer Science 38','9611','2017-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25136,'Computer Technician 10L','4938','1997-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25137,'Computers & Integrated Technology 20L','7208','1995-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25138,'Conduite automobile 10','4606','2005-08-01','0000-00-00','External','10',NULL,NULL,NULL),(25139,'Connections 20L','6616','2012-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25140,'Connections 30L','8616','2014-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25141,'Construction 10','1818','1970-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25142,'Construction 10','1819','1985-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25143,'Construction 10','1820','1950-09-01','2002-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25144,'Construction 10','1821','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25145,'Construction 10','1893','1988-02-10','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25146,'Construction 10L','1884','1989-10-19','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(25147,'Construction 20','2818','1970-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25148,'Construction 20','2819','1985-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25149,'Construction 20','2820','1950-09-01','2002-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25150,'Construction 20','2821','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25151,'Construction 20','2822','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25152,'Construction 20','2893','1988-02-10','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25153,'Construction 20','2933','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25154,'Construction 20','2934','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25155,'Construction 20','2935','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25156,'Construction 20','2936','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25157,'Construction 20','2937','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25158,'Construction 20L','2884','1989-10-19','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(25159,'Construction 30','3818','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25160,'Construction 30','3819','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25161,'Construction 30','3820','1950-09-01','2002-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25162,'Construction 30','3821','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25163,'Construction 30','3822','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25164,'Construction 30','3893','1988-02-10','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25165,'Construction 30','3934','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25166,'Construction 30','3935','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25167,'Construction 30','3936','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25168,'Construction 30','3937','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25169,'Construction 30','3976','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25170,'Construction 30','3977','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25171,'Construction 30L','3884','1989-10-19','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(25172,'Construction A 10L','1885','1989-10-19','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25173,'Construction A 20L','2885','1989-10-19','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25174,'Construction A 30L','3885','1989-10-19','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25175,'Construction B 10L','4926','1993-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25176,'Construction B 20L','6926','1993-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25177,'Construction B 30L','8926','1993-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25178,'Construction Technology For Women 10L','4936','1998-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25179,'Construction Technology For Women 20L','6936','1996-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25180,'Construction Technology For Women 30L','8936','1997-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25181,'Construction and Carpentry 10','4980','1999-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25182,'Construction and Carpentry 18','5467','2007-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(25183,'Construction and Carpentry 20','6980','1999-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25184,'Construction and Carpentry 28','7467','2007-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(25185,'Construction and Carpentry 30','8980','1999-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25186,'Construction and Carpentry 38','9467','2007-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25187,'Consumer Economics 10','1743','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25188,'Consumer Economics 20','2743','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25189,'Consumer Education 20','2155','1975-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25190,'Consumer Studies 10L','1161','1990-08-15','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25191,'Consumer Studies 20','2160','1977-09-01','2000-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25192,'Contemporary Oral Indian Literature 10L','1140','1989-09-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25193,'Contemporary Oral Indian Literature 20L','2142','1990-05-11','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25194,'Contemporary Oral Indian Literature 30L','3142','1990-02-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25195,'Content Reading Exploration 10L','4090','2009-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25196,'Cosmetology 10','1908','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25197,'Cosmetology 10','1909','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25198,'Cosmetology 10','1910','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25199,'Cosmetology 10','1911','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25200,'Cosmetology 10','4200','1990-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25201,'Cosmetology 10','4901','1990-09-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25202,'Cosmetology 10L','4902','1990-09-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25203,'Cosmetology 18','5450','2000-08-16','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(25204,'Cosmetology 20','2906','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25205,'Cosmetology 20','2907','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25206,'Cosmetology 20','2908','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25207,'Cosmetology 20','2909','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25208,'Cosmetology 20','2910','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25209,'Cosmetology 20','2911','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25210,'Cosmetology 20','2912','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25211,'Cosmetology 20','6200','1990-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25212,'Cosmetology 20','6901','1990-09-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25213,'Cosmetology 20L','2904','1990-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25214,'Cosmetology 20L','6902','1990-09-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25215,'Cosmetology 28','7450','2000-08-16','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(25216,'Cosmetology 30','3905','1975-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25217,'Cosmetology 30','3906','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25218,'Cosmetology 30','3907','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25219,'Cosmetology 30','3908','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25220,'Cosmetology 30','3909','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25221,'Cosmetology 30','3910','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25222,'Cosmetology 30','3911','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25223,'Cosmetology 30','3912','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25224,'Cosmetology 30','8200','1990-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25225,'Cosmetology 30','8901','1990-09-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25226,'Cosmetology 30L','3904','1990-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25227,'Cosmetology 30L','8902','1990-09-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25228,'Cosmetology 38','9450','2000-08-16','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25229,'Cours de perfectionnement du franÃ§ais 20L','6053','1998-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25230,'Cours de perfectionnement du franÃ§ais10L','4053','1998-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25231,'Creative Writing 10','1122','1986-07-28','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25232,'Creative Writing 10L','1124','1990-09-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25233,'Creative Writing 20','2122','1986-07-28','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25234,'Creative Writing 20','6024','1996-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25235,'Creative Writing 20L','2124','1990-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25236,'Creative Writing 30','3122','1986-07-28','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25237,'Creative Writing 30L','3124','1990-09-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25238,'Cree 10','1465','1988-06-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25239,'Cree 10L','1466','1990-08-23','2009-07-31','Locally Developed','10',NULL,NULL,NULL),(25240,'Cree 20','2465','1988-06-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25241,'Cree 20L','2466','1990-08-23','2009-07-31','Locally Developed','11',NULL,NULL,NULL),(25242,'Cree 30','3465','1988-06-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25243,'Cree 30L','3466','1990-08-23','2009-07-31','Locally Developed','12',NULL,NULL,NULL),(25244,'Cree A 10 L','4071','2002-08-16','2009-07-31','Locally Developed','10',NULL,NULL,NULL),(25245,'Cree A 20 L','6071','2002-08-16','2009-07-31','Locally Developed','11',NULL,NULL,NULL),(25246,'Cree A 30 L','8071','2002-08-16','2009-07-31','Locally Developed','12',NULL,NULL,NULL),(25247,'Cree B 10 L','4072','2002-08-16','2007-07-31','Locally Developed','10',NULL,NULL,NULL),(25248,'Cree B 20 L','6072','2002-08-16','2007-07-31','Locally Developed','11',NULL,NULL,NULL),(25249,'Cree B 30 L','8072','2002-08-16','2007-07-31','Locally Developed','12',NULL,NULL,NULL),(25250,'Cree Culture Program 10L','4083','2005-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25251,'Cree Culture Program 20L','6083','2005-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25252,'Cree Culture Program 30L','8083','2005-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25253,'Cree Traditional Pursuits 10L','4522','1993-08-15','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25254,'Cree Traditional Pursuits 20L','6522','1994-08-15','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25255,'Cree Traditional Pursuits 30L','8522','1994-08-15','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25256,'Critical Thinking 20L','7333','2006-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25257,'CrÃ©ation LittÃ©raire 10L','4098','2013-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25258,'Cultural Arts 10L','5322','1999-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25259,'Cultural Arts 20L','7322','1999-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25260,'Cultural Arts 30L','9322','1999-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25261,'Cultural animateur 20','2516','1987-01-23','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25262,'Dactylographie 10','1757','1983-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25263,'Dactylographie 20','2757','1983-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25264,'Dactylographie 30','3757','1983-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25265,'Dance 10','4528','1997-08-15','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25266,'Dance 20','6528','1997-08-15','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25267,'Dance 30','8528','1997-08-15','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25268,'Data Processing 20','2735','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25269,'Data Processing 20','2736','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25270,'Data Processing 20L','2734','1990-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25271,'Data Processing 30','3735','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25272,'Data Processing 30','3736','1986-07-28','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25273,'Data Processing 30L','3734','1990-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25274,'Deaf Studies 10 SD','1285','1984-06-07','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25275,'Dene 10L','1467','1989-06-22','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25276,'Dene 20L','2467','1991-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25277,'Dene 30L','3467','1996-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25278,'Denesuline A 10L','4075','2003-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25279,'Denesuline A 20L','6075','2003-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25280,'Denesuline A 30L','8075','2003-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25281,'Denesuline B 10L','4076','2003-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25282,'Denesuline B 20L','6076','2003-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25283,'Denesuline B 30L','8076','2003-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25284,'Design Studies 10','4948','1995-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25285,'Design Studies 10','4968','1998-08-16','1999-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25286,'Design Studies 20','6948','1997-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25287,'Design Studies 20','6968','1998-08-16','1999-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25288,'Design Studies 30','8948','1997-08-16','2012-07-31','Departmentally Developed','12',NULL,NULL,NULL),(25289,'Design Studies 30','8968','1998-08-16','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25290,'Design technique et industriel 10','5104','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25291,'Design technique et industriel 20','7104','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25292,'Design technique et industriel 30','9104','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25293,'Developmental English Language Arts 10L','4080','2004-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25294,'Developmental English Language Arts 20L','6080','2005-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25295,'Developmental Studies 30L','9312','1998-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25296,'Digital Citizenship 10L','5339','2013-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25297,'Digital Citizenship 20L','7339','2013-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25298,'Distributive Education 30','3758','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25299,'Distributive Education 30','3759','1989-11-16','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25300,'Distributive Education 30','3760','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25301,'Drafting & Computer-Aided Design 10','4977','1999-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25302,'Drafting & Computer-Aided Design 18','5491','2017-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(25303,'Drafting & Computer-Aided Design 20','6977','1999-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25304,'Drafting & Computer-Aided Design 28','7491','2017-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(25305,'Drafting & Computer-Aided Design 30','8977','1999-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25306,'Drafting & Computer-Aided Design 38','9491','2017-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25307,'Drafting 10','1823','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25308,'Drafting 10','1824','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25309,'Drafting 10','1825','1950-09-01','2002-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25310,'Drafting 10','1826','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25311,'Drafting 10','1839','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25312,'Drafting 10','1840','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25313,'Drafting 10','1894','1988-02-10','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25314,'Drafting 10','1924','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25315,'Drafting 10','1925','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25316,'Drafting 10','1926','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25317,'Drafting 10','4947','1997-08-16','2011-07-31','Departmentally Developed','10',NULL,NULL,NULL),(25318,'Drafting 10L','1886','1989-10-19','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(25319,'Drafting 10L','1887','1989-10-19','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(25320,'Drafting 20','2823','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25321,'Drafting 20','2825','1950-09-01','2002-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25322,'Drafting 20','2826','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25323,'Drafting 20','2827','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25324,'Drafting 20','2840','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25325,'Drafting 20','2894','1988-02-10','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25326,'Drafting 20','2924','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25327,'Drafting 20','2925','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25328,'Drafting 20','2926','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25329,'Drafting 20','2927','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25330,'Drafting 20','6947','1997-08-16','2011-07-31','Departmentally Developed','11',NULL,NULL,NULL),(25331,'Drafting 20L','2887','1989-10-19','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(25332,'Drafting 30','3823','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25333,'Drafting 30','3825','1950-09-01','2002-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25334,'Drafting 30','3826','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25335,'Drafting 30','3827','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25336,'Drafting 30','3894','1988-02-10','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25337,'Drafting 30','3923','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25338,'Drafting 30','3924','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25339,'Drafting 30','3925','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25340,'Drafting 30','3926','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25341,'Drafting 30','3927','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25342,'Drafting 30','8947','1997-08-16','2011-07-31','Departmentally Developed','12',NULL,NULL,NULL),(25343,'Drafting 30L','3886','1989-10-19','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(25344,'Drafting 30L','3887','1989-10-19','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(25345,'Drafting B 20','2841','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25346,'Drafting C 30','3828','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25347,'Drafting C 30','3840','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25348,'Drafting C 30','3841','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25349,'Drafting II 20','2824','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25350,'Drafting II 30','3824','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25351,'Drafting and Design 18','5478','2009-08-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(25352,'Drafting and Design 28','7478','2009-08-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(25353,'Drafting and Design 38','9478','2009-08-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(25354,'Drafting.20L','2886','1989-10-19','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(25355,'Drama 10','1515','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25356,'Drama 10','4525','1996-08-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25357,'Drama 18','5471','2009-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(25358,'Drama 20','2515','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25359,'Drama 20','6525','1996-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25360,'Drama 28','7471','2009-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(25361,'Drama 30','3515','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25362,'Drama 30','8525','1996-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25363,'Drama 38','9471','2009-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25364,'Drama II 30','3514','1970-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25365,'Driver Education 10','1336','1972-09-01','1997-08-15','External','10',NULL,NULL,NULL),(25366,'Driver Education 10','4605','1996-08-15','0000-00-00','External','10',NULL,NULL,NULL),(25367,'Droit 30','8350','2010-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25368,'Drumming and Singing 10L','5323','2001-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25369,'Drumming and Singing 20L','7323','2001-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25370,'Drumming and Singing 30L','9323','2001-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25371,'DÃ«nesulinÃ© 10L','4077','2003-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25372,'DÃ«nesulinÃ© 20L','6077','2003-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25373,'DÃ«nesulinÃ© 30L','8077','2003-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25374,'ESL A 10L','4014','1992-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25375,'ESL B 10L','4056','1999-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25376,'Earth Science 30','8251','2013-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25377,'Economics 20','2140','1950-09-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25378,'Economics 20 (I)','6317','1991-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25379,'Economics 21','2141','1978-09-01','2016-07-31','Locally Modified Down','11',NULL,NULL,NULL),(25380,'Economics 30','3140','1950-09-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25381,'Economics 30','3143','1978-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25382,'Economics 30','3743','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25383,'Economics 30A','3141','1950-09-01','0000-00-00','Locally Modified Up','12',NULL,NULL,NULL),(25384,'Economics 30L (I)','8317','1991-02-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25385,'Economics 31','3139','1950-09-01','2016-07-31','Locally Modified Down','12',NULL,NULL,NULL),(25386,'Economics Of The Home 30','3670','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25387,'Economics Of The Home 31','3671','1950-09-01','1997-08-15','Locally Modified Down','12',NULL,NULL,NULL),(25388,'Economie 20','6308','1992-08-16','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25389,'Economie 30','8308','1992-08-15','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25390,'Economie 30L','8334','1998-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25391,'Economie domestique 10','1647','1983-09-01','2002-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25392,'Economie domestique 18','5446','1996-08-16','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(25393,'Economie domestique 28','7446','1996-08-16','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(25394,'Economie domestique 38','9446','1996-08-16','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(25395,'Education chretienne 10','1347','1983-09-01','2011-07-31','Departmentally Developed','10',NULL,NULL,NULL),(25396,'Education chretienne 20','2347','1983-09-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25397,'Education chretienne 30','3347','1983-09-01','2011-07-31','Departmentally Developed','12',NULL,NULL,NULL),(25398,'Education physique 10','1317','1983-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25399,'Education physique 20','2317','1983-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25400,'Education physique 30','3317','1983-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25401,'Electric Arc Welding 30','8944','1997-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25402,'Electrical 10','1938','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25403,'Electrical 10','1940','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25404,'Electrical 10','1941','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25405,'Electrical 10','1942','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25406,'Electrical 20','2838','1987-05-07','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25407,'Electrical 20','2938','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25408,'Electrical 20','2939','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25409,'Electrical 20','2940','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25410,'Electrical 20','2941','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25411,'Electrical 20','2942','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25412,'Electrical 20','7121','2001-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25413,'Electrical 28','7612','2018-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(25414,'Electrical 30','3838','1987-05-07','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25415,'Electrical 30','3939','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25416,'Electrical 30','3940','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25417,'Electrical 30','3941','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25418,'Electrical 30','3942','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25419,'Electrical A 30','9121','2001-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25420,'Electrical A 38','9612','2018-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25421,'Electrical B 30','9122','2001-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25422,'Electrical B 38','9613','2018-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25423,'Electrical and Electronics 10','4956','1998-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25424,'Electrical and Electronics 18','5611','2018-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(25425,'Electrical and Electronics 18','5612','2018-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(25426,'Electrical and Electronics A 38','9492','2017-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25427,'Electrical and Electronics B 38','9493','2017-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25428,'Electricity 10','1859','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25429,'Electricity 10','1860','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25430,'Electricity 10L','1882','1989-10-19','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(25431,'Electricity 10L','1883','1989-09-01','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(25432,'Electricity 20','2860','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25433,'Electricity 20L','2882','1989-10-19','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(25434,'Electricity 20L','2883','1989-10-19','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(25435,'Electricity 30L','3882','1989-10-19','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(25436,'Electricity 30L','3883','1989-10-19','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(25437,'Electricity And Electronics 20','6956','1998-08-16','2002-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25438,'Electricity And Electronics 30','8956','1998-08-16','2002-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25439,'Electricity C 30','3859','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25440,'Electricity C 30','3860','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25441,'Electricity C 30','3861','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25442,'Electricity and Electronics 18','5472','2009-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(25443,'Electricity and Electronics 28','7472','2009-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(25444,'Electricity and Electronics 38','9472','2009-08-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(25445,'Electricity-Electronics 10','1813','1970-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25446,'Electricity-Electronics 10','1814','1977-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25447,'Electricity-Electronics 10','1815','1950-09-01','2003-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25448,'Electricity-Electronics 10','1816','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25449,'Electricity-Electronics 10','1892','1988-02-10','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25450,'Electricity-Electronics 20','2813','1985-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25451,'Electricity-Electronics 20','2815','1950-09-01','2003-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25452,'Electricity-Electronics 20','2816','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25453,'Electricity-Electronics 20','2817','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25454,'Electricity-Electronics 20','2892','1988-02-10','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25455,'Electricity-Electronics 30','3813','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25456,'Electricity-Electronics 30','3815','1950-09-01','2003-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25457,'Electricity-Electronics 30','3816','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25458,'Electricity-Electronics 30','3817','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25459,'Electricity-Electronics 30','3892','1988-02-10','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25460,'Electricity-Electronics B 20','2814','1985-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25461,'Electricity-Electronics B 30','3814','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25462,'Electricity/Electronics 10','4966','1998-08-16','1999-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25463,'Electricity/Electronics 20','6966','1998-08-16','1999-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25464,'Electricity/Electronics 30','8966','1998-08-16','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25465,'Electronics 10','1945','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25466,'Electronics 10','1946','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25467,'Electronics 10','1947','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25468,'Electronics 10L','1868','1990-01-14','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(25469,'Electronics 20','2839','1987-05-07','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25470,'Electronics 20','2943','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25471,'Electronics 20','2944','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25472,'Electronics 20','2945','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25473,'Electronics 20','2946','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25474,'Electronics 20','2947','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25475,'Electronics 20','7123','2001-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25476,'Electronics 20L','2868','1990-01-24','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(25477,'Electronics 28','7613','2018-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(25478,'Electronics 30','3839','1987-05-07','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25479,'Electronics 30','3943','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25480,'Electronics 30','3944','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25481,'Electronics 30','3945','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25482,'Electronics 30','3946','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25483,'Electronics 30','3947','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25484,'Electronics 30L','3868','1990-01-24','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(25485,'Electronics A 30','9123','2001-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25486,'Electronics A 38','9614','2018-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25487,'Electronics B 30','9124','2001-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25488,'Electronics B 38','9615','2018-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25489,'Emergency Services 20L','7039','2015-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25490,'Emergency Services 30L','9039','2015-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25491,'Emergency Services Response Training 10L','5028','2013-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25492,'Emergency Services Response Training 20L','7028','2013-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25493,'Emergency Services Response Training 30L','9028','2014-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25494,'Employee Relations 20','2774','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25495,'Employee Relations 20','2775','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25496,'Employment Development 10L','5304','1996-08-16','2000-08-15','Locally Developed','10',NULL,NULL,NULL),(25497,'Employment Essential Skills 30L','9338','2012-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25498,'Energies et mines 10','5106','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25499,'Energies et mines 20','7106','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25500,'Energies et mines 30','9106','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25501,'Energy and Mines 10','4982','1999-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25502,'Energy and Mines 20','6982','1999-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25503,'Energy and Mines 30','8982','1999-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25504,'English 10','1090','1975-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25505,'English 10A','1091','1975-09-01','1997-08-15','Locally Modified Up','10',NULL,NULL,NULL),(25506,'English 11','1089','1975-09-01','1997-08-15','Locally Modified Down','10',NULL,NULL,NULL),(25507,'English 20','2090','1975-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25508,'English 20A','2091','1975-09-01','1997-08-15','Locally Modified Up','11',NULL,NULL,NULL),(25509,'English 21','2089','1975-09-01','1997-08-15','Locally Modified Down','11',NULL,NULL,NULL),(25510,'English 30','3090','1975-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25511,'English 30A','3091','1975-09-01','1997-08-15','Locally Modified Up','12',NULL,NULL,NULL),(25512,'English 31','3089','1975-09-01','1997-08-15','Locally Modified Down','12',NULL,NULL,NULL),(25513,'English A 10','1080','1978-09-01','1999-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25514,'English A 10 (I)','4012','1991-08-16','1999-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25515,'English A 10 (IB)','4001','1988-08-15','1999-08-15','International Baccalaureate','10',NULL,NULL,NULL),(25516,'English A 10 SD','1095','1986-06-06','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25517,'English A 10A','1081','1978-09-01','2000-08-15','Locally Modified Up','10',NULL,NULL,NULL),(25518,'English A 10L','1082','1990-09-01','1999-08-15','Locally Developed','10',NULL,NULL,NULL),(25519,'English A 11','1079','1978-09-01','1999-08-15','Locally Modified Down','10',NULL,NULL,NULL),(25520,'English A 20','2080','1978-09-01','2000-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25521,'English A 20 (I)','6012','1991-08-16','2000-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25522,'English A 20 (IB)','6001','1989-08-15','2000-08-15','International Baccalaureate','11',NULL,NULL,NULL),(25523,'English A 20 SD','2095','1986-06-06','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25524,'English A 20A','2081','1978-09-01','2000-08-15','Locally Modified Up','11',NULL,NULL,NULL),(25525,'English A 21','2079','1978-09-01','2000-08-15','Locally Modified Down','11',NULL,NULL,NULL),(25526,'English A 30','3080','1978-09-01','2004-08-31','Departmentally Developed','12',NULL,NULL,NULL),(25527,'English A 30 (I)','8012','1993-08-16','2001-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25528,'English A 30 (IB)','8001','1989-08-15','2001-08-15','International Baccalaureate','12',NULL,NULL,NULL),(25529,'English A 30 SD','3095','1986-06-06','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25530,'English A 30A','3081','1978-09-01','2001-08-15','Locally Modified Up','12',NULL,NULL,NULL),(25531,'English A 31','3079','1978-09-01','2001-08-15','Locally Modified Down','12',NULL,NULL,NULL),(25532,'English B 10','1085','1978-09-01','1999-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25533,'English B 10 (I)','4013','1991-08-16','1999-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25534,'English B 10 (IB)','4002','1988-08-15','1999-08-15','International Baccalaureate','10',NULL,NULL,NULL),(25535,'English B 10 SD','1100','1984-06-06','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25536,'English B 10A','1086','1978-09-01','1999-08-15','Locally Modified Up','10',NULL,NULL,NULL),(25537,'English B 10L','1083','1990-09-01','1999-08-15','Locally Developed','10',NULL,NULL,NULL),(25538,'English B 11','1084','1978-09-01','1999-08-15','Locally Modified Down','10',NULL,NULL,NULL),(25539,'English B 20','2085','1978-09-01','2000-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25540,'English B 20 (I)','6013','1991-08-16','2000-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25541,'English B 20 (IB)','6002','1989-08-15','2000-08-15','International Baccalaureate','11',NULL,NULL,NULL),(25542,'English B 20 SD','2100','1984-06-06','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25543,'English B 20A','2086','1978-09-01','2000-08-15','Locally Modified Up','11',NULL,NULL,NULL),(25544,'English B 21','2084','1978-09-01','2000-08-15','Locally Modified Down','11',NULL,NULL,NULL),(25545,'English B 30','3085','1978-09-01','2004-08-31','Departmentally Developed','12',NULL,NULL,NULL),(25546,'English B 30 (I)','8013','1993-08-16','2001-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25547,'English B 30 (IB)','8002','1989-08-15','2001-08-15','International Baccalaureate','12',NULL,NULL,NULL),(25548,'English B 30 SD','3100','1986-06-06','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25549,'English B 30A','3086','1978-09-01','2001-08-15','Locally Modified Up','12',NULL,NULL,NULL),(25550,'English B 31','3084','1978-09-01','2001-08-15','Locally Modified Down','12',NULL,NULL,NULL),(25551,'English Language Arts 20','6017','1996-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25552,'English Language Arts 20 (IB)','6032','1997-08-16','0000-00-00','International Baccalaureate','11',NULL,NULL,NULL),(25553,'English Language Arts 20A','6054','1999-08-16','0000-00-00','Locally Modified Up','11',NULL,NULL,NULL),(25554,'English Language Arts 20A (2012)','6104','2016-08-01','0000-00-00','Locally Modified Up','11',NULL,NULL,NULL),(25555,'English Language Arts 21','6049','1998-08-16','0000-00-00','Locally Modified Down','11',NULL,NULL,NULL),(25556,'English Language Arts 21 (2012)','6102','2018-08-01','0000-00-00','Locally Modified Down','11',NULL,NULL,NULL),(25557,'English Language Arts 28','7482','2016-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(25558,'English Language Arts A 10','4017','1995-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25559,'English Language Arts A 10 (IB)','4032','1997-08-16','0000-00-00','International Baccalaureate','10',NULL,NULL,NULL),(25560,'English Language Arts A 10A','4054','1999-08-15','0000-00-00','Locally Modified Up','10',NULL,NULL,NULL),(25561,'English Language Arts A 10A (2011)','4104','2016-08-01','0000-00-00','Locally Modified Up','10',NULL,NULL,NULL),(25562,'English Language Arts A 11','4049','1998-08-16','0000-00-00','Locally Modified Down','10',NULL,NULL,NULL),(25563,'English Language Arts A 11 (2011)','4102','2018-08-01','0000-00-00','Locally Modified Down','10',NULL,NULL,NULL),(25564,'English Language Arts A 18','5482','2016-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(25565,'English Language Arts A 30','8017','1997-08-15','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25566,'English Language Arts A 30 (AP)','8064','2000-08-15','0000-00-00','Advanced Placement','12',NULL,NULL,NULL),(25567,'English Language Arts A 30 (IB)','8032','1997-08-16','0000-00-00','International Baccalaureate','12',NULL,NULL,NULL),(25568,'English Language Arts A 30A','8054','2000-08-16','0000-00-00','Locally Modified Up','12',NULL,NULL,NULL),(25569,'English Language Arts A 30A (2013)','8104','2016-08-01','0000-00-00','Locally Modified Up','12',NULL,NULL,NULL),(25570,'English Language Arts A 31','8049','2000-08-16','2016-07-31','Locally Modified Down','12',NULL,NULL,NULL),(25571,'English Language Arts A 31(2013)','8102','2016-08-01','0000-00-00','Locally Modified Down','12',NULL,NULL,NULL),(25572,'English Language Arts A 38','9482','2016-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25573,'English Language Arts B 10','4018','1995-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25574,'English Language Arts B 10 (IB)','4033','1997-08-16','0000-00-00','International Baccalaureate','10',NULL,NULL,NULL),(25575,'English Language Arts B 10A','4055','1999-08-15','0000-00-00','Locally Modified Up','10',NULL,NULL,NULL),(25576,'English Language Arts B 10A (2011)','4105','2016-08-01','0000-00-00','Locally Modified Up','10',NULL,NULL,NULL),(25577,'English Language Arts B 11','4050','1998-08-16','0000-00-00','Locally Modified Down','10',NULL,NULL,NULL),(25578,'English Language Arts B 11 (2011)','4103','2018-08-01','0000-00-00','Locally Modified Down','10',NULL,NULL,NULL),(25579,'English Language Arts B 18','5483','2016-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(25580,'English Language Arts B 30','8018','1997-08-15','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25581,'English Language Arts B 30 (AP)','8065','2000-08-15','0000-00-00','Advanced Placement','12',NULL,NULL,NULL),(25582,'English Language Arts B 30 (IB)','8033','1997-08-16','0000-00-00','International Baccalaureate','12',NULL,NULL,NULL),(25583,'English Language Arts B 30A','8055','2000-08-16','0000-00-00','Locally Modified Up','12',NULL,NULL,NULL),(25584,'English Language Arts B 30A (2013)','8105','2016-08-01','0000-00-00','Locally Modified Up','12',NULL,NULL,NULL),(25585,'English Language Arts B 31','8050','2000-08-16','2016-07-31','Locally Modified Down','12',NULL,NULL,NULL),(25586,'English Language Arts B 31 (2013)','8103','2016-08-01','0000-00-00','Locally Modified Down','12',NULL,NULL,NULL),(25587,'English Language Arts B 38','9483','2016-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25588,'English Literature and Composition 20L','6106','2017-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25589,'English as a Second Language 20L','6014','2006-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25590,'English as an Additional Language 10L','4093','2009-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25591,'English as an Additional Language 20L','6088','2008-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25592,'English as an Additional Language A 10L','4088','2008-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25593,'English as an Additional Language A 20L','6096','2011-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25594,'English as an Additional Language B 10L','4089','2008-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25595,'English as an Additional Language B 20L','6097','2011-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25596,'Enseignement moral 10L','4802','1995-08-15','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25597,'Enseignement moral 20L','6802','1995-08-15','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25598,'Enseignement moral 30L','8802','1996-08-15','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25599,'Enseignement technique et profession. 18','5432','1991-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(25600,'Enseignement technique et profession. 28','7432','1991-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(25601,'Enseignement technique et profession. 38','9432','1991-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(25602,'Entrepreneuriat 10L','5213','2000-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25603,'Entrepreneuriat 20L','7213','2000-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25604,'Entrepreneuriat 30L','9213','2000-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25605,'Entrepreneurship 18','5444','1996-08-16','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(25606,'Entrepreneurship 28','7444','1996-08-16','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(25607,'Entrepreneurship 30','9201','1991-05-27','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25608,'Entrepreneurship 38','9444','1996-08-16','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25609,'Entrepreneurship: Venture Planning 20L','7336','2011-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25610,'Entrepreneurship: Venture Planning 30L','9336','2010-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25611,'Entreprise et innovation 10','5107','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25612,'Entreprise et innovation 20','7107','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25613,'Entreprise et innovation 30','9107','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25614,'Environmental Awareness 30L','8253','2012-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25615,'Environmental Education 20L','6205','1991-08-21','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25616,'Environmental Science 20','6246','2013-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25617,'Environmental Science 20 (IB)','6261','2014-08-01','0000-00-00','International Baccalaureate','11',NULL,NULL,NULL),(25618,'Environmental Science 20A','6268','2015-08-01','0000-00-00','Locally Modified Up','11',NULL,NULL,NULL),(25619,'Environmental Science 21','6266','2016-01-01','0000-00-00','Locally Modified Down','11',NULL,NULL,NULL),(25620,'Environmental Science 28','7486','2017-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(25621,'Environmental Studies 20','2237','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25622,'Environmental Studies 30','3237','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25623,'Environmental Studies 30L','8242','2007-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25624,'Environmental Systems and Societies (IB) 20L','6244','2010-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25625,'Environmental Systems and Societies (IB) 30L','8244','2010-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25626,'Equine Studies 10L','5341','2014-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25627,'Equine Studies 20L','7341','2015-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25628,'Equine Studies 30L','9341','2015-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25629,'Espagnol 10','4094','2010-08-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25630,'Espagnol 10L','4030','1994-08-15','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25631,'Espagnol 20','6094','2010-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25632,'Espagnol 20L','6030','1995-08-15','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25633,'Espagnol 30','8094','2010-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25634,'Espagnol 30L','8030','1995-08-15','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25635,'Espagnol 30L','8035','1997-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25636,'Ethics 10','1348','1980-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25637,'Ethics 11','1349','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25638,'Ethics 20','2348','1980-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25639,'Ethics 21','2349','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25640,'Ethics 30','3348','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25641,'Ethics 31','3349','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25642,'Etudes commerciales 18','5431','1991-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(25643,'Etudes commerciales 28','7431','1991-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(25644,'Etudes commerciales 38','9431','1991-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(25645,'Etudes familiales 18','5433','1991-09-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(25646,'Etudes familiales 28','7433','1991-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(25647,'Etudes familiales 38','9433','1991-09-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25648,'Etudes sociales 10','1138','1983-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25649,'Etudes sociales 18','5421','1991-09-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(25650,'Etudes sociales 20','2138','1983-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25651,'Etudes sociales 28','7421','1991-09-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(25652,'Etudes sociales 30','3138','1983-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25653,'Etudes sociales 38','9421','1991-09-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25654,'Exercise Science 30L','8607','2006-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25655,'Experience de travail 18','5425','1991-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(25656,'Experience de travail 28','7425','1991-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(25657,'Experience de travail 38','9425','1991-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(25658,'Experience de travail A 10','5308','1997-08-16','2003-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25659,'Experience de travail A 18','5426','1991-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(25660,'Experience de travail A 20','7308','1997-08-16','2003-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25661,'Experience de travail A 28','7426','1991-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(25662,'Experience de travail A 30','9308','1997-08-16','2003-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25663,'Experience de travail A 38','9426','1991-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(25664,'Experience de travail B 10','5309','1997-08-16','2003-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25665,'Experience de travail B 18','5427','1991-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(25666,'Experience de travail B 20','7309','1997-08-16','2003-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25667,'Experience de travail B 28','7427','1991-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(25668,'Experience de travail B 30','9309','1997-08-16','2003-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25669,'Experience de travail B 38','9427','1991-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(25670,'Explor de carriÃ¨res et d\'emplois 10','5329','2003-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25671,'Explor de carriÃ¨res et d\'emplois 20','7329','2003-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25672,'Explor de carriÃ¨res et d\'emplois A 30','9329','2003-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25673,'Explor de carriÃ¨res et d\'emplois B 30','9330','2003-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25674,'Exploration 10','1800','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25675,'Exploration de carrieres et d emplois B 38','9466','2006-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25676,'Exploration de carrieres et d\'emplois 18','5455','2006-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(25677,'Exploration de carrieres et d\'emplois 28','7455','2006-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(25678,'Exploration de carrieres et d\'emplois A 38','9455','2006-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25679,'Exploring Trades & Technology 10L','4933','1995-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25680,'Exploring Trades & Technology 20L','6933','1996-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25681,'Exploring Trades & Technology 30L','8933','1997-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25682,'Exploring Trades & Technology A 20L','6975','1998-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25683,'Exploring Trades & Technology A 30L','8975','1998-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25684,'Exploring Trades & Technology B 20L','6976','1998-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25685,'Exploring Trades & Technology B 30L','8976','1998-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25686,'Fabrication 10','5108','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25687,'Fabrication 20','7108','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25688,'Fabrication 30','9108','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25689,'Family Finance 30','3685','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25690,'Family Finance B 30','3684','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25691,'Family Life 10','1680','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25692,'Family Life 10','1681','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25693,'Family Life 20','2679','1989-06-22','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25694,'Family Life 20','2680','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25695,'Family Life 20','2681','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25696,'Family Life 30','3680','1950-09-01','1998-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25697,'Family Life 30L','8619','2014-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25698,'Family Life 30S','3681','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25699,'Family Life 31','3678','1950-09-01','1997-08-15','Locally Modified Down','12',NULL,NULL,NULL),(25700,'Family Life B 30','3679','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25701,'Family Life Education 10','1320','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25702,'Family Life Education 10L','4853','1993-08-16','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(25703,'Family Life Education 20','2320','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25704,'Family Life Education 20L','6853','1993-08-16','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(25705,'Family Life Education 30','3320','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25706,'Family Life Education 30L','8853','1993-08-16','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(25707,'Family Life Education 30L','8860','1997-08-16','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(25708,'Family Studies 18','5487','2017-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(25709,'Family Studies 28','7487','2017-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(25710,'Family Studies 38','9487','2017-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25711,'Family Studies A 18','5416','1990-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(25712,'Family Studies A 28','7416','1989-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(25713,'Family Studies A 38','9416','1991-05-21','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(25714,'Family Studies B 18','5439','1993-08-16','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(25715,'Family Studies B 28','7439','1993-08-16','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(25716,'Family Studies B 38','9439','1993-08-16','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(25717,'Faune 10','5109','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25718,'Faune 20','7109','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25719,'Faune 30','9109','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25720,'Filipino 10L','4061','2000-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25721,'Filipino 20L','6061','2000-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25722,'Filipino 30L','8061','2000-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25723,'Film Lab 10L','4953','1997-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25724,'Film Lab 20L','6953','1997-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25725,'Film Lab 30L','8953','1997-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25726,'Finance 30','3687','1983-09-01','2002-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25727,'Financial Literacy 20','7045','2018-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25728,'Financial Literacy 30','9045','2018-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25729,'First Responder 30L','9041','2016-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25730,'Fondements du programme Ã©ducatif en petite enfance 1 30L','9520','2018-08-01','0000-00-00','Locally Developed Dual Credit','12',NULL,NULL,NULL),(25731,'Food & Nutrition 10','1646','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25732,'Food And Its Preparation 30','3652','1983-09-01','2002-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25733,'Food And Nutrition 30','3657','1983-09-01','2002-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25734,'Food Studies 10','4858','1998-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25735,'Food Studies 10','4859','1997-08-16','1999-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25736,'Food Studies 18','5458','2006-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(25737,'Food Studies 28','7458','2006-08-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(25738,'Food Studies 30','8858','1997-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25739,'Food Studies 30','8859','1998-08-16','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25740,'Food Studies 38','9458','2006-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25741,'Foreign Language 10','1460','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25742,'Foreign Language 20','2460','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25743,'Foreign Language 30','3460','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25744,'Foreign Language A 10','1461','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25745,'Foreign Language A 20','2461','1990-05-11','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25746,'Foreign Language A 30','3461','1990-05-11','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25747,'Forensic Science 20L','7335','2009-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25748,'Forensic Science 30L','9335','2008-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25749,'Foresterie 10','5110','2000-08-16','2005-07-31','Departmentally Developed','10',NULL,NULL,NULL),(25750,'Foresterie 20','7110','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25751,'Foresterie 30','9110','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25752,'Forestry Studies 10','4979','1999-08-16','2005-07-31','Departmentally Developed','10',NULL,NULL,NULL),(25753,'Forestry Studies 20','6979','1999-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25754,'Forestry Studies 30','8979','1999-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25755,'Formation d\'apprentis  A 30','9013','2009-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25756,'Formation d\'apprentis A 20','7013','2009-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25757,'Formation d\'apprentis B 20','7014','2009-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25758,'Formation d\'apprentis B 30','9014','2009-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25759,'Foundational English Language Arts 10L','4092','2009-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25760,'Foundations of Sport 30L','8609','2007-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25761,'Francais A 10','1417','1983-09-01','2000-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25762,'Francais A 11','4009','1991-09-01','2000-08-15','Locally Modified Down','10',NULL,NULL,NULL),(25763,'Francais A 20','2417','1983-09-01','2000-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25764,'Francais A 21','6009','1992-08-16','2000-08-15','Locally Developed','11',NULL,NULL,NULL),(25765,'Francais A 30','3417','1983-09-01','2000-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25766,'Francais A 31','8009','1993-08-16','2000-08-15','Locally Developed','12',NULL,NULL,NULL),(25767,'Francais B 10','1422','1983-09-01','2000-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25768,'Francais B 11','4010','1991-09-01','2000-08-15','Locally Modified Down','10',NULL,NULL,NULL),(25769,'Francais B 20','2422','1983-09-01','2000-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25770,'Francais B 21','6010','1992-08-16','2000-08-15','Locally Developed','11',NULL,NULL,NULL),(25771,'Francais B 30','3422','1983-09-01','2000-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25772,'Francais B 31','8010','1993-08-16','2000-08-15','Locally Developed','12',NULL,NULL,NULL),(25773,'Francais Oral (IB) 10L','1408','1990-01-24','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25774,'Francais fransaskois B 20','6023','1996-09-01','1999-06-01','Departmentally Developed','11',NULL,NULL,NULL),(25775,'FranÃ§ais 28','7600','2017-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(25776,'FranÃ§ais A 18','5600','2017-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(25777,'FranÃ§ais A 38','9600','2017-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25778,'FranÃ§ais B 18','5601','2017-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(25779,'FranÃ§ais B 38','9601','2017-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(25780,'FranÃ§ais fransaskois 20','6022','1996-09-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25781,'FranÃ§ais fransaskois 21','6078','2004-08-01','0000-00-00','Locally Modified Down','11',NULL,NULL,NULL),(25782,'FranÃ§ais fransaskois A 10','4022','1996-09-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25783,'FranÃ§ais fransaskois A 11','4078','2002-08-01','0000-00-00','Locally Modified Down','10',NULL,NULL,NULL),(25784,'FranÃ§ais fransaskois A 30','8022','1996-09-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25785,'FranÃ§ais fransaskois A 31','8078','2004-08-01','0000-00-00','Locally Modified Down','12',NULL,NULL,NULL),(25786,'FranÃ§ais fransaskois B 10','4023','1996-09-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25787,'FranÃ§ais fransaskois B 11','4079','2003-08-01','0000-00-00','Locally Modified Down','10',NULL,NULL,NULL),(25788,'FranÃ§ais fransaskois B 30','8023','1996-09-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25789,'FranÃ§ais fransaskois B 31','8079','2003-08-01','0000-00-00','Locally Modified Down','12',NULL,NULL,NULL),(25790,'FranÃ§ais immersion 10','4020','1995-08-15','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25791,'FranÃ§ais immersion 10 (IB)','4044','1998-08-16','0000-00-00','International Baccalaureate','10',NULL,NULL,NULL),(25792,'FranÃ§ais immersion 11','4107','2017-08-01','0000-00-00','Locally Modified Down','10',NULL,NULL,NULL),(25793,'FranÃ§ais immersion 20','6020','1995-08-15','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25794,'FranÃ§ais immersion 20 (IB)','6044','1998-08-16','0000-00-00','International Baccalaureate','11',NULL,NULL,NULL),(25795,'FranÃ§ais immersion 21','6107','2017-08-01','0000-00-00','Locally Modified Down','11',NULL,NULL,NULL),(25796,'FranÃ§ais immersion 30','8020','1995-08-15','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25797,'FranÃ§ais immersion 30 (IB)','8044','1998-08-16','0000-00-00','International Baccalaureate','12',NULL,NULL,NULL),(25798,'FranÃ§ais immersion 31','8107','2017-08-01','0000-00-00','Locally Modified Down','12',NULL,NULL,NULL),(25799,'FranÃ§ais immersion intÃ©grÃ© A 20','6021','1995-08-15','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25800,'FranÃ§ais immersion intÃ©grÃ© A 20 (IB)','6045','1998-08-16','0000-00-00','International Baccalaureate','11',NULL,NULL,NULL),(25801,'FranÃ§ais immersion intÃ©grÃ© B 20','6037','1997-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25802,'FranÃ§ais immersion intÃ©grÃ© B 20 (IB)','6046','1998-08-16','0000-00-00','International Baccalaureate','11',NULL,NULL,NULL),(25803,'French 10','1410','1950-09-01','1998-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25804,'French 10','4019','1995-08-15','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25805,'French 10 (IB)','4003','1989-08-15','2016-07-31','International Baccalaureate','10',NULL,NULL,NULL),(25806,'French 10 (IB)','4034','1997-08-16','0000-00-00','International Baccalaureate','10',NULL,NULL,NULL),(25807,'French 10 A','4085','2006-08-01','0000-00-00','Locally Modified Up','10',NULL,NULL,NULL),(25808,'French 10A','1411','1950-09-01','1998-08-15','Locally Modified Up','10',NULL,NULL,NULL),(25809,'French 11','1409','1950-09-01','1998-08-15','Locally Modified Down','10',NULL,NULL,NULL),(25810,'French 20','2410','1950-09-01','1998-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25811,'French 20','6019','1995-08-15','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25812,'French 20 (IB)','6003','1989-08-15','2016-07-31','International Baccalaureate','11',NULL,NULL,NULL),(25813,'French 20 (IB)','6034','1997-08-16','0000-00-00','International Baccalaureate','11',NULL,NULL,NULL),(25814,'French 20 A','6085','2007-08-01','0000-00-00','Locally Modified Up','11',NULL,NULL,NULL),(25815,'French 20A','2411','1950-09-01','1998-08-15','Locally Modified Up','11',NULL,NULL,NULL),(25816,'French 21','2409','1950-09-01','1998-08-15','Locally Modified Down','11',NULL,NULL,NULL),(25817,'French 30','3410','1950-09-01','1998-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25818,'French 30','8019','1995-08-15','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25819,'French 30 (AP)','8066','2000-08-15','0000-00-00','Advanced Placement','12',NULL,NULL,NULL),(25820,'French 30 (IB)','8003','1989-08-15','2016-07-31','International Baccalaureate','12',NULL,NULL,NULL),(25821,'French 30 (IB)','8034','1997-08-16','0000-00-00','International Baccalaureate','12',NULL,NULL,NULL),(25822,'French 30 A','8085','2006-08-01','0000-00-00','Locally Modified Up','12',NULL,NULL,NULL),(25823,'French 30A','3411','1950-09-01','1998-08-15','Locally Modified Up','12',NULL,NULL,NULL),(25824,'French A 10 (IB)','4004','1988-08-15','1998-08-15','International Baccalaureate','10',NULL,NULL,NULL),(25825,'French A 10A','4007','1990-08-15','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25826,'French A 20 (IB)','6004','1988-08-15','1998-08-15','International Baccalaureate','11',NULL,NULL,NULL),(25827,'French A 20A','6007','1990-08-15','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25828,'French A 30 (IB)','8004','1989-08-15','1998-08-15','International Baccalaureate','12',NULL,NULL,NULL),(25829,'French A 30A','8007','1990-08-15','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25830,'French B 10 (IB)','4005','1988-08-15','1998-08-15','International Baccalaureate','10',NULL,NULL,NULL),(25831,'French B 10A','4008','1990-08-15','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25832,'French B 20 (IB)','6005','1988-08-15','1998-08-15','International Baccalaureate','11',NULL,NULL,NULL),(25833,'French B 20A','6008','1990-08-15','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25834,'French B 30 (IB)','8005','1989-08-15','1998-08-15','International Baccalaureate','12',NULL,NULL,NULL),(25835,'French B 30A','8008','1990-08-15','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25836,'French Language Arts 18','5436','1992-08-16','1999-08-15','Alternative Education','10',NULL,NULL,NULL),(25837,'French Language Arts 28','7436','1993-08-16','1999-08-15','Alternative Education','11',NULL,NULL,NULL),(25838,'French Language Arts 38','9436','1994-08-15','1999-08-15','Alternative Education','12',NULL,NULL,NULL),(25839,'Garage Band 10L','4545','2012-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25840,'Garage Band 20L','6545','2013-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25841,'Garage Band 30L','8545','2013-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25842,'Gender and Sexual Diversity 20L','6625','2017-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25843,'General Education 10','1280','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25844,'General Education 20','2280','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25845,'General Education 30','3280','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25846,'General Mathematics 10','1230','1950-09-01','1998-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25847,'General Mathematics 10A','1231','1950-09-01','1997-08-15','Locally Modified Up','10',NULL,NULL,NULL),(25848,'General Mathematics 10L','1228','1990-09-01','1998-08-15','Locally Developed','10',NULL,NULL,NULL),(25849,'General Mathematics 11','1229','1950-09-01','1998-08-15','Locally Modified Down','10',NULL,NULL,NULL),(25850,'General Mathematics 20','2230','1950-09-01','1998-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25851,'General Mathematics 20A','2231','1950-09-01','1997-08-15','Locally Modified Up','11',NULL,NULL,NULL),(25852,'General Mathematics 20L','2228','1990-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25853,'General Mathematics 21','2229','1950-09-01','1998-08-15','Locally Modified Down','11',NULL,NULL,NULL),(25854,'General Mathematics 30','3230','1950-09-01','2014-06-30','Departmentally Developed','12',NULL,NULL,NULL),(25855,'General Mathematics 30A','3231','1950-09-01','1997-08-15','Locally Modified Up','12',NULL,NULL,NULL),(25856,'General Mathematics 31','3229','1950-09-01','2001-08-15','Locally Modified Down','12',NULL,NULL,NULL),(25857,'General Welding 30','3959','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25858,'Geographie 10','1153','1983-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25859,'Geographie 20','2153','1983-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25860,'Geographie 30','3153','1983-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25861,'Geography 10','1148','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25862,'Geography 10','1150','1950-09-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25863,'Geography 10A','1151','1950-09-01','0000-00-00','Locally Modified Up','10',NULL,NULL,NULL),(25864,'Geography 10L','4325','1996-08-15','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25865,'Geography 11','1149','1950-09-01','0000-00-00','Locally Modified Down','10',NULL,NULL,NULL),(25866,'Geography 20','2150','1950-09-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25867,'Geography 20A','2151','1950-09-01','0000-00-00','Locally Modified Up','11',NULL,NULL,NULL),(25868,'Geography 21','2149','1950-09-01','0000-00-00','Locally Modified Down','11',NULL,NULL,NULL),(25869,'Geography 30','3150','1950-09-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25870,'Geography 30A','3151','1950-09-01','0000-00-00','Locally Modified Up','12',NULL,NULL,NULL),(25871,'Geography 31','3149','1950-09-01','0000-00-00','Locally Modified Down','12',NULL,NULL,NULL),(25872,'Geology 20','2270','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25873,'Geology 30','3270','1950-09-01','2007-07-31','Departmentally Developed','12',NULL,NULL,NULL),(25874,'Geology 30L','8241','2007-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25875,'Geometrie-trigonometrie 10','1223','1987-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25876,'Geometrie-trigonometrie 20','2223','1987-09-01','1998-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25877,'Geometrie-trigonometrie 30','3223','1983-09-01','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25878,'Geometry 10','1220','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25879,'Geometry 10A','1221','1950-09-01','1997-08-15','Locally Modified Up','10',NULL,NULL,NULL),(25880,'Geometry 11','1219','1950-09-01','1997-08-15','Locally Modified Down','10',NULL,NULL,NULL),(25881,'Geometry 20','2220','1946-09-01','1998-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25882,'Geometry 20A','2221','1950-09-01','1997-08-15','Locally Modified Up','11',NULL,NULL,NULL),(25883,'Geometry 21','2219','1950-09-01','1997-08-15','Locally Modified Down','11',NULL,NULL,NULL),(25884,'Geometry Trigonometry 30 (I)','8411','1993-08-16','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25885,'Geometry-Trigonometry (Modern) 30','3220','1950-09-01','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25886,'Geometry-Trigonometry (Modern) 30A','3221','1950-09-01','1999-08-15','Locally Modified Up','12',NULL,NULL,NULL),(25887,'Geometry-Trigonometry (Modern) 31','3219','1950-09-01','1999-08-15','Locally Modified Down','12',NULL,NULL,NULL),(25888,'Geometry-Trigonometry (Traditional) 30','3225','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25889,'Geometry-Trigonometry (Traditional) 30A','3226','1950-09-01','1997-08-15','Locally Modified Up','12',NULL,NULL,NULL),(25890,'Geometry-Trigonometry (Traditional) 31','3224','1950-09-01','1997-08-15','Locally Modified Down','12',NULL,NULL,NULL),(25891,'Geometry-Trigonometry 10','1225','1987-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25892,'Geometry-Trigonometry 10 (I)','4411','1991-08-16','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25893,'Geometry-Trigonometry 10 (IB)','4401','1988-08-15','1997-08-15','International Baccalaureate','10',NULL,NULL,NULL),(25894,'Geometry-Trigonometry 10A','1226','1988-09-01','1997-08-15','Locally Modified Up','10',NULL,NULL,NULL),(25895,'Geometry-Trigonometry 20','2225','1950-09-01','1998-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25896,'Geometry-Trigonometry 20 (I)','6411','1992-08-16','1998-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25897,'Geometry-Trigonometry 20 (IB)','6401','1988-08-15','1999-08-15','International Baccalaureate','11',NULL,NULL,NULL),(25898,'Geometry-Trigonometry 20A','2226','1988-09-01','1998-08-15','Locally Modified Up','11',NULL,NULL,NULL),(25899,'Geometry-Trigonometry 30 (IB)','8401','1989-08-15','1999-08-15','International Baccalaureate','12',NULL,NULL,NULL),(25900,'German 10','1435','1950-09-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25901,'German 10 (IB)','4006','1989-08-15','0000-00-00','International Baccalaureate','10',NULL,NULL,NULL),(25902,'German 10A','1436','1988-09-01','2016-07-31','Locally Modified Up','10',NULL,NULL,NULL),(25903,'German 20','2435','1946-09-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25904,'German 20 (IB)','6006','1989-08-15','0000-00-00','International Baccalaureate','11',NULL,NULL,NULL),(25905,'German 20A','2436','1988-09-01','2016-07-31','Locally Modified Up','11',NULL,NULL,NULL),(25906,'German 30','3435','1950-09-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25907,'German 30 (IB)','8006','1989-08-15','0000-00-00','International Baccalaureate','12',NULL,NULL,NULL),(25908,'German 30A','3436','1988-09-01','2016-07-31','Locally Modified Up','12',NULL,NULL,NULL),(25909,'German I 10','1433','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25910,'Gestion des finances 10','5111','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25911,'Gestion des finances 10L','5212','1999-05-30','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25912,'Gestion des finances 20','7111','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25913,'Gestion des finances 20L','7212','1999-05-30','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25914,'Gestion des finances 30','9111','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25915,'Gestion des finances 30L','9212','1999-05-30','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25916,'Gestion et marketing 10','5112','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25917,'Gestion et marketing 20','7112','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25918,'Gestion et marketing 30','9112','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25919,'Graphic Arts 10','1833','1971-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25920,'Graphic Arts 10','4983','1999-08-16','2002-08-16','Departmentally Developed','10',NULL,NULL,NULL),(25921,'Graphic Arts 10L','1842','1990-09-01','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(25922,'Graphic Arts 10L','4927','1993-08-16','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(25923,'Graphic Arts 20','2833','1971-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25924,'Graphic Arts 20','6983','1999-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25925,'Graphic Arts 20L','2842','1990-09-01','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(25926,'Graphic Arts 30','3832','1972-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25927,'Graphic Arts 30','3833','1972-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25928,'Graphic Arts 30','8983','1999-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(25929,'Graphic Arts 30L','3842','1990-09-01','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(25930,'Graphic Arts A 20L','6922','1992-08-16','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(25931,'Graphic Arts A 30L','8922','1992-08-16','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(25932,'Graphic Arts B 20L','6923','1993-08-16','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(25933,'Graphic Arts B 30L','8923','1993-08-16','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(25934,'Greek 20','2475','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25935,'Guidance 10','1335','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25936,'Guidance 20','2335','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25937,'Guitar 10L','4532','1997-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25938,'Guitar 20L','6532','1997-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25939,'Guitar 30L','8532','1997-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25940,'Health 10','1306','1948-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25941,'Health Care 20L','6614','2011-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25942,'Health Care 30L','8614','2011-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(25943,'Health Science 20','6245','2013-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25944,'Health Science 20 (IB)','6262','2014-08-01','0000-00-00','International Baccalaureate','11',NULL,NULL,NULL),(25945,'Health Science 20A','6269','2015-08-01','0000-00-00','Locally Modified Up','11',NULL,NULL,NULL),(25946,'Health Science 21(2016)','6265','2015-08-01','0000-00-00','Locally Modified Down','11',NULL,NULL,NULL),(25947,'Health Science 28','7485','2017-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(25948,'Health Services 20L','7005','2006-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25949,'Health Unit Secretary','2922','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25950,'Health Unit Secretary 10','1919','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(25951,'Health Unit Secretary 10','1920','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25952,'Health Unit Secretary 10','1921','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25953,'Health Unit Secretary 20','2919','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(25954,'Health Unit Secretary 20','2920','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25955,'Health Unit Secretary 20','2921','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25956,'Health Unit Secretary 30','3919','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(25957,'Health Unit Secretary 30','3920','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25958,'Health Unit Secretary 30','3921','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25959,'Health Unit Secretary 30','3922','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25960,'Health, Safety and Nutrition 30L','9504','2015-08-01','0000-00-00','Locally Developed Dual Credit','12',NULL,NULL,NULL),(25961,'Health/Physical Education A 18','5413','1988-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(25962,'Health/Physical Education A 28','7413','1989-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(25963,'Health/Physical Education A 38','9413','1990-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(25964,'Health/Physical Education B 18','5438','1993-08-16','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(25965,'Health/Physical Education B 28','7438','1993-08-16','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(25966,'Health/Physical Education B 38','9438','1993-08-16','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(25967,'High Performance Training 20L','6613','2010-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25968,'High Performance Training and Psychology 20L','6623','2015-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25969,'Hindi 10L','4028','1994-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(25970,'Hindi 20L','6028','1997-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(25971,'Histoire 10','1133','1987-01-23','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25972,'Histoire 10','4312','1992-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25973,'Histoire 20','2133','1987-01-23','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25974,'Histoire 20','6312','1992-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25975,'Histoire 30','3133','1987-01-23','2000-08-15','Departmentally Developed','12',NULL,NULL,NULL),(25976,'Histoire 31','8314','1992-08-16','1999-08-15','Locally Developed','12',NULL,NULL,NULL),(25977,'Histoire immersion 11','4354','2017-08-01','0000-00-00','Locally Modified Down','10',NULL,NULL,NULL),(25978,'Histoire immersion 21','6354','2017-08-01','0000-00-00','Locally Modified Down','11',NULL,NULL,NULL),(25979,'History 10','1135','1975-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25980,'History 10','4306','1992-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(25981,'History 10 (I)','4316','1991-08-16','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(25982,'History 10 (IB)','4303','1989-08-15','1999-08-15','International Baccalaureate','10',NULL,NULL,NULL),(25983,'History 10 (IB)','4327','1997-08-16','0000-00-00','International Baccalaureate','10',NULL,NULL,NULL),(25984,'History 10A','1136','1975-09-01','1998-08-15','Locally Modified Up','10',NULL,NULL,NULL),(25985,'History 10A','4332','1998-08-16','0000-00-00','Locally Modified Up','10',NULL,NULL,NULL),(25986,'History 11','1134','1975-09-01','1997-08-15','Locally Modified Down','10',NULL,NULL,NULL),(25987,'History 11','4310','1992-08-16','0000-00-00','Locally Modified Down','10',NULL,NULL,NULL),(25988,'History 18','5453','2006-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(25989,'History 20','2135','1975-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25990,'History 20','6306','1992-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(25991,'History 20 (I)','6316','1992-08-16','1998-08-15','Departmentally Developed','11',NULL,NULL,NULL),(25992,'History 20 (IB)','6303','1989-08-15','1999-08-15','International Baccalaureate','11',NULL,NULL,NULL),(25993,'History 20 (IB)','6327','1997-08-16','0000-00-00','International Baccalaureate','11',NULL,NULL,NULL),(25994,'History 20A','2136','1975-09-01','1998-08-15','Locally Modified Up','11',NULL,NULL,NULL),(25995,'History 20A','6332','1998-08-16','0000-00-00','Locally Modified Up','11',NULL,NULL,NULL),(25996,'History 21','2134','1987-01-23','1998-08-15','Locally Modified Down','11',NULL,NULL,NULL),(25997,'History 21','6310','1993-08-16','0000-00-00','Locally Modified Down','11',NULL,NULL,NULL),(25998,'History 28','7453','2006-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(25999,'History 30','3135','1975-09-01','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26000,'History 30 (I)','8316','1993-08-16','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26001,'History 30 (IB)','8303','1988-08-15','1999-08-15','International Baccalaureate','12',NULL,NULL,NULL),(26002,'History 30: Canadian Studies','8306','1995-08-15','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26003,'History 30: Canadian Studies (IB)','8327','1997-08-16','0000-00-00','International Baccalaureate','12',NULL,NULL,NULL),(26004,'History 30A','3136','1975-09-01','1999-08-15','Locally Modified Up','12',NULL,NULL,NULL),(26005,'History 30A: Canadian Studies','8332','1999-08-16','0000-00-00','Locally Modified Up','12',NULL,NULL,NULL),(26006,'History 31','3134','1975-09-01','1999-08-15','Locally Modified Down','12',NULL,NULL,NULL),(26007,'History 31: Canadian Studies','8310','1996-08-16','0000-00-00','Locally Modified Down','12',NULL,NULL,NULL),(26008,'History 38','9453','2006-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(26009,'History Of The Americas (IB) 30L','8330','1998-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26010,'History Of US & Latin Americas (IB) 30L','8336','1999-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26011,'History of English Literature 30','3160','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26012,'History of English Literature 30A','3161','1950-09-01','1997-08-15','Locally Modified Up','12',NULL,NULL,NULL),(26013,'History of English Literature 31','3159','1950-09-01','1997-08-15','Locally Modified Down','12',NULL,NULL,NULL),(26014,'Hockey Skills 10L','4608','2007-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26015,'Hockey Skills 20L','6608','2011-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26016,'Hockey Skills 30L','8608','2012-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26017,'Holocaust and Genocide Studies 20L','6356','2017-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26018,'Holocaust and Genocide Studies 20L','8356','2017-08-01','2017-08-02','Locally Developed','11',NULL,NULL,NULL),(26019,'Home Economics 10','1638','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26020,'Home Economics 10','1640','1948-09-01','2002-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26021,'Home Economics 10','1645','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26022,'Home Economics 11','1637','1950-09-01','2016-07-31','Locally Modified Down','10',NULL,NULL,NULL),(26023,'Home Economics 20','2639','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26024,'Home Economics 20','2640','1946-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26025,'Home Economics 20','2645','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26026,'Home Economics 31','3639','1950-09-01','1997-08-15','Locally Modified Down','12',NULL,NULL,NULL),(26027,'Home Economics A 10','1639','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26028,'Home Economics(A) 30','3640','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26029,'Home Economics(B) 30','3645','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26030,'Home Management 10L','4850','1991-08-21','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26031,'Home Management A 20L','6850','1991-08-21','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26032,'Home Management A 30L','8850','1990-09-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26033,'Home Management B 20L','6851','1991-08-21','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26034,'Home Management B 30L','8851','1991-08-21','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26035,'Home Mechanics 10','1843','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26036,'Horticulture 10','4981','1999-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26037,'Horticulture 10L','4912','1991-08-21','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(26038,'Horticulture 18','5468','2008-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(26039,'Horticulture 20','6981','1999-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26040,'Horticulture 28','7468','2008-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(26041,'Horticulture 30','8981','1999-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26042,'Horticulture 38','9468','2008-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(26043,'Horticulture A 20L','6912','1990-08-21','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(26044,'Horticulture A 30L','8912','1990-09-01','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(26045,'Horticulture B 20L','6913','1990-09-01','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(26046,'Horticulture B 30L','8913','1990-09-01','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(26047,'Housing & Interior Design 30','3675','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26048,'Housing & Interior Design 31','3674','1950-09-01','1997-08-15','Locally Modified Down','12',NULL,NULL,NULL),(26049,'Housing 30','3677','1983-09-01','2002-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26050,'Housing 30','8854','1997-08-16','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26051,'Housing 30','8855','1997-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26052,'Human Growth and Development 30L','9505','2016-08-01','0000-00-00','Locally Developed Dual Credit','12',NULL,NULL,NULL),(26053,'Hygiene/education physique 18','5430','1991-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(26054,'Hygiene/education physique 28','7430','1991-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(26055,'Hygiene/education physique 38','9430','1991-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(26056,'IT Essentials 30L','9004','2007-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26057,'IT Essentials: PC Hardware and Software 20L','7004','2006-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26058,'Independent Living 20L','6900','1990-09-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26059,'Independent Living Skills 10L','1321','1990-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26060,'Independent Studies 10','1340','1985-06-25','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26061,'Independent Studies 20','2340','1985-06-25','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26062,'Independent Studies 30','3340','1989-06-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26063,'Indian Language 10','4011','1988-08-16','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26064,'Indian Language 20','6011','1988-08-16','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26065,'Indian Language 30','8011','1988-08-16','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26066,'Indigenous Culture 30L','8548','2017-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26067,'Industrial Arts 10','1834','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26068,'Industrial Arts 10','1835','1950-09-01','2003-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26069,'Industrial Arts 10','1836','1983-05-07','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26070,'Industrial Arts 10L','5100','1992-08-16','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(26071,'Industrial Arts 20','2834','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26072,'Industrial Arts 20','2835','1950-09-01','2003-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26073,'Industrial Arts 20','2836','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26074,'Industrial Arts 20','2837','1987-05-07','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26075,'Industrial Arts 20L','7100','1992-08-16','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(26076,'Industrial Arts 30','3834','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26077,'Industrial Arts 30','3835','1950-09-01','2003-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26078,'Industrial Arts 30','3836','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26079,'Industrial Arts 30L','9100','1992-08-16','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(26080,'Industrial Communication 30L','9503','2015-08-01','0000-00-00','Locally Developed Dual Credit','12',NULL,NULL,NULL),(26081,'Industrial Design 10','1832','1972-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26082,'Industrial Mechanic/Millwright 10L','5022','2012-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26083,'Industrial Mechanic/Millwright 20L','7022','2013-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26084,'Industrial Mechanic/Millwright 30L','9022','2013-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26085,'Infographie 10L','4985','1999-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26086,'Information Processing 10','5200','1991-05-27','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26087,'Information Processing 10L','1624','1989-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26088,'Information Processing 18','5461','2005-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(26089,'Information Processing 20','7200','1991-05-27','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26090,'Information Processing 20L','2624','1990-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26091,'Information Processing 28','7461','2005-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(26092,'Information Processing 30','9200','1991-05-27','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26093,'Information Processing 30L','3624','1990-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26094,'Information Processing 38','9461','2005-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(26095,'Information Processing A 10L','1625','1990-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26096,'Information Processing B 10L','1626','1990-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26097,'Information Technology 20L','7206','1994-08-16','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(26098,'Information Technology 30L','9206','1994-08-16','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(26099,'Informatique 10','1607','1987-01-23','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26100,'Informatique 10','1622','1988-09-01','2005-07-31','Departmentally Developed','10',NULL,NULL,NULL),(26101,'Informatique 10','1623','1988-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26102,'Informatique 20','2609','1987-01-23','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26103,'Informatique 20','2622','1988-09-01','2005-07-31','Departmentally Developed','11',NULL,NULL,NULL),(26104,'Informatique 20','2623','1988-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26105,'Informatique 20','6254','2016-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26106,'Informatique 30','3609','1987-01-23','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26107,'Informatique 30','3623','1988-09-01','2005-07-31','Departmentally Developed','12',NULL,NULL,NULL),(26108,'Informatique 30','8254','2016-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26109,'Informatique appliquee 10','1620','1988-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26110,'Informatique appliquee 20','2620','1988-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26111,'Informatique programme 10','1606','1987-01-23','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26112,'Informatique programme 20','2607','1987-01-23','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26113,'Inquiry Quest 20L','6349','2009-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26114,'Institutional Services 10L','4908','1990-08-21','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26115,'Institutional Services A 20L','6908','1990-08-21','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26116,'Institutional Services A 30L','8908','1990-09-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26117,'Institutional Services B 20L','6909','1990-09-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26118,'Institutional Services B 30L','8909','1991-08-21','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26119,'Instrumental Jazz 10','4544','2012-08-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26120,'Instrumental Jazz 20','6544','2012-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26121,'Instrumental Jazz 30','8544','2012-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26122,'Integral Calculus 30L','8437','2012-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26123,'Integrated English A 10','1087','1990-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26124,'Integrated English A 20','2087','1990-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26125,'Integrated English A 30','3087','1990-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26126,'Integrated English B 10','1088','1990-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26127,'Integrated English B 20','2088','1990-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26128,'Integrated English B 30','3088','1990-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26129,'Integrated Studies 10L','1341','1990-09-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26130,'Integrated Studies 20L','2341','1990-09-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26131,'Integrated Studies 30L','3341','1990-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26132,'Integrated francais A 10','1412','1990-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26133,'Integrated francais A 20','2412','1990-09-01','1999-08-15','Locally Developed','11',NULL,NULL,NULL),(26134,'Integrated francais A 30','3412','1990-09-01','1999-08-15','Locally Developed','12',NULL,NULL,NULL),(26135,'Integrated francais B 10','1413','1990-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26136,'Integrated francais B 20','2413','1990-09-01','1999-08-15','Locally Developed','11',NULL,NULL,NULL),(26137,'Integrated francais B 30','3413','1990-09-01','1999-08-15','Locally Developed','12',NULL,NULL,NULL),(26138,'Interdisciplinary Studies 20L','6305','1992-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26139,'Interdisciplinary Studies 30L','8305','1996-08-15','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26140,'Interior Design 30','3672','1983-09-01','2002-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26141,'Interior Design 30','8856','1997-08-16','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26142,'Interior Design 30','8857','1997-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26143,'Interpersonal Communications 30L','9502','2015-08-01','0000-00-00','Locally Developed Dual Credit','12',NULL,NULL,NULL),(26144,'Interpretation Musicale et Arts de La ScÃ¨ne 10L','4540','2005-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26145,'Intro aux system:pol,econ et jur can 30L','8335','1999-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26146,'Introduction To Business 10','1789','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26147,'Introduction To Business 10','1790','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26148,'Introduction To Business 10L','1791','1990-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26149,'Introduction To Business 20L','2791','1990-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26150,'Introduction To Business 30L','3791','1990-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26151,'Introduction To Business 30L','9215','2012-08-01','2016-07-31','Locally Developed','12',NULL,NULL,NULL),(26152,'Introduction To Business 30L','9515','2016-08-01','0000-00-00','Locally Developed Dual Credit','12',NULL,NULL,NULL),(26153,'Introduction to English 10L','4091','2009-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26154,'Introduction to Power Engineering 20L','7036','2014-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26155,'Introduction to Power Engineering 30L','9036','2014-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26156,'Islamic Studies 10L','4351','2012-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26157,'Islamic Studies 20L','6351','2012-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26158,'Islamic Studies 30L','8351','2012-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26159,'Japanese 10L','1456','1990-01-24','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26160,'Japanese 20L','2456','1991-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26161,'Japanese 30L','3456','1991-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26162,'Jazz Band 10L','4542','2007-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26163,'Jazz Band 20L','6542','2007-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26164,'Jazz Band 30L','8542','2007-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26165,'Jazz Studies 10L','4533','2002-08-15','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26166,'Jazz Studies 20L','6533','1998-08-15','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26167,'Jazz Studies 30L','8533','2002-08-15','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26168,'Job Safety Skills For Young Workers 30L','9311','2000-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26169,'Journalism 10','1123','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26170,'Journalism 10L','1126','1990-09-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26171,'Journalism 20','2123','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26172,'Journalism 20L','2126','1990-09-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26173,'Journalism 30','3123','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26174,'Journalism 30L','3126','1990-09-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26175,'Journalism Studies 20','6027','1996-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26176,'Journalism Studies 30L','8086','2007-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26177,'Journalisme 20L','6038','1997-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26178,'Keypunch 20','2780','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26179,'Kinesiology 30L','8615','2012-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26180,'La francophonie 30L','8538','2004-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26181,'Language Ab Initio (IB) 20L','6095','2011-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26182,'Language Arts/Communications A 18','5402','1988-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(26183,'Language Arts/Communications A 28','7402','1989-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(26184,'Language Arts/Communications A 38','9402','1990-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(26185,'Language Arts/Communications B 18','5403','1988-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(26186,'Language Arts/Communications B 28','7403','1989-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(26187,'Language Arts/Communications B 38','9403','1990-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(26188,'Language Studies 10L','4087','2008-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26189,'Language Studies 20L','6087','2008-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26190,'Language Studies 30L','8087','2008-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26191,'Langue francaise 10','1420','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26192,'Langue francaise 20','2420','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26193,'Langue francaise 30','3420','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26194,'Langue/communication A 18','5418','1991-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(26195,'Langue/communication A 28','7418','1991-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(26196,'Langue/communication A 38','9418','1991-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(26197,'Langue/communication B 18','5419','1991-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(26198,'Langue/communication B 28','7419','1991-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(26199,'Langue/communication B 38','9419','1991-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(26200,'Latin 10','1430','1950-09-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26201,'Latin 11','1429','1950-09-01','0000-00-00','Locally Modified Down','10',NULL,NULL,NULL),(26202,'Latin 20','2430','1950-09-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26203,'Latin 30','3430','1950-09-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26204,'Law 10','1145','1975-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26205,'Law 11','1144','1975-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26206,'Law 20','2740','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26207,'Law 20L','2145','1990-08-15','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(26208,'Law 30','3145','1975-09-01','2002-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26209,'Law 30','3740','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26210,'Law 30','3741','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26211,'Law 30','8339','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26212,'Le droit 30L','8319','1993-08-16','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(26213,'Leadership 10L','5314','2013-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26214,'Leadership 20L','7314','2008-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26215,'Leadership 30L','9314','2000-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26216,'Leadership Studies 30L','8627','2017-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26217,'Learning Strategies 10L','4861','1997-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26218,'Life Of Christ 30L','8801','1991-02-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26219,'Life Skills 10L','1322','1990-08-23','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(26220,'Life Skills 18','5407','1988-09-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(26221,'Life Skills 20L','2322','1990-09-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26222,'Life Skills 28','7407','1989-09-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(26223,'Life Skills 30L','3322','1989-08-15','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26224,'Life Skills 38','9407','1990-09-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(26225,'Life Skills B 18','5442','1999-08-16','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(26226,'Life Skills B 28','7442','1993-08-16','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(26227,'Life Skills B 38','9442','1995-08-16','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(26228,'Life Transitions 18','5459','2006-08-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(26229,'Life Transitions 20','6600','1994-02-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26230,'Life Transitions 28','7459','2006-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(26231,'Life Transitions 30','8600','1994-02-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26232,'Life Transitions 38','9459','2006-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(26233,'Lifeguard 30L','9513','2016-08-01','0000-00-00','Locally Developed Dual Credit','12',NULL,NULL,NULL),(26234,'Linguistics A 30L','9508','2015-08-01','0000-00-00','Locally Developed Dual Credit','12',NULL,NULL,NULL),(26235,'Linguistics B 30L','9509','2015-08-01','0000-00-00','Locally Developed Dual Credit','12',NULL,NULL,NULL),(26236,'Linking Community and Careers 10L','5001','2003-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26237,'Literacy 20L','6100','2014-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26238,'Literacy 30L','8100','2014-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26239,'Literature 10','1110','1948-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26240,'Literature 10A','1111','1950-09-01','1997-08-15','Locally Modified Up','10',NULL,NULL,NULL),(26241,'Literature 11','1109','1950-09-01','1997-08-15','Locally Modified Down','10',NULL,NULL,NULL),(26242,'Literature 20','2110','1946-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26243,'Literature 20A','2111','1950-09-01','1997-08-15','Locally Modified Up','11',NULL,NULL,NULL),(26244,'Literature 21','2109','1950-06-01','1997-08-15','Locally Modified Down','11',NULL,NULL,NULL),(26245,'Literature 30','3110','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26246,'Literature 30A','3111','1950-09-01','1997-08-15','Locally Modified Up','12',NULL,NULL,NULL),(26247,'Literature 31','3109','1950-09-01','1997-08-15','Locally Modified Down','12',NULL,NULL,NULL),(26248,'Litterature francaise 10','1415','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26249,'Litterature francaise 20','2415','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26250,'Litterature francaise 30','3415','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26251,'Logistique 10','5113','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26252,'Logistique 20','7113','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26253,'Logistique 30','9113','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26254,'Machining 10','1862','1987-05-07','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26255,'Machining 10','1863','1987-05-07','2005-07-31','Departmentally Developed','10',NULL,NULL,NULL),(26256,'Machining 10','1864','1987-05-07','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26257,'Machining 10','1895','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26258,'Machining 10','1948','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26259,'Machining 10','1950','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26260,'Machining 10','1951','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26261,'Machining 10','1952','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26262,'Machining 10','4992','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26263,'Machining 10L','1888','1989-10-19','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(26264,'Machining 10L','1889','1988-09-01','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(26265,'Machining 18','5473','2009-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(26266,'Machining 20','2862','1987-05-07','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26267,'Machining 20','2863','1987-05-07','2005-07-31','Departmentally Developed','11',NULL,NULL,NULL),(26268,'Machining 20','2864','1987-05-07','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26269,'Machining 20','2895','1988-02-10','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26270,'Machining 20','2948','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26271,'Machining 20','2949','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26272,'Machining 20','2950','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26273,'Machining 20','2951','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26274,'Machining 20','2952','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26275,'Machining 20','2978','1976-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26276,'Machining 20','2979','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26277,'Machining 20','6992','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26278,'Machining 20L','2888','1989-10-19','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(26279,'Machining 20L','2889','1989-10-19','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(26280,'Machining 28','7473','2009-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(26281,'Machining 30','3862','1987-05-07','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26282,'Machining 30','3863','1987-05-07','2005-07-31','Departmentally Developed','12',NULL,NULL,NULL),(26283,'Machining 30','3864','1987-05-07','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26284,'Machining 30','3895','1988-02-10','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26285,'Machining 30','3949','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26286,'Machining 30','3950','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26287,'Machining 30','3951','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26288,'Machining 30','3952','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26289,'Machining 30','3978','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26290,'Machining 30','3979','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26291,'Machining 30','8992','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26292,'Machining 30L','3888','1989-10-19','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(26293,'Machining 30L','3889','1989-10-19','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(26294,'Machining 38','9473','2009-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(26295,'Macro Design 30L','3879','1990-09-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26296,'Mandarin 10','4067','2001-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26297,'Mandarin 10L','4052','1999-01-01','2001-08-15','Locally Developed','10',NULL,NULL,NULL),(26298,'Mandarin 20','6067','2001-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26299,'Mandarin 20L','6052','1999-08-16','2001-08-15','Locally Developed','11',NULL,NULL,NULL),(26300,'Mandarin 30','8067','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26301,'Math: Foundations 20','6425','2011-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26302,'Math: Foundations 20 (IB)','6432','2011-08-01','0000-00-00','International Baccalaureate','11',NULL,NULL,NULL),(26303,'Math: Foundations 30','8425','2012-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26304,'Math: Foundations 30 (IB)','8432','2012-08-01','0000-00-00','International Baccalaureate','12',NULL,NULL,NULL),(26305,'Math: Foundations and Pre-Calculus 10A','4436','2012-08-01','0000-00-00','Locally Modified Up','10',NULL,NULL,NULL),(26306,'Math: Foundations and Pre-calculus 10','4424','2010-08-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26307,'Math: Foundations and Pre-calculus 10 (IB)','4431','2010-08-01','0000-00-00','International Baccalaureate','10',NULL,NULL,NULL),(26308,'Math: Pre-calculus 20','6426','2011-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26309,'Math: Pre-calculus 20 (IB)','6433','2011-08-01','0000-00-00','International Baccalaureate','11',NULL,NULL,NULL),(26310,'Math: Pre-calculus 30','8426','2012-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26311,'Math: Pre-calculus 30 (IB)','8433','2012-08-01','0000-00-00','International Baccalaureate','12',NULL,NULL,NULL),(26312,'Math: Workplace and Apprenticeship 10','4423','2010-08-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26313,'Math: Workplace and Apprenticeship 20','6423','2011-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26314,'Math: Workplace and Apprenticeship 30','8423','2012-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26315,'Mathematical Studies 30L','8434','2011-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26316,'Mathematics & Machines 10','1720','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26317,'Mathematics & Machines 20','2720','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26318,'Mathematics & Machines 30','3720','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26319,'Mathematics 10','1212','1948-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26320,'Mathematics 10','4403','1992-08-16','2013-07-31','Departmentally Developed','10',NULL,NULL,NULL),(26321,'Mathematics 10 (IB)','4413','1997-08-16','2011-07-31','International Baccalaureate','10',NULL,NULL,NULL),(26322,'Mathematics 10A','4420','2002-08-16','2011-07-31','Locally Modified Up','10',NULL,NULL,NULL),(26323,'Mathematics 10L','1213','1990-09-01','1999-08-15','Locally Developed','10',NULL,NULL,NULL),(26324,'Mathematics 11','1208','1990-09-01','1997-08-15','Locally Modified Down','10',NULL,NULL,NULL),(26325,'Mathematics 11','4412','1995-08-15','2016-07-31','Locally Modified Down','10',NULL,NULL,NULL),(26326,'Mathematics 11 (2010)','4439','2015-08-01','0000-00-00','Locally Modified Down','10',NULL,NULL,NULL),(26327,'Mathematics 18','5404','1988-09-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(26328,'Mathematics 20','2212','1969-09-01','1998-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26329,'Mathematics 20','6403','1992-08-16','2014-01-31','Departmentally Developed','11',NULL,NULL,NULL),(26330,'Mathematics 20 (IB)','6413','1997-08-16','2011-07-31','International Baccalaureate','11',NULL,NULL,NULL),(26331,'Mathematics 20 A','6420','2003-08-16','2011-07-31','Locally Modified Up','11',NULL,NULL,NULL),(26332,'Mathematics 20L','2213','1990-09-01','1998-08-15','Locally Developed','11',NULL,NULL,NULL),(26333,'Mathematics 21','2208','1990-09-01','1998-08-15','Locally Modified Down','11',NULL,NULL,NULL),(26334,'Mathematics 21','6412','1995-08-15','2016-07-31','Locally Modified Down','11',NULL,NULL,NULL),(26335,'Mathematics 21 (2010)','6439','2015-08-01','0000-00-00','Locally Modified Down','11',NULL,NULL,NULL),(26336,'Mathematics 28','7404','1989-09-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(26337,'Mathematics 30','3212','1974-09-01','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26338,'Mathematics 30A','3213','1988-09-01','1999-08-15','Locally Developed','12',NULL,NULL,NULL),(26339,'Mathematics 31','3208','1990-09-01','1999-08-15','Locally Modified Down','12',NULL,NULL,NULL),(26340,'Mathematics 38','9404','1990-09-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(26341,'Mathematics A 30','8404','1993-08-15','2013-07-31','Departmentally Developed','12',NULL,NULL,NULL),(26342,'Mathematics A 30 (IB)','8413','1997-08-16','2012-07-31','International Baccalaureate','12',NULL,NULL,NULL),(26343,'Mathematics B 30','8405','1993-08-15','2013-07-31','Departmentally Developed','12',NULL,NULL,NULL),(26344,'Mathematics B 30 (IB)','8414','1997-08-16','2012-07-31','International Baccalaureate','12',NULL,NULL,NULL),(26345,'Mathematics C 30','8406','1993-08-15','2013-07-31','Departmentally Developed','12',NULL,NULL,NULL),(26346,'Mathematics C 30 (IB)','8415','1997-08-16','2012-07-31','International Baccalaureate','12',NULL,NULL,NULL),(26347,'Mathematiques 30','3207','1993-08-16','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26348,'Maths : fondements des mathÃ©matiques 20','6429','2011-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26349,'Maths : fondements des mathÃ©matiques 30','8429','2012-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26350,'Maths : fondements et prÃ©calcul 10','4428','2010-08-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26351,'Maths : milieu de travail et formation d\'apprentis 10','4427','2010-08-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26352,'Maths : milieu de travail et formation d\'apprentis 20','6427','2011-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26353,'Maths : milieu de travail et formation d\'apprentis 30','8427','2012-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26354,'Maths : prÃ©calcul 20','6430','2011-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26355,'Maths : prÃ©calcul 30','8430','2012-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26356,'MathÃ©matiques 10','4407','1992-08-16','2012-07-31','Departmentally Developed','10',NULL,NULL,NULL),(26357,'MathÃ©matiques 11','4419','1999-08-16','2016-07-31','Locally Modified Down','10',NULL,NULL,NULL),(26358,'MathÃ©matiques 11 (2015)','4440','2016-08-01','0000-00-00','Locally Modified Down','10',NULL,NULL,NULL),(26359,'MathÃ©matiques 18','5420','1991-09-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(26360,'MathÃ©matiques 20','6407','1992-08-16','2012-07-31','Departmentally Developed','11',NULL,NULL,NULL),(26361,'MathÃ©matiques 21','6419','1999-08-16','2016-07-31','Locally Modified Down','11',NULL,NULL,NULL),(26362,'MathÃ©matiques 21 (2015)','6440','2016-08-01','0000-00-00','Locally Modified Down','11',NULL,NULL,NULL),(26363,'MathÃ©matiques 28','7420','1991-09-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(26364,'MathÃ©matiques 38','9420','1991-09-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(26365,'MathÃ©matiques A 30','8407','1996-08-16','2012-07-31','Departmentally Developed','12',NULL,NULL,NULL),(26366,'MathÃ©matiques B 30','8408','1997-01-01','2012-07-31','Departmentally Developed','12',NULL,NULL,NULL),(26367,'MathÃ©matiques C 30','8409','1997-01-01','2012-07-31','Departmentally Developed','12',NULL,NULL,NULL),(26368,'Mechanical And Automotive 18','5494','2017-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(26369,'Mechanical And Automotive A 28','7494','2017-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(26370,'Mechanical And Automotive A 38','9494','2017-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(26371,'Mechanical And Automotive B 28','7495','2017-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(26372,'Mechanical And Automotive B 38','9495','2017-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(26373,'Mechanical Studies 10','4967','1998-08-16','1999-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26374,'Mechanical Studies 20','6967','1998-08-16','1999-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26375,'Mechanical Studies 30','8967','1998-08-16','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26376,'Mechanical Technical 10','1808','1970-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26377,'Mechanical Technical 10','1809','1985-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26378,'Mechanical Technical 10','1811','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26379,'Mechanical Technical 10','1891','1988-02-10','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26380,'Mechanical Technical 10L','1875','1989-09-01','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(26381,'Mechanical Technical 10L','1876','1989-09-01','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(26382,'Mechanical Technical 20','2806','1987-05-07','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26383,'Mechanical Technical 20','2811','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26384,'Mechanical Technical 20','2812','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26385,'Mechanical Technical 20','2891','1988-02-10','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26386,'Mechanical Technical 20L','2875','1989-10-19','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(26387,'Mechanical Technical 30','3806','1987-05-07','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26388,'Mechanical Technical 30','3809','1985-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26389,'Mechanical Technical 30','3811','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26390,'Mechanical Technical 30','3812','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26391,'Mechanical Technical 30','3891','1988-02-10','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26392,'Mechanical Technical 30 (IB)','3807','1950-09-01','1997-08-15','International Baccalaureate','12',NULL,NULL,NULL),(26393,'Mechanical Technical 30L','3875','1989-10-19','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(26394,'Mechanical Technical A 20L','2876','1989-10-19','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(26395,'Mechanical Technical A 30L','3876','1989-10-19','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(26396,'Mechanical Technical B 20','2809','1985-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26397,'Mechanical Technical B 20L','6924','1993-08-16','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(26398,'Mechanical Technical B 30L','8924','1993-08-16','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(26399,'Mechanical Technical C 30','3808','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26400,'Mechanical and Automotive 10','4957','1998-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26401,'Mechanical and Automotive A 20','6957','1998-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26402,'Mechanical and Automotive A 30','8957','1998-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26403,'Mechanical and Automotive B 20','6987','1998-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26404,'Mechanical and Automotive B 30','8987','1998-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26405,'Mechanics 10','1810','1950-09-01','2003-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26406,'Mechanics 18','5474','2009-08-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(26407,'Mechanics 20','2810','1950-09-01','2003-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26408,'Mechanics 30','3810','1950-09-01','2003-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26409,'Mechanics A 28','7474','2009-08-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(26410,'Mechanics A 38','9474','2009-08-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(26411,'Mechanics B 28','7477','2009-08-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(26412,'Mechanics B 38','9477','2009-08-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(26413,'Media 20S','2470','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26414,'Media 30S','3470','1970-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26415,'Media Studies 20','6025','1996-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26416,'Media Studies 20L','6000','1991-08-21','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(26417,'Media Studies 30L','8000','1991-08-15','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(26418,'Medical Terminology 30L','8621','2014-08-01','2014-08-02','Locally Developed','12',NULL,NULL,NULL),(26419,'Medical Terminology 30L','9501','2014-08-01','0000-00-00','Locally Developed Dual Credit','12',NULL,NULL,NULL),(26420,'Men\'s and Women\'s Dance 10L','5324','2001-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26421,'Men\'s and Women\'s Dance 20L','7324','2001-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26422,'Men\'s and Women\'s Dance 30L','9324','2001-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26423,'Mental Health Studies 20L','6629','2018-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26424,'Mental Health and Addictions 10L','4617','2014-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26425,'Mental Wellness 30L','8630','2018-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26426,'Merchandising 10','1745','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26427,'Merchandising 10L','5202','1990-08-21','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26428,'Merchandising 20','2744','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26429,'Merchandising 20','2745','1950-09-01','1998-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26430,'Merchandising 30','3744','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26431,'Merchandising 30','3745','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26432,'Merchandising A 20L','7202','1990-09-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26433,'Merchandising A 30L','9202','1990-09-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26434,'Merchandising B 20L','7203','1990-09-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26435,'Merchandising B 30L','9203','1990-09-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26436,'Metal Inert Gas Welding 30','8972','1998-08-16','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26437,'Metalwork 10','1854','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26438,'Metalwork 10','1855','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26439,'Metalwork 20','2855','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26440,'Metalwork 30','3855','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26441,'Metalwork B 20','2856','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26442,'Metalwork C 30','3856','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26443,'Metis Studies 30L','3146','1989-10-19','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26444,'Michif 10L','4082','2005-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26445,'Michif 20L','6082','2005-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26446,'Michif 30L','8082','2005-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26447,'Michif A 10 L','4069','2002-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26448,'Michif A 20 L','6069','2002-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26449,'Michif A 30 L','8069','2002-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26450,'Michif B 10 L','4070','2002-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26451,'Michif B 20 L','6070','2002-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26452,'Michif B 30 L','8070','2002-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26453,'Mieux-Ãªtre 10','4601','1992-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26454,'Mieux-Ãªtre 18','5602','2017-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(26455,'Military Reserve Cooperative Educat 30L','9316','2001-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26456,'Mode 10','5115','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26457,'Mode 20','7115','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26458,'Mode 30','9115','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26459,'Motor Mechanics 10','1844','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26460,'Motor Mechanics 10','1845','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26461,'Motor Mechanics 20','2844','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26462,'Motor Mechanics 20','2845','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26463,'Motor Mechanics 30','3845','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26464,'Multimedia Studies 30L','8043','1997-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26465,'Music 10','1520','1950-09-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26466,'Music 10 (Conservatory Canada)','4503','1991-09-01','0000-00-00','External','10',NULL,NULL,NULL),(26467,'Music 10 (IB)','4506','1989-08-15','0000-00-00','International Baccalaureate','10',NULL,NULL,NULL),(26468,'Music 10 (Mcgill Conservatory)','4505','1991-09-01','0000-00-00','External','10',NULL,NULL,NULL),(26469,'Music 10 (Royal Conservatory)','4502','1991-09-01','0000-00-00','External','10',NULL,NULL,NULL),(26470,'Music 10 (Trinity College)','4504','1991-09-01','0000-00-00','External','10',NULL,NULL,NULL),(26471,'Music 10A','1521','1994-08-16','2016-07-31','Locally Modified Up','10',NULL,NULL,NULL),(26472,'Music 11','1519','1950-09-01','2016-07-31','Locally Modified Down','10',NULL,NULL,NULL),(26473,'Music 18','5607','2017-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(26474,'Music 20','2520','1950-09-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26475,'Music 20 (Conservatory Canada)','6503','1991-09-01','0000-00-00','External','11',NULL,NULL,NULL),(26476,'Music 20 (IB)','6506','1989-08-15','0000-00-00','International Baccalaureate','11',NULL,NULL,NULL),(26477,'Music 20 (Mcgill Conservatory)','6505','1991-09-01','0000-00-00','External','11',NULL,NULL,NULL),(26478,'Music 20 (Royal Conservatory)','6502','1991-09-01','0000-00-00','External','11',NULL,NULL,NULL),(26479,'Music 20 (Trinity College)','6504','1991-09-01','0000-00-00','External','11',NULL,NULL,NULL),(26480,'Music 20A','2521','1950-09-01','2016-07-31','Locally Modified Up','11',NULL,NULL,NULL),(26481,'Music 21','2519','1950-09-01','2016-07-31','Locally Modified Down','11',NULL,NULL,NULL),(26482,'Music 28','7607','2017-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(26483,'Music 30','3520','1967-09-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26484,'Music 30 (AP)','8537','2000-08-15','0000-00-00','Advanced Placement','12',NULL,NULL,NULL),(26485,'Music 30 (Conservatory Canada)','8503','1991-09-01','0000-00-00','External','12',NULL,NULL,NULL),(26486,'Music 30 (IB)','8506','1989-08-15','0000-00-00','International Baccalaureate','12',NULL,NULL,NULL),(26487,'Music 30 (Mcgill Conservatory)','8505','1991-09-01','0000-00-00','External','12',NULL,NULL,NULL),(26488,'Music 30 (Royal Conservatory)','8502','1991-09-01','0000-00-00','External','12',NULL,NULL,NULL),(26489,'Music 30 (Trinity College)','8504','1991-09-01','0000-00-00','External','12',NULL,NULL,NULL),(26490,'Music 30A','3521','1970-09-01','2016-07-31','Locally Modified Up','12',NULL,NULL,NULL),(26491,'Music 31','3519','1970-09-01','2016-07-31','Locally Modified Down','12',NULL,NULL,NULL),(26492,'Music 38','9607','2017-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(26493,'Music Apprentice 20L','6517','1992-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26494,'Music Apprentice 30L','8517','1992-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26495,'Musical Theatre 10L','4547','2016-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26496,'Musical Theatre 20L','6547','2016-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26497,'Musical Theatre 30L','8547','2014-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26498,'Musique 10','1523','1983-09-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26499,'Musique 20','2523','1983-09-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26500,'Musique 30','3523','1983-09-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26501,'MÃ©canique 10','5114','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26502,'MÃ©canique 20','7114','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26503,'MÃ©canique 30','9114','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26504,'Nakawe 10L','4081','2005-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26505,'Nakawe 20L','6081','2005-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26506,'Nakawe 30L','8081','2005-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26507,'Nakoda 10L','4063','2000-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26508,'Nakoda 20L','6063','2000-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26509,'Nakoda 30L','8063','2000-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26510,'Native Art 10L','4515','1993-02-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26511,'Native Education 20','2463','1980-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26512,'Native Studies 10','1139','1986-02-07','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26513,'Native Studies 10','4309','1992-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26514,'Native Studies 10 (IB)','4328','1997-08-16','0000-00-00','International Baccalaureate','10',NULL,NULL,NULL),(26515,'Native Studies 11','4329','1998-08-16','0000-00-00','Locally Modified Down','10',NULL,NULL,NULL),(26516,'Native Studies 18','5454','2006-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(26517,'Native Studies 20','2139','1986-02-07','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26518,'Native Studies 20','6309','1992-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26519,'Native Studies 20 (IB)','6328','1997-08-16','0000-00-00','International Baccalaureate','11',NULL,NULL,NULL),(26520,'Native Studies 21','6329','1999-08-16','0000-00-00','Locally Modified Down','11',NULL,NULL,NULL),(26521,'Native Studies 28','7454','2006-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(26522,'Native Studies 30','3144','1986-02-07','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26523,'Native Studies 30','8309','1992-08-16','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26524,'Native Studies 30: Canadian Studies','8321','1995-08-15','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26525,'Native Studies 30: Canadian Studies (IB)','8328','1997-08-16','0000-00-00','International Baccalaureate','12',NULL,NULL,NULL),(26526,'Native Studies 31: Canadian Studies','8329','1998-08-16','0000-00-00','Locally Modified Down','12',NULL,NULL,NULL),(26527,'Native Studies 38','9454','2006-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(26528,'Native Tradition 10L','1141','1989-06-22','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26529,'Naval Reserve A30L','9514','2016-08-01','0000-00-00','Locally Developed Dual Credit','12',NULL,NULL,NULL),(26530,'Naval Reserve B30L','9517','2017-08-01','0000-00-00','Locally Developed Dual Credit','12',NULL,NULL,NULL),(26531,'New Testament Church History 30L','8800','1992-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26532,'New Testament Survey 10L','4800','1991-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26533,'Northern Lifestyles 10L','5009','2007-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26534,'Northern Lifestyles 20L','7009','2007-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26535,'Northern Lifestyles 30L','9009','2007-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26536,'Norwegian 10L','4060','2000-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26537,'Norwegian 20L','6060','2000-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26538,'Norwegian 30L','8060','2000-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26539,'Nurturing Family Development 10L','4620','2014-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26540,'Nurturing Family Development 20L','6620','2014-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26541,'Nurturing Family Development 30L','8620','2014-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26542,'Occupational Training Academic I 10','1975','1972-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26543,'Occupational Training Academic II 10','1976','1972-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26544,'Occupational Training Academic III 10','1977','1972-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26545,'Occupational Training Academics IV 10','1978','1972-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26546,'Occupational Training Grooming I 10','1990','1972-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26547,'Occupational Training Home Economics I 1','1985','1972-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26548,'Occupational Training Home Economics II','1986','1972-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26549,'Occupational Training Merchandising I 10','1988','1971-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26550,'Occupational Training Shop A 20','2980','1972-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26551,'Occupational Training Shop I 10','1980','1972-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26552,'Occupational Training Shop II 10','1981','1972-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26553,'Occupational Training Shop III 10','1982','1972-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26554,'Occupational Training Shop IV 10','1983','1972-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26555,'Occupational Training Tutorial Academic','1993','1972-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26556,'Office Procedures 10','1765','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26557,'Office Procedures 10','1766','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26558,'Office Procedures 20','2764','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26559,'Office Procedures 20','2765','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26560,'Office Procedures 30','3764','1972-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26561,'Office Procedures 30','3765','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26562,'Office Procedures 30','3766','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26563,'Oilfield Operations 20L','6954','1997-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26564,'Old Testament Survey 20L','6800','1991-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26565,'Orchestra 10','1530','1950-09-01','2001-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26566,'Orchestra 10','1532','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26567,'Orchestra 10L','4539','2004-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26568,'Orchestra 20','2530','1950-09-01','2001-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26569,'Orchestra 20','2532','1950-09-01','2005-07-31','Departmentally Developed','11',NULL,NULL,NULL),(26570,'Orchestra 20L','6539','2004-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26571,'Orchestra 30','3530','1970-09-01','2001-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26572,'Orchestra 30','3532','1950-09-01','2005-07-31','Departmentally Developed','12',NULL,NULL,NULL),(26573,'Orchestra 30L','8539','2005-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26574,'Orient. scolaire et professionnelle 18','5424','1991-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(26575,'Orient. scolaire et professionnelle 28','7424','1991-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(26576,'Orient. scolaire et professionnelle 38','9424','1991-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(26577,'Orientation des carrieres 18','5447','1996-08-16','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(26578,'Orientation des carrieres 28','7447','1996-08-16','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(26579,'Orientation des carrieres 38','9447','1996-08-16','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(26580,'Orientation to Service Rigs 30L','9043','2017-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26581,'Outdoor Education 30L','8626','2017-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26582,'Oxy Acetylene Welding 30','8945','1997-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26583,'Paa:Internship 20L','6931','1996-08-16','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(26584,'Paa:Internship A 30L','8931','1996-08-16','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(26585,'Paa:Internship B 30L','8932','1996-08-16','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(26586,'Pacific Rim Studies 20L','2128','1990-09-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26587,'Paleontology 20L','7037','2014-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26588,'Parenting Skills 10L','1682','1991-08-21','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26589,'Parenting Skills 20L','7325','2002-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26590,'Parenting Skills 30L','9325','2011-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26591,'Parts Management 20L','7006','2006-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26592,'Parts Management 30L','9006','2006-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26593,'Persian 10L','4058','2000-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26594,'Persian 20L','6058','2000-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26595,'Persian 30L','8058','2000-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26596,'Personal Competence 30L','9507','2016-08-01','0000-00-00','Locally Developed Dual Credit','12',NULL,NULL,NULL),(26597,'Personal Finance 30L','9018','2010-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26598,'Personal Fitness 20L','6611','2009-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26599,'Personal Fitness 30L','8611','2009-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26600,'Photo-Graphics 10','4978','1999-08-16','2014-07-31','Departmentally Developed','10',NULL,NULL,NULL),(26601,'Photography 10','5019','2012-08-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26602,'Photography 10L','1801','1990-09-01','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(26603,'Photography 10L','1802','1989-10-19','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(26604,'Photography 20','6978','1999-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26605,'Photography 20L','2801','1990-09-01','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(26606,'Photography 20L','2802','1989-10-19','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(26607,'Photography 30','8978','1999-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26608,'Photography 30L','3801','1990-09-01','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(26609,'Photography 30L','3802','1989-10-19','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(26610,'Physical Education 10','1305','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26611,'Physical Education 10','1314','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26612,'Physical Education 10','1315','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26613,'Physical Education 10','4603','1992-08-16','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26614,'Physical Education 18','5476','2009-08-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(26615,'Physical Education 20','2310','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26616,'Physical Education 20','2314','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26617,'Physical Education 20','2315','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26618,'Physical Education 20','6603','1992-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26619,'Physical Education 20L','2318','1990-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26620,'Physical Education 21','2313','1950-09-01','1997-08-15','Locally Modified Down','11',NULL,NULL,NULL),(26621,'Physical Education 28','7476','2009-08-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(26622,'Physical Education 28','7499','2017-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(26623,'Physical Education 30','3310','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26624,'Physical Education 30','3314','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26625,'Physical Education 30','3315','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26626,'Physical Education 30','8603','1992-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26627,'Physical Education 31','3313','1991-09-01','1997-08-15','Locally Modified Down','12',NULL,NULL,NULL),(26628,'Physical Education 38','9476','2009-08-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(26629,'Physical Education 38','9499','2017-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(26630,'Physical Science 20','6247','2013-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26631,'Physical Science 20 (IB)','6263','2014-08-01','0000-00-00','International Baccalaureate','11',NULL,NULL,NULL),(26632,'Physical Science 21','6267','2016-01-01','0000-00-00','Locally Modified Down','11',NULL,NULL,NULL),(26633,'Physics (IB) 20L','6270','2015-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26634,'Physics 20','2245','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26635,'Physics 20','6213','1992-08-16','2015-07-31','Departmentally Developed','11',NULL,NULL,NULL),(26636,'Physics 20 (I)','6220','1992-08-16','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26637,'Physics 20 (IB)','6210','1989-08-15','1999-08-15','International Baccalaureate','11',NULL,NULL,NULL),(26638,'Physics 20 (IB)','6234','1997-08-16','2015-07-31','International Baccalaureate','11',NULL,NULL,NULL),(26639,'Physics 20A','6228','1996-08-16','2015-07-31','Locally Modified Up','11',NULL,NULL,NULL),(26640,'Physics 21','2244','1950-09-01','1997-08-15','Locally Modified Down','11',NULL,NULL,NULL),(26641,'Physics 21','6231','1996-08-16','2016-07-31','Locally Modified Down','11',NULL,NULL,NULL),(26642,'Physics 30','3245','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26643,'Physics 30','8213','1992-08-16','2016-08-31','Departmentally Developed','12',NULL,NULL,NULL),(26644,'Physics 30 (AP)','8238','2000-08-15','2016-08-31','Advanced Placement','12',NULL,NULL,NULL),(26645,'Physics 30 (AP)','8277','2016-08-01','0000-00-00','Advanced Placement','12',NULL,NULL,NULL),(26646,'Physics 30 (I)','8220','1993-08-16','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26647,'Physics 30 (IB)','8210','1989-08-15','1999-08-15','International Baccalaureate','12',NULL,NULL,NULL),(26648,'Physics 30 (IB)','8234','1997-08-16','2016-08-31','International Baccalaureate','12',NULL,NULL,NULL),(26649,'Physics 30 (IB)','8280','2016-08-01','0000-00-00','International Baccalaureate','12',NULL,NULL,NULL),(26650,'Physics 30 (new)','8257','2015-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26651,'Physics 30A','8228','1996-08-16','2016-08-31','Locally Modified Up','12',NULL,NULL,NULL),(26652,'Physics 31','3244','1950-09-01','1997-08-15','Locally Modified Down','12',NULL,NULL,NULL),(26653,'Physics 31','8231','1996-08-16','2016-08-31','Locally Modified Down','12',NULL,NULL,NULL),(26654,'Physics Preparation AP 30L','8274','2016-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26655,'Physics Pssc 20','2240','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26656,'Physics Pssc 20A','2241','1950-09-01','1997-08-15','Locally Modified Up','11',NULL,NULL,NULL),(26657,'Physics Pssc 21','2239','1950-09-01','1997-08-15','Locally Modified Down','11',NULL,NULL,NULL),(26658,'Physics Pssc 30','3240','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26659,'Physique 20','2247','1983-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26660,'Physique 20','6223','1993-08-16','2015-07-31','Departmentally Developed','11',NULL,NULL,NULL),(26661,'Physique 21','6239','2004-08-01','2016-08-31','Locally Modified Down','11',NULL,NULL,NULL),(26662,'Physique 30','3247','1983-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26663,'Physique 30','8223','1993-08-16','2016-08-31','Departmentally Developed','12',NULL,NULL,NULL),(26664,'Physique 30 (nouveau)','8260','2015-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26665,'Physique et en loisirs 30L','8602','1992-08-15','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26666,'Piping Trades 10L','4914','1990-08-21','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26667,'Piping Trades A 20L','6914','1990-08-21','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26668,'Piping Trades A 30L','8914','1990-09-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26669,'Piping Trades B 20L','6915','1990-09-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26670,'Piping Trades B 30L','8915','1990-09-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26671,'Piping and Sheet Metal 10L','5326','2002-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26672,'Piping and Sheet Metal A 20L','7327','2002-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26673,'Piping and Sheet Metal A 30L','9327','2002-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26674,'Piping and Sheet Metal B 20L','7328','2002-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26675,'Piping and Sheet Metal B 30L','9328','2002-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26676,'Plumbing and Heating 10L','5029','2014-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26677,'Plumbing and Heating A 20L','7030','2014-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26678,'Plumbing and Heating A 30L','9030','2014-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26679,'Plumbing and Heating B 20L','7031','2014-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26680,'Plumbing and Heating B 30L','9031','2014-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26681,'Polish 10L','4015','1993-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26682,'Polish 20L','6015','1994-08-15','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26683,'Polish 30L','8015','1995-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26684,'Portuguese 10L','4062','2000-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26685,'Pottery 10L','4518','1992-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26686,'Power Engineering Class 4 A1 30L','9032','2014-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26687,'Power Engineering Class 4 A2 30L','9033','2014-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26688,'Power Engineering Class 4 B1 30L','9034','2014-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26689,'Power Engineering Class 4 B2 30L','9035','2014-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26690,'Practical & Applied Arts Survey A 10','4047','1998-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26691,'Practical & Applied Arts Survey A 20','6047','1998-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26692,'Practical & Applied Arts Survey A 30','8047','1998-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26693,'Practical & Applied Arts Survey B 10','4048','1998-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26694,'Practical & Applied Arts Survey B 20','6048','1998-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26695,'Practical & Applied Arts Survey B 30','8048','1998-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26696,'Practical Skills For Home Living 10L','4852','1992-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26697,'Practical and Applied Arts Survey A 18','5456','2006-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(26698,'Practical and Applied Arts Survey A 28','7456','2006-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(26699,'Practical and Applied Arts Survey A 38','9456','2006-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(26700,'Practical and Applied Arts Survey B 18','5457','2006-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(26701,'Practical and Applied Arts Survey B 28','7457','2006-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(26702,'Practical and Applied Arts Survey B 38','9457','2006-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(26703,'Prairie Management Conservation Studies 20L','7334','2008-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26704,'Pratiques agricoles 10','5102','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26705,'Pratiques agricoles 20','7102','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26706,'Pratiques agricoles 30','9102','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26707,'Prior Learning 30','9302','1995-08-16','0000-00-00','Prior Learning','12',NULL,NULL,NULL),(26708,'Profession: Intervevant en petite enfance 1 30L','9518','2018-08-01','0000-00-00','Locally Developed Dual Credit','12',NULL,NULL,NULL),(26709,'Projet special 10','5321','2001-08-16','2001-08-17','Departmentally Developed','10',NULL,NULL,NULL),(26710,'Projet special 20','7321','2001-08-16','2001-08-17','Departmentally Developed','11',NULL,NULL,NULL),(26711,'Projet special 30','9321','2001-08-16','2001-08-17','Departmentally Developed','12',NULL,NULL,NULL),(26712,'Projet spÃ©cial 10','5310','1999-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26713,'Projet spÃ©cial 20','7310','1999-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26714,'Projet spÃ©cial 30','9310','1999-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26715,'Psychologie 10L','4333','1998-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26716,'Psychologie 20','2333','1983-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26717,'Psychologie 20','6343','2006-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26718,'Psychologie 20L','6333','1998-08-16','2006-07-31','Locally Developed','11',NULL,NULL,NULL),(26719,'Psychologie 30','3333','1983-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26720,'Psychologie 30','8343','2005-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26721,'Psychologie 30L','8333','1998-08-16','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(26722,'Psychology 20','2330','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26723,'Psychology 20','2331','1950-09-01','2002-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26724,'Psychology 20','6340','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26725,'Psychology 30','3330','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26726,'Psychology 30','3331','1950-09-01','2002-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26727,'Psychology 30','8340','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26728,'Psychology 30 (AP)','8338','2000-08-15','0000-00-00','Advanced Placement','12',NULL,NULL,NULL),(26729,'Quilting 10L','5024','2013-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26730,'Radio Television Arts 20','2890','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26731,'Radio Television Arts 30','3890','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26732,'Record Keeping 10','1712','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26733,'Related Arts 10','1513','1975-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26734,'Related Arts 20','2513','1975-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26735,'Religions of the World 30L','8808','2016-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26736,'Research Methods for Independent Learning 20L','6304','1991-08-15','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26737,'Resource Management (Traditional) 10L','4984','1999-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26738,'Retailing 10','1742','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26739,'Robotics 10L','5016','2011-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26740,'Robotics 20L','7016','2010-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26741,'Robotics 30L','9016','2011-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26742,'Robotics Applications and Explorations 20L','7020','2012-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26743,'Robotics Applications and Explorations 28','7610','2017-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(26744,'Robotics Applications and Explorations 30L','9020','2013-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26745,'Robotics Applications and Explorations 38','9610','2017-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(26746,'Robotics and Automation 10','5047','2018-08-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26747,'Robotics and Automation 20','7047','2018-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26748,'Robotics and Automation 30','9047','2018-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26749,'Rsch Meth For Independent Learning 20L','7318','2001-08-16','2001-08-30','Locally Developed','11',NULL,NULL,NULL),(26750,'Russian 10','4068','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26751,'Russian 10L','1450','1972-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26752,'Russian 10L','4036','1997-08-16','2001-08-15','Locally Developed','10',NULL,NULL,NULL),(26753,'Russian 20','2450','1972-09-01','2001-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26754,'Russian 20L','6036','2001-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26755,'Russian 30','3450','1950-09-01','2001-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26756,'SantÃ© communautaire 10','5116','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26757,'SantÃ© communautaire 20','7116','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26758,'SantÃ© communautaire 30','9116','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26759,'Sask. Studies-Agriculture 10','1631','1975-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26760,'Sask. Studies-Agriculture 20','2631','1975-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26761,'Sask. Studies-Agriculture 30','3631','1975-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26762,'Saskatchewan Agriculture 20L','7008','2007-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26763,'Saskatchewan Context for EAL Students 20L','6352','2015-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26764,'Saulteaux 10L','4016','1993-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26765,'Saulteaux 20L','6016','1994-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26766,'Saulteaux 30L','8016','1995-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26767,'School To Work 10L','5313','1998-01-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26768,'School To Work 20L','7304','1997-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26769,'School To Work 30L','9313','1998-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26770,'Science (Physical) 10 (I)','4217','1991-08-16','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26771,'Science 10','1235','1948-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26772,'Science 10','4214','1992-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26773,'Science 10 (IB)','4206','1988-08-15','1999-08-15','International Baccalaureate','10',NULL,NULL,NULL),(26774,'Science 10 (IB)','4232','1997-08-16','0000-00-00','International Baccalaureate','10',NULL,NULL,NULL),(26775,'Science 10A','1236','1950-09-01','1997-08-15','Locally Modified Up','10',NULL,NULL,NULL),(26776,'Science 10A','4226','1995-08-15','0000-00-00','Locally Modified Up','10',NULL,NULL,NULL),(26777,'Science 10L','1239','1990-09-01','1999-08-15','Locally Developed','10',NULL,NULL,NULL),(26778,'Science 11','1234','1950-09-01','1997-08-15','Locally Modified Down','10',NULL,NULL,NULL),(26779,'Science 11','4221','1993-08-16','2016-07-31','Locally Modified Down','10',NULL,NULL,NULL),(26780,'Science 11 (2016)','4271','2016-08-01','0000-00-00','Locally Modified Down','10',NULL,NULL,NULL),(26781,'Science 18','5484','2017-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(26782,'Science 20','2235','1949-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26783,'Science 20A','2236','1949-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26784,'Science 20L','2238','1990-08-23','1999-08-15','Locally Developed','11',NULL,NULL,NULL),(26785,'Science 21','2234','1950-09-01','1999-08-15','Locally Developed','11',NULL,NULL,NULL),(26786,'Science 21','6221','1993-08-16','2018-07-31','Locally Modified Down','11',NULL,NULL,NULL),(26787,'Science 30','3235','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26788,'Science 31','3234','1950-09-01','1999-08-15','Locally Developed','12',NULL,NULL,NULL),(26789,'Science 31','8221','1993-08-16','2018-08-31','Locally Modified Down','12',NULL,NULL,NULL),(26790,'Science A 18','5406','1988-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(26791,'Science A 28','7406','1989-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(26792,'Science A 38','9406','1990-09-01','2017-12-31','Alternative Education','12',NULL,NULL,NULL),(26793,'Science B 18','5449','2000-08-16','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(26794,'Science B 28','7449','2000-08-16','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(26795,'Science B 38','9449','2000-08-16','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(26796,'Sciences 10','1238','1983-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26797,'Sciences 10','4224','1995-08-15','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26798,'Sciences 11','4215','2003-08-01','2017-01-31','Locally Modified Down','10',NULL,NULL,NULL),(26799,'Sciences 11 (2016)','4272','2016-08-01','0000-00-00','Locally Modified Down','10',NULL,NULL,NULL),(26800,'Sciences 18','5422','1991-09-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(26801,'Sciences 21','6215','1992-08-16','0000-00-00','Locally Modified Down','11',NULL,NULL,NULL),(26802,'Sciences 28','7422','1991-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(26803,'Sciences 38','9422','1991-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(26804,'Sciences de l\'environnement 20','6249','2013-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26805,'Sciences de l\'environnement 21 (2018)','6285','2018-08-01','0000-00-00','Locally Modified Down','11',NULL,NULL,NULL),(26806,'Sciences de l\'environnement 28','7603','2017-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(26807,'Sciences de la sante 28','7604','2017-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(26808,'Sciences de la santÃ© 20','6248','2013-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26809,'Sciences de la santÃ© 21','6273','2016-08-01','0000-00-00','Locally Modified Down','11',NULL,NULL,NULL),(26810,'Sciences de la terre 30','8252','2013-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26811,'Sciences humaines 10','1137','1987-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26812,'Sciences humaines 10','4313','1992-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26813,'Sciences humaines 20','2137','1987-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26814,'Sciences humaines 20','6313','1992-08-16','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26815,'Sciences humaines 30','3127','1987-09-01','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26816,'Sciences mÃ©dico-lÃ©gales 20L','7337','2011-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26817,'Sciences mÃ©dico-lÃ©gales 30L','9337','2011-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26818,'Sciences physiques 20','6250','2013-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26819,'Sciences physiques 21 (2018)','6284','2018-08-01','0000-00-00','Locally Modified Down','11',NULL,NULL,NULL),(26820,'Sciences sociales 11','4343','2003-08-01','0000-00-00','Locally Modified Down','10',NULL,NULL,NULL),(26821,'Sciences sociales 18','5445','1996-08-16','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(26822,'Sciences sociales 28','7445','1996-08-16','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(26823,'Sciences sociales 38','9445','1996-08-16','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(26824,'Sciences sociales fransaskois 10','4323','1996-09-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26825,'Sciences sociales fransaskois 11','4345','2006-08-01','0000-00-00','Locally Modified Down','10',NULL,NULL,NULL),(26826,'Sciences sociales fransaskois 18','5463','2006-08-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(26827,'Sciences sociales fransaskois 20','6323','1996-09-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26828,'Sciences sociales fransaskois 21','6345','2006-08-01','0000-00-00','Locally Modified Down','11',NULL,NULL,NULL),(26829,'Sciences sociales fransaskois 28','7463','2006-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(26830,'Sciences sociales fransaskois 30','8323','1995-08-15','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26831,'Sciences sociales fransaskois 31','8345','2006-08-01','0000-00-00','Locally Modified Down','12',NULL,NULL,NULL),(26832,'Sciences sociales fransaskois 38','9463','2006-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(26833,'Sciences sociales immersion 30','8324','1995-08-15','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26834,'Sciences sociales immersion 31','8355','2017-08-01','0000-00-00','Locally Modified Down','12',NULL,NULL,NULL),(26835,'Shorthand & Transcription 30','3753','1975-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26836,'Shorthand 10','1750','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26837,'Shorthand 10A','1751','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26838,'Shorthand 20','2748','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26839,'Shorthand 20','2749','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26840,'Shorthand 20','2750','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26841,'Shorthand 30','3749','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26842,'Shorthand 30','3750','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26843,'Shorthand 30','3751','1975-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26844,'Shorthand 30','3752','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26845,'Skills & Tools For Transition 20L','7002','2003-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26846,'Small Engine Mechanics 10L','5023','2013-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26847,'Soccer 10L','4625','2016-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26848,'Soccer 20L','6624','2016-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26849,'Social Justice: Gender and Sexual Diversity 20L','6628','2017-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26850,'Social Responsibility 20L','7017','2009-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26851,'Social Science A 18','5405','1988-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(26852,'Social Science A 28','7405','1989-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(26853,'Social Science A 38','9405','1990-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(26854,'Social Science B 18','5437','1993-08-16','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(26855,'Social Science B 28','7437','1993-08-16','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(26856,'Social Science B 38','9437','1993-08-15','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(26857,'Social Studies 10','1130','1948-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26858,'Social Studies 10','4307','1992-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26859,'Social Studies 10 (IB)','4302','1988-08-15','1999-08-15','International Baccalaureate','10',NULL,NULL,NULL),(26860,'Social Studies 10 (IB)','4326','1997-08-16','0000-00-00','International Baccalaureate','10',NULL,NULL,NULL),(26861,'Social Studies 10 SD','1125','1984-06-06','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26862,'Social Studies 10A','1131','1950-09-01','1997-08-15','Locally Modified Up','10',NULL,NULL,NULL),(26863,'Social Studies 10A','4322','1995-08-15','0000-00-00','Locally Modified Up','10',NULL,NULL,NULL),(26864,'Social Studies 10L','1127','1990-09-01','1999-08-15','Locally Developed','10',NULL,NULL,NULL),(26865,'Social Studies 11','1129','1950-09-01','1997-08-15','Locally Modified Down','10',NULL,NULL,NULL),(26866,'Social Studies 11','4318','1993-08-16','0000-00-00','Locally Modified Down','10',NULL,NULL,NULL),(26867,'Social Studies 18','5452','2006-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(26868,'Social Studies 20','2130','1946-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26869,'Social Studies 20','6307','1992-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26870,'Social Studies 20 (IB)','6302','1989-08-15','1999-08-15','International Baccalaureate','11',NULL,NULL,NULL),(26871,'Social Studies 20 (IB)','6326','1997-08-16','0000-00-00','International Baccalaureate','11',NULL,NULL,NULL),(26872,'Social Studies 20 SD','2125','1984-06-06','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26873,'Social Studies 20A','2131','1950-09-01','1997-08-15','Locally Modified Up','11',NULL,NULL,NULL),(26874,'Social Studies 20A','6322','1995-08-15','0000-00-00','Locally Modified Up','11',NULL,NULL,NULL),(26875,'Social Studies 20L','2127','1990-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26876,'Social Studies 21','2129','1950-09-01','1999-08-15','Locally Modified Down','11',NULL,NULL,NULL),(26877,'Social Studies 21','6318','1994-08-16','0000-00-00','Locally Modified Down','11',NULL,NULL,NULL),(26878,'Social Studies 28','7452','2006-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(26879,'Social Studies 30','3130','1950-09-01','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26880,'Social Studies 30 (IB)','8302','1989-08-15','1999-08-15','International Baccalaureate','12',NULL,NULL,NULL),(26881,'Social Studies 30 SD','3125','1984-06-06','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26882,'Social Studies 30: Canadian Studies','8307','1995-08-15','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26883,'Social Studies 30: Canadian Studies (IB)','8326','1997-08-16','0000-00-00','International Baccalaureate','12',NULL,NULL,NULL),(26884,'Social Studies 30A','3131','1950-09-01','1999-08-15','Locally Modified Up','12',NULL,NULL,NULL),(26885,'Social Studies 30A: Canadian Studies','8322','1995-08-15','0000-00-00','Locally Modified Up','12',NULL,NULL,NULL),(26886,'Social Studies 31','3129','1960-09-01','1999-08-15','Locally Modified Down','12',NULL,NULL,NULL),(26887,'Social Studies 31: Canadian Studies','8318','1996-08-16','0000-00-00','Locally Modified Down','12',NULL,NULL,NULL),(26888,'Social Studies 38','9452','2006-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(26889,'Social Studies Indian History 11','1132','1988-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26890,'Social Studies Indian History 21','2132','1972-09-01','1999-08-15','Locally Modified Down','11',NULL,NULL,NULL),(26891,'Social Studies Indian History 31','3132','1988-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26892,'Sociologie-psychologie 20L','6331','1998-08-16','2006-07-31','Locally Developed','11',NULL,NULL,NULL),(26893,'Sociology 10','1325','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26894,'Sociology 20','2325','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26895,'Sociology 20A','2326','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26896,'Sociology 20L','6315','1992-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26897,'Sociology 30','3325','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26898,'Sociology 30A','3326','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26899,'Sociology 30L','8315','1995-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26900,'Soins esthÃ©tiques 10','5117','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26901,'Soins esthÃ©tiques 20','7117','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26902,'Soins esthÃ©tiques 30','9117','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26903,'Spanish 10','1445','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26904,'Spanish 10','4074','2003-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26905,'Spanish 10L','1446','1990-09-01','2005-07-31','Locally Developed','10',NULL,NULL,NULL),(26906,'Spanish 20','2445','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26907,'Spanish 20','6074','2003-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26908,'Spanish 20L','2446','1991-08-01','2005-07-31','Locally Developed','11',NULL,NULL,NULL),(26909,'Spanish 30','3445','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26910,'Spanish 30','8074','2003-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26911,'Spanish 30L','3446','1992-08-16','2005-07-31','Locally Developed','12',NULL,NULL,NULL),(26912,'Special Project 10','5303','1997-08-15','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26913,'Special Project 20','7303','1997-08-15','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26914,'Special Project 30','9303','1997-08-15','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26915,'Sport Psychology 10L','4337','2000-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26916,'Sport Psychology 20L','6337','2000-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26917,'Sport Psychology 30L','8337','2000-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26918,'Sports Medicine 10L','5315','2001-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26919,'Sports Medicine 20L','7315','2007-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26920,'Stage pratique 1 30L','9519','2018-08-01','0000-00-00','Locally Developed Dual Credit','12',NULL,NULL,NULL),(26921,'Statistics 30L','8435','2012-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26922,'Strategic Communications 18','5401','1989-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(26923,'Strategic Communications 28','7401','1990-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(26924,'Strategic Communications 38','9401','1990-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(26925,'Student Assistant 20L','2281','1990-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26926,'Student Assistant 30L','3281','1990-09-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26927,'Studio Art 20L','6541','2007-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26928,'Studio Art 30L','8541','2007-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26929,'Tech Voc Education A 10L','4202','1990-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26930,'Tech Voc Education A 10L','4903','1991-09-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26931,'Tech Voc Education B 10L','4203','1990-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26932,'Tech Voc Education B 10L','4904','1991-09-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26933,'Tech Voc Education C 10L','4204','1990-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26934,'Tech Voc Education C 10L','4905','1991-09-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26935,'Technical 10','1803','1987-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26936,'Technical 10','1804','1987-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26937,'Technical 10','1806','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26938,'Technical 20','2805','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26939,'Technical 30','3805','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(26940,'Technical Arts 20L','6920','1992-01-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26941,'Technical/Vocational Education A 18','5415','1989-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(26942,'Technical/Vocational Education A 28','7415','1990-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(26943,'Technical/Vocational Education A 38','9415','1991-05-21','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(26944,'Technical/Vocational Education B 18','5435','1993-08-16','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(26945,'Technical/Vocational Education B 28','7435','1992-08-15','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(26946,'Technical/Vocational Education B 38','9435','1992-08-15','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(26947,'Technological Communications 30L','8701','1992-08-15','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(26948,'Technologie des communications 10','5118','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26949,'Technologie des communications 20','7118','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26950,'Technologie des communications 30','9118','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26951,'Technologies de l\'information 10','5214','2002-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26952,'Technologies de l\'information 20','7214','2002-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26953,'Technologies de l\'information 30','9214','2002-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26954,'Technologies de la construction 10','5119','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26955,'Technologies de la construction 20','7119','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26956,'Technologies de la construction 30','9119','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26957,'Technology 10L','4989','1999-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(26958,'Technology 20L','6989','1999-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26959,'Technology 30L','8989','1999-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26960,'Television 20L','2898','1989-10-19','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26961,'Television and Communications Techn 30L','8524','1995-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26962,'Television/Communication Arts 20L','6514','1992-08-15','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26963,'Television/Communication Arts 30L','8514','1992-08-15','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26964,'Theatre Art 20L','2514','1989-10-19','2004-07-31','Locally Developed','11',NULL,NULL,NULL),(26965,'Theatre Arts 20','6958','1998-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26966,'Theatre Arts 20','6974','1998-08-16','1999-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26967,'Theatre Arts 20 (IB)','6988','1999-08-16','0000-00-00','International Baccalaureate','11',NULL,NULL,NULL),(26968,'Theatre Arts 20L','6928','1994-08-16','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(26969,'Theatre Arts 30','8958','1998-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26970,'Theatre Arts 30','8974','1998-08-16','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26971,'Theatre Arts 30 (IB)','8988','2000-08-16','0000-00-00','International Baccalaureate','12',NULL,NULL,NULL),(26972,'Theory Of Knowledge (IB) 30L','8301','1991-08-15','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26973,'Tourism, Hospitality, & Entrepreneurship A 30','9209','1997-01-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26974,'Tourism, Hospitality, & Entrepreneurship B 30','9210','1997-01-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26975,'Tourisme 10','5120','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26976,'Tourisme 20','7120','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26977,'Tourisme 30','9120','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26978,'Trade Mathematics 30L','9320','2001-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26979,'Trades Measurement and Communication 30L','9007','2007-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(26980,'Traitement de l\'information 10','5207','1996-08-16','2003-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26981,'Traitement de l\'information 18','5443','1996-08-16','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(26982,'Traitement de l\'information 20','7207','1996-08-16','2003-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26983,'Traitement de l\'information 28','7443','1996-08-16','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(26984,'Traitement de l\'information 30','9207','1996-08-16','2003-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26985,'Traitement de l\'information 38','9443','1996-08-16','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(26986,'Transcription 30','3748','1975-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26987,'Transitions dans la vie 20','6601','1996-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26988,'Transitions dans la vie 30','8601','1996-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(26989,'Typewriting 10','1755','1948-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(26990,'Typewriting 10','1756','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(26991,'Typewriting 20','2755','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(26992,'Typewriting 20A','2756','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26993,'Typewriting 20L','2754','1990-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(26994,'Typewriting 30','3755','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(26995,'Typewriting 30L','9204','1991-08-21','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(26996,'U.S. History 20L','6320','1994-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(26997,'Ukrainian 10','1440','1950-09-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(26998,'Ukrainian 20','2440','1950-09-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(26999,'Ukrainian 30','3440','1963-09-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(27000,'Ukrainian Christian Ethics 10','4803','1997-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(27001,'Ukrainian Christian Ethics 20','6803','1997-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(27002,'Ukrainian Christian Ethics 30','8803','1997-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(27003,'Ukrainian Language Arts 10','4031','1997-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(27004,'Ukrainian Language Arts 20','6031','1997-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(27005,'Ukrainian Language Arts 30','8031','1997-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(27006,'Upholstery 10','4996','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(27007,'Upholstery 10L','4910','1990-08-21','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(27008,'Upholstery 20','6996','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(27009,'Upholstery 30','8996','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(27010,'Upholstery A 20L','6910','1990-08-21','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(27011,'Upholstery A 30L','8910','1990-09-01','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(27012,'Upholstery B 20L','6911','1990-09-01','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(27013,'Upholstery B 30L','8911','1990-09-01','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(27014,'Visual Art 10','4527','1997-07-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(27015,'Visual Art 10 (IB)','4531','1997-08-16','0000-00-00','International Baccalaureate','10',NULL,NULL,NULL),(27016,'Visual Art 18','5480','2015-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(27017,'Visual Art 20','6527','1997-08-15','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(27018,'Visual Art 20 (IB)','6531','1997-08-16','0000-00-00','International Baccalaureate','11',NULL,NULL,NULL),(27019,'Visual Art 28','7480','2015-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(27020,'Visual Art 30','8527','1997-08-15','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(27021,'Visual Art 30 (AP)','8543','2010-08-01','0000-00-00','Advanced Placement','12',NULL,NULL,NULL),(27022,'Visual Art 30 (IB)','8531','1997-08-16','0000-00-00','International Baccalaureate','12',NULL,NULL,NULL),(27023,'Visual Art 38','9480','2015-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(27024,'Visual Arts 30L','9317','2001-08-16','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(27025,'Visually Impaired Life Skills 30L','8311','1992-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(27026,'Vocal Jazz 10','4546','2013-08-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(27027,'Vocal Jazz 10L','4530','1997-08-16','2015-07-31','Locally Developed','10',NULL,NULL,NULL),(27028,'Vocal Jazz 20','6546','2013-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(27029,'Vocal Jazz 20L','6530','1997-08-16','2015-07-31','Locally Developed','11',NULL,NULL,NULL),(27030,'Vocal Jazz 30','8546','2013-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(27031,'Vocal Jazz 30L','8530','1997-08-16','2015-07-31','Locally Developed','12',NULL,NULL,NULL),(27032,'Vocational Agriculture 10','1973','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(27033,'Vocational Agriculture 20','2973','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(27034,'Volleyball L2 30L','9516','2016-08-01','0000-00-00','Locally Developed Dual Credit','12',NULL,NULL,NULL),(27035,'Welding 10','1865','1987-05-07','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(27036,'Welding 10','1866','1987-05-07','2002-08-15','Departmentally Developed','10',NULL,NULL,NULL),(27037,'Welding 10','1867','1987-05-07','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(27038,'Welding 10','1869','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(27039,'Welding 10','1870','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(27040,'Welding 10','1896','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(27041,'Welding 10','1953','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(27042,'Welding 10','1954','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(27043,'Welding 10','1955','1975-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(27044,'Welding 10','1956','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(27045,'Welding 10','1957','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(27046,'Welding 10','4943','1997-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(27047,'Welding 10','4971','1998-08-16','1999-08-15','Departmentally Developed','10',NULL,NULL,NULL),(27048,'Welding 10L','1877','1989-09-01','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(27049,'Welding 10L','1878','1989-10-19','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(27050,'Welding 18','5475','2009-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(27051,'Welding 20','2865','1987-05-07','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(27052,'Welding 20','2866','1987-05-07','2002-08-15','Departmentally Developed','11',NULL,NULL,NULL),(27053,'Welding 20','2867','1987-05-07','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(27054,'Welding 20','2870','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(27055,'Welding 20','2871','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(27056,'Welding 20','2896','1988-02-10','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(27057,'Welding 20','2953','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(27058,'Welding 20','2954','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(27059,'Welding 20','2955','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(27060,'Welding 20','2956','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(27061,'Welding 20','2957','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(27062,'Welding 20','2981','1972-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(27063,'Welding 20','2982','1950-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(27064,'Welding 20','6943','1997-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(27065,'Welding 20','6971','1998-08-16','1999-08-15','Departmentally Developed','11',NULL,NULL,NULL),(27066,'Welding 20L','2877','1989-10-19','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(27067,'Welding 28','7475','2009-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(27068,'Welding 30','3865','1987-05-07','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(27069,'Welding 30','3866','1987-05-07','2002-08-15','Departmentally Developed','12',NULL,NULL,NULL),(27070,'Welding 30','3867','1987-05-07','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(27071,'Welding 30','3869','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(27072,'Welding 30','3870','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(27073,'Welding 30','3896','1988-02-10','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(27074,'Welding 30','3953','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(27075,'Welding 30','3954','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(27076,'Welding 30','3955','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(27077,'Welding 30','3956','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(27078,'Welding 30','3957','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(27079,'Welding 30','3981','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(27080,'Welding 30','3982','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(27081,'Welding 30','8971','1998-08-16','1999-08-15','Departmentally Developed','12',NULL,NULL,NULL),(27082,'Welding 30L','3877','1989-10-19','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(27083,'Welding 38','9475','2009-08-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(27084,'Welding A 20L','2878','1989-10-19','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(27085,'Welding A 30','8943','1997-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(27086,'Welding A 30L','3878','1989-10-19','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(27087,'Welding A 38','9496','2017-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(27088,'Welding B 20L','6925','1993-08-16','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(27089,'Welding B 30','3961','1950-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(27090,'Welding B 30','8937','1997-01-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(27091,'Welding B 30L','8925','1993-08-16','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(27092,'Welding B 38','9497','2017-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(27093,'Wellness 10','4600','1991-08-15','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(27094,'Wellness 18','5460','2006-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(27095,'Wildlife Management 10','4993','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(27096,'Wildlife Management 10L','5211','1997-08-16','2011-07-31','Locally Developed','10',NULL,NULL,NULL),(27097,'Wildlife Management 20','6993','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(27098,'Wildlife Management 20L','7211','1997-08-16','2011-07-31','Locally Developed','11',NULL,NULL,NULL),(27099,'Wildlife Management 30','8993','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(27100,'Wildlife Management 30L','9211','1997-08-16','2011-07-31','Locally Developed','12',NULL,NULL,NULL),(27101,'Woods Cree Cultural Activities 10L','4510','1990-08-16','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(27102,'Woods Cree Cultural Activities 20L','6510','1991-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(27103,'Woods Cree Cultural Activities 30L','8510','1991-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(27104,'Woodworking 10','1849','1950-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(27105,'Woodworking 10','1850','1950-09-01','1997-08-15','Departmentally Developed','10',NULL,NULL,NULL),(27106,'Woodworking 10L','1851','1990-05-03','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(27107,'Woodworking 10L','1852','1990-05-03','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(27108,'Woodworking 20','2850','1950-09-01','1997-08-15','Departmentally Developed','11',NULL,NULL,NULL),(27109,'Woodworking 20L','2852','1990-05-03','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(27110,'Woodworking 30','3850','1950-09-01','1997-08-15','Departmentally Developed','12',NULL,NULL,NULL),(27111,'Woodworking 30L','3852','1990-05-03','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(27112,'Word Processing 20L','2767','1990-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(27113,'Work Experience Education 18','5409','1990-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(27114,'Work Experience Education 28','7409','1990-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(27115,'Work Experience Education 38','9409','1990-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(27116,'Work Experience Education A 10','1994','1983-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(27117,'Work Experience Education A 10','5300','1993-05-01','2005-07-31','Departmentally Developed','10',NULL,NULL,NULL),(27118,'Work Experience Education A 10L','1996','1990-08-23','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(27119,'Work Experience Education A 18','5410','1989-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(27120,'Work Experience Education A 20','2994','1983-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(27121,'Work Experience Education A 20','7300','1993-02-01','2005-07-31','Departmentally Developed','11',NULL,NULL,NULL),(27122,'Work Experience Education A 20L','2996','1990-08-23','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(27123,'Work Experience Education A 28','7410','1989-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(27124,'Work Experience Education A 30','3994','1983-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(27125,'Work Experience Education A 30','9300','1993-02-01','2005-07-31','Departmentally Developed','12',NULL,NULL,NULL),(27126,'Work Experience Education A 30L','3996','1990-08-23','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(27127,'Work Experience Education A 38','9410','1990-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(27128,'Work Experience Education B 10','1995','1983-09-01','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(27129,'Work Experience Education B 10','5301','1993-05-01','2005-07-31','Departmentally Developed','10',NULL,NULL,NULL),(27130,'Work Experience Education B 10L','1997','1990-08-23','1997-08-15','Locally Developed','10',NULL,NULL,NULL),(27131,'Work Experience Education B 18','5411','1990-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(27132,'Work Experience Education B 20','2995','1983-09-01','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(27133,'Work Experience Education B 20','7301','1993-05-01','2005-07-31','Departmentally Developed','11',NULL,NULL,NULL),(27134,'Work Experience Education B 20L','2997','1990-08-23','1997-08-15','Locally Developed','11',NULL,NULL,NULL),(27135,'Work Experience Education B 28','7411','1989-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(27136,'Work Experience Education B 30','3995','1983-09-01','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(27137,'Work Experience Education B 30','9301','1993-05-01','2005-07-31','Departmentally Developed','12',NULL,NULL,NULL),(27138,'Work Experience Education B 30L','3997','1990-08-23','1997-08-15','Locally Developed','12',NULL,NULL,NULL),(27139,'Work Experience Education B 38','9411','1990-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(27140,'World Literature (IB) 20L','6051','1998-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(27141,'World Religions (IB) 30L','8353','2015-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(27142,'World Religions 30L','8342','2002-08-16','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(27143,'World Religions 30L','9319','2001-08-16','2002-08-15','Locally Developed','12',NULL,NULL,NULL),(27144,'Yoga 10L','4622','2015-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(27145,'littÃ©ratie financiÃ¨re 20','7046','2018-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(27146,'littÃ©ratie financiÃ¨re 30','9046','2018-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(27147,'nehiyawewin (Cree) 10','4084','2006-08-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(27148,'nehiyawewin (Cree) 18','5481','2015-08-01','0000-00-00','Alternative Education','10',NULL,NULL,NULL),(27149,'nehiyawewin (Cree) 20','6084','2006-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(27150,'nehiyawewin (Cree) 28','7481','2015-08-01','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(27151,'nehiyawewin (Cree) 30','8084','2006-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(27152,'nehiyawewin (Cree) 38','9481','2015-08-01','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(27153,'robotique et automatisation 10','5048','2018-08-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(27154,'robotique et automatisation 20','7048','2018-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(27155,'robotique et automatisation 30','9048','2018-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(27156,'Ã‰ducation artistique 10','4500','1990-09-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(27157,'Ã‰ducation artistique 10L','4509','1990-08-15','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(27158,'Ã‰ducation artistique 18','5429','1991-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(27159,'Ã‰ducation artistique 20','6500','1992-08-15','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(27160,'Ã‰ducation artistique 20L','6509','1997-08-15','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(27161,'Ã‰ducation artistique 28','7429','1991-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(27162,'Ã‰ducation artistique 30','8500','1993-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(27163,'Ã‰ducation artistique 30L','8509','1997-08-15','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(27164,'Ã‰ducation artistique 38','9429','1991-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(27165,'Ã‰ducation chrÃ©tienne 10','4805','1998-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(27166,'Ã‰ducation chrÃ©tienne 18','5428','1991-09-01','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(27167,'Ã‰ducation chrÃ©tienne 20','6805','1998-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(27168,'Ã‰ducation chrÃ©tienne 28','7428','1991-09-01','2017-07-31','Alternative Education','11',NULL,NULL,NULL),(27169,'Ã‰ducation chrÃ©tienne 30','8805','1998-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(27170,'Ã‰ducation chrÃ©tienne 38','9428','1991-09-01','2017-07-31','Alternative Education','12',NULL,NULL,NULL),(27171,'Ã‰ducation physique 18','5448','1996-08-16','2017-07-31','Alternative Education','10',NULL,NULL,NULL),(27172,'Ã‰ducation physique 20','6604','1996-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(27173,'Ã‰ducation physique 28','7448','1996-08-16','0000-00-00','Alternative Education','11',NULL,NULL,NULL),(27174,'Ã‰ducation physique 30','8604','1996-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(27175,'Ã‰ducation physique 38','9448','1996-08-16','0000-00-00','Alternative Education','12',NULL,NULL,NULL),(27176,'Ã‰lectro-technologies 10','5105','2000-08-16','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(27177,'Ã‰lectro-technologies 20','7105','2000-08-16','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(27178,'Ã‰lectro-technologies 30','9105','2000-08-16','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(27179,'Ã‰thique et Ã©ducation Ã¡ la citoyennetÃ© 10L','5050','2018-08-01','0000-00-00','Locally Developed','10',NULL,NULL,NULL),(27180,'Ã‰thique et Ã©ducation Ã¡ la citoyennetÃ© 20L','7050','2018-08-01','0000-00-00','Locally Developed','11',NULL,NULL,NULL),(27181,'Ã‰thique et Ã©ducation Ã¡ la citoyennetÃ© 30L','9050','2018-08-01','0000-00-00','Locally Developed','12',NULL,NULL,NULL),(27182,'Ã‰tudes catholiques 10','4809','2018-08-01','0000-00-00','Departmentally Developed','10',NULL,NULL,NULL),(27183,'Ã‰tudes catholiques 20','6809','2018-08-01','0000-00-00','Departmentally Developed','11',NULL,NULL,NULL),(27184,'Ã‰tudes catholiques 30','8809','2018-08-01','0000-00-00','Departmentally Developed','12',NULL,NULL,NULL),(27185,'Ã‰tudes de la francophonie 20L','6073','2002-08-16','0000-00-00','Locally Developed','11',NULL,NULL,NULL);
/*!40000 ALTER TABLE `sasked_courses` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `schedat`
--

DROP TABLE IF EXISTS `schedat`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `schedat` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `day` tinyint(4) DEFAULT NULL,
  `period` tinyint(4) DEFAULT NULL,
  `subjsec` varchar(32) DEFAULT NULL,
  `term` tinyint(3) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `schedat`
--

LOCK TABLES `schedat` WRITE;
/*!40000 ALTER TABLE `schedat` DISABLE KEYS */;
/*!40000 ALTER TABLE `schedat` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `schoolevent`
--

DROP TABLE IF EXISTS `schoolevent`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `schoolevent` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` date DEFAULT NULL,
  `communityevents` text,
  `staffupdates` text,
  `dataupdates` text,
  `resourcespending` text,
  `facilityupdates` text,
  `otherupdates` text,
  `upcomingevents` text,
  `landedu` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=18 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `schoolevent`
--

LOCK TABLES `schoolevent` WRITE;
/*!40000 ALTER TABLE `schoolevent` DISABLE KEYS */;
/*!40000 ALTER TABLE `schoolevent` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sessions`
--

DROP TABLE IF EXISTS `sessions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sessions` (
  `id` varchar(32) NOT NULL DEFAULT '',
  `a_session` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sessions`
--

LOCK TABLES `sessions` WRITE;
/*!40000 ALTER TABLE `sessions` DISABLE KEYS */;
/*!40000 ALTER TABLE `sessions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ssp_exceptions`
--

DROP TABLE IF EXISTS `ssp_exceptions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ssp_exceptions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studnum` int(11) DEFAULT NULL,
  `treatynum` varchar(16) DEFAULT NULL,
  `ssptype` varchar(16) DEFAULT NULL,
  `tdate` date DEFAULT NULL,
  `tauthor` varchar(40) DEFAULT NULL,
  `tgrade` varchar(8) DEFAULT NULL,
  `tage` varchar(16) DEFAULT NULL,
  `tseason` varchar(16) DEFAULT NULL,
  `tstamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `reasoncode` varchar(32) DEFAULT NULL,
  `reasonother` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ssp_exceptions`
--

LOCK TABLES `ssp_exceptions` WRITE;
/*!40000 ALTER TABLE `ssp_exceptions` DISABLE KEYS */;
/*!40000 ALTER TABLE `ssp_exceptions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `staff`
--

DROP TABLE IF EXISTS `staff`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `staff` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sal` varchar(6) DEFAULT NULL,
  `lastname` varchar(60) DEFAULT NULL,
  `firstname` varchar(40) DEFAULT NULL,
  `middlename` varchar(40) DEFAULT NULL,
  `userid` varchar(40) DEFAULT NULL,
  `password` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `tdate` date DEFAULT NULL,
  `doatt` char(1) DEFAULT NULL,
  `certification1` varchar(255) DEFAULT NULL,
  `home_phone` varchar(64) DEFAULT NULL,
  `cell_phone` varchar(64) DEFAULT NULL,
  `street` varchar(64) DEFAULT NULL,
  `city` varchar(32) DEFAULT NULL,
  `prov` varchar(32) DEFAULT NULL,
  `pcode` varchar(32) DEFAULT NULL,
  `emergency_contact_name` varchar(255) DEFAULT NULL,
  `emergency_contact_phone` varchar(255) DEFAULT NULL,
  `driver_license` varchar(64) DEFAULT NULL,
  `driver_class` varchar(64) DEFAULT NULL,
  `vehicle_reg` varchar(64) DEFAULT NULL,
  `vehicle_plate` varchar(64) DEFAULT NULL,
  `citizenship` varchar(64) DEFAULT NULL,
  `passport` varchar(64) DEFAULT NULL,
  `alt_street` varchar(64) DEFAULT NULL,
  `alt_city` varchar(32) DEFAULT NULL,
  `alt_prov` varchar(32) DEFAULT NULL,
  `alt_country` varchar(64) DEFAULT NULL,
  `alt_pcode` varchar(32) DEFAULT NULL,
  `alt_phone` varchar(64) DEFAULT NULL,
  `alt_email` varchar(64) DEFAULT NULL,
  `certification2` varchar(255) DEFAULT NULL,
  `certification3` varchar(255) DEFAULT NULL,
  `certification4` varchar(255) DEFAULT NULL,
  `certification5` varchar(255) DEFAULT NULL,
  `certification6` varchar(255) DEFAULT NULL,
  `certification7` varchar(255) DEFAULT NULL,
  `certification8` varchar(255) DEFAULT NULL,
  `ldap_uid` varchar(64) DEFAULT NULL,
  `ldap_uidnumber` mediumint(9) DEFAULT NULL,
  `ldap_gidnumber` mediumint(9) DEFAULT NULL,
  `teachingcertificatestatus` varchar(16) DEFAULT NULL,
  `teachingcertificatejurisdiction` varchar(16) DEFAULT NULL,
  `ancestry` varchar(16) DEFAULT NULL,
  `indianstatus` varchar(16) DEFAULT NULL,
  `gender` varchar(16) DEFAULT NULL,
  `birthdate` date DEFAULT NULL,
  `fulltimeequivalent` varchar(16) DEFAULT NULL,
  `occupations` text,
  `nrskip` char(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `staff`
--

LOCK TABLES `staff` WRITE;
/*!40000 ALTER TABLE `staff` DISABLE KEYS */;
/*!40000 ALTER TABLE `staff` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `staff_absent`
--

DROP TABLE IF EXISTS `staff_absent`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `staff_absent` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` varchar(40) DEFAULT NULL,
  `lastname` varchar(60) DEFAULT NULL,
  `firstname` varchar(40) DEFAULT NULL,
  `adate` date DEFAULT NULL,
  `reason` varchar(32) DEFAULT NULL,
  `daypart` varchar(32) DEFAULT NULL,
  `other` varchar(255) DEFAULT NULL,
  `late` varchar(32) DEFAULT NULL,
  `comment` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `staff_absent`
--

LOCK TABLES `staff_absent` WRITE;
/*!40000 ALTER TABLE `staff_absent` DISABLE KEYS */;
/*!40000 ALTER TABLE `staff_absent` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `staff_leave`
--

DROP TABLE IF EXISTS `staff_leave`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `staff_leave` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` varchar(32) DEFAULT NULL,
  `category` varchar(64) DEFAULT NULL,
  `hours` varchar(8) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `staff_leave`
--

LOCK TABLES `staff_leave` WRITE;
/*!40000 ALTER TABLE `staff_leave` DISABLE KEYS */;
/*!40000 ALTER TABLE `staff_leave` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `staff_multi`
--

DROP TABLE IF EXISTS `staff_multi`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `staff_multi` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` varchar(32) DEFAULT NULL,
  `field_name` varchar(255) DEFAULT NULL,
  `field_value` varchar(255) DEFAULT NULL,
  `field_additional` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `staff_multi`
--

LOCK TABLES `staff_multi` WRITE;
/*!40000 ALTER TABLE `staff_multi` DISABLE KEYS */;
/*!40000 ALTER TABLE `staff_multi` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `staff_payjrl`
--

DROP TABLE IF EXISTS `staff_payjrl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `staff_payjrl` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` varchar(32) DEFAULT NULL,
  `date` date DEFAULT NULL,
  `category` varchar(64) DEFAULT NULL,
  `hours` varchar(8) DEFAULT NULL,
  `comment` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `staff_payjrl`
--

LOCK TABLES `staff_payjrl` WRITE;
/*!40000 ALTER TABLE `staff_payjrl` DISABLE KEYS */;
/*!40000 ALTER TABLE `staff_payjrl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `staff_transfer`
--

DROP TABLE IF EXISTS `staff_transfer`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `staff_transfer` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` varchar(40) DEFAULT NULL,
  `date` date DEFAULT NULL,
  `type` varchar(32) DEFAULT NULL,
  `lastname` varchar(60) DEFAULT NULL,
  `firstname` varchar(40) DEFAULT NULL,
  `certificatenumber` varchar(255) DEFAULT NULL,
  `description` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `staff_transfer`
--

LOCK TABLES `staff_transfer` WRITE;
/*!40000 ALTER TABLE `staff_transfer` DISABLE KEYS */;
/*!40000 ALTER TABLE `staff_transfer` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `staffwd`
--

DROP TABLE IF EXISTS `staffwd`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `staffwd` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sal` varchar(6) DEFAULT NULL,
  `lastname` varchar(60) DEFAULT NULL,
  `firstname` varchar(40) DEFAULT NULL,
  `middlename` varchar(40) DEFAULT NULL,
  `userid` varchar(40) DEFAULT NULL,
  `password` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `tdate` date DEFAULT NULL,
  `doatt` char(1) DEFAULT NULL,
  `certification1` varchar(255) DEFAULT NULL,
  `home_phone` varchar(64) DEFAULT NULL,
  `cell_phone` varchar(64) DEFAULT NULL,
  `street` varchar(64) DEFAULT NULL,
  `city` varchar(32) DEFAULT NULL,
  `prov` varchar(32) DEFAULT NULL,
  `pcode` varchar(32) DEFAULT NULL,
  `emergency_contact_name` varchar(255) DEFAULT NULL,
  `emergency_contact_phone` varchar(255) DEFAULT NULL,
  `driver_license` varchar(64) DEFAULT NULL,
  `driver_class` varchar(64) DEFAULT NULL,
  `vehicle_reg` varchar(64) DEFAULT NULL,
  `vehicle_plate` varchar(64) DEFAULT NULL,
  `citizenship` varchar(64) DEFAULT NULL,
  `passport` varchar(64) DEFAULT NULL,
  `alt_street` varchar(64) DEFAULT NULL,
  `alt_city` varchar(32) DEFAULT NULL,
  `alt_prov` varchar(32) DEFAULT NULL,
  `alt_country` varchar(64) DEFAULT NULL,
  `alt_pcode` varchar(32) DEFAULT NULL,
  `alt_phone` varchar(64) DEFAULT NULL,
  `alt_email` varchar(64) DEFAULT NULL,
  `certification2` varchar(255) DEFAULT NULL,
  `certification3` varchar(255) DEFAULT NULL,
  `certification4` varchar(255) DEFAULT NULL,
  `certification5` varchar(255) DEFAULT NULL,
  `certification6` varchar(255) DEFAULT NULL,
  `certification7` varchar(255) DEFAULT NULL,
  `certification8` varchar(255) DEFAULT NULL,
  `ldap_uid` varchar(64) DEFAULT NULL,
  `ldap_uidnumber` mediumint(9) DEFAULT NULL,
  `ldap_gidnumber` mediumint(9) DEFAULT NULL,
  `teachingcertificatestatus` varchar(16) DEFAULT NULL,
  `teachingcertificatejurisdiction` varchar(16) DEFAULT NULL,
  `ancestry` varchar(16) DEFAULT NULL,
  `indianstatus` varchar(16) DEFAULT NULL,
  `gender` varchar(16) DEFAULT NULL,
  `birthdate` date DEFAULT NULL,
  `fulltimeequivalent` varchar(16) DEFAULT NULL,
  `occupations` text,
  `nrskip` char(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `staffwd`
--

LOCK TABLES `staffwd` WRITE;
/*!40000 ALTER TABLE `staffwd` DISABLE KEYS */;
/*!40000 ALTER TABLE `staffwd` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `student`
--

DROP TABLE IF EXISTS `student`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `student` (
  `studid` int(11) NOT NULL AUTO_INCREMENT,
  `lastname` varchar(40) DEFAULT NULL,
  `firstname` varchar(40) DEFAULT NULL,
  `initial` varchar(40) DEFAULT NULL,
  `studnum` int(11) DEFAULT NULL,
  `grade` varchar(8) DEFAULT NULL,
  `homeroom` varchar(8) DEFAULT NULL,
  `sex` char(1) DEFAULT NULL,
  `birthdate` date DEFAULT NULL,
  `house` varchar(20) DEFAULT NULL,
  `healthid` varchar(12) DEFAULT NULL,
  `entry` varchar(255) DEFAULT NULL,
  `ethnic` varchar(20) DEFAULT NULL,
  `single` char(1) DEFAULT NULL,
  `internet` char(1) DEFAULT NULL,
  `youngest` char(1) DEFAULT NULL,
  `owing` decimal(9,2) DEFAULT NULL,
  `treaty` varchar(20) DEFAULT NULL,
  `medical` mediumtext,
  `studrel` varchar(25) DEFAULT NULL,
  `momrel` varchar(25) DEFAULT NULL,
  `dadrel` varchar(25) DEFAULT NULL,
  `parish` varchar(255) DEFAULT NULL,
  `commun` char(1) DEFAULT NULL,
  `recon` char(1) DEFAULT NULL,
  `confirm` char(1) DEFAULT NULL,
  `maiden` varchar(40) DEFAULT NULL,
  `relation1` varchar(20) DEFAULT NULL,
  `contact1` varchar(255) DEFAULT NULL,
  `name1` varchar(255) DEFAULT NULL,
  `hphone1` varchar(64) DEFAULT NULL,
  `wphone1` varchar(64) DEFAULT NULL,
  `cell1` varchar(64) DEFAULT NULL,
  `fax1` varchar(64) DEFAULT NULL,
  `address1` varchar(40) DEFAULT NULL,
  `city1` varchar(40) DEFAULT NULL,
  `pcode1` varchar(10) DEFAULT NULL,
  `workplace1` varchar(60) DEFAULT NULL,
  `relation2` varchar(20) DEFAULT NULL,
  `contact2` varchar(255) DEFAULT NULL,
  `name2` varchar(255) DEFAULT NULL,
  `hphone2` varchar(64) DEFAULT NULL,
  `wphone2` varchar(64) DEFAULT NULL,
  `cell2` varchar(64) DEFAULT NULL,
  `fax2` varchar(64) DEFAULT NULL,
  `address2` varchar(40) DEFAULT NULL,
  `city2` varchar(40) DEFAULT NULL,
  `pcode2` varchar(10) DEFAULT NULL,
  `workplace2` varchar(60) DEFAULT NULL,
  `emrelation` varchar(20) DEFAULT NULL,
  `emname` varchar(255) DEFAULT NULL,
  `emhphone` varchar(64) DEFAULT NULL,
  `emwphone` varchar(64) DEFAULT NULL,
  `emcell` varchar(64) DEFAULT NULL,
  `doctor` varchar(70) DEFAULT NULL,
  `docphone` varchar(15) DEFAULT NULL,
  `busroute` varchar(30) DEFAULT NULL,
  `provnum` varchar(12) DEFAULT NULL,
  `band` varchar(64) DEFAULT NULL,
  `bandnum` varchar(32) DEFAULT NULL,
  `baptism` char(1) DEFAULT NULL,
  `contact` varchar(255) DEFAULT NULL,
  `family` varchar(32) DEFAULT NULL,
  `alias` varchar(16) DEFAULT NULL,
  `pic` varchar(255) DEFAULT NULL,
  `password` varchar(32) DEFAULT NULL,
  `field1` varchar(255) DEFAULT NULL,
  `field2` varchar(255) DEFAULT NULL,
  `field3` varchar(255) DEFAULT NULL,
  `prov1` varchar(32) DEFAULT NULL,
  `prov2` varchar(32) DEFAULT NULL,
  `reserveres` varchar(64) DEFAULT NULL,
  `program` varchar(64) DEFAULT NULL,
  `utag` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `trans_type` varchar(255) DEFAULT NULL,
  `trans_name` varchar(255) DEFAULT NULL,
  `trans_am_route` varchar(64) DEFAULT NULL,
  `trans_pickup_time` varchar(16) DEFAULT NULL,
  `trans_pm_route` varchar(64) DEFAULT NULL,
  `trans_dropoff_time` varchar(16) DEFAULT NULL,
  `trans_bus_stop_location` varchar(64) DEFAULT NULL,
  `group_after_school_prog` char(1) DEFAULT NULL,
  `lunchstatus` varchar(255) DEFAULT NULL,
  `par1_email` varchar(64) DEFAULT NULL,
  `par2_email` varchar(64) DEFAULT NULL,
  `name_prefix` varchar(64) DEFAULT NULL,
  `name_suffix` varchar(64) DEFAULT NULL,
  `name_knownas` varchar(64) DEFAULT NULL,
  `group_alt1` varchar(64) DEFAULT NULL,
  `group_alt2` varchar(64) DEFAULT NULL,
  `group_alt3` varchar(64) DEFAULT NULL,
  `billet` varchar(255) DEFAULT NULL,
  `childcare_name` varchar(255) DEFAULT NULL,
  `childcare_address` varchar(255) DEFAULT NULL,
  `childcare_phone1` varchar(255) DEFAULT NULL,
  `childcare_phone2` varchar(255) DEFAULT NULL,
  `internet_type` varchar(255) DEFAULT NULL,
  `par1_firstname` varchar(255) DEFAULT NULL,
  `par1_lastname` varchar(255) DEFAULT NULL,
  `par2_firstname` varchar(255) DEFAULT NULL,
  `par2_lastname` varchar(255) DEFAULT NULL,
  `graddate` date DEFAULT NULL,
  `ldap_uid` varchar(64) DEFAULT NULL,
  `ldap_uidnumber` mediumint(9) DEFAULT NULL,
  `ldap_gidnumber` mediumint(9) DEFAULT NULL,
  `address_land` varchar(32) DEFAULT NULL,
  `tuition_status` varchar(64) DEFAULT NULL,
  `tuition_duration` varchar(64) DEFAULT NULL,
  `tuition_program` varchar(128) DEFAULT NULL,
  `tuition_collect` tinyint(4) DEFAULT NULL,
  `tuition_country` varchar(8) DEFAULT NULL,
  `immersion_type` varchar(32) DEFAULT NULL,
  `cumfolder` tinyint(4) DEFAULT NULL,
  `address1mailing` varchar(128) DEFAULT NULL,
  `address2mailing` varchar(128) DEFAULT NULL,
  `parent_lockout` varchar(8) DEFAULT NULL,
  PRIMARY KEY (`studid`),
  KEY `student_name` (`lastname`,`firstname`),
  KEY `student_grade` (`grade`),
  KEY `student_homeroom` (`homeroom`),
  KEY `student_studnum` (`studnum`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `student`
--

LOCK TABLES `student` WRITE;
/*!40000 ALTER TABLE `student` DISABLE KEYS */;
/*!40000 ALTER TABLE `student` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `student_inac`
--

DROP TABLE IF EXISTS `student_inac`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `student_inac` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studnum` varchar(32) DEFAULT NULL,
  `fte` varchar(255) DEFAULT NULL,
  `residence` varchar(255) DEFAULT NULL,
  `accommodation` varchar(255) DEFAULT NULL,
  `transportation_daily` varchar(255) DEFAULT NULL,
  `transportation_other` varchar(255) DEFAULT NULL,
  `language_instruction` varchar(255) DEFAULT NULL,
  `financial_edu` varchar(16) DEFAULT NULL,
  `residence_band` varchar(16) DEFAULT NULL,
  `residence_reserve` varchar(16) DEFAULT NULL,
  `schoolprogram` varchar(16) DEFAULT NULL,
  `programdelivery` varchar(16) DEFAULT NULL,
  `serviceprovision` varchar(16) DEFAULT NULL,
  `programcompletedprevyear` char(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `student_inac`
--

LOCK TABLES `student_inac` WRITE;
/*!40000 ALTER TABLE `student_inac` DISABLE KEYS */;
/*!40000 ALTER TABLE `student_inac` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `student_medical`
--

DROP TABLE IF EXISTS `student_medical`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `student_medical` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studnum` int(11) DEFAULT NULL,
  `category` varchar(255) DEFAULT NULL,
  `description` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `student_medical`
--

LOCK TABLES `student_medical` WRITE;
/*!40000 ALTER TABLE `student_medical` DISABLE KEYS */;
/*!40000 ALTER TABLE `student_medical` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `student_needs`
--

DROP TABLE IF EXISTS `student_needs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `student_needs` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `author` varchar(40) DEFAULT NULL,
  `date` date DEFAULT NULL,
  `tstamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `studnum` int(11) DEFAULT NULL,
  `treatynum` int(11) DEFAULT NULL,
  `lastname` varchar(40) DEFAULT NULL,
  `firstname` varchar(40) DEFAULT NULL,
  `birthdate` date DEFAULT NULL,
  `grade` varchar(8) DEFAULT NULL,
  `hrteacher` varchar(255) DEFAULT NULL,
  `strengths` text,
  `challenges` text,
  `support` text,
  `recommendations` text,
  `rec_other` text,
  `rec_classroom` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `student_needs`
--

LOCK TABLES `student_needs` WRITE;
/*!40000 ALTER TABLE `student_needs` DISABLE KEYS */;
/*!40000 ALTER TABLE `student_needs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `student_nomrollwd`
--

DROP TABLE IF EXISTS `student_nomrollwd`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `student_nomrollwd` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studnum` varchar(32) DEFAULT NULL,
  `fte` varchar(255) DEFAULT NULL,
  `residence` varchar(255) DEFAULT NULL,
  `accommodation` varchar(255) DEFAULT NULL,
  `transportation_daily` varchar(255) DEFAULT NULL,
  `transportation_other` varchar(255) DEFAULT NULL,
  `language_instruction` varchar(255) DEFAULT NULL,
  `financial_edu` varchar(16) DEFAULT NULL,
  `residence_band` varchar(16) DEFAULT NULL,
  `residence_reserve` varchar(16) DEFAULT NULL,
  `schoolprogram` varchar(16) DEFAULT NULL,
  `programdelivery` varchar(16) DEFAULT NULL,
  `serviceprovision` varchar(16) DEFAULT NULL,
  `programcompletedprevyear` char(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `student_nomrollwd`
--

LOCK TABLES `student_nomrollwd` WRITE;
/*!40000 ALTER TABLE `student_nomrollwd` DISABLE KEYS */;
/*!40000 ALTER TABLE `student_nomrollwd` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Temporary table structure for view `studentall`
--

DROP TABLE IF EXISTS `studentall`;
/*!50001 DROP VIEW IF EXISTS `studentall`*/;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
/*!50001 CREATE TABLE `studentall` (
  `studid` tinyint NOT NULL,
  `lastname` tinyint NOT NULL,
  `firstname` tinyint NOT NULL,
  `initial` tinyint NOT NULL,
  `studnum` tinyint NOT NULL,
  `grade` tinyint NOT NULL,
  `homeroom` tinyint NOT NULL,
  `sex` tinyint NOT NULL,
  `birthdate` tinyint NOT NULL,
  `house` tinyint NOT NULL,
  `healthid` tinyint NOT NULL,
  `entry` tinyint NOT NULL,
  `ethnic` tinyint NOT NULL,
  `single` tinyint NOT NULL,
  `internet` tinyint NOT NULL,
  `youngest` tinyint NOT NULL,
  `owing` tinyint NOT NULL,
  `treaty` tinyint NOT NULL,
  `medical` tinyint NOT NULL,
  `studrel` tinyint NOT NULL,
  `momrel` tinyint NOT NULL,
  `dadrel` tinyint NOT NULL,
  `parish` tinyint NOT NULL,
  `commun` tinyint NOT NULL,
  `recon` tinyint NOT NULL,
  `confirm` tinyint NOT NULL,
  `maiden` tinyint NOT NULL,
  `relation1` tinyint NOT NULL,
  `contact1` tinyint NOT NULL,
  `name1` tinyint NOT NULL,
  `hphone1` tinyint NOT NULL,
  `wphone1` tinyint NOT NULL,
  `cell1` tinyint NOT NULL,
  `fax1` tinyint NOT NULL,
  `address1` tinyint NOT NULL,
  `city1` tinyint NOT NULL,
  `pcode1` tinyint NOT NULL,
  `workplace1` tinyint NOT NULL,
  `relation2` tinyint NOT NULL,
  `contact2` tinyint NOT NULL,
  `name2` tinyint NOT NULL,
  `hphone2` tinyint NOT NULL,
  `wphone2` tinyint NOT NULL,
  `cell2` tinyint NOT NULL,
  `fax2` tinyint NOT NULL,
  `address2` tinyint NOT NULL,
  `city2` tinyint NOT NULL,
  `pcode2` tinyint NOT NULL,
  `workplace2` tinyint NOT NULL,
  `emrelation` tinyint NOT NULL,
  `emname` tinyint NOT NULL,
  `emhphone` tinyint NOT NULL,
  `emwphone` tinyint NOT NULL,
  `emcell` tinyint NOT NULL,
  `doctor` tinyint NOT NULL,
  `docphone` tinyint NOT NULL,
  `busroute` tinyint NOT NULL,
  `provnum` tinyint NOT NULL,
  `band` tinyint NOT NULL,
  `bandnum` tinyint NOT NULL,
  `baptism` tinyint NOT NULL,
  `contact` tinyint NOT NULL,
  `family` tinyint NOT NULL,
  `alias` tinyint NOT NULL,
  `pic` tinyint NOT NULL,
  `password` tinyint NOT NULL,
  `field1` tinyint NOT NULL,
  `field2` tinyint NOT NULL,
  `field3` tinyint NOT NULL,
  `prov1` tinyint NOT NULL,
  `prov2` tinyint NOT NULL,
  `reserveres` tinyint NOT NULL,
  `program` tinyint NOT NULL,
  `utag` tinyint NOT NULL,
  `email` tinyint NOT NULL,
  `trans_type` tinyint NOT NULL,
  `trans_name` tinyint NOT NULL,
  `trans_am_route` tinyint NOT NULL,
  `trans_pickup_time` tinyint NOT NULL,
  `trans_pm_route` tinyint NOT NULL,
  `trans_dropoff_time` tinyint NOT NULL,
  `trans_bus_stop_location` tinyint NOT NULL,
  `group_after_school_prog` tinyint NOT NULL,
  `lunchstatus` tinyint NOT NULL,
  `par1_email` tinyint NOT NULL,
  `par2_email` tinyint NOT NULL,
  `name_prefix` tinyint NOT NULL,
  `name_suffix` tinyint NOT NULL,
  `name_knownas` tinyint NOT NULL,
  `group_alt1` tinyint NOT NULL,
  `group_alt2` tinyint NOT NULL,
  `group_alt3` tinyint NOT NULL,
  `billet` tinyint NOT NULL,
  `childcare_name` tinyint NOT NULL,
  `childcare_address` tinyint NOT NULL,
  `childcare_phone1` tinyint NOT NULL,
  `childcare_phone2` tinyint NOT NULL,
  `internet_type` tinyint NOT NULL,
  `par1_firstname` tinyint NOT NULL,
  `par1_lastname` tinyint NOT NULL,
  `par2_firstname` tinyint NOT NULL,
  `par2_lastname` tinyint NOT NULL,
  `graddate` tinyint NOT NULL,
  `ldap_uid` tinyint NOT NULL,
  `ldap_uidnumber` tinyint NOT NULL,
  `ldap_gidnumber` tinyint NOT NULL,
  `address_land` tinyint NOT NULL,
  `tuition_status` tinyint NOT NULL,
  `tuition_duration` tinyint NOT NULL,
  `tuition_program` tinyint NOT NULL,
  `tuition_collect` tinyint NOT NULL,
  `tuition_country` tinyint NOT NULL,
  `immersion_type` tinyint NOT NULL,
  `cumfolder` tinyint NOT NULL,
  `address1mailing` tinyint NOT NULL,
  `address2mailing` tinyint NOT NULL,
  `parent_lockout` tinyint NOT NULL
) ENGINE=MyISAM */;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `studentwd`
--

DROP TABLE IF EXISTS `studentwd`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `studentwd` (
  `studid` int(11) NOT NULL AUTO_INCREMENT,
  `lastname` varchar(40) DEFAULT NULL,
  `firstname` varchar(40) DEFAULT NULL,
  `initial` varchar(40) DEFAULT NULL,
  `studnum` int(11) DEFAULT NULL,
  `grade` varchar(8) DEFAULT NULL,
  `homeroom` varchar(8) DEFAULT NULL,
  `sex` char(1) DEFAULT NULL,
  `birthdate` date DEFAULT NULL,
  `house` varchar(20) DEFAULT NULL,
  `healthid` varchar(12) DEFAULT NULL,
  `entry` varchar(255) DEFAULT NULL,
  `ethnic` varchar(20) DEFAULT NULL,
  `single` char(1) DEFAULT NULL,
  `internet` char(1) DEFAULT NULL,
  `youngest` char(1) DEFAULT NULL,
  `owing` decimal(9,2) DEFAULT NULL,
  `treaty` varchar(20) DEFAULT NULL,
  `medical` mediumtext,
  `studrel` varchar(25) DEFAULT NULL,
  `momrel` varchar(25) DEFAULT NULL,
  `dadrel` varchar(25) DEFAULT NULL,
  `parish` varchar(255) DEFAULT NULL,
  `commun` char(1) DEFAULT NULL,
  `recon` char(1) DEFAULT NULL,
  `confirm` char(1) DEFAULT NULL,
  `maiden` varchar(40) DEFAULT NULL,
  `relation1` varchar(20) DEFAULT NULL,
  `contact1` varchar(255) DEFAULT NULL,
  `name1` varchar(255) DEFAULT NULL,
  `hphone1` varchar(64) DEFAULT NULL,
  `wphone1` varchar(64) DEFAULT NULL,
  `cell1` varchar(64) DEFAULT NULL,
  `fax1` varchar(64) DEFAULT NULL,
  `address1` varchar(40) DEFAULT NULL,
  `city1` varchar(40) DEFAULT NULL,
  `pcode1` varchar(10) DEFAULT NULL,
  `workplace1` varchar(60) DEFAULT NULL,
  `relation2` varchar(20) DEFAULT NULL,
  `contact2` varchar(255) DEFAULT NULL,
  `name2` varchar(255) DEFAULT NULL,
  `hphone2` varchar(64) DEFAULT NULL,
  `wphone2` varchar(64) DEFAULT NULL,
  `cell2` varchar(64) DEFAULT NULL,
  `fax2` varchar(64) DEFAULT NULL,
  `address2` varchar(40) DEFAULT NULL,
  `city2` varchar(40) DEFAULT NULL,
  `pcode2` varchar(10) DEFAULT NULL,
  `workplace2` varchar(60) DEFAULT NULL,
  `emrelation` varchar(20) DEFAULT NULL,
  `emname` varchar(255) DEFAULT NULL,
  `emhphone` varchar(64) DEFAULT NULL,
  `emwphone` varchar(64) DEFAULT NULL,
  `emcell` varchar(64) DEFAULT NULL,
  `doctor` varchar(70) DEFAULT NULL,
  `docphone` varchar(15) DEFAULT NULL,
  `busroute` varchar(30) DEFAULT NULL,
  `provnum` varchar(12) DEFAULT NULL,
  `band` varchar(64) DEFAULT NULL,
  `bandnum` varchar(32) DEFAULT NULL,
  `baptism` char(1) DEFAULT NULL,
  `contact` varchar(255) DEFAULT NULL,
  `family` varchar(32) DEFAULT NULL,
  `alias` varchar(16) DEFAULT NULL,
  `pic` varchar(255) DEFAULT NULL,
  `password` varchar(32) DEFAULT NULL,
  `field1` varchar(255) DEFAULT NULL,
  `field2` varchar(255) DEFAULT NULL,
  `field3` varchar(255) DEFAULT NULL,
  `prov1` varchar(32) DEFAULT NULL,
  `prov2` varchar(32) DEFAULT NULL,
  `reserveres` varchar(64) DEFAULT NULL,
  `program` varchar(64) DEFAULT NULL,
  `utag` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `trans_type` varchar(255) DEFAULT NULL,
  `trans_name` varchar(255) DEFAULT NULL,
  `trans_am_route` varchar(64) DEFAULT NULL,
  `trans_pickup_time` varchar(16) DEFAULT NULL,
  `trans_pm_route` varchar(64) DEFAULT NULL,
  `trans_dropoff_time` varchar(16) DEFAULT NULL,
  `trans_bus_stop_location` varchar(64) DEFAULT NULL,
  `group_after_school_prog` char(1) DEFAULT NULL,
  `lunchstatus` varchar(255) DEFAULT NULL,
  `par1_email` varchar(64) DEFAULT NULL,
  `par2_email` varchar(64) DEFAULT NULL,
  `name_prefix` varchar(64) DEFAULT NULL,
  `name_suffix` varchar(64) DEFAULT NULL,
  `name_knownas` varchar(64) DEFAULT NULL,
  `group_alt1` varchar(64) DEFAULT NULL,
  `group_alt2` varchar(64) DEFAULT NULL,
  `group_alt3` varchar(64) DEFAULT NULL,
  `billet` varchar(255) DEFAULT NULL,
  `childcare_name` varchar(255) DEFAULT NULL,
  `childcare_address` varchar(255) DEFAULT NULL,
  `childcare_phone1` varchar(255) DEFAULT NULL,
  `childcare_phone2` varchar(255) DEFAULT NULL,
  `internet_type` varchar(255) DEFAULT NULL,
  `par1_firstname` varchar(255) DEFAULT NULL,
  `par1_lastname` varchar(255) DEFAULT NULL,
  `par2_firstname` varchar(255) DEFAULT NULL,
  `par2_lastname` varchar(255) DEFAULT NULL,
  `graddate` date DEFAULT NULL,
  `ldap_uid` varchar(64) DEFAULT NULL,
  `ldap_uidnumber` mediumint(9) DEFAULT NULL,
  `ldap_gidnumber` mediumint(9) DEFAULT NULL,
  `address_land` varchar(32) DEFAULT NULL,
  `tuition_status` varchar(64) DEFAULT NULL,
  `tuition_duration` varchar(64) DEFAULT NULL,
  `tuition_program` varchar(128) DEFAULT NULL,
  `tuition_collect` tinyint(4) DEFAULT NULL,
  `tuition_country` varchar(8) DEFAULT NULL,
  `immersion_type` varchar(32) DEFAULT NULL,
  `cumfolder` tinyint(4) DEFAULT NULL,
  `address1mailing` varchar(128) DEFAULT NULL,
  `address2mailing` varchar(128) DEFAULT NULL,
  `parent_lockout` varchar(8) DEFAULT NULL,
  PRIMARY KEY (`studid`),
  KEY `studentwd_name` (`lastname`,`firstname`),
  KEY `studentwd_grade` (`grade`),
  KEY `studentwd_homeroom` (`homeroom`),
  KEY `studentwd_studnum` (`studnum`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `studentwd`
--

LOCK TABLES `studentwd` WRITE;
/*!40000 ALTER TABLE `studentwd` DISABLE KEYS */;
/*!40000 ALTER TABLE `studentwd` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `subject`
--

DROP TABLE IF EXISTS `subject`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `subject` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `subjcode` varchar(32) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `grade` varchar(8) DEFAULT NULL,
  `teacher` varchar(255) DEFAULT NULL,
  `modules` varchar(255) DEFAULT NULL,
  `type` varchar(10) DEFAULT NULL,
  `sequence` int(11) DEFAULT NULL,
  `section` varchar(32) DEFAULT NULL,
  `subjsec` varchar(32) DEFAULT NULL,
  `q1` varchar(255) DEFAULT NULL,
  `q2` varchar(255) DEFAULT NULL,
  `q3` varchar(255) DEFAULT NULL,
  `q4` varchar(255) DEFAULT NULL,
  `q5` varchar(255) DEFAULT NULL,
  `q6` varchar(255) DEFAULT NULL,
  `q7` varchar(255) DEFAULT NULL,
  `q8` varchar(255) DEFAULT NULL,
  `q9` varchar(255) DEFAULT NULL,
  `q10` varchar(255) DEFAULT NULL,
  `q11` varchar(255) DEFAULT NULL,
  `q12` varchar(255) DEFAULT NULL,
  `q13` varchar(255) DEFAULT NULL,
  `q14` varchar(255) DEFAULT NULL,
  `q15` varchar(255) DEFAULT NULL,
  `q16` varchar(255) DEFAULT NULL,
  `q17` varchar(255) DEFAULT NULL,
  `q18` varchar(255) DEFAULT NULL,
  `q19` varchar(255) DEFAULT NULL,
  `q20` varchar(255) DEFAULT NULL,
  `alias` varchar(16) DEFAULT NULL,
  `visible` char(1) DEFAULT NULL,
  `startrptperiod` tinyint(3) unsigned DEFAULT NULL,
  `endrptperiod` tinyint(3) unsigned DEFAULT NULL,
  `markscheme` text,
  `faculty` varchar(255) DEFAULT NULL,
  `location` varchar(255) DEFAULT NULL,
  `smdesc` varchar(8) DEFAULT NULL,
  `instmode` varchar(64) DEFAULT NULL,
  `exammix` varchar(64) DEFAULT NULL,
  `active` char(1) DEFAULT NULL,
  `schedppc1` int(11) DEFAULT NULL,
  `schedppc2` int(11) DEFAULT NULL,
  `schedppc3` int(11) DEFAULT NULL,
  `schedppc4` int(11) DEFAULT NULL,
  `backwith` varchar(16) DEFAULT NULL,
  `credit` varchar(8) DEFAULT NULL,
  `difficulty` varchar(8) DEFAULT NULL,
  `area` varchar(255) DEFAULT NULL,
  `calcavg` char(1) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `subject_subjsec` (`subjsec`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `subject`
--

LOCK TABLES `subject` WRITE;
/*!40000 ALTER TABLE `subject` DISABLE KEYS */;
/*!40000 ALTER TABLE `subject` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `subject_multi`
--

DROP TABLE IF EXISTS `subject_multi`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `subject_multi` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `subjsec` varchar(32) DEFAULT NULL,
  `field_name` varchar(255) DEFAULT NULL,
  `field_value` varchar(255) DEFAULT NULL,
  `field_additional` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `subject_multi`
--

LOCK TABLES `subject_multi` WRITE;
/*!40000 ALTER TABLE `subject_multi` DISABLE KEYS */;
/*!40000 ALTER TABLE `subject_multi` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tattend`
--

DROP TABLE IF EXISTS `tattend`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tattend` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` varchar(40) DEFAULT NULL,
  `attdate` date DEFAULT NULL,
  `currdate` datetime DEFAULT NULL,
  `subjects` varchar(255) DEFAULT NULL,
  `periods` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tattend`
--

LOCK TABLES `tattend` WRITE;
/*!40000 ALTER TABLE `tattend` DISABLE KEYS */;
/*!40000 ALTER TABLE `tattend` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `temp_conf_system`
--

DROP TABLE IF EXISTS `temp_conf_system`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `temp_conf_system` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `filename` varchar(64) DEFAULT NULL,
  `sectionname` varchar(64) DEFAULT NULL,
  `sequenceval` int(11) DEFAULT NULL,
  `dataname` varchar(64) DEFAULT NULL,
  `datatype` varchar(32) DEFAULT NULL,
  `datavalue` text,
  `hashvar` varchar(64) DEFAULT NULL,
  `version` varchar(16) DEFAULT NULL,
  `description` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=287 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `temp_conf_system`
--

LOCK TABLES `temp_conf_system` WRITE;
/*!40000 ALTER TABLE `temp_conf_system` DISABLE KEYS */;
INSERT INTO `temp_conf_system` VALUES (1,'admin','attendance',100,'g_ppd','hash','%g_ppd = (\'6\' => \'2\',\'11\' => \'5\',\'PK\' => \'2\',\'3\' => \'2\',\'7\' => \'2\',\'K\' => \'2\',\'9\' => \'2\',\'12\' => \'5\',\'2\' => \'2\',\'8\' => \'2\',\'4\' => \'2\',\'1\' => \'2\',\'10\' => \'5\',\'5\' => \'2\');',NULL,'5.25','The number of Periods Per Day (PPD) taken for attendance at each particular grade/form level. A PPD of \'2\' means that only a morning and afternoon attendance is done. Do not change any values here during the school year since this will throw off attendance reports, etc. Change only from one year to the next.'),(2,'admin','attendance',102,'g_AttendanceEntryMethod','hash','%g_AttendanceEntryMethod = (\'6\' => \'homeroom\',\'11\' => \'subject\',\'PK\' => \'homeroom\',\'3\' => \'homeroom\',\'7\' => \'homeroom\',\'K\' => \'homeroom\',\'9\' => \'homeroom\',\'12\' => \'subject\',\'2\' => \'homeroom\',\'8\' => \'homeroom\',\'4\' => \'homeroom\',\'1\' => \'homeroom\',\'10\' => \'subject\',\'5\' => \'homeroom\');',NULL,NULL,'Maps the grade to an attendance entry method, homeroom or subject '),(3,'admin','attendance',105,'attend','array','@attend = (\'Absent Unexcused\',\'Absent Excused\',\'Absent Illness\',\'Absent Moved\',\'Absent Suspension\',\'Late Unexcused\',\'Late Excused\');',NULL,'5.25','The list of all attendance reasons in display order. Do not alter ordering unless you also update the \'points\' for these as well, since the ordering must match between these 2 values.'),(4,'admin','attendance',110,'absentUnexcused','scalar','$absentUnexcused = \'Absent Unexcused\';',NULL,'5.25','The main attendance reason text for \'Absent Unexcused\'.'),(5,'admin','attendance',115,'absentString','scalar','$absentString = \'Absent\';',NULL,'5.25','Text string that matches the \'Absent\' part of the attendance reasons. '),(6,'admin','attendance',120,'lateUnexcused','scalar','$lateUnexcused = \'Late Unexcused\';',NULL,'5.25','The text value for a Late Unexcused reason.'),(7,'admin','attendance',125,'lateString','scalar','$lateString = \'Late\';',NULL,'5.25','The text value for \'Late\' in attendance reasons.'),(8,'admin','attendance',130,'points','array','@points = (\'3\',\'1\',\'1\',\'1\',\'1\',\'1\',\'1\');',NULL,'5.25','The points that match in order each of the attendance reasons stored in the attend variable. '),(9,'admin','attendance',135,'trigger','hash','%trigger = (\'6\' => \'Absence (Two)\',\'18\' => \'Absence (Six)\',\'30\' => \'Absence (Ten)\',\'24\' => \'Absence (Eight)\',\'12\' => \'Absence (Four)\');',NULL,'5.25','These are the number of attendance point triggers and their matching text description. '),(10,'admin','attendance',140,'ignore_reason','array','@ignore_reason = (5,6);',NULL,'5.25','The attendance reasons to ignore when doing a search for perfect attendance. These values are the array index values for the reason and they start at 0.'),(11,'admin','attendance',150,'formletter','hash','%formletter = (\'6\' => \'discipline.tex\',\'18\' => \'discipline.tex\',\'30\' => \'withdraw.tex\',\'24\' => \'discipline.tex\',\'12\' => \'discipline.tex\');',NULL,'5.25','The number of points required to trigger a particular form letter (stored in the templates folder) These values are total from the \'points\' variable that map to each particular attendance reason. (attend variable)'),(12,'admin','dates',400,'month','array','@month = (\'\', \'January\', \'February\', \'March\', \'April\', \'May\', \'June\', \'July\', \'August\', \'September\', \'October\', \'November\', \'December\');',NULL,'5.25','Months of the Year. They are 1 based (not zero based). Do not change, other than for translation.'),(13,'admin','dates',405,'s_month','array','@s_month = (\'\', \'Jan\', \'Feb\', \'Mar\', \'Apr\', \'May\', \'Jun\', \'Jul\', \'Aug\', \'Sep\', \'Oct\', \'Nov\', \'Dec\');',NULL,'5.25','Short Month Values. They are 1 based. (ie. $s_month[1] = \'Jan\' ).'),(14,'admin','dates',410,'dow','array','@dow = (\'\',\'Sunday\', \'Monday\', \'Tuesday\', \'Wednesday\', \'Thursday\', \'Friday\', \'Saturday\');',NULL,'5.25','Day of Week values (longer form) with a 1 value being Sunday.'),(15,'admin','dates',412,'dowstd','array','@dowstd = (\'Sunday\', \'Monday\', \'Tuesday\', \'Wednesday\', \'Thursday\', \'Friday\', \'Saturday\');',NULL,'10.5','Day of Week values (longer form) with a 0 value being Sunday.'),(16,'admin','dates',415,'s_dow','array','@s_dow = (\'\',\'Sun\',\'Mon\',\'Tue\',\'Wed\',\'Thu\',\'Fri\',\'Sat\');',NULL,'5.25','Short Day of the Week Values. They are 1 based with first day being Sunday.'),(17,'admin','dates',420,'g_DaysPerCycle','scalar','$g_DaysPerCycle = \'1\';',NULL,'5.25','The number of days in a school cycle until it repeats.'),(18,'admin','dates',425,'g_ResetCycleDate','hash','%g_ResetCycleDate = (\'2010-11-30\'=> \'2\');',NULL,'5.75','These are dates on which the cycle is reset to a new starting value. Following dates then follow this day in normal cycle format. If we reset Monday to a Day 3 in a 5 day cycle (for some reason), then Tuesday would be day 4, Wednesday Day 5, and Thursday would be Day 1 (restarting the cycle). '),(19,'admin','discipline',1400,'g_DiscInfraction','hash','%g_DiscInfraction = (\'Skipping classes\' => \'1\',\'Left grounds w/o permission\' => \'1\',\'Uncooperative- Defiant\' => \'1\',\'Destructive to school property\' => \'1\',\'Bullying other students\' => \'1\',\'Disrespectful and uncooperative\' => \'1\',\'Substance Abuse violation\' => \'1\',\'Gang Related\' => \'1\',\'Defacing school property\' => \'1\',\'Smoking in restricted areas\' => \'1\',\'Defiance- Skipping in-school suspension\' => \'1\',\'Brought a weapon to school\' => \'1\',\'Rude / discourteous\' => \'1\',\'Unacceptable language\' => \'1\',\'Excessive talking\' => \'1\',\'Smoking when not permitted to do so\' => \'1\',\'Student Placed on Contract\' => \'1\',\'Excessive tardiness\' => \'1\',\'Fighting\' => \'1\');',NULL,'','This variable lists all infractions for the discipline system.'),(20,'admin','discipline',1410,'g_DiscAction','array','@g_DiscAction = (\'reviewed student\\\'s file\',\'had conference with student\',\'consulted counsellor\',\'consulted elder\');',NULL,'','This variable lists actions taken by the school.'),(21,'admin','Email',1500,'g_EmailAuthId','scalar','$g_EmailAuthId = \'user\';',NULL,NULL,'The email userid with access to the mail server.'),(22,'admin','Email',1510,'g_EmailAuthPwd','scalar','$g_EmailAuthPwd = \'password \';',NULL,NULL,'The password for access to the mail server.'),(23,'admin','Email',1520,'g_EmailPort','scalar','$g_EmailPort = \'587\';',NULL,NULL,'The port address to use for communication to the mail server. Port 25 is the typical port for unencrypted traffic. Port 587 is used for encrypted TLS traffic.'),(24,'admin','Email',1530,'g_EmailServer','scalar','$g_EmailServer = \'localhost\';',NULL,NULL,'The DNS name or IP address of the mail server. Defaults to localhost.'),(25,'admin','Email',1540,'g_EmailUseTLS','scalar','$g_EmailUseTLS = \'1\';',NULL,NULL,'A zero or one value to turn off or on the use of encrypted TLS communication. Also requires a port change as well'),(26,'admin','Email',1550,'g_EmailPersona','hash','%g_EmailPersona = (\'noreply\' => \'No Reply <noreply@school.org>\');',NULL,NULL,'The various persona used when sending email via scripts.'),(27,'admin','homevisit',100,'g_HomeVisitReason','array','@g_HomeVisitReason = (\'Attendance\', \'Suspension/Explusion\', \'Illness\', \'Mental Health Concern\', \'Parent Pickup for Meeting\', \'Student Service Related (Parent/Guardian Signature)\', \'Bus Issue\', \'Other\');',NULL,'10.5','The list of all home visit reasons in display order.'),(28,'admin','IEP',100,'g_MasteryLevel','array','@g_MasteryLevel = (\'50%\',\'75%\',\'95%\');',NULL,'','The Mastery Level required for objectives in the IEP system.'),(29,'admin','language',500,'doctype','scalar','$doctype = \'<!DOCTYPE html>\';',NULL,'5.25','The version of HTML sent by scripts. Currently HTML 4.01 Transitional.'),(30,'admin','language',505,'langcode','scalar','$langcode = \'en\';',NULL,'5.25','Not used, yet.'),(31,'admin','language',510,'language','scalar','$language = \'English\';',NULL,'5.25','The current language. Not used, yet.'),(32,'admin','language',515,'charset','scalar','$charset = \'UTF-8\';',NULL,'5.25','The character set that is sent when sending pages from scripts. This value is sent using the cgi->header(-charset,$charset) function.'),(33,'admin','language',525,'chartype','scalar','$chartype = \'<meta charset=\"UTF-8\">\';',NULL,'5.25','The value sent by scripts as part of the html page \'head\' section.'),(34,'admin','pagelayout',600,'defaultpapersize','scalar','$defaultpapersize = \'letterpaper\';',NULL,'5.25','The default value for the size of paper. Many scripts (but not all) will use this to speed up paper selection. The values are: letterpaper, a4paper, legalpaper.'),(35,'admin','pagelayout',605,'g_letterpaper_textheight','scalar','$g_letterpaper_textheight = \'246mm\';',NULL,'5.25','Text Height for Letter Paper.'),(36,'admin','pagelayout',610,'g_letterpaper_textwidth','scalar','$g_letterpaper_textwidth = \'190mm\';',NULL,'5.25','Text Width for Letter Paper.'),(37,'admin','pagelayout',615,'g_legalpaper_textheight','scalar','$g_legalpaper_textheight = \'325mm\';',NULL,'5.25','Text Height for Legal Paper.'),(38,'admin','pagelayout',620,'g_legalpaper_textwidth','scalar','$g_legalpaper_textwidth = \'190mm\';',NULL,'5.25','Text Width for Legal Paper'),(39,'admin','pagelayout',625,'g_a4paper_textheight','scalar','$g_a4paper_textheight = \'272mm\';',NULL,'5.25','Text Height for A4 paper.'),(40,'admin','pagelayout',630,'g_a4paper_textwidth','scalar','$g_a4paper_textwidth = \'184mm\';',NULL,'5.25','Text Width for A4 paper.'),(41,'admin','pagelayout',635,'g_color','array','@g_color = (\'#8FA\', \'#FF8\', \'#AAF\', \'#F8F\', \'#FAF\', \'#AFF\', \'#FAA\', \'#AFA\', \'#AAF\', \'#AAA\');',NULL,'5.25','Default color range values used by the gradebook for coloring assessment groups. '),(42,'admin','pagelayout',640,'a_latex_header','scalar','$a_latex_header = \'\\\\inputencoding{latin1}\';',NULL,'5.25','The header used by LaTeX to generate the PDF files. A different value is required for other languages, esp including Thai.'),(43,'admin','pageurl',1000,'homepage','scalar','$homepage = \'/index.shtml\';',NULL,'5.25','The URL for the main index file on the admin site. Do not change.'),(44,'admin','pageurl',1005,'attpage','scalar','$attpage = \'/attendance.html\';',NULL,'5.25','URL for the attendance page'),(45,'admin','pageurl',1010,'discpage','scalar','$discpage = \'/discipline.html\';',NULL,'5.25','URL for the discipline page.'),(46,'admin','pageurl',1015,'feespage','scalar','$feespage = \'/fees.html\';',NULL,'5.25','The URL for the fees page.'),(47,'admin','pageurl',1020,'reppage','scalar','$reppage = \'/repcard.html\';',NULL,'5.25','The URL for the report card page.'),(48,'admin','pageurl',1025,'schpage','scalar','$schpage = \'/timetable.html\';',NULL,'5.25','The Timetable page URL.'),(49,'admin','pageurl',1030,'exppage','scalar','$exppage = \'/export.html\';',NULL,'5.25','The URL for the export page.'),(50,'admin','pageurl',1035,'eoypage','scalar','$eoypage = \'/eoy.html\';',NULL,'5.25','The URL to the Start/End of Year page.'),(51,'admin','pageurl',1050,'tchpage','scalar','$tchpage = \'/tindex.pl\';',NULL,'5.25','The URL location for the main teacher page index file.'),(52,'admin','pageurl',1055,'parpage','scalar','$parpage=\'/pindex.pl\';',NULL,'6.50','The URL location of the main parent site page index file'),(53,'admin','password',900,'g_studentpwd_minlen','scalar','$g_studentpwd_minlen = 8;',NULL,'5.25','The minimum length a student password may be.'),(54,'admin','password',905,'g_studentpwd_maxlen','scalar','$g_studentpwd_maxlen = 8;',NULL,'5.25','The maximum length for a student password.'),(55,'admin','password',910,'g_studentpwd_genlen','scalar','$g_studentpwd_genlen = 8;',NULL,'5.25','This is the length of a generated password when adding students.'),(56,'admin','password',915,'g_studentpwd_caps','scalar','$g_studentpwd_caps = 0;',NULL,'5.25','A value of 1 indicates that one or more capital letters are required in a student password. A value of 0 turns off this requirement.'),(57,'admin','password',920,'g_studentpwd_signs','scalar','$g_studentpwd_signs = 0;',NULL,'5.25','This indicates whether signs or symbols are required in the password. A zero value turns it off and a 1 value turns it on.'),(58,'admin','password',930,'g_staffpwd_minlen','scalar','$g_staffpwd_minlen = 6;',NULL,'5.25','The minimum length that a password may be.'),(59,'admin','password',935,'g_staffpwd_maxlen','scalar','$g_staffpwd_maxlen = 0;',NULL,'5.25','The maximum length that a password may be. A 0 value will disable this requirement.'),(60,'admin','password',940,'g_staffpwd_genlen','scalar','$g_staffpwd_genlen = 6;',NULL,'5.25','This is the length of a generated password when adding staff.'),(61,'admin','password',945,'g_staffpwd_caps','scalar','$g_staffpwd_caps = 1;',NULL,'5.25','A value of 1 indicates that one or more capital letters are required in a password. A value of 0 turns off this requirement.'),(62,'admin','password',950,'g_staffpwd_signs','scalar','$g_staffpwd_signs = 0;',NULL,'5.25','Indicates whether a staff password will require symbols such as @ or #, etc. A value of 0 turns this off, and a value of 1 turns it on.'),(63,'admin','pathways',1200,'cgidir','scalar','$cgidir = \'/opt/openadmin/mosquito/cgi\';',NULL,'5.25','Directory root of all the cgi scripts in the server filesystem. (ie absolute location)'),(64,'admin','pathways',1205,'tchcgidir','scalar','$tchcgidir = \'/opt/openadmin/mosquito/tcgi\';',NULL,'5.25','The absolute pathway to the root directory for the teacher site scripts. '),(65,'admin','pathways',1210,'parcgidir','scalar','$parcgidir = \'/opt/openadmin/mosquito/pcgi\';',NULL,'5.26','The absolute pathway to the parent CGI scripts.'),(66,'admin','pathways',1215,'downloaddir','scalar','$downloaddir = \'/opt/openadmin/mosquito/admin/download\';',NULL,'5.25','The absolute pathway to the download directory. This is used by scripts to move files into this location so they can be downloaded. Typically PDF files or export data.'),(67,'admin','pathways',1220,'tchdownloaddir','scalar','$tchdownloaddir = \'/opt/openadmin/mosquito/tadmin/download\';',NULL,'5.25','The absolute pathway for the download directory on the teacher site. Files for download (ie. PDF) are copied here by scripts. '),(68,'admin','pathways',1230,'picdir','scalar','$picdir = \'/opt/openadmin/mosquito/admin/pic-big\';',NULL,'5.25','The absolute path to the location of the directory storing the full size pictures of students.'),(69,'admin','pathways',1240,'tndir','scalar','$tndir = \'/opt/openadmin/mosquito/admin/pic-sm\';',NULL,'5.25','The Thumbnail pictures absolute path location in the filesystem.'),(70,'admin','pathways',1250,'globdir','scalar','$globdir = \'/opt/openadmin/global\';',NULL,'5.25','The directory location of the global file (global.conf) that stores the other databases that may be searched on this server for withdrawn students. It also contains the \'read only\' user values to allow it to read from those databases. For single schools the file is normally located in the school etc directory.'),(71,'admin','pathways',1260,'g_EtcPath','scalar','$g_EtcPath = \'../../etc\';',NULL,'5.50','The full path to the location of the configuration files for OA for this school.'),(72,'admin','pathways',1270,'iepdir','scalar','$iepdir = \'/opt/openadmin/iep1819\';',NULL,'5.25','The absolute path to the IEP system, if used.'),(73,'admin','pathways',1280,'pdflatex','scalar','$pdflatex = \'/usr/bin/pdflatex\';',NULL,'5.25','The pathway to the PDF Latex executable file.'),(74,'admin','preplan',1700,'pp_DaysPerCycle','scalar','$pp_DaysPerCycle = \'6\';',NULL,'','For the pre-plan system, the number of days in a teaching cycle.'),(75,'admin','preplan',1705,'pp_PeriodsPerDay','scalar','$pp_PeriodsPerDay = \'6\';',NULL,'','For the pre-plan system, the number of teaching periods per day. Independent from the number of attendance periods per day.'),(76,'admin','preplan',1710,'pp_SemesterCount','scalar','$pp_SemesterCount = \'2\';',NULL,'','For the pre-plan system, the number of semesters in a school year. A semester is the smallest time interval that courses run. Typically a semester is 2 terms long (2 report cards), in a 4 term school year.'),(77,'admin','preplan',1715,'pp_DefaultPeriodsPerCycle','scalar','$pp_DefaultPeriodsPerCycle = \'6\';',NULL,'','For the pre-plan system, a default value, where the value is not set, for the number of teaching periods per teaching cycle. For example, if you have a 6 day cycle, and you want to teach every day, then it would be 6. If you have a 5 day cycle..ie weekly, then a value of 5 would possibly make it every day or a double period one day and no periods on another day.'),(78,'admin','preplan',1720,'pp_Grade9PassingAverage','scalar','$pp_Grade9PassingAverage = \'48\';',NULL,'','For the pre-plan system, the average value used to find how many grade 9s will be in grade 10 in the following year'),(79,'admin','sasked',1300,'schoolnumber','scalar','$schoolnumber = \'9597113\';',NULL,'5.25','The provincial or state number used to identify the school in that province or state.'),(80,'admin','sasked',1310,'xmlns','scalar','$xmlns = \'http://www.k12.gov.sk.ca/xsd/sl/3.x/SLMessage.xsd\';',NULL,'5.25','Sask Ed value for the XML Name space. Do not change.'),(81,'admin','sasked',1315,'xmlnsxsi','scalar','$xmlnsxsi = \'http://www.w3.org/2001/XMLSchema-instance\';',NULL,'5.25','Sask Ed XML value. Do not change.'),(82,'admin','sasked',1320,'xsischemaLocation','scalar','$xsischemaLocation = \'http://www.k12.gov.sk.ca/xsd/sl/3.x/SLMessage.xsd\n http://www.k12.gov.sk.ca/xsd/sl/3.x/SLMessage.xsd\';',NULL,'5.25','Sask Ed XML setting. Do not change.'),(83,'admin','sasked',1325,'program','scalar','$program = \'10\';',NULL,'5.25','The Sask Ed value for the program a student is following. Typically a \'10\' for an English stream student in Saskatchewan, Canada. Ignore if not a Sask School.'),(84,'admin','sasked',1330,'nativeschool','scalar','$nativeschool = \'1\';',NULL,'5.25','A Sask Ed value to indicate if the school is a First Nations school. Ignore if not in Sask, Canada.  (1=True, 0=False)'),(85,'admin','sasked',1335,'url','scalar','$url = \'https://www.k12.gov.sk.ca/spls/sdsxml/pkgb_xml_interface.sl_message\';',NULL,'5.25','The Sask Ed URL location for SDS record transfer. Do Not Change.'),(86,'admin','schooladdress',300,'schoolname','scalar','$schoolname = \'Mosquito School\';',NULL,'5.25','The name of the school as it will appear on reports and report card.'),(87,'admin','schooladdress',305,'schooladdr1','scalar','$schooladdr1 = \'Box 160\';',NULL,'5.25','First part of the street address for the school.'),(88,'admin','schooladdress',310,'schooladdr2','scalar','$schooladdr2 = \'\';',NULL,'5.25','Second part of the school street address, if required.'),(89,'admin','schooladdress',315,'schoolcity','scalar','$schoolcity = \'Cando\';',NULL,'5.25','City in which school is located.'),(90,'admin','schooladdress',320,'schoolprov','scalar','$schoolprov = \'SK\';',NULL,'5.25','The province or state the school is located in.'),(91,'admin','schooladdress',325,'schoolpcode','scalar','$schoolpcode = \'S0K 0M0\';',NULL,'5.25','The Postal Code or zip code for the school.'),(92,'admin','schooladdress',330,'schoolphone','scalar','$schoolphone = \'(306) 937-3800\';',NULL,'5.25','The phone number of the school.'),(93,'admin','schooladdress',335,'schoolfax','scalar','$schoolfax = \'(306) 937-7503\';',NULL,'5.25','The fax number of the school.'),(94,'admin','schooladdress',340,'schoolemail','scalar','$schoolemail = \'contact@YOURSCHOOL.ca\';',NULL,'5.25','The email address for the school. Typically the \'general mailbox\' for the school, rather than a secretary or admin email account.'),(95,'admin','schooladdress',345,'schoolwebsite','scalar','$schoolwebsite = \'www.OURSCHOOL.net\';',NULL,'5.25','The URL for the school website.'),(96,'admin','schooladdress',350,'returnaddress','scalar','$returnaddress = \'\';',NULL,'5.25','The return address for email sent out via email script.'),(97,'admin','schooladdress',355,'g_Divisionname','scalar','$g_Divisionname = \'\';',NULL,'5.25','Name of your school division, if any. Leave blank if a stand alone school with no affiliation to other schools.'),(98,'admin','schooladdress',360,'g_mailserver','scalar','$g_mailserver = \'mail.yourdomain.edu\';',NULL,'5.25','The URL for the email server used by the email scripts. It will accept mail from the Open Admin server.'),(99,'admin','schoolrole',800,'g_position','array','@g_position = (\'Classroom Teacher\',\'Educational Assistant\',\'Special Education Teacher\',\'Principal\',\'Vice-Principal\',\'Secretary\',\'Librarian\',\'Community School Room\',\'Custodian\',\'Education Director\',\'Catalyst Teacher\',\'Career Counsellor\',\'Elder\',\'Bus Driver\',\'Maintenance\',\'EA Mentors\',\'EA Trainees\');',NULL,'5.25','The various staff positions in the school.'),(100,'admin','schoolrole',805,'g_posadmin','array','@g_posadmin = (\'Principal\',\'Vice-Principal\');',NULL,'5.25','Text values for the administrators from the positions variable values.'),(101,'admin','schoolrole',810,'g_possped','scalar','$g_possped = \'Special Education Teacher\';',NULL,'5.25','The text value for the special education teacher from the position variable.'),(102,'admin','schoolrole',815,'g_StaffAbsReason','array','@g_StaffAbsReason = (\'Unexcused\', \'Culture\', \'Sport\', \'Professional Development\', \'Medical Appointment\', \'Illness\', \'Bereavment\', \r\n\'Late\', \'EDO\', \'Mat/Pat Leave\', \'Annual Leave\', \'Sp Leave w Pay\',\'Leave w/o Pay\',\'Other (specify)\');\r\n',NULL,'','List of Staff Absence Reasons for missing school.'),(103,'admin','schoolrole',815,'g_StaffAbsReason','array','@g_StaffAbsReason = (\'Unexcused\', \'Culture\', \'Sport\', \'Professional Development\', \'Medical Appointment\', \'Illness\', \'Bereavment\', \r\n\'Late\', \'EDO\', \'Mat/Pat Leave\', \'Annual Leave\', \'Sp Leave w Pay\',\'Leave w/o Pay\',\'Other (specify)\');\r\n',NULL,'','List of Staff Absence Reasons for missing school.'),(104,'admin','schoolyear',200,'schoolyear','scalar','$schoolyear = \'2019-2020\';',NULL,'5.25','The school year in YYYY-YYYY format. (ie. 2011-2012)'),(105,'admin','schoolyear',210,'schoolstart','scalar','$schoolstart = \'2019-08-26\';',NULL,'5.25','The starting date for school. Typically the first day that teachers come. This allows a couple of admin days to be set at school start before students arrive. If not desired (to show admin days), then set this to the first day that students come.'),(106,'admin','schoolyear',220,'schoolend','scalar','$schoolend = \'2020-06-28\';',NULL,'5.25','The last day of school. Typically the last day when teachers are at school and report cards are handed out, etc. Administration days are set in the dates to indicate that students do not come. It can be set to last day for students if desired (although not recommended).'),(107,'admin','schoolyear',240,'g_MTrackTerm','hash','%g_MTrackTerm = (\'1\' => {\'3\' => {\'start\' => \'2020-04-12\',\'end\' => \'2020-06-28\'},\'2\' => {\'end\' => \'2020-04-11\',\'start\' => \'2019-11-23\'},\'1\' => {\'end\' => \'2019-11-22\',\'start\' => \'2019-09-03\'}});',NULL,'5.50','Holds the term data (dates) for all tracks and all terms. Structure is: g_MTrackTerm{track}{term}{\'start\' => \'2011-03-15\', \'end\' => \'2011-06-28\'}'),(108,'admin','schoolyear',250,'g_MTrackTermType','hash','%g_MTrackTermType = (\'3\' => 1,\'K\' => 1,\'2\' => 1,\'8\' => 1,\'6\' => 1,\'PK\' => 1,\'4\' => 1,\'7\' => 1,\'5\' => 1,\'1\' => 1);',NULL,'5.25','The grade and a matching index value used to find the term start and end dates when multi-Track school.'),(109,'admin','schoolyear',270,'g_TermDisplay','hash','%g_TermDisplay = (\'1\' => {\'2\' => \'Term 2\',\'3\' => \'Term 3\',\'1\' => \'Term 1\'});',NULL,'5.50','This controls the descriptive text that is shown for each particular term. This gives much more flexibility to the assignment of report periods.'),(110,'admin','schoolyear',275,'g_TermDisplayBlock','hash','%g_TermDisplayBlock = ();',NULL,'','List names for blocks of terms (typically called Semesters, etc). '),(111,'admin','schoolyear',280,'g_TrackDisplay','hash','%g_TrackDisplay = (\'1\' => \'All \');',NULL,'','Lists names associated with each Track.'),(112,'admin','staffpay',1750,'pay_LeaveAreas','array','@pay_LeaveAreas = (\'Sick\',\'Bereavement\',\'Personal\',\'Family\');',NULL,'','The types of predefined leave categories that hold starting hours.'),(113,'admin','system',700,'dbtype','scalar','$dbtype = \'mysql\';',NULL,'5.25','Type of the database. It is either \'mysql\' or \'pgsql\'. '),(114,'admin','system',705,'sql','hash','%sql = (\'like\' => \'like\',\'default\' => \'NULL\');',NULL,'5.25','SQL values to make use of both MySQL and PostgreSQL possible. We have only been using MySQL for several years. Do Not Change.'),(115,'admin','system',710,'maxfilesize','scalar','$maxfilesize = 30000;',NULL,'5.25','The maximum file size for uploads.'),(116,'admin','system',715,'adminname','scalar','$adminname = \'Les Richardson\';',NULL,'5.25','Name of the system administrator for the Open Admin server. This is displayed when a system error has occurred.'),(117,'admin','system',720,'adminemail','scalar','$adminemail = \'openadmin@gmail.com\';',NULL,'5.25','Email address of the system admin who manages the Open Admin server. This is the contact email address that is shown in the case of system errors.'),(118,'admin','system',730,'g_InacSchool','scalar','$g_InacSchool = \'1\';',NULL,'5.75','The INAC (Indigenous and Northern Affairs Canada) number of the school'),(119,'admin','system',740,'g_SessionDuration','scalar','$g_SessionDuration = \'60\';',NULL,'',''),(120,'admin','system',750,'g_OpenadminVersion','scalar','$g_OpenadminVersion = \'11.0\';',NULL,'',''),(121,'admin','system',765,'remoteuser','scalar','$remoteuser = \'tsecremote\';',NULL,'8.30','User access to remote server for previous year attendance and marks information'),(122,'admin','system',766,'remotepassword','scalar','$remotepassword = \'ts99ec4\';',NULL,'8.30','Password for access to remote server for previous year attendance and marks information'),(123,'admin','system',767,'remotehost','scalar','$remotehost = \'10.162.70.33\';',NULL,'8.30','IP Address of remote server for previous year attendance and marks information'),(124,'admin','system',770,'g_BritishSchoolMode','scalaronoff','$g_BritishSchoolMode = \'0\';',NULL,'','This variable turns on British School mode, affecting grades to forms translation.'),(125,'admin','system',773,'g_FormMap','hash','%g_FormMap = (\'7\' => \'f1\',\'8\' => \'F2\');',NULL,'','This hash maps the grade to a particular form value.'),(126,'admin','system',780,'g_FeederSchools','array','@g_FeederSchools = ();',NULL,'',''),(127,'admin','timetable',1800,'g_PeriodTime','hash','%g_PeriodTime = (\'B\' => {\'1\' => {\'s\' => \'9:00\',\'e\' => \'10:00\'},\'3\' => {\'e\' => \'12:30\',\'s\' => \'11:20\'},\'2\' => {\'s\' => \'10:10\',\'e\' => \'11:10\'},\'4\' => {\'s\' => \'12:40 \',\'e\' => \'13:50 \'}},\'A\' => {\'3\' => {\'e\' => \'16:30\',\'s\' => \'15:15\'},\'1\' => {\'e\' => \'14:30\',\'s\' => \'13:30\'},\'2\' => {\'s\' => \'14:40\',\'e\' => \'15:10\'}});',NULL,'','Block of Period Start and End Times.'),(128,'admin','timetable',1810,'g_PeriodMap','hash','%g_PeriodMap = (\'12\' => \'A\',\'11\' => \'A\',\'10\' => \'A\');',NULL,'','This variable maps period blocks found in the g_PeriodTime hash to particular grades (that are set as having subject attendance). Grades without subject attendance (ie. homeroom) will allow teachers to set their own periods on a per grade basis.'),(129,'admin','url-other',1100,'cgiurl','scalar','$cgiurl = \'/cgi-bin\';',NULL,'5.25','The URL address for the scripts. This is also set in the Apache configuration for the script alias value. Leave it at \'/cgi-bin\'. '),(130,'admin','url-other',1105,'tcgiurl','scalar','$tcgiurl = \'/cgi-bin\';',NULL,'5.25','The URL for all teacher site scripts. This is also set in the Apache web server configuration value. Do not change.'),(131,'admin','url-other',1110,'webdownloaddir','scalar','$webdownloaddir = \'/download\';',NULL,'5.25','The URL location of the download directory for downloading PDF files, etc. Do Not change.'),(132,'admin','url-other',1115,'tchwebdownloaddir','scalar','$tchwebdownloaddir = \'/download\';',NULL,'5.25','The URL for file download on the teacher site. Again, leave at \'/download\', unless you are using a custom configuration of some sort.'),(133,'admin','url-other',1120,'css','scalar','$css = \'/admin.css\';',NULL,'5.25','The location of the CSS file. This is sent by the scripts as part of the page header.'),(134,'admin','url-other',1125,'tchcss','scalar','$tchcss = \'/tadmin.css\';',NULL,'5.25','The URL for the teacher CSS file.'),(135,'admin','url-other',1130,'parcss','scalar','$parcss = \'/padmin.css\';',NULL,'5.25','The URL of the parent site CSS file.'),(136,'admin','url-other',1135,'picdirurl','scalar','$picdirurl = \'/pic-big\';',NULL,'5.25','The URL for the full sized pictures (ie. more pixels) of students'),(137,'admin','url-other',1140,'tndirurl','scalar','$tndirurl = \'/pic-sm\';',NULL,'5.25','The Thumbnail Directory URL (TN Dir Url). The location of the pictures of students in a smaller pixel format (ie. thumbnail) for fast loading/display.'),(138,'admin','url-other',1150,'g_jquery_url','scalar','$g_jquery_url = \'//ajax.googleapis.com/ajax/libs/jquery/2.0.3/jquery.min.js\';',NULL,'8.00','The URL of the jQuery Library'),(139,'admin','url-other',1155,'g_jquery_ui_url','scalar','$g_jquery_ui_url = \'//ajax.googleapis.com/ajax/libs/jqueryui/1.10.3/jquery-ui.min.js\';',NULL,'8.00','The URL of the jQuery UI Library. Loaded second'),(140,'admin','url-other',1160,'g_JqueryUiCss','scalar','$g_JqueryUiCss = \'https://ajax.googleapis.com/ajax/libs/jqueryui/1.10.3/themes/smoothness/jquery-ui.css\';',NULL,'','URL to the css file used by jquery UI.'),(141,'fees','general',2000,'debitSign','scalar','$debitSign = \'-\';',NULL,'5.25','Sign convention for debit values.'),(142,'fees','general',2005,'padding_digits','scalar','$padding_digits = 4;',NULL,'5.25','Number of digits to left pad record id\'s. '),(143,'fees','general',2010,'profiles','hash','%profiles = (\'Elementary\' => \'Grade: K 1 2 3 4 5 6\',\'High School\' => \'Grade: 10 11 12\',\'Middle Years\' => \'Grade: 7 8 9\');',NULL,'5.25','Grade Profiles'),(144,'fees','report',2030,'f_FeesRolloverDate','scalar','$f_FeesRolloverDate = \'2017-01-01\';',NULL,'','This variable sets the starting date for transaction viewing in transactview.pl script.'),(145,'fees','tax',2015,'f_tax1','hash','%f_tax1 = (\'rate\' => \'0.05\',\'pass\' => 1,\'account\' => \'\',\'name\' => \'GST\',\'description\' => \'Goods and Services Tax\');',NULL,'','Stores the characteristics of the first tax charged.'),(146,'fees','tax',2016,'f_tax2','hash','%f_tax2 = (\'rate\' => \'0.05\',\'pass\' => 1,\'account\' => \'\',\'name\' => \'PST\',\'description\' => \'Provincial Sales Tax\');',NULL,'','Stores the characteristics of the second tax charged.'),(147,'fees','tax',2017,'f_tax3','hash','%f_tax3 = (\'rate\' => \'0\',\'pass\' => 1,\'account\' => \'\',\'name\' => \'\',\'description\' => \'\');',NULL,'','Stores the characteristics of the third tax charged.'),(148,'fees','tax',2018,'f_tax4','hash','%f_tax4 = (\'rate\' => \'0\',\'pass\' => 1,\'account\' => \'\',\'name\' => \'\',\'description\' => \'\');',NULL,'','Stores the characteristics of the fourth tax charged.'),(149,'first_nation','Certifier',10,'certifier_firstname','scalar','$certifier_firstname = \'Audrey\';',NULL,'','First Name of Certifier'),(150,'first_nation','Certifier',15,'certifier_lastname','scalar','$certifier_lastname = \'Night\';',NULL,'','Last Name of Certifier'),(151,'first_nation','Certifier',20,'certifier_title','scalar','$certifier_title = \'Principal\';',NULL,'','Title of Certifier (ie. Principal, Vice-Principal)'),(152,'first_nation','Contact',10,'contact_firstname','scalar','$contact_firstname = \'Audrey\';',NULL,'','First Name of Contact'),(153,'first_nation','Contact',12,'contact_lastname','scalar','$contact_lastname = \'Night\';',NULL,'','Last Name of Contact'),(154,'first_nation','Contact',15,'contact_title','scalar','$contact_title = \'Principal\';',NULL,'','Title of Contact (ie. Principal, Vice-Principal)'),(155,'first_nation','Contact',20,'contact_phone','scalar','$contact_phone = \'(306) 937-3800\';',NULL,'','Phone of Contact'),(156,'first_nation','Contact',21,'contact_phone_ext','scalar','$contact_phone_ext = \'\';',NULL,'','Phone Extension of Contact'),(157,'first_nation','Contact',25,'contact_email','scalar','$contact_email = \'audrey.night@tsec.ca\';',NULL,'','Email of Contact'),(158,'first_nation','Contact',30,'contact_address','scalar','$contact_address = \'Box 160\';',NULL,'','Address of Contact'),(159,'first_nation','Contact',35,'contact_city','scalar','$contact_city = \'Cando\';',NULL,'','City of Contact'),(160,'first_nation','Contact',40,'contact_province','scalar','$contact_province = \'SK\';',NULL,'','Province of Contact'),(161,'first_nation','Contact',45,'contact_postalcode','scalar','$contact_postalcode = \'S0K 0V0\';',NULL,'','Postal Code of Contact'),(162,'first_nation','General',10,'region','scalar','$region = \'6\';',NULL,'','AANDC Region of the School'),(163,'first_nation','General',20,'provincialcertification','scalar','$provincialcertification = \'true\';',NULL,NULL,'Provincial Certification (true or false (blank=false)'),(164,'first_nation','General',30,'tuitionagreement','scalar','$tuitionagreement = \'1\';',NULL,NULL,'Tuition Agreement with students attending Provincial Schools'),(165,'first_nation','General',40,'count_culture','scalar','$count_culture = \'128\';',NULL,NULL,'Number of students who are provided with culturally-based curriculum or land-based learning services'),(166,'first_nation','General',50,'count_language','scalar','$count_language = \'128\';',NULL,NULL,'Number of students who are taught at least one subject in a First Nations language'),(167,'first_nation','Recipient',10,'recipientnumber','scalar','$recipientnumber = \'343\';',NULL,'','AANDC Recipient Number'),(168,'first_nation','Recipient',20,'recipient_name','scalar','$recipient_name = \'Mosquito, Grizzly Bear\\\'s Head, Lean Man First Nation\';',NULL,NULL,'Recipient Name'),(169,'first_nation','Recipient',30,'recipient_id','scalar','$recipient_id = \'343\';',NULL,NULL,'Recipient ID (typically band number)'),(170,'first_nation','Recipient',40,'recipient_type','scalar','$recipient_type = \'01\';',NULL,NULL,'Recipient Type'),(171,'first_nation','Recipient',50,'recipient_phone','scalar','$recipient_phone = \'(306) 937-3800\';',NULL,'',''),(172,'first_nation','Recipient',60,'recipient_phone_ext','scalar','$recipient_phone_ext = \'\';',NULL,'',''),(173,'first_nation','Recipient',70,'recipient_fax','scalar','$recipient_fax = \'\';',NULL,'',''),(174,'first_nation','Recipient',80,'recipient_street','scalar','$recipient_street = \'Box 160\';',NULL,'',''),(175,'first_nation','Recipient',90,'recipient_city','scalar','$recipient_city = \'Cando\';',NULL,'',''),(176,'first_nation','Recipient',100,'recipient_province','scalar','$recipient_province = \'SK\';',NULL,'',''),(177,'first_nation','Recipient',110,'recipient_postalcode','scalar','$recipient_postalcode = \'S0K 0V0\';',NULL,'',''),(178,'first_nation','School',10,'deliveryorg_name','scalar','$deliveryorg_name = \'MOSQUITO\';',NULL,NULL,'Delivery Org Name'),(179,'first_nation','School',20,'deliveryorg_id','scalar','$deliveryorg_id = \'1176\';',NULL,NULL,'Delivery Org ID'),(180,'first_nation','School',30,'deliveryorg_type','scalar','$deliveryorg_type = \'24\';',NULL,NULL,'Delivery Org Type'),(181,'first_nation','School',40,'f_DirectorFirstname','scalar','$f_DirectorFirstname = \'Tristan\';',NULL,NULL,'First Name of Education Director'),(182,'first_nation','School',50,'f_DirectorLastname','scalar','$f_DirectorLastname = \'Bird\';',NULL,NULL,'Last Name of Education Director'),(183,'gbook',NULL,NULL,'altcolor','scalar','$altcolor = \'#3B7\';',NULL,'5.25','Alternate color value to the green of teacher site, to stand out. Don\'t forget the # symbol.'),(184,'gbook',NULL,NULL,'defaultItemWeight','scalar','$defaultItemWeight = 500;',NULL,'5.25','Default Item Weight for each assessment item. Do not alter this unless you have a very good idea of what you\'re doing.'),(185,'gbook',NULL,NULL,'specchar','scalar','$specchar = \'*\';',NULL,'5.25','The character used for an assessment so that the value is ignored by the averaging process. This values means the test is ignored or \'excused\'.'),(186,'gbook',NULL,NULL,'useMultipliers','scalaronoff','$useMultipliers = 1;',NULL,'5.25','Turn on the use of weight multipliers when adding items, rather than just raw weight values. Also used by weight adjustment of items.'),(187,'gbook',NULL,NULL,'wtmult','hash','%wtmult = (\'6\' => \'1.5\',\'3\' => \'0.5\',\'7\' => \'2\',\'9\' => \'4\',\'2\' => \'0.33333\',\'8\' => \'3\',\'1\' => \'0.2\',\'4\' => \'0.66666\',\'0\' => \'0\',\'5\' => \'1\');',NULL,'5.25','Mapping function that maps arbitrary values (with 5 being \'normal\') to weight multipliers.'),(188,'image',NULL,NULL,'convertprog','scalar','$convertprog = \'/usr/bin/convert\';',NULL,'5.25','The location of the ImageMagick convert program in the file system. Used to convert image sizes.'),(189,'image',NULL,NULL,'imageheight','scalar','$imageheight = \'300\';',NULL,'5.25','The height uploaded student/staff images are converted to, in pixels (using the ImageMagick convert program)'),(190,'image',NULL,NULL,'maxbufcount','scalar','$maxbufcount = 4096;',NULL,'5.25','The maximum size of uploaded image files (including zip files of images) in KBytes. '),(191,'image',NULL,NULL,'thumbheight','scalar','$thumbheight = \'150\';',NULL,'5.25','The height of converted upload images in pixels. These are stored in the thumbnails folder (pic-sm).'),(192,'ldap',NULL,NULL,'adminpassword','scalar','$adminpassword = \'password\';',NULL,'5.25','Admin password to manage the LDAP server.'),(193,'ldap',NULL,NULL,'adminuser','scalar','$adminuser = \'cn=admin,dc=jp2,dc=loccsd,dc=ca\';',NULL,'5.25','Admin user to manage LDAP directory.'),(194,'ldap',NULL,NULL,'basedn','scalar','$basedn = \'dc=jp2,dc=loccsd,dc=ca\';',NULL,'5.25','Base Distinguished Name.'),(195,'ldap',NULL,NULL,'group_staff','scalar','$group_staff = \'staff\';',NULL,'5.25','The name of the staff group in the LDAP directory.  Matches the Staff GID, of course, on the user management server. (ie. NFS, Samba mounts, etc.)'),(196,'ldap',NULL,NULL,'group_student','scalar','$group_student = \'student\';',NULL,'5.25','The text name for the student group in the LDAP directory.  '),(197,'ldap',NULL,NULL,'ldap_staff_gidnumber','scalar','$ldap_staff_gidnumber = 600;',NULL,'5.25','The gid (Group ID) number for the staff accounts on the server(s). '),(198,'ldap',NULL,NULL,'ldap_startinguidnumber','scalar','$ldap_startinguidnumber = 10000;',NULL,'5.25','Starting values for UID (User Id) numbers for new LDAP accounts. Existing accounts may be lower and there may be new accounts already higher than this value. It might better be called a \'suggested starting point\' for adding new accounts. '),(199,'ldap',NULL,NULL,'ldap_student_gidnumber','scalar','$ldap_student_gidnumber = 500;',NULL,'5.25','The gid (Group ID) number for the student accounts on the server(s). '),(200,'ldap',NULL,NULL,'org','scalar','$org = \'jp2.loccsd.ca\';',NULL,'5.25','Organization to use in the ldap directory.'),(201,'ldap',NULL,NULL,'servername','scalar','$servername = \'myserver.ca\';',NULL,'5.25','LDAP server to manage.'),(202,'ldap',NULL,NULL,'slappasswd','scalar','$slappasswd = \'/usr/local/sbin/slappasswd\';',NULL,'5.25','Location of the slappasswd binary in the filesystem.'),(203,'repcard','Config',100,'r_CalcGPA','scalaronoff','$r_CalcGPA = \'0\';',NULL,'4.75','On/Off type; Turns on the GPA (Grade Point Average) calculation.'),(204,'repcard','Config',110,'r_ClassAvg','scalaronoff','$r_ClassAvg = \'0\';',NULL,'4.75','On/Off type. When turned on, it will calculate the class average for a subject and place the class average in the comment section.'),(205,'repcard','Config',120,'r_PrintYearEnd','scalaronoff','$r_PrintYearEnd = \'0\';',NULL,'4.75','On/Off type. Whether to print a year end section for graduation'),(206,'repcard','Config',130,'r_ShowAdmins','scalaronoff','$r_ShowAdmins = \'0\';',NULL,'4.75','On/Off type. Turns on the principal/vice principal names at top of the report card.'),(207,'repcard','Config',140,'r_ShowDemerits','scalaronoff','$r_ShowDemerits = \'0\';',NULL,'4.75','On/Off Type. Turns on demerits display function.'),(208,'repcard','Config',150,'r_ShowGradeCategory','scalaronoff','$r_ShowGradeCategory = \'0\';',NULL,'4.75','On/Off type. Turns this function on or off. The Grade Category is another approach to ranking students. The function assigns a value based on their marks in various subjects.'),(209,'repcard','Config',160,'r_ShowGradeScheme','scalaronoff','$r_ShowGradeScheme = \'1\';',NULL,'5.00','On/Off type. Turns on the evaluation scheme ( set in evalsch variable).'),(210,'repcard','Config',170,'r_ShowHomeroomTeacher','scalaronoff','$r_ShowHomeroomTeacher = \'1\';',NULL,'4.75','On/Off type. Turns on the homeroom teacher printing at top of report card.'),(211,'repcard','Config',180,'r_ShowLogo','scalaronoff','$r_ShowLogo = \'1\';',NULL,'4.75','On/Off type. Shows the logo at top of the report card, rather than just the school name.'),(212,'repcard','Config',190,'r_ShowProvNum','scalaronoff','$r_ShowProvNum = \'1\';',NULL,'5.00','On/Off type. Show provincial/state number at the top of the report card.'),(213,'repcard','Config',200,'r_ShowRanking','scalaronoff','$r_ShowRanking = 0;',NULL,'4.75','On/Off type. Shows the ranking of the student in the class.'),(214,'repcard','Config',210,'r_ShowSubjectAttendance','hash','%r_ShowSubjectAttendance = (\'PK\' => 0, \'K\' => 0, 1 => 0, 2 =>0,3 =>0, 4=>0, 5=>0, 6=>0, 7=>0, 8=>0, 9=>1, 10=>1, 11=>1, 12=>1);',NULL,'5.75','Subject Attendance display control (On/Off 1/0) for each grade.'),(215,'repcard','Config',220,'r_ShowTermAverage','scalaronoff','$r_ShowTermAverage = \'0\';',NULL,'4.75','On/Off type. Shows the term average for the student.'),(216,'repcard','Config',230,'r_SingleTermOnly','scalaronoff','$r_SingleTermOnly = \'0\';',NULL,'','Sets if teacher can post from the gradebook to the current term only (when set to 1) or if teacher can choose term from drop-down (when set to 0)'),(217,'repcard','Config',240,'r_SkipBlankReportCard','scalaronoff','$r_SkipBlankReportCard = \'0\';',NULL,'4.75','On/Off type.  If turned on, it will skip students that have no evaluations (i.e. students have just enrolled, etc)'),(218,'repcard','Config',250,'r_SupressSubject','hash','%r_SupressSubject = (\'123\' => \'1\');',NULL,'5.00','Either subject codes (8412) or subject-section codes (8412-2) are checked against this list and will not show up on the report card. Additional Comments subjects (which are used to store the global, non-subject comments) should not be placed on this list, but are set separately (using r_AdditionalComments). Add values by putting the subject code or subject-section as the new key and a 1 as the new value.'),(219,'repcard','Config',260,'r_TeacherModeOverride','scalaronoff','$r_TeacherModeOverride = 0;',NULL,'4.75','On/Off type. Teacher mode for the report card means it is called from the teacher site. This mode normally only allows the teacher to print his/her own students and subjects. By leaving this override on (ie. =1), the teacher site will print the report card exactly as on the main admin site.'),(220,'repcard','Config',270,'r_TermDisplay','hash','%r_TermDisplay = (\'4\' => \'Term 4\',\'1\' => \'Term 1\',\'3\' => \'Term 3\',\'2\' => \'Term 2\');',NULL,'5.00','To be renamed to g_TermDisplay and moved to admin.conf. Maps the term number to descriptive text.'),(221,'repcard','Config',280,'r_MarkEntryTerm','hash','%r_MarkEntryTerm = (\'1\' => \'1\');',NULL,NULL,'Controls the mark entry term for each of the tracks (blocks of grades).'),(222,'repcard','Eval Key',400,'r_Eval','hashofarray','%r_Eval = (\'c\' => [\'4: Exceeds expectations\',\'3: Fully meets expectations\',\'2: Meets expectations at beginning level\',\'1: Not yet within expectations\'],\'a\' => [\'E::Excellent\',\'G::Good\',\'S::Satisfactory\',\'NI::Needs Improvement\',\'AR::At Risk of Failure\'],\'b\' => [\'VG::Very Good\',\'G::Good\',\'I::Improving\',\'N::Needs More Practice\',\'NA::Not Applicable At This Time\']);',NULL,'5.00','All of the Evaluation/Assessment Keys - general values for all subjects. These are pointed to by the EvalSch variable that maps each grade to a particular assessment group.'),(223,'repcard','Eval Key',405,'r_EvalSch','hash','%r_EvalSch = (\'6\' => \'a\',\'11\' => \'a\',\'PK\' => \'b\',\'3\' => \'a\',\'7\' => \'a\',\'K\' => \'c\',\'9\' => \'a\',\'12\' => \'a\',\'2\' => \'a\',\'8\' => \'a\',\'4\' => \'a\',\'1\' => \'a\',\'10\' => \'a\',\'5\' => \'a\');',NULL,'5.00','A structure that maps the grades to a particular evaluation key found in the Eval variable.'),(224,'repcard','Eval Key',410,'r_EvalAlt1','hashofarray','%r_EvalAlt1 = (\'a\' => [\'4::Eagerly engages in activities. Encourages and supports peers  in learning. Fulfills requirements for task. Produces work of high quality.\',\'3::Willingly participates in activities. Completes tasks with care.  Fulfills most requirements for tasks. Produces work of satisfactory quality.\',\'2::Participates in activities with some encouragement. Completes most  tasks. Partially fulfills requirements. Produces work of marginal quality.\',\'1::Requires continual encouragement to participate in activites. Has  difficulty completing tasks. Seldom fulfills requirements. Work is often late, missing,  or sketchy\']);',NULL,'5.00','Alternate Evaluation Key (#1)'),(225,'repcard','Eval Key',420,'r_EvalAlt1Title','scalar','$r_EvalAlt1Title = \'Effort\';',NULL,'5.00','Title of the alternate evaluation Key #1'),(226,'repcard','Eval Key',440,'r_EvalSchAlt1','hash','%r_EvalSchAlt1 = (\'8\' => \'a\',\'6\' => \'a\',\'4\' => \'a\',\'1\' => \'a\',\'3\' => \'a\',\'7\' => \'a\',\'2\' => \'a\',\'5\' => \'a\');',NULL,'5.00','An Alternate mapping key between grade and evaluation key.'),(227,'repcard','Eval Key',450,'r_PDEval','hashofarray','%r_PDEval = (\'a\' => [\'I - Independent - Student is able to demonstrate appropriate social  and personal behaviours independently and consistently\',\'M - Meeting Success - Student demonstrates appropriate personal and  social behaviours in the school environment.\',\'P - Progressing with Support - Student is progressing towards an  awareness of appropriate personal and social behaviours in the school environment.  He/She often requires guidance.\',\'D - Experiencing Difficulty - Extensive guidance is required for student  to display appropriate personal and social behaviours in a school environment.\'],\'b\' => [\'O - Outstanding\',\'G - Good\',\'A - Acceptable\',\'NI - Needs Improvement\']);',NULL,'5.00','Holds the Personal Development evaluation key. The PDEvalGrp variable holds the \r\nkeys that map to a particular grade.'),(228,'repcard','Eval Key',460,'r_PDEvalGrp','hash','%r_PDEvalGrp = (\'6\' => \'a\',\'PK\' => \'c\',\'3\' => \'a\',\'K\' => \'c\',\'7\' => \'a\',\'2\' => \'a\',\'8\' => \'a\',\'1\' => \'a\',\'4\' => \'a\',\'5\' => \'a\');',NULL,'5.00','Maps the grade to a particular evaluation key for Personal Development subject.'),(229,'repcard','Eval Key',470,'r_Personal_Growth','scalar','$r_Personal_Growth = \'Personal and Social Development\';',NULL,'5.00','Name of the Personal Growth subject'),(230,'repcard','Eval Key',480,'r_AssessKeyCols','scalar','$r_AssessKeyCols = \'3\';',NULL,'5.00','Number of columns used for the evaluation keys.'),(231,'repcard','Eval Key',490,'r_AssessKeyWidth','scalar','$r_AssessKeyWidth = \'140mm\';',NULL,'5.00','Width of the Evaluation Keys.'),(232,'repcard','Layout',680,'r_CenterSubjects','scalaronoff','$r_CenterSubjects = \'1\';',NULL,'5','On/Off type to center subject table on report card. Typically on.'),(233,'repcard','Layout',710,'r_FontSize','scalar','$r_FontSize = \'10pt\';',NULL,'5.00','Font Size, typically 10 or 11 points.'),(234,'repcard','Layout',720,'r_GrayScale','scalar','$r_GrayScale = \'0.90\';',NULL,'5.00','Darkness of the gray section of table headings, etc. Typically 0.90 to 0.92  Change this value depending on the output from your laser printer or digital photocopier, since this is variable.'),(235,'repcard','Layout',730,'r_HOffset','scalar','$r_HOffset = \'-8mm\';',NULL,'5.00','Horizontal offset for items on the page. It shifts things left and right.'),(236,'repcard','Layout',733,'r_VOffset','scalar','$r_VOffset = \'-15mm\';',NULL,'5.00','The vertical offset for page elements on the report card. Shifts everything up or down.'),(237,'repcard','Layout',740,'r_LogoFile','scalar','$r_LogoFile = \'schoollogo.jpg\';',NULL,'5.00','Name of the School Logo file'),(238,'repcard','Layout',750,'r_LogoWidth','scalar','$r_LogoWidth = \'42mm\';',NULL,'5.00','Width of the School Logo'),(239,'repcard','Layout',752,'r_DivLogoFile','scalar','$r_DivLogoFile = \'\';',NULL,'5.00','Name of the division logo file. Having a blank entry turns this off.'),(240,'repcard','Layout',754,'r_DivLogoWidth','scalar','$r_DivLogoWidth = \'18mm\';',NULL,'4.75','Width of the school division logo.'),(241,'repcard','Layout',770,'r_SchoolAddressWidth','scalar','$r_SchoolAddressWidth = \'70mm\';',NULL,'5.00','Width of the school address at the top of the report card.'),(242,'repcard','Layout',775,'r_AddressSpacer','scalar','$r_AddressSpacer = \'5mm\';',NULL,'4.75','Amount of vertical space below logos to help align the address vertically with the logos.'),(243,'repcard','Layout',780,'r_SubjSpace','scalar','$r_SubjSpace = \'80mm\';',NULL,'5.00','Width of the subject name cell in the marks table. Use only measurements in mm.'),(244,'repcard','Layout',783,'r_MarkSpace','scalar','$r_MarkSpace = \'15mm\';',NULL,'5.00','Width of the cell in the table used to show evaluation outcomes. Use only measurements in mm.'),(245,'repcard','Layout',790,'r_TermDisplayLeading','scalaronoff','$r_TermDisplayLeading = 1;',NULL,'4.75','On/Off type. Controls whether later starting subjects display back to start term with blanks.'),(246,'repcard','Layout',800,'r_TermDisplayTrailing','scalaronoff','$r_TermDisplayTrailing = 1;',NULL,'4.75','On/Off type. Allows completed subjects to extend to current term with blanks.'),(247,'repcard','Notes',900,'r_Note1','scalar','$r_Note1 = \'\';',NULL,'4.75','A note that is displayed near top of the report card, just below student name section.'),(248,'repcard','Notes',910,'r_Note2','scalar','$r_Note2 = \'\';',NULL,'4.75','A note that is displayed near top of the report card, just below student name section.'),(249,'repcard','Notes',920,'r_Note3','scalar','$r_Note3 = \'\';',NULL,NULL,'Note 3 is located at bottom of report card, below global comment (additional comment), but above tear off line for parents.'),(250,'repcard','Notes',930,'r_Note4','scalar','$r_Note4 = \'\';',NULL,NULL,'Note 4 is located at bottom of report card below tear off line for parents (or placement text at year end).'),(251,'repcard','Picture',1000,'r_ShowStudentPicture','scalaronoff','$r_ShowStudentPicture = \'1\';',NULL,'5.25','On/Off type. Turn on Student Pictures to show on the report card.'),(252,'repcard','Picture',1010,'r_StudentPictureWidth','scalar','$r_StudentPictureWidth = \'25mm\';',NULL,'5.25','Sets the width of a student picture, when student pictures are turned on with the ShowStudentPicture setting.'),(253,'repcard','Placement',1100,'r_FinalTerm','hash','%r_FinalTerm = (1 => 3, 2 => 3, 3 => 3, 4 => 3, 5 => 3, 6 => 3, 7 => 3, 8 => 3, 9 => undef, 10 => undef, 11 => undef, 12 => undef);',NULL,'5.00','The final term for each grade in the school. Used to trigger the printing of the graduation section feature, if turned on. We map the grade to a particular final term. If undefined for that grade, the feature is not used.'),(254,'repcard','Placement',1110,'r_PlacementIndex','hash','%r_PlacementIndex = (\'PK\' => \'a\',\'K\' => \'a\',\'1\' => \'a\',\'2\' => \'a\',\'3\' => \'a\',\'4\' => \'a\',\'5\' => \'a\',\'6\' => \'a\',\'7\' => \'a\',\'8\' => \'a\',\'9\' => \'a\',\'10\' => \'a\',\'11\' => \'a\',\'12\' => \'a\');',NULL,'5.00','This value controls which Placment text (r_PlacementTeX value) is used based on their grade. '),(255,'repcard','Placement',1120,'r_PlacementTex','hash','%r_PlacementTex = (\'a\' => \'\\\\begin{tabular}{c}{\\\\sf Mosquito School}\\\\\\\\ {\\\\LARGE\\\\sf Student Placement}\\\\\\\\ {\\\\bf\\\\it\\\\Large %studentname% }\\\\\\\\ will be placed in Grade \\\\underline{\\\\hspace{13mm}} at the beginning  of the next school year.\\\\\\\\ \\\\medskip\\\\\\\\ \\\\underline{\\\\hspace{61mm}} \\\\hfill \\\\underline{\\\\hspace{61mm}}\\\\\\\\ {\\\\small Principal} \\\\hfill {\\\\small Teacher}\\\\\\\\ {\\\\large\\\\sf June 30, %schoolyearend%} \\\\end{tabular};\');',NULL,'5.00','The TeX markup for the placement section of the student in the next school year.\r\nIt is printed at year end and controlled by the FinalTerm value.'),(256,'repcard','Section Control',1200,'r_NewPageBeforeAttendance','scalaronoff','$r_NewPageBeforeAttendance = 1;',NULL,'4.75','On/Off type to turn on a hard page break before the attendance page.'),(257,'repcard','Section Control',1210,'r_ShowAdditionalComments','scalaronoff','$r_ShowAdditionalComments = 1;',NULL,'4.75','On/Off type. Turns on ability to show additional comments section (the generalized comment section of report card below attendance).'),(258,'repcard','Section Control',1220,'r_ShowMonthlyAttendance','scalar','$r_ShowMonthlyAttendance = \'4\';',NULL,'4.75','Show the attendance section (by month). The value here (1-4) controls where it prints on the report card. 1=top, 2=below keys, 3=below subjects, 4=below additional comments. There is also a separate feature to show subject attendance. (showSubjectAttendance). A value of 0 will not display any monthly attendance at all.'),(259,'repcard','Section Control',1230,'r_ShowTearoff','scalaronoff','$r_ShowTearoff = \'1\';',NULL,'5.00','On/Off type. Turns on showing the tearoff section of the report card.'),(260,'repcard','Setting',1500,'r_AdditionalComments','hash','%r_AdditionalComments = (\'999995\' => \'1\',\'999992\' => \'1\',\'999997\' => \'1\',\'999996\' => \'1\',\'999993\' => \'1\',\'99999\' => \'1\',\'99999K\' => \'1\',\'99998\' => \'1\',\'999998\' => \'1\',\'999991\' => \'1\',\'999994\' => \'1\');',NULL,'5.00','Subject codes and/or subject-section values for the additional comments subjects used for global comments. The \'marks\' in these subjects are ignored. It is a hash value so several values can be used, if required. The best approach is to use a common subject code for all of these \'subjects\', and just change the section value for different grades.'),(261,'repcard','Setting',1510,'r_AverageWeight','hashofarray','%r_AverageWeight = (\'1-2\' => [\'0.4\',\'0.6\']);',NULL,'4.75','When using the calcAverage function to come up with an average value from all terms, the values here are used to weight the term marks to come up with the weighted average for the student to date.'),(262,'repcard','Setting',1512,'r_AveragePrecision','scalar','$r_AveragePrecision = \'2\';',NULL,NULL,'Controls the number of decimal places displayed in average.'),(263,'repcard','Setting',1530,'r_GCDisplay','hash','%r_GCDisplay = (\'4\' => \'P\',\'1\' => \'I\',\'3\' => \'III\',\'2\' => \'II\',\'5\' => \'U\');',NULL,'4.75','Grade Category Display hash. It maps a particular returned valued from the calcGradeCategory function into a particular display value on the report card. The function would have to be customized to return values described in policy.'),(264,'repcard','Setting',1540,'r_LateAbsentRatio','scalar','$r_LateAbsentRatio = 3;',NULL,'4.75','For subject attendance this value will convert lates into absences. Typically 3 lates = 1 absent.'),(265,'repcard','Setting',1550,'r_MarkField','scalar','$r_MarkField = \'a1\';',NULL,'5.00','Field used to store a numeric value. Typically \'a1\' but could go from a2 to a20.'),(266,'repcard','Setting',1570,'r_Position','scalar','$r_Position = \'Classroom Teacher\';',NULL,'5.00','Name of the Position that marks a staff member as a homeroom teacher. (ie. teaches most of the subjects to that one group of students; typical in the lower grade levels). '),(267,'repcard','Setting',1580,'r_Principal','scalar','$r_Principal = \'Mr. Elwin Cameron\';',NULL,'4.75','Name of the principal. His/Her name at top of report card, if the feature turned on.'),(268,'repcard','Setting',1583,'r_VicePrincipal','scalar','$r_VicePrincipal = \'Vice-principal\';',NULL,'4.75','Description of the Vice Principal at top of the report card'),(269,'repcard','Setting',1590,'r_PrintParentSig','scalaronoff','$r_PrintParentSig = 1;',NULL,'4.75','On/Off type to show parent signature section with tear off.'),(270,'repcard','Setting',1600,'r_TeacherSign','scalar','$r_TeacherSign = \'teacher\';',NULL,'5.00','Selects kind of signing method: teacher, principal, or both, called \'combo\'. Only one of those 3 values can be used: teacher, principal, or combo.'),(271,'schedule',NULL,NULL,'ptime','array','@ptime = (\'\',\'9:05-9:55\',\'10:00-10:50\',\'10:55-11:45\',\'12:35-1:25\',\'1:30-2:20\',\'2:25-3:15\');',NULL,'5.25','The period intervals during the day. Start Time and End Time. It is 1 based (no zeroth period). Leave the first element blank.'),(272,'transcript',NULL,NULL,'creditValues','array','@creditValues = (\'1\',\'0.5\',\'0.3333\',\'0.25\',\'0.125\');',NULL,'5.25','The various values that a course can have for credit. These are fractional values with sufficient precision  ( 1/2, 1/3, 1/4, 1/8 )'),(273,'transcript',NULL,NULL,'failletter','scalar','$failletter = \'F\';',NULL,'5.25','Character indicating a failed class (on a Pass/Fail basis).'),(274,'transcript',NULL,NULL,'gradRequirements','hash','%gradRequirements = (\'English\' => \'4\',\'Bible\' => \'2\',\'Math\' => \'3\',\'Science\' => \'3\',\'Social Studies\' => \'3.5\',\'Worldview\' => \'1\',\'Phys Ed\' => \'0.5\',\'Logic\' => \'1\',\'Languages\' => \'2\',\'Fine Arts\' => \'1\');',NULL,'5.25','Graduation Requirements. These would be the credits required in each of the subject areas. Each course has a subject area setting that would match these key values.'),(275,'transcript',NULL,NULL,'letterToQual','hash','%letterToQual = (\'F\' => \'0\',\'A\' => \'4.00\',\'B-\' => \'2.67\',\'A-\' => \'3.67\',\'D+\' => \'1.33\',\'B\' => \'3\',\'B+\' => \'3.33\',\'C+\' => \'2.33\',\'D\' => \'1\',\'C\' => \'2\',\'D-\' => \'0.67\',\'C-\' => \'1.67\',\'A+\' => \'4.00\');',NULL,'5.25','This is part of the GPA (Grade Point Average) calculation that converts a letter grade back into a numeric value. There should be little need to change this.'),(276,'transcript',NULL,NULL,'markToLetter','hash','%markToLetter = (\'59.9\' => \'D-\',\'79.5\' => \'B-\',\'72.5\' => \'C\',\'62.5\' => \'D\',\'69.5\' => \'C-\',\'82.5\' => \'B\',\'77.5\' => \'C+\',\'97.5\' => \'A+\',\'0\' => \'F\',\'67.5\' => \'D+\',\'92.5\' => \'A\',\'87.5\' => \'B+\',\'89.5\' => \'A-\');',NULL,'5.25','This is used to convert a numeric grade value into a letter grade value in the transcript system.'),(277,'transcript',NULL,NULL,'passletter','scalar','$passletter = \'P\';',NULL,'5.25','Letter indicating a passed class (on a Pass/Fail basis).'),(278,'transcript',NULL,NULL,'section1','scalar','$section1 = \'Honours classes receive extra +0.5 grade point.\n\nAP classes receive +1.0 extra grade point\n\n\';',NULL,'5.25','Section 1 description for use on the transcript(report).'),(279,'transcript',NULL,NULL,'term_desc','hash','%term_desc = (\'c\' => \'Undefined\',\'a\' => \'Fall Semester\',\'b\' => \'Spring Semester\');',NULL,'5.25','Term Text Description - soon to be duplicated in admin.conf'),(280,'transcript',NULL,NULL,'term_key','hash','%term_key = (\'6\' => \'c\',\'3\' => \'b\',\'7\' => \'c\',\'2\' => \'a\',\'8\' => \'c\',\'1\' => \'a\',\'4\' => \'b\',\'5\' => \'c\');',NULL,'5.25','Term Keys that map grade level to a particular group of term descriptions.'),(281,'transcript',NULL,NULL,'t_TruncateSection','scalaronoff','$t_TruncateSection = \'1\';',NULL,'5.25','On/Off type. Whether to truncate section text or not. (1=On, 0=Off). Only used by the transcript report.'),(282,'transcript','',0,'t_ShowMark','scalaronoff','$t_ShowMark = \'1\';',NULL,'4.00','Show mark (number grade) on transcripts, rather than letter grade.'),(283,'usermanage',NULL,NULL,'google_domain','scalar','$google_domain = \'DOMAIN\';',NULL,'5.25','Google Domain to manage.'),(284,'usermanage',NULL,NULL,'google_password','scalar','$google_password = \'PASSWORD\';',NULL,'5.25','Google Domain Password'),(285,'usermanage',NULL,NULL,'google_username','scalar','$google_username = \'admin\';',NULL,'5.25','Google Domain admin user.'),(286,'usermanage','',0,'gradeskip','array','@gradeskip = (\'PK\', \'K\', \'1\', \'2\');',NULL,'5.25','Grades NOT to add accounts for in Google Apps.');
/*!40000 ALTER TABLE `temp_conf_system` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `temp_meta`
--

DROP TABLE IF EXISTS `temp_meta`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `temp_meta` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `dbaseid` varchar(64) DEFAULT NULL,
  `tableid` varchar(64) DEFAULT NULL,
  `fieldid` varchar(64) DEFAULT NULL,
  `datatype` varchar(16) DEFAULT NULL,
  `arrayidx` smallint(5) unsigned DEFAULT NULL,
  `size` smallint(5) unsigned DEFAULT NULL,
  `fieldname` varchar(255) DEFAULT NULL,
  `defaultvalue` text,
  `formtype` varchar(255) DEFAULT NULL,
  `viewsize` varchar(255) DEFAULT NULL,
  `required` char(1) DEFAULT NULL,
  `description` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=197 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `temp_meta`
--

LOCK TABLES `temp_meta` WRITE;
/*!40000 ALTER TABLE `temp_meta` DISABLE KEYS */;
INSERT INTO `temp_meta` VALUES (1,NULL,'announce','adate','date',4,0,'Date','','text','20','',NULL),(2,NULL,'announce','adatetime','datetime',1,0,'Date/Time','','text','20','',NULL),(3,NULL,'announce','adesc','text',2,0,'Description','','textarea','6x80','',NULL),(4,NULL,'announce','atopic','varchar(255)',3,255,'Topic','','text','30','',NULL),(5,NULL,'announce','atype','varchar(16)',6,16,'Type','teacher parent both','select','20','',NULL),(6,NULL,'announce','author','varchar(32)',7,32,'author',NULL,'text','20',NULL,NULL),(7,NULL,'announce','id','int(11)',0,0,'id','','readonly','20','',NULL),(8,NULL,'announce','topstay','char(1)',5,1,'Stay on Top?','1','checkbox','20','',NULL),(9,NULL,'staff','alt_city','varchar(32)',26,32,'alt_city','','text','20','',NULL),(10,NULL,'staff','alt_country','varchar(64)',28,64,'alt_country','','text','20','',NULL),(11,NULL,'staff','alt_email','varchar(64)',31,64,'alt_email','','text','20','',NULL),(12,NULL,'staff','alt_pcode','varchar(32)',29,32,'alt_pcode','','text','20','',NULL),(13,NULL,'staff','alt_phone','varchar(64)',30,64,'alt_phone','','text','20','',NULL),(14,NULL,'staff','alt_prov','varchar(32)',27,32,'alt_prov','','text','20','',NULL),(15,NULL,'staff','alt_street','varchar(64)',25,64,'alt_street','','text','20','',NULL),(16,NULL,'staff','ancestry','varchar(16)',44,16,'Ancestry','0998.01 First_Nation 0998.02 Inuit 0998.03 Metis 9999 Non-Aboriginal','selecthash','20','',NULL),(17,NULL,'staff','birthdate','date',47,0,'birthdate',NULL,'text','20',NULL,NULL),(18,NULL,'staff','cell_phone','varchar(64)',12,64,'Cell Phone','','text','30','',NULL),(19,NULL,'staff','certification1','varchar(255)',10,255,'Certificate Number','','text','20','',NULL),(20,NULL,'staff','certification2','varchar(255)',32,255,'certification2','','text','20','',NULL),(21,NULL,'staff','certification3','varchar(255)',33,255,'certification3','','text','20','',NULL),(22,NULL,'staff','certification4','varchar(255)',34,255,'certification4','','text','20','',NULL),(23,NULL,'staff','certification5','varchar(255)',35,255,'certification5','','text','20','',NULL),(24,NULL,'staff','certification6','varchar(255)',36,255,'certification6','','text','20','',NULL),(25,NULL,'staff','certification7','varchar(255)',37,255,'certification7','','text','20','',NULL),(26,NULL,'staff','certification8','varchar(255)',38,255,'certification8','','text','20','',NULL),(27,NULL,'staff','citizenship','varchar(64)',23,64,'Citizenship','','text','20','',NULL),(28,NULL,'staff','city','varchar(32)',14,32,'City','','text','15','',NULL),(29,NULL,'staff','doatt','char(1)',9,1,'Does Attendance','~ Y','select','20','',NULL),(30,NULL,'staff','driver_class','varchar(64)',20,64,'License Class','','text','20','',NULL),(31,NULL,'staff','driver_license','varchar(64)',19,64,'Driver\'s License','','text','20','',NULL),(32,NULL,'staff','email','varchar(255)',7,255,'Email','','text','30','',NULL),(33,NULL,'staff','emergency_contact_name','varchar(255)',17,255,'Emergency Contact Name','','text','30','',NULL),(34,NULL,'staff','emergency_contact_phone','varchar(255)',18,255,'Emergency Contact Phone','','text','30','',NULL),(35,NULL,'staff','firstname','varchar(40)',3,40,'Firstname','','text','20','',NULL),(36,NULL,'staff','fulltimeequivalent','varchar(16)',48,16,'Full Time Equivalent','0843 Full_Time_(100%) \r\n0844.875 Part_Time_(88%) \r\n0844.750 Part_Time_(75%) \r\n0844.625 Part_Time_(63%) \r\n0844.500 Part_Time_(50%)\r\n0844.375 Part_Time_(38%)\r\n0844.250 Part_Time_(25%)\r\n0844.125 Part_Time_(13%)','selecthash','20','',NULL),(37,NULL,'staff','gender','varchar(16)',46,16,'Gender','~ M F','select','20','',NULL),(38,NULL,'staff','home_phone','varchar(64)',11,64,'Home Phone','','text','20','',NULL),(39,NULL,'staff','id','int(11)',0,0,'id','','readonly','20','',NULL),(40,NULL,'staff','indianstatus','varchar(16)',45,16,'Indian Status','1 Registered 2 Not_Registered 3 Not_Eligible','selecthash','20','',NULL),(41,NULL,'staff','lastname','varchar(60)',2,60,'Lastname','','text','30','',NULL),(42,NULL,'staff','ldap_gidnumber','mediumint(9)',41,0,'ldap_gidnumber','','text','20','',NULL),(43,NULL,'staff','ldap_uid','varchar(64)',39,64,'ldap_uid','','text','20','',NULL),(44,NULL,'staff','ldap_uidnumber','mediumint(9)',40,0,'ldap_uidnumber','','text','20','',NULL),(45,NULL,'staff','middlename','varchar(40)',4,40,'Middlename','','text','20','',NULL),(46,NULL,'staff','nrskip','char(1)',50,1,'Nominal Roll Skip','1','checkbox','20','','Staff Members that are NOT to be included in the First Nation nominal roll should be checked. '),(47,NULL,'staff','occupations','text',49,0,'Occupations Area','0210 Teacher_(Educator) \r\n0213 Resource/Special_Education_teacher_(Educator)\r\n0213.01 Language_and_Culture_teacher_(Educator)\r\n8201 Physical_Education_teacher_(Educator)\r\n0112 Principal_(Educator) \r\n0105 Vice-principal_(Educator)\r\n0206 Librarian_(Educator)\r\n0203.01 Guidance_Counsellor_(Educator)\r\n0203 Counsellor_(Educator)\r\n0108 Director_(Educator)\r\n0413 Teacher_Aide/Classroom_Assistant_(Non-Educator)\r\n0413.01 Special_Education_Teacher_Aide/_Classroom_Assistant_(Non-Educator) \r\n0107 School_Secretary_(Non-Educator)\r\n9999 Other_Specify_(Non-Educator)','text','20','',NULL),(48,NULL,'staff','passport','varchar(64)',24,64,'Passport','','text','20','',NULL),(49,NULL,'staff','password','varchar(255)',6,255,'password','','text','20','',NULL),(50,NULL,'staff','pcode','varchar(32)',16,32,'Postal Code','','text','10','',NULL),(51,NULL,'staff','prov','varchar(32)',15,32,'Province','SK','text','10','',NULL),(52,NULL,'staff','sal','varchar(6)',1,6,'Salutation','Mr. Ms. Mrs.','select','20','',NULL),(53,NULL,'staff','street','varchar(64)',13,64,'Street','','text','20','',NULL),(54,NULL,'staff','tdate','date',8,0,'tdate','','text','20','',NULL),(55,NULL,'staff','teachingcertificatejurisdiction','varchar(16)',43,16,'Teaching Certificate Jurisdiction','SK','text','4','',NULL),(56,NULL,'staff','teachingcertificatestatus','varchar(16)',42,16,'Teaching Certificate Status','1222 Permanent \r\n1224 Temporary/Provisional/Probationary\r\n1228 In_Progress\r\n9999 Not_Certified','selecthash','20','',NULL),(57,NULL,'staff','userid','varchar(40)',5,40,'User Id','','text','20','Y',NULL),(58,NULL,'staff','vehicle_plate','varchar(64)',22,64,'Vehicle Plate','','text','20','',NULL),(59,NULL,'staff','vehicle_reg','varchar(64)',21,64,'Vehicle Registration','','text','20','',NULL),(60,NULL,'staff_multi','field_additional','varchar(255)',4,255,'field_additional',NULL,'text','20',NULL,NULL),(61,NULL,'staff_multi','field_name','varchar(255)',2,255,'field_name',NULL,'text','20',NULL,NULL),(62,NULL,'staff_multi','field_value','varchar(255)',3,255,'field_value',NULL,'text','20',NULL,NULL),(63,NULL,'staff_multi','id','int(11)',0,0,'id',NULL,'text','20',NULL,NULL),(64,NULL,'staff_multi','userid','varchar(32)',1,32,'userid',NULL,'text','20',NULL,NULL),(65,NULL,'student','address1','varchar(40)',34,40,'Addr 1','','text','20','',NULL),(66,NULL,'student','address1mailing','varchar(128)',114,128,'Mailing Address 1','','text','30','',NULL),(67,NULL,'student','address2','varchar(40)',45,40,'Addr 2','','text','20','',NULL),(68,NULL,'student','address2mailing','varchar(128)',115,128,'Mailing Address 2','','text','30','',NULL),(69,NULL,'student','address_land','varchar(32)',106,32,'Land Address (TR)','','text','20','',NULL),(70,NULL,'student','alias','varchar(16)',63,16,'Alias','','text','20','',NULL),(71,NULL,'student','band','varchar(64)',58,64,'Band Name','','text','20','',NULL),(72,NULL,'student','bandnum','varchar(32)',59,32,'Band# (3digit)','','text','20','',NULL),(73,NULL,'student','baptism','char(1)',60,1,'Baptism','','checkbox','','',NULL),(74,NULL,'student','billet','varchar(255)',92,255,'Billet','','text','20','',NULL),(75,NULL,'student','birthdate','date',8,0,'Birthdate (yymmdd)','','text','12','Y',NULL),(76,NULL,'student','busroute','varchar(30)',56,30,'Bus Route','','text','20','',NULL),(77,NULL,'student','cell1','varchar(64)',32,64,'Cell 1','','text','20','',NULL),(78,NULL,'student','cell2','varchar(64)',43,64,'Cell 2','','text','20','',NULL),(79,NULL,'student','childcare_address','varchar(255)',94,255,'Babysitter - Address','','text','20','',NULL),(80,NULL,'student','childcare_name','varchar(255)',93,255,'Babysitter - Name','','text','20','',NULL),(81,NULL,'student','childcare_phone1','varchar(255)',95,255,'Babysitter - Phone1','','text','20','',NULL),(82,NULL,'student','childcare_phone2','varchar(255)',96,255,'Babysitter - Phone2','','text','20','',NULL),(83,NULL,'student','city1','varchar(40)',35,40,'City 1','','text','20','',NULL),(84,NULL,'student','city2','varchar(40)',46,40,'City 2','','text','20','',NULL),(85,NULL,'student','commun','char(1)',23,1,'Commun','','checkbox','','',NULL),(86,NULL,'student','confirm','char(1)',25,1,'Confirm','','checkbox','','',NULL),(87,NULL,'student','contact','varchar(255)',61,255,'Contact Address','','text','20','',NULL),(88,NULL,'student','contact1','varchar(255)',28,255,'Contact 1','','text','20','',NULL),(89,NULL,'student','contact2','varchar(255)',39,255,'Contact 2','','text','20','',NULL),(90,NULL,'student','cumfolder','tinyint(4)',113,0,'Cum Folder - present','','checkbox','20','',NULL),(91,NULL,'student','dadrel','varchar(25)',21,25,'Dad Religion','','text','20','',NULL),(92,NULL,'student','docphone','varchar(15)',55,15,'Doc Phone','','text','20','',NULL),(93,NULL,'student','doctor','varchar(70)',54,70,'Doctor','','text','20','',NULL),(94,NULL,'student','email','varchar(255)',74,255,'Email','','text','30','',NULL),(95,NULL,'student','emcell','varchar(64)',53,64,'Em Cell','','text','20','',NULL),(96,NULL,'student','emhphone','varchar(64)',51,64,'Emerg H Phone','','text','20','',NULL),(97,NULL,'student','emname','varchar(255)',50,255,'Emerg Name','','text','20','',NULL),(98,NULL,'student','emrelation','varchar(20)',49,20,'Emerg Relation','','text','20','',NULL),(99,NULL,'student','emwphone','varchar(64)',52,64,'Emerg W Phone','','text','20','',NULL),(100,NULL,'student','entry','varchar(255)',11,255,'entry','','text','20','',NULL),(101,NULL,'student','ethnic','varchar(20)',12,20,'Ethnic Category','Non_Native Status_Native Non-status_Native Metis','select','10','',NULL),(102,NULL,'student','family','varchar(32)',62,32,'Family','','text','8','',NULL),(103,NULL,'student','fax1','varchar(64)',33,64,'Fax 1','','text','20','',NULL),(104,NULL,'student','fax2','varchar(64)',44,64,'Fax 2','','text','20','',NULL),(105,NULL,'student','field1','varchar(255)',66,255,'field1','','text','20','',NULL),(106,NULL,'student','field2','varchar(255)',67,255,'field2','','text','20','',NULL),(107,NULL,'student','field3','varchar(255)',68,255,'field3','','text','20','',NULL),(108,NULL,'student','firstname','varchar(40)',2,40,'First Name','','text','30','Y',NULL),(109,NULL,'student','graddate','date',102,0,'Grad Date','','text','20','',NULL),(110,NULL,'student','grade','varchar(8)',5,8,'Grade','~ PK K 1 2 3 4 5 6 7 8 9 10 11 12','select','2','Y',NULL),(111,NULL,'student','group_after_school_prog','char(1)',82,1,'Aft Sch Prog','~ Y','select','','',NULL),(112,NULL,'student','group_alt1','varchar(64)',89,64,'Alt Group 1','','text','20','',NULL),(113,NULL,'student','group_alt2','varchar(64)',90,64,'Alt Group 2','','text','20','',NULL),(114,NULL,'student','group_alt3','varchar(64)',91,64,'Alt Group 3','','text','20','',NULL),(115,NULL,'student','healthid','varchar(12)',10,12,'Health ID','','text','11','',NULL),(116,NULL,'student','homeroom','varchar(8)',6,8,'Homeroom','','text','8','Y',NULL),(117,NULL,'student','house','varchar(20)',9,20,'House League','','text','10','',NULL),(118,NULL,'student','hphone1','varchar(64)',30,64,'H Phone 1','','text','20','',NULL),(119,NULL,'student','hphone2','varchar(64)',41,64,'H Phone 2','','text','20','',NULL),(120,NULL,'student','immersion_type','varchar(32)',112,32,'Immersion Type','~ FR CR UK','select','20','',NULL),(121,NULL,'student','initial','varchar(40)',3,40,'Middle Name','','text','30','',NULL),(122,NULL,'student','internet','char(1)',14,1,'Internet','','checkbox','1','',NULL),(123,NULL,'student','internet_type','varchar(255)',97,255,'Internet Type','','text','20','',NULL),(124,NULL,'student','lastname','varchar(40)',1,40,'(Legal) Last Name','','text','30','Y',NULL),(125,NULL,'student','ldap_gidnumber','mediumint(9)',105,0,'ldap_gidnumber','','text','20','',NULL),(126,NULL,'student','ldap_uid','varchar(64)',103,64,'ldap_uid','','text','20','',NULL),(127,NULL,'student','ldap_uidnumber','mediumint(9)',104,0,'ldap_uidnumber','','text','20','',NULL),(128,NULL,'student','lunchstatus','varchar(255)',83,255,'Lunch Status','~ Free Reduced Full','select','20','',NULL),(129,NULL,'student','maiden','varchar(40)',26,40,'Maiden Name','','text','20','',NULL),(130,NULL,'student','medical','text',18,0,'Medical','','textarea','6x30','',NULL),(131,NULL,'student','momrel','varchar(25)',20,25,'Mom Religion','','text','20','',NULL),(132,NULL,'student','name1','varchar(255)',29,255,'Name 1','','text','20','',NULL),(133,NULL,'student','name2','varchar(255)',40,255,'Name 2','','text','20','',NULL),(134,NULL,'student','name_knownas','varchar(64)',88,64,'Known As','','text','20','',NULL),(135,NULL,'student','name_prefix','varchar(64)',86,64,'Name Prefix','','text','20','',NULL),(136,NULL,'student','name_suffix','varchar(64)',87,64,'Name Suffix','','text','20','',NULL),(137,NULL,'student','owing','decimal(9,2)',16,0,'Owing','','text','8','',NULL),(138,NULL,'student','par1_email','varchar(64)',84,64,'Email - Par 1','','text','20','',NULL),(139,NULL,'student','par1_firstname','varchar(255)',98,255,'Firstname - Par 1','','text','20','',NULL),(140,NULL,'student','par1_lastname','varchar(255)',99,255,'Lastname - Par 1','','text','20','',NULL),(141,NULL,'student','par2_email','varchar(64)',85,64,'Email - Par 2','','text','20','',NULL),(142,NULL,'student','par2_firstname','varchar(255)',100,255,'Firstname - Par 2','','text','20','',NULL),(143,NULL,'student','par2_lastname','varchar(255)',101,255,'Lastname - Par 2','','text','20','',NULL),(144,NULL,'student','parent_lockout','varchar(8)',116,8,'Parent Lockout','','text','20','',NULL),(145,NULL,'student','parish','varchar(255)',22,255,'Parish','','text','20','',NULL),(146,NULL,'student','password','varchar(32)',65,32,'Password','','text','20','',NULL),(147,NULL,'student','pcode1','varchar(10)',36,10,'PCode 1','','text','20','',NULL),(148,NULL,'student','pcode2','varchar(10)',47,10,'PCode 2','','text','20','',NULL),(149,NULL,'student','pic','varchar(255)',64,255,'pic','','text','20','',NULL),(150,NULL,'student','program','varchar(64)',72,64,'Program','10 Regular_Program \r\n05 Alternative_Education_Plan 09 Adult_Secondary_Program 18 Alternative_Adult_Secondary\r\n15 Special_Education_Program(up_to_Grade_9)','selecthash','20','',NULL),(151,NULL,'student','prov1','varchar(32)',69,32,'Prov1','SK AB BC MB ON QC NL NT PE NB NS NU YT','select','3','',NULL),(152,NULL,'student','prov2','varchar(32)',70,32,'Prov2','SK AB BC MB ON QC NL NT PE NB NS NU YT','select','3','',NULL),(153,NULL,'student','provnum','varchar(12)',57,12,'Provincial Stud Num','','text','20','',NULL),(154,NULL,'student','recon','char(1)',24,1,'Recon','','checkbox','','',NULL),(155,NULL,'student','relation1','varchar(20)',27,20,'Relation 1','Mother Father Aunt Uncle Grandfather Grandmother Guardian','select','20','',NULL),(156,NULL,'student','relation2','varchar(20)',38,20,'Relation 2','Mother Father Aunt Uncle Grandfather Grandmother Guardian','select','20','',NULL),(157,NULL,'student','reserveres','varchar(64)',71,64,'Reserve Resident','1 Yes 0 No','selecthash','20','',NULL),(158,NULL,'student','sex','char(1)',7,1,'Sex','M F','select','6','Y',NULL),(159,NULL,'student','single','char(1)',13,1,'Single Parent','','checkbox','1','',NULL),(160,NULL,'student','studid','int(11)',0,0,'studid','','readonly','20','',NULL),(161,NULL,'student','studnum','int(11)',4,0,'Local Student Num','','readonly','20','',NULL),(162,NULL,'student','studrel','varchar(25)',19,25,'Student Religion','','text','20','',NULL),(163,NULL,'student','trans_am_route','varchar(64)',77,64,'AM Route','','text','20','',NULL),(164,NULL,'student','trans_bus_stop_location','varchar(64)',81,64,'Bus Stop Location','','text','20','',NULL),(165,NULL,'student','trans_dropoff_time','varchar(16)',80,16,'Dropoff Time','','text','6','',NULL),(166,NULL,'student','trans_name','varchar(255)',76,255,'Bus Route','','text','20','',NULL),(167,NULL,'student','trans_pickup_time','varchar(16)',78,16,'Pickup Time','','text','6','',NULL),(168,NULL,'student','trans_pm_route','varchar(64)',79,64,'PM Route','','text','20','',NULL),(169,NULL,'student','trans_type','varchar(255)',75,255,'Transport','~ Bus Walk Parent','select','20','',NULL),(170,NULL,'student','treaty','varchar(20)',17,20,'Treaty# (10digit)','','text','12','',NULL),(171,NULL,'student','tuition_collect','tinyint(4)',110,0,'Tuition Collect','','checkbox','20','',NULL),(172,NULL,'student','tuition_country','varchar(8)',111,8,'Country of Origin','','text','8','',NULL),(173,NULL,'student','tuition_duration','varchar(64)',108,64,'Tuition Duration (mo)','','text','10','',NULL),(174,NULL,'student','tuition_program','varchar(128)',109,128,'Tuition Program','~ AS CE CA CC EF ES GE IC IS NA OT RE SE SQ WH FP GP','select','20','',NULL),(175,NULL,'student','tuition_status','varchar(64)',107,64,'Tuition Status','~ FE FT RE ID','select','20','',NULL),(176,NULL,'student','utag','varchar(255)',73,255,'utag','','text','20','',NULL),(177,NULL,'student','workplace1','varchar(60)',37,60,'Wrkplace 1','','text','20','',NULL),(178,NULL,'student','workplace2','varchar(60)',48,60,'Wrkplace 2','','text','20','',NULL),(179,NULL,'student','wphone1','varchar(64)',31,64,'W Phone 1','','text','20','',NULL),(180,NULL,'student','wphone2','varchar(64)',42,64,'W Phone 2','','text','20','',NULL),(181,NULL,'student','youngest','char(1)',15,1,'Youngest','','checkbox','1','',NULL),(182,NULL,'student_inac','accommodation','tinyint(4)',4,0,'Accommodation','3425 Group_home\r\n1673.02 Student_residence\r\n1673.01 Boarding_school\r\n1678.01 Mandatory_room_and_board,_mandatory_private_home_placement\r\n1678.02 Room_and_board_(5_days)','selecthash','20','',''),(183,NULL,'student_inac','financial_edu','tinyint(4)',8,0,'Financial Support From','','text','5','',''),(184,NULL,'student_inac','fte','tinyint(4)',2,0,'Full Time Equivalent','0843 Full_Time_(100%)  0844.875 Part_Time_(88%)  0844.750 Part_Time_(75%)  0844.625 Part_Time_(63%)  0844.500 Part_Time_(50%) 0844.375 Part_Time_(38%) 0844.250 Part_Time_(25%) 0844.125 Part_Time_(13%)','selecthash','4','',''),(185,NULL,'student_inac','id','int(11)',0,0,'Id','No Entry','readonly','20','',''),(186,NULL,'student_inac','language_instruction','tinyint(4)',7,0,'Language of Instruction','EN English NAI First_Nation FR French','selecthash','20','',''),(187,NULL,'student_inac','programcompletedprevyear','char(1)',14,1,'Program Completed Previous Year',NULL,'checkbox','20',NULL,NULL),(188,NULL,'student_inac','programdelivery','varchar(16)',12,16,'Program Delivery','0605 Classroom\r\n0608.01 Distance_Education_(correspondence_courses,etc.)\r\n0608.02 Virtual_(Internet)\r\n0608.03 Blended:_Classroom_and_Virtual(Internet)\r\n0608.04 Blended:_Classroom_and_Distance_Education 0610 Home_Schooled','selecthash','20','',NULL),(189,NULL,'student_inac','residence','tinyint(4)',3,0,'Residence','1 On_Reserve\r\n2 On_Crown_land_(in_a_community_administered_by_a_band) \r\n3 Off_Reserve_(not_eligible_to_be_funded_by_INAC)','selecthash','20','',''),(190,NULL,'student_inac','residence_band','tinyint(4)',9,0,'Band of Residence','','text','5','',''),(191,NULL,'student_inac','residence_reserve','tinyint(4)',10,0,'Reserve of Residence','9514 9471 6480 6481','select','5','','The reserve the student normally resides at.'),(192,NULL,'student_inac','schoolprogram','varchar(16)',11,16,'School Program','0100 Regular \r\n9999 Immersion \r\n1000 Bilingual\r\n2600 Alternative/Outreach\r\n1501 Adult/Mature\r\n0308 Technical\r\n0399 Vocational\r\n0309.01 Trade-FTP\r\n0309.02 Trade-FMS\r\n9999.01 Course_upgrade_after_graduation','selecthash','20','',NULL),(193,NULL,'student_inac','serviceprovision','varchar(16)',13,16,'Service Provision','41 Continued_Enrollment_-_Elementary/Secondary_Program\r\n42 Continued_Enrollment_-_Post_Graduation_Course_Upgrade\r\n1921 Graduated\r\n1922 Course_Upgrade_Completed\r\n1908 Transferred_To_Another_School_On_SAME_Nominal_Roll(Feeder_School)\r\n23 Transferred_-_To_another_Recipient\r\n1926 Withdrew\r\n28 Moved_off_reserve\r\n29 Not_enrolled_in_an_accredited/eligible_program\r\n24 Insufficient_attendance\r\n26 Over/Under_Age\r\n1924 Medical\r\n1923 Deceased','selecthash','20','',NULL),(194,NULL,'student_inac','studnum','varchar(32)',1,32,'Student Number','No Entry','readonly','20','',''),(195,NULL,'student_inac','transportation_daily','tinyint(4)',5,0,'Daily Transportation','01 Transportation_by_School_Bus\r\n02 Transportation_by_Public_Transit\r\n03 Transportation_by_other_means\r\n04 Transportation_for_HCSE_Student','selecthash','20','',''),(196,NULL,'student_inac','transportation_other','tinyint(4)',6,0,'Transportation Other','05 Lunch\r\n06 Weekend_Transportation\r\n07 Seasonal_Transportation\r\n08 Weekend/Seasonal_Transportation_for_HCSE_student','selecthash','20','','');
/*!40000 ALTER TABLE `temp_meta` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `transfer`
--

DROP TABLE IF EXISTS `transfer`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `transfer` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studnum` int(11) DEFAULT NULL,
  `date` date DEFAULT NULL,
  `type` varchar(10) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `entrytype` varchar(8) DEFAULT NULL,
  `exittype` varchar(8) DEFAULT NULL,
  `prov` varchar(8) DEFAULT NULL,
  `country` varchar(8) DEFAULT NULL,
  `utag` char(1) DEFAULT NULL,
  `lastname` varchar(40) DEFAULT NULL,
  `firstname` varchar(40) DEFAULT NULL,
  `middlename` varchar(40) DEFAULT NULL,
  `birthdate` date DEFAULT NULL,
  `provnum` varchar(12) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `transfer`
--

LOCK TABLES `transfer` WRITE;
/*!40000 ALTER TABLE `transfer` DISABLE KEYS */;
/*!40000 ALTER TABLE `transfer` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tscriptdata`
--

DROP TABLE IF EXISTS `tscriptdata`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tscriptdata` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studnum` int(11) DEFAULT NULL,
  `subjectcode` char(32) DEFAULT NULL,
  `subjecttext` char(255) DEFAULT NULL,
  `subjectarea` char(255) DEFAULT NULL,
  `score_mark` char(32) DEFAULT NULL,
  `score_letter` char(4) DEFAULT NULL,
  `score_diff` char(4) DEFAULT NULL,
  `schoolyear` char(16) DEFAULT NULL,
  `crdate` date DEFAULT NULL,
  `credit` char(16) DEFAULT NULL,
  `term` int(11) DEFAULT NULL,
  `term_desc` char(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tscriptdata`
--

LOCK TABLES `tscriptdata` WRITE;
/*!40000 ALTER TABLE `tscriptdata` DISABLE KEYS */;
/*!40000 ALTER TABLE `tscriptdata` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tscriptident`
--

DROP TABLE IF EXISTS `tscriptident`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tscriptident` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `studnum` int(11) DEFAULT NULL,
  `lastname` char(40) DEFAULT NULL,
  `firstname` char(40) DEFAULT NULL,
  `middlename` char(40) DEFAULT NULL,
  `birthdate` date DEFAULT NULL,
  `studentid` char(32) DEFAULT NULL,
  `graddate` date DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tscriptident`
--

LOCK TABLES `tscriptident` WRITE;
/*!40000 ALTER TABLE `tscriptident` DISABLE KEYS */;
/*!40000 ALTER TABLE `tscriptident` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `xlat_hint`
--

DROP TABLE IF EXISTS `xlat_hint`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `xlat_hint` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `phrase` text,
  `description` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `xlat_hint`
--

LOCK TABLES `xlat_hint` WRITE;
/*!40000 ALTER TABLE `xlat_hint` DISABLE KEYS */;
/*!40000 ALTER TABLE `xlat_hint` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `xlat_lang`
--

DROP TABLE IF EXISTS `xlat_lang`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `xlat_lang` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `language` varchar(64) DEFAULT NULL,
  `encoding` varchar(64) DEFAULT NULL,
  `author` varchar(64) DEFAULT NULL,
  `phrase` text,
  `translation` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `xlat_lang`
--

LOCK TABLES `xlat_lang` WRITE;
/*!40000 ALTER TABLE `xlat_lang` DISABLE KEYS */;
/*!40000 ALTER TABLE `xlat_lang` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `xlat_phrase`
--

DROP TABLE IF EXISTS `xlat_phrase`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `xlat_phrase` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `area` varchar(64) DEFAULT NULL,
  `file` varchar(64) DEFAULT NULL,
  `phrase` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `xlat_phrase`
--

LOCK TABLES `xlat_phrase` WRITE;
/*!40000 ALTER TABLE `xlat_phrase` DISABLE KEYS */;
/*!40000 ALTER TABLE `xlat_phrase` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Final view structure for view `studentall`
--

/*!50001 DROP TABLE IF EXISTS `studentall`*/;
/*!50001 DROP VIEW IF EXISTS `studentall`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8 */;
/*!50001 SET character_set_results     = utf8 */;
/*!50001 SET collation_connection      = utf8_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`root`@`localhost` SQL SECURITY DEFINER */
/*!50001 VIEW `studentall` AS select `student`.`studid` AS `studid`,`student`.`lastname` AS `lastname`,`student`.`firstname` AS `firstname`,`student`.`initial` AS `initial`,`student`.`studnum` AS `studnum`,`student`.`grade` AS `grade`,`student`.`homeroom` AS `homeroom`,`student`.`sex` AS `sex`,`student`.`birthdate` AS `birthdate`,`student`.`house` AS `house`,`student`.`healthid` AS `healthid`,`student`.`entry` AS `entry`,`student`.`ethnic` AS `ethnic`,`student`.`single` AS `single`,`student`.`internet` AS `internet`,`student`.`youngest` AS `youngest`,`student`.`owing` AS `owing`,`student`.`treaty` AS `treaty`,`student`.`medical` AS `medical`,`student`.`studrel` AS `studrel`,`student`.`momrel` AS `momrel`,`student`.`dadrel` AS `dadrel`,`student`.`parish` AS `parish`,`student`.`commun` AS `commun`,`student`.`recon` AS `recon`,`student`.`confirm` AS `confirm`,`student`.`maiden` AS `maiden`,`student`.`relation1` AS `relation1`,`student`.`contact1` AS `contact1`,`student`.`name1` AS `name1`,`student`.`hphone1` AS `hphone1`,`student`.`wphone1` AS `wphone1`,`student`.`cell1` AS `cell1`,`student`.`fax1` AS `fax1`,`student`.`address1` AS `address1`,`student`.`city1` AS `city1`,`student`.`pcode1` AS `pcode1`,`student`.`workplace1` AS `workplace1`,`student`.`relation2` AS `relation2`,`student`.`contact2` AS `contact2`,`student`.`name2` AS `name2`,`student`.`hphone2` AS `hphone2`,`student`.`wphone2` AS `wphone2`,`student`.`cell2` AS `cell2`,`student`.`fax2` AS `fax2`,`student`.`address2` AS `address2`,`student`.`city2` AS `city2`,`student`.`pcode2` AS `pcode2`,`student`.`workplace2` AS `workplace2`,`student`.`emrelation` AS `emrelation`,`student`.`emname` AS `emname`,`student`.`emhphone` AS `emhphone`,`student`.`emwphone` AS `emwphone`,`student`.`emcell` AS `emcell`,`student`.`doctor` AS `doctor`,`student`.`docphone` AS `docphone`,`student`.`busroute` AS `busroute`,`student`.`provnum` AS `provnum`,`student`.`band` AS `band`,`student`.`bandnum` AS `bandnum`,`student`.`baptism` AS `baptism`,`student`.`contact` AS `contact`,`student`.`family` AS `family`,`student`.`alias` AS `alias`,`student`.`pic` AS `pic`,`student`.`password` AS `password`,`student`.`field1` AS `field1`,`student`.`field2` AS `field2`,`student`.`field3` AS `field3`,`student`.`prov1` AS `prov1`,`student`.`prov2` AS `prov2`,`student`.`reserveres` AS `reserveres`,`student`.`program` AS `program`,`student`.`utag` AS `utag`,`student`.`email` AS `email`,`student`.`trans_type` AS `trans_type`,`student`.`trans_name` AS `trans_name`,`student`.`trans_am_route` AS `trans_am_route`,`student`.`trans_pickup_time` AS `trans_pickup_time`,`student`.`trans_pm_route` AS `trans_pm_route`,`student`.`trans_dropoff_time` AS `trans_dropoff_time`,`student`.`trans_bus_stop_location` AS `trans_bus_stop_location`,`student`.`group_after_school_prog` AS `group_after_school_prog`,`student`.`lunchstatus` AS `lunchstatus`,`student`.`par1_email` AS `par1_email`,`student`.`par2_email` AS `par2_email`,`student`.`name_prefix` AS `name_prefix`,`student`.`name_suffix` AS `name_suffix`,`student`.`name_knownas` AS `name_knownas`,`student`.`group_alt1` AS `group_alt1`,`student`.`group_alt2` AS `group_alt2`,`student`.`group_alt3` AS `group_alt3`,`student`.`billet` AS `billet`,`student`.`childcare_name` AS `childcare_name`,`student`.`childcare_address` AS `childcare_address`,`student`.`childcare_phone1` AS `childcare_phone1`,`student`.`childcare_phone2` AS `childcare_phone2`,`student`.`internet_type` AS `internet_type`,`student`.`par1_firstname` AS `par1_firstname`,`student`.`par1_lastname` AS `par1_lastname`,`student`.`par2_firstname` AS `par2_firstname`,`student`.`par2_lastname` AS `par2_lastname`,`student`.`graddate` AS `graddate`,`student`.`ldap_uid` AS `ldap_uid`,`student`.`ldap_uidnumber` AS `ldap_uidnumber`,`student`.`ldap_gidnumber` AS `ldap_gidnumber`,`student`.`address_land` AS `address_land`,`student`.`tuition_status` AS `tuition_status`,`student`.`tuition_duration` AS `tuition_duration`,`student`.`tuition_program` AS `tuition_program`,`student`.`tuition_collect` AS `tuition_collect`,`student`.`tuition_country` AS `tuition_country`,`student`.`immersion_type` AS `immersion_type`,`student`.`cumfolder` AS `cumfolder`,`student`.`address1mailing` AS `address1mailing`,`student`.`address2mailing` AS `address2mailing`,`student`.`parent_lockout` AS `parent_lockout` from `student` union select `studentwd`.`studid` AS `studid`,`studentwd`.`lastname` AS `lastname`,`studentwd`.`firstname` AS `firstname`,`studentwd`.`initial` AS `initial`,`studentwd`.`studnum` AS `studnum`,`studentwd`.`grade` AS `grade`,`studentwd`.`homeroom` AS `homeroom`,`studentwd`.`sex` AS `sex`,`studentwd`.`birthdate` AS `birthdate`,`studentwd`.`house` AS `house`,`studentwd`.`healthid` AS `healthid`,`studentwd`.`entry` AS `entry`,`studentwd`.`ethnic` AS `ethnic`,`studentwd`.`single` AS `single`,`studentwd`.`internet` AS `internet`,`studentwd`.`youngest` AS `youngest`,`studentwd`.`owing` AS `owing`,`studentwd`.`treaty` AS `treaty`,`studentwd`.`medical` AS `medical`,`studentwd`.`studrel` AS `studrel`,`studentwd`.`momrel` AS `momrel`,`studentwd`.`dadrel` AS `dadrel`,`studentwd`.`parish` AS `parish`,`studentwd`.`commun` AS `commun`,`studentwd`.`recon` AS `recon`,`studentwd`.`confirm` AS `confirm`,`studentwd`.`maiden` AS `maiden`,`studentwd`.`relation1` AS `relation1`,`studentwd`.`contact1` AS `contact1`,`studentwd`.`name1` AS `name1`,`studentwd`.`hphone1` AS `hphone1`,`studentwd`.`wphone1` AS `wphone1`,`studentwd`.`cell1` AS `cell1`,`studentwd`.`fax1` AS `fax1`,`studentwd`.`address1` AS `address1`,`studentwd`.`city1` AS `city1`,`studentwd`.`pcode1` AS `pcode1`,`studentwd`.`workplace1` AS `workplace1`,`studentwd`.`relation2` AS `relation2`,`studentwd`.`contact2` AS `contact2`,`studentwd`.`name2` AS `name2`,`studentwd`.`hphone2` AS `hphone2`,`studentwd`.`wphone2` AS `wphone2`,`studentwd`.`cell2` AS `cell2`,`studentwd`.`fax2` AS `fax2`,`studentwd`.`address2` AS `address2`,`studentwd`.`city2` AS `city2`,`studentwd`.`pcode2` AS `pcode2`,`studentwd`.`workplace2` AS `workplace2`,`studentwd`.`emrelation` AS `emrelation`,`studentwd`.`emname` AS `emname`,`studentwd`.`emhphone` AS `emhphone`,`studentwd`.`emwphone` AS `emwphone`,`studentwd`.`emcell` AS `emcell`,`studentwd`.`doctor` AS `doctor`,`studentwd`.`docphone` AS `docphone`,`studentwd`.`busroute` AS `busroute`,`studentwd`.`provnum` AS `provnum`,`studentwd`.`band` AS `band`,`studentwd`.`bandnum` AS `bandnum`,`studentwd`.`baptism` AS `baptism`,`studentwd`.`contact` AS `contact`,`studentwd`.`family` AS `family`,`studentwd`.`alias` AS `alias`,`studentwd`.`pic` AS `pic`,`studentwd`.`password` AS `password`,`studentwd`.`field1` AS `field1`,`studentwd`.`field2` AS `field2`,`studentwd`.`field3` AS `field3`,`studentwd`.`prov1` AS `prov1`,`studentwd`.`prov2` AS `prov2`,`studentwd`.`reserveres` AS `reserveres`,`studentwd`.`program` AS `program`,`studentwd`.`utag` AS `utag`,`studentwd`.`email` AS `email`,`studentwd`.`trans_type` AS `trans_type`,`studentwd`.`trans_name` AS `trans_name`,`studentwd`.`trans_am_route` AS `trans_am_route`,`studentwd`.`trans_pickup_time` AS `trans_pickup_time`,`studentwd`.`trans_pm_route` AS `trans_pm_route`,`studentwd`.`trans_dropoff_time` AS `trans_dropoff_time`,`studentwd`.`trans_bus_stop_location` AS `trans_bus_stop_location`,`studentwd`.`group_after_school_prog` AS `group_after_school_prog`,`studentwd`.`lunchstatus` AS `lunchstatus`,`studentwd`.`par1_email` AS `par1_email`,`studentwd`.`par2_email` AS `par2_email`,`studentwd`.`name_prefix` AS `name_prefix`,`studentwd`.`name_suffix` AS `name_suffix`,`studentwd`.`name_knownas` AS `name_knownas`,`studentwd`.`group_alt1` AS `group_alt1`,`studentwd`.`group_alt2` AS `group_alt2`,`studentwd`.`group_alt3` AS `group_alt3`,`studentwd`.`billet` AS `billet`,`studentwd`.`childcare_name` AS `childcare_name`,`studentwd`.`childcare_address` AS `childcare_address`,`studentwd`.`childcare_phone1` AS `childcare_phone1`,`studentwd`.`childcare_phone2` AS `childcare_phone2`,`studentwd`.`internet_type` AS `internet_type`,`studentwd`.`par1_firstname` AS `par1_firstname`,`studentwd`.`par1_lastname` AS `par1_lastname`,`studentwd`.`par2_firstname` AS `par2_firstname`,`studentwd`.`par2_lastname` AS `par2_lastname`,`studentwd`.`graddate` AS `graddate`,`studentwd`.`ldap_uid` AS `ldap_uid`,`studentwd`.`ldap_uidnumber` AS `ldap_uidnumber`,`studentwd`.`ldap_gidnumber` AS `ldap_gidnumber`,`studentwd`.`address_land` AS `address_land`,`studentwd`.`tuition_status` AS `tuition_status`,`studentwd`.`tuition_duration` AS `tuition_duration`,`studentwd`.`tuition_program` AS `tuition_program`,`studentwd`.`tuition_collect` AS `tuition_collect`,`studentwd`.`tuition_country` AS `tuition_country`,`studentwd`.`immersion_type` AS `immersion_type`,`studentwd`.`cumfolder` AS `cumfolder`,`studentwd`.`address1mailing` AS `address1mailing`,`studentwd`.`address2mailing` AS `address2mailing`,`studentwd`.`parent_lockout` AS `parent_lockout` from `studentwd` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2020-01-13 20:30:37
